#
# $Id: //depot/prod/DOT/dev/test/nate/lib/NATE/Error/Simple.pm#1 $
#
# *********************************************************
# This file has been modified from its original version.
# Changed the package name from Error to NATE::Error and
# Error::Simple to NATE::Error::Simple.
# Modified in Dec 2009
# *********************************************************
#
# Error.pm
#
# Copyright (c) 2006 Shlomi Fish <shlomif@iglu.org.il>. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT/X11 license.
#
## @pod here

use strict;
use warnings;

use NATE::Error;

1;
__END__

=head1 NAME

NATE::Error::Simple - The Simple Error Sub-class of Error

=head1 SYNOPSIS

   base 'NATE::Error::Simple';

=head1 DESCRIPTION

The only purpose of this module is to allow one to say the following:

    use base 'NATE::Error::Simple';

and the only thing it does is use NATE::Error.pm. Refer to the documentation
of L<C<NATE::Error>> for more information about NATE::Error::Simple.

=head1 METHODS

=head2 NATE::Error::Simple->new($text [, $value])

This method constructs a NATE::Error::Simple with the text C<$text> and the optional value
C<$value>.

=head2 $err->stringify()

The NATE::Error::Simple overloads this method.

=head1 KNOWN BUGS

None.

=head1 SEE ALSO

L<C<NATE::Error>>

=head1 AUTHOR/MAINTAINER

Shlomi Fish ( C<< shlomif@iglu.org.il >> )
