
# Copyright (c) 2009 Network Appliance, Inc.
# All rights reserved.
## @summary
##      All the Global Constant having the Debug IDs
##
## @status public
##
## @author  Neelkanth Raju. neelkant@netapp.com
##

package NACL::APISet::Node::GUI::CMode::GlobalConst;

use Exporter 'import';

@EXPORT = qw (
     $SYSTEM_NAME $LOGGING_POPUP $MENU_BAR $CLUSTER_VSERVER
     $CLUSTER_TAB $CLUSTER_TAB_COLLAPSED $VSERVER_TAB_COLLAPSED $NODES_TAB_COLLAPSED
     $EVENTS_TREE_SPACE $KERBEROS_REALM_TREE $KERBEROS_NET_INT_TREE
     $QUOTAS_TREE $QTREE_TREE $LUN_TREE $SHARES_TREE $EXPORTS_TREE $NAMESPACE_TREE
     $VOLUME_TREE $STORAGE_TREE $AGGR_TREE $DISK_TREE $NIS_TREE_SPACE $SERVICES_TREE
     $NIS_TREE $LDAP_TREE $KERBEROS_TREE $CIFS_SETUP_BTN $SNAPSHOT_POLICIES_TREE
     $SCHEDULES_TREE $PEERS_TREE $LICENSES_TREE $DATE_TIME_TREE $SNMP_TREE
     $USERS_TREE $ROLES_TREE $JOB_TREE $EVENTS_TREE $SNAPMIRROR_LOG_TREE
     $DEDUPLICATION_POLICIES_TREE $EXPORT_POLICIES_TREE
     $NAME_MAPPING_TREE $UNIX_TREE $LOCAL_USERS_GROUPS_TREE $POLICIES_TREE $CIFS_TREE
     $DNS_TREE $FCP_TREE $ISCSI_TREE $NFS_TREE $PROTOCOLS_TREE $NETWORK_INTERFACE_TREE
     $DATAPROTECTION_TREE $CONFIGURATION_TREE $SECURITY_TREE $DIAGNOSTICS_TREE
     $POPUP_ERROR_ICON $POPUP_ERROR_MESSAGE $SYSTEM_TAB
     $SYSTEM_TAB_CLASS_ID $SYSTEM_TAB_CLOSE_CLASS_ID $TREE_ELEMENT_CLASS_ID
     $GENERIC_ERROR_ICON $GENERIC_SECURITY_DIALOG $GENERIC_SECURITY_DIALOG_OK_BUTTON
     $GENERIC_DIALOG_CLOSE $GENERIC_DIALOG2_CLOSE $GENERIC_DIALOG2_OK_BUTTON
     $GENERIC_DIALOG_TITLE_BAR $GENERIC_DIALOG_TITLE_BAR1 $GENERIC_DIALOG_YES_BUTTON
     $GENERIC_DIALOG_CANCEL_BUTTON $GENERIC_DIALOG_TITLE_CLOSE_BUTTON $GENERIC_DIALOG_OK_BUTTON
     $GENERIC_WARNING_DIALOG $GENERIC_WARNING_TEXT $GENERIC_WARNING_DIALOG_OK_BUTTON
     $GENERIC_PLEASE_WAIT $GENERIC_ERROR_DIALOG $GENERIC_ERROR_DIALOG1
     $GENERIC_INVALID_FIELD $GENERIC_INVALID_ICON $GENERIC_TOOLTIP
     $GENERIC_SECURE_CONNECTION_OPTION $GENERIC_NONSECURE_CONNECTION_OPTION
     $GENERIC_DIALOG_SAVE_BUTTON
     $HELP_BUTTON $ABOUT_NETAPP_DROPDOWN $CONFIG_BUTTON
     $CONFIG_TEXT $CONFIG_TEXTAREA $CONFIG_OK_BUTTON $ABOUT_OK_BUTTON
     $ADMINISTRATION_BUTTON $ADMIN_SETTINGS_BUTTON $LOG_LEVEL_INPUT
     $SETTINGS_CANCEL $LOGIN_PAGE_SYSTEM_IP $LOGIN_PAGE_USERNAME
     $LOGIN_PAGE_PASSWORD $LOGIN_PAGE_SUBMIT_BTN

     $SYSTEM_IP_KEY $SYSTEM_NAME_KEY $SYSTEM_USERNAME_KEY $SYSTEM_PASSWORD_KEY
     $SYSTEM_TYPE_HA $SYSTEM_TYPE_SINGLE $SYSTEM_TYPE_VSERVER $SYSTEM_TYPE_CMODE
     $GENERIC_WAIT $ELEMENT_WAIT $QUICK_LINKS_BTN

     $ADDING $CONFIGURING $CREATING $FETCHING $LOADING
     $LOADING_WITHOUT_TEXT $PROVISIONING $RETRIEVING $SETTING
     $STARTING $UNLOCKING $UPDATING $VALIDATING $VERIFYING
);

# Hash keys used by System Details Hash
$SYSTEM_IP_KEY        = "systemIp";
$SYSTEM_NAME_KEY      = "systemName";
$SYSTEM_USERNAME_KEY  = "systemUsername";
$SYSTEM_PASSWORD_KEY  = "systemPassword";

# Values for System Type
$SYSTEM_TYPE_HA      = "HA Pair";
$SYSTEM_TYPE_SINGLE  = "Storage Controller";
$SYSTEM_TYPE_VSERVER = "Vserver";
$SYSTEM_TYPE_CMODE   = "Cluster";

$GENERIC_WAIT=400000;
$ELEMENT_WAIT=30000;

#####################################################################
#    Constant text values for system tree elements 
#####################################################################

#Generic
$STORAGE_TREE                = "Storage";
$VOLUME_TREE                 = "Volumes";
$NAMESPACE_TREE              = "Namespace";
$EXPORTS_TREE                = "Exports";
$SHARES_TREE                 = "Shares";
$LUN_TREE                    = "LUNs";
$QTREE_TREE                  = "Qtrees";
$QUOTAS_TREE                 = "Quotas";
$POLICIES_TREE               = "Policies";
$EXPORT_POLICIES_TREE        = "Export Policies";
$DEDUPLICATION_POLICIES_TREE = "Efficiency Policies";
$DATAPROTECTION_TREE         = "SnapMirror";
$CONFIGURATION_TREE          = "Configuration";
$NETWORK_INTERFACE_TREE      = "Network Interfaces";
$PROTOCOLS_TREE              = "Protocols";
$CIFS_TREE                   = "CIFS";
$NFS_TREE                    = "NFS";
$ISCSI_TREE                  = "iSCSI";
$FCP_TREE                    = "FC/FCoE";
$SERVICES_TREE               = "Services";
$NIS_TREE_SPACE              = "NIS ";
$NIS_TREE                    = "NIS";
$LDAP_TREE                   = "LDAP";
$KERBEROS_REALM_TREE         = "Kerberos Realm";
$KERBEROS_NET_INT_TREE       = "Kerberos Interface";
$DNS_TREE                    = "DNS/DDNS Services";
$LOCAL_USERS_GROUPS_TREE     = "Local Users and Groups";
$UNIX_TREE                   = "UNIX";
$NAME_MAPPING_TREE           = "Name Mapping";

#Cluster Tab
$CLUSTER_TAB            = "//span[\@aria-level='1' and text()='Cluster']";
$CLUSTER_TAB_COLLAPSED  = "//div[contains(\@class,'x-panel-collapsed')]"
                          . "/div/span[\@aria-level='1' and text()='Cluster']";
$VSERVER_TAB_COLLAPSED  = "//div[contains(\@class,'x-panel-collapsed')]"
                          . "/div/span[\@aria-level='1' and text()='Storage Virtual Machines']";
$NODES_TAB_COLLAPSED    = "//div[contains(\@class,'x-panel-collapsed')]"
                          . "/div/span[\@aria-level='1' and text()='Nodes']";
$SYSTEM_NAME            = "//div[div/span[text()='Storage Virtual Machines']]"
                          . "/div/div/div[\@id='navigation-tree']/div/div"
                          . "[contains(\@id,'navigation-tree') and \@aria-level=1]"
                          . "/span[\@class='x-tree3-node-text']";
$CLUSTER_VSERVER        = "//div[div/span[text()='Storage Virtual Machines']]"
                          . "/div/div/div[\@id='navigation-tree']/div/div"
                          . "[contains(\@id,'navigation-tree') and \@aria-level=1]"
                          . "/span[\@class='x-tree3-node-text']";
$STORAGE_TREE           = "Storage";
$AGGR_TREE              = "Aggregates";
$DISK_TREE              = "Disks";
$CONFIGURATION_TREE     = "Configuration";
$SERVICES_TREE          = "Services";
$LDAP_TREE              = "LDAP";
$SNAPSHOT_POLICIES_TREE = "Snapshot Policies";
$SCHEDULES_TREE         = "Schedules";
$PEERS_TREE             = "Peers";
$LICENSES_TREE          = "Licenses";
$DATE_TIME_TREE         = "DateTime";
$SNMP_TREE              = "SNMP";
$SECURITY_TREE          = "Security";
$USERS_TREE             = "Users";
$ROLES_TREE             = "Roles";
$DIAGNOSTICS_TREE       = "Diagnostics";
$JOB_TREE               = "Job";
$EVENTS_TREE_SPACE      = "Events ";
$EVENTS_TREE            = "Events";
$SNAPMIRROR_LOG_TREE    = "SnapMirror Log";

#####################################################################
#  All the Debug ids from SYSTEM MANAGER LOGIN PAGE
######################################################################
$LOGIN_PAGE_SYSTEM_IP  = "//input[\@id='gwt-debug-StorageSystemIpTextField-input']";
$LOGIN_PAGE_USERNAME   = "//input[\@id='gwt-debug-UserNameTextField-input']";
$LOGIN_PAGE_PASSWORD   = "//input[\@id='gwt-debug-PasswordTextField-input']";
$LOGIN_PAGE_SUBMIT_BTN = "//button[text()='Sign In']";
$HELP_BUTTON           = "//table[\@id='gwt-debug-SystemManagerSupportItem']";
$ABOUT_NETAPP_DROPDOWN = "gwt-debug-SystemManagerAboutSystemManagerButton";
$CONFIG_BUTTON         = "//table[\@id="
      . "'gwt-debug-AboutSystemManagerConfigurationButton']//button";
$CONFIG_TEXT           = "//div[\@id='gwt-debug-configurationTextAuto']";
$CONFIG_TEXTAREA       = "//div/div/textarea";
$CONFIG_OK_BUTTON      = "//button[text()='OK']";
$ABOUT_OK_BUTTON       = "//button[text()='OK']";
$ADMINISTRATION_BUTTON =
      "//table[\@id='gwt-debug-SystemManagerAdminButton']//button";
$ADMIN_SETTINGS_BUTTON = "gwt-debug-SystemManagerSettingsItem";
$LOG_LEVEL_INPUT       =
      "//input[\@id='gwt-debug-optionsDialogOptionsTabLogLevel-input']";
$SETTINGS_CANCEL       =
      "//table[\@id='gwt-debug-OptionsDialogCancelBtn']//button";
$LOGGING_POPUP         = "//center/b[contains(text(),'Logging')]";
$MENU_BAR              = "//div[contains(\@class,'menubar-menu-panel')]";

# Pop-up error checks
$POPUP_ERROR_ICON    = "//div[\@class='ext-mb-icon  ext-mb-error']";
$POPUP_ERROR_MESSAGE = "//span[\@class='ext-mb-text']";

#####################################################################
#  All the generic Debug ids
#####################################################################

$SYSTEM_TAB                = "gwt-debug-SystemTabHeader";
$SYSTEM_TAB_CLASS_ID       = "x-tab-strip-closable";
$SYSTEM_TAB_CLOSE_CLASS_ID = "x-tab-strip-close";
$TREE_ELEMENT_CLASS_ID     = "\@class='x-tree3-node-text'";
$GENERIC_DIALOG2_OK_BUTTON = "//button[text()='OK']";
$GENERIC_DIALOG_CLOSE
    = "//div[\@class=' x-nodrag x-tool-close x-tool x-component']";
$GENERIC_DIALOG2_CLOSE
    = "//div[\@class=' x-nodrag x-tool-close x-tool x-component ']";
$GENERIC_DIALOG_TITLE_BAR
    = "//div[\@class=' x-small-editor x-window-header "
    . "x-window-draggable x-component x-unselectable']";
$GENERIC_DIALOG_TITLE_CLOSE_BUTTON
    = "//div[\@class=' x-small-editor x-window-header "
    . "x-window-draggable x-component x-unselectable']/div";
$GENERIC_DIALOG_TITLE_BAR1
    = "//div[\@class=' x-small-editor x-window-header "
    . "x-component x-unselectable  x-window-draggable']";
$GENERIC_DIALOG_OK_BUTTON = "//button[text()='Ok']";
$GENERIC_DIALOG_CANCEL_BUTTON = "//button[text()='Cancel']";
$GENERIC_DIALOG_SAVE_BUTTON   = "//button[text()='Save']";
$GENERIC_DIALOG_YES_BUTTON    = "//button[text()='Yes']";
$GENERIC_WARNING_DIALOG =
    " x-window-plain x-window-dlg x-window x-component";
$GENERIC_WARNING_TEXT
    = "//div[\@class='ext-mb-content']/span[\@class='ext-mb-text']";
$GENERIC_WARNING_DIALOG_OK_BUTTON
    = "//div[contains(\@class,'x-small-editor x-panel-btns-center"
    . " x-panel-fbar x-component x-toolbar-layout-ct']/table/tbody";

$ADDING               = "//div[contains(text(),'Starting')]";
$CONFIGURING          = "//div[contains(text(),'Configuring')]";
$CREATING             = "//div[contains(text(),'Creating')]";
$FETCHING             = "//div[contains(text(),'Fetching')]";
$LOADING              = "//div[contains(text(),'Loading ')]";
$LOADING_WITHOUT_TEXT = "//div[contains(\@class,'x-mask-loading')]";
$PROVISIONING         = "//div[contains(text(),'Provisioning')]";
$RETRIEVING           = "//div[contains(text(),'Retrieving')]";
$SETTING              = "//div[contains(text(),'Setting ')]";
$STARTING             = "//div[contains(text(),'Starting')]";
$UNLOCKING            = "//div[contains(text(),'Unlocking')]";
$UPDATING             = "//div[contains(text(),'Updating')]";
$VALIDATING           = "//div[contains(text(),'Validating')]";
$VERIFYING            = "//div[contains(text(),'Verifying')]";

$GENERIC_PLEASE_WAIT = "//div[\@class='ext-el-mask-msg x-mask-loading']";
$GENERIC_ERROR_DIALOG  = "error-dialog";
$GENERIC_ERROR_DIALOG1 = "gwt-debug-error-dialog";
$GENERIC_INVALID_FIELD = "//*[contains(\@class,'x-form-invalid')]";
$GENERIC_INVALID_ICON  = "//img[\@class='gwt-Image x-component ']";
$GENERIC_TOOLTIP       = "//div[\@class='x-tip-body ']";
$GENERIC_ERROR_ICON = "//img[\@id='gwt-debug-MessageWithIconContainerIcon']";
$GENERIC_SECURE_CONNECTION_OPTION    = "gwt-debug-SecurityWarningSSLSetup";
$GENERIC_NONSECURE_CONNECTION_OPTION = "gwt-debug-SecurityWarningNonSecure";
$QUICK_LINKS_BTN = "//div[contains(text(),'Quick Links')]";
