# ----------------------------------------------------------------------------
# # Copyright (c) 2014 Network Appliance, Inc.
# All rights reserved.
# ----------------------------------------------------------------------------
## @summary
##
##
## @description
##
##
## @synopsis
##      use SmNetwork;
##
##      getPorts(%args);
##      changeStatusNetworkInterface(%args);
##      createBroadcastDomain(%args);
##      createInterfaceGroup(%args);
##      createIpSpace(%args);
##      createNetworkInterface(%args);
##      createSubnet(%args);
##      createVlan(%args);
##      deleteBroadcastDomain(%args);
##      deleteEthernetPort(%args);
##      deleteIpSpace(%args);
##      deleteNetworkInterface(%args);
##      deleteSubnet(%args);
##      editAdapterSettings(%args);
##      editBroadcastDomain(%args);
##      editInterfaceGroup(%args);
##      editIpSpace(%args);
##      editNetworkInterface(%args);
##      editPort(%args);
##      editSubnet(%args);
##      filterInterface(%args);
##      filterIpSpace(%args);
##      getAdapterProperties(%args);
##      getBroadCastDomainPortDetails(%args);
##      getBroadCastDomainProperties(%args);
##      _getEditDefaultValues(%args);
##      getEthernetPortProperties(%args);
##      getIpSpaceProperties(%args);
##      getNetworkInterfaceBottomPanelDetails(%args);
##      getNetworkInterfaceProperties(%args);
##      getSubnetBottomPanelDetails(%args);
##      getSubnetProperties(%args);
##      getVserverPeerDetails(%args);
##      getifGroupDetails(%args);
##      refreshAdapterPage(%args);
##      refreshBroadcastDomainPage(%args);
##      refreshIpspacesPage(%args);
##      refreshNetworkPage(%args);
##      refreshPortPage(%args);
##      refreshSubnetPage(%args);
##      BroadcastDomainRightClickOption(%args);
##      rightClickInterfaceOpts(%args);
##      rightClickIpSpaceOpts(%args);
##      selectAdapter(%args);
##      selectBroadcastDomain(%args);
##      selectInterfaceGroup(%args);
##      selectIpSpace(%args);
##      selectNetworkInterface(%args);
##      selectPort(%args);
##      selectSubnet(%args);
##      setAdapterTab(%args);
##      setBroadCastDomainTab(%args);
##      setEthernetPortTab(%args);
##      setIpSpacesTab(%args);
##      setNetWorkInterfaceTab(%args);
##      setNetworkPage(%args);
##      setSubnetTab(%args);
##
## @status shared
## @author ng-sysmgr-automation-core
## @change 18/2/2015 : neelkant : Initial template converted form base java library.
## @pod here

=head1 NAME

NACL::APISet::Node::GUI::CMode::SmNetwork

=head1 DESCRIPTION

NACL::APISet::Node::GUI::CMode::SmNetwork

=cut

package NACL::APISet::Node::GUI::CMode::SmNetwork;

# Compiler directives.
use strict;
use warnings;

# Common Module imports.
use Cwd qw(abs_path);
use Data::Dumper;
use NATE::ParamSet;
use Params::Validate qw(validate_with SCALAR ARRAYREF );
use Selenium::Remote::WDKeys;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

# NACL Module imports.
use NACL::APISet::Node::GUI::CMode::GlobalConst;

# NATE Exception Module import.
use NATE::BaseException qw(:try);

# Export required items
use Exporter 'import';

# Export all the public libraries
our @EXPORT = qw (
  getPorts
  changeStatusNetworkInterface
  createBroadcastDomain
  createInterfaceGroup
  createIpSpace
  createNetworkInterface
  createSubnet
  createVlan
  deleteBroadcastDomain
  deleteIpSpace
  deleteEthernetPort
  deleteNetworkInterface
  deleteSubnet
  editAdapterSettings
  editBroadcastDomain
  editInterfaceGroup
  editIpSpace
  editNetworkInterface
  editPort
  editSubnet
  filterInterface
  filterIpSpace
  getAdapterProperties
  getBroadCastDomainPortDetails
  getBroadCastDomainProperties
  getEthernetPortProperties
  _getEditDefaultValues
  getIpSpaceProperties
  getNetworkInterfaceBottomPanelDetails
  getNetworkInterfaceProperties
  getSubnetBottomPanelDetails
  getSubnetProperties
  getVserverPeerDetails
  getifGroupDetails
  refreshAdapterPage
  refreshBroadcastDomainPage
  refreshIpspacesPage
  refreshNetworkPage
  refreshPortPage
  refreshSubnetPage
  BroadcastDomainRightClickOption
  rightClickInterfaceOpts
  rightClickIpSpaceOpts
  selectAdapter
  selectBroadcastDomain
  selectInterfaceGroup
  selectIpSpace
  selectNetworkInterface
  selectPort
  selectSubnet
  setAdapterTab
  setBroadCastDomainTab
  setEthernetPortTab
  setIpSpacesTab
  setNetWorkInterfaceTab
  setNetworkPage
  setSubnetTab
);

# Declare the Global Varibales
our $ADAPTER_PAGE_REFRESH                  = undef;
our $ADAPTER_TAB                           = undef;
our $AUTOMATIC_ADAPTER_SPEED               = undef;
our $AUTO_NEGOTIATE_RADIO_BUTTON           = undef;
our $BD_PAGE_REFRESH                       = undef;
our $BROADCAST                             = undef;
our $BROADCAST_BROWSE                      = undef;
our $BROADCAST_DOMAIN_BROWSE_BUTTON        = undef;
our $BROADCAST_DOMAIN_BROWSE_CANCEL_BUTTON = undef;
our $BROADCAST_DOMAIN_BROWSE_OK_BUTTON     = undef;
our $BROADCAST_DOMAIN_TAB                  = undef;
our $BROADCAST_DOMAIN_TEXT_BOX             = undef;
our $BROADCAST_MTU                         = undef;
our $BROADCAST_NAME                        = undef;
our $CONFIRMATION_OK_BUTTON  = "//table/tbody/tr/td/em/button[text()='OK']";
our $CREATE_BROADCAST_BUTTON = undef;
our $CREATE_BROADCAST_CANCEL_BUTTON       = undef;
our $CREATE_BROADCAST_CREATE_BUTTON       = undef;
our $CREATE_BROADCAST_ERROR_NOPORT        = undef;
our $CREATE_INTERFACE_CANCEL_BUTTON       = undef;
our $CREATE_INTERFACE_CANCEL_CONFIRMATION = undef;
our $CREATE_INTERFACE_GROUP_BUTTON        = undef;
our $CREATE_INTERFACE_NAME                = undef;
our $CREATE_INTERFACE_SUBNET              = undef;
our $CREATE_INTERFACE_SUBNET_TEXT_BOX     = undef;
our $CREATE_IPSPACE_CANCEL_BUTTON         = undef;
our $CREATE_IPSPACE_CREATE_BUTTON         = undef;
our $CREATE_IP_SPACE                      = undef;
our $CREATE_NETWORK_INTERFACE             = undef;
our $CREATE_SUBNET                        = undef;
our $CREATE_SUBNET_CANCEL_BUTTON          = undef;
our $CREATE_SUBNET_CREATE_BUTTON          = undef;
our $CREATE_VLAN_BUTTON                   = undef;
our $CREATE_VLAN_NODE                     = undef;  
our $CREATE_VLAN_PORT                     = undef; 
our $EDIT_INTERFACE_DELETE                = undef;  
our $CREATE_VLAN_CANCEL_BUTTON            = undef;
our $CREATE_VLAN_ADD_BUTTON               = undef;  
our $CREATE_VLAN_CREATE_BUTTON            = undef;
our $CREATE_VLAN_TAGS                     = undef;
our $CREATING                           = "//div[contains(text(),'Creating')]";
our $DELETE_BROADCAST_BUTTON            = undef;
our $CONFIRMATION_CHECKBOX              = undef;
our $DELETE_INTERFACE_TOOLBAR_BUTTON    = undef;
our $DELETE_IPSPACE                     = undef;
our $DELETE_SUBNET                      = undef;
our $DELETING                           = "//div[contains(text(),'Deleting')]";
our $EDIT_ADAPTER_CANCEL_BUTTON         = undef;
our $EDIT_ADAPTER_SETTING               = undef;
our $EDIT_ADAPTER_SETTING_BUTTON        = undef;
our $EDIT_BROADCAST_BUTTON              = undef;
our $EDIT_BROADCAST_CANCEL_BUTTON       = undef;
our $EDIT_BROADCAST_IPSPACE             = undef;
our $EDIT_BROADCAST_MTU                 = undef;
our $EDIT_BROADCAST_NAME                = undef;
our $EDIT_BROADCAST_ONLY_SAVE_BUTTON    = undef;
our $EDIT_BROADCAST_SAVE_BUTTON         = undef;
our $EDIT_GATEWAY                       = undef;
our $EDIT_INTERFACE_BUTTON              = undef;
our $EDIT_INTERFACE_CANCEL_BUTTON       = undef;
our $EDIT_INTERFACE_CANCEL_CONFIRMATION = undef;
our $EDIT_INTERFACE_GROUP_BUTTON        = undef;
our $EDIT_INTERFACE_GROUP_CANCEL_BUTTON = undef;
our $EDIT_INTERFACE_GROUP_SAVE_BUTTON   = undef;
our $EDIT_INTERFACE_NAME_LABEL          = undef;
our $EDIT_INTERFACE_PORT_LABEL          = undef;
our $EDIT_INTERFACE_PROTOCOL_LABEL      = undef;
our $EDIT_INTERFACE_ROLE_LABEL          = undef;
our $EDIT_INTERFACE_SAVE_CLOSE          = undef;
our $EDIT_INTERFACE_SUBNET_LABEL        = undef;
our $EDIT_INTERFACE_SVM_LABEL           = undef;
our $EDIT_INTERFACE_WARNING             = undef;
our $EDIT_INTERFACE_WWPN                = undef;
our $EDIT_IPSPACE_CANCEL_BUTTON         = undef;
our $EDIT_IPSPACE_CREATE_BUTTON         = undef;
our $EDIT_IP_ADDRESS                    = undef;
our $EDIT_IP_BASED_RADIO_BUTTON         = undef;
our $EDIT_IP_SPACE                      = undef;
our $EDIT_IP_SPACE_NAME                 = undef;
our $EDIT_LCAP_MODE_RADIO_BUTTON        = undef;
our $EDIT_MAC_BASED_RADIO_BUTTON        = undef;
our $EDIT_MULTIPLE_MODE_RADIO_BUTTON    = undef;
our $EDIT_PORT_BUTTON                   = undef;
our $EDIT_PORT_CANCEL_BUTTON            = undef;
our $EDIT_PORT_CANCEL_CONFIRMATION      = undef;
our $EDIT_PORT_SAVE_BUTTON              = undef;
our $EDIT_SEQUENTIAL_RADIO_BUTTON       = undef;
our $EDIT_SINGLE_MODE_RADIO_BUTTON      = undef;
our $EDIT_SUBNET                        = undef;
our $EDIT_SUBNET_BUTTON                 = undef;
our $EDIT_SUBNET_CANCEL_BUTTON          = undef;
our $EDIT_SUBNET_NAME                   = undef;
our $EDIT_SUBNET_SAVECLOSE_BUTTON       = undef;
our $EDIT_SUBNET_SAVE_BUTTON            = undef;
our $ENABLE_DDNS_CHECKBOX               = undef;
our $ENABLE_MANAGMENT_CHECKBOX          = undef;
our $ETHERNET_PORT_LINK                 = undef;
our $GATEWAY                            = undef;
our $INERFACE_CREATE_BUTTON             = undef;
our $INTERFACE_GROUP_CANCEL_BUTTON      = undef;
our $INTERFACE_GROUP_CREATE             = undef;
our $INTERFACE_GROUP_NAME               = undef;
our $INTERFACE_INTERCLUSTER             = undef;
our $INTERFACE_MANAGEMENT_ACCESS        = undef;
our $INTERFACE_ROLE_DATA                = undef;
our $INTERFACE_SVM_TEXT_BOX             = undef;
our $IP_ADDRESS                         = undef;
our $IP_BASED_RADIO_BUTTON              = undef;
our $IP_SPACE                           = undef;
our $IP_SPACES_PAGE_REFRESH             = undef;
our $IP_SPACES_TAB                      = undef;
our $IP_SPACE_NAME                      = undef;
our $IpSpaceTabXpath                    = "//em/span/span[text()='IPspaces']";
our $LCAP_MODE_RADIO_BUTTON             = undef;
our $LOADING                            = "//div[contains(text(),'Loading ')]";
our $MAC_BASED_RADIO_BUTTON             = undef;
our $MANUAL_ADAPTER_SPEED               = undef;
our $MANUAL_SETTING_RADIO_BUTTON        = undef;
our $MANUAL_SPEED_TEXTBOX               = undef;
our $MODIFYING                          = "//div[contains(text(),'Modifying')]";
our $MULTIPLE_MODE_RADIO_BUTTON         = undef;
our $NETWORK_INTERFACE_TAB              = undef;
our $NETWORK_PAGE_REFRESH               = undef;
our $NODE_TEXT_BOX                      = undef;
our $Network                            = "Network";
our $PORTS_TAB                          = undef;
our $PORT_PAGE_REFRESH                  = undef;
our $RENAMING                           = "//div[contains(text(),'Renaming')]";
our $scope                              = "cluster";
our $SELECT_DUPLEX_MODE                 = undef;
our $SELECT_DUPLEX_SPEED                = undef;
our $SEQUENTIAL_RADIO_BUTTON            = undef;
our $SETTING                            = "//div[contains(text(),'Setting ')]";
our $SHOWPORTS                          = undef;
our $SHOW_PORT                          = undef;
our $SINGLE_MODE_RADIO_BUTTON           = undef;
our $SUBNET                             = undef;
our $SUBNET_CANCEL_CONFIRMATION         = undef;
our $SUBNET_NAME                        = undef;
our $SUBNET_PAGE_REFRESH                = undef;
our $SUBNET_TAB                         = undef;
our $ADAPTER_GRID                        = undef;
our $CONFIRM_CANCEL_BUTTON              = undef;
our $clinetwork                         = undef;
our $DOMAIN_GRID                         = undef;
our $elementIdOrXpath                   = undef;
our $filer                              = undef;
our $NETWORK_INTERFACE_GRID               = undef;
our $CONFIRM_OK_BUTTON                  = undef;
our $passwrd                            = undef;
our $PORT_GRID                           = undef;
our $startTime                          = undef;
our $SUBNET_PAGE_GRID                     = undef;
our $username                           = undef;
our @ports;

my $nate_params = NATE::ParamSet->new( global => 1 );
my $logdir      = abs_path( $nate_params->get("LOGDIR_UNIX") );
my $runid       = $nate_params->get("RUNID");

our $screenshot = "$logdir/$runid" . "_captured_screenshot_";
our $s_count    = 0;

=head1 METHODS

=head2 getPorts

Returns array

=over

=item Options

=over


=back

=back

=over

=back

=cut

sub getPorts {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    return @ports;

} ## end getPorts


=head2 changeStatusNetworkInterface

Returns boolean

=over

=item Options

=over

=item C<< status => SCALAR >>

 (Optional)

=back

=back

=over

=cut

sub changeStatusNetworkInterface {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'status' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Changing the status of the selected Network Interface");
    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();

        $self->setNetWorkInterfaceTab();

        $Log->comment("Clicking on the Status button");
        $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "NetworkInterfacePageStatusInterfaceTBMenu" )->click();
        $self->wait_for_element_not_present($LOADING);
        $Log->comment( "Selecting the " . $args{'status'} . " option" );
        $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "NetworkInterfacePage"
              . $args{'status'}
              . "InterfaceTBMenu" )->click();
        $Log->comment("Waiting for the page navigate load");
        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Click on Confirmation button");
        $self->_find_element($CONFIRM_OK_BUTTON)->click();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment( "Exception Found->Failed navigate Change the status "
              . "from Network Interface tab" );
        $Log->comment( $e->text() );
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end changeStatusNetworkInterface


=head2 createBroadcastDomain

Returns boolean

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>

 (Optional)

=item C<< ipspace => SCALAR >>

 (Optional)

=item C<< mtu => SCALAR >>

 (Optional)

=item C<< node => SCALAR >>

 (Optional)

=item C<< ports => SCALAR >>

 (Optional)

=back

=back

=over

=cut

sub createBroadcastDomain {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;
    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();

        my $ipspaceXpath =
          "//div[contains(\@class,'x-combo-list-item') and text()='"
          . $args{'ipspace'} . "']";
        $Log->comment("Creating the Broadcast Domain ");
        $Log->comment("Setting the BroadCast Tab");
        $self->setBroadCastDomainTab();
        $Log->comment("Clicking on create broadcast button");
        $self->_find_element($CREATE_BROADCAST_BUTTON)->click();
        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Checking if any pop-up is there");

        if (
            $self->is_element_present(
                    "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "CreateBroadcastDomainDialogNoFreePortsMsgBoxOKBtn"
            )
          )
        {
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            $Log->comment("No Free Port is available navigate create the");
            $self->_find_element( "gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "CreateBroadcastDomainDialogNoFreePortsMsgBoxOKBtn" )
              ->click();
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );

            $Log->exit() if $may_exit;
            return 0;
        }
        if ( !$self->is_element_present($CREATE_BROADCAST_CANCEL_BUTTON) ) {
            $Log->comment("Not able navigate find Create dialog");
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );

            $Log->exit() if $may_exit;
            return 0;
        }
        if ( exists( $args{'broadcast-domain'} ) ) {
            $Log->comment( "Entering the Broadcast Name " .
                $args{'broadcast-domain'} );
            $self->_find_element($BROADCAST_NAME)->send_keys(
                $args{'broadcast-domain'} );
        }
        if ( exists( $args{'mtu'} ) ) {
            $Log->comment( "Entering the MTU " . $args{'mtu'} );
            $self->_find_element($BROADCAST_MTU)->send_keys( $args{'mtu'} );
        }
        if ( exists( $args{'ipspace'} ) ) {
            $Log->comment("Clicking on IP space text box");
            $self->_find_element($IP_SPACE)->click();
            $Log->comment( "Selecting the IP space " . $args{'ipspace'} );
            $self->_find_element($ipspaceXpath)->click();
        }
        if ( exists( $args{'ports'} ) ) {
            my @ports = @{$args{'ports'}};
            foreach my $cur_port (@ports) {
                $Log->comment( "Selecting Port " . $cur_port);
                $self->click_nowait("//td/div/div[\@title='$cur_port']");
          }
       }
        $Log->comment("Clicking on the Create button");
        $elementIdOrXpath =
          $self->_find_element($CREATE_BROADCAST_CREATE_BUTTON);
        $startTime = $self->click_EventTime($elementIdOrXpath);
        $self->eventWaitingTime( $CREATING, $startTime, $methodName );
        $Log->comment(
            "Checking if there is any error or Invalid field present");
        $self->check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Exception is " . $e );
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment(" Checking if Cancel button is present");
        if ( $self->is_element_present($CREATE_BROADCAST_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Cancel button");
            $self->_find_element($CREATE_BROADCAST_CANCEL_BUTTON)->click();
        }
        $Log->comment("Checking if OK button is present");
        if ( $self->is_element_present($CONFIRMATION_OK_BUTTON) ) {
            $Log->comment("Clicking on cofirmation OK button");
            $self->_find_element($CONFIRMATION_OK_BUTTON)->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end createBroadcastDomain

=head2 createInterfaceGroup

Returns boolean

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>

 (Optional)

=item C<< ifgrp => SCALAR >>

 (Optional)

=item C<< ipspace => SCALAR >>

 (Optional)

=item C<< distr-func => SCALAR >>

 (Optional)

=item C<< mode => SCALAR >>

 (Optional)

=item C<< node => SCALAR >>

 (Optional)

=item C<< port => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub createInterfaceGroup {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Creating Interface Group");
    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();

        $self->wait_for_element_not_present($LOADING);
        $self->setEthernetPortTab();
        $self->reset_filters( $PORT_GRID, ["Port:"] );

        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Clicking on Create Interface Group Button");
        $self->_find_element($CREATE_INTERFACE_GROUP_BUTTON)->click();
        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);

        $self->check_for_error();

        if ( exists( $args{'ifgrp'} ) ) {
            $Log->comment(
                "Entering the Interface Group Name " . $args{'ifgrp'} );
            $self->_find_element($INTERFACE_GROUP_NAME)->clear();
            $self->_find_element($INTERFACE_GROUP_NAME)
              ->send_keys( $args{'ifgrp'} );
        }
        if ( exists( $args{'node'} ) ) {
            $Log->comment("Clicking on Node text box");
            $self->_find_element($NODE_TEXT_BOX)->click();
            $Log->comment( "Selecting Node: " . $args{'node'} );
            $self->_find_element(
                    "//div[contains(\@class,'x-combo-list-item') and text()='"
                  . $args{'node'}
                  . "']" )->click();
            $self->wait_for_element_not_present($LOADING);
        }
        $self->check_for_error();

        if ( exists( $args{'port'} ) ) {
            my @port = @{$args{'port'}};
            foreach my $p (@port) {
                $Log->comment("Selecting ports");
                $self->_find_element("//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY}
                   . "NetworkEthernerPortsPagePortsListView']//td[text()='$p']"
                   . "/preceding-sibling::td/input")->click();
            }
        }
        if ( exists( $args{'mode'} ) ) {
            $Log->comment(
                "Checking the mode type and clicking on it respectively");
            if ( $args{'mode'} =~ /single/ ) {
                $Log->comment( "Clicking the Radio button " . $args{'mode'} );
                $self->_find_element($SINGLE_MODE_RADIO_BUTTON)->click();
            }
            elsif ( $args{'mode'} =~ /multiple/ ) {
                $Log->comment( "Clicking the Radio button " . $args{'mode'} );
                $self->_find_element($MULTIPLE_MODE_RADIO_BUTTON)->click();
            }
            elsif ( $args{'mode'} =~ /LCAP/ ) {
                $Log->comment( "Clicking the Radio button " . $args{'mode'} );
                $self->_find_element($LCAP_MODE_RADIO_BUTTON)->click();
            }
        }
        if ( exists( $args{'distr-func'} ) ) {
            $Log->comment( "Selecting the load distribution type"
                     . " and clicking on it respectively");
            if ( $args{'distr-func'} =~ /ip/ ) {
                $Log->comment( "Clicking the Radio button " . $args{'distr-func'} );
                $self->_find_element($IP_BASED_RADIO_BUTTON)->click();
            }
            elsif ( $args{'distr-func'} =~ /mac/ ) {
                $Log->comment( "Clicking the Radio button " . $args{'distr-func'} );
                $self->_find_element($MAC_BASED_RADIO_BUTTON)->click();
            }
            elsif ( $args{'distr-func'} =~ /sequential/ ) {
                $Log->comment( "Clicking the Radio button " . $args{'distr-func'} );
                $self->_find_element($SEQUENTIAL_RADIO_BUTTON)->click();
            }
        }
        if ( exists( $args{'broadcast-domain'} )and exists( $args{'ipspace'} ) ) {
            $Log->comment("Clicking the BroadCast Domain Browse Button");
            $self->_find_element($BROADCAST_DOMAIN_BROWSE_BUTTON)->click();
            $self->wait_for_element_not_present($LOADING);
            my @domains =
              $self->find_elements( "//div[\@id='gwt-debug-"
                  . $self->{$SYSTEM_NAME_KEY}
                  . "BroadcastDomainBrowserCustomGrid']/div/div/div[2]/div/div"
              );
            $Log->comment(
                "Selecting BD Domain: " . $args{'broadcast-domain'} );
              $self->_find_element( "//div[contains(\@id,'BroadcastDomainBrowserCustomGrid')]"
               .  "//tr[td[contains(\@class,'td-broadcast-domain')]//div[text()='"
               . $args{'broadcast-domain'} . "']"
               . "and td[contains(\@class,'td-ipspace')]//div[text()='$args{ipspace}']]")->click();

            $Log->comment("Clicking on Browse Dialog OK button");
            $self->_find_element($BROADCAST_DOMAIN_BROWSE_OK_BUTTON)->click();
        }
        $Log->comment("clicking on Create button");
        if ( $self->is_element_present($INTERFACE_GROUP_CREATE) ) {
            $Log->comment("clicking on create button inside");
            $self->_find_element($INTERFACE_GROUP_CREATE)->click();
        }
        $Log->comment(
            "Checking if there is any error or Invalid field is present");
        $self->check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Exception is " . $e );
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment("Checking if Cancel button is present");
        if ( $self->is_element_present($INTERFACE_GROUP_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Cancel button");
            $self->_find_element($INTERFACE_GROUP_CANCEL_BUTTON)->click();
        }
        $Log->comment("Checking if OK button is present");
        if ( $self->is_element_present($CONFIRMATION_OK_BUTTON) ) {
            $Log->comment("Clicking on cofirmation OK button");
            $self->_find_element($CONFIRMATION_OK_BUTTON)->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end createInterfaceGroup


=head2 createIpSpace

Returns boolean

=over

=item Options

=over

=item C<< ipspace => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub createIpSpace {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'ipspace' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Creating IP Space");
    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();
        
        $Log->comment("Setting the IPSPaces Tab");
        $self->setIpSpacesTab();
        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Clicking on Create IP Space");
        $self->_find_element($CREATE_IP_SPACE)->click();
        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
        $Log->comment(
            "Entering the name of IP space " . $args{'ipspace'} );
        $self->_find_element($IP_SPACE_NAME)->send_keys( $args{'ipspace'} );
        $Log->comment("Clicking on the Create button");
        $self->_find_element($CREATE_IPSPACE_CREATE_BUTTON)->click();
        $Log->comment(
            "Checking if there is any error or Invalid field present");

        $self->check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment( "Exception is " . $e );
        $Log->comment( "Exception message is " . $e->text() );
        $Log->comment("Checking if cancel button is present");
        if ( $self->is_element_present($CREATE_IPSPACE_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Cancel button");
            $self->_find_element($CREATE_IPSPACE_CANCEL_BUTTON)->click();
        }
        $Log->comment("Checking if Ok button is present");
        if ( $self->is_element_present($CONFIRMATION_OK_BUTTON) ) {
            $Log->comment("Clicking on cofirmation OK button");
            $self->_find_element($CONFIRMATION_OK_BUTTON)->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end createIpSpace


=head2 createNetworkInterface

Returns boolean

=over

=item Options

=over

=item C<< vserver => SCALAR >>

 (Optional)

=item C<< lif => SCALAR >>

 (Required)

=item C<< role => SCALAR >>

 (Optional)

=item C<< address => SCALAR >>

 (Optional)

=item C<< home-node => SCALAR >>

 (Optional)

=item C<< home-port => SCALAR >>

 (Optional)

=item C<< protocols => SCALAR >>

 (Optional)

=item C<< subnet => SCALAR >>

 (Optional)

=item C<< enableDDNS => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub createNetworkInterface {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();
        $self->wait_for_element_not_present($LOADING);

        $Log->comment("Creating the Network Interface");
        $self->setNetWorkInterfaceTab();

        $Log->comment("Clicking on create network interface button");
        $self->_find_element($CREATE_NETWORK_INTERFACE)->click();

        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
        if ( !$self->is_element_present($CREATE_INTERFACE_NAME) ) {
            $Log->comment(
"Interface Name text box is not available navigate create Interface"
            );
            $Log->comment("Checking whether Cancel button is Present");
            if ( $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) ) {
                $Log->comment("Clicking on Interface Cancel button");
                $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)->click();
            }
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );

            $Log->exit() if $may_exit;
            return 0;
        }
        if ( exists( $args{'lif'} ) ) {
            $Log->comment( "Entering the Name of the Interface Group: "
                  . $args{'lif'} );
            $self->_find_element($CREATE_INTERFACE_NAME)
              ->send_keys( $args{'lif'} );
        }
        if ( exists( $args{'role'} ) ) {
            $Log->comment(
                "Selecting the Interface Role: " . $args{'role'} );
            if ( $args{'role'} =~ /data|node-mgmt/ ) {
                $self->_find_element($INTERFACE_ROLE_DATA)->click();
            }
            elsif ( $args{'role'} =~ /intercluster/ ) {
                $self->_find_element($INTERFACE_INTERCLUSTER)->click();
            }
        }
        if ( exists( $args{'vserver'} ) ) {
            $Log->comment("Clicking On SVM TextBox");
            $self->_find_element("//div[3]/div/div/img")->click();
            $Log->comment("Selecting the SVM from the drop down");
            $self->select_from_dropdown( "//div[contains(\@class,'gwt-debug-'.
                $self->{$SYSTEM_NAME_KEY} .'svmCombo')]", $args{'vserver'}, 1);
        #   "//div[contains(\@class,'gwt-debug-'. $self->{$SYSTEM_NAME_KEY} .'svmCombo') and text()='" . $args{'vserver'} . "']" )->click();
        }
        if ( exists( $args{'protocols'} ) ) {
            $Log->comment(
                "Spliting the Protocol access navigate get all the Protocols");
            my @protocol = split( /,/, $args{'protocols'} );
            $Log->comment("Selecting the Protocol Access");
            for ( my $i = 0 ; $i < @protocol ; $i++ ) {
                if ( $protocol[$i] =~ /cifs/ ) {
                    $Log->comment( "Selecting the Protocol: " . $protocol[$i] );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "cifsCheckbox']/input" )->click();
                }
                elsif ( $protocol[$i] =~ /nfs/ ) {
                    $Log->comment( "Selecting the Protocol: " . $protocol[$i] );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "nfsCheckbox']/input" )->click();
                }
                elsif ( $protocol[$i] =~ /iscsi/ ) {
                    $Log->comment( "Selecting the Protocol: " . $protocol[$i] );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "iscsiCheckbox']/input" )->click();
                }
                elsif ( $protocol[$i] =~ /fc/ ) {
                    $Log->comment( "Selecting the Protocol: " . $protocol[$i] );
                    $self->_find_element( "//div[\@id='gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "fcpCheckbox']/input" )->click();
                }
            }
        }
        if ( exists( $args{'role'} ) ) {
            $Log->comment(
                "Selecting the Interface Role: " . $args{'role'} );
            if ( $args{'role'} =~ /node-mgmt/ and
                   !$self->is_checked($self->_find_element($INTERFACE_MANAGEMENT_ACCESS))
               ) {
                $Log->comment("Enabling Management Access");
                $self->_find_element($INTERFACE_MANAGEMENT_ACCESS)->click();
            }
            else {
                $Log->comment("Checking whether Cancel button is Present");
                if (
                    $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) )
                {
                    $Log->comment("Clicking on Interface Cancel button");
                    $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)
                      ->click();
                }
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );

                $Log->exit() if $may_exit;
                return 0;
            }
        }
        if ( exists( $args{'subnet'} ) ) {
            $Log->comment("Clicking on subnet in text Box");
            $self->_find_element(
                "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetCombo']/img" )
              ->click();
            $Log->comment( "Selecting the subnet from the drop down listed "
                  . $args{'subnet'} );
            $self->_find_element(
                    "//div[contains(\@class,'x-combo-list-item') and text()='"
                  . $args{'subnet'}
                  . "']" )->click();
        }
        try {
            if ( exists( $args{'address'} ) ) {
                $Log->comment("Clicking on the Specific IP Radio button");
                $self->_find_element( "//div[contains(\@id,'gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "specificIPRadio')]/input" )->click();
                $Log->comment("Checking if the text box got visible");
                if (
                    !$self->is_element_present(
                        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipAddressTextField-input"
                    )
                  )
                {
                    $Log->comment("text box is not available");
                    $self->capture_screenshot(
                        $screenshot . $s_count++ . ".png" );

                    $Log->exit() if $may_exit;
                    return 0;
                }
                $Log->comment(
                    "Entering the Specific IP " . $args{'address'} );
                $self->_find_element(
                    "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipAddressTextField-input" )
                  ->send_keys( $args{'address'} );
            }
        }
        catch NATE::BaseException with {
            my $e = shift;
            $Log->comment( "Exception e is " . $e );
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            NATE::BaseException->throw( $e->text() );
        };
        if ( exists( $args{'home-node'})  and exists( $args{'home-port'} ) )  {
            try {
                $Log->comment( "Clicking on the node navigate get the ports: "
                      . $args{'home-node'} );
                $self->_find_element( "//div[contains(\@id,'gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "NetworkPortInterfaceGrid')]/div/span[text()='" .
                      $args{'home-node'} . "']" )->click();
                $Log->comment(
                    "Double Clicking on the node navigate get the ports: "
                      . $args{'home-node'} );
                $self->_double_click(
                            "//div[contains(\@id,'gwt-debug-"
                          . $self->{$SYSTEM_NAME_KEY}
                          . "NetworkPortInterfaceGrid')]/div/span[text()='" .
                          $args{'home-node'} . "']"
                );
                $Log->comment( "Clicking on the port " . $args{'home-port'} );
                $self->_find_element(
"//div[contains(\@class,'x-tree3-el')]/span[text()='" . $args{'home-port'} . "']" )->click();
            }
            catch NATE::BaseException with {
                my $e = shift;
                $Log->comment(
                    "Not able navigate select the Port and Exception is "
                      . $e );
                $Log->comment( "Exception message is " . $e->text() );
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
                $Log->comment("Checking whether Cancel button is Present");
                if (
                    $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) )
                {
                    $Log->comment("Clicking on Interface Cancel button");
                    $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)
                      ->click();
                }
                NATE::BaseException->throw( $e->text() );
            };
        }
        my $element =
          $self->_find_element( "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "dynamicDnsUpdate']/input" );
        my $WarningSVM = "gwt-debug-MessageWithIconContainerMessageText";
        my $WarningDDNS =
          "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "dynamicDnsUpdateInfoMessage";
        if ( $self->is_element_present($WarningSVM) ) {
            $Log->comment("GEtting the wrning msg for SVM");
            my $warningSVM = $self->_find_element($WarningSVM)->get_text();
            $Log->comment($warningSVM);
        }
        if ( $self->is_element_present($WarningDDNS) ) {
            $Log->comment("Getting the warning msg for SVM");
            my $warningDDNS = $self->_find_element($WarningDDNS)->get_text();
            $Log->comment($warningDDNS);
        }
        if ( exists( $args{'enableDDNS'} ) ) {
            $Log->comment("Enabling Dynamic DDNS ");
            if ( $element->is_enabled() ) {
                if ( !$self->is_checked($element) ) {
                    $Log->comment("Clicking Enable DDNS CheckBox");
                    $element->click();
                }
                else {
                    $Log->comment("CheckBox already selected");
                }
            }
            else {
                $Log->comment("Checkbox button DDNS disabled");
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
                if (
                    $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) )
                {
                    $Log->comment("Clicking on Interface Cancel button");
                    $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)
                      ->click();
                    NATE::BaseException->throw( "Checkbox button DDNS disabled" );
                    $Log->exit() if $may_exit;
                }
            }
        }
        $Log->comment("Checking if create button is present");
        if ( $self->is_element_present($INERFACE_CREATE_BUTTON) ) {
            $Log->comment("Clicking on the Create button");
            $self->_find_element($INERFACE_CREATE_BUTTON)->click();
        }
        $Log->comment("Waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
        if ( $self->is_element_present("//button[text()='OK']") ) {
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            $Log->comment("Clicking on warning dialog OK Button");
            $self->_find_element("//button[text()='OK']")->click();
            if ( $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) ) {
                $Log->comment("Clicking on Interface Cancel button");
                $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)->click();

                $Log->exit() if $may_exit;
                return 0;
            }
        }
        if (
            $self->is_element_present(
                "//img[contains(\@src,'icon-error->png')]")
          )
        {
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            $Log->comment("Error present for mgmt access");
            if ( $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) ) {
                $Log->comment("Clicking on Interface Cancel button");
                $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)->click();
            }

            $Log->exit() if $may_exit;
            return 0;
        }
        $Log->comment(
            " checking whether error or any invalid field is present");
        $self->check_for_error();
        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Exception message is " . $e->text() );
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment("Checking whether Cancel button is Present");
        if ( $self->is_element_present($CREATE_INTERFACE_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Interface Cancel button");
            $self->_find_element($CREATE_INTERFACE_CANCEL_BUTTON)->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end createNetworkInterface

=head2 createSubnet

Returns String

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>

 (Optional)

=item C<< ipspace => SCALAR >>

 (Optional)

=item C<< gateway => SCALAR >>

 (Optional)

=item C<< ip-ranges => SCALAR >>

 (Optional)

=item C<< subnet-name => SCALAR >>

 (Optional)

=item C<< subnet => SCALAR >>

 (Optional)

=item C<< port => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub createSubnet {

    my $self = shift;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

     my ( $package, $file, $line, $subname ) = caller(0);
                 my $methodName = $subname;

    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();

        $Log->comment("Clicking on Create Subnet button");
        $self->_find_element($CREATE_SUBNET)->click();
        $Log->comment("Wait for loading the Page");
        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Checking if the Subnet Name field exist");
        if ( !$self->is_element_present($SUBNET_NAME) ) {
            $Log->comment(
                "Subnet Name text box is not available navigate create subnet");
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            $Log->comment("Checking if Cancel button is present");
            if ( $self->is_element_present($CREATE_SUBNET_CANCEL_BUTTON) ) {
                $Log->comment("Clicking on Subnet Cancel button");
                $self->_find_element($CREATE_SUBNET_CANCEL_BUTTON)->click();
            }
            $Log->comment("Checking if confirm cancel button is present");
            if ( $self->is_element_present($SUBNET_CANCEL_CONFIRMATION) ) {
                $Log->comment("Clicking on confirm cancel button");
                $self->_find_element($SUBNET_CANCEL_CONFIRMATION)->click();
            }
            $Log->comment("Checking if confirmation OK button is present");
            if ( $self->is_element_present($CONFIRMATION_OK_BUTTON) ) {
                $Log->comment("Clicking on cofirmation OK button");
                $self->_find_element($CONFIRMATION_OK_BUTTON)->click();
            }

            $Log->exit() if $may_exit;
            return 0;
        }
        $Log->comment( "Entering the name for subnet:  " . $args{'subnet-name'} );
        $self->_find_element($SUBNET_NAME)->clear();
        $self->_find_element($SUBNET_NAME)->send_keys( $args{'subnet-name'} );
        $Log->comment( "Entering the subnet:  " . $args{'subnet'} );
        $self->_find_element($SUBNET)->send_keys( $args{'subnet'} );
        if ( $args{'ip_address'} ) {
            $Log->comment( "Entering the IP Address: " . $args{'ip_address'} );
            $self->_find_element($IP_ADDRESS)->send_keys( $args{'ip_address'} );
        }
        if ( $args{'gateway'} ) {
            $Log->comment( "Entering the Gateway: " . $args{'gateway'} );
            $self->_find_element($GATEWAY)->send_keys( $args{'gateway'} );
        }
        if ( exists( $args{'broadcast-domain'} ) 
                and exists( $args{'ipspace'} ) ) {
                $Log->comment("Clicking on Browse Button");
                $elementIdOrXpath = $self->_find_element($BROADCAST_BROWSE);
                $startTime        = $self->click_EventTime($elementIdOrXpath);
                $self->eventWaitingTime( $LOADING, $startTime,
                    $methodName . "_bd_loading" );
                my @totalRows;
                @totalRows =
                  $self->find_elements( "//div[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "BroadcastDomainBrowserCustomGrid']/div/div/div[2]/div/div");
                $Log->comment( "Clicking the broadcast ");
                $self->_find_element( "//div[\@id='gwt-debug-$self->{$SYSTEM_NAME_KEY}"
                   . "BroadcastDomainBrowserCustomGrid']"
                   .
                   "//tr[td[contains(\@class,'td-broadcast-domain')]//div[text()='$args{'broadcast-domain'}'] "
                   . "and td[contains(\@class,'td-ipspace')]//div[text()='$args{ipspace}']]")->click();

                $Log->comment("waiting for the LOADING element not present");
                $self->wait_for_element_not_present($LOADING);
                $Log->comment("Clicking ON OK Button ");
                $elementIdOrXpath =
                  $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "BroadcastDomainBrowserDialogOkBtn" );
                $startTime = $self->click_EventTime($elementIdOrXpath);
                $self->eventWaitingTime( $LOADING, $startTime,
                    $methodName . "_ports_in_bd_loading" );
                $self->check_for_error();
        }
        if ( exists( $args{'port'} ) ) {
            if ( $self->is_element_present($SHOWPORTS) ) {
                $Log->comment("clicking on show ports ");
                $self->_find_element($SHOWPORTS)->click();
            }
            $self->wait_for_element_not_present($LOADING);
            if (
                $self->is_element_present(
                        "//table[\@id='gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "SubnetCreateDialogShowPortsPanelDisclosurePanel']/tbody/tr[2]/td/div/div/table/tbody/tr/td[2]"
                )
              )
            {
                $Log->comment(
                    "No ports are attached navigate this broadcast domain->"
                );
            }
            else {
                $Log->comment(
                    "Ports are attached navigate broadcast domain->");
            }
            if ( !exists( $args{'create'} ) ) {
                if ( $self->is_element_present($CREATE_SUBNET_CANCEL_BUTTON)
                  )
                {
                    $Log->comment("Clicking on Subnet Cancel button");
                    $self->_find_element($CREATE_SUBNET_CANCEL_BUTTON)
                      ->click();
                }
                return 1;
            }
        }

        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Checking if Create button is present");
        if ( $self->is_element_present($CREATE_SUBNET_CREATE_BUTTON) ) {
            $Log->comment("Clicking on Create button");
            $elementIdOrXpath =
              $self->_find_element($CREATE_SUBNET_CREATE_BUTTON);
            $startTime = $self->click_EventTime($elementIdOrXpath);
        }
        $Log->comment(
            "waiting for the CREATING,SETTING,LOADING elements not present");
        $self->wait_for_element_not_present($CREATING);
        $self->wait_for_element_not_present($SETTING);
        $self->wait_for_element_not_present($LOADING);
        $self->captureResponseTime( $startTime, $methodName );
        $Log->comment(
"Checking if there is any invalid field or any error after clicking on create button"
        );
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment( "Exception message is " . $e->text() );
        if (
            $self->is_element_present(
"//table[\@id='gwt-debug-error-dialog-ok-button']/tbody/tr[2]/td[2]/em/button"
            )
          )
        {
            $Log->comment("Clicking on ontap error OK buttton");
            $self->_find_element(
"//table[\@id='gwt-debug-error-dialog-ok-button']/tbody/tr[2]/td[2]/em/button"
            )->click();
        }
        $Log->comment("Checking if Cancel button is present");
        if ( $self->is_element_present($CREATE_SUBNET_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Subnet Cancel button");
            $self->_find_element($CREATE_SUBNET_CANCEL_BUTTON)->click();
        }
        $Log->comment("Checking if confirm cancel button is present");
        if ( $self->is_element_present($SUBNET_CANCEL_CONFIRMATION) ) {
            $Log->comment("Clicking on confirm cancel button");
            $self->_find_element($SUBNET_CANCEL_CONFIRMATION)->click();
        }
        $Log->comment("Checking if confirmation OK button is present");
        if ( $self->is_element_present($CONFIRMATION_OK_BUTTON) ) {
            $Log->comment("Clicking on cofirmation OK button");
            $self->_find_element($CONFIRMATION_OK_BUTTON)->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end createSubnet

=head2 createVlan

Returns boolean

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>

 (Optional)

=item C<< ipspace => SCALAR >>

 (Optional)

=item C<< node => SCALAR >>

 (Optional)

=item C<< port => SCALAR >>

 (Optional)

=item C<< vlan_id => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub createVlan {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Creating the VLAN");
    my $domainXpath =
      "//div/table/div[text()='" . $args{'broadcast-domain'} . "']";
    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();

        $self->wait_for_element_not_present($LOADING);
        $self->setEthernetPortTab();

        $Log->comment("Clicking on create VLAN button");
        $self->_find_element($CREATE_VLAN_BUTTON)->click();
        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);

        $Log->comment( "Selecting the node " . $args{'node'} );
        $self->select_from_dropdown($CREATE_VLAN_NODE, $args{'node'}, 1);
        $Log->comment("Selecting the interface ". $args{'port'});
        $self->select_from_dropdown($CREATE_VLAN_PORT, $args{'port'}, 1);

        $Log->comment( "Entering the VLAN tags " . $args{'vlan-id'} );
        $self->_find_element($CREATE_VLAN_TAGS) ->send_keys( $args{'vlan-id'} );
        $Log->comment("Clicking on add vlan tag button");
        $self->_find_element($CREATE_VLAN_ADD_BUTTON)->click();


         $Log->comment("Selecting the Broadcast domain ");

         if ( exists( $args{'broadcast-domain'} ) and exists( $args{'ipspace'} ) ) {
                $Log->comment("Clicking on Browse Button");
                $self->_find_element($BROADCAST_BROWSE)->click();
                $Log->comment( "Clicking the broadcast ");
                $self->_find_element( "//div[contains(\@id,'gwt-debug-$self->{$SYSTEM_NAME_KEY}"
                   . "BroadcastDomainBrowserCustomGrid')]"
                   .  "//tr[td[contains(\@class,'td-broadcast-domain')]//div[text()='$args{'broadcast-domain'}']"
                   . "and td[contains(\@class,'td-ipspace')]//div[text()='$args{ipspace}']]")->click();
                $Log->comment("waiting for the LOADING element not present");
                $self->wait_for_element_not_present($LOADING);
                $Log->comment("Clicking ON OK Button ");
                  $self->_find_element( "gwt-debug-"
                      . $self->{$SYSTEM_NAME_KEY}
                      . "BroadcastDomainBrowserDialogOkBtn" )->click();
                $self->check_for_error();
        }
 
        $Log->comment("Clicking on create button");
        $self->_find_element($CREATE_VLAN_CREATE_BUTTON)->click();
        $Log->comment("Checking if there is any error or invalid field");
        $self->check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment( "Exception is " . $e );
        $Log->comment( "Exception message is " . $e->text() );
        $Log->comment("Checking if vlan cancel button is present");
        if ( $self->is_element_present($CREATE_VLAN_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Cancel button");
            $self->_find_element($CREATE_VLAN_CANCEL_BUTTON)->click();
        }
        $Log->comment("Checking if OK button is present");
        if ( $self->is_element_present($CONFIRMATION_OK_BUTTON) ) {
            $Log->comment("Clicking on cofirmation OK button");
            $self->_find_element($CONFIRMATION_OK_BUTTON)->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end createVlan

=head2 deleteEthernetPort

Returns boolean

=over

=item Options

=over

=item C<< node => SCALAR >>
 (Required)
=item C<< port => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub deleteEthernetPort {
      my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'node'  => { type => SCALAR },
            'port' => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();

    $self->wait_for_element_not_present($LOADING);
    $self->setEthernetPortTab();
    $self->wait_for_element_not_present($LOADING);
    $self->_find_element(
       "//div[contains(\@id,'EthernetPortsTabItemGrid')]//div"
     . "[contains(\@id,'gwt-debug--DEBUG-ID-NOT-SET')]//tr"
     . "[td//div[contains(text(),$args{port})]"
     . "and td[contains(\@class,'td-node')]//div"
     . "[contains(text(),$args{node})]]")->click();

    $Log->comment( " Deleting port ".$args{'port'} );
    $Log->comment("Clicking on Delete Button");
    $self->_find_element($EDIT_INTERFACE_DELETE)->click();
    $Log->comment( "Clicking on Delete confirmation checkbox");
    $self->_find_element($CONFIRMATION_CHECKBOX)->click();
    if ( $self->is_element_present($CONFIRM_OK_BUTTON) ) {
        $Log->comment(
            "Clicking on Delete confirm OK button");
        $self->_find_element($CONFIRM_OK_BUTTON)->click();
    }
    $Log->comment(
        " Checking if there is any error or Invalid field present");
    $self->check_for_error();
    $self->wait_for_element_not_present($LOADING);

    return 1;

}##end deleteEthernetPort

=head2 deleteBroadcastDomain

Returns boolean

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>
 (Required)
=item C<< ipspace => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub deleteBroadcastDomain {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'broadcast-domain'  => { type => SCALAR },
            'ipspace' => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Setting the network Page");
                      $self->setNetworkPage();
    $Log->comment("Setting the BroadCast Tab");
    $self->setBroadCastDomainTab();
    $Log->comment( "Selecting the Broadcast " . $args{'broadcast-domain'} );
    $self->selectBroadcastDomain(
        'broadcast' => $args{'broadcast-domain'},
        'ipspace'   => $args{'ipspace'},
    );
    $Log->comment("Clicking on Delete broadcast button");
    $self->_find_element($DELETE_BROADCAST_BUTTON)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->comment(
        "Clicking on Delete broadcast domain confirmation checkbox");
    $self->_find_element($CONFIRMATION_CHECKBOX)->click();

    if ( $self->is_element_present($CONFIRM_OK_BUTTON) ) {
        $Log->comment(
            "Clicking on Delete broadcast domain confirm OK button");
        $elementIdOrXpath = $self->_find_element($CONFIRM_OK_BUTTON);
        $startTime = $self->click_EventTime($elementIdOrXpath);
        $self->eventWaitingTime( $LOADING, $startTime, $methodName );
    }
    $Log->comment(
        " Checking if there is any error or Invalid field present");
    $self->check_for_error();

    return 1;

} ## end deleteBroadcastDomain


=head2 deleteIpSpace

Returns boolean

=over

=item Options

=over

=item C<< ipspace => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub deleteIpSpace {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'ipspace' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment( " Deleting the ipspace " . $args{'ipspace'} );
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();

    $Log->comment("Setting the IPSPaces Tab");
    $self->setIpSpacesTab();
    $self->wait_for_element_not_present($LOADING);

    $Log->comment( " Selecting the ipspace " . $args{'ipspace'} );
    $self->selectIpSpace( 'ipspace' => $args{'ipspace'}, );
    $Log->comment(" Clicking on delete IpSpace button");
    $self->_find_element($DELETE_IPSPACE)->click();
    $Log->comment("Wait for loading the Page");
    $self->wait_for_element_not_present($LOADING);

    $Log->comment("Clicking On Delete Dialog Confirmation Checkbox");
    $self->_find_element($CONFIRMATION_CHECKBOX)->click();
    if ( $self->is_element_present($CONFIRM_OK_BUTTON) ) {
        $Log->comment("Clicking On Delete Dialog OK Button");
        $elementIdOrXpath = $self->_find_element($CONFIRM_OK_BUTTON);
        $startTime        = $self->click_EventTime($elementIdOrXpath);
        $Log->comment("Wait for CREATING element not present");
        $self->eventWaitingTime( $LOADING, $startTime, $methodName );
    }
    $self->wait_for_element_not_present($LOADING);
    $Log->comment(
        " Checking if there is any error or Invalid field present");
    $self->check_for_error();

    return 1;

} ## end deleteIpSpace


=head2 deleteNetworkInterface

Returns boolean

=over

=item Options

=over

=item C<< lif => SCALAR >>
 (Required)
=item C<< vserver => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub deleteNetworkInterface {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'lif' => { type => SCALAR },
            'vserver'          => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment(
        "Deleting the Network Interface " . $args{'lif'} );
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

        
    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $self->wait_for_element_not_present($LOADING);

    $Log->comment("Creating the Network Interface");
    $self->setNetWorkInterfaceTab();

    $Log->comment(
        " Selecting the networkInterface " . $args{'lif'} );
    $self->selectNetworkInterface(
        'lif' => $args{'lif'},
        'vserver'          => $args{'vserver'},
    );
    $Log->comment(" Clicking on delete networkInterface toolbar button");
    $self->_find_element($DELETE_INTERFACE_TOOLBAR_BUTTON)->click();
    $Log->comment("Wait for loading the Page");
    $self->wait_for_element_not_present($LOADING);

    $Log->comment("Clicking On Delete Dialog Confirmation Checkbox");
    $self->_find_element($CONFIRMATION_CHECKBOX)->click();
    if ( $self->is_element_present($CONFIRM_OK_BUTTON) ) {
        $Log->comment("Clicking On Delete Dialog OK Button");
        $elementIdOrXpath =
          $self->_find_element($CONFIRM_OK_BUTTON);
        $startTime = $self->click_EventTime($elementIdOrXpath);
        $Log->comment("Wait for CREATING element not present");
        $self->eventWaitingTime( $LOADING, $startTime, $methodName );
    }
    $self->wait_for_element_not_present($LOADING);

    $Log->comment(
        " Checking if there is any error or Invalid field present");
    $self->check_for_error();

    return 1;

} ## end deleteNetworkInterface


=head2 deleteSubnet

Returns boolean

=over

=item Options

=over

=item C<< subnet-name => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub deleteSubnet {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'subnet-name' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Deleting subnet " . $args{'subnet-name'} );

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $self->wait_for_element_not_present($LOADING);

    $Log->comment("Selecting Subnet");
    $self->selectSubnet( 'subnet' => $args{'subnet-name'}, );
    $self->wait_for_element_not_present($LOADING);
    $Log->comment("Clicking on Delete Subnet button");
    $self->_find_element($DELETE_SUBNET)->click();
    $Log->comment("Wait for loading the Page");
    $self->wait_for_element_not_present($LOADING);

    $Log->comment("Clicking On Delete Dialog Confirmation Checkbox");
    $self->_find_element($CONFIRMATION_CHECKBOX)->click();
    if ( $self->is_element_present($CONFIRM_OK_BUTTON) ) {
        $Log->comment("Clicking On Delete Dialog OK Button");
        $Log->comment("clicking on delete");
        $elementIdOrXpath = $self->_find_element($CONFIRM_OK_BUTTON);
        $startTime        = $self->click_EventTime($elementIdOrXpath);
    }
    $self->wait_for_element_not_present($LOADING);
    $self->eventWaitingTime( $DELETING, $startTime, $methodName );

    $Log->comment(
        " Checking if there is any error or Invalid field present");
    $self->check_for_error();

    return 1;

} ## end deleteSubnet


=head2 editAdapterSettings

Returns boolean

=over

=item Options

=over

=item C<< adapter => SCALAR >>

 (Required)

=item C<< node => SCALAR >>

 (Required)

=item C<< manual_speed => SCALAR >>

 (Optional)

=item C<< speed => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub editAdapterSettings {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'adapter' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $self->wait_for_element_not_present($LOADING);
    $Log->comment("Setting the Adapter Tab");
    $self->setAdapterTab();
    $Log->comment("Editing the Adapter settings");
    $Log->comment( "Selecting the Adapter " . $args{'adapter'} );
    $self->selectAdapter( 'adapter' => $args{'adapter'},
                          'node'   => $args{'node'} );
    $Log->comment("Clicking on the Edit button");
    $self->_find_element($EDIT_ADAPTER_SETTING)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);
    $Log->comment( "Checking the speed type " . $args{'speed'} );

    if ( $args{'speed'} =~ /auto/ ) {
        $Log->comment("Selecting the Automatic Adapter Speed");
        $self->_find_element($AUTOMATIC_ADAPTER_SPEED)->click();
    } else {
        $Log->comment("Selecting the Manual Adapter speed");
        $self->_find_element($MANUAL_ADAPTER_SPEED)->click();
        $Log->comment( "Entering the Speed " . $args{'manual_speed'} );
        $self->_find_element($MANUAL_SPEED_TEXTBOX)
          ->send_keys( $args{'manual_speed'} );
    }
    $Log->comment("Clicking on edit button");
    $self->_find_element($EDIT_ADAPTER_SETTING_BUTTON)->click();
    $Log->comment(
        " Checking if there is any error or invalid field present");

    $self->check_for_error();

    return 1;

} ## end editAdapterSettings

=head2 editBroadcastDomain

Returns boolean

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>

 (Required)

=item C<< ipspace => SCALAR >>

 (Required)

=item C<< new-name => SCALAR >>

 (Optional)

=item C<< mtu => SCALAR >>

 (Optional)

=item C<< node => SCALAR >>

 (Optional)

=item C<< ports => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub editBroadcastDomain {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 
            'broadcast-domain' => { type => SCALAR },
            'ipspace' => { type => SCALAR },
        },        
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $Log->comment("Setting the BroadCast Tab");
    $self->setBroadCastDomainTab();

    $Log->comment("Editing the Broadcast Domain ");
    $Log->comment("Setting the BroadCast Tab");
    $self->setBroadCastDomainTab();
    $Log->comment( "Selecting the broadcast navigate edit   "
          . $args{'broadcast-domain'} );
    $self->selectBroadcastDomain(
        'broadcast' => $args{'broadcast-domain'},
        'ipspace'   => $args{'ipspace'},
    );
    $Log->comment("Clicking on edit broadcast button");
    $self->_find_element($EDIT_BROADCAST_BUTTON)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    if ( exists( $args{'new-name'} ) ) {
        $Log->comment(
            "Entering the Broadcast Name " . $args{'new-name'} );
        $self->_find_element($EDIT_BROADCAST_NAME)->clear();
        $self->_find_element($EDIT_BROADCAST_NAME)
          ->send_keys( $args{'new-name'} );
    }
    if ( exists( $args{'mtu'} ) ) {
        $Log->comment( "Entering the MTU " . $args{'mtu'} );
        $self->_find_element($EDIT_BROADCAST_MTU)->clear();
        $self->_find_element($EDIT_BROADCAST_MTU)
          ->send_keys( $args{'mtu'} );
    }

    if ( exists( $args{'ports'} ) ) {
        my @ports = @{$args{'ports'}};
        foreach my $cur_port (@ports) {
            $Log->comment( "Selecting Port " . $cur_port);
            my $checkbox_element =
                $self->_find_element("//td\[div/div\[\@title='$cur_port'\]\]" );
            my $cssPath = $checkbox_element->get_attribute("id");
            eval {
                $Log->comment("Checkbox already checked");
                $self->_find_element("\#$cssPath\[class*=x-grid3-check-col-on\]", "css");
            };
            if ($@) {
                # checkbox is not cheked
                $Log->comment("Checkbox is not checked");
                $self->_find_element("\#$cssPath\[class*=x-grid3-check-col\]","css")->click();
            }
        }
    }

    $self->wait_for_element_not_present($LOADING);
    $Log->comment("Clicking on the Save and CLose button");
    $elementIdOrXpath = $self->_find_element($EDIT_BROADCAST_SAVE_BUTTON);
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $self->eventWaitingTime( $MODIFYING, $startTime, $methodName );

    $Log->comment(
        " Checking if there is any error or Invalid field present");
    $self->check_for_error();

    return 1;
} ## end editBroadcastDomain

=head2 editInterfaceGroup

Returns boolean

=over

=item Options

=over

=item C<< ifgrp => SCALAR >>

 (Required)

=item C<< port => SCALAR >>

 (Required)

=item C<< mode => SCALAR >>

 (Optional)

=item C<< new-name => SCALAR >>

 (Optional)

=back

=back

=over

=back

=cut

sub editInterfaceGroup {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => {
            'ifgrp' => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Editing Interface Group");

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    
    $self->wait_for_element_not_present($LOADING);
    $self->setEthernetPortTab();
    my $portXpath =
      "//div/table/tbody/tr/td[text()='" . $args{'port'} . "']";
    $Log->comment( "Selecting the Interface Group "
          . $args{'ifgrp'} );
    $self->selectInterfaceGroup(
        'ifgrp' => $args{'ifgrp'}, );
    $Log->comment("Clicking on EDIT Interface Group Button");
    $self->_find_element($EDIT_INTERFACE_GROUP_BUTTON)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);
    if ( exists( $args{'port'} ) ) {
        $Log->comment( "Selecting the port " . $args{'port'} );
        $self->_find_element($portXpath)->click();
    }
    $Log->comment("Clicking on SAVE button");
    $self->_find_element($EDIT_INTERFACE_GROUP_SAVE_BUTTON)->click();
    $Log->comment("Checking if there is any error or Invalid field");
    $self->check_for_error();

    return 1;
} ## end editInterfaceGroup


=head2 editIpSpace

Returns boolean

=over

=item Options

=over

=item C<< ipspace => SCALAR >>
 (Required)
=item C<< new-name => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub editIpSpace {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Editing IP Space");

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $Log->comment("Setting the network Page");
    $self->setIpSpacesTab();
    $Log->comment(
        "Selecting IP space navigate edit " . $args{'ipspace'} );
    $self->selectIpSpace( 'ipspace' => $args{'ipspace'}, );
    $Log->comment("Clicking on Edit IP Space");
    $self->_find_element($EDIT_IP_SPACE)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);
    $Log->comment(
        "Entering the name of IP space " . $args{'new-name'} );
    $self->_find_element($EDIT_IP_SPACE_NAME)->clear();
    $self->_find_element($EDIT_IP_SPACE_NAME)->send_keys( $args{'new-name'} );
    $Log->comment("Clicking on the Create button");

    $self->_find_element($EDIT_IPSPACE_CREATE_BUTTON)->click();
    $Log->comment(" Checking whether there is any error or Invalid field");

    $self->check_for_error();

    return 1;

} ## end editIpSpace

=head2 editNetworkInterface

Returns hashref

=over

=item Options

=over

=item C<< ddns => SCALAR >>
 (Optional)
=item C<< getValues => SCALAR >>
 (Optional)
=item C<< lif => SCALAR >>
 (Optional)
=item C<< mgmtAccess => SCALAR >>
 (Optional)
=item C<< vserver => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub editNetworkInterface {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my %returnValues;
    try {
        $Log->comment("Setting the network Page");
        $self->setNetworkPage();
        $self->wait_for_element_not_present($LOADING);

        $Log->comment("Creating the Network Interface");
        $self->setNetWorkInterfaceTab();

        $Log->comment("Editing the Network Interface");
        $Log->comment("Selecting the Network Interface navigate edit");
        $self->selectNetworkInterface(
            'lif' => $args{'lif'},
            'vserver'          => $args{'vserver'},
        );
        if (
            !$self->is_button_enabled(
                $self->_find_element($EDIT_INTERFACE_BUTTON)
            )
          )
        {
            $Log->comment("Edit button is disabled");
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            return 0;
        }
        $self->_find_element($EDIT_INTERFACE_BUTTON)->click();
        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
        if ( exists( $args{'mgmtAccess'} ) ) {
            $Log->comment(
                "Finding the element for enabling the Management checkbox");
            my $element = $self->_find_element($ENABLE_MANAGMENT_CHECKBOX);
            $Log->comment("Checking if Management access is  1  or not");
            if ( $args{'mgmtAccess'} =~ /yes/ ) {
                if ( !$self->is_checked($element) ) {
                    $Log->comment("Enabling Management access");
                    $element->click();
                }
                else {
                    $Log->comment("Management access is already enabled");
                }
            }
            else {
                if ( $self->is_checked($element) ) {
                    $Log->comment("Disabling Management access");
                    $element->click();
                }
                else {
                    $Log->comment("Management access is already disabled");
                }
            }
        }
        if ( exists( $args{'ddns'} ) ) {
            $Log->comment(
                "Finding the element for enabling the Management checkbox");
            my $element = $self->_find_element($ENABLE_DDNS_CHECKBOX);
            $Log->comment("Checking if DDNS access is yes or not");
            if ( $args{'ddns'} =~ /yes/ ) {
                if ( !$self->is_checked($element) ) {
                    $Log->comment("Enabling DDNS Checkbox");
                    $element->click();
                }
                else {
                    $Log->comment("DDNS is already enabled");
                }
            }
            else {
                if ( $self->is_checked($element) ) {
                    $Log->comment("Disabling DDNS Checkbox");
                    $element->click();
                }
                else {
                    $Log->comment("DDNS is already disabled");
                }
            }
        }
        if ( exists( $args{'getValues'} ) ) {
            my $name =
              $self->_find_element($EDIT_INTERFACE_NAME_LABEL)->get_text();
            $returnValues{"name"} = $name;
            my $role =
              $self->_find_element($EDIT_INTERFACE_ROLE_LABEL)->get_text();
            $returnValues{"role"} = $role;
            my $vserver =
              $self->_find_element($EDIT_INTERFACE_SVM_LABEL)->get_text();
            $returnValues{"vserver"} = $vserver;
            my $protocol =
              $self->_find_element($EDIT_INTERFACE_PROTOCOL_LABEL)->get_text();
            $returnValues{"protocol"} = $protocol;
            my $subnet =
              $self->_find_element($EDIT_INTERFACE_SUBNET_LABEL)->get_text();
            $returnValues{"subnet"} = $subnet;
            my $port =
              $self->_find_element($EDIT_INTERFACE_PORT_LABEL)->get_text();
            $returnValues{"port"} = $port;

            if (
                $self->is_checked(
                    $self->_find_element($ENABLE_MANAGMENT_CHECKBOX)
                )
              )
            {
                $returnValues{"mgmtAccess"} = "enabled";
            }
            else {
                $returnValues{"mgmtAccess"} = "disabled";
            }
            if (
                $self->is_checked(
                    $self->_find_element($ENABLE_DDNS_CHECKBOX)
                )
              )
            {
                $returnValues{"ddns"} = "enabled";
            }
            else {
                $returnValues{"ddns"} = "disabled";
            }
            if ( $self->is_element_present($EDIT_INTERFACE_WARNING) ) {
                my $warningText =
                  $self->_find_element($EDIT_INTERFACE_WARNING)->get_text();
                $returnValues{"message"} = $warningText;
            }
            if ( $args{'getValues'} =~ /cancel/ ) {
                $Log->comment("Clicking on the cancel button");
                $self->_find_element($EDIT_INTERFACE_CANCEL_BUTTON)->click();
                $Log->comment(
                    "Values in Edit Interface Dialog: " . %returnValues );
                my $return_hash = {};
                $return_hash->{parsed_output} = \%returnValues;
                return $return_hash;
            }
        }
        $Log->comment("Clicking on Save and close button");
        $self->_find_element($EDIT_INTERFACE_SAVE_CLOSE)->click();
        $self->wait_for_element_not_present($LOADING);
        $self->check_for_error();
    }
    catch NATE::BaseException with {
        my $e = shift;
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment( "Exception is " . $e->text() );
        if ( $self->is_element_present($EDIT_INTERFACE_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on the cancel button");
            $self->_find_element($EDIT_INTERFACE_CANCEL_BUTTON)->click();
        }
        return 0;
    };
    my $return_hash = {};
    $return_hash->{parsed_output} = \%returnValues;

    return $return_hash;

} ## end editNetworkInterface

=head2 editPort

Returns boolean

=over

=item Options

=over

=item C<< duplex-admin => SCALAR >>
 (Optional)
=item C<< speed-admin => SCALAR >>
 (Optional)
=item C<< type => SCALAR >>
 (Optional)
=item C<< port => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub editPort {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Editing the Port");

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    
    $Log->comment("Setting the network Page");
    $self->setEthernetPortTab();
    
    $Log->comment("Selecting the port navigate edit");
    $self->selectPort( 'port' => $args{'port'}, );
    $Log->comment("Clicking on the edit button");
    $self->_find_element($EDIT_PORT_BUTTON)->click();
    $Log->comment("Checking duplex type");
    if ( $args{'type'} =~ /auto/ ) {
        $Log->comment("Clicking on Auto Negotiate Radio button");
        $self->_find_element($AUTO_NEGOTIATE_RADIO_BUTTON)->click();
    } else {
        $Log->comment("Clicking on manual setting Radio button");
        $self->_find_element($MANUAL_SETTING_RADIO_BUTTON)->click();
        $Log->comment("Selecting the duplex mode");
        $self->_find_element($SELECT_DUPLEX_MODE)->click();
        $Log->comment( "CLicking on duplex mode " . $args{'duplex-admin'} );
        $self->select_from_dropdown($SELECT_DUPLEX_MODE, $args{'duplex-admin'}, 1);
        $Log->comment("Selecting the Speed");
        $self->_find_element($SELECT_DUPLEX_SPEED)->click();
        $Log->comment( "CLicking on duplex mode " . $args{'speed-admin'} );
        $self->select_from_dropdown($SELECT_DUPLEX_SPEED, $args{'speed-admin'}, 1);

    }
    $Log->comment("Clicking on save button");
    $self->_find_element($EDIT_PORT_SAVE_BUTTON)->click();
    $self->wait_for_element_not_present($LOADING);
    if( $self->is_element_present($CONFIRMATION_CHECKBOX)) {
        $Log->comment("Clicking on Confirmation Ok");
        $self->_find_element($CONFIRMATION_CHECKBOX)->click();
        $self->_find_element($CONFIRM_OK_BUTTON)->click();
    }
    $Log->comment("Checking if any error or invalid field is present");
    $self->check_for_error();

    return 1;
} ## end editPort


=head2 editSubnet

Returns boolean

=over

=item Options

=over

=item C<< gateway => SCALAR >>
 (Optional)
=item C<< ip-ranges => SCALAR >>
 (Optional)
=item C<< subnet-name => SCALAR >>
 (Optional)
=item C<< new-name => SCALAR >>
 (Optional)
=item C<< port => SCALAR >>
 (Optional)
=item C<< subnet => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub editSubnet {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
   
    $Log->comment("Setting the Subnet Tab");
    $self->setSubnetTab();


    $Log->comment("Editing the Subnet");
    if ( $args{'subnet-name'} ) {
        $Log->comment(
            "Selecting the subnet navigate edit " . $args{'subnet-name'} );
        $self->selectSubnet( 'subnet' => $args{'subnet-name'}, );
        $self->wait_for_element_not_present($LOADING);
    }
    $Log->comment("Clicking on EDIT Subnet button");
    $elementIdOrXpath = $self->_find_element($EDIT_SUBNET_BUTTON);
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment("waiting for page navigate load");
    $self->eventWaitingTime( $LOADING, $startTime,
        $methodName . "_ports_in_bd_loading" );
    $Log->comment("Checking if edit subnet name is present");
    if ( !$self->is_element_present($EDIT_SUBNET_NAME) ) {
        $Log->comment(
            "Subnet Name text box is not available navigate Edit subnet");
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $Log->comment("Checking if cancel button is present");
        if ( $self->is_element_present($EDIT_SUBNET_CANCEL_BUTTON) ) {
            $Log->comment("Clicking on Subnet Cancel button");
            $self->_find_element($EDIT_SUBNET_CANCEL_BUTTON)->click();
        }

        $Log->exit() if $may_exit;
        return 0;
    }
    if ( $args{'new-name'} ) {
        $Log->comment("Clearing the Subnet Name field");
        $self->_find_element($EDIT_SUBNET_NAME)->clear();
        $Log->comment(
            "Entering the name for subnet " . $args{'new-name'} );
        $self->_find_element($EDIT_SUBNET_NAME)
          ->send_keys( $args{'new-name'} );
    }
    if ( $args{'subnet'} ) {
        $Log->comment("Clearing the Subnet field");
        $self->_find_element($EDIT_SUBNET)->clear();
        $Log->comment( "Entering the subnet " . $args{'subnet'} );
        $self->_find_element($EDIT_SUBNET)->send_keys( $args{'subnet'} );
    }
    if ( $args{'ip-ranges'} ) {
        $Log->comment("Clearing the IP address field");
        $self->_find_element($EDIT_IP_ADDRESS)->clear();
        $Log->comment( "Entering the IP Address " . $args{'ip-ranges'} );
        $self->_find_element($EDIT_IP_ADDRESS)
          ->send_keys( $args{'ip-ranges'} );
    }
    if ( $args{'gateway'} ) {
        $Log->comment("Clearing the gateway field");
        $self->_find_element($EDIT_GATEWAY)->clear();
        $Log->comment( "Entering the Gateway " . $args{'gateway'} );
        $self->_find_element($EDIT_GATEWAY)->send_keys( $args{'gateway'} );
    }
    if ( $args{'port'} ) {
        $Log->comment("clicking on the Ports link ");
        $self->_find_element($SHOW_PORT)->click();
        $Log->comment("getting the list of ports used");
        my @totalRows;
        try {
            @totalRows = $self->find_elements( 
              "//div[contains(\@id,'gwt-debug-CustomGrid')"
            . " and contains(\@class,'x-grid3-row')]" );
            $Log->comment( "Number of rows->.. : " . @totalRows );
        }
        catch NATE::BaseException with {
            my $e = shift;
            $Log->comment(
                "Unable navigate get the properties " . $e->text() );
        };
        for ( my $i = 0 ; $i < @totalRows ; $i++ ) {
            $Log->comment(
                "element " . $i . " : " . $totalRows[$i]->get_text() );
            push(@ports, $totalRows[$i]->get_text() );
        }
        $Log->comment( "return ports size: " . @ports );
    }
    $Log->comment("clicking on saveclose button");
    $elementIdOrXpath = $self->_find_element($EDIT_SUBNET_SAVECLOSE_BUTTON);
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment(
        "Waiting for the MODIFYING,RENAMING elements not present");
    $self->wait_for_element_not_present($MODIFYING);
    $self->wait_for_element_not_present($RENAMING);
    $self->captureResponseTime( $startTime, $methodName );
    $Log->comment("Checking if there is any error or any invalid field");
    $self->check_for_error();

    $Log->comment("waiting for SETTING element not present");
    $self->wait_for_element_not_present($SETTING);
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    return 1;
} ## end editSubnet


=head2 filterInterface

Returns boolean

=over

=item Options

=over

=item C<< columnVal1 => SCALAR >>
 (Required)
=item C<< columnVal2 => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub filterInterface {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'columnVal1' => { type => SCALAR },
            'columnVal2' => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Filtering Network Interface Page");

    my $NETWORK_INTERFACE_GRID =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkInterfacesPageGrid";
    my $columnName1 = "Interface Name";
    my $columnName2 = "Storage Virtual Machine (SVM)";
    my $value1      = $columnName1 . ":" . $args{'columnVal1'};
    my $value2      = $columnName2 . ":" . $args{'columnVal2'};
    my @columValue  = ( $value1, $value2 );
    $self->set_filters( $NETWORK_INTERFACE_GRID, \@columValue );
    $Log->comment("Values filtered");

    return 1;

} ## end filterInterface


=head2 filterIpSpace

Returns boolean

=over

=item Options

=over

=item C<< columnVal => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub filterIpSpace {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'columnVal' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Filtering IpSpace Page");

    my $ipspaceGrid =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "IpspaceInventoryPageGrid";
    my $columnName = "Name";
    my $value      = $columnName . ":" . $args{'columnVal'};
    my @columValue = ($value);
    $self->set_filters( $ipspaceGrid, \@columValue );

    return 1;

} ## end filterIpSpace


=head2 getAdapterProperties

Returns hash

=over

=item Options

=over

=item C<< adapter => SCALAR >>
 (Required)
=item C<< node => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub getAdapterProperties {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'adapter' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my @columns = (
        "name",           "containing-aggregate",
        "state",          "space-reserve",
        "size-available", "size-total",
        "vol-sis-enabled"
    );

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $self->wait_for_element_not_present($LOADING);
    $Log->comment("Setting the Adapter Tab");
    $self->setAdapterTab();

    $Log->comment("Getting adapter Properties: " . $args{'adapter'} );
    $Log->comment("Refreshing the Adapter Page");
    $self->refreshAdapterPage();
    $Log->comment( "Selecting the adapter " . $args{'adapter'} );
    $self->selectAdapter( 'adapter' => $args{'adapter'},
                          'node'   => $args{'node'} );
    $Log->comment("Creating the object of Grid");
    $Log->comment(
        "Getting the properties of the Adapter in a list of hashmaps");
    my %rowValue =
      $self->getRowDataAsHashMap( gridID => $ADAPTER_GRID, columns => \@columns );

    return %rowValue;

} ## end getAdapterProperties

=head2 getBroadCastDomainPortDetails

Returns hashref

=over

=item Options

=over

=item C<< broadcast-domain => SCALAR >>
 (Optional)
=item C<< ipSpace => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub getBroadCastDomainPortDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'broadcast-domain'  => { type => SCALAR },
            'ipspace' => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment(
        "Getting BroadCastDomain Properties for: "
       . $args{'broadcast-domain'} );
    my $PORT_GRID = "gwt-debug-CustomGrid";
    my $noportMsg = "//div[\@id='gwt-debug-"
        . $self->{$SYSTEM_NAME_KEY}
        . "broadcast-domain-inventory-pageContentPanel']/div[2]/div/fieldset";
    my %values;
    my @totalRows;

    $self->setNetworkPage();
    $self->setBroadCastDomainTab();

    $Log->comment( "selecting the broadcast " . $args{'broadcast-domain'} );
    $self->selectBroadcastDomain(
        'broadcast' => $args{'broadcast-domain'},
        'ipspace'   => $args{'ipspace'},
    );
    if ($self->is_element_present($noportMsg) ) {
        $Log->comment( "no ports attached with BD "
              . $self->_find_element($noportMsg)->get_text() );
        $values{$args{'broadcast-domain'}} = undef;
    } else {
        $values{$args{'broadcast-domain'}} = [];

        @totalRows = $self->find_elements(
            "//div[\@id='" . $PORT_GRID . "']/div/div/div[2]/div/div" );
        $Log->comment( "NUMBER OF Rows = " . @totalRows );

        for ( my $i = 1 ; $i <= @totalRows ; $i++ ) {
            my $value =
              $self->_find_element( "//div[\@id='"
                  . $PORT_GRID . "']/div/div/div[2]/div/div[" . $i
                  . "]/table/tbody/tr/td/div/div" )->get_text();
            push( @{$values{$args{'broadcast-domain'}}}, $value );
        }
        $Log->comment( "Values: " . Dumper(\%values) );
    }

    my $return_hash = {};
    $return_hash->{parsed_output} = \%values;

    return $return_hash;

} ## end getBroadCastDomainPortDetails


=head2 getBroadCastDomainProperties

Returns array

=over

=item Options

=over


=back

=back

=over

=cut

sub getBroadCastDomainProperties {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my %prop;
    my @columns =
      ( "broadcast-domain", "mtu", "ipspace", "port-update-status-combined" );
    
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $self->setNetworkPage();
    $Log->comment("Creating the object of Grid");
    $Log->comment("Getting the properties of the Broadcast domain"
                . " in a list of hashmaps");

    %prop = $self->getRowDataAsHashMap($DOMAIN_GRID, \@columns, );
    $Log->comment("Details:" .Dumper(\%prop));
    my $return_hash = {};
    $return_hash->{parsed_output} = \%prop;

    return $return_hash;


} ## end getBroadCastDomainProperties


=head2 getEditDefaultValues

Returns hash

=over

=item Options

=over


=back

=back

=over

=cut

sub _getEditDefaultValues {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $Log->comment("Setting the BroadCast Tab");
    $self->setBroadCastDomainTab();

    my %resultH;
    
    $Log->comment("Clicking on edit broadcast button");
    $self->_find_element($EDIT_BROADCAST_BUTTON)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $resultH{"name"} = 
      $self->_find_element($EDIT_BROADCAST_NAME)->get_attribute("value");

    $resultH{"mtu"} =
      $self->_find_element($EDIT_BROADCAST_MTU)->get_attribute("value");

    $resultH{"ipspace"} =
      $self->_find_element($EDIT_BROADCAST_IPSPACE)->get_text();

    my @totalRows =
      $self->find_elements( "//div[\@id='gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
          .  "EditBroadcastDomainDialogPortsPanel']//div[contains(\@class,'x-grid3-row')]"
      );

    $Log->comment( "Total Rows: " . @totalRows );
    $resultH{"ports"} = [];
    $resultH{"portState"} = [];

    my @port_elements =
     $self->find_elements( "//div[\@id='gwt-debug-"
            . $self->{$SYSTEM_NAME_KEY}
            . "EditBroadcastDomainDialogPortsPanel']//td[contains"
            . "(\@class,'x-grid3-td-port-node-column')]/div/div");

    foreach my $cur_port_element (@port_elements ) {
        my @node_elements =
            $self->find_elements( "//div[\@id='gwt-debug-"
               . $self->{$SYSTEM_NAME_KEY}
               . "EditBroadcastDomainDialogPortsPanel']"
               . "//td[contains(\@class,'x-grid3-td-$self->{$SYSTEM_NAME_KEY}')]//span");
        foreach my $node_element (@node_elements) {
            my $node_name = $self->stringTrim($node_element->get_text());
            my $cur_port = $self->stringTrim($cur_port_element->get_text());
            $cur_port = $node_name . ":" . $cur_port;
            push( @{$resultH{"ports"}}, $cur_port );
    
            my $checkbox_element =
                $self->_find_element("//td\[div/div\[\@title='$cur_port'\]\]" );
            my $cssPath = $checkbox_element->get_attribute("id");
            eval {
                $self->_find_element("\#$cssPath\[class*=x-grid3-check-col-on\]", "css");
                push( @{$resultH{"portState"}} , "selected" ); 
            };
            if ($@) {
                push( @{$resultH{"portState"}} , "notselected" ); 
            }
        }
    }

    $Log->debug( "Edit default values: " . Dumper(\%resultH)); 

    return %resultH;

} ## end _getEditDefaultValues


=head2 getEthernetPortProperties

Returns HashMap<String, String>

=over

=item Options

=over

=item C<< port => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub getEthernetPortProperties {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'port' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my @columns =
      ( "port", "node", "broadcast-domain", "ipspace", "port-type" );


    $Log->comment( "Getting Port Properties: " . $args{'port'} );
    my $colvalue   = "Port" . ":" . $args{'port'};
    my @columValue = ($colvalue);
    $self->set_filters( $PORT_GRID, \@columValue );
    $Log->comment("Refreshing the Port page");
    $self->refreshPortPage();
    $Log->comment( "Selecting the port " . $args{'port'} );
    $self->selectPort( 'port' => $args{'port'}, );
    $Log->comment("Creating the object of Grid");
    $Log->comment(
        "Getting the properties of the Port in a list of hashmaps");
    my %rowValue =
      $self->getRowDataAsHashMap( $PORT_GRID, \@columns );

    return %rowValue;
} ## end getEthernetPortProperties

=head2 getIpSpaceProperties

Returns array

=over

=item Options

=over


=back

=back

=over

=cut

sub getIpSpaceProperties {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my $ipspaceGrid = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "IpspaceInventoryPageGrid";
    my @columns = ( "ipspace", "broadcast-domains" );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $Log->comment("Creating the object of Grid");
    $Log->comment(
        "Getting the properties of the ipspace");
    my %prop =
      $self->getRowDataAsHashMap( $ipspaceGrid, \@columns );
  $Log->comment("Details: ".Dumper(\%prop));
  return \%prop;
  # my $return_hash = {};
  #   $return_hash->{parsed_output} = \%prop;
  #   return $return_hash;


} ## end getIpSpaceProperties

=head2 getNetworkInterfaceBottomPanelDetails

Returns hash

=over

=item Options

=over

=item C<< lif => SCALAR >>
 (Optional)
=item C<< vserver => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub getNetworkInterfaceBottomPanelDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'lif' => { type => SCALAR },
            'vserver'          => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my %values;
    my @keys = (
        "NetworkAddress",       "Role",
        "IPSpace",              "BroadcastDomain",
        "Netmask",              "Gateway",
        "InterfaceAdminStatus", "InterfaceDynamicUpdateStatus"
    );

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $self->wait_for_element_not_present($LOADING);

    $Log->comment("Creating the Network Interface");
    $self->setNetWorkInterfaceTab();

    $Log->comment(
        "Selecting the NetWork Interface " . $args{'lif'} );
    $self->selectNetworkInterface(
        'lif'       => $args{'lif'},
        'vserver'   => $args{'vserver'},
    );
    $Log->comment("Checking whether Loading is Present");
    $self->is_element_present($LOADING);
    for ( my $i = 0 ; $i < @keys ; $i++ ) {
        my $text =
          $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "NetworkInterfacesBottomPanelGeneralProperties"
              . $keys[$i] )->get_text();
          $Log->comment("Bottom Panel properties found");
        $values{ $keys[$i] } = $text;
    }

    $Log->comment( "Network Interface Bottom panel details: " . Dumper(\%values) );

    return %values;

} ## end getNetworkInterfaceBottomPanelDetails


=head2 getNetworkInterfaceProperties

Returns array

=over

=item Options

=over


=back

=back

=over

=cut

sub getNetworkInterfaceProperties {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my @columns = (
        "interface-name", "vserver",
        "address",        "current-node-with-port",
        "data-protocol",  "management-role",
        "subnet-name",    "role"
    );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $Log->comment("Creating the Network Interface");
    $self->setNetWorkInterfaceTab();

    $Log->comment(
        "Driver is " . $self . " Grid is " . $NETWORK_INTERFACE_GRID );
    $Log->comment("Creating the object of Grid");
    $Log->comment("Properties is " . $self );
    $Log->comment("Getting the properties of the network Interface");
    my %prop =
      $self->getRowDataAsHashMap( gridID =>$NETWORK_INTERFACE_GRID,
                                  columns => \@columns );

    return %prop;

} ## end getNetworkInterfaceProperties


=head2 getSubnetBottomPanelDetails

Returns hash

=over

=item Options

=over

=item C<< subnet => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub getSubnetBottomPanelDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'subnet' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    $self->setNetworkPage();
    my %values;
    my @keys =
      ( "IPUsageMsgLbl", "UsedIPMsgLbl", "AvailableIPMsgLbl", "IPRangesLbl" );
    my @key =
      ( "IPUsageMessage", "UsedIPCount", "AvailableIPCount", "IPRange" );

    $Log->comment( "Selecting the subnet " . $args{'subnet'} );
    $self->selectSubnet( 'subnet' => $args{'subnet'}, );
    $self->is_element_present($LOADING);
    for ( my $i = 0 ; $i < @keys ; $i++ ) {
        my $text =
          $self->_find_element( "gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "SubnetInventoryPage"
              . $keys[$i] )->get_text();
        $values{ $key[$i] } = $text;
    }
    $Log->debug( "subnet bottom panel details: " . Dumper(\%values) );

    return %values;
} ## end getSubnetBottomPanelDetails


=head2 getSubnetProperties

Returns hashref

=over

=item Options

=over


=back

=back

=over

=cut

sub getSubnetProperties {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_; 
    
    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my %values; 
    my @totalRows;
    my @columns = (
        "subnet-name",      "subnet ",
        "gateway",          "available-count",
        "used-count",       "total-count",
        "broadcast-domain", "ipspace"
    );

    $self->refreshSubnetPage();
    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    @totalRows = $self->find_elements(
        "//div[\@class='x-grid3-viewport']/div[2]/div/div");
    $Log->comment( "NUMBER OF Rows = " . @totalRows );

    for ( my $i = 1 ; $i <= @totalRows ; $i++ ) {
        my $value;
        foreach my $column (@columns) {
            $value = $self->_find_element(
                    "//div[\@class='x-grid3-viewport']/div[2]/div/div[" 
                  . $i
                  . "]/table/tbody/tr/td[contains(\@class,'x-grid3-td-"
                  . $column
                  . "')]/div" )->get_text();
            $values{"subnet-name"}->{$column} = $value;
        }
        if ( $values{"subnet-name"}->{"subnet-name"} =~ /None/ ) {
            $values{"subnet-name"} = undef;
        }
    }
    $Log->comment( "Subnet properties: " . Dumper(\%values)); 
    my $return_hash = {};
    $return_hash->{parsed_output} = \%values;

    return $return_hash;
} ## end getSubnetProperties


=head2 getVserverPeerDetails

Returns array

=over

=item Options

=over

=item C<< ifgrpname => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub getVserverPeerDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'ifgrpname' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my @columns = ( "interface-name", "vserver", "address", "is-home" );

    $self->selectInterfaceGroup( 'ifgrp' => $args{'ifgrpname'}, );
    $self->wait_for_element_not_present($LOADING);
    my $gridID = "gwt-debug-$self->{$SYSTEM_NAME_KEY}" 
       . "EthernetPortBottomPanelInterfaceGrid";

    return $self->getRowDataAsHashMap( gridID => $gridID, columns => \@columns);

} ## end getVserverPeerDetails

=head2 getifGroupDetails

Returns HashMap<String, String>

=over

=item Options

=over

=item C<< port => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub getifGroupDetails {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'port' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my %props;

    $Log->comment("Setting the network Page");
    $self->setNetworkPage();

    $self->wait_for_element_not_present($LOADING);
    $self->setEthernetPortTab();

    my $colvalue   = "Port" . ":" . $args{'port'};
    $self->wait_for_element_not_present($LOADING);
    $self->selectPort( 'port' => $args{'port'}, );
    my @fields = ( "Distribution", "Create policy", "Member List" );
    my @valueIds = (
        "EthernetPortBottomPanelDistributionFieldLabelField",
        "EthernetPortBottomPanelCreatePolicyFieldLabelField",
        "EthernetPortBottomPanelMemberListFieldLabelField"
    );
    for ( my $i = 0 ; $i < @valueIds ; $i++ ) {
        my $value = $self->_find_element(
            "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . $valueIds[$i] )->get_text();
        $props{ $fields[$i] } = $value;
    }
    $Log->debug( "ifgrp bottom panel details: " . Dumper(\%props)  );

    my $return_hash = {};
    $return_hash->{parsed_output} = \%props;

    return $return_hash;
} ## end getifGroupDetails

=head2 refreshAdapterPage

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub refreshAdapterPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Refreshing adapter page in System Manager");

    $Log->comment("Clicking on the Refresh button on adapter Page");
    $self->_find_element($ADAPTER_PAGE_REFRESH)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end refreshAdapterPage

=head2 refreshBroadcastDomainPage

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub refreshBroadcastDomainPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;
    $Log->comment("Refreshing BroadCast Domain page in System Manager");

    $Log->comment("Clicking on the Refresh button on BroadCastDomain Page");
    $elementIdOrXpath = $self->_find_element($BD_PAGE_REFRESH);
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment("waiting for the LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime, $methodName );

    return 1;

} ## end refreshBroadcastDomainPage


=head2 refreshIpspacesPage

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub refreshIpspacesPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Refreshing IP spaces page in System Manager");

    $Log->comment("Clicking on the Refresh button on IP spaces Page");
    $self->_find_element($IP_SPACES_PAGE_REFRESH)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end refreshIpspacesPage

=head2 refreshNetworkPage

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub refreshNetworkPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Refreshing Network page in System Manager");

    $Log->comment("Clicking on the Refresh button on Network Page");
    $self->_find_element( "gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
          . "NetworkInterfacePageRefreshPageTBButton" )->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end refreshNetworkPage


=head2 refreshPortPage

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub refreshPortPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Refreshing Port page in System Manager");

    $Log->comment("Clicking on the Refresh button on Port Page");
    $self->_find_element($PORT_PAGE_REFRESH)->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end refreshPortPage

=head2 refreshSubnetPage

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub refreshSubnetPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_; 

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;
    $Log->comment("Refreshing subnet page in System Manager");

     $Log->comment("Setting the network Page");
     $self->setNetworkPage();

     $Log->comment("Setting the Subnet Tab");
     $self->setSubnetTab();

    $Log->comment("Clicking on the Refresh button on Subnet Page");
    $elementIdOrXpath = $self->_find_element($SUBNET_PAGE_REFRESH);
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment("waiting for the LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime, $methodName );

    return 1;
} ## end refreshSubnetPage

=head2 BroadcastDomainRightClickOption

Returns boolean

=over

=item Options

=over

=item C<< broadcast => SCALAR >>
 (Required)
=item C<< ipspace => SCALAR >>
 (Required)
=item C<< menuItem => SCALAR >>
 (Optional)
=item C<< mtu => SCALAR >>
 (Optional)
=item C<< node => SCALAR >>
 (Optional)
=item C<< port => SCALAR >>
 (Optional)
=item C<< ports => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub BroadcastDomainRightClickOption {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    $Log->comment("Setting the network Page");
    $self->setNetworkPage();
    $Log->comment("Setting the BroadCast Tab");
    $self->setBroadCastDomainTab();

    $Log->comment("Right Click Operations");

    my $element =
     $self->_find_element(
        "//div[\@id='gwt-debug-$self->{$SYSTEM_NAME_KEY}"
        . "broadcast-domain-inventory-pageGrid']"
        .  "//tr[td[contains(\@class,'td-broadcast-domain')]//div[text()='$args{broadcast}']"
        . "and td[contains(\@class,'td-ipspace')]//div[text()='$args{ipspace}']]");

    $Log->comment( "element is " . $element );

    if ( $args{'menuItem'} =~ /EditAndClose/ ) {
        if ( $self->rightClick( $element, "Edit" ) ) {
            $Log->comment("Able navigate do right click operation");
            $self->wait_for_element_not_present($LOADING);
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        } else {
            $Log->exit() if $may_exit;
            NATE::BaseException->throw(
                "Not Able navigate do right click operation");
        }
        my %values = $self->_getEditDefaultValues();
        $Log->comment( " Values are " . %values );

        if ( $values{"ports"}->[0] eq $args{'port'}
          && $values{"mtu"}->[0] eq $args{'mtu'}
          && $values{"ipspace"}->[0] eq $args{'ipspace'} 
          && $values{"name"}->[0] eq $args{'broadcast'}
           ) {
            $Log->comment("Verification has been done successfully");
        }
        $Log->comment("Clicking on the Cancel button");
        $self->_find_element($EDIT_BROADCAST_CANCEL_BUTTON)->click();
    }

    if ( $args{'menuItem'} =~ /EditSaveAndClose/ ) {
        if ( $self->rightClick( $element, "Edit" ) ) {
            $Log->comment("Able navigate do right click operation");
            $self->wait_for_element_not_present($LOADING);
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        } else {
            $Log->exit() if $may_exit;
            NATE::BaseException->throw(
                "Not Able navigate do right click operation");
        }

        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);

        if ( !$self->is_element_present($EDIT_BROADCAST_CANCEL_BUTTON) ) {
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            $Log->exit() if $may_exit;
            NATE::BaseException->throw(
                "Not Able to find edit dialog");
        }
        if ( exists( $args{'broadcast'} ) ) {
            $Log->comment(
                "Entering the Broadcast Name " . $args{'broadcast'} );
            $self->_find_element($EDIT_BROADCAST_NAME)->clear();
            $self->_find_element($EDIT_BROADCAST_NAME)
              ->send_keys( $args{'broadcast'} );
        }
        if ( exists( $args{'mtu'} ) ) {
            $Log->comment( "Entering the MTU " . $args{'mtu'} );
            $self->_find_element($EDIT_BROADCAST_MTU)->clear();
            $self->_find_element($EDIT_BROADCAST_MTU)
              ->send_keys( $args{'mtu'} );
        }
   
        if ( exists( $args{'ports'} ) ) {
            my @ports = @{$args{'ports'}};
            foreach my $cur_port (@ports) {
                $Log->comment( "Selecting Port " . $cur_port);
                my $checkbox_element =
                    $self->_find_element("//td\[div/div\[\@title='$cur_port'\]\]" );
                my $cssPath = $checkbox_element->get_attribute("id");
                eval {
                    $Log->comment("Checkbox already checked");
                    $self->_find_element("\#$cssPath\[class*=x-grid3-check-col-on\]",
                      "css");
                };
                if ($@) {
                    # checkbox is not cheked
                    $Log->comment("Checkbox is not checked");
                    $self->_find_element("\#$cssPath\[class*=x-grid3-check-col\]","css")->click();
                }
            }
        }
        $self->wait_for_element_not_present($LOADING);
        $Log->comment("Clicking on the Save button");
        $self->_find_element($EDIT_BROADCAST_ONLY_SAVE_BUTTON)->click();
        $Log->comment("Clicking on the close button");
        $self->_find_element($EDIT_BROADCAST_SAVE_BUTTON)->click();
        $Log->comment(
            " Checking if there is any error or Invalid field present");
        $self->check_for_error();
    }

    if ( $args{'menuItem'} =~ /Delete/ ) {
        if ( $self->rightClick( $element, "Delete" ) ) {
            $Log->comment("Able navigate do right click operation");
            $self->wait_for_element_not_present($LOADING);
            $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        } else {
            $Log->exit() if $may_exit;
            NATE::BaseException->throw(
                "Not Able navigate do right click operation");
        }

        $Log->comment("waiting for the LOADING element not present");
        $self->wait_for_element_not_present($LOADING);
        if ( !$self->is_element_present($CONFIRM_CANCEL_BUTTON) ) {
            $Log->exit() if $may_exit;
            NATE::BaseException->throw(
               "Not able navigate find delete dialog");
        }

        $Log->comment(
            "Clicking on Delete broadcast domain confirmation checkbox");
        $self->_find_element($CONFIRMATION_CHECKBOX)->click();
        if ( $self->is_element_present($CONFIRM_OK_BUTTON) ) {
            $Log->comment(
                "Clicking on Delete broadcast domain confirm OK button");
            $self->_find_element($CONFIRM_OK_BUTTON)->click();
        }
        $Log->comment(
            " Checking if there is any error or Invalid field present");
        $self->check_for_error(); 
        $self->wait_for_element_not_present($LOADING);

    }

    return 1;

} ## end BroadcastDomainRightClickOption


=head2 rightClickInterfaceOpts

Returns boolean

=over

=item Options

=over

=item C<< lif => SCALAR >>
 (Required)
=item C<< menuItem => SCALAR >>
 (Optional)
=item C<< vserver => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub rightClickInterfaceOpts {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Right Click Operations");
    try {
        $self->filterInterface(
            'columnVal1' => $args{'lif'},
            'columnVal2' => $args{'vserver'},
        );
        my $element =
          $self->_find_element( "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "NetworkInterfacesPageGrid']/div[3]/div/div[contains(\@class,'x-grid3-scroller')]/div"
              . "/div/table/tbody/tr/td/div[contains(\@class,'x-grid3-col-interface-name')]/div[text()='"
              . $args{'lif'}
              . "']" );
        $Log->comment( "element is " . $element );
        if ( $args{'menuItem'} =~ /Disable/ ) {
            if ( $self->rightClick( $element, "Disable" ) ) {
                $Log->comment("Able navigate do right click operation");
                $self->wait_for_element_not_present($LOADING);
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            }
            else {
                $Log->comment("Not Able navigate do right click operation");

                $Log->exit() if $may_exit;
                return 0;
            }
            $Log->comment(
"Clicking on the Ok button navigate confirm the Disable operation"
            );
            $self->_find_element(
                "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogOKButton" )
              ->click();
            $self->check_for_error(); 
        }
        if ( $args{'menuItem'} =~ /Delete/ ) {
            if ( $self->rightClick( $element, "Delete" ) ) {
                $Log->comment("Able navigate do right click operation");
                $self->wait_for_element_not_present($LOADING);
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            }
            else {
                $Log->comment("Not Able navigate do right click operation");

                $Log->exit() if $may_exit;
                return 0;
            }
            $Log->comment("Clicking on the confirmation checkbox");
            $self->_find_element($CONFIRMATION_CHECKBOX)->click();
            $Log->comment("Clicking on the delete button");
            $self->_find_element(
                "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogOKButton" )
              ->click();
            $self->check_for_error(); 
        }
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Exception is " . $e );
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        $self->_find_element($CONFIRM_CANCEL_BUTTON)->click();
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end rightClickInterfaceOpts


=head2 rightClickIpSpaceOpts

Returns boolean

=over

=item Options

=over

=item C<< ipspace => SCALAR >>
 (Required)
=item C<< menuItem => SCALAR >>
 (Optional)
=item C<< new-name => SCALAR >>
 (Optional)

=back

=back

=over

=cut

sub rightClickIpSpaceOpts {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Right Click Operations");
    try {
        $Log->comment("Filtering the IpSpace");
        $self->filterIpSpace( 'columnVal' => $args{'ipspace'}, );
        my $element =
          $self->_find_element( "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "IpspaceInventoryPageGrid']/div[3]/div/div[contains(\@class,'x-grid3-scroller')]/div"
              . "/div/table/tbody/tr/td/div[contains(\@class,'x-grid3-col-ipspace')]/div[text()='"
              . $args{'ipspace'}
              . "']" );
        $Log->comment( "element is " . $element );
        if ( $args{'menuItem'} =~ /Delete/ ) {
            if ( $self->rightClick( $element, "Delete" ) ) {
                $Log->comment("Able navigate do right click operation");
                $self->wait_for_element_not_present($LOADING);
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            }
            else {
                $Log->comment("Not Able navigate do right click operation");

                $Log->exit() if $may_exit;
                return 0;
            }
            $Log->comment("Clicking on the confirmation checkbox");
            $self->_find_element($CONFIRMATION_CHECKBOX)->click();
            $Log->comment("Clicking on the delete button");
            $self->_find_element(
                "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogOKButton" )
              ->click();
            $self->check_for_error();
        }
        if ( $args{'menuItem'} =~ /Edit/ ) {
            if ( $self->rightClick( $element, "Edit" ) ) {
                $Log->comment("Able navigate do right click operation");
                $self->wait_for_element_not_present($LOADING);
                $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
            }
            else {
                $Log->comment("Not Able navigate do right click operation");

                $Log->exit() if $may_exit;
                return 0;
            }
            $Log->comment(
                "Entering the name of IP space " . $args{'new-name'} );
            $self->_find_element($EDIT_IP_SPACE_NAME)->clear();
            $self->_find_element($EDIT_IP_SPACE_NAME)
              ->send_keys( $args{'new-name'} );
            $Log->comment("Clicking on the Create button");
            $self->_find_element($EDIT_IPSPACE_CREATE_BUTTON)->click();
            $Log->comment(
                " Checking whether there is any error or Invalid field");
            $self->check_for_error();
        }
    }
    catch NATE::BaseException with {
        my $e = shift;
        $Log->comment( "Exception is " . $e );
        $self->capture_screenshot( $screenshot . $s_count++ . ".png" );
        if ( $self->is_element_present($CONFIRM_CANCEL_BUTTON)) {
            $self->_find_element($CONFIRM_CANCEL_BUTTON)->click();
        }
        if (
            $self->is_element_present(
                "gwt-debug-UtilitiesShowMessageBoxOkButton")
          )
        {
            $self->_find_element("gwt-debug-UtilitiesShowMessageBoxOkButton")
              ->click();
        }
        NATE::BaseException->throw( $e->text() );
    };
    return 1;

} ## end rightClickIpSpaceOpts

=head2 selectAdapter

Returns boolean

=over

=item Options

=over

=item C<< adapter => SCALAR >>
 (Required)
=item C<< node => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectAdapter {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'adapter' => { type => SCALAR },
                          'node'   => { type => SCALAR },
                      },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Selecting adapter");

    $Log->comment( "Finding the Adapter " . $args{'adapter'} );
       $self->_find_element(
           "//div[contains(\@id,'NetworkManagePageFCPAdaptersTabGrid')]//tr[td//div[text()='$args{node}']"
           ." and td[contains(\@class,'x-grid3-td-adapter')]//div[text()='$args{adapter}']]")->click(); 
    $Log->comment( "Clicking on the adapter " . $args{'adapter'} );
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return 1;

} ## end selectAdapter

=head2 selectBroadcastDomain

Returns boolean

=over

=item Options

=over

=item C<< broadcast => SCALAR >>
 (Required)
=item C<< ipSpace => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectBroadcastDomain {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'broadcast' => { type => SCALAR },
            'ipspace'   => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment( "Selecting the Broadcast " . $args{'broadcast'} );

    $self->_find_element( "//div[\@id='gwt-debug-$self->{$SYSTEM_NAME_KEY}"
       . "broadcast-domain-inventory-pageGrid']"
       . "//tr[td[contains(\@class,'td-broadcast-domain')]//div[text()='$args{broadcast}']"
       . "and td[contains(\@class,'td-ipspace')]//div[text()='$args{ipspace}']]")->click();

    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return 1;

} ## end selectBroadcastDomain

=head2 selectInterfaceGroup

Returns boolean

=over

=item Options

=over

=item C<< ifgrp => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectInterfaceGroup {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'ifgrp' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Selecting interface Group");

    $Log->comment(
        "Finding the Interface Group " . $args{'ifgrp'} );
    my $relation =
      $self->_find_element( "//div[contains(\@id,'gwt-debug-". $self->{$SYSTEM_NAME_KEY}
          ."EthernetPortsTabItemGrid')]//div[text() ='$args{'ifgrp'}']");
    $Log->comment(
        "Clicking on the Interface Group " . $args{'ifgrp'} );
    $relation->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return 1;

} ## end selectInterfaceGroup


=head2 selectIpSpace

Returns boolean

=over

=item Options

=over

=item C<< ipSpace => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectIpSpace {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'ipspace' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Selecting ipspace");

    $Log->comment( " Finding the IP Space " . $args{'ipspace'} );
    my $relation =
      $self->_find_element( "//div[\@id='gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
          . "IpspaceInventoryPageGrid']//div[text()='"
          . $args{'ipspace'}
          . "']" );
    $Log->comment( "Element exists "
          . $self->is_element_present(
                "//div[\@id='gwt-debug-"
              . $self->{$SYSTEM_NAME_KEY}
              . "IpspaceInventoryPageGrid']//div[text()='"
              . $args{'ipspace'} . "']"
          )
    );
    $Log->comment( " CLicking on the IP Space " . $args{'ipspace'} );
    $relation->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return 1;

} ## end selectIpSpace


=head2 selectNetworkInterface

Returns boolean

=over

=item Options

=over

=item C<< lif => SCALAR >>
 (Required)
=item C<< vserver => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectNetworkInterface {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params => \@_,
        spec   => {
            'lif' => { type => SCALAR },
            'vserver'          => { type => SCALAR },
        },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment(
        " Selecting the Network Interface " . $args{'lif'} );

    $self->filterInterface(
        'columnVal1' => $args{'lif'},
        'columnVal2' => $args{'vserver'},
    );

    my $relation =
      $self->_find_element( "//div[\@id='gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
          . "NetworkInterfacesPageGrid']/div[3]/div/div[contains(\@class,'x-grid3-scroller')]/div"
          . "/div/table/tbody/tr/td/div[contains(\@class,'x-grid3-col-interface-name')]/div[text()='"
          . $args{'lif'}
          . "']" );
    $Log->comment(
        "Clicking on the Network Interface " . $args{'lif'} );
    $relation->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return 1;

} ## end selectNetworkInterface

=head2 selectPort

Returns boolean

=over

=item Options

=over

=item C<< port => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectPort {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'port' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Selecting port");
    my $colvalue = "Port:".$args{'port'};
    $self->reset_filters( $PORT_GRID, [$colvalue] );
    $self->set_filters( $PORT_GRID, [$colvalue] );

    $Log->comment( "Finding the port " . $args{'port'} );
    my $relation =
      $self->_find_element( "//div[\@id='"
          . $PORT_GRID
          . "']/div/div/div[contains(\@class,'x-grid3-scroller')]/div"
          . "/div/table/tbody/tr/td/div[contains(\@class,'x-grid3-col-port')]/div[text()='"
          . $args{'port'}
          . "']" );
    $Log->comment( "Clicking on the port " . $args{'port'} );
    $relation->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    $Log->exit() if $may_exit;
    return 1;
} ## end selectPort


=head2 selectSubnet

Returns boolean

=over

=item Options

=over

=item C<< subnet => SCALAR >>
 (Required)

=back

=back

=over

=cut

sub selectSubnet {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        spec        => { 'subnet' => { type => SCALAR }, },
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my $selected = $self->_find_element(
        "//div[contains(\@class,'x-grid3-col-subnet-name')]/div[text()='"
      . $args{'subnet'}
      . "']" )->click();
    Log->comment( "Selecting subnet " . $args{'subnet'});
    return $selected;

} ## end selectSubnet


=head2 setAdapterTab

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub setAdapterTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Clicking on the Adapter Tab");
    $self->_find_element($ADAPTER_TAB)->click();
    $Log->comment("Wait for loading");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end setAdapterTab

=head2 setBroadCastDomainTab

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub setBroadCastDomainTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    my ( $package, $file, $line, $subname ) = caller(0);
    my $methodName = $subname;

    $Log->comment("Clicking on BroadCast Domain Tab");
    $elementIdOrXpath = $self->_find_element($BROADCAST_DOMAIN_TAB);
    $startTime        = $self->click_EventTime($elementIdOrXpath);
    $Log->comment("waiting for the LOADING element not present");
    $self->eventWaitingTime( $LOADING, $startTime, $methodName );

    return 1;

} ## end setBroadCastDomainTab


=head2 setEthernetPortTab

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub setEthernetPortTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Clicking on Ethernet Port link");
    $self->_find_element("//li[3]/a[2]/em/span/span")->click();
    $Log->comment("waiting for the LOADING element not present");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end setEthernetPortTab

=head2 setIpSpacesTab

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub setIpSpacesTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Clicking on the IP Spaces Tab");
    $self->_find_element($IpSpaceTabXpath)->click();
    $Log->comment("Wait for loading");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end setIpSpacesTab


=head2 setNetWorkInterfaceTab

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub setNetWorkInterfaceTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args = validate_with(
        params      => \@_,
        allow_extra => 1
    );

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Clicking on the Network Interface Tab");
    $self->_find_element($NETWORK_INTERFACE_TAB)->click();
    $Log->comment("Wait for loading");
    $self->wait_for_element_not_present($LOADING);

    return 1;
} ## end setNetWorkInterfaceTab


=head2 setNetworkPage

Returns boolean

=over

=item Options

=over

=back

=back

=over

=cut

sub setNetworkPage {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );
    
    $Log->comment("Navigating navigate Network Page");
    $self->cluster_tree_navigate( $scope, $Network );

    if ( $self->is_element_present(
            "//button[\@class='x-btn-text ' and text()='OK']")) {
        $Log->comment("clicking on error ok button");
        $self->_find_element(
            "//button[\@class='x-btn-text ' and text()='OK']")->click();
    }

    $SUBNET_TAB =
        "//li[contains(\@id,'gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY} 
      . "NetworkPageNetworkSubnetTab')]";
    $NETWORK_INTERFACE_TAB =  "//li[contains(\@id,'gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
                . "NetworkPageNetworkInterfacesTabTabItem')]";
    $PORTS_TAB =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkPageEthernetPortsTabEthernetPortsTabItem";
    $BROADCAST_DOMAIN_TAB =  "//li[contains(\@id,'gwt-debug-"
          . $self->{$SYSTEM_NAME_KEY}
                . "NetworkPageBroadcastDomainTabTabItem')]";
    $ADAPTER_TAB          = "//div//li[contains(\@id,
    'NetworkPageFcpAdaptersTabFCPAdaptersTabItem')]";
    $IP_SPACES_TAB        = "//div[contains(\@class,'x-tab-panel-header
    x-tab-panel-header-plain x-unselectable')//span(text(), 'IPspaces')";
    $SUBNET_PAGE_GRID =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetInventoryPagePagingGrid";
    $NETWORK_INTERFACE_GRID =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkInterfacesPageGrid";
    $PORT_GRID =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemGrid";
    $DOMAIN_GRID =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "broadcast-domain-inventory-pageGrid";
    $ADAPTER_GRID  = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "AdapterGrid";
    $CREATE_SUBNET =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetInventoryPageCreateButton";
    $DELETE_SUBNET =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetInventoryPageDeleteButton";
    $EDIT_SUBNET_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetInventoryPageEditButton";
    $CREATE_SUBNET_CREATE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetCreateDialogOkButton";
    $CREATE_SUBNET_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetCreateDialogCancelButton";
    $SUBNET_CANCEL_CONFIRMATION =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetSetupCancelConfirmationDialogYes";
    $SUBNET_PAGE_REFRESH =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetInventoryPageRefreshButton";
    $NETWORK_PAGE_REFRESH =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemRefreshButton";
    $PORT_PAGE_REFRESH =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemRefreshButton";
    $ADAPTER_PAGE_REFRESH =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkManagePageFCPAdaptersTabRefreshBtn";
    $IP_SPACES_PAGE_REFRESH = "gwt-debug-"   . $self->{$SYSTEM_NAME_KEY} ."IpsacesInventoryPageRefreshButton";
    $SUBNET_NAME =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetCreateDialogNameFieldValueTextField-input";
    $SUBNET =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetCreateDialogSubnetFieldValueTextField-input";
    $IP_ADDRESS =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetCreateDialogIpAddressListRangeTextArea-input";
    $GATEWAY =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetCreateDialogGatewayFieldValueTextField-input";
    $BROADCAST =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetCreateDialogBcastDomainComboBoxComboBoxWithGrid-input";
    $BROADCAST_BROWSE =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageCreateVlanBrowseButton";
    $SHOWPORTS =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetCreateDialogShowPortsPanelDisclosurePanel-header";
    $EDIT_SUBNET_NAME =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetEditDialogNameFieldValueTextField-input";
    $EDIT_SUBNET =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetEditDialogSubnetFieldValueTextField-input";
    $EDIT_IP_ADDRESS =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetEditDialogIpAddressListRangeTextArea-input";
    $EDIT_GATEWAY =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetEditDialogGatewayFieldValueTextField-input";
    $SHOW_PORT =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetEditDialogShowPortsPanelDisclosurePanel-header";
    $EDIT_SUBNET_SAVECLOSE_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "SubnetEditDialogSaveAndCloseButton";
    $EDIT_SUBNET_SAVE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetEditDialogSaveButton";
    $EDIT_SUBNET_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "SubnetEditDialogCancelButton";
    $CREATE_NETWORK_INTERFACE
    ="gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkInterfacePageCreateInterfaceTBButton";

    $CREATE_INTERFACE_NAME =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "nameField-input";
    $CREATE_INTERFACE_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "cancelButton";
    $CREATE_INTERFACE_CANCEL_CONFIRMATION =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $INTERFACE_ROLE_DATA =
      "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "dataRoleRadio']/input";
    $INTERFACE_INTERCLUSTER =
        "//div[\@id='gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "interClusterRoleRadio']/input";
    $INTERFACE_SVM_TEXT_BOX = "//div[3]/div/div/input";
    $INTERFACE_MANAGEMENT_ACCESS =
        "//div[\@id='gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "mgmtAccessCheckbox']/input";
    $CREATE_INTERFACE_SUBNET_TEXT_BOX = "//tr[5]/td[2]/div/div/div/div/input";
    $CREATE_INTERFACE_SUBNET =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $INERFACE_CREATE_BUTTON = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "okButton";
    $EDIT_INTERFACE_CANCEL_CONFIRMATION =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_PORT_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemEditButton";
    $AUTO_NEGOTIATE_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditEthernetPortDialogAutoNegRadio";
    $SELECT_DUPLEX_MODE =
      "//div[contains(\@id,'EditEthernetPortDialogManualSettingContainerLayoutContainer')]"
     . "//div[label[contains(text(),'Duplex')]]//img";
    $SELECT_DUPLEX_SPEED =
      "//div[contains(\@id,'EditEthernetPortDialogManualSettingContainerLayoutContainer')]/"
     . "/div[label[contains(text(),'Speed')]]//img";
    $EDIT_PORT_SAVE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditEthernetPortDialogOkButton";
    $EDIT_PORT_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditEthernetPortDialogCancelButton";
    $EDIT_PORT_CANCEL_CONFIRMATION =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_INTERFACE_BUTTON =
        "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkInterfacePageEditInterfaceTBButton";
    $ENABLE_MANAGMENT_CHECKBOX =
        "//div[\@id='gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogMgmtAccessCheckboxCheckBox']/input";
    $ENABLE_DDNS_CHECKBOX =
        "//div[\@id='gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogDynamicUpdateCheckBox']/input";
    $EDIT_INTERFACE_CANCEL_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogCancelButton";
    $EDIT_INTERFACE_WWPN =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "TextAddressTextField-input";
    $EDIT_INTERFACE_SAVE_CLOSE =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogOkButton";
    $EDIT_INTERFACE_NAME_LABEL =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogLifNameFieldFixedWidthLabelField";
    $EDIT_INTERFACE_ROLE_LABEL =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogRoleFieldLabelField";
    $EDIT_INTERFACE_SVM_LABEL =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogSvmFieldFixedWidthLabelField";
    $EDIT_INTERFACE_PROTOCOL_LABEL =
        "//div[\@id='gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogPanelNwfFormPanel']/div[2]/div/form/div[4]/div/div";
    $EDIT_INTERFACE_SUBNET_LABEL =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogSubnetFieldFixedWidthLabelField";
    $EDIT_INTERFACE_PORT_LABEL =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogPortFieldLabelField";
    $EDIT_INTERFACE_WARNING =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditNetworkInterfaceDialogDynamicDnsUpdateInfoMessageMessageWithIconContainer";
    $DELETE_INTERFACE_TOOLBAR_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkInterfacePageDeleteInterfaceTBButton";
    $CREATE_INTERFACE_GROUP_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EthernetPortsTabItemCreateIfGroupButton";
    $INTERFACE_GROUP_NAME =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageIfGrpName-input";
    $INTERFACE_GROUP_CANCEL_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageCreateDlgCancelBtn";
    $MANUAL_SETTING_RADIO_BUTTON = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} .
    "EditEthernetPortDialogManualSettingRadio";
    $BROADCAST_DOMAIN_TEXT_BOX =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageCreateIfGrpBroadcastDomainTextField-input";
    $BROADCAST_DOMAIN_BROWSE_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageCreateIfGrpBrowseButton";
    $BROADCAST_DOMAIN_BROWSE_OK_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "BroadcastDomainBrowserDialogOkBtn";
    $BROADCAST_DOMAIN_BROWSE_CANCEL_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "BroadcastDomainBrowserDialogCancelBtn";
    $NODE_TEXT_BOX =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageCreateIfGrpNodeTypeComboBox-input";
    $SINGLE_MODE_RADIO_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageSingleRadio";
    $MULTIPLE_MODE_RADIO_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageMultipleRadio";
    $LCAP_MODE_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkEthernerPortsPageLACPRadio";
    $IP_BASED_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkEthernerPortsPageIPRadio";
    $MAC_BASED_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkEthernerPortsPageMacRadio";
    $SEQUENTIAL_RADIO_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageSequentialRadio";
    $INTERFACE_GROUP_CREATE =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "NetworkEthernerPortsPageCreateDlgOKBtn";
    $EDIT_INTERFACE_GROUP_BUTTON =
    "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemEditButton";
    $EDIT_INTERFACE_GROUP_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditIfGroupDialogCancelButton";
    $EDIT_SINGLE_MODE_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_MULTIPLE_MODE_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_LCAP_MODE_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_IP_BASED_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_MAC_BASED_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_SEQUENTIAL_RADIO_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $EDIT_INTERFACE_GROUP_SAVE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditIfGroupDialogOkButton";
    $CREATE_VLAN_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemCreateVLanButton";
    $CREATE_VLAN_NODE = "gwt-debug-". $self->{$SYSTEM_NAME_KEY} ."NetworkEthernerPortsPageCreateVlanNodeTypeComboBox";
    $CREATE_VLAN_PORT = "//div[4]/div/div/input";
    $EDIT_INTERFACE_DELETE ="gwt-debug-". $self->{$SYSTEM_NAME_KEY} . "EthernetPortsTabItemDeleteButton";    
    $CREATE_VLAN_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "CreateVlanDialogCancelButton";
    $CREATE_VLAN_TAGS =
      "//div[contains(\@id, 'CreateVlanDialogAddContainerLayoutContainer')]//div/input";  
    $CREATE_VLAN_ADD_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "CreateVlanDialogAddButton";
    $CREATE_VLAN_CREATE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "CreateVlanDialogOkButton";
    $EDIT_ADAPTER_SETTING =
    "//table[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "NetworkManagePageFCPAdaptersTabEditBtn']/tbody//button[text()='Edit']";
    $AUTOMATIC_ADAPTER_SPEED =
    " //div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditFCPAdapterDialogAutomaticRadio']/input";
    $MANUAL_ADAPTER_SPEED =
    "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditFCPAdapterDialogManualRadio']/input";
    $MANUAL_SPEED_TEXTBOX =
    "//div[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditFCPAdapterDialogSpeedTextField']/input";
    $EDIT_ADAPTER_SETTING_BUTTON =
    "//table[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} .
    "EditFCPAdapterDialogOkBtn']//button";
    $EDIT_ADAPTER_CANCEL_BUTTON =
    "//table[\@id='gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditFCPAdapterDialogCancelBtn']//button";
    $CREATE_IP_SPACE = "gwt-debug-IpsacesInventoryPageCreateButton";
    $IP_SPACE_NAME =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipspaceNameTextField-input";
    $CREATE_IPSPACE_CREATE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipspaceOkButton";
    $CREATE_IPSPACE_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipspaceCancelButton";
    $EDIT_IP_SPACE = "gwt-debug-IpsacesInventoryPageEditButton";
    $EDIT_IP_SPACE_NAME =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipspaceNameTextField-input";
    $EDIT_IPSPACE_CREATE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipspaceOkButton";
    $EDIT_IPSPACE_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ipspaceCancelButton";
    $ETHERNET_PORT_LINK =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "subnetPageRefreshButton";
    $BD_PAGE_REFRESH =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "BroadcastDomainInventoryPageBtnMgrRefreshButton";
    $CREATE_BROADCAST_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "BroadcastDomainInventoryPageBtnMgrCreateButton";
    $BROADCAST_NAME =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "CreateBroadcastDomainDialogNameTextFld-input";
    $BROADCAST_MTU =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "CreateBroadcastDomainDialogMTUNbrFld-input";
    $IP_SPACE =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "CreateBroadcastDomainDialogIPSpaceCombo-input";
    $CREATE_BROADCAST_CREATE_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "CreateBroadcastDomainDialogCreateBtn";
    $CREATE_BROADCAST_CANCEL_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "CreateBroadcastDomainDialogCancelBtn";
    $CREATE_BROADCAST_ERROR_NOPORT =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "CreateBroadcastDomainDialogSelectPortMsgCtr";
    $EDIT_BROADCAST_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "BroadcastDomainInventoryPageBtnMgrEditButton";
    $EDIT_BROADCAST_NAME =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditBroadcastDomainDialogNameTextFld-input";
    $EDIT_BROADCAST_MTU =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditBroadcastDomainDialogMTUNbrFld-input";
    $EDIT_BROADCAST_IPSPACE =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditBroadcastDomainDialogIPSpaceValueLbl";
    $EDIT_BROADCAST_SAVE_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditBroadcastDomainDialogSaveNCloseBtn";
    $EDIT_BROADCAST_ONLY_SAVE_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "EditBroadcastDomainDialogSaveBtn";
    $EDIT_BROADCAST_CANCEL_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "EditBroadcastDomainDialogCancelBtn";
    $DELETE_BROADCAST_BUTTON =
        "gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "BroadcastDomainInventoryPageBtnMgrDeleteButton";
    $DELETE_IPSPACE = "gwt-debug-IpsacesInventoryPageDeleteButton";
    $CONFIRMATION_CHECKBOX =
        "//div[\@id='gwt-debug-"
      . $self->{$SYSTEM_NAME_KEY}
      . "ConfirmationDialogCheckBox1']/input";
    $CONFIRM_OK_BUTTON = "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogOKButton";
    $CONFIRM_CANCEL_BUTTON =
      "gwt-debug-" . $self->{$SYSTEM_NAME_KEY} . "ConfirmationDialogCancelButton";
    $Log->comment("Wait navigate page load completely");
    $self->wait_for_element_not_present($LOADING);
    return 1;

} ## end setNetworkPage


=head2 setSubnetTab

Returns boolean

=over

=item Options

=over


=back

=back

=over

=cut

sub setSubnetTab {

    my $self = shift;

    $Log->enter() if $may_enter;

    my %args=@_;

    $Log->debug( sub { "Input Hash contains " . Dumper( \%args ) } );

    $Log->comment("Clicking on the Subnet Tab");
    $self->_find_element($SUBNET_TAB)->click();
    $Log->comment("Wait for loading");
    $self->wait_for_element_not_present($LOADING);

    return 1;

} ## end setSubnetTab


1;
