# $Id: //depot/prod/test/nacldev/lib/NACL/APISet/Response/VMAPI.pm $
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Base class for ESX Response object 
## @author bkprasha@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

package NACL::APISet::Response::VMAPI;

use strict;
use warnings;

use base  qw(NACL::APISet::Response);

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();


sub get_method_name {
	my ($self) = shift;
	return $self->{method_name}	;
}

=head1 NAME

NACL::APISet::Response::VMAPI - Base class for ESX Response object 

=head1 SYNOPSIS

 use NACL::APISet::Response::VMAPI;

=head1 DESCRIPTION

A C<NACL::APISet::Response::VMAPI> Base class for ESX Response object 

=head1 Methods

=head2 get_method_name

Gets the name of the method originally called by the user

=over

=item Synopsis

$response_obj = apiset_obj->find_entity_views(view_type => 'VirtualMachine');
$method = $response_obj->get_method_name();

=item Returns

Returns the name of the method called by the user

=back

# $Id: //depot/prod/test/nacldev/lib/NACL/APISet/Response/VMAPI.pm $

=cut


1;
