# $Id: $
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Aggregate Component Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::APISet::Version::Host::SysManager::CMode

=head1 DESCRIPTION
version class stub for OCSM CMode
=cut

package NACL::APISet::Version::Host::SysManager::CMode;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Params::Validate qw(:all);

use base 'NACL::APISet::Version::Host::SysManager';

###############################################################################
# Method:    new
# Objective: Constructor to create DFM version object
# Details:   See POD documentation at the end of this file.
###############################################################################

sub new {
    $Log->enter() if $may_enter;
    my ( $proto, %args ) = @_;

    my $class = ref($proto) || $proto;

    # Validate parameters and populate member variables
    my $self = NACL::APISet::validate_params(
        $class,
        params => \%args,
        spec   => {
            hostobj    => { isa  => "Hostrec", optional => 0 },
            category   => { type => SCALAR, optional => 1, default => 'Host' },
            shell_type => { type => SCALAR, optional => 1, default => 'SysManager::CMode'},
            set        => { type => SCALAR, optional => 1, default => 'SysManager::CMode'},
        }
    );

    bless $self, $class;

    $Log->exit() if $may_exit;
    return $self;
} ## end sub new()

1;
