# -*-perl-*-
#
# Copyright (c) 2015,.. NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DPG Validations
## @author ng-smgr-auto@netapp.com
## @status shared
## @pod here

package NACL::AppBuilder::DpgWorkflows::StringConstants;

use strict;
use warnings;

use Const::Fast;

=head1 NAME

NACL::AppBuilder::DpgWorkflows::StringConstants

=head1 DESCRIPTION

This library contains string constants for DPG workflows

=cut

#
# snapmirror show output constants
#
const our $CSM_CONNECTION_ABORTED => 'csm: connection aborted';
const our $DASH => '-';

#Management and Control Create Assertions
const our $LUN_NO_RENAME => 'Read-only file system';
const our $CREATE_WITH_DST_DP_VOL_FAIL => 'Destination .* must be a read-write volume';
const our $SAME_CREATE_SAME_CGITEMS_FAIL => 'Volume can be a part of only one SnapMirror Consistency Group';
const our $SAME_CREATE_DIFFERENT_CGITEMS_FAIL => 'Volume can be a part of only one SnapMirror Consistency Group';
const our $SRC_ITEMS_MULTIPLE_CG_FAIL => 'Volume can be a part of only one SnapMirror Consistency Group';
const our $DST_ITEMS_MULTIPLE_CG_FAIL => 'Volume can be a part of only one SnapMirror Consistency Group';
const our $GREATER_THAN_MAX_CGITEMS_FAIL => 'Number of items in a SnapMirror Consistency Group cannot exceed';
const our $MIX_FILES_LUNS_CGITEMS_FAIL => 'SnapMirror Consistency Group items can be of only one type file or lun';
const our $CGITEM_FANOUT_FAIL => 'Duplicate source SnapMirror Consistency Group item';
const our $CGITEM_FANIN_FAIL =>'Duplicate destination SnapMirror Consistency Group item';
const our $ONE_CG_PER_SRC_VOL_FAIL => 'Volume can be a part of only one SnapMirror Consistency Group';
const our $ONE_CG_PER_DST_VOL_FAIL => 'Volume can be a part of only one SnapMirror Consistency Group';
const our $CGITEMS_MULTIPLE_SRC_VOL => 'All source SnapMirror Consistency Group items should belong to same volume';
const our $CGITEMS_MULTIPLE_DST_VOL => 'All destination SnapMirror Consistency Group items should belong to same volume';
const our $CG_ITEM_MAPPINGS_NOT_FOUND => 'The specified cg-item-mappings must be the same as the cg-item-mappings used in the existing SnapMirror relationship with destination';
const our $CG_REL_NOT_QUIESED => 'Relationship is not quiesced or quiescing';
const our $INCR_DELETE_NOT_ALLOWED => "SnapMirror operation \"incr_delete\" not allowed, run a complete resync operation before trying the command again\. If the resync fails due to a non-recoverable error, do a full delete and re-create the Consistency Group relationship with proper cg-item-mappings";
const our $CG_MODIFY_IN_PROGRESS => "Modification of this Consistency Group Relationship is in progress\. Wait a few minutes and try the command again";

# Reference: http://opengrok-prd.eng.netapp.com/source/xref/dev/message_catalogs/src/en/snapmirror_errors.et
const our $REL_ALREADY_INITIALIZED => 'Relationship is already initialized\.';
const our $FG_SRC_GEOMETRY_MISMATCH_RECREATE_REL => 'Geometry of the destination FlexGroup has been changed since the SnapMirror relationship was created\. Delete the relationship and delete and recreate the destination FlexGroup with a geometry that matches the source FlexGroup\. Create the SnapMirror relationship again before retrying the operation\.';


# Reference: http://opengrok-prd.eng.netapp.com/source/xref/dev/message_catalogs/src/en/olv_errors.et
const our $FLEXGROUP_EXPAND_FAILED_DP => 'Expanding a DP FlexGroup is not supported\.';
const our $EXPAND_FAILED_SNAPMIRROR => 'Expanding a FlexGroup that is in a SnapMirror relationship is not supported\. Delete and release the SnapMirror relationship to expand the FlexGroup\.';

# LRE & LRSE string in audit logs
const our $LOGICAL_TRANSFER => '(Logical Transfer -).*(Directory Mode)';
const our $LOGICAL_TRANSFER_WITH_SE => '(Logical Transfer with Storage Efficiency -).*(Directory Mode)';
const our $LOGICAL_TRANSFER_FAILURE  => '(Failed to start transfer).*(Compression formats of reference Snapshot copy and transfer Snapshot copy do not match)';

#SE tool for different cg
const our $DATASET_TOOL_PATH_SECONDARY => '/usr/software/test/common/dev/dblade/wafl/compression/tools/cmpr_dataset.pl';
const our $DATASET_TOOL_PATH_ADAPTIVE => '/usr/software/test/common/dev/dblade/wafl/compression/tools/cmpr_dataset_adaptive.pl';

1;
