#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::AppBuilder::Xgen::Resource::Security::FileDirectory::Apply;

use strict;
use warnings;

use parent qw( NACL::Service::Xgen::Resource );

use Params::Validate qw(validate_with SCALAR);
use NACL::Service::Xgen::Exceptions::InvalidAttribute;

sub _validate_private_attrs {
    my ($self, $args) = @_;

    eval {
        $args = validate_with(
            params => [%{$args}],
            spec => {
                "policy-name"     => { type => SCALAR, optional => 1 },
                vserver         => { type => SCALAR, optional => 1 },
            });
    };
    if (my $err = $@) {
        NACL::Service::Xgen::Exceptions::InvalidAttribute->throw($err);
    }

    return $args;
}

1;

__END__

=head1 NAME

NACL::AppBuilder::Xgen::Resource::Security::FileDirectory::Apply

=head1 AUTHOR/MAINTAINER

=over

=item PTEFIT AUTOMATION (ng-ptefit-automation-core@netapp.com)

=back

   Last revised $Date: $ by $Author: $

=cut
