#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Aggregate Ecache Component Module
## @author Paul Chen chenp@netapp.com, dl-metawafl-qa@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::AggregateEcache

=head1 DESCRIPTION

C<NACL::C::AggregateEcache> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>.
It represents access to metawafl nodescope 'tec' command.
A related class is <NACL::CS::AggregateEcacheStats|lib-NACL-CS-EcacheStats-pm>,
which represents the current state of metawafl ecache status.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut


package NACL::C::AggregateEcache;

use strict;
use warnings;

use Params::Validate
    qw(validate_with SCALAR BOOLEAN ARRAYREF HASHREF UNDEF SCALARREF OBJECT);

use base 'NACL::C::Component::ONTAP';

use Class::MethodMaker [scalar => 'aggregate',];

sub _primary_keys_validate_spec {
       return (aggregate => {type => SCALAR},);
}

__PACKAGE__->_nodescope_builder(command => 'mw_tec_init',   method => 'init');
__PACKAGE__->_nodescope_builder(command => 'mw_tec_add',    method => 'add');
__PACKAGE__->_nodescope_builder(command => 'mw_tec_dirty',  method => 'dirty');
__PACKAGE__->_nodescope_builder(command => 'mw_tec_free',   method => 'free');

__PACKAGE__->_cs_call_method_builder(method => 'stats');
__PACKAGE__->_cs_call_method_builder(method => 'flushq');
__PACKAGE__->_cs_call_method_builder(method => 'dumpq');
__PACKAGE__->_cs_call_method_builder(method => 'find', extra_filters => ['key']);

1;
