
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemand Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::AntivirusOnDemand

=head1 DESCRIPTION

C<NACL::C::AntivirusOnDemand> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP AntivirusOnDemand.  A related class is
L<NACL::CS::AntivirusOnDemand|lib-NACL-CS-AntivirusOnDemand-pm>, which represents
the past state of an ONTAP AntivirusOnDemand.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 jobid

=head2 vserver

=cut

package NACL::C::AntivirusOnDemand;

use strict;
use warnings;

use NACL::CS::AntivirusOnDemand;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;
use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::C::Exceptions::AntivirusOnDemand::AlreadyScheduled ();

=head1 METHODS

=head2 new

  my $AntivirusOnDemand = NACL::C::AntivirusOnDemand->new(command_interface=>$ci,
                                   jobid =>$jobid,
                                  );

Return a new AntivirusOnDemand component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'jobid',
    scalar => 'vserver',
];

=head2 find

    my $AntivirusOnDemand  = NACL::C::AntivirusOnDemand->find(command_interface => $ci, ...);
    my @AntivirusOnDemands = NACL::C::AntivirusOnDemand->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-get-iter' api for CMode ZAPI.

=head2 state

    my $AntivirusOnDemand_state = $NACL::C::AntivirusOnDemand->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::AntivirusOnDemand would return
a NACL::CS::AntivirusOnDemand object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses CMode CLI/ZAPI APISet.

=cut

=head2 schedule

   NACL::C::AntivirusOnDemand->schedule(
                                command_interface => $ci,
                                  ...);

(Class method)
This method is used to schedules On-Demand Scan.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-schedule' api for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "command" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: command

=item C<< "schedule" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: schedule

=item C<< "vserver" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand schedule" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub schedule {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( command schedule vserver
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'antivirus_on_demand_schedule',
    );

    my $ret;
    try {
        $ret = $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => "_schedule_cmode_cli",
                    interface => "CLI",
                    set       => "CMode",
                },
                {   method    => "_schedule_cmode_zapi",
                    interface => "ZAPI",
                    set       => "CMode",
                },
            ],
            frontend => 'NACL::C::AntivirusOnDemand::schedule',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::AntivirusOnDemand::AlreadyScheduled
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub schedule

sub _schedule_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = validate_with(
        params      => \@_,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $allowed_cmode_options = [
        qw( command schedule vserver
            extended_query )
    ];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->antivirus_on_demand_schedule(%cmode_args);
    my $jobid = NACL::CS::AntivirusOnDemand->fetch(
        command_interface => $command_interface,
        filter            => {
            vserver => $cmode_args{vserver},
            name    => $cmode_args{command},
        },
    );
    my %args_to_new = (
        command_interface => $command_interface,
        jobid             => $jobid->jobid(),
    );
    $args_to_new{vserver} = $cmode_args{vserver}
        if (exists $cmode_args{vserver});

    my $obj = $pkg->new(%args_to_new);
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub _schedule_cmode_cli

sub _schedule_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $allowed_cmode_options = [qw( command schedule vserver )];

    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_schedule(%cmode_args);
    my $jobid = NACL::CS::AntivirusOnDemand->fetch(
        command_interface => $command_interface,
        filter            => {
            vserver => $cmode_args{vserver},
            name    => $cmode_args{command},
        },
    );

    my $obj = $pkg->new(
        command_interface => $command_interface,
        vserver           => $cmode_args{vserver},
        jobid             => $jobid->jobid(),
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub _schedule_cmode_zapi

=head2 abort

   NACL::C::AntivirusOnDemand->abort(
                                command_interface => $ci,
                                id => $id,
                                  ...);

(Class method)
This method is used to aborts On-Demand Scan.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-abort' api for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "jobid" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: id

=item C<< "vserver" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'id' => $string >>

ID possible value(s) are, integer

Applicable for CMode CLI

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand abort" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub abort {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( jobid

                    id
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'antivirus_on_demand_abort',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_abort_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_abort_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::AntivirusOnDemand::abort',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub abort

sub _abort_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    %opts = $pkg->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_abort',
        options => \%opts,
    );

    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        map    => {'jobid' => 'id'},
        target => \%cmode_args,
    );

    $apiset->antivirus_on_demand_abort(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _abort_cmode_cli

sub _abort_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    my $apiset = $opts{apiset};

    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        map    => {'jobid' => 'id'},
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_abort(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _abort_cmode_zapi

=head2 unschedule

   NACL::C::AntivirusOnDemand->unschedule(
                                command_interface => $ci,
                                 id => $id,
                                  ...);

(Class method)
This method is used to unschedules On-Demand Scan.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-unschedule' api for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "jobid" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: id

=item C<< "vserver" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'id' => $string >>

ID possible value(s) are, integer

Applicable for CMode CLI

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand unschedule" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub unschedule {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( jobid vserver

                    id
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'antivirus_on_demand_unschedule',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_unschedule_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_unschedule_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::AntivirusOnDemand::unschedule',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub unschedule

sub _unschedule_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my %cmode_args = $pkg->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_unschedule',
        options => \%opts,
    );

    if (exists $opts{jobid}) {
        $cmode_args{id} = $opts{jobid};
    }

    $apiset->antivirus_on_demand_unschedule(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _unschedule_cmode_cli

sub _unschedule_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => [qw( vserver )],
        map    => {'jobid' => 'id'},
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_unschedule(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _unschedule_cmode_zapi

=head2 run

   NACL::C::AntivirusOnDemand->run(
                                command_interface => $ci,
                                  ...);

(Class method)
This method is used to runs On-Demand Scan.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-run' api for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "verbose" => $string >>

Applicable for CMode CLI.

=item C<< "print" => $string >>

Applicable for CMode CLI.

=item C<< "command" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: command

=item C<< "vserver" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand run" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub run {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( verbose print command vserver
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'antivirus_on_demand_run',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_run_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_run_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::AntivirusOnDemand::run',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub run

sub _run_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};
    my $prompts_answers = ['Do you want to continue? {y|n}:' => "y",];

    my %cmode_args = $pkg->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_run',
        options => \%opts,
    );

    $apiset->antivirus_on_demand_run(%cmode_args,
        'connectrec-match_table' => $prompts_answers);
    $Log->exit() if $may_exit;
} ## end sub _run_cmode_cli

sub _run_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate_with(
        params      => \@args,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $allowed_cmode_options = [qw( command vserver )];

    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_run(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _run_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'jobid'   => {type => SCALAR | UNDEF, optional => 1},
        'vserver' => {type => SCALAR,         optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
