# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemandCommandScanCluster Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::AntivirusOnDemandCommandScanCluster

=head1 DESCRIPTION

C<NACL::C::AntivirusOnDemandCommandScanCluster> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP AntivirusOnDemandCommandScanCluster.  A related class is
L<NACL::CS::AntivirusOnDemandCommandScanCluster|lib-NACL-CS-AntivirusOnDemandCommandScanCluster-pm>, which represents
the past state of an ONTAP AntivirusOnDemandCommandScanCluster.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 name

=cut

package NACL::C::AntivirusOnDemandCommandScanCluster;

use strict;
use warnings;

use NACL::CS::AntivirusOnDemandCommandScanCluster;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::C::Exceptions::AntivirusOnDemandCommandScanCluster::AlreadyExists (
);
use NACL::C::Exceptions::AntivirusOnDemandCommandScanCluster::DoesNotExist ();
use NACL::C::Exceptions::AntivirusOnDemandCommandScanCluster::InUse        ();

use NACL::C::_Mixins::AntivirusOnDemandCommand qw(:exceptions);

=head1 METHODS

=head2 new

  my $AntivirusOnDemandCommandScanCluster = NACL::C::AntivirusOnDemandCommandScanCluster->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'name' => $name,
                                  );

Return a new AntivirusOnDemandCommandScanCluster component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'name',
];

=head2 find

    my $AntivirusOnDemandCommandScanCluster_obj  = NACL::C::AntivirusOnDemandCommandScanCluster->find(command_interface => $ci, ...);
    my @AntivirusOnDemandCommandScanCluster_objs = NACL::C::AntivirusOnDemandCommandScanCluster->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method invokes  av-on-demand-command-scan-cluster-get-iter for CMode ZAPI.

=head2 state

    my AntivirusOnDemandCommandScanCluster_state = $AntivirusOnDemandCommandScanCluster_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::AntivirusOnDemandCommandScanCluster would return
a NACL::CS::AntivirusOnDemandCommandScanCluster object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method invokes  av-on-demand-command-scan-cluster-get-iter for CMode ZAPI.

=cut

=head2 delete

    NACL::C::AntivirusOnDemandCommandScanCluster->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'name' => $name,
                                ...);

                                 or

    $AntivirusOnDemandCommandScanCluster_obj->delete(...);

(Class or instance method)
This method is used to deletes an On-demand Scan Command.
Uses a CMode CLI/ZAPI APISet.
This method invokes  av-on-demand-command-scan-cluster-destroy for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Applicable for CMode CLI

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Command Name
Applicable for CMode CLI/ZAPI
This maps to command-name in CMode ZAPI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand command scan-cluster delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::AntivirusOnDemandCommandScanCluster::DoesNotExist>

This type of exception gets thrown if an attempt is made to delete an
on-demand cluster scan that does not exist.

=item C<NACL::C::Exceptions::AntivirusOnDemandCommandScanCluster::InUse>

This type of exceptions gets thrown if an attempt is made to delete an
on-demand cluster scan when the command is in use.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'antivirus_on_demand_command_scan_cluster_delete',
    );
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_delete_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_delete_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend =>
                'NACL::C::AntivirusOnDemandCommandScanCluster::delete',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        __PACKAGE__->_convert_exception(exception => $_[0]);
    };
    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my %cmode_args = $pkg_or_obj->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_command_scan_cluster_delete',
        options => \%opts,
    );

    $apiset->antivirus_on_demand_command_scan_cluster_delete(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    delete $opts{command_interface};
    my $apiset = $opts{apiset};

    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        map    => {'name' => 'command-name',},
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_scan_cluster_delete(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::AntivirusOnDemandCommandScanCluster->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'name' => $name,
                                ...);

                                 or

    $AntivirusOnDemandCommandScanCluster_obj->modify(...);

(Class or instance method)
This method is used to modifies an On-demand Scan Command.
Uses a CMode CLI/ZAPI APISet.
This method invokes  av-on-demand-command-scan-cluster-modify for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Applicable for CMode CLI/ZAPI

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Command Name
Applicable for CMode CLI/ZAPI
This maps to command-name in CMode ZAPI.

=item C<< 'recursion' => $string >>

Enable Subdirectory Recusion, possible value(s) are on,off
Applicable for CMode CLI/ZAPI.
This maps to enable-subdirectory-recursion in CMode ZAPI.

=item C<< 'include-files' => $string >>

Include or Exclude File-pattern, possible value(s) are include,exclude
Applicable for CMode CLI/ZAPI

=item C<< 'force' => $string >>

Force Creation
Applicable for CMode CLI/ZAPI

=item C<< 'include-directories' => $string >>

Include or Exclude Directory-pattern, possible value(s) are include,exclude
Applicable for CMode CLI/ZAPI

=item C<< 'include-vservers' => $string >>

Include or Exclude Vserver-pattern, possible value(s) are include,exclude
Applicable for CMode CLI/ZAPI

=item C<< 'follow-junctions' => $string >>

Enable Follow Junction, possible value(s) are on,off
Applicable for CMode CLI/ZAPI.
This maps to enable-junction-following in CMode ZAPI.

=item C<< 'vserver-pattern' => $string >>

Regular Expression for Vservers
Applicable for CMode CLI/ZAPI

=item C<< 'file-pattern' => $string >>

Regular Expression for Files
Applicable for CMode CLI/ZAPI

=item C<< 'directory-pattern' => $string >>

Regular Expression for Directories
Applicable for CMode CLI/ZAPI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand command scan-cluster modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( recursion include-files force include-directories include-vservers
                    follow-junctions vserver-pattern file-pattern directory-pattern
                    )
            ),
        },
        api => 'antivirus_on_demand_command_scan_cluster_modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::AntivirusOnDemandCommandScanCluster::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my %cmode_args = $pkg_or_obj->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_command_scan_cluster_modify',
        options => \%opts,
    );

    $apiset->antivirus_on_demand_command_scan_cluster_modify(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    delete $opts{command_interface};
    my $apiset = $opts{apiset};

    my $allowed_cmode_options = [
        qw(  include-files force include-directories
            include-vservers  vserver-pattern file-pattern
            directory-pattern
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {
            'name'             => 'command-name',
            'follow-junctions' => 'enable-junction-following',
            'recursion'        => 'enable-subdirectory-recursion',
        },
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_scan_cluster_modify(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $AntivirusOnDemandCommandScanCluster_obj    = NACL::C::AntivirusOnDemandCommandScanCluster->create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'name' => $name,
                                ...);

(Class method)
This method is used to adds a new On-demand Scan Command.
Uses a CMode CLI/ZAPI APISet.
This method invokes  av-on-access-policy-create for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver
Applicable for CMode CLI/ZAPI

=item C<< 'name' => $name >>

(Required)
Command Name
Applicable for CMode CLI/ZAPI
This maps to command-name in CMode ZAPI.

=item C<< 'recursion' => $string >>

Enable Subdirectory Recusion, possible value(s) are on,off
Applicable for CMode CLI/ZAPI.
This maps to enable-subdirectory-recursion in CMode ZAPI.

=item C<< 'include-files' => $string >>

Include or Exclude File-pattern, possible value(s) are include,exclude
Applicable for CMode CLI/ZAPI

=item C<< 'force' => $string >>

Force Creation
Applicable for CMode CLI/ZAPI

=item C<< 'include-directories' => $string >>

Include or Exclude Directory-pattern, possible value(s) are include,exclude
Applicable for CMode CLI/ZAPI

=item C<< 'include-vservers' => $string >>

Include or Exclude Vserver-pattern, possible value(s) are include,exclude
Applicable for CMode CLI/ZAPI

=item C<< 'follow-junctions' => $string >>

Enable Follow Junction, possible value(s) are on,off
Applicable for CMode CLI/ZAPI.
This maps to enable-junction-following in CMode ZAPI.

=item C<< 'vserver-pattern' => $string >>

Regular Expression for Vservers
Applicable for CMode CLI/ZAPI

=item C<< 'file-pattern' => $string >>

Regular Expression for Files
Applicable for CMode CLI/ZAPI

=item C<< 'directory-pattern' => $string >>

Regular Expression for Directories
Applicable for CMode CLI/ZAPI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand command scan-cluster create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::AntivirusOnDemandCommandScanCluster::AlreadyExists>

This type of exception gets thrown if an attempt is made to create an
on-demand cluster scan command that already exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( recursion include-files force include-directories include-vservers
                    follow-junctions vserver-pattern file-pattern directory-pattern
                    )
            ),
        },
        api => 'antivirus_on_demand_command_scan_cluster_create',
    );
    my $obj;
    try {
        $obj = $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_create_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_create_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend =>
                'NACL::C::AntivirusOnDemandCommandScanCluster::create',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        __PACKAGE__->_convert_exception(exception => $_[0]);
    }
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = $pkg->_validate_backend_opts(@args);

    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my %cmode_args = $pkg->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_command_scan_cluster_create',
        options => \%opts,
    );

    $apiset->antivirus_on_demand_command_scan_cluster_create(%cmode_args);
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vserver           => $cmode_args{'vserver'},
        name              => $cmode_args{'name'},
    );
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = $pkg->_validate_backend_opts(@args);

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $allowed_cmode_options = [
        qw(  include-files  force include-directories
            include-vservers  vserver-pattern file-pattern
            directory-pattern
            )
    ];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {
            'name'             => 'command-name',
            'follow-junctions' => 'enable-junction-following',
            'recursion'        => 'enable-subdirectory-recursion',
        },
        target => \%cmode_args,
    );

    $apiset->av_on_demand_command_scan_cluster_create(%cmode_args);
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        name              => $cmode_args{'command-name'},
    );
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR | UNDEF, optional => 1},
        'name'    => {type => SCALAR},
    );
}

1;
