# $Id: //depot/prod/test/nacldev/lib/NACL/C/AntivirusOnDemandCommandScanDir.pm#4 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemandCommandScanDir Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::AntivirusOnDemandCommandScanDir

=head1 DESCRIPTION

C<NACL::C::AntivirusOnDemandCommandScanDir> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP AntivirusOnDemandCommandScanDir.  A related class is
L<NACL::CS::AntivirusOnDemandCommandScanDir|lib-NACL-CS-AntivirusOnDemandCommandScanDir-pm>, which represents
the past state of an ONTAP AntivirusOnDemandCommandScanDir.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 name

=cut

package NACL::C::AntivirusOnDemandCommandScanDir;

use strict;
use warnings;

use NACL::CS::AntivirusOnDemandCommandScanDir;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use NATE::BaseException qw(:try);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::APISet::Exceptions::ResponseException qw(:try);
use NACL::C::Exceptions::AntivirusOnDemandCommandScanDir::AlreadyExists ();
use NACL::C::Exceptions::AntivirusOnDemandCommandScanDir::DoesNotExist  ();
use NACL::C::Exceptions::AntivirusOnDemandCommandScanDir::InUse         ();

use NACL::C::_Mixins::AntivirusOnDemandCommand qw(:exceptions);

=head1 METHODS

=head2 new

  my $AntivirusOnDemandCommandScanDir = NACL::C::AntivirusOnDemandCommandScanDir->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'name' => $name,
                                  );

Return a new AntivirusOnDemandCommandScanDir component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
} ## end sub init

=head2 find

    my $AntivirusOnDemandCommandScanDir_obj  = NACL::C::AntivirusOnDemandCommandScanDir->find(command_interface => $ci, ...);
    my @AntivirusOnDemandCommandScanDir_objs = NACL::C::AntivirusOnDemandCommandScanDir->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'av-on-demand-command-scan-dir-get-iter' api for CMode ZAPI.

=head2 state

    my AntivirusOnDemandCommandScanDir_state = $AntivirusOnDemandCommandScanDir_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::AntivirusOnDemandCommandScanDir would return
a NACL::CS::AntivirusOnDemandCommandScanDir object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 modify

    NACL::C::AntivirusOnDemandCommandScanDir->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'name' => $name,
                                ...);

                                 or

    $AntivirusOnDemandCommandScanDir_obj->modify(...);

(Class or instance method)
This method is used to modifies an On-demand Scan Command.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-scan-dir-modify' api for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI

Maps to:
  CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
  option.

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Command Name

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: command-name

=item C<< 'scan-path' => $string >>

Path Name

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: scan-path

=item C<< 'recursion' => $string >>

Enable Subdirectory Recusion, possible value(s) are on,off

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: enable-subdirectory-recursion

=item C<< 'include-files' => $string >>

Include or Exclude File-pattern, possible value(s) are include,exclude

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: include-files

=item C<< 'follow-junctions' => $string >>

Enable Follow Junction, possible value(s) are on,off

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: enable-junction-following

=item C<< 'file-pattern' => $string >>

Regular Expression for Files

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: file-pattern

=item C<< 'force' => $string >>

Force Creation

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: force

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand command scan-dir modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( scan-path recursion include-files follow-junctions file-pattern force
                    )
            ),
        },
        api => 'antivirus_on_demand_command_scan_dir_modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::AntivirusOnDemandCommandScanDir::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    my $apiset = delete $opts{apiset};

    my %cmode_args = $pkg_or_obj->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_command_scan_dir_modify',
        options => \%opts,
    );
    $pkg_or_obj->_handle_cli_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $cmode_args{vserver},
        command_interface => $opts{command_interface},
        frontend_method   => 'modify',
    );

    $apiset->antivirus_on_demand_command_scan_dir_modify(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vserver           = $opts{vserver};

    my $allowed_cmode_options = [
        qw( scan-path include-files file-pattern
            force
            )
    ];
    my %cmode_args;

    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {
            'follow-junctions' => 'enable-junction-following',
            'name'             => 'command-name',
            'recursion'        => 'enable-subdirectory-recursion',
        },
        target => \%cmode_args,
    );

    $pkg_or_obj->_handle_zapi_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $vserver,
        command_interface => $command_interface
    );

    my $conversion_values = {'on' => 'true', 'off' => 'false'};
    my $options_values_to_translate
        = [qw( enable-junction-following enable-subdirectory-recursion )];
    foreach my $option (@$options_values_to_translate) {
        if (defined $cmode_args{"$option"}) {
            $cmode_args{"$option"}
                = $conversion_values->{$cmode_args{$option}};
        }
    }

    $apiset->av_on_demand_command_scan_dir_modify(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi

=head2 delete

    NACL::C::AntivirusOnDemandCommandScanDir->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'name' => $name,
                                ...);

                                 or

    $AntivirusOnDemandCommandScanDir_obj->delete(...);

(Class or instance method)
This method is used to deletes an On-demand Scan Command.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-scan-dir-delete/av-on-demand-command-scan-dir-destroy'
api for CMode ZAPI.

CMode ZAPI try to run the delete command, if the command
not supported in the build then it will try to run the destroy command.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:
  CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
  option.

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Command Name

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: command-name

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand command scan-dir delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::AntivirusOnDemandCommandScanDir::DoesNotExist>

This type of exception gets thrown if an attempt is made to delete an
on-demand directory scan that does not exist.

=item C<NACL::C::Exceptions::AntivirusOnDemandCommandScanDir::InUse>

This type of exceptions gets thrown if an attempt is made to delete an
on-demand directory scan when the command is in use.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'antivirus_on_demand_command_scan_dir_delete',
    );
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_delete_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_delete_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::AntivirusOnDemandCommandScanDir::delete',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        __PACKAGE__->_convert_exception(exception => $_[0]);
    };

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    my $apiset = delete $opts{apiset};

    my %cmode_args = $pkg_or_obj->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_command_scan_dir_delete',
        options => \%opts,
    );
    $pkg_or_obj->_handle_cli_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $cmode_args{vserver},
        command_interface => $opts{command_interface},
        frontend_method   => 'delete',
    );

    $apiset->antivirus_on_demand_command_scan_dir_delete(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_validate_backend_opts(@args);

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vserver           = $opts{vserver};

    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        map    => {'name' => 'command-name'},
        target => \%cmode_args,
    );

    $pkg_or_obj->_handle_zapi_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $vserver,
        command_interface => $command_interface
    );

    try {
        $apiset->av_on_demand_command_scan_dir_delete(%cmode_args);
    }
    catch NACL::APISet::Exceptions::CommandNotFoundException with {

   #caught a command failed exception.
   #trying to delete the entry using av-on-demand-command-scan-dir-destroy api
        $apiset->av_on_demand_command_scan_dir_destroy(%cmode_args);
    };
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_zapi

=head2 create

    my $AntivirusOnDemandCommandScanDir_obj    = NACL::C::AntivirusOnDemandCommandScanDir->create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'name' => $name,
                                ...);

(Class method)
This method is used to adds a new On-demand Scan Command.

Uses a CMode CLI/ZAPI APISet.

Invokes 'av-on-demand-command-scan-dir-create' api for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI.

Maps to:
  CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
  option.

=item C<< 'name' => $name >>

(Required)
Command Name

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: name

=item C<< 'scan-path' => $string >>

Path Name

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: scan-path

=item C<< 'recursion' => $string >>

Enable Subdirectory Recusion, possible value(s) are on,off

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: enable-subdirectory-recursion

=item C<< 'include-files' => $string >>

Include or Exclude File-pattern, possible value(s) are include,exclude

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: include-files

=item C<< 'follow-junctions' => $string >>

Enable Follow Junction, possible value(s) are on,off

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: enable-junction-following

=item C<< 'file-pattern' => $string >>

Regular Expression for Files

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: file-pattern

=item C<< 'force' => $string >>

Force Creation

Applicable for CMode CLI/ZAPI.

Maps to:
    CM ZAPI: force

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"antivirus on-demand command scan-dir create" command in ONTAP.

Applicable for CMode CLI.

=back

=item Exceptions

=back

=over

=item C<NACL::C::Exceptions::AntivirusOnDemandCommandScanDir::AlreadyExists>

This type of exception gets thrown if an attempt is made to create an
on-demand directory scan command that already exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( scan-path recursion include-files follow-junctions file-pattern force
                    )
            ),
        },
        api => 'antivirus_on_demand_command_scan_dir_create',
    );
    my $obj;
    try {
        $obj = $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_create_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_create_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::AntivirusOnDemandCommandScanDir::create',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        __PACKAGE__->_convert_exception(exception => $_[0]);
    };

    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = $pkg->_validate_backend_opts(@args);

    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my %cmode_args = $pkg->get_api_options(
        apiset  => $apiset,
        api     => 'antivirus_on_demand_command_scan_dir_create',
        options => \%opts,
    );
    my $vserver = $pkg->_handle_cli_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $cmode_args{vserver},
        command_interface => $command_interface,
        frontend_method   => 'delete',
    );

    $apiset->antivirus_on_demand_command_scan_dir_create(%cmode_args);
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vserver           => $vserver,
        name              => $cmode_args{'name'},
    );
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = $pkg->_validate_backend_opts(@args);

    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vserver           = $opts{vserver};

    my $allowed_cmode_options = [
        qw( scan-path include-files file-pattern
            force
            )
    ];

    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        map    => {
            'follow-junctions' => 'enable-junction-following',
            'name'             => 'command-name',
            'recursion'        => 'enable-subdirectory-recursion',
        },
        target => \%cmode_args,
    );

    $vserver = $pkg->_handle_zapi_vserver_context(
        api_opts          => \%cmode_args,
        vserver           => $vserver,
        command_interface => $command_interface
    );

    my $conversion_values = {'on' => 'true', 'off' => 'false'};
    my $options_values_to_translate
        = [qw( enable-junction-following enable-subdirectory-recursion )];
    foreach my $option (@$options_values_to_translate) {
        if (defined $cmode_args{"$option"}) {
            $cmode_args{"$option"}
                = $conversion_values->{$cmode_args{$option}};
        }
    }

    $apiset->av_on_demand_command_scan_dir_create(%cmode_args);

    my $obj = $pkg->new(
        command_interface => $command_interface,
        vserver           => $vserver,
        name              => $cmode_args{'command-name'},
    );
    $Log->exit() if $may_exit;
    return $obj;

} ## end sub _create_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR},
        'name'    => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
