#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
## @summary Sanlun Component Module
## @author dl-nacl-dev@netapp.com, gupendra@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::Sanlun

=head1 DESCRIPTION

C<NACL::C::Client::Sanlun> Is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>. 

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 lun_pathname

Lun path name

=head2 controller

Name of the controller

=head2 device_filename

Device file name

=head2 adapter

Name of the adapter

=cut

package NACL::C::Client::Sanlun;
use strict;
use warnings;
use NACL::CS::Client::Sanlun;
use base 'NACL::C::Component::Client';
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use Params::Validate qw(validate_with SCALAR BOOLEAN);
use NACL::APISet::Exceptions::ResponseException qw/:try/;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

    my $lunshow = NACL::C::Client::Sanlun->new( command_interface => $ci );

Return a new sanlun component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'lun_pathname',
    scalar => 'controller',
    scalar => 'device_filename',
    scalar => 'adapter',
];

sub _primary_keys_validate_spec {
    return (
        'lun_pathname' => { type => SCALAR , optional => 1},
        'controller'   => { type => SCALAR, optional => 1 },
        'device_filename' => { type => SCALAR, optional => 1 },
        'adapter'         => { type => SCALAR, optional => 1 },
    );
}

1;
