# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Abstract base class for SysManager components
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::Component::SysManager

=head1 SYNOPSIS

    use base 'NACL::C::Component::SysManager';

=head1 DESCRIPTION

NACL::C::Component::SysManager is an abstract base class for all
SysManager Component libraries.
It is derived from L<NACL::C::Component|lib-NACL-C-Component-pm>
and it provides SysManager specific component base class methods.

=head1 ATTRIBUTES

Same as those of L<NACL::C::Component|lib-NACL-C-Component-pm/ATTRIBUTES>.
(command interfaces are constrained to be sub-classes of
C<NACL::C::SysManager::SMClient>.)

=cut

package NACL::C::Component::SysManager;

use strict;
use warnings;
use base 'NACL::C::Component';

use Class::MethodMaker [
    scalar => [
        {   -type => 'NACL::C::SysManager::SMClient' },
        'command_interface'
    ],
];

1;
