
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DashboardHealthVserver Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DashboardHealthVserver

=head1 DESCRIPTION

C<NACL::C::DashboardHealthVserver> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DashboardHealthVserver.  A related class is
L<NACL::CS::DashboardHealthVserver|lib-NACL-CS-DashboardHealthVserver-pm>, which represents
the past state of an ONTAP DashboardHealthVserver.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=cut

package NACL::C::DashboardHealthVserver;

use strict;
use warnings;

use NACL::CS::DashboardHealthVserver;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DashboardHealthVserver = NACL::C::DashboardHealthVserver->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
								  );

Return a new DashboardHealthVserver component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'vserver',];

=head2 find

    my $DashboardHealthVserver_obj  = NACL::C::DashboardHealthVserver->find(command_interface => $ci, ...);
	my @DashboardHealthVserver_objs = NACL::C::DashboardHealthVserver->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DashboardHealthVserver_state = $DashboardHealthVserver_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DashboardHealthVserver would return 
a NACL::CS::DashboardHealthVserver object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_volume

    my $show_volume_obj = NACL::C::DashboardHealthVserver->show_volume(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_volume_objs = NACL::C::DashboardHealthVserver->show_volume(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_volume_obj = $DashboardHealthVserver_obj->show_volume(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DashboardHealthVserverShowVolume-pm/ATTRIBUTES>
of NACL::CS::DashboardHealthVserverShowVolume as input. 
This method returns objects of the type L<NACL::CS::DashboardHealthVserverShowVolume|lib-NACL-CS-DashboardHealthVserverShowVolume-pm>.

=cut

sub show_volume {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DashboardHealthVserverShowVolume;
    my @state_objs = NACL::CS::DashboardHealthVserverShowVolume->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_combined

    my $show_combined_obj = NACL::C::DashboardHealthVserver->show_combined(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_combined_objs = NACL::C::DashboardHealthVserver->show_combined(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_combined_obj = $DashboardHealthVserver_obj->show_combined(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DashboardHealthVserverShowCombined-pm/ATTRIBUTES>
of NACL::CS::DashboardHealthVserverShowCombined as input. 
This method returns objects of the type L<NACL::CS::DashboardHealthVserverShowCombined|lib-NACL-CS-DashboardHealthVserverShowCombined-pm>.

=cut

sub show_combined {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DashboardHealthVserverShowCombined;
    my @state_objs
        = NACL::CS::DashboardHealthVserverShowCombined->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_port

    my $show_port_obj = NACL::C::DashboardHealthVserver->show_port(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_port_objs = NACL::C::DashboardHealthVserver->show_port(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_port_obj = $DashboardHealthVserver_obj->show_port(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DashboardHealthVserverShowPort-pm/ATTRIBUTES>
of NACL::CS::DashboardHealthVserverShowPort as input. 
This method returns objects of the type L<NACL::CS::DashboardHealthVserverShowPort|lib-NACL-CS-DashboardHealthVserverShowPort-pm>.

=cut

sub show_port {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DashboardHealthVserverShowPort;
    my @state_objs = NACL::CS::DashboardHealthVserverShowPort->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_protocol

    my $show_protocol_obj = NACL::C::DashboardHealthVserver->show_protocol(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_protocol_objs = NACL::C::DashboardHealthVserver->show_protocol(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_protocol_obj = $DashboardHealthVserver_obj->show_protocol(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DashboardHealthVserverShowProtocol-pm/ATTRIBUTES>
of NACL::CS::DashboardHealthVserverShowProtocol as input. 
This method returns objects of the type L<NACL::CS::DashboardHealthVserverShowProtocol|lib-NACL-CS-DashboardHealthVserverShowProtocol-pm>.

=cut

sub show_protocol {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DashboardHealthVserverShowProtocol;
    my @state_objs
        = NACL::CS::DashboardHealthVserverShowProtocol->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_aggregate

    my $show_aggregate_obj = NACL::C::DashboardHealthVserver->show_aggregate(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_aggregate_objs = NACL::C::DashboardHealthVserver->show_aggregate(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_aggregate_obj = $DashboardHealthVserver_obj->show_aggregate(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DashboardHealthVserverShowAggregate-pm/ATTRIBUTES>
of NACL::CS::DashboardHealthVserverShowAggregate as input. 
This method returns objects of the type L<NACL::CS::DashboardHealthVserverShowAggregate|lib-NACL-CS-DashboardHealthVserverShowAggregate-pm>.

=cut

sub show_aggregate {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DashboardHealthVserverShowAggregate;
    my @state_objs
        = NACL::CS::DashboardHealthVserverShowAggregate->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_lif

    my $show_lif_obj = NACL::C::DashboardHealthVserver->show_lif(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_lif_objs = NACL::C::DashboardHealthVserver->show_lif(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_lif_obj = $DashboardHealthVserver_obj->show_lif(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DashboardHealthVserverShowLif-pm/ATTRIBUTES>
of NACL::CS::DashboardHealthVserverShowLif as input. 
This method returns objects of the type L<NACL::CS::DashboardHealthVserverShowLif|lib-NACL-CS-DashboardHealthVserverShowLif-pm>.

=cut

sub show_lif {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DashboardHealthVserverShowLif;
    my @state_objs = NACL::CS::DashboardHealthVserverShowLif->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('vserver' => {type => SCALAR},);
}

1;
