# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCpsServer Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCpsServer

=head1 DESCRIPTION

C<NACL::C::DebugCpsServer> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::DebugCpsServer->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugCpsServer;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCpsServer = NACL::C::DebugCpsServer->new(
                                   command_interface => $ci,
								  );

Return a new DebugCpsServer component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 show_error_details

    my $show_error_details_obj = NACL::C::DebugCpsServer->show_error_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_error_details_objs = NACL::C::DebugCpsServer->show_error_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_error_details_obj = $DebugCpsServer_obj->show_error_details(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCpsServerShowErrorDetails-pm/ATTRIBUTES>
of NACL::CS::DebugCpsServerShowErrorDetails as input. 
This method returns objects of the type L<NACL::CS::DebugCpsServerShowErrorDetails|lib-NACL-CS-DebugCpsServerShowErrorDetails-pm>.

=cut

sub show_error_details {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCpsServerShowErrorDetails;
    my @state_objs = NACL::CS::DebugCpsServerShowErrorDetails->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_history

    my $show_history_obj = NACL::C::DebugCpsServer->show_history(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_history_objs = NACL::C::DebugCpsServer->show_history(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_history_obj = $DebugCpsServer_obj->show_history(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCpsServerShowHistory-pm/ATTRIBUTES>
of NACL::CS::DebugCpsServerShowHistory as input. 
This method returns objects of the type L<NACL::CS::DebugCpsServerShowHistory|lib-NACL-CS-DebugCpsServerShowHistory-pm>.

=cut

sub show_history {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCpsServerShowHistory;
    my @state_objs = NACL::CS::DebugCpsServerShowHistory->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_summary

    my $show_summary_obj = NACL::C::DebugCpsServer->show_summary(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_summary_objs = NACL::C::DebugCpsServer->show_summary(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_summary_obj = $DebugCpsServer_obj->show_summary(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCpsServerShowSummary-pm/ATTRIBUTES>
of NACL::CS::DebugCpsServerShowSummary as input. 
This method returns objects of the type L<NACL::CS::DebugCpsServerShowSummary|lib-NACL-CS-DebugCpsServerShowSummary-pm>.

=cut

sub show_summary {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCpsServerShowSummary;
    my @state_objs = NACL::CS::DebugCpsServerShowSummary->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

1;
