# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsConfiguration Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsConfiguration

=head1 DESCRIPTION

C<NACL::C::DebugCrsConfiguration> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCrsConfiguration.  A related class is
L<NACL::CS::DebugCrsConfiguration|lib-NACL-CS-DebugCrsConfiguration-pm>, which represents
the past state of an ONTAP DebugCrsConfiguration.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugCrsConfiguration;

use strict;
use warnings;

use NACL::CS::DebugCrsConfiguration;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsConfiguration = NACL::C::DebugCrsConfiguration->new(
                                   command_interface => $ci,
								  );

Return a new DebugCrsConfiguration component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 find

    my $DebugCrsConfiguration_obj  = NACL::C::DebugCrsConfiguration->find(command_interface => $ci, ...);
	my @DebugCrsConfiguration_objs = NACL::C::DebugCrsConfiguration->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugCrsConfiguration_state = $DebugCrsConfiguration_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCrsConfiguration would return 
a NACL::CS::DebugCrsConfiguration object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 modify

    NACL::C::DebugCrsConfiguration->modify(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to modify CRS process configuration.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'dangling-context-age-limit' => $string >>

Dangling Context Age Limit ranges from 5 to 600
Applicable for CMode CLI

=item C<< 'threads-per-peer-cluster-maximum' => $string >>

Threads per Peer Cluster Maximum ranges from 0 to 5000
Applicable for CMode CLI

=item C<< 'simulated-communication-version' => $string >>

Simulated Communication Version ranges from 0 to 1000
Applicable for CMode CLI

=item C<< 'hold-thread-until-queue-empty' => $string >>

Hold Thread Until Queue Empty possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'dangling-context-recheck-interval' => $string >>

Dangling Context Recheck Interval ranges from 1 to 600
Applicable for CMode CLI

=item C<< 'transfer-size-maximum' => $string >>

Transfer Size Maximum
Applicable for CMode CLI

=item C<< 'cluster-queue-file-size' => $string >>

Cluster Queue File Size
Applicable for CMode CLI

=item C<< 'data-retention-recheck-interval' => $string >>

Data Retention Recheck Interval ranges from 1 to 3600
Applicable for CMode CLI

=item C<< 'open-context-lock-attempt-timeout' => $string >>

Open Context Lock Attempt Timeout ranges from 1 to 60
Applicable for CMode CLI

=item C<< 'active-queue-files-per-stream' => $string >>

Active Queue Files Per Stream ranges from 5 to 50
Applicable for CMode CLI

=item C<< 'stream-resolve-recheck-interval' => $string >>

Stream Resolve Recheck Interval ranges from 1 to 3600
Applicable for CMode CLI

=item C<< 'baseline-file-retention-period' => $string >>

Baseline File Retention Period ranges from 0 to 864000
Applicable for CMode CLI

=item C<< 'baseline-file-retention-count' => $string >>

Baseline File Retention Count ranges from 0 to 50
Applicable for CMode CLI

=item C<< 'peer-cluster-heartbeat-interval' => $string >>

Peer Cluster Heartbeat Interval ranges from 5 to 3600
Applicable for CMode CLI

=item C<< 'queue-threshold-warning-percentage' => $string >>

Queue Threshold Warning Percentage
Applicable for CMode CLI

=item C<< 'transfer-threads-maximum' => $string >>

Transfer Threads Maximum ranges from 0 to 5000
Applicable for CMode CLI

=item C<< 'dm-notification-interval' => $string >>

DM Notification Interval ranges from 5 to 3600
Applicable for CMode CLI

=item C<< 'peer-cluster-notification-interval' => $string >>

Peer Cluster Notification Interval ranges from 5 to 3600
Applicable for CMode CLI

=item C<< 'keep-sender-streams-paused' => $string >>

Keep Sender Streams Paused possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'queue-file-retention-period' => $string >>

Queue File Retention Period ranges from 0 to 864000
Applicable for CMode CLI

=item C<< 'queue-file-time-limit' => $string >>

Queue File Time Limit ranges from 0 to 864000
Applicable for CMode CLI

=item C<< 'io-latency-warning-threshold' => $string >>

I/O Latency Warning Threshold ranges from 5 to 600
Applicable for CMode CLI

=item C<< 'cps-error-count-threshold' => $string >>

CPS Error Count Threshold ranges from 1 to 10
Applicable for CMode CLI

=item C<< 'baseline-traversal-cache-size' => $string >>

Size of Baseline Traversal Cache
Applicable for CMode CLI

=item C<< 'builder-threads-per-baseline' => $string >>

Builder Threads per Baseline ranges from 0 to 100
Applicable for CMode CLI

=item C<< 'baseline-transfer-chunk-size' => $string >>

Size of Baseline Transfer Chunk
Applicable for CMode CLI

=item C<< 'baseline-builder-threads-maximum' => $string >>

Total Threads to Build Baselines ranges from 0 to 100
Applicable for CMode CLI

=item C<< 'io-latency-panic-threshold' => $string >>

I/O Latency Panic Threshold ranges from 120 to 600
Applicable for CMode CLI

=item C<< 'failed-cluster-notify-threshold' => $string >>

Failed Cluster Notify Threshold ranges from 60 to 21600
Applicable for CMode CLI

=item C<< 'io-latency-capture-threshold' => $string >>

I/O Latency Capture Threshold ranges from 60 to 600
Applicable for CMode CLI

=item C<< 'baseline-fetch-assert-timeout-enable' => $string >>

Baseline Fetch Assert Timeout Enable possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'baseline-fetch-max-assert-timeout' => $string >>

Baseline Fetch Maximum Timeout for Assert ranges from 20 to 60
Applicable for CMode CLI

=item C<< 'queue-entries-for-cluster-maximum' => $string >>

Queue Entries for Cluster Maximum ranges from 1 to 1000000
Applicable for CMode CLI

=item C<< 'queue-entries-per-stream-maximum' => $string >>

Queue Entries per Stream Maximum ranges from 1 to 1000000
Applicable for CMode CLI

=item C<< 'op-queue-notify-threshold' => $string >>

Operation Queue Notify Threshold ranges from 1 to 120
Applicable for CMode CLI

=item C<< 'op-queue-recovery-delay-limit' => $string >>

Operation Queue Recovery Limit ranges from 0 to 10
Applicable for CMode CLI

=item C<< 'baseline-fetch-extra-time' => $string >>

Baseline Fetch Extra Time ranges from 0 to 60
Applicable for CMode CLI

=item C<< 'drain-notification-threshold' => $string >>

Drain Notification Threshold ranges from 1 to 10000
Applicable for CMode CLI

=item C<< 'streams-maximum' => $string >>

Streams Maximum ranges from 1 to 2000
Applicable for CMode CLI

=item C<< 'op-queue-latency-threshold' => $string >>

Operation Queue Latency Threshold ranges from 1 to 60
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs configuration modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( dangling-context-age-limit threads-per-peer-cluster-maximum
                    simulated-communication-version hold-thread-until-queue-empty
                    dangling-context-recheck-interval transfer-size-maximum
                    cluster-queue-file-size data-retention-recheck-interval
                    open-context-lock-attempt-timeout active-queue-files-per-stream
                    stream-resolve-recheck-interval baseline-file-retention-period
                    baseline-file-retention-count peer-cluster-heartbeat-interval
                    queue-threshold-warning-percentage transfer-threads-maximum
                    dm-notification-interval peer-cluster-notification-interval
                    keep-sender-streams-paused queue-file-retention-period
                    queue-file-time-limit

                    io-latency-warning-threshold

                    cps-error-count-threshold

                    baseline-traversal-cache-size builder-threads-per-baseline
                    baseline-transfer-chunk-size baseline-builder-threads-maximum

                    io-latency-panic-threshold

                    failed-cluster-notify-threshold

                    io-latency-capture-threshold

                    baseline-fetch-assert-timeout-enable baseline-fetch-max-assert-timeout
                    queue-entries-for-cluster-maximum queue-entries-per-stream-maximum
                    op-queue-notify-threshold op-queue-recovery-delay-limit
                    baseline-fetch-extra-time drain-notification-threshold streams-maximum
                    op-queue-latency-threshold
                    )
            ),
        },
        api => 'debug_crs_configuration_modify',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsConfiguration::modify',
    );

}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_configuration_modify',);
    $Log->exit() if $may_exit;
}

=head2 reset

    NACL::C::DebugCrsConfiguration->reset(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to reset CRS process configuration to defaults.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< '*' >>

This method takes all other options supported by "debug crs configuration reset" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub reset {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        api    => 'debug_crs_configuration_reset',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_reset_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsConfiguration::reset',
    );

}

sub _reset_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_configuration_reset',);
    $Log->exit() if $may_exit;
}

__PACKAGE__->_load_event_class();

1;
