# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsStatisticsLatencyUpdateSender Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsStatisticsLatencyUpdateSender

=head1 DESCRIPTION

C<NACL::C::DebugCrsStatisticsLatencyUpdateSender> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCrsStatisticsLatencyUpdateSender.  A related class is
L<NACL::CS::DebugCrsStatisticsLatencyUpdateSender|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSender-pm>, which represents
the past state of an ONTAP DebugCrsStatisticsLatencyUpdateSender.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 period_begin

=head2 node

=cut

package NACL::C::DebugCrsStatisticsLatencyUpdateSender;

use strict;
use warnings;

use NACL::CS::DebugCrsStatisticsLatencyUpdateSender;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsStatisticsLatencyUpdateSender = NACL::C::DebugCrsStatisticsLatencyUpdateSender->new(
                                   command_interface => $ci,
                                   'period-begin' => $period_begin,
                                   'node' => $node,
								  );

Return a new DebugCrsStatisticsLatencyUpdateSender component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'period_begin',
    scalar => 'node',
];

=head2 find

    my $DebugCrsStatisticsLatencyUpdateSender_obj  = NACL::C::DebugCrsStatisticsLatencyUpdateSender->find(command_interface => $ci, ...);
	my @DebugCrsStatisticsLatencyUpdateSender_objs = NACL::C::DebugCrsStatisticsLatencyUpdateSender->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugCrsStatisticsLatencyUpdateSender_state = $DebugCrsStatisticsLatencyUpdateSender_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCrsStatisticsLatencyUpdateSender would return 
a NACL::CS::DebugCrsStatisticsLatencyUpdateSender object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_by_object

    my $show_by_object_obj = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_by_object(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_by_object_objs = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_by_object(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_by_object_obj = $DebugCrsStatisticsLatencyUpdateSender_obj->show_by_object(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowByObject-pm/ATTRIBUTES>
of NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByObject as input. 
This method returns objects of the type L<NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByObject|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowByObject-pm>.

=cut

sub show_by_object {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByObject;
    my @state_objs
        = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByObject->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_by_stream

    my $show_by_stream_obj = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_by_stream(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_by_stream_objs = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_by_stream(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_by_stream_obj = $DebugCrsStatisticsLatencyUpdateSender_obj->show_by_stream(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowByStream-pm/ATTRIBUTES>
of NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByStream as input. 
This method returns objects of the type L<NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByStream|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowByStream-pm>.

=cut

sub show_by_stream {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByStream;
    my @state_objs
        = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowByStream->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_details

    my $show_details_obj = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_details_objs = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_details_obj = $DebugCrsStatisticsLatencyUpdateSender_obj->show_details(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowDetails-pm/ATTRIBUTES>
of NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowDetails as input. 
This method returns objects of the type L<NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowDetails|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowDetails-pm>.

=cut

sub show_details {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowDetails;
    my @state_objs
        = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowDetails->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_object_details

    my $show_object_details_obj = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_object_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_object_details_objs = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_object_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_object_details_obj = $DebugCrsStatisticsLatencyUpdateSender_obj->show_object_details(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails-pm/ATTRIBUTES>
of NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails as input. 
This method returns objects of the type L<NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails-pm>.

=cut

sub show_object_details {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails;
    my @state_objs
        = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails
        ->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_stream_details

    my $show_stream_details_obj = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_stream_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_stream_details_objs = NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_stream_details(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_stream_details_obj = $DebugCrsStatisticsLatencyUpdateSender_obj->show_stream_details(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowStreamDetails-pm/ATTRIBUTES>
of NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowStreamDetails as input. 
This method returns objects of the type L<NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowStreamDetails|lib-NACL-CS-DebugCrsStatisticsLatencyUpdateSenderShowStreamDetails-pm>.

=cut

sub show_stream_details {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowStreamDetails;
    my @state_objs
        = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowStreamDetails
        ->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'period-begin' => {type => SCALAR},
        'node'         => {type => SCALAR},
    );
}

1;
