# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsStorageArea Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsStorageArea

=head1 DESCRIPTION

C<NACL::C::DebugCrsStorageArea> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCrsStorageArea.  A related class is
L<NACL::CS::DebugCrsStorageArea|lib-NACL-CS-DebugCrsStorageArea-pm>, which represents
the past state of an ONTAP DebugCrsStorageArea.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 area

=cut

package NACL::C::DebugCrsStorageArea;

use strict;
use warnings;

use NACL::CS::DebugCrsStorageArea;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsStorageArea = NACL::C::DebugCrsStorageArea->new(
                                   command_interface => $ci,
                                   'area' => $area,
								  );

Return a new DebugCrsStorageArea component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'area',];

=head2 find

    my $DebugCrsStorageArea_obj  = NACL::C::DebugCrsStorageArea->find(command_interface => $ci, ...);
	my @DebugCrsStorageArea_objs = NACL::C::DebugCrsStorageArea->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugCrsStorageArea_state = $DebugCrsStorageArea_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCrsStorageArea would return 
a NACL::CS::DebugCrsStorageArea object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 get_current_data

    NACL::C::DebugCrsStorageArea->get_current_data(
                                command_interface => $ci,
	                            'area' => $area,
                                ...);
	                             
								 or

    $DebugCrsStorageArea_obj->get_current_data(...);

(Class or instance method)
This method is used to get the current CRS storage area data.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'area' => $area >>

(Required for class method, Not Applicable for instance method)

Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs storage area get current data" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub get_current_data {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug crs storage-area get-current-data',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_get_current_data_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsStorageArea::get_current_data',
    );

    $Log->exit() if $may_exit;
}

sub _get_current_data_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_storage_area_get_current_data',);
    $Log->exit() if $may_exit;
}

=head2 modify_storage_area

    NACL::C::DebugCrsStorageArea->modify_storage_area(
                                command_interface => $ci,
	                            'area' => $area,
                                ...);
	                             
								 or

    $DebugCrsStorageArea_obj->modify_storage_area(...);

(Class or instance method)
This method is used to notify CRS of a change in a Storage Area.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'area' => $area >>

(Required for class method, Not Applicable for instance method)

Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues
Applicable for CMode CLI

=item C<< 'epoch' => $string >>

Area Epoch
Applicable for CMode CLI

=item C<< 'path' => $string >>

Storage Area Path
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs storage area modify storage area" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify_storage_area {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( epoch path
                    )
            ),
        },
        cli_cmd => 'debug crs storage-area modify-storage-area',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_storage_area_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsStorageArea::modify_storage_area',
    );

    $Log->exit() if $may_exit;
}

sub _modify_storage_area_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_storage_area_modify_storage_area',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('area' => {type => SCALAR},);
}

1;
