# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsStreamOperational Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsStreamOperational

=head1 DESCRIPTION

C<NACL::C::DebugCrsStreamOperational> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCrsStreamOperational.  A related class is
L<NACL::CS::DebugCrsStreamOperational|lib-NACL-CS-DebugCrsStreamOperational-pm>, which represents
the past state of an ONTAP DebugCrsStreamOperational.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 stream_uuid

=cut

package NACL::C::DebugCrsStreamOperational;

use strict;
use warnings;

use NACL::CS::DebugCrsStreamOperational;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsStreamOperational = NACL::C::DebugCrsStreamOperational->new(
                                   command_interface => $ci,
                                   'stream-uuid' => $stream_uuid,
								  );

Return a new DebugCrsStreamOperational component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'stream_uuid',];

=head2 find

    my $DebugCrsStreamOperational_obj  = NACL::C::DebugCrsStreamOperational->find(command_interface => $ci, ...);
	my @DebugCrsStreamOperational_objs = NACL::C::DebugCrsStreamOperational->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugCrsStreamOperational_state = $DebugCrsStreamOperational_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCrsStreamOperational would return 
a NACL::CS::DebugCrsStreamOperational object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_summary_stats

    my $show_summary_stats_obj = NACL::C::DebugCrsStreamOperational->show_summary_stats(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_summary_stats_objs = NACL::C::DebugCrsStreamOperational->show_summary_stats(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_summary_stats_obj = $DebugCrsStreamOperational_obj->show_summary_stats(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCrsStreamOperationalShowSummaryStats-pm/ATTRIBUTES>
of NACL::CS::DebugCrsStreamOperationalShowSummaryStats as input. 
This method returns objects of the type L<NACL::CS::DebugCrsStreamOperationalShowSummaryStats|lib-NACL-CS-DebugCrsStreamOperationalShowSummaryStats-pm>.

=cut

sub show_summary_stats {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCrsStreamOperationalShowSummaryStats;
    my @state_objs
        = NACL::CS::DebugCrsStreamOperationalShowSummaryStats->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('stream-uuid' => {type => SCALAR},);
}

1;
