# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsTestDmDummySnapshotPolicy Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCrsTestDmDummySnapshotPolicy

=head1 DESCRIPTION

C<NACL::C::DebugCrsTestDmDummySnapshotPolicy> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCrsTestDmDummySnapshotPolicy.  A related class is
L<NACL::CS::DebugCrsTestDmDummySnapshotPolicy|lib-NACL-CS-DebugCrsTestDmDummySnapshotPolicy-pm>, which represents
the past state of an ONTAP DebugCrsTestDmDummySnapshotPolicy.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 name

=head2 vserver

=cut

package NACL::C::DebugCrsTestDmDummySnapshotPolicy;

use strict;
use warnings;

use NACL::CS::DebugCrsTestDmDummySnapshotPolicy;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCrsTestDmDummySnapshotPolicy = NACL::C::DebugCrsTestDmDummySnapshotPolicy->new(
                                   command_interface => $ci,
                                   'name' => $name,
                                   'vserver' => $vserver,
								  );

Return a new DebugCrsTestDmDummySnapshotPolicy component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'name',
    scalar => 'vserver',
];

=head2 find

    my $DebugCrsTestDmDummySnapshotPolicy_obj  = NACL::C::DebugCrsTestDmDummySnapshotPolicy->find(command_interface => $ci, ...);
	my @DebugCrsTestDmDummySnapshotPolicy_objs = NACL::C::DebugCrsTestDmDummySnapshotPolicy->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugCrsTestDmDummySnapshotPolicy_state = $DebugCrsTestDmDummySnapshotPolicy_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCrsTestDmDummySnapshotPolicy would return 
a NACL::CS::DebugCrsTestDmDummySnapshotPolicy object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 add_schedule

    NACL::C::DebugCrsTestDmDummySnapshotPolicy->add_schedule(
                                command_interface => $ci,
	                            'name' => $name,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $DebugCrsTestDmDummySnapshotPolicy_obj->add_schedule(...);

(Class or instance method)
This method is used to dummy Policy Method to add a schedule to the list.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Dummy Policy Name
Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'count' => $string >>

Max Copies To keep ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'schedule' => $string >>

Schedule Name
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs test dm dummy snapshot policy add schedule" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub add_schedule {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( count schedule
                    )
            ),
        },
        cli_cmd => 'debug crs test-dm dummy-snapshot-policy add-schedule',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_add_schedule_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsTestDmDummySnapshotPolicy::add_schedule',
    );

}

sub _add_schedule_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_test_dm_dummy_snapshot_policy_add_schedule',);
    $Log->exit() if $may_exit;
}

=head2 create

    my $DebugCrsTestDmDummySnapshotPolicy_obj	= NACL::C::DebugCrsTestDmDummySnapshotPolicy->create(
                                command_interface => $ci,
	                            'name' => $name,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to add a dummy snapshot policy entry.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'name' => $name >>

(Required)
Dummy Policy Name
Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required)
Vserver
Applicable for CMode CLI

=item C<< 'comment' => $string >>

Dummy Policy Comment
Applicable for CMode CLI

=item C<< 'enabled' => $string >>

Dummy Policy Enabled possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs test dm dummy snapshot policy create" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( comment enabled
                    )
            ),
        },
        cli_cmd => 'debug crs test-dm dummy-snapshot-policy create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsTestDmDummySnapshotPolicy::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        name              => $opts{'name'},
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_test_dm_dummy_snapshot_policy_create',);
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::DebugCrsTestDmDummySnapshotPolicy->delete(
                                command_interface => $ci,
	                            'name' => $name,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $DebugCrsTestDmDummySnapshotPolicy_obj->delete(...);

(Class or instance method)
This method is used to delete a dummy snapshot policy entry.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Dummy Policy Name
Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs test dm dummy snapshot policy delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug crs test-dm dummy-snapshot-policy delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsTestDmDummySnapshotPolicy::delete',
    );

}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_test_dm_dummy_snapshot_policy_delete',);
    $Log->exit() if $may_exit;
}

=head2 modify_schedule

    NACL::C::DebugCrsTestDmDummySnapshotPolicy->modify_schedule(
                                command_interface => $ci,
	                            'name' => $name,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $DebugCrsTestDmDummySnapshotPolicy_obj->modify_schedule(...);

(Class or instance method)
This method is used to dummy Policy Method to modify a schedule in the list.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Dummy Policy Name
Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'count' => $string >>

Max Copies To keep ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'schedule' => $string >>

Schedule Name
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs test dm dummy snapshot policy modify schedule" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify_schedule {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( count schedule
                    )
            ),
        },
        cli_cmd => 'debug crs test-dm dummy-snapshot-policy modify-schedule',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_schedule_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsTestDmDummySnapshotPolicy::modify_schedule',
    );

}

sub _modify_schedule_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_test_dm_dummy_snapshot_policy_modify_schedule',);
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::DebugCrsTestDmDummySnapshotPolicy->modify(
                                command_interface => $ci,
	                            'name' => $name,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $DebugCrsTestDmDummySnapshotPolicy_obj->modify(...);

(Class or instance method)
This method is used to modify a dummy snapshot policy entry.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Dummy Policy Name
Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'comment' => $string >>

Dummy Policy Comment
Applicable for CMode CLI

=item C<< 'enabled' => $string >>

Dummy Policy Enabled possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs test dm dummy snapshot policy modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( comment enabled
                    )
            ),
        },
        cli_cmd => 'debug crs test-dm dummy-snapshot-policy modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCrsTestDmDummySnapshotPolicy::modify',
    );

}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_test_dm_dummy_snapshot_policy_modify',);
    $Log->exit() if $may_exit;
}

=head2 remove_schedule

    NACL::C::DebugCrsTestDmDummySnapshotPolicy->remove_schedule(
                                command_interface => $ci,
	                            'name' => $name,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $DebugCrsTestDmDummySnapshotPolicy_obj->remove_schedule(...);

(Class or instance method)
This method is used to dummy Policy Method to remove a schedule from the list.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'name' => $name >>

(Required for class method, Not Applicable for instance method)
Dummy Policy Name
Applicable for CMode CLI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI

=item C<< 'schedule' => $string >>

Schedule Name
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug crs test dm dummy snapshot policy remove schedule" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub remove_schedule {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( schedule
                    )
            ),
        },
        cli_cmd => 'debug crs test-dm dummy-snapshot-policy remove-schedule',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_remove_schedule_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugCrsTestDmDummySnapshotPolicy::remove_schedule',
    );

}

sub _remove_schedule_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_crs_test_dm_dummy_snapshot_policy_remove_schedule',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'name'    => {type => SCALAR},
        'vserver' => {type => SCALAR},
    );
}

1;
