#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCsmCache Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCsmCache

=head1 DESCRIPTION

C<NACL::C::DebugCsmCache> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::DebugCsmCache->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugCsmCache;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugCsmCache = NACL::C::DebugCsmCache->new(
                                   command_interface => $ci,
								  );

Return a new DebugCsmCache component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 blade_ip_map

    my $blade_ip_map_obj = NACL::C::DebugCsmCache->blade_ip_map(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @blade_ip_map_objs = NACL::C::DebugCsmCache->blade_ip_map(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $blade_ip_map_obj = $DebugCsmCache_obj->blade_ip_map(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCsmCacheBladeIpMap-pm/ATTRIBUTES>
of NACL::CS::DebugCsmCacheBladeIpMap as input. 
This method returns objects of the type L<NACL::CS::DebugCsmCacheBladeIpMap|lib-NACL-CS-DebugCsmCacheBladeIpMap-pm>.

=cut

sub blade_ip_map {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCsmCacheBladeIpMap;
    my @state_objs = NACL::CS::DebugCsmCacheBladeIpMap->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 ds_blade_map

    my $ds_blade_map_obj = NACL::C::DebugCsmCache->ds_blade_map(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @ds_blade_map_objs = NACL::C::DebugCsmCache->ds_blade_map(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $ds_blade_map_obj = $DebugCsmCache_obj->ds_blade_map(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCsmCacheDsBladeMap-pm/ATTRIBUTES>
of NACL::CS::DebugCsmCacheDsBladeMap as input. 
This method returns objects of the type L<NACL::CS::DebugCsmCacheDsBladeMap|lib-NACL-CS-DebugCsmCacheDsBladeMap-pm>.

=cut

sub ds_blade_map {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCsmCacheDsBladeMap;
    my @state_objs = NACL::CS::DebugCsmCacheDsBladeMap->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 lif_blade_map

    my $lif_blade_map_obj = NACL::C::DebugCsmCache->lif_blade_map(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @lif_blade_map_objs = NACL::C::DebugCsmCache->lif_blade_map(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $lif_blade_map_obj = $DebugCsmCache_obj->lif_blade_map(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCsmCacheLifBladeMap-pm/ATTRIBUTES>
of NACL::CS::DebugCsmCacheLifBladeMap as input. 
This method returns objects of the type L<NACL::CS::DebugCsmCacheLifBladeMap|lib-NACL-CS-DebugCsmCacheLifBladeMap-pm>.

=cut

sub lif_blade_map {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCsmCacheLifBladeMap;
    my @state_objs = NACL::CS::DebugCsmCacheLifBladeMap->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 session_table

    my $session_table_obj = NACL::C::DebugCsmCache->session_table(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @session_table_objs = NACL::C::DebugCsmCache->session_table(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $session_table_obj = $DebugCsmCache_obj->session_table(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCsmCacheSessionTable-pm/ATTRIBUTES>
of NACL::CS::DebugCsmCacheSessionTable as input. 
This method returns objects of the type L<NACL::CS::DebugCsmCacheSessionTable|lib-NACL-CS-DebugCsmCacheSessionTable-pm>.

=cut

sub session_table {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCsmCacheSessionTable;
    my @state_objs = NACL::CS::DebugCsmCacheSessionTable->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 blade_ip_map_invalidate

    NACL::C::DebugCsmCache->blade_ip_map_invalidate(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to remove blade to IP cache for a given cluster..
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'cluster-id' => $string >>

Cluster ID
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node Name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug csm cache blade ip map invalidate" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub blade_ip_map_invalidate {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( cluster-id node
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'debug_csm_cache_blade_ip_map_invalidate',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_blade_ip_map_invalidate_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCsmCache::blade_ip_map_invalidate',
    );

    $Log->exit() if $may_exit;
}

sub _blade_ip_map_invalidate_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_csm_cache_blade_ip_map_invalidate',);
    $Log->exit() if $may_exit;
}

=head2 blade_ip_map_v4

    my $blade_ip_map_v4_obj = NACL::C::DebugCsmCache->blade_ip_map_v4(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @blade_ip_map_v4_objs = NACL::C::DebugCsmCache->blade_ip_map_v4(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $blade_ip_map_v4_obj = $DebugCsmCache_obj->blade_ip_map_v4(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugCsmCacheBladeIpMapV4-pm/ATTRIBUTES>
of NACL::CS::DebugCsmCacheBladeIpMapV4 as input. 
This method returns objects of the type L<NACL::CS::DebugCsmCacheBladeIpMapV4|lib-NACL-CS-DebugCsmCacheBladeIpMapV4-pm>.

=cut

sub blade_ip_map_v4 {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugCsmCacheBladeIpMapV4;
    my @state_objs = NACL::CS::DebugCsmCacheBladeIpMapV4->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

1;
