# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCsmSession Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugCsmSession

=head1 DESCRIPTION

C<NACL::C::DebugCsmSession> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugCsmSession.  A related class is
L<NACL::CS::DebugCsmSession|lib-NACL-CS-DebugCsmSession-pm>, which represents
the past state of an ONTAP DebugCsmSession.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 pointer

=head2 node

=cut

package NACL::C::DebugCsmSession;

use strict;
use warnings;

use NACL::CS::DebugCsmSession;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $DebugCsmSession = NACL::C::DebugCsmSession->new(
                                   command_interface => $ci,
                                   'pointer' => $pointer,
                                   'node' => $node,
								  );

Return a new DebugCsmSession component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'pointer',
    scalar => 'node',
];

=head2 find

    my $DebugCsmSession  = NACL::C::DebugCsmSession->find(command_interface => $ci, ...);
	my @DebugCsmSessions = NACL::C::DebugCsmSession->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my DebugCsmSession_state = $NACL::C::DebugCsmSession->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugCsmSession would return 
a NACL::CS::DebugCsmSession object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 clobber

    NACL::C::DebugCsmSession->clobber(
                                command_interface => $ci,
	                            'node' => $node,
                                ...);

(Class method)
This method is used to clobber the session established.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)

Applicable for CMode CLI.

=item C<< 'uniquifier' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"debug csm session clobber" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub clobber {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( uniquifier node
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'debug_csm_session_clobber',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_clobber_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCsmSession::clobber',
    );

    $Log->exit() if $may_exit;
} ## end sub clobber

sub _clobber_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts, api => 'debug_csm_session_clobber',);
    $Log->exit() if $may_exit;
} ## end sub _clobber_cmode_cli

=head2 send

    NACL::C::DebugCsmSession->send(
                                command_interface => $ci,
	                            'node' => $node,
                                ...);

(Class method)
This method is used to send on an existing CSM session.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)

Applicable for CMode CLI.

=item C<< 'priority' => $string >>

Applicable for CMode CLI.

=item C<< 'request-size' => $string >>

Applicable for CMode CLI.

=item C<< 'count' => $string >>

Applicable for CMode CLI.

=item C<< 'uniquifier' => $string >>

Applicable for CMode CLI.

=item C<< 'qos-deadline' => $string >>

Applicable for CMode CLI.

=item C<< 'response-size' => $string >>

Applicable for CMode CLI.

=item C<< 'timeout-ms' => $string >>

Applicable for CMode CLI.

=item C<< 'request-bytes' => $string >>

Applicable for CMode CLI.

=item C<< 'response-delay-ms' => $string >>

Applicable for CMode CLI.

=item C<< 'request-delay-ms' => $string >>

Applicable for CMode CLI.

=item C<< 'response-bytes' => $string >>

Applicable for CMode CLI.

=item C<< 'track-each-request' => $string >>

Applicable for CMode CLI.

=item C<< 'qos-workload-id' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'disable-sess-retransmit' => $string >>


Disables Session Layer Retransmit for Each Request possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"debug csm session send" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub send {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( priority request-size count uniquifier qos-deadline response-size node
                    timeout-ms request-bytes response-delay-ms request-delay-ms response-bytes
                    track-each-request qos-workload-id

                    disable-sess-retransmit
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'debug_csm_session_send',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_send_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCsmSession::send',
    );

    $Log->exit() if $may_exit;
} ## end sub send

sub _send_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts, api => 'debug_csm_session_send',);
    $Log->exit() if $may_exit;
} ## end sub _send_cmode_cli

=head2 create

    my $DebugCsmSession_obj	= NACL::C::DebugCsmSession->create(
                                command_interface => $ci,
	                            'node' => $node,
                                ...);

(Class method)
This method is used to create a new CSM session.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)

Applicable for CMode CLI.

=item C<< 'num-channels-med' => $string >>

Applicable for CMode CLI.

=item C<< 'window-size-med' => $string >>

Applicable for CMode CLI.

=item C<< 'source-blade' => $string >>

Applicable for CMode CLI.

=item C<< 'bandwidth-limit-bps' => $string >>

Applicable for CMode CLI.

=item C<< 'min-num-connections-high' => $string >>

Applicable for CMode CLI.

=item C<< 'passive-node' => $string >>

Applicable for CMode CLI.

=item C<< 'min-num-connections-low' => $string >>

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $string >>

Applicable for CMode CLI.

=item C<< 'conn-retransmit-timeout-ms' => $string >>

Applicable for CMode CLI.

=item C<< 'window-size-high' => $string >>

Applicable for CMode CLI.

=item C<< 'conn-retransmit-rto-change' => $string >>

Applicable for CMode CLI.

=item C<< 'min-num-connections-med' => $string >>

Applicable for CMode CLI.

=item C<< 'num-channels-low' => $string >>

Applicable for CMode CLI.

=item C<< 'timeout-ms' => $string >>

Applicable for CMode CLI.

=item C<< 'window-size-low' => $string >>

Applicable for CMode CLI.

=item C<< 'dest-blade' => $string >>

Applicable for CMode CLI.

=item C<< 'num-channels-high' => $string >>

Applicable for CMode CLI.

=item C<< 'conn-retransmit-min-count' => $string >>

Applicable for CMode CLI.

=item C<< 'disable-congestion-control' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'dead-connection-timeout-ms-med' => $string >>

Dead Medium Priority Connection Timeout in Milliseconds possible value(s) are, integer

Applicable for CMode CLI.

=item C<< 'dead-connection-timeout-ms-high' => $string >>

Dead High Priority Connection Timeout in Milliseconds possible value(s) are, integer

Applicable for CMode CLI.

=item C<< 'idle-session-timeout-ms' => $string >>

Time Before an Idle Session is Closed in Milliseconds possible value(s) are, integer

Applicable for CMode CLI.

=item C<< 'dead-connection-timeout-ms-low' => $string >>

Dead Low Priority Connection Timeout in Milliseconds possible value(s) are, integer

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< 'connection-retry-timeout-ms' => $string >>

Time before a connectionless session will close in milliseconds
Applicable for CMode CLI

=item C<< 'passive-blade' => $string >>

Remote Blade Id in Destination Cluster
Applicable for CMode CLI

=item C<< 'failed-session-replacement-delay-ms' => $string >>


Wait Time Before Seeking to Replace a Fully Failed Shared Session in Milliseconds
Applicable for CMode CLI

=item C<< 'enable-local-timeout-return-code' => $string >>


Disables Session Layer Congestion Control possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'sess-retransmit-wait-for-response-ms' => $string >>

Amount of Time to Wait for a Response After Connection Failure
Applicable for CMode CLI

=item C<< 'can-sess-retransmit-be-disabled' => $string >>


Allows Session Layer Retransmit to be Disabled Per Request possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"debug csm session create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( num-channels-med node window-size-med source-blade bandwidth-limit-bps
                    min-num-connections-high passive-node min-num-connections-low
                    destination-cluster conn-retransmit-timeout-ms window-size-high
                    conn-retransmit-rto-change min-num-connections-med num-channels-low
                    timeout-ms window-size-low dest-blade num-channels-high
                    conn-retransmit-min-count disable-congestion-control

                    dead-connection-timeout-ms-med dead-connection-timeout-ms-high
                    idle-session-timeout-ms dead-connection-timeout-ms-low

                    connection-retry-timeout-ms

                    passive-blade

                    failed-session-replacement-delay-ms

                    enable-local-timeout-return-code

                    sess-retransmit-wait-for-response-ms can-sess-retransmit-be-disabled
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'debug_csm_session_create',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugCsmSession::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        pointer           => $opts{'pointer'},
        node              => $opts{'node'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts, api => 'debug_csm_session_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

=head2 status

    my $status_obj = NACL::C::DebugCsmSession->status(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @status_objs = NACL::C::DebugCsmSession->status(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $status_obj = $DebugCsmSession_obj->status();
 
(Class or Instance method)
This method returns objects of the type L<NACL::CS::DebugCsmSessionStatus|lib-NACL-CS-DebugCsmSessionStatus-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch> 
(requested_fields, filter, allow_empty) and has all of the other properties of 
fetch methods (callable in scalar or list context, throws a NoElementsFound 
exception if no matching elements are found)

=cut

sub status {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::DebugCsmSessionStatus;
    my @state_objs = NACL::CS::DebugCsmSessionStatus->fetch(@_);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub status


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'pointer' => {type => SCALAR | UNDEF, optional => 1},
        'node'    => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
