# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugDmVserverBaseline Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugDmVserverBaseline

=head1 DESCRIPTION

C<NACL::C::DebugDmVserverBaseline> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. 
Unlike other components this package does not model any element/service 
but is present to provide component-level support for functionality. 
Since it does not model any element/service there is no ComponentState 
module for this component. For the same reason, 'find' and 'state' will
not work for this component.
Instead NACL::CS::DebugDmVserverBaseline->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugDmVserverBaseline;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugDmVserverBaseline = NACL::C::DebugDmVserverBaseline->new(
                                   command_interface => $ci,
								  );

Return a new DebugDmVserverBaseline component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 apply_manual

    NACL::C::DebugDmVserverBaseline->apply_manual(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to apply Manual Baseline.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $string >>

Stream UUID
Applicable for CMode CLI

=item C<< 'is-rebaseline' => $string >>

A Rebaseline or Not possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'global-baseline-message-id' => $string >>

Global Baseline Sequence Number
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver baseline apply manual" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub apply_manual {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( stream-uuid is-rebaseline global-baseline-message-id
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug dm vserver baseline apply-manual',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_apply_manual_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverBaseline::apply_manual',
    );

}

sub _apply_manual_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_baseline_apply_manual',);
    $Log->exit() if $may_exit;
}

=head2 apply_till_baseline_marker

    NACL::C::DebugDmVserverBaseline->apply_till_baseline_marker(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to apply Baseline with Baseline Marker .
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $string >>

Stream UUID
Applicable for CMode CLI

=item C<< 'baseline-marker-message-id' => $string >>

Baseline marker sequence number
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver baseline apply till baseline marker" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub apply_till_baseline_marker {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( stream-uuid baseline-marker-message-id
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug dm vserver baseline apply-till-baseline-marker',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_apply_till_baseline_marker_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugDmVserverBaseline::apply_till_baseline_marker',
    );

}

sub _apply_till_baseline_marker_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_baseline_apply_till_baseline_marker',);
    $Log->exit() if $may_exit;
}

=head2 apply_till_sync_marker

    NACL::C::DebugDmVserverBaseline->apply_till_sync_marker(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to apply Baseline with Sync Marker.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $string >>

Stream UUID
Applicable for CMode CLI

=item C<< 'sync-marker-message-id' => $string >>

Sync Marker Sequence Number
Applicable for CMode CLI

=item C<< 'sync-marker-tag' => $string >>

Sync Marker Identifier
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver baseline apply till sync marker" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub apply_till_sync_marker {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( stream-uuid sync-marker-message-id sync-marker-tag
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'debug dm vserver baseline apply-till-sync-marker',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_apply_till_sync_marker_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverBaseline::apply_till_sync_marker',
    );

}

sub _apply_till_sync_marker_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_baseline_apply_till_sync_marker',);
    $Log->exit() if $may_exit;
}

=head2 generate_local

    NACL::C::DebugDmVserverBaseline->generate_local(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to generate Local Baseline.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $string >>

Stream UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver baseline generate local" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub generate_local {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( stream-uuid
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug dm vserver baseline generate-local',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_generate_local_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverBaseline::generate_local',
    );

}

sub _generate_local_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_baseline_generate_local',);
    $Log->exit() if $may_exit;
}

=head2 generate

    NACL::C::DebugDmVserverBaseline->generate(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to generate Baseline.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'baseline-vservers-for-cserver' => $string >>


Baseline Vservers During Cserver Baseline (default: true) possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'stream-uuid' => $string >>

Stream UUID
Applicable for CMode CLI

=item C<< 'baseline-type' => $string >>

Baseline Type
Applicable for CMode CLI

=item C<< 'marker-tag' => $string >>

Marker Identifier
Applicable for CMode CLI

=item C<< 'transaction-id' => $string >>

Transaction ID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver baseline generate" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub generate {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( baseline-vservers-for-cserver stream-uuid baseline-type marker-tag

                    transaction-id
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'debug dm vserver baseline generate-local',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_generate_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverBaseline::generate',
    );

}

sub _generate_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_baseline_generate',);
    $Log->exit() if $may_exit;
}

__PACKAGE__->_load_event_class();

1;
