# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugDmVserverStream Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugDmVserverStream

=head1 DESCRIPTION

C<NACL::C::DebugDmVserverStream> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugDmVserverStream.  A related class is
L<NACL::CS::DebugDmVserverStream|lib-NACL-CS-DebugDmVserverStream-pm>, which represents
the past state of an ONTAP DebugDmVserverStream.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 stream_uuid

=cut

package NACL::C::DebugDmVserverStream;

use strict;
use warnings;

use NACL::CS::DebugDmVserverStream;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugDmVserverStream = NACL::C::DebugDmVserverStream->new(
                                   command_interface => $ci,
                                   'stream-uuid' => $stream_uuid,
								  );

Return a new DebugDmVserverStream component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'stream_uuid',];

=head2 find

    my $DebugDmVserverStream_obj  = NACL::C::DebugDmVserverStream->find(command_interface => $ci, ...);
	my @DebugDmVserverStream_objs = NACL::C::DebugDmVserverStream->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugDmVserverStream_state = $DebugDmVserverStream_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugDmVserverStream would return 
a NACL::CS::DebugDmVserverStream object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 abort

    NACL::C::DebugDmVserverStream->abort(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->abort(...);

(Class or instance method)
This method is used to abort Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream abort" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub abort {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug dm vserver stream abort',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_abort_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::abort',
    );

}

sub _abort_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_abort',);
    $Log->exit() if $may_exit;
}

=head2 create

    my $DebugDmVserverStream_obj	= NACL::C::DebugDmVserverStream->create(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
   
(Class method)
This method is used to create Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required)
Stream UUID
Applicable for CMode CLI

=item C<< 'app-instance-uuid' => $string >>

Identifier for app instance
Applicable for CMode CLI

=item C<< 'stream-admin-state' => $string >>

Stream Admin State possible value(s) are, up,down,paused
Applicable for CMode CLI

=item C<< 'service-notification' => $string >>

Service Notification Options
Applicable for CMode CLI

=item C<< 'league-uuid' => $string >>

League UUID
Applicable for CMode CLI

=item C<< 'remote-cluster-uuid' => $string >>

Remote Cluster UUID
Applicable for CMode CLI

=item C<< 'remote-vserver-uuid' => $string >>

Remote Vserver UUID
Applicable for CMode CLI

=item C<< 'message-notification' => $string >>

Message Notification Options
Applicable for CMode CLI

=item C<< 'stream-direction' => $string >>

Stream Direction possible value(s) are, sender,receiver
Applicable for CMode CLI

=item C<< 'retry-count' => $string >>

Apply Retry Count
Applicable for CMode CLI

=item C<< 'stream-synopsis' => $string >>

Stream Synopsis
Applicable for CMode CLI

=item C<< 'vserver-uuid' => $string >>

Local Vserver UUID
Applicable for CMode CLI

=item C<< 'stream-storage-capacity' => $string >>

Stream Storage Capacity
Applicable for CMode CLI

=item C<< 'app-name' => $string >>

Application Name possible value(s) are, async-dr,sync-dr
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream create" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( app-instance-uuid stream-admin-state service-notification league-uuid
                    remote-cluster-uuid remote-vserver-uuid message-notification
                    stream-direction retry-count stream-synopsis vserver-uuid
                    stream-storage-capacity app-name
                    )
            ),
        },
        cli_cmd => 'debug dm vserver stream create',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        stream_uuid       => $opts{'stream-uuid'},
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_create',);
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::DebugDmVserverStream->delete(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->delete(...);

(Class or instance method)
This method is used to delete Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< 'ignore-remote-delete-failure' => $string >>


Ignore Remote Delete Failure (default: true) possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'delete-remote-stream' => $string >>

Delete Remote Stream (default: true) possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'abort-pending-requests' => $string >>

Abort Pending Requests possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'force' => $string >>


Deletes even when stream is not empty (default: true) possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'ignore-pending-contents' => $string >>


Ignore Pending Stream Contents (default: true) possible value(s) are, true,false
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( ignore-remote-delete-failure delete-remote-stream abort-pending-requests

                    force

                    ignore-pending-contents
                    )
            ),
        },
        cli_cmd => 'debug dm vserver stream delete',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::delete',
    );

}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_delete',);
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::DebugDmVserverStream->modify(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->modify(...);

(Class or instance method)
This method is used to modify Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< 'message-notification' => $string >>

Message Notification Options
Applicable for CMode CLI

=item C<< 'stream-admin-state' => $string >>

Stream Admin State possible value(s) are, up,down,paused
Applicable for CMode CLI

=item C<< 'service-notification' => $string >>

Service Notification Options
Applicable for CMode CLI

=item C<< 'retry-count' => $string >>

Apply Retry Count
Applicable for CMode CLI

=item C<< 'stream-synopsis' => $string >>

Stream Synopsis
Applicable for CMode CLI

=item C<< 'stream-storage-capacity' => $string >>

Stream Storage Capacity
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( message-notification stream-admin-state service-notification retry-count
                    stream-synopsis stream-storage-capacity
                    )
            ),
        },
        cli_cmd => 'debug dm vserver stream modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::modify',
    );

}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_modify',);
    $Log->exit() if $may_exit;
}

=head2 pause

    NACL::C::DebugDmVserverStream->pause(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->pause(...);

(Class or instance method)
This method is used to pause Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream pause" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub pause {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug dm vserver stream pause',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_pause_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::pause',
    );

}

sub _pause_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_pause',);
    $Log->exit() if $may_exit;
}

=head2 query

    NACL::C::DebugDmVserverStream->query(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->query(...);

(Class or instance method)
This method is used to query Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< 'message-type' => $string >>

Message Type possible value(s) are, baseline,marker,update
Applicable for CMode CLI

=item C<< 'marker-tag' => $string >>

Marker Identifier
Applicable for CMode CLI

=item C<< 'message-id' => $string >>

Message Sequence Number
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream query" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub query {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( message-type marker-tag

                    message-id
                    )
            ),
        },
        cli_cmd => 'debug dm vserver stream query',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_query_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::query',
    );

}

sub _query_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_query',);
    $Log->exit() if $may_exit;
}

=head2 resume

    NACL::C::DebugDmVserverStream->resume(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->resume(...);

(Class or instance method)
This method is used to resume Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream resume" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub resume {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug dm vserver stream resume',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_resume_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::resume',
    );

}

sub _resume_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_resume',);
    $Log->exit() if $may_exit;
}

=head2 drain

    NACL::C::DebugDmVserverStream->drain(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->drain(...);

(Class or instance method)
This method is used to drain Stream.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< 'stream-storage-path' => $string >>

Sender Stream Path
Applicable for CMode CLI

=item C<< 'empty-drain' => $string >>

Is there anything to drain possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'drain-from-mdv' => $string >>

Drain the intents from MDV possible value(s) are, true,false
Applicable for CMode CLI

=item C<< 'status' => $string >>


Drain status possible value(s) are, drain-complete,drain-in-progress,drain-fatal-error
Applicable for CMode CLI

=item C<< 'sender-metainfo-path' => $string >>

Sender Meta Info Path
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream drain" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub drain {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'debug dm vserver stream drain',
        additional_spec => {
            _optional_scalars(
                qw( stream-storage-path

                    empty-drain

                    drain-from-mdv status sender-metainfo-path
                    )
            )
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_drain_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::drain',
    );

}

sub _drain_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_drain',);
    $Log->exit() if $may_exit;
}

=head2 query_latest

    NACL::C::DebugDmVserverStream->query_latest(
                                command_interface => $ci,
	                            'stream-uuid' => $stream_uuid,
                                ...);
	                             
								 or

    $DebugDmVserverStream_obj->query_latest(...);

(Class or instance method)
This method is used to query Latest Message.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'stream-uuid' => $stream_uuid >>

(Required for class method, Not Applicable for instance method)
Stream UUID
Applicable for CMode CLI

=item C<< 'message-type' => $string >>

Message Type possible value(s) are, baseline,marker,update
Applicable for CMode CLI

=item C<< 'message' => $string >>

Message Content
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug dm vserver stream query latest" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub query_latest {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( message-type

                    message
                    )
            ),
        },
        cli_cmd => 'debug dm vserver stream query-latest',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_query_latest_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugDmVserverStream::query_latest',
    );

    $Log->exit() if $may_exit;
}

sub _query_latest_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_dm_vserver_stream_query_latest',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('stream-uuid' => {type => SCALAR},);
}

1;
