# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugLocksReconstruction Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugLocksReconstruction

=head1 DESCRIPTION

C<NACL::C::DebugLocksReconstruction> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugLocksReconstruction.  A related class is
L<NACL::CS::DebugLocksReconstruction|lib-NACL-CS-DebugLocksReconstruction-pm>, which represents
the past state of an ONTAP DebugLocksReconstruction.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 filer

=cut

package NACL::C::DebugLocksReconstruction;

use strict;
use warnings;

use NACL::CS::DebugLocksReconstruction;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugLocksReconstruction = NACL::C::DebugLocksReconstruction->new(
                                   command_interface => $ci,
                                   'filer' => $filer,
								  );

Return a new DebugLocksReconstruction component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'filer',];

=head2 find

    my $DebugLocksReconstruction_obj  = NACL::C::DebugLocksReconstruction->find(command_interface => $ci, ...);
	my @DebugLocksReconstruction_objs = NACL::C::DebugLocksReconstruction->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugLocksReconstruction_state = $DebugLocksReconstruction_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugLocksReconstruction would return 
a NACL::CS::DebugLocksReconstruction object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_volume

    my $show_volume_obj = NACL::C::DebugLocksReconstruction->show_volume(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_volume_objs = NACL::C::DebugLocksReconstruction->show_volume(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_volume_obj = $DebugLocksReconstruction_obj->show_volume(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugLocksReconstructionShowVolume-pm/ATTRIBUTES>
of NACL::CS::DebugLocksReconstructionShowVolume as input. 
This method returns objects of the type L<NACL::CS::DebugLocksReconstructionShowVolume|lib-NACL-CS-DebugLocksReconstructionShowVolume-pm>.

=cut

sub show_volume {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugLocksReconstructionShowVolume;
    my @state_objs
        = NACL::CS::DebugLocksReconstructionShowVolume->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('filer' => {type => SCALAR},);
}

1;
