# $Id$

#
# Copyright (c) 2001-2017 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugSmdb Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugSmdb

=head1 DESCRIPTION

C<NACL::C::DebugSmdb> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugSmdb.  A related class is
L<NACL::CS::DebugSmdb|lib-NACL-CS-DebugSmdb-pm>, which represents
the past state of an ONTAP DebugSmdb.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 table

=cut

package NACL::C::DebugSmdb;

use strict;
use warnings;

use NACL::CS::DebugSmdb;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugSmdb = NACL::C::DebugSmdb->new(
                                   command_interface => $ci,
                                   'table' => $table,
								  );

Return a new DebugSmdb component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'table',];

=head2 find

    my $DebugSmdb_obj  = NACL::C::DebugSmdb->find(command_interface => $ci, ...);
	my @DebugSmdb_objs = NACL::C::DebugSmdb->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugSmdb_state = $DebugSmdb_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugSmdb would return 
a NACL::CS::DebugSmdb object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 create

    my $DebugSmdb_obj	= NACL::C::DebugSmdb->create(
                                command_interface => $ci,
	                            'table' => $table,
                                ...);

(Class method)
This method is used to enable SMDB table debugging.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'table' => $table >>

(Required)
Table Name

Applicable for CMode CLI.

=item C<< 'next-error' => $string >>

next() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'tracing' => $string >>

smf iterator tracing possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'testmode' => $string >>

table test mode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'modify-error' => $string >>

modify() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'remove-error' => $string >>

remove() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'send-to' => $string >>

Logging Destination possible value(s) are, file,user,both

Applicable for CMode CLI.

=item C<< 'create-error' => $string >>

create() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'postop-error' => $string >>

postop() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'testmode-copy' => $string >>

copy normal for testmode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'nextseq-error' => $string >>

nextseq() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'action' => $string >>

Debugging Options possible value(s) are, none,app,imp,both

Applicable for CMode CLI.

=item C<< 'testmode-local' => $string >>

force local access possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'get-error' => $string >>

get() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'other-error' => $string >>

app-specific error ranges from 0 to 256

Applicable for CMode CLI

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< 'smf-trace' => $string >>

SMF Iterator Tracing possible value(s) are, yes,no,auto
Applicable for CMode CLI

=item C<< 'trace-threshold' => $string >>

Trace Threshold (secs) ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-int-prio' => $string >>

DSMF Max in Intermediate Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-high-prio' => $string >>

SMF Max in High Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-active-thresh' => $string >>

DSMF Max Active Threshold ranges from 0 to 255
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug smdb create" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( next-error tracing testmode modify-error remove-error send-to create-error
                    postop-error testmode-copy nextseq-error action testmode-local get-error
                    other-error

                    smf-trace trace-threshold

                    dsmf-max-in-int-prio dsmf-max-in-high-prio dsmf-max-active-thresh
                    )
            ),
        },
        cli_cmd => 'debug smdb create',
    );
    my $obj = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdb::create',
    );

    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    $pkg->_base_backend_cmode_cli(%opts,
            api => 'debug_smdb_create');

    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $opts{command_interface},
        table             => $opts{'table'},
    );
}

=head2 delete

    NACL::C::DebugSmdb->delete(
                                command_interface => $ci,
	                            'table' => $table,
                                ...);
	                             
								 or

    $DebugSmdb_obj->delete(...);

(Class or instance method)
This method is used to disable SMDB table debugging.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'table' => $table >>

(Required for class method, Not Applicable for instance method)
Table Name

Applicable for CMode CLI.

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug smdb delete" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        additional_spec =>
            {'cmd_execution_time' => {type => SCALARREF, optional => 1},},
        cli_cmd => 'debug smdb delete',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdb::delete',
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;

    $pkg_or_obj->_base_backend_cmode_cli(
        @_,
        api => 'debug_smdb_delete');

    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::DebugSmdb->modify(
                                command_interface => $ci,
	                            'table' => $table,
                                ...);
	                             
								 or

    $DebugSmdb_obj->modify(...);

(Class or instance method)
This method is used to set SMDB table debugging.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'table' => $table >>

(Required for class method, Not Applicable for instance method)
Table Name

Applicable for CMode CLI.

=item C<< 'next-error' => $string >>

next() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'tracing' => $string >>

smf iterator tracing possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'testmode' => $string >>

table test mode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'modify-error' => $string >>

modify() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'remove-error' => $string >>

remove() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'send-to' => $string >>

Logging Destination possible value(s) are, file,user,both

Applicable for CMode CLI.

=item C<< 'create-error' => $string >>

create() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'postop-error' => $string >>

postop() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'testmode-copy' => $string >>

copy normal for testmode possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'nextseq-error' => $string >>

nextseq() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'action' => $string >>

Debugging Options possible value(s) are, none,app,imp,both

Applicable for CMode CLI.

=item C<< 'testmode-local' => $string >>

force local access possible value(s) are, yes,no

Applicable for CMode CLI.

=item C<< 'get-error' => $string >>

get() error ranges from 0 to 16

Applicable for CMode CLI

=item C<< 'other-error' => $string >>

app-specific error ranges from 0 to 256

Applicable for CMode CLI

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< 'smf-trace' => $string >>

SMF Iterator Tracing possible value(s) are, yes,no,auto
Applicable for CMode CLI

=item C<< 'trace-threshold' => $string >>

Trace Threshold (secs) ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-int-prio' => $string >>

DSMF Max in Intermediate Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-in-high-prio' => $string >>

SMF Max in High Priority Queue ranges from 0 to 255
Applicable for CMode CLI

=item C<< 'dsmf-max-active-thresh' => $string >>

DSMF Max Active Threshold ranges from 0 to 255
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug smdb modify" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( next-error tracing testmode modify-error remove-error send-to create-error
                    postop-error testmode-copy nextseq-error action testmode-local get-error
                    other-error

                    smf-trace trace-threshold

                    dsmf-max-in-int-prio dsmf-max-in-high-prio dsmf-max-active-thresh
                    )
            ),
        },
        cli_cmd => 'debug smdb modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdb::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;

    $pkg_or_obj->_base_backend_cmode_cli(
        @_, 
        api => 'debug_smdb_modify'
    );

    $Log->exit() if $may_exit;
}

=head2 debug_smdb_table

This method is used to perform operation on the underlying
SMDB tables. The possible operation which can be performed are
create, delete, modify, run and show
Unlike other commands , this command doesnt take options 
in a standard way and there is no equivalent ZAPI api
Also the "debug smdb" commands follow non-convention syntax, typical
Component support is NOT available for these commands and instead the
APISet should be used. See the documentation for "debug_smdb_table_create",
"debug_smdb_table_modify" and "debug_smdb_table_delete" in
L<NACL::APISet::Node::CLI::CMode|lib-NACL-APISet-Node-CLI-CMode-pm>.

=cut

sub debug_smdb_table {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'fields'             => {type => ARRAYREF,  optional => 1},
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( create show run delete modify
                    )
            ),
        },
        cli_cmd => 'debug smdb table',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_debug_smdb_table_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugSmdb::debug_smdb_table',
    );

    $Log->exit() if $may_exit;
}

sub _debug_smdb_table_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;

    $pkg_or_obj->_base_backend_cmode_cli(
        @_,
        api => 'debug_smdb_table'
    );

    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('table' => {type => SCALAR},);
}

1;
