# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugUpgradeRevert Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugUpgradeRevert

=head1 DESCRIPTION

C<NACL::C::DebugUpgradeRevert> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugUpgradeRevert.  A related class is
L<NACL::CS::DebugUpgradeRevert|lib-NACL-CS-DebugUpgradeRevert-pm>, which represents
the past state of an ONTAP DebugUpgradeRevert.
However, since it does not have any primary keys, 'find' and 'state' do not
work for this component. (This component is considered a 'singleton',
i.e. there is only one row shown by the relevant 'show' command)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::DebugUpgradeRevert;

use strict;
use warnings;

use NACL::CS::DebugUpgradeRevert;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $DebugUpgradeRevert = NACL::C::DebugUpgradeRevert->new(
                                   command_interface => $ci,
								  );

Return a new DebugUpgradeRevert component object with the given attributes.

=cut

use Class::MethodMaker [];

=head2 find

    my $DebugUpgradeRevert_obj  = NACL::C::DebugUpgradeRevert->find(command_interface => $ci, ...);
	my @DebugUpgradeRevert_objs = NACL::C::DebugUpgradeRevert->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugUpgradeRevert_state = $DebugUpgradeRevert_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugUpgradeRevert would return 
a NACL::CS::DebugUpgradeRevert object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 system_node_upgrade_revert_revert_chk

    NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_revert_chk(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to run the revert check command..
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by "system node upgrade revert revert chk" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub system_node_upgrade_revert_revert_chk {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        additional_spec =>
            {'cmd_execution_time' => {type => SCALARREF, optional => 1},},
        ignore_primary_keys => 1,
        cli_cmd             => 'system node upgrade-revert revert-chk',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method => '_system_node_upgrade_revert_revert_chk_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugUpgradeRevert::system_node_upgrade_revert_revert_chk',
    );

    $Log->exit() if $may_exit;
}

sub _system_node_upgrade_revert_revert_chk_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'system_node_upgrade_revert_revert_chk'
    );

    $Log->exit() if $may_exit;
}

=head2 system_node_upgrade_revert_revert_clr

    NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_revert_clr(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to run the revert clear command - emptys the U/R upgrade status table..
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by "system node upgrade revert revert clr" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub system_node_upgrade_revert_revert_clr {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        additional_spec =>
            {'cmd_execution_time' => {type => SCALARREF, optional => 1},},
        ignore_primary_keys => 1,
        cli_cmd             => 'system node upgrade-revert revert-clr',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method => '_system_node_upgrade_revert_revert_clr_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugUpgradeRevert::system_node_upgrade_revert_revert_clr',
    );

    $Log->exit() if $may_exit;
}

sub _system_node_upgrade_revert_revert_clr_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'system_node_upgrade_revert_revert_clr'
    );

    $Log->exit() if $may_exit;
}

=head2 system_node_upgrade_revert_revert

    NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_revert(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to run the revert at a specific revert phase..
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'startup-phase' => $string >>

Boot startup phase possible value(s) are, pre-root,pre-apps,post-apps
Applicable for CMode CLI

=item C<< 'version' => $string >>

ONTAP Version
Applicable for CMode CLI

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by "system node upgrade revert revert" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub system_node_upgrade_revert_revert {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( startup-phase version
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_revert',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_system_node_upgrade_revert_revert_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugUpgradeRevert::system_node_upgrade_revert_revert',
    );

    $Log->exit() if $may_exit;
}

sub _system_node_upgrade_revert_revert_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'system_node_upgrade_revert_revert'
    );

    $Log->exit() if $may_exit;
}

=head2 system_node_upgrade_revert_show

    my $system_node_upgrade_revert_show_obj = NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @system_node_upgrade_revert_show_objs = NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $system_node_upgrade_revert_show_obj = $DebugUpgradeRevert_obj->system_node_upgrade_revert_show(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugUpgradeRevertSystemNodeUpgradeRevertShow-pm/ATTRIBUTES>
of NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShow as input. 
This method returns objects of the type L<NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShow|lib-NACL-CS-DebugUpgradeRevertSystemNodeUpgradeRevertShow-pm>.

=cut

sub system_node_upgrade_revert_show {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShow;
    my @state_objs
        = NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShow->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 system_node_upgrade_revert_show_task_status

    my $system_node_upgrade_revert_show_task_status_obj = NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show_task_status(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @system_node_upgrade_revert_show_task_status_objs = NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show_task_status(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $system_node_upgrade_revert_show_task_status_obj = $DebugUpgradeRevert_obj->system_node_upgrade_revert_show_task_status(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus-pm/ATTRIBUTES>
of NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus as input. 
This method returns objects of the type L<NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus|lib-NACL-CS-DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus-pm>.

=cut

sub system_node_upgrade_revert_show_task_status {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus;
    my @state_objs
        = NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus
        ->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 system_node_upgrade_revert_upgrade_task

    NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_upgrade_task(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to upgrade a specific task..
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'startup-phase' => $string >>

Startup Phase possible value(s) are, pre-root,pre-apps,post-apps
Applicable for CMode CLI

=item C<< 'version' => $string >>

Version Number
Applicable for CMode CLI

=item C<< 'process' => $string >>

Process Name
Applicable for CMode CLI

=item C<< 'task-id' => $string >>

Task Identifier
Applicable for CMode CLI

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by "system node upgrade revert upgrade task" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub system_node_upgrade_revert_upgrade_task {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( startup-phase version process task-id
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_upgrade_task',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method =>
                    '_system_node_upgrade_revert_upgrade_task_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugUpgradeRevert::system_node_upgrade_revert_upgrade_task',
    );

    $Log->exit() if $may_exit;
}

sub _system_node_upgrade_revert_upgrade_task_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'system_node_upgrade_revert_upgrade_task'
    );

    $Log->exit() if $may_exit;
}

=head2 system_node_upgrade_revert_upgrade

    NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_upgrade(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to run the upgrade at a specific phase..
Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by "system node upgrade revert upgrade" command in ONTAP

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub system_node_upgrade_revert_upgrade {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        additional_spec =>
            {'cmd_execution_time' => {type => SCALARREF, optional => 1},},
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_upgrade',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_system_node_upgrade_revert_upgrade_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::DebugUpgradeRevert::system_node_upgrade_revert_upgrade',
    );

    $Log->exit() if $may_exit;
}

sub _system_node_upgrade_revert_upgrade_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift ; 

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'system_node_upgrade_revert_upgrade',
    );

    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

1;
