# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugVreport Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DebugVreport

=head1 DESCRIPTION

C<NACL::C::DebugVreport> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP DebugVreport.  A related class is
L<NACL::CS::DebugVreport|lib-NACL-CS-DebugVreport-pm>, which represents
the past state of an ONTAP DebugVreport.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 object

=head2 type

=cut

package NACL::C::DebugVreport;

use strict;
use warnings;

use NACL::CS::DebugVreport;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::APISet::Exceptions::ResponseException;
use NACL::C::StorageAggregate;
use NATE::BaseException qw(:try);

=head1 METHODS

=head2 new

  my $DebugVreport = NACL::C::DebugVreport->new(
                                   command_interface => $ci,
                                   'object' => $object,
                                   'type' => $type,
								  );

Return a new DebugVreport component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'object',
    scalar => 'type',
];

=head2 find

    my $DebugVreport_obj  = NACL::C::DebugVreport->find(command_interface => $ci, ...);
	my @DebugVreport_objs = NACL::C::DebugVreport->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my DebugVreport_state = $DebugVreport_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::DebugVreport would return 
a NACL::CS::DebugVreport object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 fix

    NACL::C::DebugVreport->fix(
                                command_interface => $ci,
	                            'object' => $object,
	                            'type' => $type,
                                ...);
	                             
								 or

    $DebugVreport_obj->fix(...);

(Class or instance method)
This method is used to fix vreport discrepancy by updating VLDB tables.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'object' => $object >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'type' => $type >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'export-policy' => $string >>

Applicable for CMode CLI.

=item C<< 'language' => $string >>

Applicable for CMode CLI.

=item C<< 'vs-uuid' => $string >>

Applicable for CMode CLI.

=item C<< 'vserver-root' => $string >>

Applicable for CMode CLI.

=item C<< 'node' => $string >>

Applicable for CMode CLI.

=item C<< 'snapshot-policy' => $string >>

Applicable for CMode CLI.

=item C<< 'action' => $string >>

Applicable for CMode CLI.

=item C<< 'aggregate' => $string >>

Applicable for CMode CLI.

=item C<< 'antivirus-on-access-policy' => $string >>

Applicable for CMode CLI.

=item C<< 'ns-switch' => [ $ns-switch1, $ns-switch2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'flexcache-cache-policy' => $string >>

Flexcache Cache Policy Name possible value(s) are, text

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< 'sm-force-clean-up' => $string >>

Force Removal of SnapMirror Entries
Applicable for CMode CLI

=item C<< 'efficiency-policy' => $string >>

Default Efficiency Policy
Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub fix {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => {
            'ns-switch' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( export-policy language vs-uuid vserver-root node snapshot-policy action
                    aggregate antivirus-on-access-policy

                    flexcache-cache-policy

                    sm-force-clean-up

                    efficiency-policy
                    )
            ),
        },
    );

    try {
	$pkg_or_obj->_fix_call_on_apiset(%opts);
    } catch NACL::APISet::Exceptions::ResponseException with {
	my $ex = shift;
	if($ex->text() =~/foreign\s+aggregate/i) {
	    my $aggr = $opts{object};
	    $aggr =~s/(.*)\(.*\)?/$1/;
	    my $local_node = NACL::C::StorageAggregate->get_local_node_name(
	        command_interface => $opts{command_interface},
		aggregate => $aggr
	    );
            my $local_ci = NACL::C::Node->new(node => $local_node);
            $pkg_or_obj->_fix_call_on_apiset(%opts, command_interface => $local_ci);
	}else {
	    $ex->throw();
	}
    };
    $Log->exit() if $may_exit;
} ## end sub fix

sub _fix_call_on_apiset {
    my $pkg_or_obj = shift;
    $pkg_or_obj->call_on_apiset(
	@_,
	choices => [
	    {   method    => '_fix_cmode_cli',
	        interface => 'CLI',
	        set       => 'CMode',
	    },
	],
    );
}

sub _fix_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( ns-switch export-policy object language vs-uuid vserver-root node
            snapshot-policy action type aggregate antivirus-on-access-policy
            extended_query
            flexcache-cache-policy

            sm-force-clean-up

            efficiency-policy
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    foreach my $array_element (qw(ns-switch)) {
        if (defined $cmode_args{$array_element}) {
            $cmode_args{$array_element} = join ',',
                @{$cmode_args{$array_element}};
        }
    } ## end foreach my $array_element qw(ns-switch)

    $pkg_or_obj->_api_call_log_debug_opts(
        api      => 'debug_vreport_fix',
        api_opts => \%cmode_args
    );

    $apiset->debug_vreport_fix(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _fix_cmode_cli

=head2 delete_locks

    NACL::C::DebugVreport->delete_locks(
                                command_interface => $ci,
	                            'type' => $type,
	                            'object' => $object,
                                ...);
	                             
								 or

    $DebugVreport_obj->delete_locks(...);

(Class or instance method)
This method is used to delete vreport locks taken by node.
Uses CMode CLI .

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'type' => $type >>

(Required for class method, Not Applicable for instance method)

Object type possible value(s) are, aggregate,volume,junction,snapmirror,vserver
Applicable for CMode CLI

=item C<< 'object' => $object >>

(Required for class method, Not Applicable for instance method)
Object
Applicable for CMode CLI

=item C<< 'node' => $string >>

Node name possible value(s) are, <nodename>,local
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "debug vreport delete locks" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete_locks {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( node
                    )
            ),
        },
        ignore_primary_keys => 1,
        api => 'debug_vreport_delete_locks',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_locks_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DebugVreport::delete_locks',
    );

    $Log->exit() if $may_exit;
}

sub _delete_locks_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'debug_vreport_delete_locks',);
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'object' => {type => SCALAR},
        'type'   => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
