# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdConfiguration Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::DiagSecdConfiguration

=head1 DESCRIPTION

C<NACL::C::DiagSecdConfiguration> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. Unlike other components this
package does not model any element/service but is present to provide
component-level support for functionality. Since it does not model any
element/service there is no ComponentState module for this component.
For the same reason, 'find' and 'state' will not work for this component.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut

package NACL::C::DiagSecdConfiguration;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars);

use NACL::CS::DiagSecdConfigurationShowFields;
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;
use NACL::CS::DiagSecdConfigurationQuery;

use Class::MethodMaker [scalar => 'node',];

=head2 show_fields

   NACL::C::DiagSecdConfiguration->show_fields(
                                command_interface => $ci,
                                node => $node
                                  ...);

(Class method)
This method is used to show configuration source fields.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "source-name" => $string >>

Applicable for CMode CLI.

=item C<< "node" => $node >>

(Required)

Applicable for CMode CLI.

=item C<< 'node' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"diag secd configuration show-fields" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub show_fields {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( source-name
                    node
                    )
            ),
        },
        cli_cmd => 'diag secd configuration show-fields',
    );
    my @ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_show_fields_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::DiagSecdConfiguration::show_fields',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @ret : $ret[0];
} ## end sub show_fields

sub _show_fields_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my @state_objs;

    my $response;
    $pkg->_base_backend_cmode_cli(%opts, 
               api   => 'diag_secd_configuration_show_fields',
               apiset_response_obj => \$response,);


    my $output   = $response->get_parsed_output();
    my $obj      = NACL::CS::DiagSecdConfigurationShowFields->new(
        command_interface => $opts{command_interface});
    foreach my $row (@$output) {
        $obj->_set_fields(row => $row);
        push @state_objs, $obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _show_fields_cmode_cli

=head2 reload

   NACL::C::DiagSecdConfiguration->reload(
                                command_interface => $ci,
                                node => $node
                                  ...);
   
(Class method)
This method is used to reload configuration sources.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< node => $node >>

(Required)

Applicable for CMode CLI.

=item C<< 'node' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"diag secd configuration reload" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub reload {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {_optional_scalars(qw( node ))},
        cli_cmd         => 'diag secd configuration reload',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_reload_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::DiagSecdConfiguration::reload',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub reload

sub _reload_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'diag_secd_configuration_reload'
    );

    $Log->exit() if $may_exit;
} ## end sub _reload_cmode_cli

=head2 query

   NACL::C::DiagSecdConfiguration->query(
                                command_interface => $ci,
                                node => $node
                                  ...);
   
(Class method)
This method is used to query a configuration source.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "source-name" => $string >>

Applicable for CMode CLI.

=item C<< "node" => $node >>

(Required)

Applicable for CMode CLI.

=item C<< "query-string" => [ $query-string1, $query-string2, ... ] >>

Applicable for CMode CLI.

=item C<< 'node' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"diag secd configuration query" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub query {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            "query-string" => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( source-name
                    node
                    )
            ),
        },
        cli_cmd => 'diag secd configuration query',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_query_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::DiagSecdConfiguration::query',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub query

sub _query_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my @state_objs;
    my $response;
    $pkg->_base_backend_cmode_cli(%opts,
		api => 'diag_secd_configuration_query',
		apiset_response_obj => \$response,);
    my $output = $response->get_parsed_output();
    my $obj = NACL::CS::DiagSecdConfigurationQuery->new(
		command_interface => $opts{command_interface});
    foreach my $row (@$output) {
	my %values = %$row;
	while ( my ( $key, $val ) = each %values ) {
	    delete $values{$key} if(!defined($val));
	}
        $obj->_set_fields(row => \%values);
	push @state_objs, $obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _query_cmode_cli

=head2 admin

    NACL::C::DiagSecdConfiguration->admin(
                                command_interface => $ci,
                                ...);
   
(Class method)
This method is used to perform an admin op on a configuration source.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'admin-op' => $string >>

*Info=1,add,delete,modify,query

Applicable for CMode CLI.

=item C<< 'marshaled-values' => $string >>

Applicable for CMode CLI.

=item C<< 'marshaled-names' => $string >>

Applicable for CMode CLI.

=item C<< 'source-name' => $string >>

*Name of configuration source

Applicable for CMode CLI.

=item C<< 'node' => $string >>

*Node

Applicable for CMode CLI.

=item C<< 'cmd_execution_time' => \$scalar >>

(Optional) Scalar reference , it will be updated with the command execution
time returned by the apiset response object

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"diag secd configuration admin" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub admin {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'cmd_execution_time' => {type => SCALARREF, optional => 1},
            _optional_scalars(
                qw( admin-op marshaled-values marshaled-names source-name node
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'diag secd configuration admin',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_admin_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::DiagSecdConfiguration::admin',
    );

    $Log->exit() if $may_exit;
} ## end sub admin

sub _admin_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'diag_secd_configuration_admin'
    );

    $Log->exit() if $may_exit;
} ## end sub _admin_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('node' => {type => SCALAR});
}
1;
