# $Id$
#
# Copyright (c) 2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware End User License Agreement

# VMware, Inc. (VMware) provides the vSphere Command-Line Interface (vSphere CLI) 
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively 
# the Software) to you subject to the following terms and conditions.  If you 
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation, 
# sample utility applications and sample code regarding programming interfaces to one or 
# more VMware products as referenced in such materials (VMware Products).  This Software 
# is intended to be used to execute supplied commands and utility applications and to 
# create scripts that interact with the VMware Products. 

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a 
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (Developer Software).  For
# vSphere SDK for Perl, some code may be designated as distributable code and/or
# modifiable code at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as distributable code and/ or modifiable code at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the distributable code with your Developer Software.  Any merged portion of any 
# distributable code is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the modifiable code.  You are permitted to
# re-distribute the distributable code and the modified or derivative works of the 
# modifiable code only as part of your Developer Software for non-commercial or commercial 
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.  

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMwares sole discretion, to provide alternatives that reduce any adverse impact on VMwares
# intellectual property or other rights.  

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMwares name, trademarks or service marks in your Developer Softwares
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com. 

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.  

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement. 

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARES LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys fees), arising from your
# modification or derivative works of the modifiable code, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary ESX/VirtualMachine Component Module
## @author kathar.hidayath@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::ESX::VirtualMachine

=head1 DESCRIPTION

C<NACL::C::ESX::VirtualMachine> is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>.  It represents access
to the Virtual Machine managed object reference of an ESX Server.
A related class isL<NACL::CS::ESX::VirtualMachine|lib-NACL-CS-ESX-VirtualMachine-pm>,
which represents the state of Virtual Machines on the given ESX Server.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vm_name

The name of the virtual machine , used to identify it uniquely.

=head2 hostName

The name of the host in which the virtual machine is created, used to identify it uniquely.

=head2 ipAddress

The ip address of the virtual machine , used to identify it uniquely.

=cut

package NACL::C::ESX::VirtualMachine;

use strict;
use warnings;
use Params::Validate qw(validate_with validate SCALAR BOOLEAN);
use NATE::BaseException qw(:try);

use NACL::CS::ESX::VirtualMachine;
use NACL::C::ESX::Task;
use NACL::ComponentUtils qw(_optional_scalars Dumper);
use base 'NACL::C::Component';
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $vm_obj = NACL::C::ESX::VirtualMachine->new(command_interface=>$ci,
                                          vm_name => $vm_name,
                                          );

Return a new ESX::VirtualMachine component object with the given attributes.

=cut

use Class::MethodMaker [
    new    => [ '-hash', '-init', 'new' ],
    scalar => 'vm_name',
    scalar => [ { -type => 'NACL::C::ESX::ESXHost' }, 'command_interface', ],
    scalar => [ { -type => 'NACL::C::ESX::Task' },    'task_obj' ],
];

=head2 power_on

  my $control  = NACL::C::ESX::VirtualMachine->power_on(
                                        command_interface => $ci,
                                        host              => $host_name );

(Class method) This method will power on the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< host => $host_name >>

(optional) Name of the host the virtual machine is associated with.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub power_on {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params          => \@_,
        additional_spec => { host => { type => SCALAR, optional => 1 } },
    );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_power_on_vm', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub power_on

sub _power_on_vm {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_options = [qw( host )];
    my $vms             = $command_interface->virtualmachines();
    my $target_vm       = _find_target_vm( $opts{'vm_name'}, $vms );
    my %args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );
    my $result = $target_vm->PowerOnVM_Task(%args);
    my $task_obj = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
        task_obj          => $task_obj,
    );
} ## end sub _power_on_vm

=head2 power_off

  my $control  = NACL::C::ESX::VirtualMachine->power_off(
                                        command_interface => $ci, );

(Class method) This method will power off the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub power_off {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_, );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_power_off_vm', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub power_off

sub _power_off_vm {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms       = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    my $result    = $target_vm->PowerOffVM_Task();
    my $task_obj  = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $vmName,
        task_obj          => $task_obj,
    );
} ## end sub _power_off_vm

=head2 suspend

  my $control  = NACL::C::ESX::VirtualMachine->suspend(
                                        command_interface => $ci, );

(Class method) This method will suspend the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub suspend {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_, );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_suspend_vm', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub suspend

sub _suspend_vm {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms       = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    my $result    = $target_vm->SuspendVM_Task();
    my $task_obj  = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $vmName,
        task_obj          => $task_obj,
    );
} ## end sub _suspend_vm

=head2 reset

  my $control  = NACL::C::ESX::VirtualMachine->reset(
                                        command_interface => $ci, );

(Class method) This method will reset the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub reset {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_, );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_reset_vm', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub reset

sub _reset_vm {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms       = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    my $result    = $target_vm->ResetVM_Task();
    my $task_obj  = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $vmName,
        task_obj          => $task_obj,
    );
} ## end sub _reset_vm

=head2 reboot_guest

  my $control  = NACL::C::ESX::VirtualMachine->reboot_guest(
                                        command_interface => $ci, );

(Class method) This method will reboot OS of the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub reboot_guest {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_, );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_reboot_guest', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub reboot_guest

sub _reboot_guest {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    $target_vm->RebootGuest();
    $Log->exit() if $may_exit;
    return;
} ## end sub _reboot_guest

=head2 shutdown_guest

  my $control  = NACL::C::ESX::VirtualMachine->shutdown_guest(
                                        command_interface => $ci, );

(Class method) This method will shut down OS of the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub shutdown_guest {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_, );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_shutdown_guest', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub shutdown_guest

sub _shutdown_guest {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    $target_vm->ShutdownGuest();
    $Log->exit() if $may_exit;
    return;
} ## end sub _shutdown_guest

=head2 standby_guest

  my $control  = NACL::C::ESX::VirtualMachine->standby_guest(
                                        command_interface => $ci, );

(Class method) This method will standby OS of the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub standby_guest {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with( params => \@_, );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_standby_guest', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub standby_guest

sub _standby_guest {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    $target_vm->StandbyGuest();
    $Log->exit() if $may_exit;
    return;
} ## end sub _standby_guest

=head2 register_vm

  my $register  = NACL::C::ESX::VirtualMachine->register_vm(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        path              => $path);

(Class method) This method will register the Virtual machine on the folder.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< vm_name => $vm_name >>

(optional) Name of the virtual machine to register.

=item C<< path => $path >>

(Required) A datastore path to the virtual machine.

=item C<< asTemplate => boolean >>

(Required) Flag to specify whether or not the virtual machine should be marked
as a template.

=item C<< host => Host System Object >>

(Optional) The target host on which the virtual machine will run.
This parameter must specify a host that is a member of the ComputeResource
indirectly specified by the pool. For a stand-alone host or a cluster with DRS,
the parameter can be omitted, and the system selects a default.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub register_vm {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params          => \@_,
        additional_spec => {
            vm_name    => { type => SCALAR, optional => 1, },
            path       => { type => SCALAR, },
            asTemplate => { type => BOOLEAN, },
        },
        allow_extra => 1,
    );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_register_vm', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub register_vm

sub _register_vm {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_options = [qw( path name asTemplate pool host )];
    my $datacenter      = $command_interface->datacenter();
    my $folder_view = $apiset->get_view( mo_ref => $datacenter->vmFolder() );
    my $host_view   = $command_interface->hostsystem();

    my $pool = $command_interface->cluster_compute_resource();
    if ( !$pool ) {
        $pool = $apiset->get_view( mo_ref => $host_view->parent );
    }
    $pool = $pool->get_raw_output();
    $opts{'pool'} = $pool->resourcePool();

    my %args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );
    if ( !$folder_view ) {
        $Log->exit() if $may_exit;
        NATE::BaseException->throw("No Folder view retreived");
    }
    my $folder_obj = $folder_view->{parsed_output};
    $args{'name'} = $opts{'vm_name'};
    my $result = $folder_obj->RegisterVM_Task(%args);
    my $task_obj = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
        task_obj          => $task_obj,
    );
} ## end sub _register_vm

=head2 unregister_vm

  my $control  = NACL::C::ESX::VirtualMachine->unregister_vm(
                                        command_interface => $ci, );

(Class method) This method will reboot OS of the Virtual machine.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub unregister_vm {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params      => \@_,
        allow_extra => 1,
    );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_unregister_vm', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub unregister_vm

sub _unregister_vm {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $vmName            = delete $opts{vm_name};

    my $vms = $command_interface->virtualmachines();
    my $target_vm = _find_target_vm( $vmName, $vms );
    $target_vm->UnregisterVM();
    $Log->exit() if $may_exit;
    return;
} ## end sub _unregister_vm

=head2 migrate_within_host

  my $register  = NACL::C::ESX::VirtualMachine->migrate_within_host(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        priority          => $priority);

(Class method) This method will migrate the Virtual machine within
the same host.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< vm_name => $vm_name >>

(optional) Name of the virtual machine to register.

=item C<< priority => $priority >>

(Required) The task priority to be used.

=item C<< pool => $pool >>

(optional) The target resource pool for the virtual machine.
If the pool parameter is left unset, the virtual machine's current pool
is used as the target pool.

=item C<< state => $state >>

(optional) If specified, the virtual machine migrates only if its state
matches the specified state.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub migrate_within_host {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params          => \@_,
        additional_spec => {
            vm_name  => { type => SCALAR, },
            priority => { type => SCALAR, },
            state    => { type => SCALAR, optional => 1 },
            pool     => { type => SCALAR, optional => 1 },
        },
        allow_extra => 1,
    );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_migrate_within_host', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub migrate_within_host

sub _migrate_within_host {
    $Log->enter() if $may_enter;
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_options = [qw( priority state pool host )];
    my $vms             = $command_interface->virtualmachines();
    my $target_vm       = _find_target_vm( $opts{'vm_name'}, $vms );
    my $host = $apiset->get_view( mo_ref => $target_vm->runtime->host );
    my %args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );

    if ( $opts{'pool'} ) {
        my $pool_mo_ref = $apiset->find_entity_view(
            view_type => 'ResourcePool',
            filter    => { name => $opts{'pool'} }
        );
        $args{'pool'} = $pool_mo_ref;
    }
    $args{'host'} = $host;
    my $result = $target_vm->MigrateVM_Task(%args);
    my $task_obj = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
        task_obj          => $task_obj,
    );
} ## end sub _migrate_within_host

=head2 migrate_another_host

  my $control  = NACL::C::ESX::VMRegister->migrate_another_host(
                                        command_interface => $source_ci,
                                        vm_name           => $vm_name,
                                        host              => $target_host_name,
                                        priority          => $priority);

(Class method) This method will migrate the Virtual machine to another host.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>
This is the command interface to the vcenter where the target and destination
host are present

=item C<< vm_name => $vm_name >>

(optional) Name of the virtual machine to register.

=item C<< priority => $priority >>

(Required) The task priority to be used.

=item C<< pool => $pool >>

(optional) The target resource pool for the virtual machine.
If the pool parameter is left unset, the virtual machine's current pool
is used as the target pool.

=item C<< host => $host >>

The target host to which the virtual machine is intended to migrate.
The host parameter may be left unset if the compute resource associated
with the target pool represents a stand-alone host or a DRS-enabled cluster.
In the former case the stand-alone host is used as the target host.
In the latter case, the DRS system selects an appropriate target host
from the cluster.

=item C<< state => $state >>

(optional) If specified, the virtual machine migrates only if its state
matches the specified state.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>=back

=back

=back

=cut

sub migrate_another_host {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        ## Fix for burt 1088589.The host param can be a SCALAR and we can obtain
	## the host view of destination host by invoking find_enitity_view
        params          => \@_,
        additional_spec => {
            vm_name  => { type => SCALAR, },
            priority => { type => SCALAR, },
            state    => { type => SCALAR, optional => 1 },
            pool     => { type => SCALAR, optional => 1 },
            host     => { type => SCALAR, optional => 1 },
        },
        allow_extra => 1,
    );
    my $ret = $pkg->call_on_apiset( %opts,
        choices => [ { method => '_migrate_another_host', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub migrate_another_host

sub _migrate_another_host {
    my $pkg               = shift;
    my %opts              = $pkg->_validate_backend_opts(@_);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_options = [qw( priority state pool host )];
    my $src_vms         = $command_interface->virtualmachines();
    my $src_vm          = _find_target_vm( $opts{'vm_name'}, $src_vms );
    my ( $tgt_vms, $tgt_vm, $host );
    $host = $opts{'host'};
    my %args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );
    ## Fix for burt 1088559. We can obtain host view of destination host
    ## by invoking find_entity_view using vcenter apiset and passing the
    ## raw output to MigrateVM_Task
    if ($host) {
        my $host_view = $command_interface->apiset()->find_entity_view(
            view_type => 'HostSystem',
	    filter    => { name => $opts{'host'} }
        );
        $args{'host'} = $host_view->get_raw_output();
    }

    if ( $opts{'pool'} ) {
        my $pool_mo_ref = $apiset->find_entity_view(
            view_type => 'ResourcePool',
            filter    => { name => $opts{'pool'} }
        );
        $args{'pool'} = $pool_mo_ref;
    }

    my $result = $src_vm->MigrateVM_Task(%args);
    my $task_obj = _get_task_object( $apiset, $command_interface, $result );
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
        task_obj          => $task_obj,
    );
} ## end sub _migrate_another_host

sub _primary_keys_validate_spec {
    return ( vm_name => { type => SCALAR }, );
}

sub _find_target_vm {
    my ( $name, $vms ) = @_;
    foreach my $vm ( @{$vms} ) {
        my $configs = $vm->summary->config;
	if($vm->config){
            if ( $vm->config->name =~ /$name/ ) {
                return $vm;
            }
	}
    }
} ## end sub _find_target_vm

sub _get_task_object {
    $Log->enter() if $may_enter;
    my ( $apiset, $command_interface, $result ) = @_;
    my $response_for_task = $apiset->get_view( mo_ref => $result );
    my $task              = $response_for_task->get_raw_output();
    my $task_obj          = NACL::C::ESX::Task->new(
        'command_interface' => $command_interface,
        'key'               => $task->info()->key()
    );
    $task_obj->info( $task->info() );
    $Log->exit() if $may_exit;
    return $task_obj;
} ## end sub _get_task_object
1;
