# $Id: //depot/prod/test/nacldev/lib/NACL/C/ESX/VmkNIC.pm#1 $

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware End User License Agreement

# VMware, Inc. (VMware) provides the vSphere Command-Line Interface (vSphere CLI) 
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively 
# the Software) to you subject to the following terms and conditions.  If you 
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation, 
# sample utility applications and sample code regarding programming interfaces to one or 
# more VMware products as referenced in such materials (VMware Products).  This Software 
# is intended to be used to execute supplied commands and utility applications and to 
# create scripts that interact with the VMware Products. 

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a 
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (Developer Software).  For
# vSphere SDK for Perl, some code may be designated as distributable code and/or
# modifiable code at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as distributable code and/ or modifiable code at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the distributable code with your Developer Software.  Any merged portion of any 
# distributable code is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the modifiable code.  You are permitted to
# re-distribute the distributable code and the modified or derivative works of the 
# modifiable code only as part of your Developer Software for non-commercial or commercial 
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.  

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMwares sole discretion, to provide alternatives that reduce any adverse impact on VMwares
# intellectual property or other rights.  

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMwares name, trademarks or service marks in your Developer Softwares
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com. 

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.  

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement. 

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARES LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys fees), arising from your
# modification or derivative works of the modifiable code, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary ESX/VmkNIC Component Module
## @author bkprasha@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::ESX::VmkNIC

=head1 DESCRIPTION

C<NACL::C::ESX::VmkNIC> is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>.  It represents access
to the VMKernel NIC in the NetworkSystem managed object reference 
of an ESX Server.  

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 portgroup_name

Name of the port group to set as connection point.

=cut

package NACL::C::ESX::VmkNIC;

use strict;
use warnings;
use Params::Validate qw(validate_with validate SCALAR );
use NATE::BaseException qw(:try);
use Data::Dumper;

# use NACL::CS::ESX::VmkNIC;
use NACL::ComponentUtils qw(_optional_scalars Dumper);
use base 'NACL::C::Component';
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $vmknic_obj = NACL::C::ESX::VmkNIC->new(command_interface=>$ci,
                                          portgroup_name => $portgroup_name,
                                          );

Return a new ESX::VmkNIC component object with the given attributes.

=cut

use Class::MethodMaker [
    new    => [ '-hash', '-init', 'new' ],
    scalar => 'portgroup_name',
    scalar => [ { -type => 'NACL::C::ESX::ESXHost' }, 'command_interface', ],
];

=head2 add

  NACL::C::ESX::VmkNIC->add(
				command_interface=>$ci,
				portgroup_name =>$portgroup_name,
				ip_address => $ip_address,
				netmask => $netmask
			);
									  
  $vmknic_obj->add(
				ip_address => $ip_address,
				netmask => $netmask
			);

(Class or Instance method) Request addition of a new VmkNIC element, and  return a new
VmkNIC component object that refers to it. 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required) Name of the port group to set as connection point.

=item C<< ip_address=>$string >>

(Required) The IP address for this VMkernel NIC where IP address can be: 
             <X.X.X.X>      - to use static IPv4 address specified
             DHCP           - to enable IPv4 DHCP for address
             <X:X:X::/X>    - to use static IPv6 address (valid for vSphere 4.0 and later)
             DHCPV6         - to enable IPv6 DHCP for address (valid for vSphere 4.0 and later)
             AUTOCONF       - to enable IPv6 Router advertised address (valid for vSphere 4.0 and later)

=item C<< netmask=> $string >>

(Required) The IP netmask for this VMkernel NIC			 

=back

=back

=cut

sub add {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            ip_address => { type => SCALAR },
            netmask    => { type => SCALAR },
        },
    );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
        choices => [ { method => '_add_vmknic', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 delete

  NACL::C::ESX::VmkNIC->delete(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request deletion of VMkernel NIC on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which the VMkernel NIC is to be deleted

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
        choices => [ { method => '_delete_vmknic', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 enable_vmotion

  NACL::C::ESX::VmkNIC->enable_vmotion(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request vmotion enable on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which vmotion is to be enabled

=back

=back

=cut

sub enable_vmotion {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
		nic_type => 'vmotion',
		enable => 1,
        choices => [ { method => '_enable_or_disable_vnic_for_nictype', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 disable_vmotion

  NACL::C::ESX::VmkNIC->disable_vmotion(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request vmotion disable on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which vmotion is to be disabled

=back

=back

=cut


sub disable_vmotion {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
		nic_type => 'vmotion',
		enable => 0,
        choices => [ { method => '_enable_or_disable_vnic_for_nictype', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 enable_ft

  NACL::C::ESX::VmkNIC->enable_ft(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request fault tolerance logging enable on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which fault tolerance logging is to be enabled

=back

=back

=cut


sub enable_ft {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
		nic_type => 'faultToleranceLogging',
		enable => 1,
        choices => [ { method => '_enable_or_disable_vnic_for_nictype', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 disable_ft

  NACL::C::ESX::VmkNIC->disable_ft(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request fault tolerance logging disable on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which fault tolerance logging is to be disabled

=back

=back

=cut


sub disable_ft {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
		nic_type => 'faultToleranceLogging',
		enable => 0,
        choices => [ { method => '_enable_or_disable_vnic_for_nictype', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 enable_mgmt

  NACL::C::ESX::VmkNIC->enable_mgmt(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request management enable on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which management is to be enabled

=back

=back

=cut


sub enable_mgmt {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
		nic_type => 'management',
		enable => 1,
        choices => [ { method => '_enable_or_disable_vnic_for_nictype', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

=head2 disable_mgmt

  NACL::C::ESX::VmkNIC->disable_mgmt(
					command_interface=>$ci,
					portgroup_name =>$portgroup_name,
				);
									  
  $vmknic_obj->delete();

(Class or Instance method) Request management disable on the given portgroup 

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< portgroup_name=> $string >>

(Required)Name of the Portgroup on which management is to be disabled

=back

=back

=cut

sub disable_mgmt {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args, );

    my $ret =
      $pkg_or_obj->call_on_apiset( %opts,
		nic_type => 'management',
		enable => 0,
        choices => [ { method => '_enable_or_disable_vnic_for_nictype', }, ], );

    $Log->exit() if $may_exit;
    return $ret;
}

sub _add_vmknic {
    $Log->enter() if $may_enter;
    my ($pkg, @args)      = @_;
    my %opts              = $pkg->_validate_backend_opts(@args);
	my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();
    my $pg                = $opts{portgroup_name};
    my $ip                = $opts{ip_address};
    my $netmask           = $opts{netmask};
    my $ipV6Config;
    my $ip_config;
    my $dhcp = _is_dhcp($ip);
    my $v4   = _is_v4($ip);
    my $vnic = _find_vnic( $networksystem, $pg );

    if ($vnic) {
        $ip_config = $vnic->spec->ip;
    }
    else {
        $ip_config = HostIpConfig->new(
            dhcp       => 0,
            ipV6Config => HostIpConfigIpV6AddressConfiguration->new(
                dhcpV6Enabled            => 0,
                autoConfigurationEnabled => 0,
                ipV6Address              => []
            )
        );
    }

    if ($dhcp) {
        if ($v4) {
            $ip_config = HostIpConfig->new( dhcp => $dhcp );
        }
        else {
            $ip_config->ipV6Config(
                HostIpConfigIpV6AddressConfiguration->new( ipV6Address => [] )
            );
            if ($ip) {
                $ip_config->ipV6Config->dhcpV6Enabled(1);
            }
        }
    }
    else {
        if ($v4) {
            if ($ip) {
                $ip_config = HostIpConfig->new(
                    dhcp       => $dhcp,
                    ipAddress  => $ip,
                    subnetMask => $netmask
                );
            }
        }
        else {
            my ( $address, $length );

            if ( $ip && $ip ne "AUTOCONF" ) {
                ( $address, $length ) = _parse_v6Address($ip);
                my $ipV6Address = HostIpConfigIpV6Address->new(
                    ipAddress    => $address,
                    prefixLength => $length,
                    operation    => "add"
                );
                $ipV6Config =
                  HostIpConfigIpV6AddressConfiguration->new(
                    ipV6Address => [$ipV6Address] );
                $ip_config->ipV6Config($ipV6Config);
            }
        }
    }

    if ( $ip && $ip =~ /autoconf/i ) {
        $ip_config->ipV6Config(
            HostIpConfigIpV6AddressConfiguration->new( ipV6Address => [] ) );
        $ip_config->ipV6Config->autoConfigurationEnabled(1);
    }

    my $vnic_spec = HostVirtualNicSpec->new( ip => $ip_config );

    $networksystem->AddVirtualNic(
        portgroup => $pg,
        nic       => $vnic_spec
    );

    $Log->exit() if $may_exit;

    return $pkg->new(
        portgroup_name    => $opts{'portgroup_name'},
        command_interface => $command_interface
    );
}

sub _delete_vmknic {
    $Log->enter() if $may_enter;
    my ($pkg, @args)      = @_;
    my %opts              = $pkg->_validate_backend_opts(@args);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};
    my $networksystem     = $command_interface->networksystem();
    my $pg                = $opts{portgroup_name};

    my $vnic = _find_vnic( $networksystem, $pg );
    $networksystem->RemoveVirtualNic( device => $vnic->device );
    $Log->exit() if $may_exit;
}

sub _enable_or_disable_vnic_for_nictype{
	$Log->enter() if $may_enter;
    my ($pkg, @args)      = @_;
	my %opts = validate_with(
		params => \@args,
		spec   => {
			%{$pkg->_backend_validate_spec()},
			enable   => { type => SCALAR },
			nic_type => { type => SCALAR }
		},
		allow_extra => 1
	);
	
    my $command_interface 	= delete $opts{command_interface};
    my $apiset            	= delete $opts{apiset};
    my $networksystem     	= $command_interface->networksystem();
	my $virtual_nic_manager = $command_interface->virtualnicmanager();
    my $pg                	= $opts{portgroup_name};
	my $nic_type			= $opts{nic_type};
	my $enable				= $opts{enable};
	
    my $vnic = _find_vnic( $networksystem, $pg );
    
	if ($enable) {
	   $virtual_nic_manager->SelectVnicForNicType(nicType => $nic_type,
								  device => $vnic->device);
	} else {
	   $virtual_nic_manager->DeselectVnicForNicType(nicType => $nic_type,
									device => $vnic->device);
	}
	
    $Log->exit() if $may_exit;
}

sub _find_vnic {
    my ( $ns, $pg ) = @_;
    if ( defined( $ns->networkInfo ) ) {
        my $vnics = $ns->networkInfo->vnic;
        my $vnic;

        foreach $vnic (@$vnics) {
            if ( $vnic->portgroup && $pg eq $vnic->portgroup ) {
                return $vnic;
            }
        }
    }
    else {
        return undef;
    }
}

sub _is_dhcp {
    $Log->enter() if $may_enter;
    my ($ip) = @_;
    my $dhcp = 0;

    if ( $ip && $ip =~ /dhcp/i ) {
        $dhcp = 1;
    }
    $Log->exit() if $may_exit;
    return $dhcp;
}

sub _is_v4 {
    $Log->enter() if $may_enter;
    my ($ip) = @_;
    my $v4 = 0;

    if ( $ip && ( $ip =~ /^\d+(?:\.\d+){3}$/ || $ip eq "DHCP" || $ip eq "V4" ) )
    {
        $v4 = 1;
    }
    $Log->exit() if $may_exit;
    return $v4;
}

sub _parse_v6Address {
    $Log->enter() if $may_enter;
    my ($ip)    = @_;
    my $address = undef;
    my $length  = undef;

    if ( $ip && $ip =~ /(.*)\/(.*)/ ) {
        $address = $1;
        $length  = $2;
    }
    $Log->exit() if $may_exit;
    return ( $address, $length );
}

sub _primary_keys_validate_spec {
    return (
        portgroup_name => { type => SCALAR },

    );
}

1;
