#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception for, when an attempt is made to operate on application element
## which is non-existent.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Application::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when a attempt is made to perform an operation on a application element
which already exists .

=cut

package NACL::C::Exceptions::Application::AlreadyExists;

use Tharn qw();
use NATE::Log qw(log_global);
my $Log = log_global();
$may_enter = $Log->may_enter();
$may_exit  = $Log->may_exit();
use base qw(
    NACL::C::Exceptions::AlreadyExists
);
1;
