#
# Copyright (c) 2016 NetApp Inc.
# All rights reserved.
#
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Client::FileDirOps::ReadTestFailed

=head1 DESCRIPTION

This exception is thrown when we attempt to read a file or directory which dont have read access
or is not present

=head1 EXAMPLE

   use NACL::C::Exceptions::Client::FileDirOps::ReadTestFailed qw(:try);

   try {
       NACL::C::Client::FileDirOps->read_test(
           command_interface  =>  $Client,
           path           =>  $path);
   } catch NACL::C::Exceptions::Client::FileDirOps::ReadTestFailed {
        # Read Test Failed
   };

=cut

package NACL::C::Exceptions::Client::FileDirOps::ReadTestFailed;
use Tharn qw($Log);
use base qw(
    NACL::C::Exceptions::Component
    NACL::APISet::Exceptions::ResponseException
);

1;
