#
# Copyright (c) 2016 NetApp Inc.
# All rights reserved.
#
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Client::FileDirOps::WriteTestFailed

=head1 DESCRIPTION

This exception is thrown when we attempt to write to a dir or file which dont have write access

=head1 EXAMPLE

   use NACL::C::Exceptions::Client::FileDirOps::WriteTestFailed qw(:try);

   try {
       NACL::C::Client::FileDirOps->write_test(
           command_interface  =>  $Client,
           path           =>  $path);
   } catch NACL::C::Exceptions::Client::FileDirOps::WriteTestFailed {
        # Write Test Failed
   };

=cut

package NACL::C::Exceptions::Client::FileDirOps::WriteTestFailed;
use Tharn qw($Log);
use base qw(
    NACL::C::Exceptions::Component
    NACL::APISet::Exceptions::ResponseException
);

1;
