# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/DFM/Alarm/DoesNotExist.pm$
#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when a Alarm destroy operation is performed on an
##          alarm that does not exist.
##
## @author ramyar@netapp.com, dl-mpo-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::DFM::Alarm::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when alarm destroy operation is performed on a
alarm that does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::DFM::Alarm::DoesNotExist qw(:try);

   try {
       $non_existing_alarm_obj->destroy();
   } catch NACL::C::Exceptions::DFM::Alarm::DoesNotExist with {
        # Alarm does not exist
   };

=cut

package NACL::C::Exceptions::DFM::Alarm::DoesNotExist;

use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::APISet::Exceptions::InvalidParamValueException
);

1;
