# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Lun/AlreadyExists.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception is thrown when a Lun of the same name already exists
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Lun::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a lun which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::Lun::AlreadyExists qw(:try);

   try {
       NACL::C::Lun->create(path => $already_existing_lunpath, %other_opts);
   } catch NACL::C::Exceptions::Lun::AlreadyExists with {
        # Lun already exists.
   };

=cut

package NACL::C::Exceptions::Lun::AlreadyExists;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::AlreadyExists
);
sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my $detected = $pkg->_detect_helper(
        @args,
	#First regex is for CMode
        regexes => [ qr/exists at the/i, qr/already exists at/i,]
    );
    $Log->exit() if $may_exit;
    return $detected;
}

1;
