# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/LunPortSet/DoesNotExist.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for LunPortSet
##
## @author kathar@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::LunPortset::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete an igroup
when entry does not exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::LunPortSet::DoesNotExist qw(:try);

   try {
       NACL::C::LunPortSet->delete(
           command_interface => $Node,
           volume            => $Volume,
           igroup            => $LunPortSet,
           %other_opts);
   } catch NACL::C::Exceptions::LunPortSet::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::LunPortset::DoesNotExist;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw( NACL::C::Exceptions::DoesNotExist);
sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [ qr/Cannot\sfind\sportset/,
                     qr/entry\sdoesn't\sexist/ ]
    );
    $Log->exit() if $may_exit;
    return $detected;
}

1;
