#
# Copyright (c) 2009-2014 NetApp Inc.
# All rights reserved.
#
## @summary This exception gets thrown if the operation performed on the local
##          cluster does not get replicated on the MCC remote cluster.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::MCCVerificationFailed

=head1 DESCRIPTION

This exception is thrown iif the operation performed on the local
cluster does not get replicated on the MCC remote cluster.

=head1 EXAMPLE

   use NACL::C::Exceptions::MCCVerificationFailed qw(:try);

   try {
	   NACL::C::Volume->create(..., nacltask_to_check_mcc => 1);
   } catch NACL::C::Exceptions::MCCVerificationFailed with {
        my $exception = shift;
        my %primary_keys = $exception->primary_keys();
        my $ci           = $exception->command_interface();
   };

=cut

package NACL::C::Exceptions::MCCVerificationFailed;
use base 'NATE::BaseException';
use Class::MethodMaker [
    hash   => 'primary_keys',
    scalar => [
        {-type => 'NACL::C::CommandInterface::ONTAP'},
        'command_interface',
    ],
];
1;
