# Copyright (c) 2012-2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for NetworkRoutingGroupsRoute
##
## @author dl-nacl-dev
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::NetworkRoutingGroupsRoute::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a network routing group which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::NetworkRoutingGroupsRoute:::AlreadyExists qw(:try);

   try {
       NACL::C::NetworkRoutingGroupsRoute->create(
           command_interface  => $Node,
           vserver            => $Vserver,
           %other_opts);
   } catch NACL::C::Exceptions::NetworkRoutingGroupsRoute::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::NetworkRoutingGroupsRoute::AlreadyExists;
use base 'NACL::C::Exceptions::AlreadyExists';
1;
