# Copyright (c) 2013 NetApp Inc.
# All rights reserved.
#
## @summary A base class for the NotInMCCConfig exceptions
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::NotInMCCConfig

=head1 DESCRIPTION

This is an abstract base class for the exceptions that get thrown
when we attempt to check the MCC configuration for the filer or node.

=head1 EXAMPLE

   use NACL::C::Exceptions::NotInMCCConfig qw(:try);

   try {
       $node = NACL::C::Node->find();
       $node->get_remote_interface_mcc();
   } catch NACL::C::Exceptions::NotInMCCConfig with {
        # MCC is not configured
   };

=cut

package NACL::C::Exceptions::NotInMCCConfig;
use base 'NATE::BaseException';

1;
