# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Snapmirror/ServiceNotEnabledOnSource.pm
#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when service is not enabled on the source.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Snapmirror::ServiceNotEnabledOnSource

=head1 DESCRIPTION

This exception is thrown when service is not enabled on source.

=head1 EXAMPLE

   use NACL::C::Exceptions::Snapmirror::ServiceNotEnabledOnSource qw(:try);

   try {
       NACL::C::Snapmirror->create(
           command_interface  => $Node,
           'destination-path'       => $Path,
           %other_opts);
   } catch NACL::C::Exceptions::Snapmirror::ServiceNotEnabledOnSource with {
        # service is not enabled on source
   };

=cut

package NACL::C::Exceptions::Snapmirror::ServiceNotEnabledOnSource;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [qr/service\s+not\s+enabled\s+on\s+the\s+source/,]
    );
    $Log->exit();
    return $detected;
}
1;
