# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/Snapmirror/TransferFromSourceNotPossible.pm
#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when snapmirror transfer not possible snapmirror may be misconfigured
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::Snapmirror::TransferFromSourceNotPossible

=head1 DESCRIPTION

This exception is thrown when snapmirror transfer not possible snapmirror may be misconfigured

=head1 EXAMPLE

   use NACL::C::Exceptions::Snapmirror::TransferFromSourceNotPossible qw(:try);

   try {
        NACL::C::Snapmirror->create(
            command_interface  =>  $command_interface,
            'source-path'      =>  $source_specification,
            %other_options
        );
   } catch NACL::C::Exceptions::Snapmirror::TransferFromSourceNotPossible with {
        # transfer from source not possible snapmirror may be misconfigured
   };

=cut

package NACL::C::Exceptions::Snapmirror::TransferFromSourceNotPossible;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw(
    NACL::APISet::Exceptions::CommandFailedException
    NACL::C::Exceptions::Component
);

sub detect {
    $Log->enter();
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [
	   qr/transfer\s+from\s+source\s+not\s+possible\;\s+snapmirror\s+may\s+be\s+misconfigured/
	]
    );
    $Log->exit();
    return $detected;
}
1;
