#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary An exception for when we attempt to modify the attributes of an
##          aggregate to a state the aggregate is already in.
##
## @author madhavs@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::StorageAggregate::AlreadyModified;

=head1 DESCRIPTION

This exception is thrown when we attempt to modify the attributes of an aggregate
to a state the aggregate is already in.

=head1 EXAMPLE

   use NACL::C::Exceptions::StorageAggregate::AlreadyModified; qw(:try);

   try {
       $offline_aggr_obj->modify(state => 'offline');
   } catch NACL::C::Exceptions::StorageAggregate::AlreadyModified with {
        # Already offline
   };

=cut

package NACL::C::Exceptions::StorageAggregate::AlreadyModified;

use base qw(
	NACL::APISet::Exceptions::CommandFailedException
	NACL::C::Exceptions::Component
);

1;
