#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary An exception for  the state of the aggregagte (i.e. busy)
##          This is mainly observerd when the aggregate is already
##          online but dynamically growing. In this state of an aggregate no modification
##          to the aggregate is allowed.
##
## @author chethanm@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::StorageAggregate::CurrentlyBusy;

=head1 DESCRIPTION

This exception is thrown when the aggregate is found to be in dynamic growth state or busy.

=head1 EXAMPLE

   use NACL::C::Exceptions::StorageAggregate::CurrentlyBusy; qw(:try);

   try {
       $offline_aggr_obj->modify(state => 'offline');
   } catch NACL::C::Exceptions::StorageAggregate::CurrentlyBusy with {
        # Aggregate is busy, hence can't modify the state to offline
   };

=cut

package NACL::C::Exceptions::StorageAggregate::CurrentlyBusy;

use base qw(
	NACL::APISet::Exceptions::CommandFailedException
        NACL::C::Exceptions::Component
);

1;
