#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception can be thrown during software image upgrade.
##          relationship.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::SystemNodeImage::Update64BitAggr

=head1 DESCRIPTION

This exception is thrown when an attempt is made to upgrade software image.

=head1 EXAMPLE

   use NACL::C::Exceptions::SystemNodeImage::Update64BitAggr;

   try {
       NACL::C::SystemNodeImage->update(%opts);
   } catch NACL::C::Exceptions::SystemNodeImage::Update64BitAggr with {};

=cut

package NACL::C::Exceptions::SystemNodeImage::Update64BitAggr;

use base qw(
    NACL::C::Exceptions::Component
    NACL::APISet::Exceptions::CommandFailedException
);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

sub detect {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $detected = $pkg->_detect_helper(
        @args,
        regexes => [
            qr/format_32bit: Update 64bit aggregate default settings for releases earlier than Data ONTAP \S+ using the "storage aggregate 64bit-upgrade prepare-to-downgrade"/i
        ],
    );
    $Log->exit() if $may_exit;
    return $detected;
} ## end sub detect
1;
