# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VolumeQuotaPolicy
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VolumeQuotaPolicy::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a quota policy which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VolumeQuotaPolicy::AlreadyExists qw(:try);

   try {
       $policy = NACL::C::VolumeQuotaPolicy->create(
                command_interface => $command_interface,
                'vserver'   => $vserver,
                'policy-name'    => $policy,
                 %other_opts);
   } catch NACL::C::Exceptions::VolumeQuotaPolicy::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VolumeQuotaPolicy::AlreadyExists;
use base 'NACL::C::Exceptions::AlreadyExists';
1;
