#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VolumeQuotaPolicy
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VolumeQuotaPolicy::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when an attempt is made to delete a 
non-existent quota policy

=head1 EXAMPLE

   use NACL::C::Exceptions::VolumeQuotaPolicy::DoesNotExist qw(:try);

   try {
       NACL::C::VolumeQuotaPolicy->delete(
           command_interface => $Node,
           vserver           => $vserver,
           'policy-name'     => $policy,
           %other_opts);
   } catch NACL::C::Exceptions::VolumeQuotaPolicy::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VolumeQuotaPolicy::DoesNotExist;
use base qw(NACL::C::Exceptions::DoesNotExist);
1;
