# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for Cifs ShareAccessControl
##
## @author ng-ptefit-automation-core
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions:VserverCifsShareAccessControl:::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a ShareAccessControl which already
exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsShareAccessControl::AlreadyExists qw(:try);

   try {
       $sched = NACL::C::VserverCifsShareAccessControl->create(
                command_interface => $Filer_Dst,
                'vserver' => $vsever,
                'share' => $cifs_share,
                'user-or-group' => $name,
                permission => $permission,
                 %other_opts);
   } catch NACL::C::Exceptions::VserverCifsShareAccessControl::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverCifsShareAccessControl::AlreadyExists;

use base 'NACL::C::Exceptions::AlreadyExists';
1;
