# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for
#   VserverCifsUsersAndGroupsLocalGroup member
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberAlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a local cifs group member which
already exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberAlreadyExists qw(:try);

   try {
       $cifs_member = NACL::C::VserverCifsUsersAndGroupsLocalGroup->add_members(
                command_interface => $command_interface,
                'vserver'   => $vserver,
                 %other_opts);
   } catch NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberAlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberAlreadyExists;
use base 'NACL::C::Exceptions::AlreadyExists';
1;
