#
# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VserverCifsUsersAndGroupsLocalGroup member
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberDoesNotExist

=head1 DESCRIPTION

This exception is thrown when an attempt is made to delete a 
non-existent local cifs Group member

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberDoesNotExist qw(:try);

   try {
       NACL::C::VserverCifsUsersAndGroupsLocalGroup->remove_members(
           command_interface => $Node,
           vserver           => $vserver,
           %other_opts);
   } catch NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberDoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalGroup::MemberDoesNotExist;
use base qw(NACL::C::Exceptions::DoesNotExist);

1;
