# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for
#   VserverCifsUsersAndGroupsLocalUser
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalUser::AlreadyExists

=head1 DESCRIPTION

This exception is thrown when we attempt to create a local cifs user which
already exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalUser::AlreadyExists qw(:try);

   try {
       $cifs_user = NACL::C::VserverCifsUsersAndGroupsLocalUser->create(
                command_interface => $command_interface,
                'vserver'   => $vserver,
                 %other_opts);
   } catch NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalUser::AlreadyExists with {
        # Duplicate entry exists
   };

=cut

package NACL::C::Exceptions::VserverCifsUsersAndGroupsLocalUser::AlreadyExists;
use base 'NACL::C::Exceptions::AlreadyExists';
1;
