# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicyEvent/DoesNotExist.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a duplicate entry for VserverFpolicyPolicyEvent
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicyEvent::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete an Vserver Fpolicy Policy Event
when entry does not exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicyEvent::DoesNotExist qw(:try);

   try {
    NACL::C::VserverFpolicyPolicyEvent->delete(
                command_interface => $ci,
                vserver           => $vserver,
    );
   } catch NACL::C::Exceptions::VserverFpolicyPolicyEvent::DoesNotExist with {
        # entry doesn't exist
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicyEvent::DoesNotExist;
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::DoesNotExist';
1;
