# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverFpolicyPolicyScope/DoesNotExist.pm#1 $
#
# Copyright (c) 2009-2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when there is a entry does not exist for VserverFpolicyPolicyScope.
##
## @author sshaik@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverFpolicyPolicyScope::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete an Vserver Fpolicy Policy Scope
when entry does not exist.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverFpolicyPolicyScope::DoesNotExist qw(:try);

   try {
       NACL::C::VserverFpolicyPolicyScope->delete(%opts);
   } catch NACL::C::Exceptions::VserverFpolicyPolicyScope::DoesNotExist with {
	# entry doesn't exist
   };

=cut

package NACL::C::Exceptions::VserverFpolicyPolicyScope::DoesNotExist;
use base 'NACL::C::_Mixins::Exceptions::VserverFpolicyPolicy::DoesNotExist';
1;
