# $Id: //depot/prod/test/nacldev/lib/NACL/C/Exceptions/VserverVscanOnAccessPolicy/DoesNotExist.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary An exception when entry doesn't exists for VserverVscanOnAccessPolicy
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::C::Exceptions::VserverVscanOnAccessPolicy::DoesNotExist

=head1 DESCRIPTION

This exception is thrown when we attempt to delete an igroup
when entry does not exists.

=head1 EXAMPLE

   use NACL::C::Exceptions::VserverVscanOnAccessPolicy::DoesNotExist qw(:try);

   try {
       NACL::C::VserverVscanOnAccessPolicy->delete(
           command_interface => $Node,
           volume            => $Volume,
           'policy-name'     => $policy_name,
           %other_opts);
   } catch NACL::C::Exceptions::VserverVscanOnAccessPolicy::DoesNotExist with {
        # Entry Does not exists
   };

=cut

package NACL::C::Exceptions::VserverVscanOnAccessPolicy::DoesNotExist;
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use base qw( NACL::C::Exceptions::DoesNotExist);

1;
