# $Id$
#
# Copyright (c) 2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware End User License Agreement

# VMware, Inc. (VMware) provides the vSphere Command-Line Interface (vSphere CLI)
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively
# the Software) to you subject to the following terms and conditions.  If you
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation,
# sample utility applications and sample code regarding programming interfaces to one or
# more VMware products as referenced in such materials (VMware Products).  This Software
# is intended to be used to execute supplied commands and utility applications and to
# create scripts that interact with the VMware Products.

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (Developer Software).  For
# vSphere SDK for Perl, some code may be designated as distributable code and/or
# modifiable code at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as distributable code and/ or modifiable code at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the distributable code with your Developer Software.  Any merged portion of any
# distributable code is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the modifiable code.  You are permitted to
# re-distribute the distributable code and the modified or derivative works of the
# modifiable code only as part of your Developer Software for non-commercial or commercial
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMwares sole discretion, to provide alternatives that reduce any adverse impact on VMwares
# intellectual property or other rights.

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMwares name, trademarks or service marks in your Developer Softwares
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com.

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement.

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARES LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys fees), arising from your
# modification or derivative works of the modifiable code, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary HyperV/VMSnapshot Component Module
## @author rawat@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::HyperV::VMSnapshot

=head1 DESCRIPTION

C<NACL::C::HyperV::VMSnapshot> is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>.  It is used to create,
delete or to manipulate the snapshot of a virtual machine on an HyperV Server.
A related class isL<NACL::CS::HyperV::VMSnapshot|lib-NACL-CS-HyperV-VMSnapshot-pm>,
which represents the state of Virtual Machine Snapshots on the given HyperV Server.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 name

The name of the virtual machine snapshot to process

=cut

package NACL::C::HyperV::VMSnapshot;

use strict;
use warnings;
use Params::Validate qw(validate_with validate SCALAR BOOLEAN SCALARREF UNDEF);
use NATE::BaseException qw(:try);
use NACL::C::Exceptions::HyperV::VmIsNotASnapshot;
use NACL::APISet;
use NACL::C::HyperV;
use NACL::ComponentUtils qw(_optional_scalars Dumper);
use base 'NACL::C::Component::HyperV';
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $snapshot_obj = NACL::C::HyperV::VMSnapshot->new(command_interface=>$ci,
                                          name => $snapshot_name,
                                          );

Return a new HyperV::VMSnapshot component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'name',
    scalar => 'vmName',
];

=head2 create

  my $snapshot  = NACL::C::HyperV::VMSnapshot->create(command_interface=>$ci,
                                        name =>$snapshot_name );

(Class method) Request addition of a new VMSnapshot element, and  return a new
VMSnapshot component object that refers to it.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< vmName => $Vm_Name >>

(Required) Name of the virtual machine to which the snapshot has to be created.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< name=> $string >>

(Required) Name of the Snapshot.

=item C<< memory=> boolean >>

(Required) If set, it dumps the internal state of the VM.

=item C<< quiesce=> boolean >>

(Required) If set, quiesce the file system in the VM.

=item C<< description=>$description >>

(Optional) Description about the snapshot

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args,
        additional_spec => {
            description => { type => SCALAR, optional => 1 },
            memory      => { type => BOOLEAN },
            quiesce     => { type => BOOLEAN },
            task_object => { type => SCALARREF, optional => 1 },
        },
    );
    my $ret = $pkg_or_obj->call_on_apiset( %opts,
                        choices => [
                            {
                              method => '_create_snapshot_esx',
                              interface => 'VMAPI',
                              set   => 'ESX',
                            },
                            {
                              method => '_create_snapshot_xen',
                              interface => 'XAPI',
                              set   => 'Xen',
                            },
                        ],
                   );

    $Log->exit() if $may_exit;
    return $ret;
}

sub _create_snapshot_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vmName};
    my $task_object       = $opts{task_object};

    my $allowed_options = [
        qw( name description memory quiesce )
    ];

    my %args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );

    my $target_vm = $command_interface->_find_target_vm( vm_name => $vmName );

    my $result = $target_vm->CreateSnapshot_Task(%args);
    if ($task_object) {
        $$task_object = $command_interface->_get_task_object( apiset => $apiset, result => $result );
    }
    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        command_interface => $command_interface,
        vmName           => $vmName,
        name     => $args{'name'},
    );
}

sub _create_snapshot_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vmName};
    my $snapshot_name     = $opts{name};
    my $quiesce           = $opts{quiesce};


    my $target_vm = $command_interface->_get_vm_ref(
                                            vm_name => $vmName,
                                            apiset  => $apiset,
                                        );

    my $req = "VM.snapshot";
    if ($quiesce) {
        $req = "VM.snapshot_with_quiesce";
    }

    $apiset->simple_request($req, $target_vm, $snapshot_name);

    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        command_interface => $command_interface,
        vmName            => $vmName,
        name              => $snapshot_name,
    );
}

=head2 remove

  NACL::C::HyperV::VMSnapshot->remove(command_interface=>$ci,name =>$snapshot_name);

  OR

  $snapshot_obj->remove();

(Class or Instance method) Request deletion of a new VMSnapshot element, and  return a new
VMSnapshot component object that refers to it.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< name => $snapshot >>

(Required for class method) Name of the snapshot to be removed.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< removeChildren=> boolean >>

(Optional) If set, removes the entire snapshot subtree.

Applicable only for ESX VMAPI.

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

Applicable only for ESX VMAPI.

=back

=back

=cut

sub remove {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args,
        additional_spec => {
            removeChildren => { type => BOOLEAN, optional => 1 },
            task_object => { type => SCALARREF, optional => 1 },
        },
    );

    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_remove_snapshot_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
            {
              method => '_remove_snapshot_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _remove_snapshot_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vmName};
    my $snapshot          = $opts{name};
    my $allowed_options   = [ qw( removeChildren ) ];
    my $task_object       = $opts{task_object};

    my %args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );

    my $vm = $command_interface->_find_target_vm( vm_name => $vmName );

    # $count is for future reference to find the duplicate snapshots
    my $count = 0;
    my $ref;
    ($ref, $count) =
        _find_snapshot_name($vm->snapshot->rootSnapshotList, $snapshot);
    if ( $count == 0 ) {
        $Log->exit() if $may_exit;
        NATE::BaseException->throw("No such snapshot exists : ".$snapshot);
    } elsif ( $count > 1  ) {
        $Log->exit() if $may_exit;
        NATE::BaseException->throw("More than one snapshot exists with name");
    }
    my $response_for_snapshot = $apiset->get_view( mo_ref => $ref->snapshot );
    my $target_vm = $response_for_snapshot->get_raw_output();

    my $result = $target_vm->RemoveSnapshot_Task(%args);
    if ($task_object) {
        $$task_object = $command_interface->_get_task_object( apiset => $apiset, result => $result );
    }

    $Log->exit() if $may_exit;
}

sub _remove_snapshot_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $snapshot          = $opts{name};

    my $vm_state = NACL::CS::HyperV::VirtualMachine->fetch(
        command_interface => $command_interface,
        filter            => { vm_name => $snapshot, },
    );
    
    if ($vm_state->isSnapshot() != 1) {
        my $ex = shift;
        NACL::C::Exceptions::HyperV::VmIsNotASnapshot->throw(
            text => "VM passed is not a Snapshot. Can not remove it.",
        );
    }
    
    my $snapshot_vm = $command_interface->_get_vm_ref(
        vm_name => $snapshot,
        apiset  => $apiset,
    );

    my $req = "VM.destroy";
    $apiset->simple_request($req, $snapshot_vm);

    $Log->exit() if $may_exit;
}

sub _find_snapshot_name {
    my ($tree, $name) = @_;
    my $ref = undef;
    my $count = 0;
    foreach my $node (@$tree) {
        if ($node->name eq $name) {
            $ref = $node;
            $count++;
        }
        my ($subRef, $subCount) = _find_snapshot_name($node->childSnapshotList, $name);
        $count = $count + $subCount;
        $ref = $subRef if ($subCount);
    }
    # $count is for future reference to find the duplicate snapshots
    return ($ref, $count);
}

=head2 revert

  NACL::C::HyperV::VMSnapshot->revert(command_interface=>$ci,name =>$snapshot_name);

  OR

  $snapshot_obj->revert();

(Class or Instance method) Reverts a VM to its previous snapshot.

Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< name => $snapshot >>

(Required for class method) Name of the snapshot to be removed.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=back

=back

=cut

sub revert {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with( params => \@args);

    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_revert_snapshot_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _revert_snapshot_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $snapshot          = $opts{name};
    
    my $snapshot_vm = $command_interface->_get_vm_ref(
        vm_name => $snapshot,
        apiset  => $apiset,
    );

    my $req = "VM.revert";
    $apiset->simple_request($req, $snapshot_vm);

    $Log->exit() if $may_exit;
}

sub _primary_keys_validate_spec {
    return ( vmName => { type => SCALAR|UNDEF, optional => 1, },
             name   => { type => SCALAR }, );
} ## end sub _primary_keys_validate_spec

1;
