# $Id$
#
# Copyright (c) 2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
# VMware End User License Agreement

# VMware, Inc. (VMware) provides the vSphere Command-Line Interface (vSphere CLI)
# and/or vSphere Software Development Kit for Perl (vSphere SDK for Perl) (collectively
# the Software) to you subject to the following terms and conditions.  If you
# disagree with any of the following terms, then do not use the Software.

# 1.  The Software contains a variety of materials, interface definitions, documentation,
# sample utility applications and sample code regarding programming interfaces to one or
# more VMware products as referenced in such materials (VMware Products).  This Software
# is intended to be used to execute supplied commands and utility applications and to
# create scripts that interact with the VMware Products.

# 2.  Use Rights:  Subject to the restrictions below, you may download and make a
# reasonable number of copies of the Software contents for your use solely for the purpose
# of creating software that communicates with VMware Products (Developer Software).  For
# vSphere SDK for Perl, some code may be designated as distributable code and/or
# modifiable code at http://www.vmware.com/go/vsdkperl-redistribution-info.  For vSphere
# CLI, some code may be designated as distributable code and/ or modifiable code at
# http://www.vmware.com/go/vcli-redistribution-info.  You may use and merge all or portions
# of the distributable code with your Developer Software.  Any merged portion of any
# distributable code is subject to this Agreement.  Additionally, you may modify or create
# derivative works of all or portions of the modifiable code.  You are permitted to
# re-distribute the distributable code and the modified or derivative works of the
# modifiable code only as part of your Developer Software for non-commercial or commercial
# use. Open source software components provided with the Software are licensed to you under
# the terms of the applicable license agreements included with such open source software
# components.  The open source software licenses can be found in the open_source_licenses.txt
# file, other materials accompanying the Software, the documentation or corresponding source
# files available at http://www.vmware.com/download/vi/open_source.html.

# 3.  Restrictions:  You agree that you will not (1) use the Software to create, design or
# develop anything other than Developer Software; (2) make any more copies of the Software
# than are reasonably necessary for the authorized use and backup and archival purposes;
# (3) modify, create derivative works of, reverse engineer, reverse compile, or disassemble
# the Software, except as expressly permitted in Section 2; (4) distribute, sell, lease, rent,
# lend, or sublicense any part of the Software to any third party except as expressly permitted
# in Section 2 or; (5) use the Software to (a) create, design or develop software or service to
# circumvent, enable, modify or provide access, permissions or rights which would violate the
# technical restrictions of VMware Products, any additional licensing terms provided by VMware
# via product documentation, email notification and/or policy change on VMware website, and/or
# the terms of the End User License Agreements of VMware products; (b) disable, remove, over-ride
# or modify the display of any VMware product End User License Agreements to the end customers;
# and (c) upload or otherwise transmit any material containing software viruses or other computer
# code, files or programs designed to interrupt, destroy, or limit the functionality of any
# software or hardware.

# The restrictions in this Section 3 shall not apply if and to the extent they contradict
# mandatory local law (including, but not limited to, law implementing the EC Software Directive)
# provided that, before you exercise any rights that you believe to be entitled to based on
# mandatory law, you provide VMware with 30 days prior written notice at SDK_Legal@vmware.com and
# provide all reasonably requested information to allow VMware to assess your claim and, at
# VMwares sole discretion, to provide alternatives that reduce any adverse impact on VMwares
# intellectual property or other rights.

# 4.   VMware retains ownership of the Software, including without limitation all copyrights and
# other intellectual property rights therein. You may not remove, delete or modify any of VMware
# copyright statements in the Software.

# 5.  You may not use VMwares name, trademarks or service marks in your Developer Softwares
# names or in a way that suggests your Developer Software is certified or endorsed by VMware. Your
# use of VMware product names and trademarks shall comply with the Branding Guidelines posted at
# www.vmware.com.

# 6.  If you are currently entitled to support from VMware, you may submit a support request
# for installation assistance of this Software and assistance in executing unmodified utility
# applications or vSphere CLI commands provided with this Software.  Except as provided herein,
# you are not entitled to any VMware support for this Software or any other services from VMware
# in connection with this Software or your Developer Software.

# 7.  Term, Termination and Changes: This Agreement shall continue as long as you are in compliance
# with the terms specified herein or until otherwise terminated.  You and or VMware each may
# terminate this Agreement for any reason at any time.  You agree, upon termination, to destroy
# all copies of the Software within your possession or control. The Confidential Information,
# Limitations of Warranties, Liability and Indemnification sections set out in this Agreement
# shall survive any termination or expiration of this Agreement.

# 8.  Limitations of Warranties and Liability:  THE SOFTWARE IS PROVIDED AS IS WITHOUT ANY
# WARRANTIES OF ANY KIND.  TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, VMWARE DISCLAIMS
# ANY IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS.

# TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL VMWARE BE LIABLE FOR ANY
# LOST PROFITS OR BUSINESS OPPORTUNITIES, LOSS OF USE, BUSINESS INTERRUPTION, LOSS OF DATA, OR ANY
# OTHER INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE SOFTWARE OR
# YOUR USE OF THE SOFTWARE, UNDER ANY THEORY OF LIABILITY, WHETHER BASED IN CONTRACT, TORT,
# NEGLIGENCE, PRODUCT LIABILITY, OR OTHERWISE.  BECAUSE SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION
# OR LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE PRECEDING LIMITATION MAY
# NOT APPLY TO YOU.

# VMWARES LIABILITY ARISING OUT OF THE SOFTWARE PROVIDED HEREUNDER WILL NOT, IN ANY EVENT,
# EXCEED US$5.00.

# THE FOREGOING LIMITATIONS SHALL APPLY TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, REGARDLESS
# OF WHETHER VMWARE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES AND REGARDLESS OF WHETHER
# ANY REMEDY FAILS OF ITS ESSENTIAL PURPOSE.

# 9.  Indemnification: You agree to defend, indemnify and hold harmless VMware, and any of its
# directors, officers, employees, affiliates or agents, from and against any and all claims, losses,
# damages, liabilities and other expenses (including reasonable attorneys fees), arising from your
# modification or derivative works of the modifiable code, distribution or use of your Developer
# Software or breach of this Agreement.

# 10.  These terms are governed by the laws of the State of California and the United States of
# America without regard to conflict of laws principles.  You may not assign any part of this Agreement
# without the prior written consent of VMware.  Any attempted assignment without consent shall be void.
# These terms constitute the entire agreement between you and VMware with respect to the Software, and
# supersede all prior written or oral communications, understandings and agreements. Any waiver of these
# terms must be in writing to be effective. If any provision of these terms is found to be invalid or
# unenforceable, the remaining terms will continue to be valid and enforceable to the fullest extent
# permitted by law.

## @summary HyperV/VirtualMachine Component Module
## @author rawat@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::HyperV::VirtualMachine

=head1 DESCRIPTION

C<NACL::C::HyperV::VirtualMachine> is a derived class of
L<NACL::C::Component|lib-NACL-C-Component-pm>.  It represents access
to the Virtual Machine managed object reference of an HyperV Server.
A related class isL<NACL::CS::HyperV::VirtualMachine|lib-NACL-CS-HyperV-VirtualMachine-pm>,
which represents the state of Virtual Machines on the given HyperV Server.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vm_name

The name of the virtual machine , used to identify it uniquely.

=head2 hostName

The name of the host in which the virtual machine is created, used to identify it uniquely.

=head2 ipAddress

The ip address of the virtual machine , used to identify it uniquely.

=cut

package NACL::C::HyperV::VirtualMachine;

use strict;
use warnings;
use Params::Validate qw(validate_with validate SCALAR BOOLEAN SCALARREF HASHREF OBJECT);
use NATE::BaseException qw(:try);

use NACL::CS::HyperV::VirtualMachine;
use NACL::C::HyperV::Task;
use NACL::ComponentUtils qw(_optional_scalars Dumper);
use base 'NACL::C::Component::HyperV';
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use RPC::XML qw(RPC_BOOLEAN RPC_INT RPC_I4 RPC_DOUBLE RPC_STRING);

require VMware::VICommon;
require VMware::VIMRuntime;
require VMware::VIM25Stub;

=head1 METHODS

=head2 new

  my $vm_obj = NACL::C::HyperV::VirtualMachine->new(command_interface=>$ci,
                                                        vm_name => $vm_name,
                                                   );

Return a new HyperV::VirtualMachine component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vm_name',
];

=head2 power_on

  NACL::C::HyperV::VirtualMachine->power_on(
                                       command_interface => $ci,
                                       vm_name           => $vm_name
                                       hyperv            => $hyperv
                                   );

 OR

 $vm_obj->power_on(
          hyperv    => $hyperv
 );

(Class or Instance method) This method will power on the Virtual machine.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< host => $host >>

(optional) Name of the host the virtual machine is associated with.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

=item C<< hyperv=>$hyperv >>

(optional) If passed, VM will be resumed on this host.

=item C<< force=>$boolean >>

(optional) Attempt to force the VM to resume. If this
flag is false then the VM may fail pre-resume
safety checks (e.g. if the CPU the VM was
running on looks substantially different to the
current one)
default to 0.

=item C<< start_paused=>$boolean >>

(optional) Instantiate VM in paused state if set to true.
default to 1.

=back

=back

=cut

sub power_on {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            hyperv          => { type => OBJECT|SCALAR, optional => 1 },
            start_paused    => { type => BOOLEAN, default => 0 },
            force           => { type => BOOLEAN, default => 0 },
            task_object     => { type => SCALARREF, optional => 1 },
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_power_on_vm_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
            {
              method => '_power_on_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub power_on

sub _power_on_vm_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $task_object       = $opts{task_object};

    my $allowed_options = [qw( hyperv )];
    my %args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );


    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $opts{vm_name} );
    my $result = $target_vm->PowerOnVM_Task(%args);

    if ($task_object) {
        $$task_object = $pkg_or_obj->_get_task_object( apiset => $apiset, result => $result );
    }

    $Log->exit() if $may_exit;
} ## end sub _power_on_vm

sub _power_on_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $start_paused = RPC_BOOLEAN($opts{start_paused});
    my $force = RPC_BOOLEAN($opts{force});

    if (defined $opts{hyperv}) {
        my $xenserver = $command_interface->_get_xen_host(
                                            xenserver => $opts{hyperv},
                                            apiset  => $apiset,
                                        );
        $apiset->simple_request("VM.start_on", $vm_ref, $xenserver, $start_paused, $force);
    } else {
        $apiset->simple_request("VM.start", $vm_ref, $start_paused, $force);
    }

    $Log->exit() if $may_exit;
} ## end sub _power_on_vm

=head2 power_off

  my $control  = NACL::C::HyperV::VirtualMachine->power_off(
                                                    command_interface => $ci,
                                                    vm_name           => $vm_name,
                                                  );

  OR

  my $control = $vm_obj->power_off();

(Class or Instance method) This method will power off the Virtual machine.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

=back

=back

=cut

sub power_off {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            task_object     => { type => SCALARREF, optional => 1 },
            hard_shutdown   => { type => BOOLEAN, default => 0 },
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_power_off_vm_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
            {
              method => '_power_off_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub power_off

sub _power_off_vm_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@args);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};
    my $task_object       = $opts{task_object};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    my $result    = $target_vm->PowerOffVM_Task();
    if ($task_object) {
        $$task_object = $pkg_or_obj->_get_task_object( apiset => $apiset, result => $result );
    }

    $Log->exit() if $may_exit;
} ## end sub _power_off_vm

sub _power_off_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $req = "VM.clean_shutdown";
    if ($opts{hard_shutdown}) {
        $req = "VM.hard_shutdown";
    }

    $apiset->simple_request($req, $vm_ref);

    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
    );
} ## end sub _power_off_vm_xen

=head2 suspend

  my $control  = NACL::C::HyperV::VirtualMachine->suspend(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        );

  OR

  $vm->suspend();

(Class or Instance method) This method will suspend the Virtual machine.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

=back

=back

=cut

sub suspend {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            task_object => { type => SCALARREF, optional => 1 },
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_suspend_vm_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
            {
              method => '_suspend_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub suspend

sub _suspend_vm_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};
    my $task_object       = $opts{task_object};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    my $result    = $target_vm->SuspendVM_Task();
    if ($task_object) {
        $$task_object = $pkg_or_obj->_get_task_object( apiset => $apiset, result => $result );
    }

    $Log->exit() if $may_exit;
} ## end sub _suspend_vm

sub _suspend_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $req = "VM.suspend";

    $apiset->simple_request($req, $vm_ref);

    $Log->exit() if $may_exit;
} ## end sub _suspend_vm_xen

=head2 resume

  my $control  = NACL::C::HyperV::VirtualMachine->resume(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        hyperv            => $hyperv,
                                        force             => $force,
                                        start_paused      => $start_paused,
                                    );

  OR

  $vm->resume(
        hyperv          => $hyperv,
        force           => $force,
        start_paused    => $start_paused,
  );

(Class or Instance method) This method will resume the Virtual machine.
By default VM will resume on which it was suspended. If hyperv is passed
then it will resume on $hyperv.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< hyperv=>$hyperv >>

(optional) If passed, VM will be resumed on this hyperv.

=item C<< force=>$boolean >>

(optional) Attempt to force the VM to resume. If this
flag is false then the VM may fail pre-resume
safety checks (e.g. if the CPU the VM was
running on looks substantially different to the
current one)
default to 0.

=item C<< start_paused=>$boolean >>

(optional) Resume VM in paused state if set to true.
default to 1.

=back

=back

=cut

sub resume {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            hyperv          => { type => SCALAR|OBJECT, optional => 1 },
            start_paused    => { type => BOOLEAN, default => 1 },
            force           => { type => BOOLEAN, default => 0 },
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_resume_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub resume

sub _resume_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $start_paused = RPC_BOOLEAN($opts{start_paused});
    my $force = RPC_BOOLEAN($opts{force});
    if (defined $opts{hyperv}) {
        my $xenserver = $command_interface->_get_xen_host(
                                            xenserver => $opts{hyperv},
                                            apiset  => $apiset,
                                        );
        $apiset->simple_request("VM.resume_on", $vm_ref, $xenserver, $start_paused, $force);
    } else {
        $apiset->simple_request("VM.resume", $vm_ref, $start_paused, $force);
    }

    $Log->exit() if $may_exit;
} ## end sub _resume_vm_xen

=head2 pause

  my $control  = NACL::C::HyperV::VirtualMachine->pause(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                    );

  OR

  $vm->pause();

(Class or Instance method) This method will pause the Virtual machine.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub pause {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_pause_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub pause

sub _pause_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                        vm_name => $opts{vm_name},
                                        apiset  => $apiset,
                                    );

    $apiset->simple_request("VM.pause", $vm_ref);

    $Log->exit() if $may_exit;
} ## end sub _pause_vm_xen

=head2 unpause

  my $control  = NACL::C::HyperV::VirtualMachine->unpause(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                    );

  OR

  $vm->unpause();

(Class or Instance method) This method will resume the paused Virtual machine.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub unpause {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
                method => '_unpause_vm_xen',
                interface => 'XAPI',
                set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub unpause

sub _unpause_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    $apiset->simple_request("VM.unpause", $vm_ref);

    $Log->exit() if $may_exit;
} ## end sub _unpause_vm_xen

=head2 migrate

  my $control  = NACL::C::HyperV::VirtualMachine->migrate(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        hyperv            => $hyperv,
                                  );

  OR

  $vm->migrate(hyperv => $hyperv);

(Class or Instance method) This method will migrate the VM to specified host.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< hyperv=>$hyperv >>

(Required) VM will be migrated to this hyperv.

=item C<< extra_config_operations=>$hashref >>

(Optional) Extra configuration operations.

=back

=back

=cut

sub migrate {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            hyperv                  => { type => SCALAR|OBJECT,},
            extra_config_operations => { type => HASHREF, default => {},},
        },
    );
    
    # Call to backend method
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_migrate_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub migrate

sub _migrate_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $extra_config_operations = $opts{extra_config_operations};
    my $xenserver = $command_interface->_get_xen_host(
                                            xenserver => $opts{hyperv},
                                            apiset  => $apiset,
                                        );

    $apiset->simple_request("VM.pool_migrate", $vm_ref,
                            $xenserver, $extra_config_operations);

    $Log->exit() if $may_exit;
} ## end sub _migrate_vm_xen


=head2 set_memory_dynamic

  my $control  = NACL::C::HyperV::VirtualMachine->set_memory_dynamic(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        min               => $min,
                                        max               => $max,
                                    );

  OR

  $vm->set_memory_dynamic(
        min => $min,
        max => $max,
  );

(Class or Instance method) Set the minimum and maximum amounts of
physical memory the VM is allowed to use.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< min=>$min >>

(Required) The new minimum value.

=item C<< max=>$max >>

(Required) The new maximum value.

=back

=back

=cut

sub set_memory_dynamic {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            min => { type => SCALAR, optional => 1},
            max => { type => SCALAR, optional => 1},
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_set_memory_dynamic_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub set_memory_dynamic

sub _set_memory_dynamic_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $min = RPC_STRING($opts{min});
    my $max = RPC_STRING($opts{max});
    if (defined $min and defined $max) {
        $apiset->simple_request("VM.set_memory_dynamic_range", $vm_ref, $min, $max);
    } elsif (defined $min) {
        $apiset->simple_request("VM.set_memory_dynamic_min", $vm_ref, $min);
    } elsif (defined $max) {
        $apiset->simple_request("VM.set_memory_dynamic_max", $vm_ref, $max);
    } else {
        $Log->exit() if $may_exit;
        NATE::Exceptions::Argument->throw("Atleast one of the min or max is required");
    }

    $Log->exit() if $may_exit;
} ## end sub _set_memory_dynamic_xen

=head2 set_memory_static

  my $control  = NACL::C::HyperV::VirtualMachine->set_memory_static(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        min               => $min,
                                        max               => $max,
                                    );

  OR

  $vm->set_memory_static(
        min => $min,
        max => $max,
  );

(Class or Instance method) Set the static (ie boot-time) range of
virtual memory that the VM is allowed to use.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< min=>$min >>

(Required) The new minimum value.

=item C<< max=>$max >>

(Required) The new maximum value.

=back

=back

=cut

sub set_memory_static {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            min => { type => SCALAR, optional => 1},
            max => { type => SCALAR, optional => 1},
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_set_memory_static_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub set_memory_static

sub _set_memory_static_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    
    my $min = RPC_STRING($opts{min});
    my $max = RPC_STRING($opts{max});

    if (defined $min and defined $max) {
        $apiset->simple_request("VM.set_memory_static_range", $vm_ref, $min, $max);
    } elsif (defined $min) {
        $apiset->simple_request("VM.set_memory_static_min", $vm_ref, $min);
    } elsif (defined $max) {
        $apiset->simple_request("VM.set_memory_static_max", $vm_ref, $max);
    } else {
        $Log->exit() if $may_exit;
        NATE::Exceptions::Argument->throw("Atleast one of the min or max is required");
    }

    $Log->exit() if $may_exit;
} ## end sub _set_memory_static_xen

=head2 set_memory_limits

  my $control  = NACL::C::HyperV::VirtualMachine->set_memory_limits(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        static_min        => $static_min,
                                        static_max        => $static_max,
                                        dynamic_min       => $dynamic_min,
                                        dynamic_max       => $dynamic_max,
                                    );

  OR

  $vm->set_memory_limits(
        static_min  => $static_min,
        static_max  => $static_max,
        dynamic_min => $dynamic_min,
        dynamic_max => $dynamic_max,
  );

(Class or Instance method) Set the static (ie boot-time) range of
virtual memory that the VM is allowed to use.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< static_min=>$static_min >>

(Required) The new value of memory static min.

=item C<< static_max=>$static_max >>

(Required) The new value of memory static max.

=item C<< dynamic_min=>$dynamic_min >>

(Required) The new value of memory dynamic min.

=item C<< dynamic_max=>$dynamic_max >>

(Required) The new value of memory dynamic max.

=back

=back

=cut

sub set_memory_limits {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            static_min  => { type => SCALAR,},
            static_max  => { type => SCALAR,},
            dynamic_min => { type => SCALAR,},
            dynamic_max => { type => SCALAR,},
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_set_memory_limits_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub set_memory_limits

sub _set_memory_limits_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $static_min  = $opts{static_min};
    my $static_max  = $opts{static_max};
    my $dynamic_min = $opts{dynamic_min};
    my $dynamic_max = $opts{dynamic_max};

    $apiset->simple_request("VM.set_memory_limits", $vm_ref,
                            RPC_STRING($static_min), RPC_STRING($static_max), RPC_STRING($dynamic_min), RPC_STRING($dynamic_max));

    $Log->exit() if $may_exit;
} ## end sub _set_memory_limits_xen

=head2 reset

  my $control  = NACL::C::HyperV::VirtualMachine->reset(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                  );

  OR
  $vm->reset();

(Class or Instance method) This method will reset the Virtual machine.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

=back

=back

=cut

sub reset {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            task_object => { type => SCALARREF, optional => 1 },
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_reset_vm_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
            {
              method => '_reset_vm_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub reset

sub _reset_vm_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};
    my $task_object       = $opts{task_object};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    my $result    = $target_vm->ResetVM_Task();
    if ($task_object) {
        $$task_object = $pkg_or_obj->_get_task_object( apiset => $apiset, result => $result );
    }
    $Log->exit() if $may_exit;
} ## end sub _reset_vm_esx

sub _reset_vm_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    $apiset->simple_request("VM.power_state_reset", $vm_ref);

    $Log->exit() if $may_exit;
} ## end sub _reset_vm_xen

=head2 reboot_guest

  my $control  = NACL::C::HyperV::VirtualMachine->reboot_guest(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                  );
  OR

  $vm->reboot_guest();

(Class or Instance method) This method will reboot the Virtual machine.
Applicable for VMAPI ESX.
Applicable for XAPI Xen.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub reboot_guest {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            hard_reboot   => { type => BOOLEAN, default => 0 },
        },
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_reboot_guest_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
            {
              method => '_reboot_guest_xen',
              interface => 'XAPI',
              set   => 'Xen',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub reboot_guest

sub _reboot_guest_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    $target_vm->RebootGuest();

    $Log->exit() if $may_exit;
} ## end sub _reboot_guest

sub _reboot_guest_xen {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $vm_ref = $command_interface->_get_vm_ref(
                                vm_name => $opts{vm_name},
                                apiset  => $apiset,
                              );

    my $req = "VM.clean_reboot";
    if ($opts{hard_reboot}) {
        $req = "VM.hard_reboot";
    }

    $apiset->simple_request($req, $vm_ref);

    $Log->exit() if $may_exit;
} ## end sub _reboot_guest_xen

=head2 shutdown_guest

  my $control  = NACL::C::HyperV::VirtualMachine->shutdown_guest(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                    );

  OR

  $vm->shutdown_guest();

(Class or Instance method) This method will shut down the Virtual machine.
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub shutdown_guest {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_shutdown_guest_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub shutdown_guest

sub _shutdown_guest_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    $target_vm->ShutdownGuest();
    $Log->exit() if $may_exit;
} ## end sub _shutdown_guest

=head2 standby_guest

  my $control  = NACL::C::HyperV::VirtualMachine->standby_guest(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                    );

  OR

  $vm->standby_guest();

(Class or Instance method) This method will standby the Virtual machine.
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub standby_guest {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
    );
    $pkg_or_obj->call_on_apiset( %opts,
        choices => [
            {
              method => '_standby_guest_esx',
              interface => 'VMAPI',
              set   => 'ESX',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub standby_guest

sub _standby_guest_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    $target_vm->StandbyGuest();

    $Log->exit() if $may_exit;
} ## end sub _standby_guest

=head2 register_vm

  my $register  = NACL::C::HyperV::VirtualMachine->register_vm(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        path              => $path);
  OR

  $vm->register_vm(path => $path);

(Class or Instance method) This method will register the Virtual machine on the folder.
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< vm_name => $vm_name >>

(optional) Name of the virtual machine to register.

=item C<< path => $path >>

(Required) A datastore path to the virtual machine.

=item C<< asTemplate => boolean >>

(Required) Flag to specify whether or not the virtual machine should be marked
as a template.

=item C<< host => Host System Object >>

(Optional) The target host on which the virtual machine will run.
This parameter must specify a host that is a member of the ComputeResource
indirectly specified by the pool. For a stand-alone host or a cluster with DRS,
the parameter can be omitted, and the system selects a default.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub register_vm {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            vm_name    => { type => SCALAR, optional => 1, },
            path       => { type => SCALAR, },
            asTemplate => { type => BOOLEAN, },
            task_object => { type => SCALARREF, optional => 1 },
        },
    );
    my $ret = $pkg_or_obj->call_on_apiset( %opts,
                        choices => [
                            {
                              method => '_register_vm_esx',
                              interface => 'VMAPI',
                              set   => 'ESX',
                            },
                        ],
                   );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub register_vm

sub _register_vm_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $task_object       = $opts{task_object};

    my $allowed_options = [qw( path name asTemplate pool host )];
    my $datacenter      = $command_interface->datacenter();
    my $folder_view = $apiset->get_view( mo_ref => $datacenter->vmFolder() );
    my $host_view   = $command_interface->hostsystem();

    my $pool = $command_interface->cluster_compute_resource();
    if ( !$pool ) {
        $pool = $apiset->get_view( mo_ref => $host_view->parent );
    }
    $pool = $pool->get_raw_output();
    $opts{'pool'} = $pool->resourcePool();

    my %args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        target => \%args,
        copy   => $allowed_options,
        map    => { vm_name => "name" },
    );
    if ( !$folder_view ) {
        $Log->exit() if $may_exit;
        NATE::BaseException->throw("No Folder view retreived");
    }
    my $folder_obj = $folder_view->{parsed_output};
    my $result = $folder_obj->RegisterVM_Task(%args);
    if ($task_object) {
        $$task_object = $pkg_or_obj->_get_task_object( apiset => $apiset, result => $result );
    }
    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
    );
} ## end sub _register_vm

=head2 unregister_vm

  my $control  = NACL::C::HyperV::VirtualMachine->unregister_vm(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                    );

  OR

  $vm->unregister_vm();

(Class or Instance method) This method will unregister of the Virtual machine on the folder.
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=back

=back

=cut

sub unregister_vm {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
    );
    $pkg_or_obj->call_on_apiset( %opts,
                    choices => [
                        {
                          method => '_unregister_vm_esx',
                          interface => 'VMAPI',
                          set   => 'ESX',
                        },
                    ],
                 );

    $Log->exit() if $may_exit;
} ## end sub unregister_vm

sub _unregister_vm_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $vmName            = $opts{vm_name};

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $vmName );
    $target_vm->UnregisterVM();

    $Log->exit() if $may_exit;
} ## end sub _unregister_vm

=head2 migrate_within_host

  my $migrate  = NACL::C::HyperV::VirtualMachine->migrate_within_host(
                                        command_interface => $ci,
                                        vm_name           => $vm_name,
                                        priority          => $priority);
  OR
  my $migrate = $vm->migrate_within_host(priority => $priority);

(Class or Instance method) This method will migrate the Virtual machine within
the same host.
Applicable for VMAPI ESX.

=over

=item Options

=over

=item C<< command_interface=>$command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< vm_name => $vm_name >>

(optional) Name of the virtual machine to register.

=item C<< priority => $priority >>

(Required) The task priority to be used.

=item C<< pool => $pool >>

(optional) The target resource pool for the virtual machine.
If the pool parameter is left unset, the virtual machine's current pool
is used as the target pool.

=item C<< state => $state >>

(optional) If specified, the virtual machine migrates only if its state
matches the specified state.

=item C<< apiset_must=>$ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< task_object => \$task_object >>

(optional) If passed, a task object will be created
and will be assigned to it

=back

=back

=cut

sub migrate_within_host {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            vm_name     => { type => SCALAR, },
            priority    => { type => SCALAR, },
            state       => { type => SCALAR, optional => 1 },
            pool        => { type => SCALAR, optional => 1 },
            task_object => { type => SCALARREF, optional => 1 },
        },
    );
    my $ret = $pkg_or_obj->call_on_apiset( %opts,
                        choices => [
                            {
                              method => '_migrate_within_host_esx',
                              interface => 'VMAPI',
                              set   => 'ESX',
                            },
                        ],
                   );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub migrate_within_host

sub _migrate_within_host_esx {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my %opts              = $pkg_or_obj->_validate_backend_opts(@opts);
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $task_object       = $opts{task_object};

    my $allowed_options = [qw( priority state pool host )];
    my %args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_options,
        target => \%args,
    );

    my $target_vm = $pkg_or_obj->_find_target_vm( vm_name => $args{vm_name} );
    my $host = $apiset->get_view( mo_ref => $target_vm->runtime->host );

    if ( $opts{'pool'} ) {
        my $pool_mo_ref = $apiset->find_entity_view(
            view_type => 'ResourcePool',
            filter    => { name => $opts{'pool'} }
        );
        $args{'pool'} = $pool_mo_ref;
    }
    $args{'host'} = $host;
    my $result = $target_vm->MigrateVM_Task(%args);
    if ($task_object) {
        $$task_object = $pkg_or_obj->_get_task_object( apiset => $apiset, result => $result );
    }
    $Log->exit() if $may_exit;
    return $pkg_or_obj->new(
        command_interface => $command_interface,
        vm_name           => $opts{'vm_name'},
    );
} ## end sub _migrate_within_host

sub _primary_keys_validate_spec {
    return ( vm_name => { type => SCALAR }, );
}

1;
