#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary JobLog Component Module (DEPRECATED)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::JobLog

=head1 DESCRIPTION

B<DEPRECATED.>

The "job log" commands have been replaced by "logger mgwd log" commands,
so uage of this component is deprecated. Use
L<NACL::C::LoggerMgwdLog|lib-NACL-C-LoggerMgwdLog-pm> instead.

=cut

package NACL::C::JobLog;

use strict;
use warnings;
use NACL::CS::JobLog;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::C::Exceptions::JobLog::DoesNotExist ();
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument qw(:try);
use NACL::C::LoggerMgwdLog;

use Class::MethodMaker [scalar => 'module',];

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $Log->warn("Since the 'job log' commands have been removed in ONTAP, "
        . 'usage of NACL::C::JobLog is deprecated. Use '
        . 'NACL::C::LoggerMgwdLog->modify() instead');
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params      => \@args,
        allow_extra => 1,
    );
    NACL::C::LoggerMgwdLog->modify(%opts);
    $Log->exit() if $may_exit;
} ## end sub modify



__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('module' => {type => SCALAR},);
}

1;
