# $Id: //depot/prod/test/nacldev/lib/NACL/CS/LunAlignment.pm# $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary LunAlignment Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::LunAlignment

=head1 DESCRIPTION

C<NACL::C::LunAlignment> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP LunAlignment.  A related class is
L<NACL::CS::LunAlignment|lib-NACL-CS-LunAlignment-pm>, which represents
the past state of an ONTAP LunAlignment.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 lun

=head2 qtree

=head2 volume

=head2 vserver

=head2 path

=cut

package NACL::C::LunAlignment;

use strict;
use warnings;

use NACL::CS::LunAlignment;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use NACL::C::_Mixins::Lun qw(:all);
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $LunAlignment = NACL::C::LunAlignment->new(
                                   command_interface => $ci,
                                   'lun' => $lun,
                                   'qtree' => $qtree,
                                   'volume' => $volume,
                                   'vserver' => $vserver,
  );

  or 

  my $LunAlignment = NACL::C::LunAlignment->new(
                                   command_interface => $ci,
                                   'path'    => $path,
                                   'vserver' => $vserver,
  );

Return a new LunAlignment component object with the given attributes.

=cut

use Class::MethodMaker [

    scalar => [
        {   '-default_ctor' => sub {
                if (defined $_[0]->path()) {
                    return $_[0]
                        ->_extract_lun_from_path(path => $_[0]->path());
                }
            },
        },
        'lun'
    ],

    scalar => [
        {   '-default_ctor' => sub {
                if (defined $_[0]->path()) {
                    return $_[0]
                        ->_extract_qtree_from_path(path => $_[0]->path());
                }
            },
        },
        'qtree'
    ],
    scalar => [
        {   '-default_ctor' => sub {
                if (defined $_[0]->path()) {

                    return $_[0]
                        ->_extract_volume_from_path(path => $_[0]->path());
                }
            },
        },
        'volume'
    ],
    scalar => 'vserver',
    scalar => 'path',
];

=head2 find

    my $LunAlignment_obj  = NACL::C::LunAlignment->find(command_interface => $ci, ...);
    my @LunAlignment_objs = NACL::C::LunAlignment->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method invokes lun-alignment-get-iter of CMode ZAPI.

=head2 state

    my LunAlignment_state = $LunAlignment_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::LunAlignment would return 
a NACL::CS::LunAlignment object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method invokes lun-alignment-get-iter of CMode ZAPI.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR},
        'path'    => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

sub init {
    $Log->enter() if $may_enter;
    my ($self, %args) = @_;
    $self->_construct_path(params => \%args);
    $self->path($args{path});
    $self->SUPER::init(%args);
    $self->_vserver_context_init(%args);
    $Log->exit() if $may_exit;
} ## end sub init

1;
