# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary LunMapped Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::LunMapped

=head1 DESCRIPTION

C<NACL::C::LunMapped> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP LunMapped.  A related class is
L<NACL::CS::LunMapped|lib-NACL-CS-LunMapped-pm>, which represents
the past state of an ONTAP LunMapped.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 igroup

=head2 lun

=head2 qtree

=head2 volume

=head2 vserver

=head2 path

=cut

package NACL::C::LunMapped;

use strict;
use warnings;

use NACL::CS::LunMapped;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $LunMapped = NACL::C::LunMapped->new(
                                   command_interface => $ci,
                                   'igroup' => $igroup,
                                   'lun' => $lun,
                                   'qtree' => $qtree,
                                   'volume' => $volume,
                                   'vserver' => $vserver,
                                   'path' => $path,
								  );

Return a new LunMapped component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'igroup',
    scalar => 'lun',
    scalar => 'qtree',
    scalar => 'volume',
    scalar => 'vserver',
    scalar => [
        {   '-default_ctor' => sub {
                my $self = $_[0];
                my $path = '/vol/' . $self->volume() . '/' . $self->lun();
                return $path;
            },
        },
        'path'
    ],

];

=head2 find

    my $LunMapped_obj  = NACL::C::LunMapped->find(command_interface => $ci, ...);
	my @LunMapped_objs = NACL::C::LunMapped->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my LunMapped_state = $LunMapped_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::LunMapped would return 
a NACL::CS::LunMapped object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'igroup'  => {type => SCALAR},
        'volume'  => {type => SCALAR},
        'lun'     => {type => SCALAR},
        'qtree'   => {type => SCALAR, optional => 1},
        'vserver' => {type => SCALAR, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
