
#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary NetworkConnectionsListening Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::NetworkConnectionsListening

=head1 DESCRIPTION

C<NACL::C::NetworkConnectionsListening> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP NetworkConnectionsListening.  A related class is
L<NACL::CS::NetworkConnectionsListening|lib-NACL-CS-NetworkConnectionsListening-pm>, which represents
the past state of an ONTAP NetworkConnectionsListening.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 server

=head2 node

=head2 vif_name

=head2 mgmt_cid

=cut

package NACL::C::NetworkConnectionsListening;

use strict;
use warnings;

use NACL::CS::NetworkConnectionsListening;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $NetworkConnectionsListening = NACL::C::NetworkConnectionsListening->new(command_interface=>$ci,
                                   vserver =>$vserver,
                                   server =>$server,
                                   node =>$node,
                                   vif_name =>$vif_name,
                                   mgmt_cid =>$mgmt_cid,
								  );

Return a new NetworkConnectionsListening component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'server',
    scalar => 'node',
    scalar => 'vif_name',
    scalar => 'mgmt_cid',
];

=head2 find

    my $NetworkConnectionsListening  = NACL::C::NetworkConnectionsListening->find(command_interface => $ci, ...);
	my @NetworkConnectionsListenings = NACL::C::NetworkConnectionsListening->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $NetworkConnectionsListening_state = $NACL::C::NetworkConnectionsListening->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::NetworkConnectionsListening would return 
a NACL::CS::NetworkConnectionsListening object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'  => {type => SCALAR},
        'server'   => {type => SCALAR},
        'node'     => {type => SCALAR},
        'vif-name' => {type => SCALAR},
        'mgmt-cid' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
