
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary RepositoryVolumeSnapmirror Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::RepositoryVolumeSnapmirror

=head1 DESCRIPTION

C<NACL::C::RepositoryVolumeSnapmirror> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP RepositoryVolumeSnapmirror.  A related class is
L<NACL::CS::RepositoryVolumeSnapmirror|lib-NACL-CS-RepositoryVolumeSnapmirror-pm>, which represents
the past state of an ONTAP RepositoryVolumeSnapmirror.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 destination_volume

=head2 source_volume

=head2 destination_vserver

=head2 source_vserver

=head2 source_cluster

=head2 destination_cluster

=cut

package NACL::C::RepositoryVolumeSnapmirror;

use strict;
use warnings;

use NACL::CS::RepositoryVolumeSnapmirror;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $RepositoryVolumeSnapmirror = NACL::C::RepositoryVolumeSnapmirror->new(
                                   command_interface => $ci,
                                   'destination-volume' => $destination_volume,
                                   'source-volume' => $source_volume,
                                   'destination-vserver' => $destination_vserver,
                                   'source-vserver' => $source_vserver,
                                   'source-cluster' => $source_cluster,
                                   'destination-cluster' => $destination_cluster,
								  );

Return a new RepositoryVolumeSnapmirror component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'destination_volume',
    scalar => 'source_volume',
    scalar => 'destination_vserver',
    scalar => 'source_vserver',
    scalar => 'source_cluster',
    scalar => 'destination_cluster',
];

=head2 find

    my $RepositoryVolumeSnapmirror  = NACL::C::RepositoryVolumeSnapmirror->find(command_interface => $ci, ...);
	my @RepositoryVolumeSnapmirrors = NACL::C::RepositoryVolumeSnapmirror->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my RepositoryVolumeSnapmirror_state = $NACL::C::RepositoryVolumeSnapmirror->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::RepositoryVolumeSnapmirror would return 
a NACL::CS::RepositoryVolumeSnapmirror object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 delete

    NACL::C::RepositoryVolumeSnapmirror->delete(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->delete(...);

(Class or instance method)
This method is used to delete a repository snapmirror relation.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'force' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( force foreground
                    destination-volume source-volume destination-vserver source-vserver
                    source-cluster destination-cluster
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver force
            foreground source-cluster destination-cluster

            destination-volume source-volume destination-vserver source-vserver
            source-cluster destination-cluster
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_delete' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_delete(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

=head2 break

    NACL::C::RepositoryVolumeSnapmirror->break(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->break(...);

(Class or instance method)
This method is used to break a repository snapmirror relation.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'force' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub break {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( force foreground

                    destination-volume source-volume destination-vserver source-vserver
                    source-cluster destination-cluster
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_break_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub break

sub _break_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver force
            foreground source-cluster destination-cluster

            destination-volume source-volume destination-vserver source-vserver
            source-cluster destination-cluster
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_break' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_break(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _break_cmode_cli

=head2 abort

    NACL::C::RepositoryVolumeSnapmirror->abort(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->abort(...);

(Class or instance method)
This method is used to abort an active repository snapmirror transfer (Not Implemented).

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'check-only' => $string >>

Applicable for CMode CLI.

=item C<< 'hard' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub abort {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( check-only hard

                    foreground

                    destination-volume source-volume destination-vserver source-vserver
                    source-cluster destination-cluster
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_abort_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub abort

sub _abort_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver check-only
            source-vserver hard source-cluster destination-cluster

            foreground

            destination-volume source-volume destination-vserver source-vserver
            source-cluster destination-cluster
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_abort' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_abort(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _abort_cmode_cli

=head2 modify

    NACL::C::RepositoryVolumeSnapmirror->modify(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->modify(...);

(Class or instance method)
This method is used to modify a repository snapmirror relation.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'tries' => $string >>

Applicable for CMode CLI.

=item C<< 'schedule' => $string >>

Applicable for CMode CLI.

=item C<< 'throttle' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'policy' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( tries schedule throttle foreground

                    destination-volume source-volume destination-vserver source-vserver
                    destination-cluster source-cluster

                    policy
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume tries source-volume destination-vserver source-vserver
            schedule throttle foreground destination-cluster source-cluster

            destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster

            policy
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_modify' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_modify(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 create

    my $RepositoryVolumeSnapmirror_object	= NACL::C::RepositoryVolumeSnapmirror->create(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
   
(Class method)
This method is used to create a repository snapmirror relation.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required)

Applicable for CMode CLI.

=item C<< 'tries' => $string >>

Applicable for CMode CLI.

=item C<< 'schedule' => $string >>

Applicable for CMode CLI.

=item C<< 'throttle' => $string >>

Applicable for CMode CLI.

=item C<< 'type' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'policy' => $string >>

Applicable for CMode CLI.

=item C<< 'relationship-capability' => $string >>

Applicable for CMode CLI.

=item C<< 'relationship-id' => $string >>

*Relationship Id

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( tries schedule throttle type foreground

                    destination-volume source-volume destination-vserver source-vserver
                    destination-cluster source-cluster

                    policy

                    relationship-capability

                    relationship-id
                    )
            ),
        },
    );
    my $obj = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = validate_with(
        params      => \@_,
        spec        => $pkg->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume tries source-volume destination-vserver source-vserver
            schedule throttle type foreground destination-cluster source-cluster

            destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster

            policy

            relationship-capability

            relationship-id
            extended_query )
    ];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_create' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_create(%cmode_args);
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface   => $command_interface,
        destination_volume  => $cmode_args{'destination-volume'},
        source_volume       => $cmode_args{'source-volume'},
        destination_vserver => $cmode_args{'destination-vserver'},
        source_vserver      => $cmode_args{'source-vserver'},
        source_cluster      => $cmode_args{'source-cluster'},
        destination_cluster => $cmode_args{'destination-cluster'},
    );
} ## end sub _create_cmode_cli

=head2 update

    NACL::C::RepositoryVolumeSnapmirror->update(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->update(...);

(Class or instance method)
This method is used to start a repository snapmirror incremental transfer.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'throttle' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'transfer-priority' => $string >>

Transfer Priority possible value(s) are, low,normal

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub update {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( throttle foreground

                    destination-volume source-volume destination-vserver source-vserver
                    destination-cluster source-cluster

                    transfer-priority
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_update_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub update

sub _update_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver
            throttle foreground destination-cluster source-cluster

            destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster
            extended_query
            transfer-priority
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_update' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_update(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _update_cmode_cli

=head2 resync

    NACL::C::RepositoryVolumeSnapmirror->resync(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->resync(...);

(Class or instance method)
This method is used to resync a Repository snapmirror relation.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'force' => $string >>

Applicable for CMode CLI.

=item C<< 'throttle' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'transfer-priority' => $string >>

Transfer Priority possible value(s) are, low,normal

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub resync {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( force throttle foreground

                    destination-volume source-volume destination-vserver source-vserver
                    destination-cluster source-cluster

                    transfer-priority
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_resync_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub resync

sub _resync_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver force
            throttle foreground destination-cluster source-cluster

            destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster
            extended_query
            transfer-priority
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_resync' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_resync(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _resync_cmode_cli

=head2 initialize

    NACL::C::RepositoryVolumeSnapmirror->initialize(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'source-volume' => $source_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-vserver' => $source_vserver,
	                            'source-cluster' => $source_cluster,
	                            'destination-cluster' => $destination_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_object->initialize(...);

(Class or instance method)
This method is used to start a baseline repository snapmirror transfer.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< 'throttle' => $string >>

Applicable for CMode CLI.

=item C<< 'foreground' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'transfer-priority' => $string >>

Transfer Priority possible value(s) are, low,normal

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub initialize {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( throttle foreground

                    destination-volume source-volume destination-vserver source-vserver
                    destination-cluster source-cluster

                    transfer-priority
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_initialize_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
} ## end sub initialize

sub _initialize_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver
            throttle foreground destination-cluster source-cluster

            destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster
            extended_query
            transfer-priority
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $Log->debug(
        "Opts to API call 'repository_volume_snapmirror_initialize' are: \n"
            . Dumper(\%cmode_args));

    $apiset->repository_volume_snapmirror_initialize(%cmode_args);
    $Log->exit() if $may_exit;
} ## end sub _initialize_cmode_cli

=head2 update_ns_mirrors

    NACL::C::RepositoryVolumeSnapmirror->update_ns_mirrors(
                                command_interface => $ci,
	                            'source-volume' => $source_volume,
	                            'source-vserver' => $source_vserver,
                                ...);
   
(Class method)
This method is used to start an incremental ns mirror transfer.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'source-volume' => $source_volume >>

(Required)

Applicable for CMode CLI.

=item C<< 'source-vserver' => $source_vserver >>

(Required)

Applicable for CMode CLI.

=item C<< 'transfer-snapshot' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub update_ns_mirrors {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(
        params          => \@_,
        additional_spec => {
            _optional_scalars(
                qw( source-volume transfer-snapshot source-vserver
                    )
            ),
        },
        ignore_primary_keys => 1,
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_update_ns_mirrors_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _update_ns_mirrors_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = $pkg->_validate_backend_opts(@_);

    my $command_interface = $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( source-volume transfer-snapshot source-vserver
            extended_query )
    ];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->repository_volume_snapmirror_update_ns_mirrors(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 resume

    NACL::C::RepositoryVolumeSnapmirror->resume(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-volume' => $source_volume,
	                            'source-vserver' => $source_vserver,
	                            'destination-cluster' => $destination_cluster,
	                            'source-cluster' => $source_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_obj->resume(...);

(Class or instance method)
This method is used to enable future transfers.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)
*destination Volume

Applicable for CMode CLI.


=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)
*Destination Virtual Server

Applicable for CMode CLI.


=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)
*Source Volume

Applicable for CMode CLI.


=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)
*Source Virtual Server

Applicable for CMode CLI.


=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)
*Destination Cluster

Applicable for CMode CLI.


=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)
*Source Cluster

Applicable for CMode CLI.


=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub resume {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(params => \@_,);
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_resume_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _resume_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    my $apiset                = $opts{apiset};
    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->repository_volume_snapmirror_resume(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 quiesce

    NACL::C::RepositoryVolumeSnapmirror->quiesce(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-volume' => $source_volume,
	                            'source-vserver' => $source_vserver,
	                            'destination-cluster' => $destination_cluster,
	                            'source-cluster' => $source_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_obj->quiesce(...);

(Class or instance method)
This method is used to disable future transfers.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)
*destination Volume

Applicable for CMode CLI.


=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)
*Destination Virtual Server

Applicable for CMode CLI.


=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)
*Source Volume

Applicable for CMode CLI.


=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)
*Source Virtual Server

Applicable for CMode CLI.


=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)
*Destination Cluster

Applicable for CMode CLI.


=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)
*Source Cluster

Applicable for CMode CLI.


=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub quiesce {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(params => \@_,);
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_quiesce_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _quiesce_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    my $apiset                = $opts{apiset};
    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver
            destination-cluster source-cluster
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->repository_volume_snapmirror_quiesce(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 release

    NACL::C::RepositoryVolumeSnapmirror->release(
                                command_interface => $ci,
	                            'destination-volume' => $destination_volume,
	                            'destination-vserver' => $destination_vserver,
	                            'source-volume' => $source_volume,
	                            'source-vserver' => $source_vserver,
	                            'destination-cluster' => $destination_cluster,
	                            'source-cluster' => $source_cluster,
                                ...);
	                             
								 or

    $RepositoryVolumeSnapmirror_obj->release(...);

(Class or instance method)
This method is used to release a Repository snapmirror relation.

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'destination-volume' => $destination_volume >>

(Required for class method, Not Applicable for instance method)
*destination Volume

Applicable for CMode CLI.


=item C<< 'destination-vserver' => $destination_vserver >>

(Required for class method, Not Applicable for instance method)
*Destination Virtual Server

Applicable for CMode CLI.


=item C<< 'source-volume' => $source_volume >>

(Required for class method, Not Applicable for instance method)
*Source Volume

Applicable for CMode CLI.


=item C<< 'source-vserver' => $source_vserver >>

(Required for class method, Not Applicable for instance method)
*Source Virtual Server

Applicable for CMode CLI.


=item C<< 'destination-cluster' => $destination_cluster >>

(Required for class method, Not Applicable for instance method)
*Destination Cluster

Applicable for CMode CLI.


=item C<< 'source-cluster' => $source_cluster >>

(Required for class method, Not Applicable for instance method)
*Source Cluster

Applicable for CMode CLI.


=item C<< 'force' => $string >>

*Force, possible value(s) are true,false

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< 'relationship-id' => $string >>

*Relationship Id

Applicable for CMode CLI.

=item C<< 'relationship-info-only' => $string >>

*Remove relationship info only (skip cleanup of snapshots)

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub release {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@_,
        additional_spec => {
            _optional_scalars(
                qw( force
                    relationship-id relationship-info-only
                    )
            ),
        },
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_release_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _release_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    my $apiset                = $opts{apiset};
    my $allowed_cmode_options = [
        qw( destination-volume source-volume destination-vserver source-vserver force
            source-cluster destination-cluster
            extended_query
            relationship-id relationship-info-only
            )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->repository_volume_snapmirror_release(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 list_destinations

    my $list_destinations_obj = NACL::C::RepositoryVolumeSnapmirror->list_destinations(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @list_destinations_objs = NACL::C::RepositoryVolumeSnapmirror->list_destinations(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $list_destinations_obj = $RepositoryVolumeSnapmirror_obj->list_destinations(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-RepositoryVolumeSnapmirrorListDestinations-pm/ATTRIBUTES>
of NACL::CS::RepositoryVolumeSnapmirrorListDestinations as input. 
This method returns objects of the type L<NACL::CS::RepositoryVolumeSnapmirrorListDestinations|lib-NACL-CS-RepositoryVolumeSnapmirrorListDestinations-pm>.

=cut

sub list_destinations {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::RepositoryVolumeSnapmirrorListDestinations;
    my @state_objs
        = NACL::CS::RepositoryVolumeSnapmirrorListDestinations->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'destination-volume'  => {type => SCALAR},
        'source-volume'       => {type => SCALAR},
        'destination-vserver' => {type => SCALAR},
        'source-vserver'      => {type => SCALAR},
        'source-cluster'      => {type => SCALAR},
        'destination-cluster' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
