# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SnaplockLegalHold Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SnaplockLegalHold

=head1 DESCRIPTION

C<NACL::C::SnaplockLegalHold> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SnaplockLegalHold.  A related class is
L<NACL::CS::SnaplockLegalHold|lib-NACL-CS-SnaplockLegalHold-pm>, which represents
the past state of an ONTAP SnaplockLegalHold.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 operation_id

=head2 vserver

=cut

package NACL::C::SnaplockLegalHold;

use strict;
use warnings;

use NACL::CS::SnaplockLegalHold;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use feature 'state';

=head1 METHODS

=head2 new

  my $SnaplockLegalHold = NACL::C::SnaplockLegalHold->new(
                                   command_interface => $ci,
                                   'operation-id' => $operation_id,
                                   'vserver' => $vserver,
								  );

Return a new SnaplockLegalHold component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'operation_id',
    scalar => 'vserver',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $SnaplockLegalHold_obj  = NACL::C::SnaplockLegalHold->find(command_interface => $ci, ...);
	my @SnaplockLegalHold_objs = NACL::C::SnaplockLegalHold->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SnaplockLegalHold_state = $SnaplockLegalHold_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SnaplockLegalHold would return 
a NACL::CS::SnaplockLegalHold object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 abort

    NACL::C::SnaplockLegalHold->abort(
                                command_interface => $ci,
	                            'operation-id' => $operation_id,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $SnaplockLegalHold_obj->abort(...);

(Class or instance method)
This method is used to abort Snaplock legal-hold operation..
Uses CMode CLI/ZAPI .
Invokes  snaplock-legal-hold-abort  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'operation-id' => $operation_id >>

(Required for class method, Not Applicable for instance method)
Operation ID
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver-str' => $string >>

Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "snaplock legal hold abort" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub abort {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    state $additional_spec = {
        additional_spec => {
            _optional_scalars(
                qw( vserver-str
                    )
            ),
        }
    };
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        %{$additional_spec},
        cli_cmd => 'snaplock legal-hold abort',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_abort_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_abort_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_check_abort_cmode_zapi_non_iter',
            },
        ],
        frontend => 'NACL::C::SnaplockLegalHold::abort',
    );

    $Log->exit() if $may_exit;
}

sub _abort_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'snaplock_legal_hold_abort',);
    $Log->exit() if $may_exit;
}

sub _abort_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(operation-id)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'snaplock-legal-hold-abort',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

sub _check_abort_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,

        _primary_keys => [qw(operation-id vserver)],
        _vs_context   => 1

    );
    my @invalid_fields = ();
    ## following are the CLI-only fields
    my @cli_only_fields = qw(vserver-str);
    foreach my $field (@cli_only_fields) {
        push @invalid_fields, $field if (grep (/^$field$/, @opts));
    }
    if (@invalid_fields) {
        my $msg
            = 'The following fields provided '
            . 'in the call to '
            . $pkg
            . ' are not supported by the '
            . 'non-iter ZAPI, so the ZAPI back-end is being '
            . "skipped:
"
            . join(', ', @invalid_fields);
        $Log->comment($msg);
        $Log->exit() if $may_exit;
        NACL::Exceptions::InvalidChoice->throw($msg);
    }
    $Log->exit() if $may_exit;
}

=head2 begin

    NACL::C::SnaplockLegalHold->begin(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to creates legal-hold on files on a SnapLock Volume.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required)
Vserver Name
Applicable for CMode CLI

=item C<< 'path-str' => $string >>

Applicable for CMode CLI

=item C<< 'volume' => $string >>

Volume
Applicable for CMode CLI

=item C<< 'litigation-name' => $string >>

Litigation Name
Applicable for CMode CLI

=item C<< 'path' => $string >>

Path
Applicable for CMode CLI

=item C<< 'result-operation-id' => $string >>

Operation ID
Applicable for CMode CLI

=item C<< 'vserver-str' => $string >>

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "snaplock legal hold begin" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub begin {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    state $additional_spec = {
        additional_spec => {
            _optional_scalars(
                qw( path-str volume vserver litigation-name path result-operation-id vserver-str
                    )
            ),
        }
    };
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        %{$additional_spec},
        ignore_primary_keys => 1,
        cli_cmd             => 'snaplock legal-hold begin',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $operation_id;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        _operation_id => \$operation_id,
        choices => [
            {   method    => '_begin_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },

        ],
        frontend => 'NACL::C::SnaplockLegalHold::begin',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        operation_id      => $operation_id,
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _begin_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api => 'snaplock_legal_hold_begin',
        apiset_response_obj => \$response
    );
    my $output = $response->get_processed_output();
    my @output = split /operation-id/, $output;
    @output = split /"/, $output[1];
    @output = split /-instance/, $output[0];
    ${$opts{_operation_id}} = $output[0];
    $Log->exit() if $may_exit;
}

=head2 dump_files

    NACL::C::SnaplockLegalHold->dump_files(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to dump list of files under legal-hold to specified output path..
Uses CMode CLI/ZAPI .
Invokes  snaplock-legal-hold-dump-files-start  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required)
Vserver Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'output-volume' => $string >>

Output Volume Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'volume' => $string >>

Volume Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'output-directory-path' => $string >>

Path Relative to Output Volume Root
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'litigation-name' => $string >>

Litigation Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver-str' => $string >>

Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "snaplock legal hold dump files" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub dump_files {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    state $additional_spec = {
        additional_spec => {
            _optional_scalars(
                qw( output-volume volume vserver output-directory-path litigation-name
                    vserver-str
                    )
            ),
        }
    };
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        %{$additional_spec},
        ignore_primary_keys => 1,
        cli_cmd             => 'snaplock legal-hold dump-files',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $operation_id;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        _operation_id => \$operation_id,
        choices => [
            {   method    => '_dump_files_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_dump_files_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_check_dump_files_cmode_zapi_non_iter',
            },
        ],
        frontend => 'NACL::C::SnaplockLegalHold::dump_files',
    );
    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        operation_id        => $operation_id,
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _dump_files_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api => 'snaplock_legal_hold_dump_files',
        apiset_response_obj => \$response
    );
    my $output = $response->get_processed_output();
    my @output = split /operation-id/, $output;
    @output = split /"/, $output[1];
    @output = split /-instance/, $output[0];
    ${$opts{_operation_id}} = $output[0];
    $Log->exit() if $may_exit;
}

sub _dump_files_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy
        = [qw(output-volume volume output-directory-path litigation-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'snaplock-legal-hold-dump-files-start',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 dump_litigations

    NACL::C::SnaplockLegalHold->dump_litigations(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to dump list of litigations for a given Vserver to specified output path..
Uses CMode CLI/ZAPI .
Invokes  snaplock-legal-hold-dump-litigations-start  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required)
Vserver Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'output-volume' => $string >>

Output Volume Vame
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'volume' => $string >>

Volume Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'job-id-str' => $string >>

Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'output-directory-path' => $string >>

Path Relative to Output Volume Root
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'job-id' => $string >>

Result Job ID
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver-str' => $string >>

Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "snaplock legal hold dump litigations" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub dump_litigations {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    state $additional_spec = {
        additional_spec => {
            _optional_scalars(
                qw( output-volume volume job-id-str vserver output-directory-path job-id
                    vserver-str
                    )
            ),
        }
    };
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        %{$additional_spec},
        ignore_primary_keys => 1,
        cli_cmd             => 'snaplock legal-hold dump-litigations',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_dump_litigations_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_dump_litigations_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_check_dump_litigations_cmode_zapi_non_iter',
            },
        ],
        frontend => 'NACL::C::SnaplockLegalHold::dump_litigations',
    );

    $Log->exit() if $may_exit;
    return $ret;
}

sub _dump_litigations_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api => 'snaplock_legal_hold_dump_litigations',
        apiset_response_obj => \$response
    );
    my $output = $response->get_processed_output();
    my @output = split /-id/, $output;
    @output = split /-instance/, $output[1];
    $Log->exit() if $may_exit;
    return NACL::C::Job->new(
        command_interface => $opts{command_interface},
        id                => $output[0],
    );
}

sub _dump_litigations_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(output-volume volume output-directory-path)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'snaplock-legal-hold-dump-litigations-start',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 end

    NACL::C::SnaplockLegalHold->end(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to releases legal-hold on files on a SnapLock Volume.
Uses CMode CLI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required)
Vserver Name
Applicable for CMode CLI

=item C<< 'path-str' => $string >>

Applicable for CMode CLI

=item C<< 'volume' => $string >>

Volume
Applicable for CMode CLI

=item C<< 'litigation-name' => $string >>

Litigation Name
Applicable for CMode CLI

=item C<< 'path' => $string >>

Path
Applicable for CMode CLI

=item C<< 'result-operation-id' => $string >>

Operation-id
Applicable for CMode CLI

=item C<< 'vserver-str' => $string >>

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "snaplock legal hold end" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub end {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    state $additional_spec = {
        additional_spec => {
            _optional_scalars(
                qw( path-str volume vserver litigation-name path result-operation-id vserver-str
                    )
            ),
        }
    };
    my %opts = $pkg->_common_validate_with(
        params => \@args,
        %{$additional_spec},
        ignore_primary_keys => 1,
        cli_cmd             => 'snaplock legal-hold end',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $operation_id;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        _operation_id => \$operation_id,
        choices => [
            {   method    => '_end_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },

        ],
        frontend => 'NACL::C::SnaplockLegalHold::end',
    );
    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        operation_id        => $operation_id,
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _end_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $response;
    $pkg->_base_backend_cmode_cli(
        %opts,
        api => 'snaplock_legal_hold_end',
        apiset_response_obj => \$response
    );
    my $output = $response->get_processed_output();
    my @output = split /operation-id/, $output;
    @output = split /"/, $output[1];
    @output = split /-instance/, $output[0];
    ${$opts{_operation_id}} = $output[0];
    $Log->exit() if $may_exit;
}
__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'operation-id' => {type => SCALAR},
        'vserver'      => {type => SCALAR},
    );
}

1;
