#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsRdbQuorumEvents Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StatisticsRdbQuorumEvents

=head1 DESCRIPTION

C<NACL::C::StatisticsRdbQuorumEvents> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StatisticsRdbQuorumEvents.  A related class is
L<NACL::CS::StatisticsRdbQuorumEvents|lib-NACL-CS-StatisticsRdbQuorumEvents-pm>, which represents
the past state of an ONTAP StatisticsRdbQuorumEvents.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 timestamp

=head2 ring

=head2 reporter

=cut

package NACL::C::StatisticsRdbQuorumEvents;

use strict;
use warnings;

use NACL::CS::StatisticsRdbQuorumEvents;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $StatisticsRdbQuorumEvents = NACL::C::StatisticsRdbQuorumEvents->new(command_interface=>$ci,
                                   timestamp =>$timestamp,
                                   ring =>$ring,
                                   reporter =>$reporter,
								  );

Return a new StatisticsRdbQuorumEvents component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'timestamp',
    scalar => 'ring',
    scalar => 'reporter',
    scalar => 'eventtime',
];

=head2 find

    my $StatisticsRdbQuorumEvents  = NACL::C::StatisticsRdbQuorumEvents->find(command_interface => $ci, ...);
	my @StatisticsRdbQuorumEventss = NACL::C::StatisticsRdbQuorumEvents->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $StatisticsRdbQuorumEvents_state = $NACL::C::StatisticsRdbQuorumEvents->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StatisticsRdbQuorumEvents would return 
a NACL::CS::StatisticsRdbQuorumEvents object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'timestamp' => {type => SCALAR, optional => 1},
        'ring'      => {type => SCALAR},
        'reporter'  => {type => SCALAR},
        'eventtime' => {type => SCALAR, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
