
#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageArrayConfig Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageArrayConfig

=head1 DESCRIPTION

C<NACL::C::StorageArrayConfig> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageArrayConfig.  A related class is
L<NACL::CS::StorageArrayConfig|lib-NACL-CS-StorageArrayConfig-pm>, which represents
the past state of an ONTAP StorageArrayConfig.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 initiator

=head2 group

=head2 target_wwpn

=head2 node

=cut

package NACL::C::StorageArrayConfig;

use strict;
use warnings;

use NACL::CS::StorageArrayConfig;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $StorageArrayConfig = NACL::C::StorageArrayConfig->new(command_interface=>$ci,
                                   initiator =>$initiator,
                                   group =>$group,
                                   target_wwpn =>$target_wwpn,
                                   node =>$node,
                            );

Return a new StorageArrayConfig component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'initiator',
    scalar => 'group',
    scalar => 'target_wwpn',
    scalar => 'node',
];

=head2 find

    my $StorageArrayConfig  = NACL::C::StorageArrayConfig->find(command_interface => $ci, ...);
    my @StorageArrayConfigs = NACL::C::StorageArrayConfig->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $StorageArrayConfig_state = $NACL::C::StorageArrayConfig->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageArrayConfig would return
a NACL::CS::StorageArrayConfig object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'initiator'   => {type => SCALAR},
        'group'       => {type => SCALAR},
        'target-wwpn' => {type => SCALAR},
        'node'        => {type => SCALAR, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
