#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageFailoverHwassist Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageFailoverHwassist

=head1 DESCRIPTION

C<NACL::C::StorageFailoverHwassist> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageFailoverHwassist.  A related class is
L<NACL::CS::StorageFailoverHwassist|lib-NACL-CS-StorageFailoverHwassist-pm>, which represents
the past state of an ONTAP StorageFailoverHwassist.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=cut

package NACL::C::StorageFailoverHwassist;

use strict;
use warnings;

use NACL::CS::StorageFailoverHwassist;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $StorageFailoverHwassist = NACL::C::StorageFailoverHwassist->new(command_interface=>$ci,
                                   node =>$node,
                                  );

Return a new StorageFailoverHwassist component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'node',];

=head2 find

    my $StorageFailoverHwassist  = NACL::C::StorageFailoverHwassist->find(command_interface => $ci, ...);
    my @StorageFailoverHwassists = NACL::C::StorageFailoverHwassist->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $StorageFailoverHwassist_state = $NACL::C::StorageFailoverHwassist->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageFailoverHwassist would return
a NACL::CS::StorageFailoverHwassist object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 test

   NACL::C::StorageFailoverHwassist->test(
                                command_interface => $ci,
                                 node => $node,
                                  ...);

                                 or

    $StorageFailoverHwassist_object->test(...);

(Class or instance method)
This method is used to test the hwassist functionality.

Uses a CMode CLI/ZAPI APISet, 7Mode CLI.
  Invokes 'cf-hwassist-test' API for CMode ZAPI.
  Invokes 'cf hw assist test' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "node" => $node >>

(Required for class method, Not Applicable for instance method)

=item C<< "hwassist-test-result" => $string >>

  Applicable only for CMode CLI.

=item C<< 'node' => $string >>

  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: node

=item C<< 'extended_query' => $string >>

(Optional)
  Applicable only for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"storage failover hwassist test" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub test {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( hwassist-test-result

                    node
                    )
            ),
        },
        cli_cmd => 'storage failover hwassist test',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_test_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_test_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
            {   method    => "_test_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },
        ],
        frontend => 'NACL::C::StorageFailoverHwassist::test',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub test

sub _test_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'storage_failover_hwassist_test',);
    $Log->exit() if $may_exit;
} ## end sub _test_cmode_cli

sub _test_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => [qw(node)],
        api  => 'cf_hwassist_test',
    );
    $Log->exit() if $may_exit;
} ## end sub _test_cmode_zapi

sub _test_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );

    delete $opts{command_interface};
    delete $opts{node};
    my $apiset = delete $opts{apiset};

    $apiset->cf_hw_assist_test(%opts);
    $Log->exit() if $may_exit;
} ## end sub _test_7mode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('node' => {type => SCALAR, optional => 1});
}

1;
