# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageTape Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::StorageTape

=head1 DESCRIPTION

C<NACL::C::StorageTape> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP StorageTape.  A related class is
L<NACL::CS::StorageTape|lib-NACL-CS-StorageTape-pm>, which represents
the past state of an ONTAP StorageTape.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 node

=head2 device_id

=cut

package NACL::C::StorageTape;

use strict;
use warnings;

use NACL::CS::StorageTape;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $StorageTape = NACL::C::StorageTape->new(
                                   command_interface => $ci,
                                   'node' => $node,
                                   'device-id' => $device_id,
                                  );

Return a new StorageTape component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'device_id',
];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $StorageTape_obj  = NACL::C::StorageTape->find(command_interface => $ci, ...);
    my @StorageTape_objs = NACL::C::StorageTape->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my StorageTape_state = $StorageTape_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::StorageTape would return
a NACL::CS::StorageTape object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 show_all

    my $show_all_obj = NACL::C::StorageTape->show_all(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_all_objs = NACL::C::StorageTape->show_all(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_all_obj = $StorageTape_obj->show_all();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-StorageTapeShowAll-pm/ATTRIBUTES>
of NACL::CS::StorageTapeShowAll as input.
This method returns objects of the type L<NACL::CS::StorageTapeShowAll|lib-NACL-CS-StorageTapeShowAll-pm>.

=cut

sub show_all {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::StorageTapeShowAll;
    my @state_objs = NACL::CS::StorageTapeShowAll->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 reserve

    NACL::C::StorageTape->reserve(
                                command_interface => $ci,
                                'node' => $node,
                                'device-id' => $device_id,
                                ...);

                                 or

    $StorageTape_obj->reserve(...);

(Class or instance method)
This method is used to reserve a tape drive.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-reserve for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'device-id' => $device_id >>

(Required for class method, Not Applicable for instance method)
Tape Drive Device ID

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape reserve" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub reserve {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'storage tape reserve',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_reserve_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_reserve_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::reserve',
    );

    $Log->exit() if $may_exit;
}

sub _reserve_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'storage_tape_reserve',);
    $Log->exit() if $may_exit;
}

sub _reserve_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(device-id)];
    my $map = {'node' => 'node-name'};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'tape-mc-info-reserve',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 release

    NACL::C::StorageTape->release(
                                command_interface => $ci,
                                'node' => $node,
                                'device-id' => $device_id,
                                ...);

                                 or

    $StorageTape_obj->release(...);

(Class or instance method)
This method is used to release a tape drive reservation.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-release for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'device-id' => $device_id >>

(Required for class method, Not Applicable for instance method)
Tape Drive Device ID

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape release" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub release {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'storage tape release',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_release_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_release_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::release',
    );

    $Log->exit() if $may_exit;
}

sub _release_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'storage_tape_release',);
    $Log->exit() if $may_exit;
}

sub _release_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(device-id)];
    my $map = {'node' => 'node-name'};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'tape-mc-info-release',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 reset

    NACL::C::StorageTape->reset(
                                command_interface => $ci,
                                'node' => $node,
                                'device-id' => $device_id,
                                ...);

                                 or

    $StorageTape_obj->reset(...);

(Class or instance method)
This method is used to reset a tape drive.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-reset for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'device-id' => $device_id >>

(Required for class method, Not Applicable for instance method)
Tape Drive Device ID

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape reset" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub reset {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'storage tape reset',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_reset_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_reset_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::reset',
    );

    $Log->exit() if $may_exit;
}

sub _reset_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts, api => 'storage_tape_reset',);
    $Log->exit() if $may_exit;
}

sub _reset_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(node device-id)];
    my $map = {'node' => 'node-name'};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'tape-mc-info-reset',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 trace

    NACL::C::StorageTape->trace(
                                command_interface => $ci,
                                'node' => $node,
                                ...);

(Class method)
This method is used to enable/disable tape trace operations.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-trace for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'is-trace-enabled' => $string >>

Tape Trace Enabled or Disabled possible value(s) are, true,false

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape trace" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub trace {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( is-trace-enabled node
                    )
            ),
        },
        ignore_primary_keys => 1,
	cli_cmd             => 'storage tape trace',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_trace_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_trace_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::trace',
    );

    $Log->exit() if $may_exit;
}

sub _trace_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts, api => 'storage_tape_trace',);
    $Log->exit() if $may_exit;
}

sub _trace_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(is-trace-enabled)];
    my $map = {'node' => 'node-name'};
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'tape-mc-info-trace',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 online

    NACL::C::StorageTape->online(
                                command_interface => $ci,
                                'node' => $node,
                                'device-id' => $device_id,
                                ...);

                                 or

    $StorageTape_obj->online(...);

(Class or instance method)
This method is used to bring a tape drive online.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-online for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'device-id' => $device_id >>

(Required for class method, Not Applicable for instance method)
Tape Drive Device ID

Applicable for CMode CLI/ZAPI

=item C<< 'name' => $string >>

Tape Drive Device Name

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape online" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub online {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( name
                    )
            ),
        },
    cli_cmd => 'storage tape online',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_online_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_online_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::online',
    );

    $Log->exit() if $may_exit;
}

sub _online_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'storage_tape_online',);
    $Log->exit() if $may_exit;
}

sub _online_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(device-id)];
    my $map = {'node' => 'node-name'};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'tape-mc-info-online',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 offline

    NACL::C::StorageTape->offline(
                                command_interface => $ci,
                                'node' => $node,
                                'device-id' => $device_id,
                                ...);

                                 or

    $StorageTape_obj->offline(...);

(Class or instance method)
This method is used to take a tape drive offline.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-offline for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'device-id' => $device_id >>

(Required for class method, Not Applicable for instance method)
Tape Drive Device ID

Applicable for CMode CLI/ZAPI

=item C<< 'name' => $string >>

Tape Drive Device Name

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape offline" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub offline {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( name
                    )
            ),
        },
        cli_cmd => 'storage tape offline',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_offline_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_offline_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::offline',
    );

    $Log->exit() if $may_exit;
}

sub _offline_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'storage_tape_offline',);
    $Log->exit() if $may_exit;
}

sub _offline_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $map = {'name' => 'device-name'};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api => 'tape-mc-info-offline',
        map => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 position

    NACL::C::StorageTape->position(
                                command_interface => $ci,
                                'node' => $node,
                                ...);

(Class method)
This method is used to modifies the tape drive cartridge position.
Uses CMode CLI/ZAPI .
Invokes  tape-mc-info-position for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $node >>

(Required)
Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< 'count' => $string >>

Count for Positioning

Applicable for CMode CLI/ZAPI

=item C<< 'name' => $string >>

Tape Drive Device Name

Applicable for CMode CLI/ZAPI

=item C<< 'operation' => $string >>


Tape Position Operation possible value(s) are, weof,fsf,bsf,fsr,bsr,rewind,erase,eom

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "storage tape position" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub position {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( count name operation node
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd => 'storage tape position',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_position_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_position_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::StorageTape::position',
    );

    $Log->exit() if $may_exit;
}

sub _position_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts, api => 'storage_tape_position',);
    $Log->exit() if $may_exit;
}

sub _position_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(count operation)];
    my $map  = {
        'node' => 'node-name',
        'name' => 'device-name',
    };
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'tape-mc-info-position',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 show_media_changer

    my $show_media_changer_obj = NACL::C::StorageTape->show_media_changer(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_media_changer_objs = NACL::C::StorageTape->show_media_changer(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_media_changer_obj = $StorageTape_obj->show_media_changer();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-StorageTapeShowMediaChanger-pm/ATTRIBUTES>
of NACL::CS::StorageTapeShowMediaChanger as input.
This method returns objects of the type L<NACL::CS::StorageTapeShowMediaChanger|lib-NACL-CS-StorageTapeShowMediaChanger-pm>.

=cut

sub show_media_changer {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::StorageTapeShowMediaChanger;
    my @state_objs = NACL::CS::StorageTapeShowMediaChanger->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_media_changer_all

    my $show_media_changer_all_obj = NACL::C::StorageTape->show_media_changer_all(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_media_changer_all_objs = NACL::C::StorageTape->show_media_changer_all(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_media_changer_all_obj = $StorageTape_obj->show_media_changer_all();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-StorageTapeShowMediaChangerAll-pm/ATTRIBUTES>
of NACL::CS::StorageTapeShowMediaChangerAll as input.
This method returns objects of the type L<NACL::CS::StorageTapeShowMediaChangerAll|lib-NACL-CS-StorageTapeShowMediaChangerAll-pm>.

=cut

sub show_media_changer_all {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::StorageTapeShowMediaChangerAll;
    my @state_objs = NACL::CS::StorageTapeShowMediaChangerAll->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_tape_drive

    my $show_tape_drive_obj = NACL::C::StorageTape->show_tape_drive(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_tape_drive_objs = NACL::C::StorageTape->show_tape_drive(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_tape_drive_obj = $StorageTape_obj->show_tape_drive();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-StorageTapeShowTapeDrive-pm/ATTRIBUTES>
of NACL::CS::StorageTapeShowTapeDrive as input.
This method returns objects of the type L<NACL::CS::StorageTapeShowTapeDrive|lib-NACL-CS-StorageTapeShowTapeDrive-pm>.

=cut

sub show_tape_drive {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::StorageTapeShowTapeDrive;
    my @state_objs = NACL::CS::StorageTapeShowTapeDrive->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_tape_drive_all

    my $show_tape_drive_all_obj = NACL::C::StorageTape->show_tape_drive_all(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_tape_drive_all_objs = NACL::C::StorageTape->show_tape_drive_all(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_tape_drive_all_obj = $StorageTape_obj->show_tape_drive_all();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-StorageTapeShowTapeDriveAll-pm/ATTRIBUTES>
of NACL::CS::StorageTapeShowTapeDriveAll as input.
This method returns objects of the type L<NACL::CS::StorageTapeShowTapeDriveAll|lib-NACL-CS-StorageTapeShowTapeDriveAll-pm>.

=cut

sub show_tape_drive_all {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::StorageTapeShowTapeDriveAll;
    my @state_objs = NACL::CS::StorageTapeShowTapeDriveAll->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_errors

    my $show_errors_obj = NACL::C::StorageTape->show_errors(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_errors_objs = NACL::C::StorageTape->show_errors(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_errors_obj = $StorageTape_obj->show_errors();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-StorageTapeShowErrors-pm/ATTRIBUTES>
of NACL::CS::StorageTapeShowErrors as input.
This method returns objects of the type L<NACL::CS::StorageTapeShowErrors|lib-NACL-CS-StorageTapeShowErrors-pm>.

=cut

sub show_errors {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::StorageTapeShowErrors;
    my @state_objs = NACL::CS::StorageTapeShowErrors->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'node'      => {type => SCALAR},
        'device-id' => {type => SCALAR},
    );
}

1;
