# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#
## @summary PortErrorShow Component Module
## @author gupendra@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here
################################################################################

=head1 NAME

NACL::C::Switch::PortErrorShow

=head1 DESCRIPTION

C<NACL::C::Switch::PortErrorShow> Is a derived class of
L<NACL::C::Component::Switch|lib-NACL-C-Component-Switch-pm>. It represents access to
Port Errors.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 port_number

Port number on switch

=cut

package NACL::C::Switch::PortErrorShow;
use NACL::CS::Switch::PortErrorShow;
###################
# Everytime
use strict;
use warnings;

###################

use base 'NACL::C::Component::Switch';

# NATE Module
use NATE::Exceptions::Argument qw(:try);
use Params::Validate qw(validate_pos validate_with SCALAR);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::ComponentUtils qw(Dumper _optional_scalars);

use Class::MethodMaker [
    new    => [ '-hash', 'init', 'new' ],
    scalar => 'port_number',
    scalar => [ { -type => 'NACL::C::Switch' }, 'command_interface', ],
];

sub _primary_keys_validate_spec {
    return (
        'port_number' => { type => SCALAR },
    );
}

1;
