#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthAlert Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemHealthAlert

=head1 DESCRIPTION

C<NACL::C::SystemHealthAlert> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemHealthAlert.  A related class is
L<NACL::CS::SystemHealthAlert|lib-NACL-CS-SystemHealthAlert-pm>, which represents
the past state of an ONTAP SystemHealthAlert.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 alert_id

=head2 alerting_managed_element

=head2 monitor

=head2 alerting_resource

=head2 node

=cut

package NACL::C::SystemHealthAlert;

use strict;
use warnings;

use NACL::CS::SystemHealthAlert;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemHealthAlert = NACL::C::SystemHealthAlert->new(command_interface=>$ci,
                                   alert_id =>$alert_id,
                                   alerting_managed_element =>$alerting_managed_element,
                                   monitor =>$monitor,
                                   alerting_resource =>$alerting_resource,
                                   node=>$node,
                                  );

Return a new SystemHealthAlert component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'alert_id',
    scalar => 'alerting_managed_element',
    scalar => 'monitor',
    scalar => 'alerting_resource',
    scalar => 'node',
];

=head2 find

    my $SystemHealthAlert  = NACL::C::SystemHealthAlert->find(command_interface => $ci, ...);
    my @SystemHealthAlerts = NACL::C::SystemHealthAlert->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $SystemHealthAlert_state = $NACL::C::SystemHealthAlert->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemHealthAlert would return
a NACL::CS::SystemHealthAlert object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 delete

   NACL::C::SystemHealthAlert->delete(
                                command_interface => $ci,
                                 alert_id => $alert_id,
                                 alerting_managed_element => $alerting_managed_element,
                                 monitor => $monitor,
                                     alerting_resource =>$alerting_resource,
                                     node=>$node,
                                  ...);

                                 or

    $SystemHealthAlert_object->delete(...);

(Class or instance method)

Uses a CMode CLI/ZAPI APISet.

Invokes 'diagnosis-delete-alert' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "alert-id" => $alert_id >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alert-id

=item C<< "alerting-managed-element" => $alerting_managed_element >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting-managed-element

=item C<< "monitor" => $monitor >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: monitor

=item C<< "node" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node


=item C<< "alerting_resource" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting_resource

=item C<< 'alerting-managed-element' => $string >>

Applicable for CMode CLI.

=item C<< 'alerting-resource' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting_resource

=item C<< 'node' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node

=item C<< 'process' => $string >>

Applicable for CMode CLI.

=item C<< 'extended_query' => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system health alert delete" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( alerting-managed-element alerting-resource node

                    process
                    )
            )
        },
        cli_cmd => 'system health alert delete',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_delete_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_delete_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::SystemHealthAlert::delete',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_health_alert_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [
        qw( alert-id alerting-managed-element monitor node alerting-resource
            )];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => $copy,
        api  => 'diagnosis_delete_alert',
    );
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_zapi

=head2 modify

   NACL::C::SystemHealthAlert->modify(
                                command_interface => $ci,
                                 alert_id => $alert_id,
                                 alerting_managed_element => $alerting_managed_element,
                                 monitor => $monitor,
                                     alerting_resource =>$alerting_resource,
                                     node=>$node,
                                  ...);

                                 or

    $SystemHealthAlert_object->modify(...);

(Class or instance method)
This method is used to modify an alert.

Uses a CMode CLI/ZAPI APISet.

Invokes 'diagnosis-alert-modify' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "alert-id" => $alert_id >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alert-id

=item C<< "alerting-managed-element" => $alerting_managed_element >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting-managed-element

=item C<< "monitor" => $monitor >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: monitor

=item C<< "acknowledge" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: acknowledge

=item C<< "suppress" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: suppress

=item C<< "suppressor" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: suppressor

=item C<< "node" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node

=item C<< "acknowledger" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: acknowledger


=item C<< "alerting-resource" => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting-resource

=item C<< 'alerting-managed-element' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting-managed-element

=item C<< 'alerting-resource' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: alerting-resource

=item C<< 'process' => $string >>

Applicable for CMode CLI.

=item C<< 'asup-enable' => $string >>

Applicable for CMode CLI.

=item C<< 'extended_query' => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system health alert modify" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( acknowledge suppress suppressor node acknowledger

                    alerting-managed-element alerting-resource

                    process
                    asup-enable
                    )
            ),
        },
        cli_cmd => 'system health alert modify',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_modify_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::SystemHealthAlert::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_health_alert_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy= [
        qw( acknowledge suppress suppressor alert-id alerting-managed-element monitor
            node acknowledger alerting-resource
            )];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => $copy,
        api  => 'diagnosis_alert_modify',
    );
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'alert-id'                 => {type => SCALAR},
        'alerting-managed-element' => {type => SCALAR, optional => 1},
        'monitor'                  => {type => SCALAR},
        'alerting-resource'        => {type => SCALAR},
        'node'                     => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
