# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthClusterSwitchInterface Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemHealthClusterSwitchInterface

=head1 DESCRIPTION

C<NACL::C::SystemHealthClusterSwitchInterface> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemHealthClusterSwitchInterface.  A related class is
L<NACL::CS::SystemHealthClusterSwitchInterface|lib-NACL-CS-SystemHealthClusterSwitchInterface-pm>, which represents
the past state of an ONTAP SystemHealthClusterSwitchInterface.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 index

=head2 device

=head2 descr

=cut

package NACL::C::SystemHealthClusterSwitchInterface;

use strict;
use warnings;

use NACL::CS::SystemHealthClusterSwitchInterface;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemHealthClusterSwitchInterface = NACL::C::SystemHealthClusterSwitchInterface->new(
                                   command_interface => $ci,
                                   'index' => $index,
                                   'device' => $device,
                                   'descr' => $descr,
								  );

Return a new SystemHealthClusterSwitchInterface component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'index',
    scalar => 'device',
    scalar => 'descr',
];

=head2 find

    my $SystemHealthClusterSwitchInterface_obj  = NACL::C::SystemHealthClusterSwitchInterface->find(command_interface => $ci, ...);
	my @SystemHealthClusterSwitchInterface_objs = NACL::C::SystemHealthClusterSwitchInterface->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemHealthClusterSwitchInterface_state = $SystemHealthClusterSwitchInterface_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemHealthClusterSwitchInterface would return 
a NACL::CS::SystemHealthClusterSwitchInterface object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 delete

    NACL::C::SystemHealthClusterSwitchInterface->delete(
                                command_interface => $ci,
	                            'index' => $index,
	                            'device' => $device,
	                            'descr' => $descr,
                                ...);
	                             
								 or

    $SystemHealthClusterSwitchInterface_obj->delete(...);

(Class or instance method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'index' => $index >>

(Required for class method, Not Applicable for instance method)
Interface Index

Applicable for CMode CLI.

=item C<< 'device' => $device >>

(Required for class method, Not Applicable for instance method)
Switch Name

Applicable for CMode CLI.

=item C<< 'descr' => $descr >>

(Required for class method, Not Applicable for instance method)
Interface Name

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    $pkg_or_obj->_frontend_log_debug_opts(@_);
    my %opts = $pkg_or_obj->_common_validate_with(params => \@_,);
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_validate_backend_opts(@_);

    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( index device descr
            extended_query )
    ];
    my %cmode_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->system_health_cluster_switch_interface_delete(%cmode_args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $SystemHealthClusterSwitchInterface_obj	= NACL::C::SystemHealthClusterSwitchInterface->create(
                                command_interface => $ci,
	                            'index' => $index,
	                            'device' => $device,
	                            'descr' => $descr,
                                ...);

(Class method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'index' => $index >>

(Required)
Interface Index

Applicable for CMode CLI.

=item C<< 'device' => $device >>

(Required)
Switch Name

Applicable for CMode CLI.

=item C<< 'descr' => $descr >>

(Required)
Interface Name

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->_frontend_log_debug_opts(@_);
    my %opts = $pkg->_common_validate_with(params => \@_,);
    my $obj = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
    );

    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = $pkg->_validate_backend_opts(@_);

    my $command_interface = delete $opts{command_interface};
    my $apiset            = delete $opts{apiset};

    my $allowed_cmode_options = [
        qw( index device descr
            extended_query )
    ];
    my %cmode_args;
    $pkg->_hash_copy(
        source => \%opts,
        copy   => $allowed_cmode_options,
        target => \%cmode_args,
    );

    $apiset->system_health_cluster_switch_interface_create(%cmode_args);
    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $command_interface,
        index             => $cmode_args{'index'},
        device            => $cmode_args{'device'},
        descr             => $cmode_args{'descr'},
    );
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'index'  => {type => SCALAR},
        'device' => {type => SCALAR},
        'descr'  => {type => SCALAR},
    );
}

1;
