# $Id$

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemLicenseStatus Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemLicenseStatus

=head1 DESCRIPTION

C<NACL::C::SystemLicenseStatus> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemLicenseStatus.  A related class is
L<NACL::CS::SystemLicenseStatus|lib-NACL-CS-SystemLicenseStatus-pm>, which represents
the past state of an ONTAP SystemLicenseStatus.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 package

=cut

package NACL::C::SystemLicenseStatus;

use strict;
use warnings;

use NACL::CS::SystemLicenseStatus;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemLicenseStatus = NACL::C::SystemLicenseStatus->new(
                                   command_interface => $ci,
                                   'package' => $package,
								  );

Return a new SystemLicenseStatus component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'package',];

=head2 find

    my $SystemLicenseStatus_obj  = NACL::C::SystemLicenseStatus->find(command_interface => $ci, ...);
	my @SystemLicenseStatus_objs = NACL::C::SystemLicenseStatus->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemLicenseStatus_state = $SystemLicenseStatus_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemLicenseStatus would return 
a NACL::CS::SystemLicenseStatus object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('package' => {type => SCALAR},);
}

1;
