# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeHardwareUnifiedConnect Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeHardwareUnifiedConnect

=head1 DESCRIPTION

C<NACL::C::SystemNodeHardwareUnifiedConnect> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeHardwareUnifiedConnect.  A related class is
L<NACL::CS::SystemNodeHardwareUnifiedConnect|lib-NACL-CS-SystemNodeHardwareUnifiedConnect-pm>, which represents
the past state of an ONTAP SystemNodeHardwareUnifiedConnect.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 adapter

=head2 node

=cut

package NACL::C::SystemNodeHardwareUnifiedConnect;

use strict;
use warnings;

use NACL::CS::SystemNodeHardwareUnifiedConnect;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $SystemNodeHardwareUnifiedConnect = NACL::C::SystemNodeHardwareUnifiedConnect->new(
                                   command_interface => $ci,
                                   'adapter' => $adapter,
                                   'node' => $node,
								  );

Return a new SystemNodeHardwareUnifiedConnect component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'adapter',
    scalar => 'node',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $SystemNodeHardwareUnifiedConnect_obj  = NACL::C::SystemNodeHardwareUnifiedConnect->find(command_interface => $ci, ...);
	my @SystemNodeHardwareUnifiedConnect_objs = NACL::C::SystemNodeHardwareUnifiedConnect->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my SystemNodeHardwareUnifiedConnect_state = $SystemNodeHardwareUnifiedConnect_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeHardwareUnifiedConnect would return 
a NACL::CS::SystemNodeHardwareUnifiedConnect object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 modify

    NACL::C::SystemNodeHardwareUnifiedConnect->modify(
                                command_interface => $ci,
	                            'adapter' => $adapter,
	                            'node' => $node,
                                ...);
	                             
								 or

    $SystemNodeHardwareUnifiedConnect_obj->modify(...);

(Class or instance method)
This method is used to modify the Fibre Channel and converged networking adapter configuration.
Uses CMode CLI/ZAPI .
Invokes  ucm-adapter-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'adapter' => $adapter >>

(Required for class method, Not Applicable for instance method)
Adapter
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: adapter-name

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: node-name

=item C<< 'mode' => $string >>

Configured Mode possible value(s) are, fc,cna
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'type' => $string >>

Configured Type possible value(s) are, initiator,target
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'force' => $string >>

Force
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "system node hardware unified connect modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( mode type force
                    )
            ),
        },
        api => 'system_node_hardware_unified_connect_modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::SystemNodeHardwareUnifiedConnect::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_node_hardware_unified_connect_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(mode)];
    my $map  = {
        'adapter' => 'adapter-name',
        'node'    => 'node-name',
        'type'    => 'fc4-type',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'ucm-adapter-modify',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'adapter' => {type => SCALAR},
        'node'    => {type => SCALAR},
    );
}

1;
