# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeServiceProcessorAutosupport Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeServiceProcessorAutosupport

=head1 DESCRIPTION

C<NACL::C::SystemNodeServiceProcessorAutosupport> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. Unlike other components this
package does not model any element/service but is present to provide
component-level support for functionality. Since it does not model any
element/service there is no ComponentState module for this component.
For the same reason, 'find' and 'state' will not work for this component.
Instead NACL::CS::SystemNodeServiceProcessorAutosupport->fetch() should be used.
(See L<fetch|lib-NACL-CS-ComponentState-pm/fetch> for a full description)

=cut

=head1 ATTRIBUTES

None.

=cut

package NACL::C::SystemNodeServiceProcessorAutosupport;

use strict;
use warnings;

use NACL::ComponentUtils qw (_optional_scalars );

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemNodeServiceProcessorAutosupport = NACL::C::SystemNodeServiceProcessorAutosupport->new(
                                   command_interface => $ci,
                                  );

Return a new SystemNodeServiceProcessorAutosupport component object with the given attributes.

=cut

=head2 invoke

    NACL::C::SystemNodeServiceProcessorAutosupport->invoke(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to generate an AutoSupport from the Service Processor.

Uses CMode CLI, 7Mode CLI APISet.

Invokes 'system node service processor autosupport' command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'node' => $string >>

(Optional)
The name of the node on which the autosupport should be invoked

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI: -node <value> (Programmatic name: nodename)

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node service-processor autosupport invoke" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub invoke {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( node
                    )
            ),
        },
        ignore_primary_keys => 1,
        api => 'system_node_service_processor_autosupport_invoke',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_invoke_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_invoke_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        frontend => 'NACL::C::SystemNodeServiceProcessorAutosupport::invoke',
    );

    $Log->exit() if $may_exit;
} ## end sub invoke

sub _invoke_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_service_processor_autosupport_invoke',);
    $Log->exit() if $may_exit;
} ## end sub _invoke_cmode_cli

sub _invoke_7mode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts   = $pkg->_validate_backend_opts(@args);
    my $apiset = delete $opts{apiset};

    my %invoke_args;
    $pkg->_hash_copy(
        source => \%opts,
        map    => {'node' => 'nodename',},
        target => \%invoke_args,
    );
    $invoke_args{invoke} = '1';

    $apiset->system_node_service_processor_autosupport(%invoke_args);
    $Log->exit() if $may_exit;

}

__PACKAGE__->_load_event_class();

1;
