# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeUpgradeRevert Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemNodeUpgradeRevert

=head1 DESCRIPTION

C<NACL::C::SystemNodeUpgradeRevert> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemNodeUpgradeRevert.  A related class is
L<NACL::CS::SystemNodeUpgradeRevert|lib-NACL-CS-SystemNodeUpgradeRevert-pm>, which represents
the past state of an ONTAP SystemNodeUpgradeRevert.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 startup_phase

=head2 upgrade_version

=head2 node

=cut

package NACL::C::SystemNodeUpgradeRevert;

use strict;
use warnings;

use NACL::CS::SystemNodeUpgradeRevert;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $SystemNodeUpgradeRevert = NACL::C::SystemNodeUpgradeRevert->new(
                                   command_interface => $ci,
                                   'startup-phase' => $startup_phase,
                                   'upgrade-version' => $upgrade_version,
                                   'node' => $node,
								  );

Return a new SystemNodeUpgradeRevert component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'startup_phase',
    scalar => 'upgrade_version',
    scalar => 'node',
];

=head2 find

    my $SystemNodeUpgradeRevert_obj  = NACL::C::SystemNodeUpgradeRevert->find(command_interface => $ci, ...);
	my @SystemNodeUpgradeRevert_objs = NACL::C::SystemNodeUpgradeRevert->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my SystemNodeUpgradeRevert_state = $SystemNodeUpgradeRevert_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemNodeUpgradeRevert would return 
a NACL::CS::SystemNodeUpgradeRevert object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_task_status

    my $method_obj  = NACL::C::SystemNodeUpgradeRevert->show_task_status(command_interface => $ci,
                          [ filter => { %filter } ,]
						  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my $method_objs = NACL::C::SystemNodeUpgradeRevert->show_task_status(command_interface => $ci,
                          [ filter => { %filter } ,]
						  [ requested_fields => [ @req_fields ]);

(Class method)
This method returns objects of the type L<NACL::CS::SystemNodeUpgradeRevertShowTaskStatus|lib-NACL-CS-SystemNodeUpgradeRevertShowTaskStatus-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch> 
(requested_fields, filter, allow_empty) and has all of the other properties of 
fetch methods (callable in scalar or list context, throws a NoElementsFound 
exception if no matching elements are found)

=cut

sub show_task_status {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    require NACL::CS::SystemNodeUpgradeRevertShowTaskStatus;
    my @state_objs
        = NACL::CS::SystemNodeUpgradeRevertShowTaskStatus->fetch(@_);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub show_task_status

=head2 upgrade

    NACL::C::SystemNodeUpgradeRevert->upgrade(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to run the upgrade at a specific phase..

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node upgrade revert upgrade" command in ONTAP.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub upgrade {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_upgrade',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_upgrade_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeUpgradeRevert::upgrade',
    );

    $Log->exit() if $may_exit;
} ## end sub upgrade

sub _upgrade_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_upgrade_revert_upgrade',);
    $Log->exit() if $may_exit;
} ## end sub _upgrade_cmode_cli

=head2 revert_chk

    NACL::C::SystemNodeUpgradeRevert->revert_chk(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to run the revert check command..

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node upgrade revert revert chk" command in ONTAP.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub revert_chk {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_revert_chk',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_revert_chk_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeUpgradeRevert::revert_chk',
    );

    $Log->exit() if $may_exit;
} ## end sub revert_chk

sub _revert_chk_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_upgrade_revert_revert_chk',);
    $Log->exit() if $may_exit;
} ## end sub _revert_chk_cmode_cli

=head2 revert_clr

    NACL::C::SystemNodeUpgradeRevert->revert_clr(
                                command_interface => $ci,
                                ...);

(Class method)
This method is used to run the revert clear command - emptys the U/R upgrade status table..

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node upgrade revert revert clr" command in ONTAP.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub revert_clr {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params              => \@args,
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_revert_clr',

    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_revert_clr_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeUpgradeRevert::revert_clr',
    );

    $Log->exit() if $may_exit;
} ## end sub revert_clr

sub _revert_clr_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_upgrade_revert_revert_clr',);
    $Log->exit() if $may_exit;
} ## end sub _revert_clr_cmode_cli

=head2 upgrade_task

    NACL::C::SystemNodeUpgradeRevert->upgrade_task(
                                command_interface => $ci,
	                            'startup-phase' => $startup_phase,
                                ...);

(Class method)
This method is used to upgrade a specific task..

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'startup-phase' => $startup_phase >>

(Required)

Applicable for CMode CLI.

=item C<< 'version' => $string >>

Applicable for CMode CLI.

=item C<< 'process' => $string >>

Applicable for CMode CLI.

=item C<< 'task-id' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node upgrade revert upgrade task" command in ONTAP.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub upgrade_task {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( version startup-phase process task-id
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_upgrade_task',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_upgrade_task_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeUpgradeRevert::upgrade_task',
    );

    $Log->exit() if $may_exit;
} ## end sub upgrade_task

sub _upgrade_task_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_upgrade_revert_upgrade_task',);
    $Log->exit() if $may_exit;
} ## end sub _upgrade_task_cmode_cli

=head2 revert

    NACL::C::SystemNodeUpgradeRevert->revert(
                                command_interface => $ci,
	                            'startup-phase' => $startup_phase,
                                ...);

(Class method)
This method is used to run the revert at a specific revert phase..

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'startup-phase' => $startup_phase >>

(Required)

Applicable for CMode CLI.

=item C<< 'version' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"system node upgrade revert revert" command in ONTAP.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub revert {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( startup-phase version
                    )
            ),
        },
        ignore_primary_keys => 1,
        api                 => 'system_node_upgrade_revert_revert',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_revert_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::SystemNodeUpgradeRevert::revert',
    );

    $Log->exit() if $may_exit;
} ## end sub revert

sub _revert_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'system_node_upgrade_revert_revert',);
    $Log->exit() if $may_exit;
} ## end sub _revert_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'startup-phase'   => {type => SCALAR},
        'upgrade-version' => {type => SCALAR},
        'node'            => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
