# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemServiceProcessorNetwork Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::SystemServiceProcessorNetwork

=head1 DESCRIPTION

C<NACL::C::SystemServiceProcessorNetwork> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP SystemServiceProcessorNetwork.  A related class is
L<NACL::CS::SystemServiceProcessorNetwork|lib-NACL-CS-SystemServiceProcessorNetwork-pm>, which represents
the past state of an ONTAP SystemServiceProcessorNetwork.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 address_family

=head2 node

=cut

package NACL::C::SystemServiceProcessorNetwork;

use strict;
use warnings;

use NACL::CS::SystemServiceProcessorNetwork;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF SCALARREF OBJECT);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $SystemServiceProcessorNetwork = NACL::C::SystemServiceProcessorNetwork->new(
                                   command_interface => $ci,
                                   'address-family' => $address_family,
                                   'node' => $node,
								  );

Return a new SystemServiceProcessorNetwork component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'address_family',
    scalar => 'address_type',
    scalar => 'node',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $SystemServiceProcessorNetwork_obj  = NACL::C::SystemServiceProcessorNetwork->find(command_interface => $ci, ...);
	my @SystemServiceProcessorNetwork_objs = NACL::C::SystemServiceProcessorNetwork->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my SystemServiceProcessorNetwork_state = $SystemServiceProcessorNetwork_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::SystemServiceProcessorNetwork would return 
a NACL::CS::SystemServiceProcessorNetwork object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 modify

    NACL::C::SystemServiceProcessorNetwork->modify(
                                command_interface => $ci,
	                            'address-family' => $address_family,
	                            'node' => $node,
                                ...);
	                             
								 or

    $SystemServiceProcessorNetwork_obj->modify(...);

(Class or instance method)
This method is used to modify the network configuration.
Uses CMode CLI/ZAPI .
Invokes  service-processor-network-modify-iter for CMode Zapi iter
Invokes  service-processor-network-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'address-family' => $address_family >>

(Required for class method, Not Applicable for instance method)
Address Family possible value(s) are, IPv4,IPv6
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info address-type="$value" />

Mapping for non-iter: address-type

=item C<< 'node' => $node >>

(Required for class method, Not Applicable for instance method)
Node possible value(s) are, <nodename>,local
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info node="$value" />

=item C<< 'enable' => $string >>

Interface Enabled possible value(s) are, true,false
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info is-enabled="$value" />

Mapping for non-iter: is-enabled

=item C<< 'gateway-mac' => $string >>

MAC Address of the Gateway
Applicable for CMode CLI/ZAPI iter, non-iter.

=item C<< 'gateway' => $string >>

Gateway IP Address
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info gateway-ip-address="$value" />

Mapping for non-iter: gateway-ip-address

=item C<< 'prefix-length' => $string >>

Prefix Length of Subnet Mask ranges from 0 to 64
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info prefix-length="$value" />

=item C<< 'arp-interval' => $string >>

Gratuitous ARP Interval ranges from 0 to 60
Applicable for CMode CLI/ZAPI iter, non-iter.

=item C<< 'netmask' => $string >>

Netmask
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info netmask="$value" />

=item C<< 'ip-address' => $string >>

IP Address
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info ip-address="$value" />

=item C<< 'dhcp' => $string >>

DHCP Status possible value(s) are, v4,none
Applicable for CMode CLI/ZAPI iter, non-iter.

Mapping for iter-zapi: <service-processor-network-info dhcp="$value" />

=item C<< '*' >>

This method takes all other options supported by "system service processor network modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( enable gateway-mac gateway prefix-length arp-interval netmask ip-address dhcp
                    address-type node address-family)
            ),
        },
        api => 'system_service_processor_network_modify',
    );
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_check_non_iter'
            },
        ],
        frontend => 'NACL::C::SystemServiceProcessorNetwork::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'system_service_processor_network_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    require NACL::C::Exceptions::SystemServiceProcessorNetwork::DoesNotExist;
    my $copy = [
        qw(link-status status prefix-length node netmask ip-address
            setup-failure-reason setup-status is-ipv6-ra-enabled subnet-name dhcp
            address-type)
    ];
    my $map = {
        'gateway'        => 'gateway-ip-address',
        'router-ip'      => 'router-ip-address',
        'address-family' => 'address-type',
        'link-local-ip'  => 'link-local-ip-address',
        'mac'            => 'mac-address',
        'enable'         => 'is-enabled',
        'type'           => 'device-type',
    };
    $pkg_or_obj->_iter_helper(
        @opts,
        api      => 'service-processor-network-modify-iter',
        show_cmd => 'system service-processor network show',
        copy     => $copy,
        map      => $map,
        does_not_exist_exception =>
            'NACL::C::Exceptions::SystemServiceProcessorNetwork::DoesNotExist',
        fix_api_args => sub {
            # Normally only the primary keys go in query, and the rest go in
            # attributes. However, for this call, "address-type" is also a
            # key, so that also needs to go in query
            my %api_args = @_;
            my %attributes = %{$api_args{attributes}};
            my %query      = %{$api_args{query}};
            if (defined $attributes{'address-type'}) {
                $query{'address-type'} = delete $attributes{'address-type'};
            }
            return (query => \%query, attributes => \%attributes);
        },
    );
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(prefix-length node ip-address netmask dhcp address-type)];
    my $map  = {
        'enable'         => 'is-enabled',
        'gateway'        => 'gateway-ip-address',
        'address-family' => 'address-type',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'service-processor-network-modify',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(address-family node)],
        _vs_context   => 0
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    my ($pkg_or_obj, %opts) = @_;
    my $command_interface = $opts{command_interface}
        || $pkg_or_obj->command_interface();
    return (
        'address-family' => {type => SCALAR},
        'node'           => {type => SCALAR},
    );
}

1;
