# $Id$
#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeSnaplock Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VolumeSnaplock

=head1 DESCRIPTION

C<NACL::C::VolumeSnaplock> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VolumeSnaplock.  A related class is
L<NACL::CS::VolumeSnaplock|lib-NACL-CS-VolumeSnaplock-pm>, which represents
the past state of an ONTAP VolumeSnaplock.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 volume

=head2 vserver

=cut

package NACL::C::VolumeSnaplock;

use strict;
use warnings;

use NACL::CS::VolumeSnaplock;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VolumeSnaplock = NACL::C::VolumeSnaplock->new(
                                   command_interface => $ci,
                                   'volume' => $volume,
                                   'vserver' => $vserver,
								  );

Return a new VolumeSnaplock component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'volume',
    scalar => 'vserver',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VolumeSnaplock_obj  = NACL::C::VolumeSnaplock->find(command_interface => $ci, ...);
    my @VolumeSnaplock_objs = NACL::C::VolumeSnaplock->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VolumeSnaplock_state = $VolumeSnaplock_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VolumeSnaplock would return
a NACL::CS::VolumeSnaplock object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VolumeSnaplock->modify(
                                command_interface => $ci,
	                            'volume' => $volume,
	                            'vserver' => $vserver,
                                ...);
		 or

    $VolumeSnaplock_obj->modify(...);

(Class or instance method)
This method is used to modifies snaplock attributes of a snaplock volume..
Uses CMode CLI/ZAPI .
Invokes  volume-set-snaplock-attrs  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'volume' => $volume >>

(Required for class method, Not Applicable for instance method)
Volume Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'maximum-retention-period' => $string >>


Maximum Retention Period possible value(s) are, {<integer> seconds,minutes,hours,days,months,years} , infinite
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'minimum-retention-period' => $string >>


Minimum Retention Period possible value(s) are, {<integer> seconds,minutes,hours,days,months,years} , infinite
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'default-retention-period' => $string >>


Default Retention Period possible value(s) are, {<integer> seconds,minutes,hours,days,months,years} , min , max , infinite
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'autocommit-period' => $string >>

Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "volume snaplock modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( maximum-retention-period minimum-retention-period
                    default-retention-period autocommit-period
                    )
            ),
        },
        cli_cmd => 'volume snaplock modify',
    );

    my $vserver;                            # With burt932785, this ZAPIs will be supported only in ontap-vserver family
    $opts{vserver_operated_on} = \$vserver; # and not in ontap-cluster family
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VolumeSnaplock::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'volume_snaplock_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $copy = [
        qw(volume maximum-retention-period minimum-retention-period
            default-retention-period autocommit-period)
    ];
    my %map = ();
    my $api = 'volume-set-snaplock-attrs';

    # as a part of burt #1011651 api "snaplock-volume-set-privileged-delete" will be invoked
     #if "privileged-delete" is passed in call to modify()
    if ($opts{'privileged-delete'}) {
        $api = 'snaplock-volume-set-privileged-delete';
        %map =  ( 'privileged-delete' => 'state'  );

    }
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api  => $api,
        copy => $copy,
        map  => \%map,
    );
    $Log->exit() if $may_exit;
}

=head2 set_privileged_delete

    NACL::C::VolumeSnaplock->set_privileged_delete(
                                command_interface => $ci,
                                    'volume' => $volume,
                                    'vserver' => $vserver,
                                ...);

                                                                 or

    $VolumeSnaplock_obj->set_privileged_delete(...);

(Class or instance method)
This method is used to set the Privileged Delete state on a Snaplock Enterprise Volume.
Uses CMode CLI/ZAPI .
Invokes  snaplock-volume-set-privileged-delete  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'volume' => $volume >>

(Required for class method, Not Applicable for instance method)
Volume
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'state' => $string >>

Privileged Delete State possible value(s) are, off,on,disallowed
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "volume snaplock set privileged delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub set_privileged_delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( state
                    )
            ),
        },
        cli_cmd => 'volume snaplock set-privileged-delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_set_privileged_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_set_privileged_delete_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VolumeSnaplock::set_privileged_delete',
    );

    $Log->exit() if $may_exit;
}

sub _set_privileged_delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'volume_snaplock_set_privileged_delete',);
    $Log->exit() if $may_exit;
}

sub _set_privileged_delete_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(volume state)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'snaplock-volume-set-privileged-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(volume vserver)],
        _vs_context   => 1
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'volume'  => {type => SCALAR},
        'vserver' => {type => SCALAR},
    );
}

1;
