# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsDomainPasswordSchedule Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsDomainPasswordSchedule

=head1 DESCRIPTION

C<NACL::C::VserverCifsDomainPasswordSchedule> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverCifsDomainPasswordSchedule.  A related class is
L<NACL::CS::VserverCifsDomainPasswordSchedule|lib-NACL-CS-VserverCifsDomainPasswordSchedule-pm>, which represents
the past state of an ONTAP VserverCifsDomainPasswordSchedule.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=cut

package NACL::C::VserverCifsDomainPasswordSchedule;

use strict;
use warnings;

use NACL::CS::VserverCifsDomainPasswordSchedule;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverCifsDomainPasswordSchedule = NACL::C::VserverCifsDomainPasswordSchedule->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
								  );

Return a new VserverCifsDomainPasswordSchedule component object with the given attributes.

=cut

use Class::MethodMaker [scalar => 'vserver',];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverCifsDomainPasswordSchedule_obj  = NACL::C::VserverCifsDomainPasswordSchedule->find(command_interface => $ci, ...);
	my @VserverCifsDomainPasswordSchedule_objs = NACL::C::VserverCifsDomainPasswordSchedule->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverCifsDomainPasswordSchedule_state = $VserverCifsDomainPasswordSchedule_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverCifsDomainPasswordSchedule would return 
a NACL::CS::VserverCifsDomainPasswordSchedule object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverCifsDomainPasswordSchedule->modify(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $VserverCifsDomainPasswordSchedule_obj->modify(...);

(Class or instance method)
This method is used to modify the domain account password change schedule.
Uses CMode CLI/ZAPI .
Invokes  cifs-domain-password-schedule-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'schedule-randomized-minute' => $string >>


Minutes Within Which Schedule Start Can be Randomized ranges from 1 to 180
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'is-schedule-enabled' => $string >>

Is Password Change Schedule Enabled possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'schedule-time-of-day' => $string >>

Start Time for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-called-from-ui' => $string >>


Called From CIFS Password Schedule Change UI possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-job-is-queued' => $string >>

Password Change Job Queued/Dequeued possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-randomJob-id' => $string >>

Random Job Id for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'schedule-weekly-interval' => $string >>

Interval in Weeks for Password Change Schedule ranges from 1 to 52
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-randomJob-name' => $string >>

Random Job Name for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-job-name' => $string >>

Job Name for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'schedule-day-of-week' => $string >>

Day of Week for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-schedule-counter' => $string >>

Counter for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-job-id' => $string >>

Job Id for Password Change Schedule
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'pwdchange-schedule-last-changed' => $string >>

Time at Which Last Successful Password Change Occured
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver cifs domain password schedule modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( schedule-randomized-minute is-schedule-enabled schedule-time-of-day
                    pwdchange-called-from-ui pwdchange-job-is-queued pwdchange-randomJob-id
                    schedule-weekly-interval pwdchange-randomJob-name pwdchange-job-name
                    schedule-day-of-week pwdchange-schedule-counter pwdchange-job-id
                    pwdchange-schedule-last-changed
                    )
            ),
        },
        cli_cmd => 'vserver cifs domain password schedule modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverCifsDomainPasswordSchedule::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_domain_password_schedule_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [
        qw(schedule-randomized-minute schedule-time-of-day is-schedule-enabled
            schedule-weekly-interval schedule-day-of-week)
    ];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-domain-password-schedule-modify',
        copy => $copy,
        zapi_field_translations =>
            {cron_time_integer => [qw(schedule-day-of-week)],},
    );
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(vserver)],
        _vs_context   => 1
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return ('vserver' => {type => SCALAR},);
}

1;
