# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUsersAndGroupsLocalGroup Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverCifsUsersAndGroupsLocalGroup

=head1 DESCRIPTION

C<NACL::C::VserverCifsUsersAndGroupsLocalGroup> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverCifsUsersAndGroupsLocalGroup.  A related class is
L<NACL::CS::VserverCifsUsersAndGroupsLocalGroup|lib-NACL-CS-VserverCifsUsersAndGroupsLocalGroup-pm>, which represents
the past state of an ONTAP VserverCifsUsersAndGroupsLocalGroup.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 group_name

=cut

package NACL::C::VserverCifsUsersAndGroupsLocalGroup;

use strict;
use warnings;

use NACL::CS::VserverCifsUsersAndGroupsLocalGroup;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverCifsUsersAndGroupsLocalGroup = NACL::C::VserverCifsUsersAndGroupsLocalGroup->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'group-name' => $group_name,
                                  );

Return a new VserverCifsUsersAndGroupsLocalGroup component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'group_name',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverCifsUsersAndGroupsLocalGroup_obj  = NACL::C::VserverCifsUsersAndGroupsLocalGroup->find(command_interface => $ci, ...);
    my @VserverCifsUsersAndGroupsLocalGroup_objs = NACL::C::VserverCifsUsersAndGroupsLocalGroup->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
This method executes cifs-local-group-get-iter of CMode ZAPI.

=head2 state

    my VserverCifsUsersAndGroupsLocalGroup_state = $VserverCifsUsersAndGroupsLocalGroup_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverCifsUsersAndGroupsLocalGroup would return
a NACL::CS::VserverCifsUsersAndGroupsLocalGroup object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

=head2 show_sid

    my $show_sid_obj = NACL::C::VserverCifsUsersAndGroupsLocalGroup->show_sid(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_sid_objs = NACL::C::VserverCifsUsersAndGroupsLocalGroup->show_sid(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_sid_obj = $VserverCifsUsersAndGroupsLocalGroup_obj->show_sid();

(Class or Instance method)
This method returns objects of the type L<NACL::CS::VserverCifsUsersAndGroupsLocalGroupShowSid|lib-NACL-CS-VserverCifsUsersAndGroupsLocalGroupShowSid-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch>
(requested_fields, filter, allow_empty) and has all of the other properties of
fetch methods (callable in scalar or list context, throws a NoElementsFound
exception if no matching elements are found)

=cut

sub show_sid {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::VserverCifsUsersAndGroupsLocalGroupShowSid;
    my @state_objs
        = NACL::CS::VserverCifsUsersAndGroupsLocalGroupShowSid->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_members

    my $show_members_obj = NACL::C::VserverCifsUsersAndGroupsLocalGroup->show_members(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

    my @show_members_objs = NACL::C::VserverCifsUsersAndGroupsLocalGroup->show_members(command_interface => $ci,
                          [ filter => { %filter } ,]
              [ requested_fields => [ @req_fields ]);

                    or

   my $show_members_obj = $VserverCifsUsersAndGroupsLocalGroup_obj->show_members();

(Class or Instance method)
This method returns objects of the type L<NACL::CS::VserverCifsUsersAndGroupsLocalGroupShowMembers|lib-NACL-CS-VserverCifsUsersAndGroupsLocalGroupShowMembers-pm>.

This method accepts all the parameters accepted by L<fetch|lib-NACL-CS-ComponentState-pm/fetch>
(requested_fields, filter, allow_empty) and has all of the other properties of
fetch methods (callable in scalar or list context, throws a NoElementsFound
exception if no matching elements are found)

=cut

sub show_members {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = $pkg_or_obj->_handle_obj_cs_like_calls(@_);
    require NACL::CS::VserverCifsUsersAndGroupsLocalGroupShowMembers;
    my @state_objs
        = NACL::CS::VserverCifsUsersAndGroupsLocalGroupShowMembers->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 delete

    NACL::C::VserverCifsUsersAndGroupsLocalGroup->delete(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'group-name' => $group_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalGroup_obj->delete(...);

(Class or instance method)
This method is used to delete a local group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-group-delete" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'group-name' => $group_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: group-name

=item C<< 'domain-name' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-group delete" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain-name
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-group delete',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalGroup::delete',
        nacl_exceptions => [qw(DoesNotExist)],
    );

    $Log->exit() if $may_exit;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_group_delete',);
    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(group-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-group-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 remove_members

    NACL::C::VserverCifsUsersAndGroupsLocalGroup->remove_members(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'group-name' => $group_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalGroup_obj->remove_members(...);

(Class or instance method)
This method is used to remove members from a local group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-group-members-remove-members" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< '' => $group_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: group-name

=item C<< 'member-sid' => $string >>

Applicable for CMode CLI.

=item C<< 'member-names' => [ $member-name1, $member-name2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: member-names

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-group remove-members" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub remove_members {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'member-names' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( member-sid
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-group remove-members',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_remove_members_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_remove_members_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsLocalGroup::remove_members',
            nacl_exceptions => [qw(MemberDoesNotExist)],
    );

    $Log->exit() if $may_exit;
} ## end sub remove_members

sub _remove_members_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_group_remove_members',);
    $Log->exit() if $may_exit;
} ## end sub _remove_members_cmode_cli

sub _remove_members_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(member-names group-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-group-members-remove-members',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 add_members

    NACL::C::VserverCifsUsersAndGroupsLocalGroup->add_members(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'group-name' => $group_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalGroup_obj->add_members(...);

(Class or instance method)
This method is used to add members to a local group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-group-members-add-members" API for CMode ZAPI.


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'group-name' => $group_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: group-name

=item C<< 'member-sid' => $string >>

Applicable for CMode CLI.

=item C<< 'member-names' => [ $member-name1, $member-name2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: member-names

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-group add-members" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub add_members {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'member-names' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( member-sid
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-group add-members',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_add_members_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_add_members_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverCifsUsersAndGroupsLocalGroup::add_members',
            nacl_exceptions => [qw(MemberAlreadyExists)],
    );

    $Log->exit() if $may_exit;
} ## end sub add_members

sub _add_members_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_group_add_members',);
    $Log->exit() if $may_exit;
} ## end sub _add_members_cmode_cli

sub _add_members_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(member-names group-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-group-members-add-members',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverCifsUsersAndGroupsLocalGroup_obj    = NACL::C::VserverCifsUsersAndGroupsLocalGroup->create(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'group-name' => $group_name,
                                ...);

(Class method)
This method is used to create a local group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-group-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'group-name' => $group_name >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: group-name

=item C<< 'domain-name' => $string >>

Applicable for CMode CLI.

=item C<< 'description' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: description

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-group create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain-name description
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-group create',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalGroup::create',
        nacl_exceptions => [qw(AlreadyExists)],
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        vserver           => $vserver,
        group_name        => $opts{'group-name'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub create

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_group_create',);
    $Log->exit() if $may_exit;
} ## end sub _create_cmode_cli

sub _create_cmode_zapi {  
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(group-name description)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-group-create',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 rename

    NACL::C::VserverCifsUsersAndGroupsLocalGroup->rename(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'group-name' => $group_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalGroup_obj->rename(...);

(Class or instance method)
This method is used to rename a local group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-group-rename" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'group-name' => $group_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: group-name

=item C<< 'new-group-name' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: new-group-name

=item C<< 'domain-name' => $string >>

Applicable for CMode CLI.

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-group rename" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub rename {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( new-group-name domain-name
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-group rename',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_rename_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_rename_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalGroup::rename',
    );

    $pkg_or_obj->group_name($opts{'new-group-name'})
        if (ref $pkg_or_obj);
    $Log->exit() if $may_exit;
} ## end sub rename

sub _rename_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_group_rename',);
    $Log->exit() if $may_exit;
} ## end sub _rename_cmode_cli

sub _rename_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(new-group-name group-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-group-rename',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverCifsUsersAndGroupsLocalGroup->modify(
                                command_interface => $ci,
                                'vserver' => $vserver,
                                'group-name' => $group_name,
                                ...);

                                 or

    $VserverCifsUsersAndGroupsLocalGroup_obj->modify(...);

(Class or instance method)
This method is used to modify a local group.

Uses a CMode CLI/ZAPI APISet.

Invokes "cifs-local-group-modify " API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

=item C<< 'group-name' => $group_name >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: group-name

=item C<< 'domain-name' => $string >>

Applicable for CMode CLI.

=item C<< 'description' => $string >>

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: description

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver cifs users-and-groups local-group modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( domain-name description
                    )
            ),
        },
        cli_cmd => 'vserver cifs users-and-groups local-group modify',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverCifsUsersAndGroupsLocalGroup::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_cifs_users_and_groups_local_group_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(group-name description)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'cifs-local-group-modify',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'    => {type => SCALAR},
        'group-name' => {type => SCALAR},
    );
}

1;
