# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverFcpPortname Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverFcpPortname

=head1 DESCRIPTION

C<NACL::C::VserverFcpPortname> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverFcpPortname.  A related class is
L<NACL::CS::VserverFcpPortname|lib-NACL-CS-VserverFcpPortname-pm>, which represents
the past state of an ONTAP VserverFcpPortname.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 lif

=cut

package NACL::C::VserverFcpPortname;

use strict;
use warnings;

use NACL::CS::VserverFcpPortname;
use NACL::ComponentUtils qw (Dumper _optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF UNDEF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverFcpPortname = NACL::C::VserverFcpPortname->new(command_interface=>$ci,
                                   vserver =>$vserver,
                                   lif     =>$lif,
                                   adapter =>$adapter,
                                  );

Return a new VserverFcpPortname component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'lif',
    scalar => 'adapter',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverFcpPortname  = NACL::C::VserverFcpPortname->find(command_interface => $ci, ...);
    my @VserverFcpPortnames = NACL::C::VserverFcpPortname->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $VserverFcpPortname_state = $NACL::C::VserverFcpPortname->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverFcpPortname would return
a NACL::CS::VserverFcpPortname object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

   NACL::C::VserverFcpPortname->modify(
                                command_interface => $ci,
                                 vserver => $vserver,
                                     lif     => $lif
                                  ...);

                                 or

    $VserverFcpPortname_object->modify(...);

(Class or instance method)
This method is used to modify WWPN for an FCP adapter.

Uses a CMode CLI APISet.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "adapter" => $string >>

Applicable for CMode CLI.

=item C<< "wwpn" => $string >>

Applicable for CMode CLI.

=item C<< "lif" => $string >>

(Required)

Applicable for CMode CLI.

=item C<< "force" => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver fcp portname modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( adapter wwpn force
                    )
            ),
        },
        api => 'vserver_fcp_portname_modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::VserverFcpPortname::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_fcp_portname_modify',);
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

=head2 set

   NACL::C::VserverFcpPortname->set(
                                command_interface => $ci,
                                 vserver => $vserver,
                                     lif     => $lif,
                                  ...);

                                 or

    $VserverFcpPortname_object->set(...);

(Class or instance method)
This method is used to assigns a new WWPN to a FCP adapter.

Uses a CMode CLI/ZAPI, 7Mode CLI APISet.

Invokes "fcp-port-name-set" API for CMode ZAPI.

Invokes "fcp portname set" command for 7Mode CLI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< "adapter" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : adapter name (Programmatic name: "adapter")

=item C<< "wwpn" => $string >>

Applicable for CMode CLI/ZAPI,7Mode CLI.

Maps to:

CM ZAPI: port-name

7M CLI : wwpn port (Programmatic name: "wwpn")

=item C<< "lif" => $string >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: fcp-adapter

=item C<< "force" => $string >>

Applicable for CMode CLI, 7Mode CLI.

Maps to:

7M CLI : -f (Programmatic name: "force")

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI.

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver fcp portname set" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub set {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( adapter wwpn force

                    lif
                    )
            ),
        },
        cli_cmd => 'vserver fcp portname set',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_set_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
            {   method    => "_set_cmode_zapi",
                interface => "ZAPI",
                set       => "CMode",
            },
            {   method    => "_set_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },
        ],
        frontend => 'NACL::C::VserverFcpPortname::set',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub set

sub _set_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_fcp_portname_set',);
    $Log->exit() if $may_exit;
} ## end sub _set_cmode_cli

sub _set_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_zapi(
        @opts,
        copy => [qw(node)],
        map    => {
            'lif'  => 'fcp-adapter',
            'wwpn' => 'port-name',
        },
        api  => 'fcp_port_name_set',
    );
    $Log->exit() if $may_exit;
} ## end sub _set_cmode_zapi

sub _set_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );
    my $command_interface     = delete $opts{command_interface};
    my $apiset                = delete $opts{apiset};
    my $prompts_answers       = ['.*Do you want to continue.*' => 'y'];
    my $allowed_7mode_options = [
        qw( force adapter wwpn
            )
    ];
    my %fcp_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        copy   => $allowed_7mode_options,
        target => \%fcp_args,
    );
    %opts = %fcp_args;

    $apiset->fcp_portname_set(%opts,
        "connectrec-match_table" => $prompts_answers);
    $Log->exit() if $may_exit;
} ## end sub _set_7mode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR | UNDEF, optional => 1},
        'adapter' => {type => SCALAR | UNDEF, optional => 1},
        'lif'     => {type => SCALAR | UNDEF, optional => 1},
    );
} ## end sub _primary_keys_validate_spec

1;
