#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverIscsiPortal Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverIscsiPortal

=head1 DESCRIPTION

C<NACL::C::VserverIscsiPortal> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverIscsiPortal.  A related class is
L<NACL::CS::VserverIscsiPortal|lib-NACL-CS-VserverIscsiPortal-pm>, which represents
the past state of an ONTAP VserverIscsiPortal.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 lif

=cut

package NACL::C::VserverIscsiPortal;

use strict;
use warnings;

use NACL::CS::VserverIscsiPortal;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $VserverIscsiPortal = NACL::C::VserverIscsiPortal->new(command_interface=>$ci,
                                   vserver =>$vserver,
                                   lif =>$lif,
                            );

Return a new VserverIscsiPortal component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'lif',
];

=head2 find

    my $VserverIscsiPortal  = NACL::C::VserverIscsiPortal->find(command_interface => $ci, ...);
    my @VserverIscsiPortals = NACL::C::VserverIscsiPortal->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $VserverIscsiPortal_state = $NACL::C::VserverIscsiPortal->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverIscsiPortal would return
a NACL::CS::VserverIscsiPortal object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 vserver_iscsi_interface_show

    my $vserver_iscsi_interface_show_obj = NACL::C::VserverIscsiPortal->vserver_iscsi_interface_show(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @vserver_iscsi_interface_show_objs = NACL::C::VserverIscsiPortal->vserver_iscsi_interface_show(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $vserver_iscsi_interface_show_obj = $VserverIscsiPortal_obj->vserver_iscsi_interface_show(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverIscsiPortalVserverIscsiInterfaceShow-pm/ATTRIBUTES>
of NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow as input. 
This method returns objects of the type L<NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow|lib-NACL-CS-VserverIscsiPortalVserverIscsiInterfaceShow-pm>.

=cut

sub vserver_iscsi_interface_show {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow;
    my @state_objs
        = NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver' => {type => SCALAR, optional => 1},
        'lif'     => {type => SCALAR},
    );
}
1;
