# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverIscsiSession Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverIscsiSession

=head1 DESCRIPTION

C<NACL::C::VserverIscsiSession> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverIscsiSession.  A related class is
L<NACL::CS::VserverIscsiSession|lib-NACL-CS-VserverIscsiSession-pm>, which represents
the past state of an ONTAP VserverIscsiSession.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 tpgroup

=head2 vserver

=head2 tsih

=cut

package NACL::C::VserverIscsiSession;

use strict;
use warnings;

use NACL::CS::VserverIscsiSession;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use NATE::Log qw(log_global);
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverIscsiSession = NACL::C::VserverIscsiSession->new(
                                   command_interface => $ci,
                                   'tpgroup' => $tpgroup,
                                   'vserver' => $vserver,
                                   'tsih' => $tsih,
                                  );

Return a new VserverIscsiSession component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'tpgroup',
    scalar => 'vserver',
    scalar => 'tsih',
];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverIscsiSession_obj  = NACL::C::VserverIscsiSession->find(command_interface => $ci, ...);
    my @VserverIscsiSession_objs = NACL::C::VserverIscsiSession->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverIscsiSession_state = $VserverIscsiSession_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverIscsiSession would return
a NACL::CS::VserverIscsiSession object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 shutdown

    NACL::C::VserverIscsiSession->shutdown(
                                command_interface => $ci,
                                'tpgroup' => $tpgroup,
                                'vserver' => $vserver,
                                'tsih' => $tsih,
                                ...);

                                 or

    $VserverIscsiSession_obj->shutdown(...);

(Class or instance method)
This method is used to shut down a session on a node.
Uses CMode CLI/ZAPI .
Invokes  iscsi-session-shutdown for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'tpgroup' => $tpgroup >>

(Required for class method, Not Applicable for instance method)
Target Portal Group

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : tpgroup-name

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'tsih' => $tsih >>

(Required for class method, Not Applicable for instance method)
Target Session ID

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : target-session-id

=item C<< '*' >>

This method takes all other options supported by "vserver iscsi session shutdown" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub shutdown {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'vserver_iscsi_session_shutdown',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_shutdown_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => "_shutdown_7mode_cli",
                interface => "CLI",
                set       => "7Mode",
            },
            {   method    => '_shutdown_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverIscsiSession::shutdown',
    );

    $Log->exit() if $may_exit;
}

sub _shutdown_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_iscsi_session_shutdown',);
    $Log->exit() if $may_exit;
}

sub _shutdown_7mode_cli {
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;
    my %opts       = validate_with(
        params      => \@_,
        spec        => $pkg_or_obj->_backend_validate_spec(),
        allow_extra => 1
    );
    delete $opts{command_interface};
    my $apiset = delete $opts{apiset};
    my %mode7_args;
    $pkg_or_obj->_hash_copy(
        source => \%opts,
        map    => {
            "tpgroup" => "tpgroup-name",
            "tsih"    => "session-id"
        },
        target => \%mode7_args,
    );
    %opts = %mode7_args;

    $apiset->iscsi_session_shutdown(%opts);
    $Log->exit() if $may_exit;
} ## end sub _shutdown_7mode_cli

sub _shutdown_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $map = {
        'tsih'    => 'target-session-id',
        'tpgroup' => 'tpgroup-name',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api => 'iscsi-session-shutdown',
        map => $map,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'tpgroup' => {type => SCALAR},
        'vserver' => {type => SCALAR},
        'tsih'    => {type => SCALAR},
    );
}

1;
