# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverNfsKerberosRealm Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverNfsKerberosRealm

=head1 DESCRIPTION

C<NACL::C::VserverNfsKerberosRealm> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverNfsKerberosRealm.  A related class is
L<NACL::CS::VserverNfsKerberosRealm|lib-NACL-CS-VserverNfsKerberosRealm-pm>, which represents
the past state of an ONTAP VserverNfsKerberosRealm.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 realm

=head2 configname

=head2 vserver

=cut

package NACL::C::VserverNfsKerberosRealm;

use strict;
use warnings;

use NACL::CS::VserverNfsKerberosRealm;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);

# Exceptions
use NACL::C::Exceptions::VserverNfsKerberosRealm::AlreadyExists qw(:try);
use NACL::C::Exceptions::VserverNfsKerberosRealm::DoesNotExist;

=head1 METHODS

=head2 new

  my $VserverNfsKerberosRealm = NACL::C::VserverNfsKerberosRealm->new(
                                   command_interface => $ci,
                                   'realm' => $realm,
                                   'configname' => $configname,
                                   'vserver' => $vserver,
                                  );

Return a new VserverNfsKerberosRealm component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'realm',
    scalar => 'configname',
    scalar => 'vserver',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverNfsKerberosRealm_obj  = NACL::C::VserverNfsKerberosRealm->find(command_interface => $ci, ...);
    my @VserverNfsKerberosRealm_objs = NACL::C::VserverNfsKerberosRealm->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverNfsKerberosRealm_state = $VserverNfsKerberosRealm_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverNfsKerberosRealm would return
a NACL::CS::VserverNfsKerberosRealm object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverNfsKerberosRealm_obj    = NACL::C::VserverNfsKerberosRealm->create(
                                command_interface => $ci,
                                'realm' => $realm,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to create a Kerberos realm configuration.
Uses CMode CLI/ZAPI .
Invokes  kerberos-realm-create for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'realm' => $realm >>

(Required)
Kerberos Realm

Applicable for CMode CLI/ZAPI

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI

=item C<< 'adminserver-port' => $string >>

Admin Server Port ranges from 1 to 65535

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : admin-server-port

=item C<< 'kdc-ip' => $string >>

KDC IP Address

Applicable for CMode CLI/ZAPI

=item C<< 'passwordserver-port' => $string >>

Password Server Port ranges from 1 to 65535

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : password-server-port

=item C<< 'kdc-port' => $string >>

KDC Port ranges from 1 to 65535

Applicable for CMode CLI/ZAPI

=item C<< 'adserver-name' => $string >>

Active Directory Server Name

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : ad-server-name

=item C<< 'adserver-ip' => $string >>

Active Directory Server IP Address

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : ad-server-ip

=item C<< 'comment' => $string >>

Comment

Applicable for CMode CLI/ZAPI

=item C<< 'passwordserver-ip' => $string >>

Password Server IP Address

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : password-server-ip

=item C<< 'kdc-vendor' => $string >>

KDC Vendor

Applicable for CMode CLI/ZAPI

=item C<< 'clock-skew' => $string >>

Clock Skew

Applicable for CMode CLI/ZAPI

=item C<< 'adminserver-ip' => $string >>

Admin Server IP Address

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : admin-server-ip

=item C<< '*' >>

This method takes all other options supported by "vserver nfs kerberos realm create" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( adminserver-port vserver kdc-ip passwordserver-port kdc-port adserver-name
                    adserver-ip comment passwordserver-ip realm kdc-vendor clock-skew
                    adminserver-ip
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'vserver nfs kerberos realm create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_create_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_create_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverNfsKerberosRealm::create',
        );
    } catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverNfsKerberosRealm::AlreadyExists
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    my %hash = ( command_interface => $opts{command_interface},
         realm             => $opts{'realm'},
         vserver           => $vserver,
    );
    $hash{configname} = $opts{'configname'} if ( $opts{configname} );
    my $obj = $pkg->new(%hash);
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_nfs_kerberos_realm_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(kdc-ip kdc-port comment realm clock-skew kdc-vendor)];
    my $map  = {
        'adserver-name'       => 'ad-server-name',
        'adserver-ip'         => 'ad-server-ip',
        'adminserver-port'    => 'admin-server-port',
        'passwordserver-ip'   => 'password-server-ip',
        'passwordserver-port' => 'password-server-port',
        'adminserver-ip'      => 'admin-server-ip',
    };
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'kerberos-realm-create',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverNfsKerberosRealm->delete(
                                command_interface => $ci,
                                'realm' => $realm,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to delete a Kerberos realm configuration.
Uses CMode CLI/ZAPI .
Invokes  kerberos-realm-delete for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'realm' => $realm >>

(Required)
Kerberos Realm

Applicable for CMode CLI/ZAPI

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver nfs kerberos realm delete" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver realm
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'vserver nfs kerberos realm delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_delete_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_delete_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverNfsKerberosRealm::delete',
        );
    } catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverNfsKerberosRealm::DoesNotExist
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_nfs_kerberos_realm_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(realm)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'kerberos-realm-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverNfsKerberosRealm->modify(
                                command_interface => $ci,
                                'realm' => $realm,
                                'vserver' => $vserver,
                                ...);

(Class method)
This method is used to modify a Kerberos realm configuration.
Uses CMode CLI/ZAPI .
Invokes  kerberos-realm-modify for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'realm' => $realm >>

(Required)
Kerberos Realm

Applicable for CMode CLI/ZAPI

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI

=item C<< 'adminserver-port' => $string >>

Admin Server Port ranges from 1 to 65535

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : admin-server-port

=item C<< 'kdc-ip' => $string >>

KDC IP Address

Applicable for CMode CLI/ZAPI

=item C<< 'passwordserver-port' => $string >>

Password Server Port ranges from 1 to 65535

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : password-server-port

=item C<< 'kdc-port' => $string >>

KDC Port ranges from 1 to 65535

Applicable for CMode CLI/ZAPI

=item C<< 'adserver-name' => $string >>

Active Directory Server Name

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : ad-server-name

=item C<< 'adserver-ip' => $string >>

Active Directory Server IP Address

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : ad-server-ip

=item C<< 'comment' => $string >>

Comment

Applicable for CMode CLI/ZAPI

=item C<< 'passwordserver-ip' => $string >>

Password Server IP Address

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : password-server-ip

=item C<< 'kdc-vendor' => $string >>

KDC Vendor

Applicable for CMode CLI/ZAPI

=item C<< 'clock-skew' => $string >>

Clock Skew

Applicable for CMode CLI/ZAPI

=item C<< 'adminserver-ip' => $string >>

Admin Server IP Address

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : admin-server-ip

=item C<< '*' >>

This method takes all other options supported by "vserver nfs kerberos realm modify" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http:/thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( adminserver-port vserver kdc-ip passwordserver-port kdc-port adserver-name
                    adserver-ip comment passwordserver-ip realm kdc-vendor clock-skew
                    adminserver-ip
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd             => 'vserver nfs kerberos realm modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverNfsKerberosRealm::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_nfs_kerberos_realm_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(kdc-ip kdc-port comment realm clock-skew kdc-vendor)];
    my $map  = {
        'adserver-name'       => 'ad-server-name',
        'adserver-ip'         => 'ad-server-ip',
        'adminserver-port'    => 'admin-server-port',
        'passwordserver-ip'   => 'password-server-ip',
        'passwordserver-port' => 'password-server-port',
        'adminserver-ip'      => 'admin-server-ip',
    };
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'kerberos-realm-modify',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'realm'      => {type => SCALAR},
        'vserver'    => {type => SCALAR},
        'configname' => {type => SCALAR, optional => 1},
    );
}

1;
