# $Id : //depot/prod/test/nacldev/lib/NACL/C/VserverSecurityFileDirectoryNtfsDacl.pm#14 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverSecurityFileDirectoryNtfsDacl Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverSecurityFileDirectoryNtfsDacl

=head1 DESCRIPTION

C<NACL::C::VserverSecurityFileDirectoryNtfsDacl> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverSecurityFileDirectoryNtfsDacl.  A related class is
L<NACL::CS::VserverSecurityFileDirectoryNtfsDacl|lib-NACL-CS-VserverSecurityFileDirectoryNtfsDacl-pm>, which represents
the past state of an ONTAP VserverSecurityFileDirectoryNtfsDacl.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 account

=head2 vserver

=head2 ntfs_sd

=head2 access_type

=cut

package NACL::C::VserverSecurityFileDirectoryNtfsDacl;

use strict;
use warnings;

use NACL::CS::VserverSecurityFileDirectoryNtfsDacl;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsDacl::AlreadyExists (
);
use NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsDacl::DoesNotExist (
);
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument qw(:try);
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverSecurityFileDirectoryNtfsDacl = NACL::C::VserverSecurityFileDirectoryNtfsDacl->new(
                                   command_interface => $ci,
                                   'account' => $account,
                                   'vserver' => $vserver,
                                   'ntfs-sd' => $ntfs_sd,
                                   'access-type' => $access_type,
                                  );

Return a new VserverSecurityFileDirectoryNtfsDacl component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'account',
    scalar => 'vserver',
    scalar => 'ntfs_sd',
    scalar => 'access_type',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 find

    my $VserverSecurityFileDirectoryNtfsDacl_obj  = NACL::C::VserverSecurityFileDirectoryNtfsDacl->find(command_interface => $ci, ...);
    my @VserverSecurityFileDirectoryNtfsDacl_objs = NACL::C::VserverSecurityFileDirectoryNtfsDacl->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverSecurityFileDirectoryNtfsDacl_state = $VserverSecurityFileDirectoryNtfsDacl_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverSecurityFileDirectoryNtfsDacl would return
a NACL::CS::VserverSecurityFileDirectoryNtfsDacl object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 modify

    NACL::C::VserverSecurityFileDirectoryNtfsDacl->modify(
                                command_interface => $ci,
                                'account' => $account,
                                'vserver' => $vserver,
                                'ntfs-sd' => $ntfs_sd,
                                'access-type' => $access_type,
                                ...);

                                 or

    $VserverSecurityFileDirectoryNtfsDacl_obj->modify(...);

(Class or instance method)
This method is used to modify an ACE of NTFS security descriptor DACL.
Uses a CMode CLI/ZAPI APISet.
This method executes file-directory-security-ntfs-dacl-modify for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'account' => $account >>

(Required for class method, Not Applicable for instance method)
Account Name or SID
Applicable for CMode CLI/ZAPI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Applicable for CMode CLI/ZAPI

=item C<< 'ntfs-sd' => $ntfs_sd >>

(Required for class method, Not Applicable for instance method)
Security Descriptor Name
Applicable for CMode CLI/ZAPI

=item C<< 'access-type' => $access_type >>

(Required for class method, Not Applicable for instance method)
Allow or Deny
Applicable for CMode CLI/ZAPI

=item C<< 'rights' => $string >>

Access Rights
Applicable for CMode CLI/ZAPI

=item C<< 'rights-raw' => $string >>

*Raw Access Rights
Applicable for CMode CLI/ZAPI

=item C<< 'apply-to' => [ $apply-to1, $apply-to2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI

=item C<< 'advanced-rights' => [ $advanced-right1, $advanced-right2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI
Maps to:
CM ZAPI: advanced-rights

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory ntfs dacl modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'apply-to'        => {type => ARRAYREF, optional => 1},
            'advanced-rights' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( rights rights-raw
                    )
            ),
        },
        cli_cmd => 'vserver security file-directory ntfs dacl modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverSecurityFileDirectoryNtfsDacl::modify',
    );

    $Log->exit() if $may_exit;
} ## end sub modify

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_security_file_directory_ntfs_dacl_modify',
    );
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_cli

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $allowed_cmode_options = [
        qw( rights account rights-raw apply-to ntfs-sd advanced-rights
            access-type
            )
    ];

    $pkg->_base_backend_cmode_zapi(@opts,
        api    => 'file_directory_security_ntfs_dacl_modify',
        copy   => $allowed_cmode_options,
    );
    $Log->exit() if $may_exit;
} ## end sub _modify_cmode_zapi

=head2 add

    my $NtfsDacl_obj = NACL::C::VserverSecurityFileDirectoryNtfsDacl->add(
                                command_interface => $ci,
                                'account' => $account,
                                'vserver' => $vserver,
                                'ntfs-sd' => $ntfs_sd,
                                'access-type' => $access_type,
                                ...);

                                 or

    $VserverSecurityFileDirectoryNtfsDacl_obj->add(...);

(Class or instance method)
This method is used to add an ACE to NTFS security descriptor DACL.
This method returns the object for the added descriptor.
Uses a CMode CLI/ZAPI APISet.
This method invokes file-directory-security-ntfs-dacl-add in CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'account' => $account >>

(Required for class method, Not Applicable for instance method)
Account Name or SID
Applicable for CMode CLI/ZAPI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Applicable for CMode CLI/ZAPI

=item C<< 'ntfs-sd' => $ntfs_sd >>

(Required for class method, Not Applicable for instance method)
Security Descriptor Name
Applicable for CMode CLI/ZAPI

=item C<< 'access-type' => $access_type >>

(Required for class method, Not Applicable for instance method)
Allow or Deny
Applicable for CMode CLI/ZAPI

=item C<< 'rights' => $string >>

SACL ACE's Access Rights
Applicable for CMode CLI/ZAPI

=item C<< 'rights-raw' => $string >>

*SACL ACE's Raw Access Rights
Applicable for CMode CLI/ZAPI

=item C<< 'apply-to' => [ $apply-to1, $apply-to2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI

=item C<< 'advanced-rights' => [ $advanced-right1, $advanced-right2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyNtfsDacl::AlreadyExists>

This type of exception gets thrown if an attempt is made to add a
Dacl that already exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory ntfs dacl add" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=back

=back

=cut

sub add {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'apply-to'        => {type => ARRAYREF, optional => 1},
            'advanced-rights' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( rights rights-raw
                    )
            ),
        },
        cli_cmd => 'vserver security file-directory ntfs dacl add',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_add_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_add_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverSecurityFileDirectoryNtfsDacl::add',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsDacl::AlreadyExists
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };

    my $obj = $pkg_or_obj->new(
        vserver           => $opts{vserver},
        command_interface => $opts{command_interface},
        'account'         => $opts{'account'},
        'ntfs-sd'         => $opts{'ntfs-sd'},
        'access-type'     => $opts{'access-type'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub add

sub _add_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api => 'vserver_security_file_directory_ntfs_dacl_add',
    );
    $Log->exit() if $may_exit;
} ## end sub _add_cmode_cli

sub _add_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my $allowed_cmode_options = [
        qw( rights account rights-raw apply-to ntfs-sd
            access-type advanced-rights)
    ];
    $pkg_or_obj->_base_backend_cmode_zapi(@args,
        api    => 'file_directory_security_ntfs_dacl_add',
        copy   => $allowed_cmode_options,
    );
    $Log->exit() if $may_exit;
} ## end sub _add_cmode_zapi

=head2 remove

    NACL::C::VserverSecurityFileDirectoryNtfsDacl->remove(
                                command_interface => $ci,
                                'account' => $account,
                                'vserver' => $vserver,
                                'ntfs-sd' => $ntfs_sd,
                                'access-type' => $access_type,
                                ...);

                                 or

    $VserverSecurityFileDirectoryNtfsDacl_obj->remove(...);

(Class or instance method)
This method is used to remove an ACE to NTFS security descriptor DACL.
Uses a CMode CLI/ZAPI APISet.
This method invokes file-directory-security-ntfs-dacl-remove in CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'account' => $account >>

(Required for class method, Not Applicable for instance method)
Account Name or SID
Applicable for CMode CLI/ZAPI

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Applicable for CMode CLI/ZAPI

=item C<< 'ntfs-sd' => $ntfs_sd >>

(Required for class method, Not Applicable for instance method)
Security Descriptor Name
Applicable for CMode CLI/ZAPI

=item C<< 'access-type' => $access_type >>

(Required for class method, Not Applicable for instance method)
Allow or Deny
Applicable for CMode CLI/ZAPI

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyNtfsDacl::DoesNotExist>

This type of exception gets thrown if an attempt is made to remove a
Dacl which does not exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory ntfs dacl remove" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=back

=back

=cut

sub remove {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        cli_cmd => 'vserver security file directory ntfs dacl remove',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_remove_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_remove_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend =>
                'NACL::C::VserverSecurityFileDirectoryNtfsDacl::remove',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsDacl::DoesNotExist
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
} ## end sub remove

sub _remove_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@args,
        api     => 'vserver_security_file_directory_ntfs_dacl_remove',
    );
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_cli

sub _remove_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my $allowed_cmode_options = [qw( account ntfs-sd access-type)];
    $pkg_or_obj->_base_backend_cmode_zapi(@args,
        api    => 'file_directory_security_ntfs_dacl_remove',
        copy   => $allowed_cmode_options,
    );
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_zapi


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'account'     => {type => SCALAR},
        'vserver'     => {type => SCALAR},
        'ntfs-sd'     => {type => SCALAR},
        'access-type' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
