# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverSecurityFileDirectoryNtfsSacl Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com , raghaveb@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverSecurityFileDirectoryNtfsSacl

=head1 DESCRIPTION

C<NACL::C::VserverSecurityFileDirectoryNtfsSacl> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverSecurityFileDirectoryNtfsSacl.  A related class is
L<NACL::CS::VserverSecurityFileDirectoryNtfsSacl|lib-NACL-CS-VserverSecurityFileDirectoryNtfsSacl-pm>, which represents
the past state of an ONTAP VserverSecurityFileDirectoryNtfsSacl.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 account

=head2 vserver

=head2 ntfs_sd

=head2 access_type

=cut

package NACL::C::VserverSecurityFileDirectoryNtfsSacl;

use strict;
use warnings;

use NACL::CS::VserverSecurityFileDirectoryNtfsSacl;
use NACL::ComponentUtils qw (_optional_scalars Dumper);
use NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsSacl::AlreadyExists (
);
use NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsSacl::DoesNotExist (
);
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument qw(:try);
use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 new

  my $VserverSecurityFileDirectoryNtfsSacl = NACL::C::VserverSecurityFileDirectoryNtfsSacl->new(
                                   command_interface => $ci,
                                   'account' => $account,
                                   'vserver' => $vserver,
                                   'ntfs-sd' => $ntfs_sd,
                                   'access-type' => $access_type,
                                  );

Return a new VserverSecurityFileDirectoryNtfsSacl component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'account',
    scalar => 'vserver',
    scalar => 'ntfs_sd',
    scalar => 'access_type',
];

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
} ## end sub init

=head2 find

    my $VserverSecurityFileDirectoryNtfsSacl_obj  = NACL::C::VserverSecurityFileDirectoryNtfsSacl->find(command_interface => $ci, ...);
    my @VserverSecurityFileDirectoryNtfsSacl_objs = NACL::C::VserverSecurityFileDirectoryNtfsSacl->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.
  This method executes for file-directory-security-ntfs-sacl-get-iter of ZAPI.

=head2 state

    my VserverSecurityFileDirectoryNtfsSacl_state = $VserverSecurityFileDirectoryNtfsSacl_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverSecurityFileDirectoryNtfsSacl would return
a NACL::CS::VserverSecurityFileDirectoryNtfsSacl object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

=head2 add

    my $NtfsDacl_obj = NACL::C::VserverSecurityFileDirectoryNtfsSacl->add(
                                command_interface => $ci,
                                'account' => $account,
                                'vserver' => $vserver,
                                'ntfs-sd' => $ntfs_sd,
                                'access-type' => $access_type,
                                ...);

                                 or

    $VserverSecurityFileDirectoryNtfsSacl_obj->add(...);

(Class or instance method)
This method is used to add an ACE to NTFS Security Descriptor SACL.
This method returns the object for the added descriptor.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'file-directory-security-ntfs-sacl-add' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'account' => $account >>

(Required for class method, Not Applicable for instance method)
Account Name or SID
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : account

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
             option.

=item C<< 'ntfs-sd' => $ntfs_sd >>

(Required for class method, Not Applicable for instance method)
Security Descriptor Name
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : ntfs-sd

=item C<< 'access-type' => $access_type >>

(Required for class method, Not Applicable for instance method)
Access type for Specified Access Rights
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : audit-access-type

=item C<< 'rights' => $string >>

Access Rights
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : rights

=item C<< 'rights-raw' => $string >>

*Raw Access Rights
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : rights-raw

=item C<< 'apply-to' => [ $apply-to1, $apply-to2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : apply-to

=item C<< 'advanced-rights' => [ $advanced-right1, $advanced-right2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : advanced-rights

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< extended_query => $string >>

(Optional)
  Applicable only for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory ntfs sacl add" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyNtfsSacl::AlreadyExists>

This type of exception gets thrown if an attempt is made to add a
Sacl that already exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub add {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'apply-to'        => {type => ARRAYREF, optional => 1},
            'advanced-rights' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( rights rights-raw
                    )
            ),
        },
        cli_cmd => 'vserver security file directory ntfs sacl add',
    );

    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_add_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_add_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverSecurityFileDirectoryNtfsSacl::add',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsSacl::AlreadyExists
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    my $obj = $pkg_or_obj->new(
        'command_interface' => $opts{command_interface},
        'vserver'           => $vserver,
        'account'           => $opts{'account'},
        'ntfs-sd'           => $opts{'ntfs-sd'},
        'access-type'       => $opts{'access-type'},
    );
    $Log->exit() if $may_exit;
    return $obj;
} ## end sub add

sub _add_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_security_file_directory_ntfs_sacl_add',);
    $Log->exit() if $may_exit;
} ## end sub _add_cmode_cli

sub _add_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy
        = [qw(rights account ntfs-sd advanced-rights rights-raw apply-to)];
    my $map = {'access-type' => 'audit-access-type',};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api                     => 'file-directory-security-ntfs-sacl-add',
        copy                    => $copy,
        map                     => $map,
        zapi_field_translations => {hex_to_decimal => [qw(rights-raw)],},
    );
    $Log->exit() if $may_exit;
} ## end sub _add_cmode_zapi

=head2 remove

    NACL::C::VserverSecurityFileDirectoryNtfsSacl->remove(
                                command_interface => $ci,
                                'account' => $account,
                                'vserver' => $vserver,
                                'ntfs-sd' => $ntfs_sd,
                                'access-type' => $access_type,
                                ...);

                                 or

    $VserverSecurityFileDirectoryNtfsSacl_obj->remove(...);

(Class or instance method)
This method is used to remove an ACE entry from NTFS security descriptor SACL.

Uses a CMode CLI/ZAPI APISet.
  Invokes 'file-directory-security-ntfs-sacl-remove' API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'account' => $account >>

(Required for class method, Not Applicable for instance method)
Account Name or SID
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : account

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
  Applicable for CMode CLI/ZAPI.
  Maps to:
    CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
             option.

=item C<< 'ntfs-sd' => $ntfs_sd >>

(Required for class method, Not Applicable for instance method)
Security Descriptor Name
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : ntfs-sd

=item C<< 'access-type' => $access_type >>

(Required for class method, Not Applicable for instance method)
Access type for Specified Access Rights
  Applicable for CMode CLI/ZAPI
  Maps to :
    CM ZAPI : audit-access-type

=item C<< 'method-timeout' => $time_in_seconds >>

(Optional)
The default NATE timeout is 60 seconds. If the command might take more
time to complete, this option can be used to specify a larger timeout value.
The value should be provided in seconds.

=item C<< extended_query => $string >>

(Optional)
  Applicable only for CMode CLI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=item C<< '*' >>

This method takes all other options supported by
"vserver security file-directory ntfs sacl remove" command in ONTAP.

Applicable for CMode CLI/ZAPI.

=back

=back

=over

=item Exceptions

=over

=item C<NACL::C::Exceptions::VserverSecurityFileDirectoryPolicyNtfsSacl::DoesNotExist>

This type of exception gets thrown if an attempt is made to remove a
Sacl which does not exists.

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub remove {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        cli_cmd => 'vserver security file directory ntfs sacl remove',
    );
    try {

        my $vserver;
        $opts{vserver_operated_on} = \$vserver;
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_remove_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_remove_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend =>
                'NACL::C::VserverSecurityFileDirectoryNtfsSacl::remove',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception = $_[0];
        NACL::C::Exceptions::VserverSecurityFileDirectoryNtfsSacl::DoesNotExist
            ->detect_convert_and_throw(exception => $exception);
        $Log->exit() if $may_exit;
        $exception->throw();
    };
    $Log->exit() if $may_exit;
} ## end sub remove

sub _remove_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_security_file_directory_ntfs_sacl_remove',);
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_cli

sub _remove_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(account ntfs-sd)];
    my $map = {'access-type' => 'audit-access-type',};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'file-directory-security-ntfs-sacl-remove',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
} ## end sub _remove_cmode_zapi

=head2 modify

    NACL::C::VserverSecurityFileDirectoryNtfsSacl->modify(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'account' => $account,
	                            'ntfs-sd' => $ntfs_sd,
	                            'access-type' => $access_type,
                                ...);
	                             
								 or

    $VserverSecurityFileDirectoryNtfsSacl_obj->modify(...);

(Class or instance method)
This method is used to modify an NTFS security descriptor SACL entry.
Uses CMode CLI/ZAPI .
Invokes  file-directory-security-ntfs-sacl-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'account' => $account >>

(Required for class method, Not Applicable for instance method)
Account Name or SID
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'ntfs-sd' => $ntfs_sd >>

(Required for class method, Not Applicable for instance method)
NTFS Security Descriptor Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'access-type' => $access_type >>

(Required for class method, Not Applicable for instance method)
Failure or Success possible value(s) are, failure,success
Applicable for CMode CLI/ZAPI, non-iter.

Mapping for non-iter: audit-access-type

=item C<< 'rights' => $string >>


Access Rights possible value(s) are, no-access,full-control,modify,read-and-execute,read,write
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'rights-raw' => $string >>

Raw Access Rights
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'advanced-rights' => [ $advanced-right1, $advanced-right2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'apply-to' => [ $apply-to1, $apply-to2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver security file directory ntfs sacl modify" command in ONTAP

Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'advanced-rights' => {type => ARRAYREF, optional => 1},
            'apply-to'        => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( rights rights-raw
                    )
            ),
        },
        cli_cmd => 'vserver security file directory ntfs sacl modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverSecurityFileDirectoryNtfsSacl::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_security_file_directory_ntfs_sacl_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy
        = [qw(rights account ntfs-sd advanced-rights rights-raw apply-to)];
    my $map = {'access-type' => 'audit-access-type',};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api                     => 'file-directory-security-ntfs-sacl-modify',
        copy                    => $copy,
        map                     => $map,
        zapi_field_translations => {hex_to_decimal => [qw(rights-raw)],},
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'account'     => {type => SCALAR},
        'vserver'     => {type => SCALAR},
        'ntfs-sd'     => {type => SCALAR},
        'access-type' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
