#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesKerberosKeyblocks Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesKerberosKeyblocks

=head1 DESCRIPTION

C<NACL::C::VserverServicesKerberosKeyblocks> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverServicesKerberosKeyblocks.  A related class is
L<NACL::CS::VserverServicesKerberosKeyblocks|lib-NACL-CS-VserverServicesKerberosKeyblocks-pm>, which represents
the past state of an ONTAP VserverServicesKerberosKeyblocks.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 key_version

=head2 vserver

=head2 vif

=head2 lif

=head2 service_type

=head2 encryption_type

=cut

package NACL::C::VserverServicesKerberosKeyblocks;

use strict;
use warnings;

use NACL::CS::VserverServicesKerberosKeyblocks;
use NACL::ComponentUtils qw (_optional_scalars);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

=head1 METHODS

=head2 new

  my $VserverServicesKerberosKeyblocks = NACL::C::VserverServicesKerberosKeyblocks->new(command_interface=>$ci,
                                   key_version =>$key_version,
                                   vserver =>$vserver,
                                   vif =>$vif,
                                   lif =>$lif,
                                   service_type =>$service_type,
                                   encryption_type =>$encryption_type,
								  );

Return a new VserverServicesKerberosKeyblocks component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'key_version',
    scalar => 'vserver',
    scalar => 'vif',
    scalar => 'lif',
    scalar => 'service_type',
    scalar => 'encryption_type',
];

=head2 find

    my $VserverServicesKerberosKeyblocks  = NACL::C::VserverServicesKerberosKeyblocks->find(command_interface => $ci, ...);
	my @VserverServicesKerberosKeyblockss = NACL::C::VserverServicesKerberosKeyblocks->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

=head2 state

    my $VserverServicesKerberosKeyblocks_state = $NACL::C::VserverServicesKerberosKeyblocks->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverServicesKerberosKeyblocks would return 
a NACL::CS::VserverServicesKerberosKeyblocks object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

=cut

=head2 modify

   NACL::C::VserverServicesKerberosKeyblocks->modify(
                                command_interface => $ci,
	                             key_version => $key_version,
	                             vserver => $vserver,
	                             vif => $vif,
	                             lif => $lif,
	                             service_type => $service_type,
	                             encryption_type => $encryption_type,
                                  ...);
	                             
								 or

    $VserverServicesKerberosKeyblocks_object->modify(...);

(Class or instance method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "key-version" => $key_version >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "vif" => $vif >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "lif" => $lif >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "service-type" => $service_type >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "encryption-type" => $encryption_type >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI.

=item C<< "keyblock" => $string >>

Applicable for CMode CLI.

=item C<< "spn" => $string >>

Applicable for CMode CLI.

=item C<< "timestamp" => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services kerberos-keyblocks modify" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( keyblock spn timestamp
                    )
            ),
        },
        cli_cmd => 'vserver services kerberos-keyblocks modify',
    );
    my $ret = $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_modify_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::VserverServicesKerberosKeyblocks::modify',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub modify

sub _modify_cmode_cli{
    $Log->enter() if $may_enter;
    my $pkg_or_obj = shift;

    $pkg_or_obj->_base_backend_cmode_cli(
        @_,
        api => 'vserver_services_kerberos_keyblocks_modify',
    );

    $Log->exit() if $may_exit;
} ## end _modify_cmode_cli

=head2 delete

   NACL::C::VserverServicesKerberosKeyblocks->delete(
                                command_interface => $ci,
	                             key_version => $key_version,
	                             vserver => $vserver,
	                             vif => $vif,
	                             lif => $lif,
	                             service_type => $service_type,
	                             encryption_type => $encryption_type,
                                  ...);

(Class method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "key-version" => $key_version >>

(Required)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required)

Applicable for CMode CLI.

=item C<< "vif" => $vif >>

(Required)

Applicable for CMode CLI.

=item C<< "lif" => $lif >>

(Required)

Applicable for CMode CLI.

=item C<< "service-type" => $service_type >>

(Required)

Applicable for CMode CLI.

=item C<< "encryption-type" => $encryption_type >>

(Required)

Applicable for CMode CLI.

=item C<< 'key-version' => $string >>

Applicable for CMode CLI.

=item C<< 'vserver' => $string >>

Applicable for CMode CLI.

=item C<< 'lif' => $string >>

Applicable for CMode CLI.

=item C<< 'service-type' => $string >>

Applicable for CMode CLI.

=item C<< 'encryption-type' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services kerberos-keyblocks delete" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( key-version vserver lif service-type encryption-type
                    )
            )
        },
        cli_cmd => 'vserver services kerberos-keyblocks delete',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_delete_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::VserverServicesKerberosKeyblocks::delete',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub delete

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->_base_backend_cmode_cli(
        @_,
        api => 'vserver_services_kerberos_keyblocks_delete',
    );

    $Log->exit() if $may_exit;
} ## end sub _delete_cmode_cli

=head2 create

    my $VserverServicesKerberosKeyblocks_object	= NACL::C::VserverServicesKerberosKeyblocks->create(
                                command_interface => $ci,
	                             key_version => $key_version,
	                             vserver => $vserver,
	                             vif => $vif,
	                             lif => $lif,
	                             service_type => $service_type,
	                             encryption_type => $encryption_type,
                                  ...);

(Class method)

Uses a CMode CLI APIset.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< "key-version" => $key_version >>

(Required)

Applicable for CMode CLI.

=item C<< "vserver" => $vserver >>

(Required)

Applicable for CMode CLI.

=item C<< "vif" => $vif >>

(Required)

Applicable for CMode CLI.

=item C<< "lif" => $lif >>

(Required)

Applicable for CMode CLI.

=item C<< "service-type" => $service_type >>

(Required)

Applicable for CMode CLI.

=item C<< "encryption-type" => $encryption_type >>

(Required)

Applicable for CMode CLI.

=item C<< "keyblock" => $string >>

Applicable for CMode CLI.

=item C<< "spn" => $string >>

Applicable for CMode CLI.

=item C<< "timestamp" => $string >>

Applicable for CMode CLI.

=item C<< 'vserver' => $string >>

Applicable for CMode CLI.

=item C<< 'key-version' => $string >>

Applicable for CMode CLI.

=item C<< 'service-type' => $string >>

Applicable for CMode CLI.

=item C<< 'lif' => $string >>

Applicable for CMode CLI.

=item C<< 'encryption-type' => $string >>

Applicable for CMode CLI.

=item C<< "extended_query" => $string >>

(Optional)

Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by
"vserver services kerberos-keyblocks create" command in ONTAP.

Applicable for CMode CLI.

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from 
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( keyblock spn timestamp

                    vserver key-version service-type lif encryption-type
                    )
            ),
        },
        cli_cmd => 'vserver services kerberos-keyblocks create',
    );
    my $ret = $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => "_create_cmode_cli",
                interface => "CLI",
                set       => "CMode",
            },
        ],
        frontend => 'NACL::C::VserverServicesKerberosKeyblocks::create',
    );

    $Log->exit() if $may_exit;
    return $ret;
} ## end sub create

sub _create_cmode_cli{
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    if (exists $opts{'vif'}) {
        $opts{'additional_args'}->{'vif'} = $opts{'vif'};
    }

    $pkg->_base_backend_cmode_cli(
        %opts,
        api                 => 'vserver_services_kerberos_keyblocks_create',
    );

    $Log->exit() if $may_exit;
    return $pkg->new(
        command_interface => $opts{'command_interface'},
        key_version       => $opts{'key-version'},
        vserver           => $opts{'vserver'},
        vif               => $opts{'vif'},
        lif               => $opts{'lif'},
        service_type      => $opts{'service-type'},
        encryption_type   => $opts{'encryption-type'},
    );
} ## end sub _create_cmode_cli


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'key-version'     => {type => SCALAR},
        'vserver'         => {type => SCALAR},
        'vif'             => {type => SCALAR},
        'lif'             => {type => SCALAR},
        'service-type'    => {type => SCALAR},
        'encryption-type' => {type => SCALAR},
    );
} ## end sub _primary_keys_validate_spec

1;
