# $Id$

#
# Copyright (c) 2001-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceLdapClientSchema Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesNameServiceLdapClientSchema

=head1 DESCRIPTION

C<NACL::C::VserverServicesNameServiceLdapClientSchema> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverServicesNameServiceLdapClientSchema.  A related class is
L<NACL::CS::VserverServicesNameServiceLdapClientSchema|lib-NACL-CS-VserverServicesNameServiceLdapClientSchema-pm>, which represents
the past state of an ONTAP VserverServicesNameServiceLdapClientSchema.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 schema

=head2 vserver

=cut

package NACL::C::VserverServicesNameServiceLdapClientSchema;

use strict;
use warnings;

use NACL::CS::VserverServicesNameServiceLdapClientSchema;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverServicesNameServiceLdapClientSchema = NACL::C::VserverServicesNameServiceLdapClientSchema->new(
                                   command_interface => $ci,
                                   'schema' => $schema,
                                   'vserver' => $vserver,
								  );

Return a new VserverServicesNameServiceLdapClientSchema component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'schema',
    scalar => 'vserver',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverServicesNameServiceLdapClientSchema_obj  = NACL::C::VserverServicesNameServiceLdapClientSchema->find(command_interface => $ci, ...);
	my @VserverServicesNameServiceLdapClientSchema_objs = NACL::C::VserverServicesNameServiceLdapClientSchema->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverServicesNameServiceLdapClientSchema_state = $VserverServicesNameServiceLdapClientSchema_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverServicesNameServiceLdapClientSchema would return 
a NACL::CS::VserverServicesNameServiceLdapClientSchema object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 copy

    my $VserverServicesNameServiceLdapClientSchema_obj	= NACL::C::VserverServicesNameServiceLdapClientSchema->copy(
                                command_interface => $ci,
	                            'schema' => $schema,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $VserverServicesNameServiceLdapClientSchema_obj->copy(...);

(Class or instance method)
This method is used to copy an existing LDAP schema template.
Uses CMode CLI/ZAPI .
Invokes  ldap-client-schema-copy  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'schema' => $schema >>

(Required for class method, Not Applicable for instance method)
Schema Template
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'new-schema-name' => $string >>

New Schema Template Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver services name service ldap client schema copy" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub copy {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( new-schema-name
                    )
            ),
        },
        cli_cmd => 'vserver services name-service ldap client schema copy',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_copy_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_copy_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceLdapClientSchema::copy',
    );

    my %obj_opts = (
        command_interface => $opts{command_interface},
        schema            => $opts{'schema'},
        vserver           => $vserver,
    );
    my $obj = $pkg->new(%obj_opts);
    $Log->exit() if $may_exit;
    return $obj;
}

sub _copy_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_ldap_client_schema_copy',);
    $Log->exit() if $may_exit;
}

sub _copy_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(schema new-schema-name)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'ldap-client-schema-copy',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(schema vserver)],
        _vs_context   => 1
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverServicesNameServiceLdapClientSchema->delete(
                                command_interface => $ci,
	                            'schema' => $schema,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $VserverServicesNameServiceLdapClientSchema_obj->delete(...);

(Class or instance method)
This method is used to delete an LDAP schema template.
Uses CMode CLI/ZAPI .
Invokes  ldap-client-schema-delete  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'schema' => $schema >>

(Required for class method, Not Applicable for instance method)
Schema Template
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver services name service ldap client schema delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver services name-service ldap client schema delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_delete_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        nacl_exceptions => [qw(DoesNotExist)],
        frontend =>
            'NACL::C::VserverServicesNameServiceLdapClientSchema::delete',
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_ldap_client_schema_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(schema)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'ldap-client-schema-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverServicesNameServiceLdapClientSchema->modify(
                                command_interface => $ci,
	                            'schema' => $schema,
	                            'vserver' => $vserver,
                                ...);
	                             
								 or

    $VserverServicesNameServiceLdapClientSchema_obj->modify(...);

(Class or instance method)
This method is used to modify an LDAP schema template.
Uses CMode CLI/ZAPI .
Invokes  ldap-client-schema-modify  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'schema' => $schema >>

(Required for class method, Not Applicable for instance method)
Schema Template
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'posix-account-object-class' => $string >>

RFC 2307 posixAccount Object Class
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'member-uid-attribute' => $string >>

RFC 2307 memberUid Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'posix-group-object-class' => $string >>

RFC 2307 posixGroup Object Class
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'unix-account-attribute' => $string >>

ONTAP Name Mapping unixAccount Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'uid-number-attribute' => $string >>

RFC 2307 uidNumber Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'nis-mapentry-attribute' => $string >>

RFC 2307 nisMapEntry Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'cn-netgroup-attribute' => $string >>

RFC 2307 cn (for Netgroups) Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'windows-to-unix-attribute' => $string >>

ONTAP Name Mapping windowsToUnix Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'unique-member-attribute' => $string >>

RFC 2307bis uniqueMember Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'nis-netgroup-triple-attribute' => $string >>

RFC 2307 nisNetgroupTriple Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'user-password-attribute' => $string >>

RFC 2307 userPassword Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'home-directory-attribute' => $string >>

RFC 2307 homeDirectory Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'windows-to-unix-object-class' => $string >>

ONTAP Name Mapping windowsToUnix Object Class
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'cn-group-attribute' => $string >>

RFC 2307 cn (for Groups) Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'login-shell-attribute' => $string >>

RFC 2307 loginShell Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'gecos-attribute' => $string >>

RFC 2307 gecos Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'member-nis-netgroup-attribute' => $string >>

RFC 2307 memberNisNetgroup Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'nis-netgroup-object-class' => $string >>

RFC 2307 nisNetgroup Object Class
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'gid-number-attribute' => $string >>

RFC 2307 gidNumber Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'maximum-groups-rfc2307bis' => $string >>


Maximum groups supported when RFC 2307bis enabled ranges from 1 to 1024
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'group-of-unique-names-object-class' => $string >>

RFC 2307bis groupOfUniqueNames Object Class
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'comment' => $string >>

Comment
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'uid-attribute' => $string >>

RFC 2307 uid Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'windows-account-attribute' => $string >>

ONTAP Name Mapping windowsAccount Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'nis-object-class' => $string >>

RFC 2307 nisObject Object Class
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'enable-rfc2307bis' => $string >>

Enable Support for Draft RFC 2307bis possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'nis-mapname-attribute' => $string >>

RFC 2307 nisMapName Attribute
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver services name service ldap client schema modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( posix-account-object-class member-uid-attribute posix-group-object-class
                    unix-account-attribute uid-number-attribute nis-mapentry-attribute
                    cn-netgroup-attribute windows-to-unix-attribute unique-member-attribute
                    nis-netgroup-triple-attribute user-password-attribute
                    home-directory-attribute windows-to-unix-object-class cn-group-attribute
                    login-shell-attribute gecos-attribute member-nis-netgroup-attribute
                    nis-netgroup-object-class gid-number-attribute maximum-groups-rfc2307bis
                    group-of-unique-names-object-class comment uid-attribute
                    windows-account-attribute nis-object-class enable-rfc2307bis
                    nis-mapname-attribute
                    )
            ),
        },
        cli_cmd => 'vserver services name-service ldap client schema modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_modify_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceLdapClientSchema::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_ldap_client_schema_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [
        qw(member-uid-attribute posix-account-object-class posix-group-object-class
            uid-number-attribute nis-mapentry-attribute cn-netgroup-attribute schema
            unique-member-attribute nis-netgroup-triple-attribute
            user-password-attribute home-directory-attribute cn-group-attribute
            login-shell-attribute gecos-attribute member-nis-netgroup-attribute
            gid-number-attribute nis-netgroup-object-class
            group-of-unique-names-object-class uid-attribute comment
            windows-account-attribute nis-object-class enable-rfc2307bis
            nis-mapname-attribute)
    ];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'ldap-client-schema-modify',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'schema'  => {type => SCALAR},
        'vserver' => {type => SCALAR},
    );
}

1;
