# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceNisDomain Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesNameServiceNisDomain

=head1 DESCRIPTION

C<NACL::C::VserverServicesNameServiceNisDomain> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverServicesNameServiceNisDomain.  A related class is
L<NACL::CS::VserverServicesNameServiceNisDomain|lib-NACL-CS-VserverServicesNameServiceNisDomain-pm>, which represents
the past state of an ONTAP VserverServicesNameServiceNisDomain.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 domain

=head2 vserver

=cut

package NACL::C::VserverServicesNameServiceNisDomain;

use strict;
use warnings;

use NACL::CS::VserverServicesNameServiceNisDomain;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverServicesNameServiceNisDomain = NACL::C::VserverServicesNameServiceNisDomain->new(
                                   command_interface => $ci,
                                   'domain' => $domain,
                                   'vserver' => $vserver,
								  );

Return a new VserverServicesNameServiceNisDomain component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'domain',
    scalar => 'vserver',
];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverServicesNameServiceNisDomain_obj  = NACL::C::VserverServicesNameServiceNisDomain->find(command_interface => $ci, ...);
	my @VserverServicesNameServiceNisDomain_objs = NACL::C::VserverServicesNameServiceNisDomain->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverServicesNameServiceNisDomain_state = $VserverServicesNameServiceNisDomain_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverServicesNameServiceNisDomain would return 
a NACL::CS::VserverServicesNameServiceNisDomain object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverServicesNameServiceNisDomain_obj	= NACL::C::VserverServicesNameServiceNisDomain->create(
                                command_interface => $ci,
	                            'domain' => $domain,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to create a NIS domain configuration.
Uses CMode CLI/ZAPI .
Invokes  nis-create for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain' => $domain >>

(Required)
NIS Domain

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : nis-domain

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'active' => $string >>

Active Domain possible value(s) are, true,false

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : is-active

=item C<< 'servers' => [ $server1, $server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : nis-servers

=item C<< '*' >>

This method takes all other options supported by "vserver services name service nis domain create" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'servers' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( active
                    )
            ),
        },
        cli_cmd => 'vserver services name-service nis-domain create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceNisDomain::create',
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        domain            => $opts{'domain'},
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_nis_domain_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $map = {
        'domain'  => 'nis-domain',
        'active'  => 'is-active',
        'servers' => 'nis-servers',
    };
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api => 'nis-create',
        map => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverServicesNameServiceNisDomain->delete(
                                command_interface => $ci,
	                            'domain' => $domain,
	                            'vserver' => $vserver,
                                ...);

								 or

    $VserverServicesNameServiceNisDomain_obj->delete(...);

(Class or instance method)
This method is used to delete a NIS domain configuration.
Uses CMode CLI/ZAPI .
Invokes  nis-destroy for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain' => $domain >>

(Required for class method, Not Applicable for instance method)
NIS Domain

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : nis-domain

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service nis domain delete" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver services name-service nis-domain delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceNisDomain::delete',
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_nis_domain_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(vserver)];
    my $map = {'domain' => 'nis-domain',};
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'nis-destroy',
        copy => $copy,
        map  => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverServicesNameServiceNisDomain->modify(
                                command_interface => $ci,
	                            'domain' => $domain,
	                            'vserver' => $vserver,
                                ...);

								 or

    $VserverServicesNameServiceNisDomain_obj->modify(...);

(Class or instance method)
This method is used to modify a NIS domain configuration.
Uses CMode CLI/ZAPI .
Invokes  nis-modify for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'domain' => $domain >>

(Required for class method, Not Applicable for instance method)
NIS Domain

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : nis-domain

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'active' => $string >>

Active Domain possible value(s) are, true,false

Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : is-active

=item C<< 'servers' => [ $server1, $server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI


Maps to:

CMode ZAPI : nis-servers

=item C<< '*' >>

This method takes all other options supported by "vserver services name service nis domain modify" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'servers' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( active
                    )
            ),
        },
        cli_cmd => 'vserver services name-service nis-domain modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverServicesNameServiceNisDomain::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_nis_domain_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $map = {
        'domain'  => 'nis-domain',
        'active'  => 'is-active',
        'servers' => 'nis-servers',
    };
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api => 'nis-modify',
        map => $map,
    );
    $Log->exit() if $may_exit;
}

=head2 show_bound

    my $show_bound_obj = NACL::C::VserverServicesNameServiceNisDomain->show_bound(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_bound_objs = NACL::C::VserverServicesNameServiceNisDomain->show_bound(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_bound_obj = $VserverServicesNameServiceNisDomain_obj->show_bound(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverServicesNameServiceNisDomainShowBound-pm/ATTRIBUTES>
of NACL::CS::VserverServicesNameServiceNisDomainShowBound as input. 
This method returns objects of the type L<NACL::CS::VserverServicesNameServiceNisDomainShowBound|lib-NACL-CS-VserverServicesNameServiceNisDomainShowBound-pm>.

=cut

sub show_bound {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverServicesNameServiceNisDomainShowBound;
    my @state_objs
        = NACL::CS::VserverServicesNameServiceNisDomainShowBound->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_bound_debug

    my $show_bound_debug_obj = NACL::C::VserverServicesNameServiceNisDomain->show_bound_debug(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_bound_debug_objs = NACL::C::VserverServicesNameServiceNisDomain->show_bound_debug(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_bound_debug_obj = $VserverServicesNameServiceNisDomain_obj->show_bound_debug(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverServicesNameServiceNisDomainShowBoundDebug-pm/ATTRIBUTES>
of NACL::CS::VserverServicesNameServiceNisDomainShowBoundDebug as input. 
This method returns objects of the type L<NACL::CS::VserverServicesNameServiceNisDomainShowBoundDebug|lib-NACL-CS-VserverServicesNameServiceNisDomainShowBoundDebug-pm>.

=cut

sub show_bound_debug {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverServicesNameServiceNisDomainShowBoundDebug;
    my @state_objs
        = NACL::CS::VserverServicesNameServiceNisDomainShowBoundDebug->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 show_statistics

    my $show_statistics_obj = NACL::C::VserverServicesNameServiceNisDomain->show_statistics(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);
						  
                    or
					
    my @show_statistics_objs = NACL::C::VserverServicesNameServiceNisDomain->show_statistics(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or
  
   my $show_statistics_obj = $VserverServicesNameServiceNisDomain_obj->show_statistics(); 
						  
(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of 
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty) 
and has all of the other properties of fetch methods (callable in scalar or list 
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverServicesNameServiceNisDomainShowStatistics-pm/ATTRIBUTES>
of NACL::CS::VserverServicesNameServiceNisDomainShowStatistics as input. 
This method returns objects of the type L<NACL::CS::VserverServicesNameServiceNisDomainShowStatistics|lib-NACL-CS-VserverServicesNameServiceNisDomainShowStatistics-pm>.

=cut

sub show_statistics {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverServicesNameServiceNisDomainShowStatistics;
    my @state_objs
        = NACL::CS::VserverServicesNameServiceNisDomainShowStatistics->fetch(
        %opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 clear_statistics

    NACL::C::VserverServicesNameServiceNisDomain->clear_statistics(
                                command_interface => $ci,
	                            'vserver' => $vserver,
                                ...);
   
(Class method)
This method is used to clear NIS statistics information.
Uses CMode CLI/ZAPI .
Invokes  nameservice-nis-statistics-clear for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'server' => $string >>

NIS Server

Applicable for CMode CLI/ZAPI

=item C<< 'node' => $string >>

Node possible value(s) are, <nodename>,local

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "vserver services name service nis domain clear statistics" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub clear_statistics {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( vserver server node
                    )
            ),
        },
        ignore_primary_keys => 1,
        cli_cmd =>
            'vserver services name-service nis-domain clear-statistics',
    );
    $pkg->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_clear_statistics_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_clear_statistics_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend =>
            'NACL::C::VserverServicesNameServiceNisDomain::clear_statistics',
    );

    $Log->exit() if $may_exit;
}

sub _clear_statistics_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_nis_domain_clear_statistics',);
    $Log->exit() if $may_exit;
}

sub _clear_statistics_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my $copy = [qw(node server vserver)];
    $pkg->_base_backend_cmode_zapi(
        @opts,
        api  => 'nameservice-nis-statistics-clear',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'domain'  => {type => SCALAR},
        'vserver' => {type => SCALAR},
    );
}

1;
