# $Id$

#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceNsSwitch Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverServicesNameServiceNsSwitch

=head1 DESCRIPTION

C<NACL::C::VserverServicesNameServiceNsSwitch> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverServicesNameServiceNsSwitch.  A related class is
L<NACL::CS::VserverServicesNameServiceNsSwitch|lib-NACL-CS-VserverServicesNameServiceNsSwitch-pm>, which represents
the past state of an ONTAP VserverServicesNameServiceNsSwitch.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 database

=head2 vserver

=cut

package NACL::C::VserverServicesNameServiceNsSwitch;

use strict;
use warnings;

use NACL::CS::VserverServicesNameServiceNsSwitch;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::C::_Mixins::VserverServicesNameServiceNsSwitch qw(:all);
use NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::AlreadyExists;
use NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::DoesNotExist;
use NATE::BaseException qw(:try);
use NATE::Exceptions::Argument qw(:try);

=head1 METHODS

=head2 new

  my $VserverServicesNameServiceNsSwitch = NACL::C::VserverServicesNameServiceNsSwitch->new(
                                   command_interface => $ci,
                                   'database' => $database,
                                   'vserver' => $vserver,
								  );

Return a new VserverServicesNameServiceNsSwitch component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'database',
    scalar => 'vserver',
];

=head2 find

    my $VserverServicesNameServiceNsSwitch_obj  = NACL::C::VserverServicesNameServiceNsSwitch->find(command_interface => $ci, ...);
	my @VserverServicesNameServiceNsSwitch_objs = NACL::C::VserverServicesNameServiceNsSwitch->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=head2 state

    my VserverServicesNameServiceNsSwitch_state = $VserverServicesNameServiceNsSwitch_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverServicesNameServiceNsSwitch would return
a NACL::CS::VserverServicesNameServiceNsSwitch object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverServicesNameServiceNsSwitch_obj	= NACL::C::VserverServicesNameServiceNsSwitch->create(
                                command_interface => $ci,
	                            'database' => $database,
	                            'vserver' => $vserver,
                                ...);

(Class method)
This method is used to create a new Name Service Switch table entry.
Uses CMode CLI/ZAPI APISet.

Invokes "nameservice-nsswitch-create" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'database' => $database >>

(Required)

Applicable for CMode CLI/ZAPI.

Name Service Switch Database possible value(s) are, hosts,group,passwd,netgroup,namemap

Maps to:

CM ZAPI: nameservice-database

=item C<< 'vserver' => $vserver >>

(Required)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'sources' => [ $source1, $source2, ... ] >>

(Required)

Applicable for CMode CLI/ZAPI.

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Maps to:

CM ZAPI: nameservice-sources

=item C<< '*' >>

This method takes all other options supported by "vserver services name service ns switch create" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::AlreadyExists>

This type of exception gets thrown if an attempt is made to create a
an entry for ns-switch on an vserver which already exists.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'sources' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( enabled
                    )
            ),
        },
        api => 'vserver_services_name_service_ns_switch_create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    if ( $opts{enabled} ) {
         $Log->warn("\n Passing enabled option to NACL::C::VserverServicesNameServiceNsSwitch".
                   "->create is not valid anymore, removing this option from input. Please update your scripts");
        delete $opts{enabled};
    }
    try {
        $pkg->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_create_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_create_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverServicesNameServiceNsSwitch::create',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception_obj = $_[0];
        NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::AlreadyExists
            ->detect_convert_and_throw(exception => $exception_obj);
        $Log->exit() if $may_exit;
        $exception_obj->throw();
    };

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        database          => $opts{'database'},
        vserver           => $vserver,
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_ns_switch_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $map = $pkg->_common_zapi_map();
    $map->{'sources'} = 'nameservice-sources';
    $pkg->_base_backend_cmode_zapi(
        %opts,
        api             => 'nameservice-nsswitch-create',
        map             => $map,
        frontend_method => 'create',
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverServicesNameServiceNsSwitch->delete(
                                command_interface => $ci,
	                            'database' => $database,
	                            'vserver' => $vserver,
                                ...);

								 or

    $VserverServicesNameServiceNsSwitch_obj->delete(...);

(Class or instance method)
This method is used to remove a Name Service Switch table entry.
Uses CMode CLI/ZAPI APISet.

Invokes "nameservice-nsswitch-destroy" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'database' => $database >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Name Service Switch Database possible value(s) are, hosts,group,passwd,netgroup,namemap

Maps to:

CM ZAPI: nameservice-database

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< '*' >>

This method takes all other options supported by "vserver services name service ns switch delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::DoesNotExist>

This type of exception gets thrown if an attempt is made to delete a
non-existing entry for ns-switch on an vserver.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params => \@args,
        api    => 'vserver_services_name_service_ns_switch_delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_delete_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_delete_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverServicesNameServiceNsSwitch::delete',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception_obj = $_[0];
        NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::DoesNotExist
            ->detect_convert_and_throw(exception => $exception_obj);
        $Log->exit() if $may_exit;
        $exception_obj->throw();
    };
    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_ns_switch_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;

    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api             => 'nameservice-nsswitch-destroy',
        map             => {database => 'nameservice-database'},
        frontend_method => 'delete',
    );
    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverServicesNameServiceNsSwitch->modify(
                                command_interface => $ci,
	                            'database' => $database,
	                            'vserver' => $vserver,
                                ...);

								 or

    $VserverServicesNameServiceNsSwitch_obj->modify(...);

(Class or instance method)
This method is used to change a Name Service Switch table entry.
Uses CMode CLI/ZAPI APISet.

Invokes "nameservice-nsswitch-modify" API for CMode ZAPI.

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'database' => $database >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Name Service Switch Database possible value(s) are, hosts,group,passwd,netgroup,namemap

Maps to:

CM ZAPI: nameservice-database

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

Maps to:

CM ZAPI: ZAPI will be invoked in the context of the vserver specified to this
option.

=item C<< 'sources' => [ $source1, $source2, ... ] >>

(Required for class method, Not Applicable for instance method)

Applicable for CMode CLI/ZAPI.

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)

Maps to:

CM ZAPI: nameservice-sources

=item C<< '*' >>

This method takes all other options supported by "vserver services name service ns switch modify" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=item C<NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::DoesNotExist>

This type of exception gets thrown if an attempt is made to modify a
non-existing entry for ns-switch on an vserver.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'sources' => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( enabled
                    )
            ),
        },
        api => 'vserver_services_name_service_ns_switch_modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    if ( $opts{enabled} ) {
        $Log->warn("\n Passing enabled option to NACL::C::VserverServicesNameServiceNsSwitch".
                   "->modify is not valid anymore, removing this option from input. Please update your scripts");
        delete $opts{enabled};
    }
    try {
        $pkg_or_obj->call_on_apiset(
            %opts,
            choices => [
                {   method    => '_modify_cmode_cli',
                    interface => 'CLI',
                    set       => 'CMode',
                },
                {   method    => '_modify_cmode_zapi',
                    interface => 'ZAPI',
                    set       => 'CMode',
                },
            ],
            frontend => 'NACL::C::VserverServicesNameServiceNsSwitch::modify',
        );
    }
    catch NACL::APISet::Exceptions::ResponseException with {
        my $exception_obj = $_[0];
        NACL::C::Exceptions::VserverServicesNameServiceNsSwitch::DoesNotExist
            ->detect_convert_and_throw(exception => $exception_obj);
        $Log->exit() if $may_exit;
        $exception_obj->throw();
    };

}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_services_name_service_ns_switch_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my $map = $pkg_or_obj->_common_zapi_map();
    $map->{'sources'} = 'nameservice-sources';
    $pkg_or_obj->_base_backend_cmode_zapi(
        %opts,
        api             => 'nameservice-nsswitch-modify',
        map             => $map,
        frontend_method => 'modify',
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'database' => {type => SCALAR},
        'vserver'  => {type => SCALAR},
    );
}

1;
