# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanOnDemandTaskReport Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverVscanOnDemandTaskReport

=head1 DESCRIPTION

C<NACL::C::VserverVscanOnDemandTaskReport> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverVscanOnDemandTaskReport.  A related class is
L<NACL::CS::VserverVscanOnDemandTaskReport|lib-NACL-CS-VserverVscanOnDemandTaskReport-pm>, which represents
the past state of an ONTAP VserverVscanOnDemandTaskReport.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 task_name

=head2 vserver

=head2 report_file

=cut

package NACL::C::VserverVscanOnDemandTaskReport;

use strict;
use warnings;

use NACL::CS::VserverVscanOnDemandTaskReport;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

=head1 METHODS

=head2 new

  my $VserverVscanOnDemandTaskReport = NACL::C::VserverVscanOnDemandTaskReport->new(
                                   command_interface => $ci,
                                   'task-name' => $task_name,
                                   'vserver' => $vserver,
                                   'report-file' => $report_file,
								  );

Return a new VserverVscanOnDemandTaskReport component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'task_name',
    scalar => 'vserver',
    scalar => 'report_file',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverVscanOnDemandTaskReport_obj  = NACL::C::VserverVscanOnDemandTaskReport->find(command_interface => $ci, ...);
	my @VserverVscanOnDemandTaskReport_objs = NACL::C::VserverVscanOnDemandTaskReport->find(command_interface => $ci, ...); 

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverVscanOnDemandTaskReport_state = $VserverVscanOnDemandTaskReport_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverVscanOnDemandTaskReport would return 
a NACL::CS::VserverVscanOnDemandTaskReport object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverVscanOnDemandTaskReport->delete(
                                command_interface => $ci,
	                            'task-name' => $task_name,
	                            'vserver' => $vserver,
	                            'report-file' => $report_file,
                                ...);
	                             
								 or

    $VserverVscanOnDemandTaskReport_obj->delete(...);

(Class or instance method)
This method is used to delete an On-Demand report.
Uses CMode CLI/ZAPI .
Invokes  vscan-on-demand-report-delete  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'task-name' => $task_name >>

(Required for class method, Not Applicable for instance method)
Task Name
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'report-file' => $report_file >>

(Required for class method, Not Applicable for instance method)
Report File Path
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'delete-report-file' => $string >>

Delete report file also possible value(s) are, true,false
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver vscan on demand task report delete" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( delete-report-file
                    )
            ),
        },
        cli_cmd => 'vserver vscan on-demand-task report delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_delete_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        nacl_exceptions => [qw(DoesNotExist)],
        frontend        => 'NACL::C::VserverVscanOnDemandTaskReport::delete',
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_on_demand_task_report_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(delete-report-file task-name report-file)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-on-demand-report-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(task-name vserver report-file)],
        _vs_context   => 1
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'task-name'   => {type => SCALAR},
        'vserver'     => {type => SCALAR},
        'report-file' => {type => SCALAR},
    );
}

1;
