# Copyright (c) 2001-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanScannerPool Component Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::C::VserverVscanScannerPool

=head1 DESCRIPTION

C<NACL::C::VserverVscanScannerPool> is a derived class of
L<NACL::C::Component::ONTAP|lib-NACL-C-Component-ONTAP-pm>. It represents access
to an ONTAP VserverVscanScannerPool.  A related class is
L<NACL::CS::VserverVscanScannerPool|lib-NACL-CS-VserverVscanScannerPool-pm>, which represents
the past state of an ONTAP VserverVscanScannerPool.

=head1 ATTRIBUTES

=head2 command_interface

See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>

=head2 vserver

=head2 scanner_pool

=cut

package NACL::C::VserverVscanScannerPool;

use strict;
use warnings;

use NACL::CS::VserverVscanScannerPool;
use NACL::ComponentUtils qw (_optional_scalars Dumper);

use base 'NACL::C::Component::ONTAP';
use Params::Validate qw(validate_with SCALAR ARRAYREF SCALARREF);
use NATE::Log qw(log_global);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use NACL::C::Exceptions::VserverVscanScannerPool::DoesNotExist qw(:try);
use NACL::C::Exceptions::VserverVscanScannerPool::DoesNotExist;
use NACL::Global;

=head1 METHODS

=head2 new

  my $VserverVscanScannerPool = NACL::C::VserverVscanScannerPool->new(
                                   command_interface => $ci,
                                   'vserver' => $vserver,
                                   'scanner-pool' => $scanner_pool,
								  );

Return a new VserverVscanScannerPool component object with the given attributes.

=cut

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'scanner_pool',
];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head2 find

    my $VserverVscanScannerPool_obj  = NACL::C::VserverVscanScannerPool->find(command_interface => $ci, ...);
	my @VserverVscanScannerPool_objs = NACL::C::VserverVscanScannerPool->find(command_interface => $ci, ...);

(Class method)
A constructor of sorts, which discovers which elements are present (by
interacting with the given command interface).  In an array context it
creates a component object for each present element and returns them.
In a scalar context it creates a component object for just one
element.

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::find|lib-NACL-C-Component-pm/find> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=head2 state

    my VserverVscanScannerPool_state = $VserverVscanScannerPool_obj->state();

(Instance method)
Fetch the current state of the element associated
with this component, and return a Component State object corresponding
to this component (calling this on NACL::C::VserverVscanScannerPool would return
a NACL::CS::VserverVscanScannerPool object)

This method is generally not implemented in individual components. The base
class (L<NACL::C::Component|lib-NACL-C-Component-pm> provides an implementation.
See <L<NACL::C::Component::state|lib-NACL-C-Component-pm/state> for a more
detailed description along with explanation of all the options accepted.

Uses a CMode CLI/ZAPI APISet.

=cut

sub init {
    $Log->enter() if $may_enter;
    my ($self, @args) = @_;
    $self->SUPER::init(@args);
    $self->_vserver_context_init(@args);
    $Log->exit() if $may_exit;
}

=head2 apply_policy

    NACL::C::VserverVscanScannerPool->apply_policy(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'scanner-pool' => $scanner_pool,
                                ...);

								 or

    $VserverVscanScannerPool_obj->apply_policy(...);

(Class or instance method)
This method is used to apply scanner-policy to a scanner pool.
Uses CMode CLI/ZAPI .
Invokes  vscan-scanner-pool-apply-policy for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI

=item C<< 'scanner-pool' => $scanner_pool >>

(Required for class method, Not Applicable for instance method)
Scanner Pool

Applicable for CMode CLI/ZAPI

=item C<< 'scanner-policy' => $string >>

Scanner Policy

Applicable for CMode CLI

=item C<< 'cluster' => $string >>

Cluster on which policy is applied
Applicable for CMode CLI

=item C<< '*' >>

This method takes all other options supported by "vserver vscan scanner pool apply policy" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub apply_policy {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            _optional_scalars(
                qw( scanner-policy

                    cluster
                    )
            ),
        },
        cli_cmd => 'vserver vscan scanner-pool apply-policy',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_apply_policy_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_apply_policy_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],

        frontend        => 'NACL::C::VserverVscanScannerPool::apply_policy',
        nacl_exceptions => [qw(DoesNotExist)]
    );

    $Log->exit() if $may_exit;
}

sub _apply_policy_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_scanner_pool_apply_policy',);
    $Log->exit() if $may_exit;
}

sub _apply_policy_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(scanner-pool scanner-policy)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-scanner-pool-apply-policy',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 create

    my $VserverVscanScannerPool_obj	= NACL::C::VserverVscanScannerPool->create(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'scanner-pool' => $scanner_pool,
                                ...);

(Class method)
This method is used to create a scanner pool.
Uses CMode CLI/ZAPI .
Invokes  vscan-scanner-pool-create for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required) See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'scanner-pool' => $scanner_pool >>

(Required)
Scanner Pool

Applicable for CMode CLI/ZAPI

=item C<< 'session-setup-timeout' => $string >>

Session Setup Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'request-timeout' => $string >>

Request Service Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'max-session-setup-retries' => $string >>

Max Number of Consecutive Session Setup Attempts

Applicable for CMode CLI/ZAPI

=item C<< 'scan-queue-timeout' => $string >>

Scan Queue Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'session-teardown-timeout' => $string >>

Session Teardown Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'privileged-users' => [ $privileged-user1, $privileged-user2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< 'servers' => [ $server1, $server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "vserver vscan scanner pool create" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub create {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->_frontend_log_debug_opts(@args);
    my %opts = $pkg->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'privileged-users' => {type => ARRAYREF, optional => 1},
            'servers'          => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( session-setup-timeout request-timeout max-session-setup-retries
                    scan-queue-timeout session-teardown-timeout
                    )
            ),
        },
        cli_cmd => 'vserver vscan scanner-pool create',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_create_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_create_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend        => 'NACL::C::VserverVscanScannerPool::create',
        nacl_exceptions => [qw(AlreadyExists)]
    );

    my $obj = $pkg->new(
        command_interface => $opts{command_interface},
        vserver           => $vserver,
        scanner_pool      => $opts{'scanner-pool'},
    );
    $Log->exit() if $may_exit;
    return $obj;
}

sub _create_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    if ($opts{command_interface}->version_manager()->is_version_ge(
        release => $NACL::Global::ONTAP_Release_Longboard_0)){
        $opts{hostnames} = delete $opts{servers} if(defined($opts{servers}));
    } 
    $pkg->_base_backend_cmode_cli(%opts,
        api => 'vserver_vscan_scanner_pool_create',);
    $Log->exit() if $may_exit;
}

sub _create_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my $copy = [
        qw(session-setup-timeout request-timeout privileged-users
            scanner-pool max-session-setup-retries scan-queue-timeout
            session-teardown-timeout servers)
    ];
    my %map = ();
    if ($opts{command_interface}->version_manager()->is_version_ge(
        release => $NACL::Global::ONTAP_Release_Longboard_0)){
        my @copy_arr = grep {$_ !~ /server/} @$copy ;
        $copy = \@copy_arr ;
        %map = (map =>{'servers' => 'hostnames',});
    }
    $pkg->_base_backend_cmode_zapi(
        %opts,
        api  => 'vscan-scanner-pool-create',
        copy => $copy,
        %map,
    );
    $Log->exit() if $may_exit;
}

=head2 delete

    NACL::C::VserverVscanScannerPool->delete(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'scanner-pool' => $scanner_pool,
                                ...);

								 or

    $VserverVscanScannerPool_obj->delete(...);

(Class or instance method)
This method is used to delete a scanner pool.
Uses CMode CLI/ZAPI .
Invokes  vscan-scanner-pool-delete for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'scanner-pool' => $scanner_pool >>

(Required for class method, Not Applicable for instance method)
Scanner Pool

Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "vserver vscan scanner pool delete" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub delete {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver vscan scanner-pool delete',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_delete_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_delete_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                check     => '_delete_zapi_check',
            },
        ],
        frontend        => 'NACL::C::VserverVscanScannerPool::delete',
        nacl_exceptions => [qw(DoesNotExist)]
    );

    $Log->exit() if $may_exit;
}

sub _delete_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_scanner_pool_delete',);
    $Log->exit() if $may_exit;
}

sub _delete_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(scanner-pool)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-scanner-pool-delete',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

sub _delete_zapi_check {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    my @fields_to_check = ('scanner-pool');
    $pkg_or_obj->_fallback_for_relational_regex(%opts,
        fields_to_check => \@fields_to_check);

    $Log->exit() if $may_exit;
}

=head2 modify

    NACL::C::VserverVscanScannerPool->modify(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'scanner-pool' => $scanner_pool,
                                ...);

								 or

    $VserverVscanScannerPool_obj->modify(...);

(Class or instance method)
This method is used to modify a scanner pool.
Uses CMode CLI/ZAPI .
Invokes  vscan-scanner-pool-modify for CMode Zapi


=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>

=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver

Applicable for CMode CLI/ZAPI

=item C<< 'scanner-pool' => $scanner_pool >>

(Required for class method, Not Applicable for instance method)
Scanner Pool

Applicable for CMode CLI/ZAPI

=item C<< 'session-setup-timeout' => $string >>

Session Setup Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'request-timeout' => $string >>

Request Service Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'max-session-setup-retries' => $string >>

Max Number of Consecutive Session Setup Attempts

Applicable for CMode CLI/ZAPI

=item C<< 'scan-queue-timeout' => $string >>

Scan Queue Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'session-teardown-timeout' => $string >>

Session Teardown Timeout

Applicable for CMode CLI/ZAPI

=item C<< 'privileged-users' => [ $privileged-user1, $privileged-user2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< 'servers' => [ $server1, $server2, ... ] >>

(Arrayref, even if only a single value is to be sent it should specified
as an arrayref containing that single value)


Applicable for CMode CLI/ZAPI

=item C<< '*' >>

This method takes all other options supported by "vserver vscan scanner pool modify" command in ONTAP
Applicable for CMode CLI/ZAPI

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub modify {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params          => \@args,
        additional_spec => {
            'privileged-users' => {type => ARRAYREF, optional => 1},
            'servers'          => {type => ARRAYREF, optional => 1},
            _optional_scalars(
                qw( session-setup-timeout request-timeout max-session-setup-retries
                    scan-queue-timeout session-teardown-timeout
                    )
            ),
        },
        cli_cmd => 'vserver vscan scanner-pool modify',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset(
        %opts,
        choices => [
            {   method    => '_modify_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_modify_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        frontend => 'NACL::C::VserverVscanScannerPool::modify',
    );

    $Log->exit() if $may_exit;
}

sub _modify_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_scanner_pool_modify',);
    $Log->exit() if $may_exit;
}

sub _modify_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [
        qw(session-setup-timeout request-timeout scanner-pool
            privileged-users max-session-setup-retries servers scan-queue-timeout
            session-teardown-timeout)
    ];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-scanner-pool-modify',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}

=head2 show_active

    my $show_active_obj = NACL::C::VserverVscanScannerPool->show_active(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or

    my @show_active_objs = NACL::C::VserverVscanScannerPool->show_active(command_interface => $ci,
                          [ filter => { %filter } ,]
			  [ requested_fields => [ @req_fields ]);

                    or

   my $show_active_obj = $VserverVscanScannerPool_obj->show_active();

(Class or Instance method)

This method is a CS-like fetch method which accepts all the parameters of
L<fetch|lib-NACL-CS-ComponentState-pm/fetch> (requested_fields, filter, allow_empty)
and has all of the other properties of fetch methods (callable in scalar or list
context, throws a NoElementsFound exception if no matching elements are found).
The requested fields and filter takes L<ATTRIBUTES|lib-NACL-CS-VserverVscanScannerPoolShowActive-pm/ATTRIBUTES>
of NACL::CS::VserverVscanScannerPoolShowActive as input.
This method returns objects of the type L<NACL::CS::VserverVscanScannerPoolShowActive|lib-NACL-CS-VserverVscanScannerPoolShowActive-pm>.

=cut

sub show_active {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = $pkg_or_obj->_handle_obj_cs_like_calls(@args);
    require NACL::CS::VserverVscanScannerPoolShowActive;
    my @state_objs
        = NACL::CS::VserverVscanScannerPoolShowActive->fetch(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

=head2 resolve_hostnames

    NACL::C::VserverVscanScannerPool->resolve_hostnames(
                                command_interface => $ci,
	                            'vserver' => $vserver,
	                            'scanner-pool' => $scanner_pool,
                                ...);
	                             
								 or

    $VserverVscanScannerPool_obj->resolve_hostnames(...);

(Class or instance method)
This method is used to resolve the hostnames configured in the scanner pool.
Uses CMode CLI/ZAPI .
Invokes  vscan-resolve-hostnames  for CMode Zapi non-iter

=over

=item Options

=over

=item C<< command_interface => $command_interface >>

(Required for class method, Not Applicable for instance method)
See L<NACL::C::Component|lib-NACL-C-Component-pm/command_interface>

=item C<< apiset_must => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_must>

=item C<< apiset_should => $ruleset >>

(Optional) See L<NACL::C::Component|lib-NACL-C-Component-pm/apiset_should>


=item C<< 'vserver' => $vserver >>

(Required for class method, Not Applicable for instance method)
Vserver
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< 'scanner-pool' => $scanner_pool >>

(Required for class method, Not Applicable for instance method)
Scanner Pool
Applicable for CMode CLI/ZAPI, non-iter.

=item C<< '*' >>

This method takes all other options supported by "vserver vscan scanner pool resolve hostnames" command in ONTAP

=item C<< other_options >>

This method takes other common options described in L<Common method options|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#Other_options_valid_on_component_methods>

=back

=back

=over

=item Exceptions

=over

=item C<APISet exceptions>

In general, Component methods propagate the exceptions thrown from
underlying API layer and the details of those exceptions are described in the
L<Exceptions section|http://thebrewery-web.corp.netapp.com/Brewery/brewery/QA/TestAutomation/NACL/UsersGuide/ComponentLayerUsersGuide/index.html#How_do_I_know_which_exceptions_are_thrown_by_a_component_method>
of user guide.

=back

=back

=cut

sub resolve_hostnames {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    $pkg_or_obj->_frontend_log_debug_opts(@args);
    my %opts = $pkg_or_obj->_common_validate_with(
        params  => \@args,
        cli_cmd => 'vserver vscan scanner-pool resolve-hostnames',
    );
    my $vserver;
    $opts{vserver_operated_on} = \$vserver;
    $pkg_or_obj->call_on_apiset_with_exceptions(
        %opts,
        choices => [
            {   method    => '_resolve_hostnames_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_resolve_hostnames_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
            },
        ],
        frontend => 'NACL::C::VserverVscanScannerPool::resolve_hostnames',
    );

    $Log->exit() if $may_exit;
}

sub _resolve_hostnames_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    $pkg_or_obj->_base_backend_cmode_cli(@opts,
        api => 'vserver_vscan_scanner_pool_resolve_hostnames',);
    $Log->exit() if $may_exit;
}

sub _resolve_hostnames_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @opts) = @_;
    my $copy = [qw(scanner-pool)];
    $pkg_or_obj->_base_backend_cmode_zapi(
        @opts,
        api  => 'vscan-resolve-hostnames',
        copy => $copy,
    );
    $Log->exit() if $may_exit;
}


__PACKAGE__->_load_event_class();

sub _primary_keys_validate_spec {
    return (
        'vserver'      => {type => SCALAR},
        'scanner-pool' => {type => SCALAR},
    );
}

1;
