# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the VolumeSnapshotAutodelete
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::C::_Mixins::VolumeSnapshotAutodelete;

use strict;
use warnings;

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(_common_zapi_copy _common_zapi_map);
    our %EXPORT_TAGS = ('all' => \@EXPORT_OK);
}

sub _common_zapi_copy {
    return [qw(commitment trigger)],
}

sub _common_zapi_map {
    return {
        'target-free-space'   => 'target_free_space',
        'destroy-list'        => 'destroy_list',
        'defer-delete-prefix' => 'prefix',
        'delete-order'        => 'delete_order',
        'defer-delete'        => 'defer_delete',
        enabled               => 'state',
    };
}

1;
