#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the VserverSecurityFileDirectoryPolicyTask.pm Component 
## and ComponentState
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::C::_Mixins::VserverSecurityFileDirectoryPolicyTask;

use strict;
use warnings;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Params::Validate qw(validate_with HASHREF);

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(_handle_ntfs_sd);
    our %EXPORT_TAGS = ( 'all' => \@EXPORT_OK );
}


sub _handle_ntfs_sd {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, @args) = @_;
    my %opts = validate_with(
        params => \@args,
        spec   => {options => {type => HASHREF}},
    );
    my $options = $opts{options};
    my $command_interface = $options->{'command_interface'};
    if ( $command_interface->version_manager()->is_version_ge(release => '8.3')) {
        if (!ref $options->{'ntfs-sd'} ) {
            $options->{'ntfs-sd'} = [$options->{'ntfs-sd'}];
            $Log->warn("'ntfs-sd' should be an ARRAYREF for FS onwards");
        }
    }
    $Log->exit() if $may_exit;
}
1;
