
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the VserverServicesNameServiceNsSwitch Component and ComponentState
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::C::_Mixins::VserverServicesNameServiceNsSwitch;

use strict;
use warnings;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(
        _common_zapi_map
    );
    our %EXPORT_TAGS = ( 'all' => \@EXPORT_OK );
}

sub _common_zapi_map {
    $Log->enter() if $may_enter;
    my $map = {
        'enabled'   => 'is-enabled',
        'database'  => 'nameservice-database',
    };
    $Log->exit() if $may_exit;
    return $map;
}

1;
