#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemand ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusOnDemand

=head1 DESCRIPTION

C<NACL::CS::AntivirusOnDemand> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusOnDemand.  A related class is
L<NACL::C::AntivirusOnDemand|lib-NACL-C-AntivirusOnDemand-pm>, which represents access
to an ONTAP AntivirusOnDemand.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the AntivirusOnDemand
element are the attributes of the AntivirusOnDemand ComponentState.

=over

=item C<< "jobid" >>

Job ID

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-job-info>
     <jobid>$value</jobid>
 </av-on-demand-job-info>

=item C<< "name" >>

Command name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-job-info>
     <name>$value</name>
 </av-on-demand-job-info>

=item C<< "node" >>

Node Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-job-info>
     <node>$value</node>
 </av-on-demand-job-info>

=item C<< "state" >>

Job State

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-job-info>
     <state>$value</state>
 </av-on-demand-job-info>

=item C<< "schedule" >>

Job Schedule

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-job-info>
     <schedule>$value</schedule>
 </av-on-demand-job-info>

=item C<< vserver >>

Vserver Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-job-info>
     <vserver>$value</vserver>
 </av-on-demand-job-info>

=back

=cut

package NACL::CS::AntivirusOnDemand;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'jobid',
    scalar => 'name',
    scalar => 'node',
    scalar => 'state',
    scalar => 'schedule',
    scalar => 'vserver',
];

=head1 METHODS

=head2 fetch

    my $AntivirusOnDemand_state   = NACL::CS::AntivirusOnDemand->fetch(command_interface => $ci, ...);
    my @AntivirusOnDemand_states = NACL::CS::AntivirusOnDemand->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "av-on-demand-job-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching antivirus on demand(s) found',
        show_cmd       => 'antivirus on-demand show',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'antivirus_on_demand_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        api  => 'av-on-demand-job-get-iter',
        copy => [qw ( node vserver jobid name schedule state )],
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
