# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemandCommandScanCluster ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusOnDemandCommandScanCluster

=head1 DESCRIPTION

C<NACL::CS::AntivirusOnDemandCommandScanCluster> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusOnDemandCommandScanCluster.  A related class is
L<NACL::C::AntivirusOnDemandCommandScanCluster|lib-NACL-C-AntivirusOnDemandCommandScanCluster-pm>, which represents access
to an ONTAP AntivirusOnDemandCommandScanCluster.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the AntivirusOnDemandCommandScanCluster
element are the attributes of the AntivirusOnDemandCommandScanCluster ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< recursion >>

Enable Subdirectory Recusion, possible value(s) are on,off

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <enable-subdirectory-recursion>$value</enable-subdirectory-recursion>
 </av-on-demand-command-scan-cluster-info>

=item C<< include_files >>

Include or Exclude File-pattern, possible value(s) are include,exclude

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <include-files>$value</include-files>
 </av-on-demand-command-scan-cluster-info>

=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <vserver>$value</vserver>
 </av-on-demand-command-scan-cluster-info>

=item C<< name >>

Command Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <command-name>$value</command-name>
 </av-on-demand-command-scan-cluster-info>

=item C<< force >>

Force Creation

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <force>$value</force>
 </av-on-demand-command-scan-cluster-info>

=item C<< include_directories >>

Include or Exclude Directory-pattern, possible value(s) are include,exclude

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <include-directories>$value</include-directories>
 </av-on-demand-command-scan-cluster-info>

=item C<< policy_owner >>

Creator of On-demand Command

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <policy-owner>$value</policy-owner>
 </av-on-demand-command-scan-cluster-info>

=item C<< include_vservers >>

Include or Exclude Vserver-pattern, possible value(s) are include,exclude

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <include-vservers>$value</include-vservers>
 </av-on-demand-command-scan-cluster-info>

=item C<< follow_junctions >>

Enable Follow Junction, possible value(s) are on,off

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <enable-junction-following>$value</enable-junction-following>
 </av-on-demand-command-scan-cluster-info>

=item C<< vserver_pattern >>

Regular Expression for Vservers

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <vserver-pattern>$value</vserver-pattern>
 </av-on-demand-command-scan-cluster-info>

=item C<< scan_type >>

Object to be Scanned, possible value(s) are file,dir,vserver,cluster

Filled in for CMode CLI.

=item C<< file_pattern >>

Regular Expression for Files

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <file-pattern>$value</file-pattern>
 </av-on-demand-command-scan-cluster-info>

=item C<< directory_pattern >>

Regular Expression for Directories

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-cluster-info>
     <directory-pattern>$value</directory-pattern>
 </av-on-demand-command-scan-cluster-info>

=back

=cut

package NACL::CS::AntivirusOnDemandCommandScanCluster;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'recursion',
    scalar => 'include_files',
    scalar => 'vserver',
    scalar => 'name',
    scalar => 'force',
    scalar => 'include_directories',
    scalar => 'policy_owner',
    scalar => 'include_vservers',
    scalar => 'follow_junctions',
    scalar => 'vserver_pattern',
    scalar => 'scan_type',
    scalar => 'file_pattern',
    scalar => 'directory_pattern',
];

=head1 METHODS

=head2 fetch

    my $AntivirusOnDemandCommandScanCluster_state  = NACL::CS::AntivirusOnDemandCommandScanCluster->fetch(command_interface => $ci, ...);
    my @AntivirusOnDemandCommandScanCluster_states = NACL::CS::AntivirusOnDemandCommandScanCluster->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "av-on-demand-command-scan-cluster-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching antivirus on-demand command scan-cluster(s) found',
        show_cmd       => 'antivirus on-demand command scan-cluster show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'antivirus_on_demand_command_scan_cluster_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $allowed_cmode_options = [
        qw(  include-files vserver force include-directories
            include-vservers  vserver-pattern file-pattern
            directory-pattern policy-owner
            )
    ];
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => $allowed_cmode_options,
        map  => {
            'name'             => 'command-name',
            'follow-junctions' => 'enable-junction-following',
            'recursion'        => 'enable-subdirectory-recursion',
        },
        api => 'av_on_demand_command_scan_cluster_get_iter',
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
