# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemandCommandScanDir ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusOnDemandCommandScanDir

=head1 DESCRIPTION

C<NACL::CS::AntivirusOnDemandCommandScanDir> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusOnDemandCommandScanDir.  A related class is
L<NACL::C::AntivirusOnDemandCommandScanDir|lib-NACL-C-AntivirusOnDemandCommandScanDir-pm>, which represents access
to an ONTAP AntivirusOnDemandCommandScanDir.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the AntivirusOnDemandCommandScanDir
element are the attributes of the AntivirusOnDemandCommandScanDir ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< scan_path >>

Path Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
     <scan-path>$value</scan-path>
 </av-on-demand-command-scan-dir-info>

=item C<< recursion >>

Enable Subdirectory Recusion, possible value(s) are on,off

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
     <enable-subdirectory-recursion>$value</enable-subdirectory-recursion>
 </av-on-demand-command-scan-dir-info>

=item C<< include_files >>

Include or Exclude File-pattern, possible value(s) are include,exclude

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
     <include-files>$vlaue</include-files>
 </av-on-demand-command-scan-dir-info>

=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
    <vserver>$value</vserver>
 </av-on-demand-command-scan-dir-info>

=item C<< name >>

Command Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
    <command-name>$vlaue</command-name>
 </av-on-demand-command-scan-dir-info>

=item C<< force >>

Force Creation

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
    <force>$value</force>
 </av-on-demand-command-scan-dir-info>

=item C<< policy_owner >>

Creator of On-demand Command

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
    <policy-owner>$value</policy-owner>
 </av-on-demand-command-scan-dir-info>

=item C<< scan_type >>

Filled in for CMode CLI

=item C<< follow_junctions >>

Enable Follow Junction, possible value(s) are on,off

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
    <enable-junction-following>$value</enable-junction-following>
 </av-on-demand-command-scan-dir-info>

=item C<< file_pattern >>

Regular Expression for Files

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For 'requested_fields', 'filter' and Output mapping:

 <av-on-demand-command-scan-dir-info>
    <file-pattern>$value</file-pattern>
 </av-on-demand-command-scan-dir-info>

=back

=cut

package NACL::CS::AntivirusOnDemandCommandScanDir;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'scan_path',
    scalar => 'recursion',
    scalar => 'include_files',
    scalar => 'vserver',
    scalar => 'name',
    scalar => 'force',
    scalar => 'policy_owner',
    scalar => 'scan_type',
    scalar => 'follow_junctions',
    scalar => 'file_pattern',
];

=head1 METHODS

=head2 fetch

    my $AntivirusOnDemandCommandScanDir_state  = NACL::CS::AntivirusOnDemandCommandScanDir->fetch(command_interface => $ci, ...);
    my @AntivirusOnDemandCommandScanDir_states = NACL::CS::AntivirusOnDemandCommandScanDir->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes 'av-on-demand-command-scan-dir-get-iter' API for CMode ZAPI.

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching antivirus on-demand command scan-dir(s) found',
        show_cmd       => 'antivirus on-demand command scan-dir show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'antivirus_on_demand_command_scan_dir_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;

    my $conversion_values = {'on' => 'true', 'off' => 'false'};

    if (   defined $opts{filter}->{'follow-junctions'}
        && defined $conversion_values->{$opts{filter}->{'follow-junctions'}})
    {
        $opts{filter}->{'follow-junctions'}
            = $conversion_values->{$opts{filter}->{'follow-junctions'}};
    }

    if (defined $opts{filter}->{'recursion'}
        && $conversion_values->{$opts{filter}->{'recursion'}})
    {
        $opts{filter}->{'recursion'}
            = $conversion_values->{$opts{filter}->{'recursion'}};
    }

    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        %opts,
        api  => 'av_on_demand_command_scan_dir_get_iter',
        copy => [
            qw( file-pattern force include-files policy-owner scan-path vserver )
        ],
        map => {
            'name'             => 'command-name',
            'follow-junctions' => 'enable-junction-following',
            'recursion'        => 'enable-subdirectory-recursion',
        },
    );

    $conversion_values = {'true' => 'on', 'false' => 'off'};
    foreach my $state (@state_objs) {
        if (defined $state->follow_junctions()) {
            $state->follow_junctions(
                $conversion_values->{$state->follow_junctions()});
        }

        if (defined $state->recursion()) {
            $state->recursion($conversion_values->{$state->recursion()});
        }
    }

    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi
1;
