# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusOnDemandReport ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusOnDemandReport

=head1 DESCRIPTION

C<NACL::CS::AntivirusOnDemandReport> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusOnDemandReport.  A related class is
L<NACL::C::AntivirusOnDemandReport|lib-NACL-C-AntivirusOnDemandReport-pm>, which represents access
to an ONTAP AntivirusOnDemandReport.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the AntivirusOnDemandReport
element are the attributes of the AntivirusOnDemandReport ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< file_scanned >>

Attempted Scans

Filled in for CMode CLI

=item C<< file_infected >>

Infected Files

Filled in for CMode CLI

=item C<< date >>

Date and Time

Filled in for CMode CLI

=item C<< scan_duration >>

Duration of Scan

Filled in for CMode CLI

=item C<< file_deleted >>

Deleted Files

Filled in for CMode CLI

=item C<< id >>

ID

Filled in for CMode CLI

=item C<< command >>

Command Name

Filled in for CMode CLI

=item C<< file_quarantined >>

Quarantined Files

Filled in for CMode CLI

=item C<< remedy_failed >>

Remedy Failed

Filled in for CMode CLI

=item C<< location >>

Location

Filled in for CMode CLI

=item C<< vserver >>

Vserver

Filled in for CMode CLI

=item C<< scan_retry >>

Retried Scans

Filled in for CMode CLI

=item C<< package >>

Package Name

Filled in for CMode CLI

=item C<< scan_success >>

Successful Scans

Filled in for CMode CLI

=item C<< scan_failed >>

Failed Scans

Filled in for CMode CLI

=item C<< job_id >>

Job ID

Filled in for CMode CLI

=item C<< file_repaired >>

Repaired Files

Filled in for CMode CLI

=back

=cut

package NACL::CS::AntivirusOnDemandReport;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'file_scanned',
    scalar => 'file_infected',
    scalar => 'date',
    scalar => 'scan_duration',
    scalar => 'file_deleted',
    scalar => 'id',
    scalar => 'command',
    scalar => 'file_quarantined',
    scalar => 'remedy_failed',
    scalar => 'location',
    scalar => 'vserver',
    scalar => 'scan_retry',
    scalar => 'package',
    scalar => 'scan_success',
    scalar => 'scan_failed',
    scalar => 'job_id',
    scalar => 'file_repaired',
];

=head1 METHODS

=head2 fetch

    my $AntivirusOnDemandReport_state  = NACL::CS::AntivirusOnDemandReport->fetch(command_interface => $ci, ...);
	my @AntivirusOnDemandReport_states = NACL::CS::AntivirusOnDemandReport->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching antivirus on-demand report(s) found',
        frontend       => 'NACL::CS::AntivirusOnDemandReport::fetch',
        show_cmd       => 'antivirus on-demand report show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'antivirus_on_demand_report_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
