#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AntivirusUpdate ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::AntivirusUpdate

=head1 DESCRIPTION

C<NACL::CS::AntivirusUpdate> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP AntivirusUpdate.  A related class is
L<NACL::C::AntivirusUpdate|lib-NACL-C-AntivirusUpdate-pm>, which represents access
to an ONTAP AntivirusUpdate.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the AntivirusUpdate
element are the attributes of the AntivirusUpdate ComponentState.

=over

=item C<< "schedule_month" >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $schedule_month = $obj->schedule_month();
# $schedule_month contains a reference to the array of values
my @schedule_month = $obj->schedule_month();
# @schedule_month contains the array of values

Filled in for CMode CLI

=item C<< "schedule_dayofweek" >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $schedule_dayofweek = $obj->schedule_dayofweek();
# $schedule_dayofweek contains a reference to the array of values
my @schedule_dayofweek = $obj->schedule_dayofweek();
# @schedule_dayofweek contains the array of values

Filled in for CMode CLI

=item C<< "reason" >>

Filled in for CMode CLI

=item C<< "last_update" >>

Filled in for CMode CLI

=item C<< "schedule_minute" >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $schedule_minute = $obj->schedule_minute();
# $schedule_minute contains a reference to the array of values
my @schedule_minute = $obj->schedule_minute();
# @schedule_minute contains the array of values

Filled in for CMode CLI

=item C<< "auto_update" >>

Filled in for CMode CLI

=item C<< "rollback_version" >>

Filled in for CMode CLI

=item C<< "internal_current_version" >>

Filled in for CMode CLI

=item C<< "update_schedule" >>

Filled in for CMode CLI

=item C<< "internal_rollback_version" >>

Filled in for CMode CLI

=item C<< "schedule_day" >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $schedule_day = $obj->schedule_day();
# $schedule_day contains a reference to the array of values
my @schedule_day = $obj->schedule_day();
# @schedule_day contains the array of values

Filled in for CMode CLI

=item C<< "schedule_hour" >>

(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $schedule_hour = $obj->schedule_hour();
$schedule_hour contains a reference to the array of values
my @schedule_hour = $obj->schedule_hour();
@schedule_hour contains the array of values

Filled in for CMode CLI

=item C<< "current_version" >>

Filled in for CMode CLI

=back

=cut

package NACL::CS::AntivirusUpdate;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'schedule_month',
    array  => 'schedule_dayofweek',
    scalar => 'reason',
    scalar => 'last_update',
    array  => 'schedule_minute',
    scalar => 'auto_update',
    scalar => 'rollback_version',
    scalar => 'internal_current_version',
    scalar => 'update_schedule',
    scalar => 'internal_rollback_version',
    array  => 'schedule_day',
    array  => 'schedule_hour',
    scalar => 'current_version',
];

=head1 METHODS

=head2 fetch

    my $AntivirusUpdate_state   = NACL::CS::AntivirusUpdate->fetch(command_interface => $ci, ...);
	my @AntivirusUpdate_states = NACL::CS::AntivirusUpdate->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching antivirus update(s) found',
        is_singleton   => 1,
        show_cmd       => 'antivirus update show',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api          => 'antivirus_update_show',
        is_singleton => 1
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
