# $Id: //depot/prod/test/UM6.0_integ/lib/NACL/CS/DFM/DiskPhysicalSummaryLunInfo.pm#1 $

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.

## @summary Disk ComponentState Module (auto-generated by CGT)
## @author vinothg, dl-mei-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::DiskPhysicalSummaryLunInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::DiskPhysicalSummaryLunInfo> is a derived class of
L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm>. It represents the
state of an ONTAP Disk.  A related class is
L<NACL::C::DFM::Disk|lib-NACL-C-DFM-Disk-pm>, which represents access
to an ONTAP Disk.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Disk
element are the attributes of the Disk ComponentState.

=over

=item C<< raw_space >>

=item C<< spare_space >>

=item C<< total_space >>

=item C<< data_lun_count >>

=item C<< spare_lun_count >> 

=item C<< total_lun_count >> 
    
=back

=cut

package NACL::CS::DFM::DiskPhysicalSummaryLunInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'raw_space',
    scalar => 'spare_space',
    scalar => 'total_space',
    scalar => 'data_lun_count',
    scalar => 'spare_lun_count',
    scalar => 'total_lun_count',
];

1;
