# $Id: //depot/prod/test/UM6.0_integ/lib/NACL/CS/DFM/EventAction.pm#1 $ction

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Event ComponentState Module (auto-generated by CGT)
## @author vinothg,dl-mpo-nacl-dev@netapp.com
#
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::EventAction

=head1 DESCRIPTION

C<NACL::CS::DFM::EventAction> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a DFM Event.  A related class is
L<NACL::C::DFM::Event|lib-NACL-C-DFM-Event-pm>, which represents access
to a DFM Event.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Event
element are the attributes of the Event ComponentState.

=over

=item C<< error_code >>

=item C<< error_message >>

=item C<< event_id >>

=item C<< timestamp >

=item C<< warning_message >>

=back

=over

=back
 
=cut

package NACL::CS::DFM::EventAction;

use strict;
use warnings;
use Params::Validate
  qw(validate validate_with validate_pos SCALAR ARRAYREF HASHREF);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NATE::BaseException;

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'event_id',
    scalar => 'error_message',
    scalar => 'error_code',
    scalar => 'timestamp',
    scalar => 'warning_message',
];

1;
