# $Id$
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary FlashCardInfo ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::FlashCardInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::FlashCardInfo> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a FlashCardInfo.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the FlashCardInfo
element are the attributes of the FlashCardInfo ComponentState.

=over


=item C<< percent_online >>

=item C<< slot_number >>

=item C<< firmware_revision >>

=item C<< serial_number >>

=item C<< status >>

=item C<< capacity >>

=item C<< model_name >>

=back

=cut 

package NACL::CS::DFM::FlashCardInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'percent_online',
    scalar => 'slot_number',
    scalar => 'firmware_revision',
    scalar => 'serial_number',
    scalar => 'status',
    scalar => 'capacity',
    scalar => 'model_name',
];

1;
