# $Id: //depot/prod/test/main/lib/NACL/CS/FlexibleVolumeInfo.pm $
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary FlexibleVolumeInfo ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::FlexibleVolumeInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::FlexibleVolumeInfo> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a FlexibleVolumeInfo.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the FlexibleVolumeInfo
element are the attributes of the FlexibleVolumeInfo ComponentState.

=over


=item C<< aggregate_resource_key >>

=item C<< autogrow_increment_size >>

=item C<< maximum_size >>

=item C<< aggregate_name >>

=item C<< volume_clone_info >>
( Type L<NACL::CS::DFM::VolumeCloneInfo|lib-NACL-CS-DFM-VolumeCloneInfo-pm> )

=item C<< is_autosize_enabled >>

=item C<< is_snapshot_autodelete_enabled >>

=back

=cut 

package NACL::CS::DFM::FlexibleVolumeInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'aggregate_resource_key',
    scalar => 'autogrow_increment_size',
    scalar => 'maximum_size',
    scalar => 'aggregate_name',
    scalar => [ { -type => 'NACL::CS::DFM::VolumeCloneInfo' }, 'volume_clone_info' ],
    scalar => 'is_autosize_enabled',
    scalar => 'is_snapshot_autodelete_enabled',
];

sub _nested_objects {
    return {
        'volume_clone_info' => 'NACL::CS::DFM::VolumeCloneInfo',
    };
}

1;
