# $Id$
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary License ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::License

=head1 DESCRIPTION

C<NACL::CS::DFM::License> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a License.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the License
element are the attributes of the License ComponentState.

=over


=item C<< owner_type >>

=item C<< serial_number >>

=item C<< package_name >>

=item C<< description >>

=item C<< owner_name >>

=item C<< owner_resource_key >>

=item C<< expiration_time >>

=back

=cut 

package NACL::CS::DFM::License;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'owner_type',
    scalar => 'serial_number',
    scalar => 'package_name',
    scalar => 'description',
    scalar => 'owner_name',
    scalar => 'owner_resource_key',
    scalar => 'expiration_time',
];

1;
