# $Id: //depot/prod/test/nacldev/lib/NACL/CS/DFM/QuotaUser.pm#1 $

#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary QuotaUser ComponentState Module (auto-generated by CGT)
## @author deepthis,dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::QuotaUser

=head1 DESCRIPTION

C<NACL::CS::DFM::QuotaUser> is a derived class of
L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm>. It represents the
state of an ONTAP QuotaUser.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the QuotaUser
element are the attributes of the QuotaUser ComponentState.

=over

=item C<< email_address >>

=item C<< quota_user_id >> 

=item C<< sid_uid_or_gid >> 

=item C<< type >>

=item C<< user_name >>

=back

=cut

package NACL::CS::DFM::QuotaUser;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';
use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'email_address',
    scalar => 'quota_user_id',
    scalar => 'sid_uid_or_gid',
    scalar => 'type',
    scalar => 'user_name',
];

=head1 METHODS


=head2 fetch

    my $QuotaUser_state   = NACL::CS::DFM::QuotaUser->fetch(command_interface => $ci, ...);
    my @QuotaUser_states = NACL::CS::DFM::QuotaUser->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {
                method    => '_fetch_zapi',
                interface => 'ZAPI',
                set       => 'DFM',
            },
        ],
        exception_text => 'No matching QuotaUser(s) found.',
    );

    $Log->exit() if $may_exit;

    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_zapi {

    $Log->enter() if $may_enter;

    my $pkg = shift;

    my @state_objs = $pkg->SUPER::_fetch_dfm_zapi(
        @_,
        api         => 'quota-user-list-iter',
        iter_filter => [qw( quota-user-name-or-id )],
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

# Overriding the implementation of ithe super class
sub _check_for_invalid_requested_filter_fields {

    $Log->enter() if $may_enter;
    my $pkg = shift;

    $pkg->SUPER::_check_for_invalid_requested_filter_fields( @_,
        additional_filter_fields => [qw( quota-user-name-or-id )] );
    $Log->exit() if $may_exit;

}

1;
