# $Id$
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SfoInfo ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::SfoInfo

=head1 DESCRIPTION

C<NACL::CS::DFM::SfoInfo> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a SfoInfo.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SfoInfo
element are the attributes of the SfoInfo ComponentState.

=over


=item C<< partner_node_status >>

=item C<< current_mode >>

=item C<< takeover_by_partner_not_possible_reason >>

=item C<< partner_name >>

=item C<< takeover_of_partner_not_possible_reason >>

=item C<< sfo_status >>

=item C<< takeover_failure_reason >>

=item C<< giveback_state >>

=item C<< sfo_state >>

=item C<< partner_resource_key >>

=back

=cut 

package NACL::CS::DFM::SfoInfo;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'partner_node_status',
    scalar => 'current_mode',
    scalar => 'takeover_by_partner_not_possible_reason',
    scalar => 'partner_name',
    scalar => 'takeover_of_partner_not_possible_reason',
    scalar => 'sfo_status',
    scalar => 'takeover_failure_reason',
    scalar => 'giveback_state',
    scalar => 'sfo_state',
    scalar => 'partner_resource_key',
];

1;
