# $Id: //depot/prod/test/main/lib/NACL/CS/VolumeMoveHistory.pm $
#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeMoveHistory ComponentState Module (auto-generated by OCUM CGT)
## @author dl-mpo-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DFM::VolumeMoveHistory

=head1 DESCRIPTION

C<NACL::CS::DFM::VolumeMoveHistory> is a derived class of
L<NACL::CS::ComponentState::DFM|lib-NACL-CS-ComponentState-DFM-pm>. It represents the
state of a VolumeMoveHistory.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VolumeMoveHistory
element are the attributes of the VolumeMoveHistory ComponentState.

=over


=item C<< volume_move_start_time >>

=item C<< volume_name >>

=item C<< volume_move_phase >>

=item C<< volume_move_estimated_completion_time >>

=item C<< volume_resource_key >>

=item C<< volume_move_details >>

=item C<< vserver_name >>

=item C<< destination_aggregate_name >>

=item C<< volume_move_completion_time >>

=item C<< vserver_resource_key >>

=item C<< source_aggregate_name >>

=item C<< destination_aggregate_resource_key >>

=item C<< volume_move_percent_complete >>

=item C<< source_aggregate_resource_key >>

=item C<< volume_move_state >>

=back

=cut 

package NACL::CS::DFM::VolumeMoveHistory;

use strict;
use warnings;
use Params::Validate qw(validate validate_with SCALAR ARRAYREF HASHREF);
use NACL::ComponentUtils qw(Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use base 'NACL::CS::ComponentState::DFM';

use Class::MethodMaker [
    new    => [ '-hash', 'new' ],
    scalar => 'volume_move_start_time',
    scalar => 'volume_name',
    scalar => 'volume_move_phase',
    scalar => 'volume_move_estimated_completion_time',
    scalar => 'volume_resource_key',
    scalar => 'volume_move_details',
    scalar => 'vserver_name',
    scalar => 'destination_aggregate_name',
    scalar => 'volume_move_completion_time',
    scalar => 'vserver_resource_key',
    scalar => 'source_aggregate_name',
    scalar => 'destination_aggregate_resource_key',
    scalar => 'volume_move_percent_complete',
    scalar => 'source_aggregate_resource_key',
    scalar => 'volume_move_state',
];

=head1 METHODS


=head2 fetch

    my $state = NACL::CS::DFM::VolumeMoveHistory->fetch(command_interface => $ci, ...);
    my @states = NACL::CS::DFM::VolumeMoveHistory->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=cut

sub fetch {

    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {
                method    => '_fetch_zapi',
                interface => 'ZAPI',
                set       => 'DFM',
            },
        ],
        exception_text => 'No matching VolumeMoveHistory(s) found.',
    );

    $Log->exit() if $may_exit;

    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_zapi {

    $Log->enter() if $may_enter;
    my $pkg = shift;

    my @state_objs = $pkg->SUPER::_fetch_dfm_zapi(
        @_,
        api => 'volume-move-history-list-info-iter',
    );

    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _extra_filter_fields {

    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [
      qw( volume-resource-key 
      ) ]; 
}

1;
