# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DashboardHealthVserver ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DashboardHealthVserver

=head1 DESCRIPTION

C<NACL::CS::DashboardHealthVserver> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DashboardHealthVserver.  A related class is
L<NACL::C::DashboardHealthVserver|lib-NACL-C-DashboardHealthVserver-pm>, which represents access
to an ONTAP DashboardHealthVserver.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DashboardHealthVserver
element are the attributes of the DashboardHealthVserver ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< ports_total >>

Network Ports
Filled in for CMode CLI

=item C<< vol_offline >>

Offline Volumes
Filled in for CMode CLI

=item C<< critical >>

Critical Issues
Filled in for CMode CLI

=item C<< ports_shared >>

Network Ports Sharing Resources with Migrated LIFs
Filled in for CMode CLI

=item C<< lif_online >>

LIFs Online
Filled in for CMode CLI

=item C<< lif_no_failover >>

LIFs without Failover Rules
Filled in for CMode CLI

=item C<< aggr_full >>

Aggregates That Are Full
Filled in for CMode CLI

=item C<< informational >>

Informational Issues
Filled in for CMode CLI

=item C<< lif_offline >>

LIFs Offline
Filled in for CMode CLI

=item C<< lif_nothosted >>

Number of LIFS not hosted
Filled in for CMode CLI

=item C<< vstatus >>

Status, possible value(s) are online,offline
Filled in for CMode CLI

=item C<< vol_full >>

Volumes Currently Full
Filled in for CMode CLI

=item C<< nfs_health_status >>

NFS Operational Status, possible value(s) are ok,info,warning,critical
Filled in for CMode CLI

=item C<< aggr_total >>

Aggregates
Filled in for CMode CLI

=item C<< aggr_failedover >>

Aggregates Failed-Over
Filled in for CMode CLI

=item C<< aggr_offline >>

Aggregates Offline
Filled in for CMode CLI

=item C<< root_vol_mirrors_online >>

Root LS Mirrors Online
Filled in for CMode CLI

=item C<< issues >>

Health Issues
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $issues = $obj->issues();
# $issues contains a reference to the array of values
my @issues = $obj->issues();
# @issues contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { issues = [ value1, value2...] }
Filled in for CMode CLI

=item C<< vol_online >>

Online Volumes
Filled in for CMode CLI

=item C<< cifs_health_status >>

CIFS Operational Status, possible value(s) are ok,info,warning,critical
Filled in for CMode CLI

=item C<< vol_restricted >>

Volumes Restricted
Filled in for CMode CLI

=item C<< root_vol_status >>

Root Volume State, possible value(s) are online,offline
Filled in for CMode CLI

=item C<< root_vol_mirrors_total >>

Root LS Mirrors
Filled in for CMode CLI

=item C<< lif_home_port_down >>

LIFs With Home Port Down
Filled in for CMode CLI

=item C<< cifs_config_status >>

CIFS Configuration Status, possible value(s) are
configured,notconfigured,disabled
Filled in for CMode CLI

=item C<< vserver >>

Vserver Name
Filled in for CMode CLI

=item C<< nfs_config_status >>

NFS Configuration Status, possible value(s) are
configured,notconfigured,disabled
Filled in for CMode CLI

=item C<< aggr_online >>

Aggregates Online
Filled in for CMode CLI

=item C<< vhealth >>

Health, possible value(s) are ok,info,warning,critical
Filled in for CMode CLI

=item C<< lif_nothome >>

LIFs not home
Filled in for CMode CLI

=item C<< root_vol_state >>

Root Volume Health, possible value(s) are ok,info,warning,critical
Filled in for CMode CLI

=item C<< vol_total >>

Number of Volumes
Filled in for CMode CLI

=item C<< warning >>

Warning Issues
Filled in for CMode CLI

=item C<< lif_total >>

Number of LIFs
Filled in for CMode CLI

=item C<< vif_nothosted >>

Filled in for CMode CLI.

=item C<< vif_no_failover >>

Filled in for CMode CLI.

=item C<< vif_home_port_down >>

Filled in for CMode CLI.

=item C<< vif_online >>

Filled in for CMode CLI.

=item C<< vif_offline >>

Filled in for CMode CLI.

=item C<< vif_total >>

Filled in for CMode CLI.

=item C<< vif_nothome >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DashboardHealthVserver;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'ports_total',
    scalar => 'vol_offline',
    scalar => 'critical',
    scalar => 'ports_shared',
    scalar => 'lif_online',
    scalar => 'lif_no_failover',
    scalar => 'aggr_full',
    scalar => 'informational',
    scalar => 'lif_offline',
    scalar => 'lif_nothosted',
    scalar => 'vstatus',
    scalar => 'vol_full',
    scalar => 'nfs_health_status',
    scalar => 'aggr_total',
    scalar => 'aggr_failedover',
    scalar => 'aggr_offline',
    scalar => 'root_vol_mirrors_online',
    array  => 'issues',
    scalar => 'vol_online',
    scalar => 'cifs_health_status',
    scalar => 'vol_restricted',
    scalar => 'root_vol_status',
    scalar => 'root_vol_mirrors_total',
    scalar => 'lif_home_port_down',
    scalar => 'cifs_config_status',
    scalar => 'vserver',
    scalar => 'nfs_config_status',
    scalar => 'aggr_online',
    scalar => 'vhealth',
    scalar => 'lif_nothome',
    scalar => 'root_vol_state',
    scalar => 'vol_total',
    scalar => 'warning',
    scalar => 'lif_total',
    scalar => 'vif_nothosted',
    scalar => 'vif_no_failover',
    scalar => 'vif_home_port_down',
    scalar => 'vif_online',
    scalar => 'vif_offline',
    scalar => 'vif_total',
    scalar => 'vif_nothome',
];

=head1 METHODS

=head2 fetch

    my $DashboardHealthVserver_state  = NACL::CS::DashboardHealthVserver->fetch(command_interface => $ci, ...);
	my @DashboardHealthVserver_states = NACL::CS::DashboardHealthVserver->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'dashboard health vserver show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching dashboard health vserver(s) found',
        frontend       => 'NACL::CS::DashboardHealthVserver::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'dashboard_health_vserver_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
