# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCpsStorageAreaGroup ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCpsStorageAreaGroup

=head1 DESCRIPTION

C<NACL::CS::DebugCpsStorageAreaGroup> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCpsStorageAreaGroup.  A related class is
L<NACL::C::DebugCpsStorageAreaGroup|lib-NACL-C-DebugCpsStorageAreaGroup-pm>, which represents access
to an ONTAP DebugCpsStorageAreaGroup.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCpsStorageAreaGroup
element are the attributes of the DebugCpsStorageAreaGroup ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< active_recreate_retries >>

Active Recreate Retry Count

Filled in for CMode CLI

=item C<< auto_recreate >>

Auto-Recreate possible value(s) are, true,false

Filled in for CMode CLI

=item C<< abandoned_volumes >>

Abandoned Volumes
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $abandoned_volumes = $obj->abandoned_volumes();
 
# $abandoned_volumes contains a reference to the array of values
 
my @abandoned_volumes = $obj->abandoned_volumes();
 
# @abandoned_volumes contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { abandoned_volumes = [ value1, value2...] }

Filled in for CMode CLI

=item C<< problem_aggregates >>

Recent Problem Aggregates
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $problem_aggregates = $obj->problem_aggregates();
 
# $problem_aggregates contains a reference to the array of values
 
my @problem_aggregates = $obj->problem_aggregates();
 
# @problem_aggregates contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { problem_aggregates = [ value1, value2...] }

Filled in for CMode CLI

=item C<< auto_repair >>

Auto-Repair possible value(s) are, true,false

Filled in for CMode CLI

=item C<< group >>

Storage Area Group

Filled in for CMode CLI

=item C<< volumes_under_repair >>

Volumes Under Repair
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $volumes_under_repair = $obj->volumes_under_repair();
 
# $volumes_under_repair contains a reference to the array of values
 
my @volumes_under_repair = $obj->volumes_under_repair();
 
# @volumes_under_repair contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { volumes_under_repair = [ value1, value2...] }

Filled in for CMode CLI

=item C<< current_volume >>

Current Volume

Filled in for CMode CLI

=item C<< use_mirrored_aggregate >>

Use Mirrored Aggregate possible value(s) are, true,false

Filled in for CMode CLI

=item C<< standby_recreate_retries >>

Standby Recreate Retry Count

Filled in for CMode CLI

=item C<< disallowed_aggregates >>

Disallowed Aggregates
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $disallowed_aggregates = $obj->disallowed_aggregates();
 
# $disallowed_aggregates contains a reference to the array of values
 
my @disallowed_aggregates = $obj->disallowed_aggregates();
 
# @disallowed_aggregates contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { disallowed_aggregates = [ value1, value2...] }

Filled in for CMode CLI

=item C<< standby_volume >>

Standby Volume

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCpsStorageAreaGroup;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'active_recreate_retries',
    scalar => 'auto_recreate',
    array  => 'abandoned_volumes',
    array  => 'problem_aggregates',
    scalar => 'auto_repair',
    scalar => 'group',
    array  => 'volumes_under_repair',
    scalar => 'current_volume',
    scalar => 'use_mirrored_aggregate',
    scalar => 'standby_recreate_retries',
    array  => 'disallowed_aggregates',
    scalar => 'standby_volume',
];

=head1 METHODS

=head2 fetch

    my $DebugCpsStorageAreaGroup_state  = NACL::CS::DebugCpsStorageAreaGroup->fetch(command_interface => $ci, ...);
	my @DebugCpsStorageAreaGroup_states = NACL::CS::DebugCpsStorageAreaGroup->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug cps storage-area-group show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug cps storage-area-group(s) found',
        frontend       => 'NACL::CS::DebugCpsStorageAreaGroup::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_cps_storage_area_group_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
