# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCpsStorageAreaHistoricalChange ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCpsStorageAreaHistoricalChange

=head1 DESCRIPTION

C<NACL::CS::DebugCpsStorageAreaHistoricalChange> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCpsStorageAreaHistoricalChange.  A related class is
L<NACL::C::DebugCpsStorageAreaHistoricalChange|lib-NACL-C-DebugCpsStorageAreaHistoricalChange-pm>, which represents access
to an ONTAP DebugCpsStorageAreaHistoricalChange.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCpsStorageAreaHistoricalChange
element are the attributes of the DebugCpsStorageAreaHistoricalChange ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< relocation_root_cause >>

Relocation Root Cause

Filled in for CMode CLI

=item C<< change_type >>


Storage Change Type possible value(s) are, requested,available,active,unavailable,released,deleted,repairing,error,required

Filled in for CMode CLI

=item C<< volume >>

Volume

Filled in for CMode CLI

=item C<< previous_volume >>

Previous Volume

Filled in for CMode CLI

=item C<< area >>


Storage Area possible value(s) are, crs-scratch,crs-sender-queues,crs-receiver-queues

Filled in for CMode CLI

=item C<< is_active >>

Volume is Active possible value(s) are, true,false

Filled in for CMode CLI

=item C<< client_id >>

Client Identifier

Filled in for CMode CLI

=item C<< relocation_reason >>

Relocation Reason

Filled in for CMode CLI

=item C<< previous_aggregate >>

Previous Aggregate

Filled in for CMode CLI

=item C<< error_code >>

Error Code

Filled in for CMode CLI

=item C<< area_epoch >>

Area Epoch

Filled in for CMode CLI

=item C<< sequence_number >>

Sequence Number

Filled in for CMode CLI

=item C<< aggregate >>

Aggregate

Filled in for CMode CLI

=item C<< storage_requester >>

Storage Requester possible value(s) are, user,cps,client,internal

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCpsStorageAreaHistoricalChange;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'relocation_root_cause',
    scalar => 'change_type',
    scalar => 'volume',
    scalar => 'previous_volume',
    scalar => 'area',
    scalar => 'is_active',
    scalar => 'client_id',
    scalar => 'relocation_reason',
    scalar => 'previous_aggregate',
    scalar => 'error_code',
    scalar => 'area_epoch',
    scalar => 'sequence_number',
    scalar => 'aggregate',
    scalar => 'storage_requester',
];

=head1 METHODS

=head2 fetch

    my $DebugCpsStorageAreaHistoricalChange_state  = NACL::CS::DebugCpsStorageAreaHistoricalChange->fetch(command_interface => $ci, ...);
	my @DebugCpsStorageAreaHistoricalChange_states = NACL::CS::DebugCpsStorageAreaHistoricalChange->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug cps storage-area historical-change show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching debug cps storage-area historical-change(s) found',
        frontend => 'NACL::CS::DebugCpsStorageAreaHistoricalChange::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_cps_storage_area_historical_change_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
