# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugCrsDomainInstance->show_baseline_per_domain_instance() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance

=head1 DESCRIPTION

C<NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugCrsDomainInstance->show_baseline_per_domain_instance() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugCrsDomainInstance->show_baseline_per_domain_instance() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< object_op >>

Object Operation

Filled in for CMode CLI

=item C<< object >>

Exported Object Name

Filled in for CMode CLI

=item C<< index >>

Index of the Instance

Filled in for CMode CLI

=item C<< baseline_seq_num >>

Cluster Wide Baseline Sequence Number

Filled in for CMode CLI

=item C<< domain_instance_uuid >>

Domain Instance UUID

Filled in for CMode CLI

=item C<< attributes >>

Object Attributes

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'object_op',
    scalar => 'object',
    scalar => 'index',
    scalar => 'baseline_seq_num',
    scalar => 'domain_instance_uuid',
    scalar => 'attributes',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsDomainInstanceShowBaselinePerDomainInstance_state  = NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance->fetch(command_interface => $ci, ...);
	my @DebugCrsDomainInstanceShowBaselinePerDomainInstance_states = NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs domain-instance show-baseline-per-domain-instance',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs domain-instance(s) found',
        frontend =>
            'NACL::CS::DebugCrsDomainInstanceShowBaselinePerDomainInstance::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_domain_instance_show_baseline_per_domain_instance',
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
