# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsQueuePending ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsQueuePending

=head1 DESCRIPTION

C<NACL::CS::DebugCrsQueuePending> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCrsQueuePending.  A related class is
L<NACL::C::DebugCrsQueuePending|lib-NACL-C-DebugCrsQueuePending-pm>, which represents access
to an ONTAP DebugCrsQueuePending.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCrsQueuePending
element are the attributes of the DebugCrsQueuePending ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< object_op >>

Object Operation

Filled in for CMode CLI

=item C<< object >>

Exported Object Name

Filled in for CMode CLI

=item C<< creation_time >>

Creation Time

Filled in for CMode CLI

=item C<< job_handle >>

Job Handle

Filled in for CMode CLI

=item C<< message_type >>

Message Type possible value(s) are, baseline,marker,update

Filled in for CMode CLI

=item C<< is_by_job >>

Is Operation Done by a Job possible value(s) are, true,false

Filled in for CMode CLI

=item C<< streams >>

Target Streams
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $streams = $obj->streams();
 
# $streams contains a reference to the array of values
 
my @streams = $obj->streams();
 
# @streams contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { streams = [ value1, value2...] }

Filled in for CMode CLI

=item C<< domain_instance_uuid >>

Domain Instance UUID

Filled in for CMode CLI

=item C<< path_to_baseline >>

Path to Baseline

Filled in for CMode CLI

=item C<< attributes >>

Object Attributes

Filled in for CMode CLI

=item C<< context_id >>

Context ID

Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugCrsQueuePending;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'object_op',
    scalar => 'object',
    scalar => 'creation_time',
    scalar => 'job_handle',
    scalar => 'message_type',
    scalar => 'is_by_job',
    array  => 'streams',
    scalar => 'domain_instance_uuid',
    scalar => 'path_to_baseline',
    scalar => 'attributes',
    scalar => 'context_id',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsQueuePending_state  = NACL::CS::DebugCrsQueuePending->fetch(command_interface => $ci, ...);
	my @DebugCrsQueuePending_states = NACL::CS::DebugCrsQueuePending->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs queue pending show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs queue pending(s) found',
        frontend       => 'NACL::CS::DebugCrsQueuePending::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_queue_pending_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
