# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCrsRemoteCluster ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsRemoteCluster

=head1 DESCRIPTION

C<NACL::CS::DebugCrsRemoteCluster> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCrsRemoteCluster.  A related class is
L<NACL::C::DebugCrsRemoteCluster|lib-NACL-C-DebugCrsRemoteCluster-pm>, which represents access
to an ONTAP DebugCrsRemoteCluster.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCrsRemoteCluster
element are the attributes of the DebugCrsRemoteCluster ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< ecv >>

Effective Cluster Version

Filled in for CMode CLI

=item C<< protocol_version >>

CRS Protocol Version

Filled in for CMode CLI

=item C<< threads_in_use >>

Threads in Use

Filled in for CMode CLI

=item C<< cluster_uuid >>

Remote Cluster

Filled in for CMode CLI

=item C<< last_heartbeat_time >>

Last Heartbeat Received Time

Filled in for CMode CLI.

=item C<< sent_comm_failure_ems >>

Sent Communication Failure EMS possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< last_comm_attempt >>

Last Communication Attempt Time

Filled in for CMode CLI.

=item C<< peer_comm_state >>


Peer Communication State possible value(s) are, up,down,local-unreachable,network-unreachable,remote-crs-unreachable,unknown

Filled in for CMode CLI.

=item C<< last_comm_success >>

Last Communication Success Time

Filled in for CMode CLI.

=item C<< first_comm_failed >>

First Communication Failed Time

Filled in for CMode CLI.


=item C<< emit_peer_reachable_ems >>

Emit Peer Reachable EMS possible value(s) are, true,false

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCrsRemoteCluster;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'ecv',
    scalar => 'protocol_version',
    scalar => 'threads_in_use',
    scalar => 'cluster_uuid',
    scalar => 'last_heartbeat_time',
    scalar => 'sent_comm_failure_ems',
    scalar => 'last_comm_attempt',
    scalar => 'peer_comm_state',
    scalar => 'last_comm_success',
    scalar => 'first_comm_failed',
    scalar => 'emit_peer_reachable_ems',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsRemoteCluster_state  = NACL::CS::DebugCrsRemoteCluster->fetch(command_interface => $ci, ...);
	my @DebugCrsRemoteCluster_states = NACL::CS::DebugCrsRemoteCluster->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs remote-cluster show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug crs remote-cluster(s) found',
        frontend       => 'NACL::CS::DebugCrsRemoteCluster::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_remote_cluster_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
