# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugCrsStatisticsLatencyBaselineSender->show_by_object() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsStatisticsLatencyBaselineSenderShowByObject

=head1 DESCRIPTION

C<NACL::CS::DebugCrsStatisticsLatencyBaselineSenderShowByObject> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugCrsStatisticsLatencyBaselineSender->show_by_object() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugCrsStatisticsLatencyBaselineSender->show_by_object() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< breakdown >>

Breakdown Phase

Filled in for CMode CLI

=item C<< count >>

Number of Baseline

Filled in for CMode CLI

=item C<< object >>

Object Type

Filled in for CMode CLI

=item C<< bucket_1 >>

< 1ms

Filled in for CMode CLI

=item C<< min >>

Minimum

Filled in for CMode CLI

=item C<< max >>

Maximum

Filled in for CMode CLI

=item C<< bucket_2 >>

2ms to 7ms

Filled in for CMode CLI

=item C<< bucket_7 >>

> 32s

Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI

=item C<< mean >>

Mean

Filled in for CMode CLI

=item C<< bucket_3 >>

8ms to 63ms

Filled in for CMode CLI

=item C<< bucket_6 >>

4096ms to 32s

Filled in for CMode CLI

=item C<< stddev >>

Standard Deviation

Filled in for CMode CLI

=item C<< period_begin >>

Period Begin Time

Filled in for CMode CLI

=item C<< bucket_5 >>

512ms to 4095ms

Filled in for CMode CLI

=item C<< bucket_4 >>

64ms to 511ms

Filled in for CMode CLI

=item C<< breakdownkey >>

Breakdown Phase as Key

Filled in for CMode CLI.

=item C<< clear_map >>

Used to cleanup internal map possible value(s) are, true,false

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCrsStatisticsLatencyBaselineSenderShowByObject;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'breakdown',
    scalar => 'count',
    scalar => 'object',
    scalar => 'bucket_1',
    scalar => 'min',
    scalar => 'max',
    scalar => 'bucket_2',
    scalar => 'bucket_7',
    scalar => 'node',
    scalar => 'mean',
    scalar => 'bucket_3',
    scalar => 'bucket_6',
    scalar => 'stddev',
    scalar => 'period_begin',
    scalar => 'bucket_5',
    scalar => 'bucket_4',
    scalar => 'breakdownkey',
    scalar => 'clear_map',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsStatisticsLatencyBaselineSenderShowByObject_state  = NACL::CS::DebugCrsStatisticsLatencyBaselineSenderShowByObject->fetch(command_interface => $ci, ...);
	my @DebugCrsStatisticsLatencyBaselineSenderShowByObject_states = NACL::CS::DebugCrsStatisticsLatencyBaselineSenderShowByObject->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'debug crs statistics latency baseline sender show-by-object',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching debug crs statistics latency baseline sender(s) found',
        frontend =>
            'NACL::CS::DebugCrsStatisticsLatencyBaselineSenderShowByObject::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'debug_crs_statistics_latency_baseline_sender_show_by_object',
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
