# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_object_details() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails

=head1 DESCRIPTION

C<NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_object_details() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugCrsStatisticsLatencyUpdateSender->show_object_details() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< timestamp >>

Sample Time Stamp

Filled in for CMode CLI

=item C<< pre_operation_get >>

Time for Pre Operation Get (ms)

Filled in for CMode CLI

=item C<< update_contextid >>

Update Context ID

Filled in for CMode CLI

=item C<< post_operation_get >>

Time for Post Operation Get (ms)

Filled in for CMode CLI

=item C<< object_name >>

Object Name

Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI

=item C<< seqnum >>

Sequence Number

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'timestamp',
    scalar => 'pre_operation_get',
    scalar => 'update_contextid',
    scalar => 'post_operation_get',
    scalar => 'object_name',
    scalar => 'node',
    scalar => 'seqnum',
];

=head1 METHODS

=head2 fetch

    my $DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails_state  = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails->fetch(command_interface => $ci, ...);
	my @DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails_states = NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching debug crs statistics latency update sender(s) found',
        frontend =>
            'NACL::CS::DebugCrsStatisticsLatencyUpdateSenderShowObjectDetails::fetch',
        show_cmd =>
            'debug crs statistics latency update sender show-object-details',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api =>
            'debug_crs_statistics_latency_update_sender_show_object_details',
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
