#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugCsmLocalBlade ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugCsmLocalBlade

=head1 DESCRIPTION

C<NACL::CS::DebugCsmLocalBlade> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugCsmLocalBlade.  A related class is
L<NACL::C::DebugCsmLocalBlade|lib-NACL-C-DebugCsmLocalBlade-pm>, which represents access
to an ONTAP DebugCsmLocalBlade.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugCsmLocalBlade
element are the attributes of the DebugCsmLocalBlade ComponentState.

=over

=item C<< med_priority_packets >>

Filled in for CMode CLI.

=item C<< interface_id >>

Filled in for CMode CLI.

=item C<< active >>

Filled in for CMode CLI.

=item C<< blade_id >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< total >>

Filled in for CMode CLI.

=item C<< blade_type >>

Filled in for CMode CLI.

=item C<< interface_name >>

Filled in for CMode CLI.

=item C<< blade_ready >>

Filled in for CMode CLI.

=item C<< low_priority_packets >>

Filled in for CMode CLI.

=item C<< high_priority_packets >>

Filled in for CMode CLI.

=item C<< current_packets >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DebugCsmLocalBlade;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'med_priority_packets',
    scalar => 'interface_id',
    scalar => 'active',
    scalar => 'blade_id',
    scalar => 'node',
    scalar => 'total',
    scalar => 'blade_type',
    scalar => 'interface_name',
    scalar => 'blade_ready',
    scalar => 'low_priority_packets',
    scalar => 'high_priority_packets',
    scalar => 'current_packets',
];

=head1 METHODS

=head2 fetch

    my $DebugCsmLocalBlade_state   = NACL::CS::DebugCsmLocalBlade->fetch(command_interface => $ci, ...);
	my @DebugCsmLocalBlade_states = NACL::CS::DebugCsmLocalBlade->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug csm local-blade show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching debug csm local blade(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'debug_csm_local_blade_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
