# $Id$
#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugLocksShowAutoResync ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared


=head1 NAME

NACL::CS::DebugLocksShowAutoResync

=head1 DESCRIPTION

C<NACL::CS::DebugLocksShowAutoResync> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::Debug->DebugLocksShowAutoResync() is invoked.

This module does not represent the state of any element, but is an object
representation of the output obtained when a WAFL meta-data is queried using
'debug locks show-auto-resync' command

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object. Note that
even if a field is present in the output but not listed below, the Component
has code to dynamically add it, so that field will be accessible through the
returned CS objects.

=over

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< volume >>

Filled in for CMode CLI.
=item C<< lock_resync_status >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugLocksShowAutoResync;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'volume',
    scalar => 'lock_resync_status',
];

sub _set_fields {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->SUPER::_set_fields(add_unknown_fields => 1, @opts);
    $Log->exit() if $may_exit;
}

1;

