#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugSmdbTrace ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugSmdbTrace

=head1 DESCRIPTION

C<NACL::CS::DebugSmdbTrace> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugSmdbTrace.  A related class is
L<NACL::C::DebugSmdbTrace|lib-NACL-C-DebugSmdbTrace-pm>, which represents access
to an ONTAP DebugSmdbTrace.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugSmdbTrace
element are the attributes of the DebugSmdbTrace ComponentState.

=over

=item C<< next_error >>

Filled in for CMode CLI.

=item C<< tracing >>

Filled in for CMode CLI.

=item C<< modify_error >>

Filled in for CMode CLI.

=item C<< remove_error >>

Filled in for CMode CLI.

=item C<< table >>

Filled in for CMode CLI.

=item C<< create_error >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< postop_error >>

Filled in for CMode CLI.

=item C<< process >>

Filled in for CMode CLI.

=item C<< nextseq_error >>

Filled in for CMode CLI.

=item C<< action >>

Filled in for CMode CLI.

=item C<< get_error >>

Filled in for CMode CLI.

=item C<< other_error >>

Filled in for CMode CLI.

=item C<< send_to >>

Filled in for CMode CLI.

=item C<< testmode_copy >>

copy normal for testmode possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< testmode >>

table test mode possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< testmode_local >>

force local access possible value(s) are, yes,no

Filled in for CMode CLI.

=item C<< smf_trace >>

SMF Iterator Tracing possible value(s) are, yes,no,auto

Filled in for CMode CLI.

=item C<< trace_threshold >>

Trace Threshold (secs) ranges from 0 to 255

Filled in for CMode CLI.


=item C<< dsmf_max_in_int_prio >>

DSMF Max in Intermediate Priority Queue ranges from 0 to 255

Filled in for CMode CLI.

=item C<< dsmf_max_in_high_prio >>

SMF Max in High Priority Queue ranges from 0 to 255

Filled in for CMode CLI.

=item C<< dsmf_max_active_thresh >>

DSMF Max Active Threshold ranges from 0 to 255

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DebugSmdbTrace;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'next_error',
    scalar => 'tracing',
    scalar => 'modify_error',
    scalar => 'remove_error',
    scalar => 'table',
    scalar => 'create_error',
    scalar => 'node',
    scalar => 'postop_error',
    scalar => 'process',
    scalar => 'nextseq_error',
    scalar => 'action',
    scalar => 'get_error',
    scalar => 'other_error',
    scalar => 'send_to',
    scalar => 'testmode_copy',
    scalar => 'testmode',
    scalar => 'testmode_local',
    scalar => 'smf_trace',
    scalar => 'trace_threshold',
    scalar => 'dsmf_max_in_int_prio',
    scalar => 'dsmf_max_in_high_prio',
    scalar => 'dsmf_max_active_thresh',
];

=head1 METHODS

=head2 fetch

    my $DebugSmdbTrace_state   = NACL::CS::DebugSmdbTrace->fetch(command_interface => $ci, ...);
	my @DebugSmdbTrace_states = NACL::CS::DebugSmdbTrace->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug smdb trace show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching debug smdb trace(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'debug_smdb_trace_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
