# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show_task_status() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus

=head1 DESCRIPTION

C<NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show_task_status() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::DebugUpgradeRevert->system_node_upgrade_revert_show_task_status() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< retries >>

Number of Retries
Filled in for CMode CLI

=item C<< restart_required >>

Requires Restart on Upgrade possible value(s) are, true,false
Filled in for CMode CLI

=item C<< startup_phase >>

Startup Phase possible value(s) are, pre-root,pre-apps,post-apps
Filled in for CMode CLI

=item C<< status >>

Execution Status
Filled in for CMode CLI

=item C<< version >>

Upgrade/Revert Version
Filled in for CMode CLI

=item C<< description >>

Description of Task
Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local
Filled in for CMode CLI

=item C<< process >>

Process Name
Filled in for CMode CLI

=item C<< status_msg >>

Status Message
Filled in for CMode CLI

=item C<< direction >>

Upgrade/Revert Direction possible value(s) are, upgrade,revert
Filled in for CMode CLI

=item C<< timeouts >>

Number of Timeouts
Filled in for CMode CLI

=item C<< total_time >>

Total Task Execution Time (sec)
Filled in for CMode CLI

=item C<< task_id >>

Task Identifier
Filled in for CMode CLI

=back

=cut

package NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'retries',
    scalar => 'restart_required',
    scalar => 'startup_phase',
    scalar => 'status',
    scalar => 'version',
    scalar => 'description',
    scalar => 'node',
    scalar => 'process',
    scalar => 'status_msg',
    scalar => 'direction',
    scalar => 'timeouts',
    scalar => 'total_time',
    scalar => 'task_id',
];

=head1 METHODS

=head2 fetch

    my $DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus_state  = NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus->fetch(command_interface => $ci, ...);
	my @DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus_states = NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'system node upgrade-revert show-task-status',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug upgrade-revert(s) found',
        frontend =>
            'NACL::CS::DebugUpgradeRevertSystemNodeUpgradeRevertShowTaskStatus::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'system_node_upgrade_revert_show_task_status',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
