# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DebugVreport ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DebugVreport

=head1 DESCRIPTION

C<NACL::CS::DebugVreport> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DebugVreport.  A related class is
L<NACL::C::DebugVreport|lib-NACL-C-DebugVreport-pm>, which represents access
to an ONTAP DebugVreport.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DebugVreport
element are the attributes of the DebugVreport ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< dup_attributes >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $dup_attributes = $obj->dup_attributes();
# $dup_attributes contains a reference to the array of values
my @dup_attributes = $obj->dup_attributes();
# @dup_attributes contains the array of values

Filled in for CMode CLI.

=item C<< object >>

Filled in for CMode CLI.

=item C<< wafl_values >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $wafl_values = $obj->wafl_values();
# $wafl_values contains a reference to the array of values
my @wafl_values = $obj->wafl_values();
# @wafl_values contains the array of values

Filled in for CMode CLI.

=item C<< reason >>

Filled in for CMode CLI.

=item C<< vldb_values >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $vldb_values = $obj->vldb_values();
# $vldb_values contains a reference to the array of values
my @vldb_values = $obj->vldb_values();
# @vldb_values contains the array of values

Filled in for CMode CLI.

=item C<< type >>

Filled in for CMode CLI.

=item C<< use_cache >>

Filled in for CMode CLI.

=item C<< attributes >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $attributes = $obj->attributes();
# $attributes contains a reference to the array of values
my @attributes = $obj->attributes();
# @attributes contains the array of values

Filled in for CMode CLI.

=item C<< differing_attributes >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $differing_attributes = $obj->differing_attributes();
# $differing_attributes contains a reference to the array of values
my @differing_attributes = $obj->differing_attributes();
# @differing_attributes contains the array of values

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DebugVreport;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'dup_attributes',
    scalar => 'object',
    array  => 'wafl_values',
    scalar => 'reason',
    array  => 'vldb_values',
    scalar => 'type',
    scalar => 'use_cache',
    array  => 'attributes',
    array  => 'differing_attributes',
];

=head1 METHODS

=head2 fetch

    my $DebugVreport_state  = NACL::CS::DebugVreport->fetch(command_interface => $ci, ...);
	my @DebugVreport_states = NACL::CS::DebugVreport->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'debug vreport show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching debug vreport(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'debug_vreport_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
