# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagNbladeCifsServer ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagNbladeCifsServer

=head1 DESCRIPTION

C<NACL::CS::DiagNbladeCifsServer> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DiagNbladeCifsServer.  A related class is
L<NACL::C::DiagNbladeCifsServer|lib-NACL-C-DiagNbladeCifsServer-pm>, which represents access
to an ONTAP DiagNbladeCifsServer.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagNbladeCifsServer
element are the attributes of the DiagNbladeCifsServer ComponentState.

=over

=item C<< "machine_sid" >>

Filled in for CMode CLI.

=item C<< "virtual_server_id" >>

Filled in for CMode CLI.

=item C<< "name" >>

Filled in for CMode CLI.

=item C<< "local_sid" >>

Filled in for CMode CLI.

=item C<< "domain_name" >>

Filled in for CMode CLI.

=item C<< "server_type" >>

Filled in for CMode CLI.

=item C<< "ip_addresses" >>

Filled in for CMode CLI.

=item C<< "wins_servers" >>

Filled in for CMode CLI.

=item C<< "ips_to_register" >>

Filled in for CMode CLI.

=item C<< vserver >>

*Vserver

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DiagNbladeCifsServer;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'ips_to_register',
    scalar => 'machine_sid',
    scalar => 'virtual_server_id',
    scalar => 'name',
    scalar => 'local_sid',
    scalar => 'domain_name',
    scalar => 'server_type',
    array  => 'ip_addresses',
    array  => 'wins_servers',
    scalar => 'vserver',
];

=head1 METHODS

=head2 fetch

    my $DiagNbladeCifsServer_state   = NACL::CS::DiagNbladeCifsServer->fetch(command_interface => $ci, ...);
    my @DiagNbladeCifsServer_states = NACL::CS::DiagNbladeCifsServer->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.

This method does not support 'requested_fields' parameter.

See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'diag nblade cifs server show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching diag nblade cifs server(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    delete $opts{requested_fields};
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(%opts,
        api => 'diag_nblade_cifs_server_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _extra_filter_fields {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [ qw ( node ) ];
}
1;
