# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagNbladeCpxFhmapCache ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagNbladeCpxFhmapCache

=head1 DESCRIPTION

C<NACL::CS::DiagNbladeCpxFhmapCache> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DiagNbladeCpxFhmapCache.  A related class is
L<NACL::C::DiagNbladeCpxFhmapCache|lib-NACL-C-DiagNbladeCpxFhmapCache-pm>, which represents access
to an ONTAP DiagNbladeCpxFhmapCache.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the DiagNbladeCpxFhmapCache
element are the attributes of the DiagNbladeCpxFhmapCache ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< nc_junction_active >>

*Namespace Constituent Junction Active, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< data_path >>

*Data File Path

Filled in for CMode CLI.

=item C<< redir_filehandle >>

Filled in for CMode CLI.

=item C<< vserver >>

*Vserver

Filled in for CMode CLI.

=item C<< namespace_filehandle >>

*Namespace Filehandle

Filled in for CMode CLI.

=item C<< redir_path >>

Filled in for CMode CLI.

=item C<< node >>

*Node

Filled in for CMode CLI.

=item C<< namespace_constituent >>

*Namespace Constituent

Filled in for CMode CLI.

=item C<< entry_flags >>

*Entry Flags

Filled in for CMode CLI.

=item C<< data_constituent >>

*Data Constituent

Filled in for CMode CLI.

=item C<< namespace_path >>

*Namespace File Path

Filled in for CMode CLI.

=item C<< dc_junction_path >>

*Data Constituent Junction Path

Filled in for CMode CLI.

=item C<< data_filehandle >>

*Data Filehandle

Filled in for CMode CLI.

=item C<< dc_junction_active >>

*Data Constituent Junction Active, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< nc_junction_path >>

*Namespace Constituent Junction Path

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagNbladeCpxFhmapCache;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'nc_junction_active',
    scalar => 'data_path',
    scalar => 'redir_filehandle',
    scalar => 'vserver',
    scalar => 'namespace_filehandle',
    scalar => 'redir_path',
    scalar => 'node',
    scalar => 'namespace_constituent',
    scalar => 'entry_flags',
    scalar => 'data_constituent',
    scalar => 'namespace_path',
    scalar => 'dc_junction_path',
    scalar => 'data_filehandle',
    scalar => 'dc_junction_active',
    scalar => 'nc_junction_path',
];

=head1 METHODS

=head2 fetch

    my $DiagNbladeCpxFhmapCache_state  = NACL::CS::DiagNbladeCpxFhmapCache->fetch(command_interface => $ci, ...);
	my @DiagNbladeCpxFhmapCache_states = NACL::CS::DiagNbladeCpxFhmapCache->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'diag nblade cpx fhmap-cache show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching $not_matching_element found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'diag_nblade_cpx_fhmap_cache_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
