#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagNbladeReplay ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagNbladeReplay

=head1 DESCRIPTION

C<NACL::CS::DiagNbladeReplay> is a derived class of
L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm|NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DiagNbladeReplay.  A related class is
L<NACL::C::DiagNbladeReplay|lib-NACL-C-DiagNbladeReplay-pm>, which represents access
to an ONTAP DiagNbladeReplay.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagNbladeReplay
element are the attributes of the DiagNbladeReplay ComponentState.

=over

=item C<< "reason" >>

Filled in for CMode CLI.

=item C<< "rule" >>

Filled in for CMode CLI.

=item C<< "completed_at" >>

Filled in for CMode CLI.

=item C<< "result" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagNbladeReplay;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'reason',
    scalar => 'rule',
    scalar => 'completed_at',
    scalar => 'result',
];

=head1 METHODS

=head2 fetch

    my $DiagNbladeReplay_state   = NACL::CS::DiagNbladeReplay->fetch(command_interface => $ci, ...);
	my @DiagNbladeReplay_states = NACL::CS::DiagNbladeReplay->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'diag nblade replay show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching diag nblade replay(s) found',
        is_singleton   => 1
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api          => 'diag_nblade_replay_show',
        is_singleton => 1
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
