#
# Copyright (c) 2017 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdConfigurationQuery ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagSecdConfigurationQuery

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of Diag Secd Configuration Query

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagSecdConfigurationQuery
element are the attributes of the DiagSecdConfigurationQuery ComponentState.

=over

=item C<< client_config >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< ldap_servers >>

Filled in for CMode CLI.

=item C<< servers >>

Filled in for CMode CLI.

=item C<< ad_domain >>

Filled in for CMode CLI.

=item C<< preferred_ad_servers >>

Filled in for CMode CLI.

=item C<< bind_as_cifs_server >>

Filled in for CMode CLI.

=item C<< schema >>

Filled in for CMode CLI.

=item C<< port >>

Filled in for CMode CLI.

=item C<< query_timeout >>

Filled in for CMode CLI.

=item C<< min_bind_level >>

Filled in for CMode CLI.

=item C<< bind_dn >>

Filled in for CMode CLI.

=item C<< bind_password >>

Filled in for CMode CLI.

=item C<< obs_password >>

Filled in for CMode CLI.

=item C<< base_dn >>

Filled in for CMode CLI.

=item C<< base_scope >>

Filled in for CMode CLI.

=item C<< user_dn >>

Filled in for CMode CLI.

=item C<< user_scope >>

Filled in for CMode CLI.

=item C<< group_dn >>

Filled in for CMode CLI.

=item C<< netgroup_dn >>

Filled in for CMode CLI.

=item C<< group_scope >>

Filled in for CMode CLI.

=item C<< netgroup_scope >>

Filled in for CMode CLI.

=item C<< asymmetric_name_mapping >>

Filled in for CMode CLI.

=item C<< use_start_tls >>

Filled in for CMode CLI.

=item C<< netgroup_byhost_dn >>

Filled in for CMode CLI.

=item C<< netgroup_byhost_scope >>

Filled in for CMode CLI.

=item C<< is_netgroup_byhost_enabled >>

Filled in for CMode CLI.

=item C<< session_security >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagSecdConfigurationQuery;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);
use Class::MethodMaker [
    scalar => 'client_config',
    scalar => 'vserver',
    scalar => 'ldap_servers',
    scalar => 'servers',
    scalar => 'ad_domain',
    scalar => 'preferred_ad_servers',
    scalar => 'bind_as_cifs_server',
    scalar => 'schema',
    scalar => 'port',
    scalar => 'query_timeout',
    scalar => 'min_bind_level',
    scalar => 'bind_dn',
    scalar => 'bind_password',
    scalar => 'obs_password',
    scalar => 'base_dn',
    scalar => 'base_scope',
    scalar => 'user_dn',
    scalar => 'user_scope',
    scalar => 'group_dn',
    scalar => 'group_scope',
    scalar => 'netgroup_dn',
    scalar => 'netgroup_scope',
    scalar => 'asymmetric_name_mapping',
    scalar => 'use_start_tls',
    scalar => 'netgroup_byhost_dn',
    scalar => 'netgroup_byhost_scope',
    scalar => 'is_netgroup_byhost_enabled',
    scalar => 'session_security',

];

1;

