#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdConfigurationShowFields ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagSecdConfigurationShowFields

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of Diag Secd Configuration Show Fields

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagSecdConfigurationShowFields
element are the attributes of the DiagSecdConfigurationShowFields ComponentState.

=over

=item C<< num_keys >>

Filled in for CMode CLI.

=item C<< num_fields >>

Filled in for CMode CLI.

=item C<< field_names >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::DiagSecdConfigurationShowFields;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);
use Class::MethodMaker [
    scalar  => 'num_keys',
    scalar  => 'field_names',
    scalar  => 'num_fields',
];

1;
