#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdNameMapping ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagSecdNameMapping

=head1 DESCRIPTION

C<NACL::CS::DiagSecdNameMapping> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DiagSecdNameMapping.  A related class is
L<NACL::C::DiagSecdNameMapping|lib-NACL-C-DiagSecdNameMapping-pm>, which represents access
to an ONTAP DiagSecdNameMapping.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagSecdNameMapping
element are the attributes of the DiagSecdNameMapping ComponentState.

=over

=item C<< "direction" >>

Filled in for CMode CLI.

=item C<< "vserver" >>

Filled in for CMode CLI.

=item C<< "name" >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< "maps-to" >>

Contains the value to which the name maps to

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagSecdNameMapping;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'direction',
    scalar => 'vserver',
    scalar => 'name',
    scalar => 'maps_to',
    scalar => 'node',
];

=head1 METHODS

=head2 fetch

    my $DiagSecdNameMapping_state   = NACL::CS::DiagSecdNameMapping->fetch(command_interface => $ci, ...);
    my @DiagSecdNameMapping_states = NACL::CS::DiagSecdNameMapping->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Fetch method will take only filter as the input parameter.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'diag secd name-mapping show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching diag secd name mapping(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg  = shift;
    my %opts = @_;
    delete $opts{requested_fields} if ($opts{requested_fields});
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(%opts,
        api => 'diag_secd_name_mapping_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
