# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary DiagSecdTrace ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::DiagSecdTrace

=head1 DESCRIPTION

C<NACL::CS::DiagSecdTrace> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP DiagSecdTrace.  A related class is
L<NACL::C::DiagSecdTrace|lib-NACL-C-DiagSecdTrace-pm>, which represents access
to an ONTAP DiagSecdTrace.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the DiagSecdTrace
element are the attributes of the DiagSecdTrace ComponentState.

=over

=item C<< node >>

Filled in for CMode CLI.

=item C<< traceall >>

Filled in for CMode CLI.

=item C<< vserver_ids >>
(Array)

Filled in for CMode CLI.

=item C<< modules >>
(Array)

Filled in for CMode CLI.

=item C<< domain_names >>
(Array)

Filled in for CMode CLI.

=item C<< dc_names >>
(Array)

Filled in for CMode CLI.

=item C<< ip_addrs >>
(Array)

Filled in for CMode CLI.

=item C<< rpc_names >>
(Array)

Filled in for CMode CLI.

=back

=cut

package NACL::CS::DiagSecdTrace;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'traceall',
    array  => 'modules',
    array  => 'vserver_ids',
    array  => 'ip_addrs',
    array  => 'domain_names',
    array  => 'rpc_names',
    array  => 'dc_names',
];

=head1 METHODS

=head2 fetch

    my $DiagSecdTrace_state   = NACL::CS::DiagSecdTrace->fetch(command_interface => $ci, ...);
	my @DiagSecdTrace_states = NACL::CS::DiagSecdTrace->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'diag secd trace show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching diag secd trace(s) found',
        is_singleton   => 1
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'diag_secd_trace_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
