# $Id: //depot/prod/DOT/dev/lib/NACL/CS/IOfence.pm#1 $

#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary IOfence ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::IOfence

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of iofence get command

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the IOfence
element are the attributes of the IOfence ComponentState.

=over

=item C<< refcnt >>

Filled in for 7Mode CLI.

=item C<< proto_fmode >>

Filled in for 7Mode CLI.

=item C<< type >>

Filled in for 7Mode CLI.

=back

=cut

package NACL::CS::IOfence;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);
use Class::MethodMaker [
    scalar => 'refcnt',
    scalar => 'proto_fmode',
    scalar => 'type',
];

1;
