# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::LunRelocation->show_by_job_info() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::LunRelocationShowByJobInfo

=head1 DESCRIPTION

C<NACL::CS::LunRelocationShowByJobInfo> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::LunRelocation->show_by_job_info() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::LunRelocation->show_by_job_info() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< scanner_total >>

LUN Relocation Total

Filled in for CMode CLI

=item C<< job_status >>

LUN Relocation Status

Filled in for CMode CLI

=item C<< lun_index >>

LUN Index

Filled in for CMode CLI

=item C<< last_failure_reason >>

Last Failure Reason

Filled in for CMode CLI

=item C<< destination_path >>

Destination Path

Filled in for CMode CLI

=item C<< job_uuid >>

LUN Relocation Job UUID

Filled in for CMode CLI

=item C<< is_snapshot_fenced >>

Is Snapshot Fenced possible value(s) are, true,false

Filled in for CMode CLI

=item C<< cutover_time >>

Cutover Time (secs)

Filled in for CMode CLI

=item C<< max_throughput >>

Maximum Transfer Rate (per sec)

Filled in for CMode CLI

=item C<< progress_percent >>

LUN Relocation Progress (%)

Filled in for CMode CLI

=item C<< vserver >>

Vserver Name

Filled in for CMode CLI

=item C<< elapsed_time >>

Elapsed Time

Filled in for CMode CLI

=item C<< is_destination_ready >>

Is Destination Ready possible value(s) are, true,false

Filled in for CMode CLI

=item C<< is_promoted_late >>

Is Destination Promoted Late possible value(s) are, true,false

Filled in for CMode CLI

=item C<< scanner_progress >>

LUN Relocation Progress

Filled in for CMode CLI

=item C<< source_path >>

Source Path

Filled in for CMode CLI

=item C<< source_vserver >>

Source Vserver

Filled in for CMode CLI.

=item C<< node >>

Destination Node possible value(s) are, <nodename>,local

Filled in for CMode CLI.


=item C<< dest_node >>

Destination Node

Filled in for CMode CLI.


=item C<< source_snapshot_instance_uuid >>

Source Snapshot Instance UUID

Filled in for CMode CLI.

=item C<< source_snapshot >>

Source Snapshot Name

Filled in for CMode CLI.

=item C<< source_snapshot_id >>

Source Snapshot ID

Filled in for CMode CLI.


=back

=cut

package NACL::CS::LunRelocationShowByJobInfo;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'scanner_total',
    scalar => 'job_status',
    scalar => 'lun_index',
    scalar => 'last_failure_reason',
    scalar => 'destination_path',
    scalar => 'job_uuid',
    scalar => 'is_snapshot_fenced',
    scalar => 'cutover_time',
    scalar => 'max_throughput',
    scalar => 'progress_percent',
    scalar => 'vserver',
    scalar => 'elapsed_time',
    scalar => 'is_destination_ready',
    scalar => 'is_promoted_late',
    scalar => 'scanner_progress',
    scalar => 'source_path',
    scalar => 'source_vserver',
    scalar => 'node',
    scalar => 'dest_node',
    scalar => 'source_snapshot_instance_uuid',
    scalar => 'source_snapshot',
    scalar => 'source_snapshot_id',
];

=head1 METHODS

=head2 fetch

    my $LunRelocationShowByJobInfo_state  = NACL::CS::LunRelocationShowByJobInfo->fetch(command_interface => $ci, ...);
	my @LunRelocationShowByJobInfo_states = NACL::CS::LunRelocationShowByJobInfo->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'lun relocation show-by-job-info',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching lun relocation(s) found',
        frontend       => 'NACL::CS::LunRelocationShowByJobInfo::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'lun_relocation_show_by_job_info',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
