# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary MetroclusterInterconnectMirror ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::MetroclusterInterconnectMirror

=head1 DESCRIPTION

C<NACL::CS::MetroclusterInterconnectMirror> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP MetroclusterInterconnectMirror.  A related class is
L<NACL::C::MetroclusterInterconnectMirror|lib::NACL-C-MetroclusterInterconnectMirror-pm>, which represents access
to an ONTAP MetroclusterInterconnectMirror.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the MetroclusterInterconnectMirror
element are the attributes of the MetroclusterInterconnectMirror ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< status >>

Status
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror physical-link-status="$value" />


=item C<< partner_name >>

Node name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror partner-name="$value" />


=item C<< node >>

Node name possible value(s) are, <nodename>,local
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror node-name="$value" />


=item C<< dr_partnername >>

DR Partner Name
Filled in for CMode CLI/ZAPI iter

=item C<< aux_partnername >>

Aux DR Partner Name
Filled in for CMode CLI/ZAPI iter

=item C<< mirror_admin_status >>

Mirror Administrative Status possible value(s) are, enabled,disabled
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror mirroring-admin-status="$value" />


=item C<< mirror_oper_status >>


Mirror Operational Status possible value(s) are, unknown,online,offline
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror mirroring-oper-status="$value" />


=item C<< dr_systemid >>

DR System ID
Filled in for CMode CLI/ZAPI iter

=item C<< ha_partnername >>

HA Partner Name
Filled in for CMode CLI/ZAPI iter

=item C<< node_systemid >>

Local System ID
Filled in for CMode CLI/ZAPI iter

=item C<< aux_systemid >>

Auxiliary System ID
Filled in for CMode CLI/ZAPI iter

=item C<< partner_type >>

Partner Type possible value(s) are, HA,DR,AUX
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror partner-type="$value" />


=item C<< partner_sysid >>

Partner System ID
Filled in for CMode CLI/ZAPI iter

=item C<< adapter_index >>

Adapter Index
Filled in for CMode CLI/ZAPI iter

=item C<< index >>

Partner SysId Index
Filled in for CMode CLI/ZAPI iter

=item C<< ha_systemid >>

HA System ID
Filled in for CMode CLI/ZAPI iter

=item C<< adapter >>

Adapter
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror adapter-name="$value" />


=item C<< next_partner >>

Next Partner
Filled in for CMode CLI/ZAPI iter

=item C<< type >>

Type
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <metrocluster-interconnect-mirror adapter-type="$value" />

=back

=cut

package NACL::CS::MetroclusterInterconnectMirror;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'status',
    scalar => 'partner_name',
    scalar => 'node',
    scalar => 'dr_partnername',
    scalar => 'aux_partnername',
    scalar => 'mirror_admin_status',
    scalar => 'mirror_oper_status',
    scalar => 'dr_systemid',
    scalar => 'ha_partnername',
    scalar => 'node_systemid',
    scalar => 'aux_systemid',
    scalar => 'partner_type',
    scalar => 'partner_sysid',
    scalar => 'adapter_index',
    scalar => 'index',
    scalar => 'ha_systemid',
    scalar => 'adapter',
    scalar => 'next_partner',
    scalar => 'type',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $MetroclusterInterconnectMirror_state  = NACL::CS::MetroclusterInterconnectMirror->fetch(command_interface => $ci, ...);
	my @MetroclusterInterconnectMirror_states = NACL::CS::MetroclusterInterconnectMirror->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes metrocluster-interconnect-mirror-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text =>
            'No matching metrocluster interconnect mirror(s) found',
        frontend => 'NACL::CS::MetroclusterInterconnectMirror::fetch',
        show_cmd => 'metrocluster interconnect mirror show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'metrocluster_interconnect_mirror_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(partner-name partner-type
                )
        ],
        map => {
            'status'              => 'physical-link-status',
            'node'                => 'node-name',
            'mirror-admin-status' => 'mirroring-admin-status',
            'mirror-oper-status'  => 'mirroring-oper-status',
            'adapter'             => 'adapter-name',
            'type'                => 'adapter-type',
        },
        api => "metrocluster-interconnect-mirror-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
