#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary MetroclusterProgressTable ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::MetroclusterProgressTable

=head1 DESCRIPTION

C<NACL::CS::MetroclusterProgressTable> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP MetroclusterProgressTable.  A related class is
L<NACL::C::MetroclusterProgressTable|lib-NACL-C-MetroclusterProgressTable-pm>, which represents access
to an ONTAP MetroclusterProgressTable.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the MetroclusterProgressTable
element are the attributes of the MetroclusterProgressTable ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< index >>

Filled in for CMode CLI/ZAPI.

=item C<< timedelta >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI : duration

=item C<< failurecode >>

Filled in for CMode CLI.

=item C<< entryname >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI: entry-name

=item C<< node >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI: node-name

=item C<< state >>

Filled in for CMode CLI/ZAPI.

=back

=cut

package NACL::CS::MetroclusterProgressTable;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'index',
    scalar => 'timedelta',
    scalar => 'failurecode',
    scalar => 'entryname',
    scalar => 'node',
    scalar => 'state',
];

=head1 METHODS

=head2 fetch

    my $MetroclusterProgressTable_state  = NACL::CS::MetroclusterProgressTable->fetch(command_interface => $ci, ...);
	my @MetroclusterProgressTable_states = NACL::CS::MetroclusterProgressTable->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI/ZAPI APISet.

Invokes 'metrocluster-progress-table-get-iter' API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        show_cmd       => 'metrocluster progress-table show',
	exception_text => 'No matching metrocluster progress-table(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api => 'metrocluster_progress_table_show',

    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my @states = $pkg->SUPER::_fetch_cmode_zapi(
        @opts,
        copy => [qw(state index)],
        map  => {
            'entryname' => 'entry-name',
            'node'      => 'node-name',
            'timedelta' => 'duration',
        },
        api => 'metrocluster-progress-table-get-iter',
    );
    $Log->exit() if $may_exit;
    return @states;
}

1;
