#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary NetworkInterfaceCdb ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::NetworkInterfaceCdb

=head1 DESCRIPTION

C<NACL::CS::NetworkInterfaceCdb> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP NetworkInterfaceCdb.  A related class is
L<NACL::C::NetworkInterfaceCdb|lib-NACL-C-NetworkInterfaceCdb-pm>, which represents access
to an ONTAP NetworkInterfaceCdb.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the NetworkInterfaceCdb
element are the attributes of the NetworkInterfaceCdb ComponentState.

=over

=item C<< "has_valid_id" >>

Filled in for CMode CLI.

=item C<< "curr_node" >>

Filled in for CMode CLI.

=item C<< "failover_group" >>

Filled in for CMode CLI.

=item C<< "home_port" >>

Filled in for CMode CLI.

=item C<< "node" >>

Filled in for CMode CLI.

=item C<< "lif_id" >>

Filled in for CMode CLI.

=item C<< "failover_policy" >>

Filled in for CMode CLI.

=item C<< "firewall_policy" >>

Filled in for CMode CLI.

=item C<< "address" >>

Filled in for CMode CLI.

=item C<< "netmask" >>

Filled in for CMode CLI.

=item C<< "lif_name" >>

Filled in for CMode CLI.

=item C<< "home_node" >>

Filled in for CMode CLI.

=item C<< "status_admin" >>

Filled in for CMode CLI.

=item C<< "use_failover_group" >>

Filled in for CMode CLI.

=item C<< "vif_name" >>

Filled in for CMode CLI.

=item C<< "status_oper" >>

Filled in for CMode CLI.

=item C<< "curr_port" >>

Filled in for CMode CLI.

=item C<< "vif_id" >>

Filled in for CMode CLI.

=item C<< "role" >>

Filled in for CMode CLI.

=item C<< "routing_group" >>

Filled in for CMode CLI.

=item C<< auto_configuration >>

Use Address Auto-configuration

Filled in for CMode CLI.


=item C<< preferred_lifetime >>

Preferred Lifetime (autoconf)

Filled in for CMode CLI.

=item C<< valid_lifetime >>

Valid Lifetime (autoconf)

Filled in for CMode CLI.


=back

=cut

package NACL::CS::NetworkInterfaceCdb;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'has_valid_id',
    scalar => 'curr_node',
    scalar => 'failover_group',
    scalar => 'home_port',
    scalar => 'node',
    scalar => 'lif_id',
    scalar => 'failover_policy',
    scalar => 'firewall_policy',
    scalar => 'address',
    scalar => 'netmask',
    scalar => 'lif_name',
    scalar => 'home_node',
    scalar => 'status_admin',
    scalar => 'use_failover_group',
    scalar => 'vif_name',
    scalar => 'status_oper',
    scalar => 'curr_port',
    scalar => 'vif_id',
    scalar => 'role',
    scalar => 'routing_group',
    scalar => 'auto_configuration',
    scalar => 'preferred_lifetime',
    scalar => 'valid_lifetime',
];

=head1 METHODS

=head2 fetch

    my $NetworkInterfaceCdb_state   = NACL::CS::NetworkInterfaceCdb->fetch(command_interface => $ci, ...);
	my @NetworkInterfaceCdb_states = NACL::CS::NetworkInterfaceCdb->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'network interface cdb show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching network interface cdb(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'network_interface_cdb_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
