#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary QosSettingsReadAhead ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, pkj@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::QosSettingsReadAhead

=head1 DESCRIPTION

C<NACL::CS::QosSettingsReadAhead> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP QosSettingsReadAhead.  A related class is
L<NACL::C::QosSettingsReadAhead|lib-NACL-C-QosSettingsReadAhead-pm>, which represents access
to an ONTAP QosSettingsReadAhead.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the QosSettingsReadAhead
element are the attributes of the QosSettingsReadAhead ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< disk_response_weight >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <disk-response-weight>$value</disk-response-weight>
 </qos-settings-read-ahead-info>

=item C<< use_histogram >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <use-histogram>$value</use-histogram>
 </qos-settings-read-ahead-info>

=item C<< num_workloads >>

Filled in for CMode CLI.

=item C<< max_blocks >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <max-blocks>$value</max-blocks>
 </qos-settings-read-ahead-info>

=item C<< early_count >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <early-count>$value</early-count>
 </qos-settings-read-ahead-info>

=item C<< min_disk_response_time >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <min-disk-response-time>$value</min-disk-response-time>
 </qos-settings-read-ahead-info>

=item C<< max_deadline >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <max-deadline>$value</max-deadline>
 </qos-settings-read-ahead-info>

=item C<< interarrival_weight >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <interarrival-weight>$value</interarrival-weight>
 </qos-settings-read-ahead-info>

=item C<< force_full >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <force-full>$value</force-full>
 </qos-settings-read-ahead-info>

=item C<< smallfile_blocks >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <smallfile-blocks>$value</smallfile-blocks>
 </qos-settings-read-ahead-info>

=item C<< use_feedback >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <use-feedback>$value</use-feedback>
 </qos-settings-read-ahead-info>

=item C<< jitter >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <jitter>$value</jitter>
 </qos-settings-read-ahead-info>

=item C<< metadata >>

Filled in for CMode CLI.

=item C<< align_blocks >>

Filled in for CMode CLI/ZAPI. 

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <align-blocks>$value</align-blocks>
 </qos-settings-read-ahead-info>

=item C<< force_none >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <force-none>$value</force-none>
 </qos-settings-read-ahead-info>

=item C<< max_disk_response_time >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <max-disk-response-time>$value</max-disk-response-time>
 </qos-settings-read-ahead-info>

=item C<< use_async >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <use-async>$value</use-async>
 </qos-settings-read-ahead-info>

=item C<< default >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <default>$value</default>
 </qos-settings-read-ahead-info>

=item C<< metadata_blocks >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <metadata-blocks>$value</metadata-blocks>
 </qos-settings-read-ahead-info>

=item C<< read_ahead_setting_id >>

Filled in for CMode CLI.

=item C<< max_range >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <max-range>$value</max-range>
 </qos-settings-read-ahead-info>

=item C<< force_dump >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <force-dump>$value</force-dump>
 </qos-settings-read-ahead-info>

=item C<< max_gap >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <max-gap>$value</max-gap>
 </qos-settings-read-ahead-info>

=item C<< read_ahead_setting >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <read-ahead-setting-name>$value</read-ahead-setting-name>
 </qos-settings-read-ahead-info>

=item C<< disk_response_factor >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <disk-response-factor>$value</disk-response-factor>
 </qos-settings-read-ahead-info>

=item C<< use_timing >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <use-timing>$value</use-timing>
 </qos-settings-read-ahead-info>

=item C<< min_blocks >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <min-blocks>$value</min-blocks>
 </qos-settings-read-ahead-info>

=item C<< class >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <read-ahead-class>$value</read-ahead-class>
 </qos-settings-read-ahead-info>

=item C<< overshoot >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <overshoot>$value</overshoot>
 </qos-settings-read-ahead-info>

=item C<< min_range >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <min-range>$value</min-range>
 </qos-settings-read-ahead-info>

=item C<< max_retire_time >>

*Maximum Time Before a Stream is Retired (us), possible value(s) are
10000..10000000

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <max-retire-time>$value</max-retire-time>
 </qos-settings-read-ahead-info>

=item C<< min_retire_time >>

*Minimum Time Before a Stream is Retired (us), possible value(s) are
10000..10000000

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <qos-settings-read-ahead-info>
    <min-retire-time>$value</min-retire-time>
 </qos-settings-read-ahead-info>


=item C<< min_file_histogram >>


Minimum filesize for Histogram-based predictions (blocks) ranges from 8192 to 33554432

Filled in for CMode CLI.


=back

=cut

package NACL::CS::QosSettingsReadAhead;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'disk_response_weight',
    scalar => 'use_histogram',
    scalar => 'num_workloads',
    scalar => 'max_blocks',
    scalar => 'early_count',
    scalar => 'min_disk_response_time',
    scalar => 'max_deadline',
    scalar => 'interarrival_weight',
    scalar => 'force_full',
    scalar => 'smallfile_blocks',
    scalar => 'use_feedback',
    scalar => 'jitter',
    scalar => 'metadata',
    scalar => 'align_blocks',
    scalar => 'force_none',
    scalar => 'max_disk_response_time',
    scalar => 'use_async',
    scalar => 'default',
    scalar => 'metadata_blocks',
    scalar => 'read_ahead_setting_id',
    scalar => 'max_range',
    scalar => 'force_dump',
    scalar => 'max_gap',
    scalar => 'read_ahead_setting',
    scalar => 'disk_response_factor',
    scalar => 'use_timing',
    scalar => 'min_blocks',
    scalar => 'class',
    scalar => 'overshoot',
    scalar => 'min_range',
    scalar => 'max_retire_time',
    scalar => 'min_retire_time',
    scalar => 'min_file_histogram',
];

=head1 METHODS

=head2 fetch

    my $QosSettingsReadAhead_state  = NACL::CS::QosSettingsReadAhead->fetch(command_interface => $ci, ...);
    my @QosSettingsReadAhead_states = NACL::CS::QosSettingsReadAhead->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI APISet.

Invokes "qos-settings-read-ahead-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'qos settings read-ahead show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching qos settings read-ahead(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'qos_settings_read_ahead_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'qos_settings_read_ahead_get_iter',
        copy => [
            qw( default disk-response-factor disk-response-weight
                early-count  force-dump  max-blocks jitter
                force-full  max-deadline max-disk-response-time
                max-gap max-range metadata-blocks min-blocks min-disk-response-time
                min-range  overshoot use-async use-feedback use-histogram
                use-timing max-retire-time min-retire-time smallfile-blocks
                align-blocks interarrival-weight force-none
                )
        ],
        map => {
            'read-ahead-setting' => 'read-ahead-setting-name',
            'class'              => 'read-ahead-class',
        },
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
