#$Id: //depot/prod/test/nacldev/lib/NACL/CS/QosStatisticsWorkloadPerformance.pm#6 $
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary QosStatisticsWorkloadPerformance ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::QosStatisticsWorkloadPerformance

=head1 DESCRIPTION

C<NACL::CS::QosStatisticsWorkloadPerformance> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP QosStatisticsWorkloadPerformance.  A related class is
L<NACL::C::QosStatisticsWorkloadPerformance|lib-NACL-C-QosStatisticsWorkloadPerformance-pm>, which represents access
to an ONTAP QosStatisticsWorkloadPerformance.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the QosStatisticsWorkloadPerformance
element are the attributes of the QosStatisticsWorkloadPerformance ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< workload >>

Filled in for CMode CLI.

=item C<< latency >>

Filled in for CMode CLI.

=item C<< wid >>

Filled in for CMode CLI.

=item C<< tput >>

Filled in for CMode CLI.

=item C<< iops >>

Filled in for CMode CLI.

=back

=head1 ADDITIONAL FILTER FIELDS

The following options can only be passed in 'filter'. These are not valid for 'requested_fields' as these are not the attributes.

=over

=item C<< show_time_spent >>

=item C<< raw_display >>

=item C<< iterations >>

=item C<< rows >>

=item C<< interval >>

=item C<< node >>

=item C<< refresh_display >>

Toggle Screen Refresh Between Each Iteration, possible value(s) are true,false


=back

=cut

package NACL::CS::QosStatisticsWorkloadPerformance;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'workload',
    scalar => 'wid',
    scalar => 'iops',
    scalar => 'tput',
    scalar => 'latency',
];

=head1 METHODS

=head2 fetch

    my $QosStatisticsWorkloadPerformance_state  = NACL::CS::QosStatisticsWorkloadPerformance->fetch(command_interface => $ci, ...);
	my @QosStatisticsWorkloadPerformance_states = NACL::CS::QosStatisticsWorkloadPerformance->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'qos statistics workload performance show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching qos statistics workload performance(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'qos_statistics_workload_performance_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _check_for_invalid_requested_filter_fields {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    $pkg->SUPER::_check_for_invalid_requested_filter_fields(
        @_,
        additional_filter_fields => [
            qw( iterations node show-time-spent raw-display rows refresh-display interval )
        ]
    );
    $Log->exit() if $may_exit;
}

1;
