# $Id: //depot/prod/test/nacldev/lib/NACL/CS/QosStatisticsWorkloadResourceCpu.pm#4 $
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary QosStatisticsWorkloadResourceCpu ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::QosStatisticsWorkloadResourceCpu

=head1 DESCRIPTION

C<NACL::CS::QosStatisticsWorkloadResourceCpu> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP QosStatisticsWorkloadResourceCpu.  A related class is
L<NACL::C::QosStatisticsWorkloadResourceCpu|lib-NACL-C-QosStatisticsWorkloadResourceCpu-pm>, which represents access
to an ONTAP QosStatisticsWorkloadResourceCpu.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the QosStatisticsWorkloadResourceCpu
element are the attributes of the QosStatisticsWorkloadResourceCpu ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< workload >>

Filled in for CMode CLI

=item C<< CPU >>

Filled in for CMode CLI

=item C<< id >>

Filled in for CMode CLI

=item *

All the fields returned in the output of the command is supported as attributes in the returned object
Filled in for CMode CLI

=back

=head1 ADDITIONAL FILTER FIELDS

The following options can only be passed in 'filter'. These are not valid for 'requested_fields' as these are not the attributes.

=over

=item C<< show_time_spent >>

*Toggle Display of Time Spent in Execution, possible value(s) are true,false

=item C<< iterations >>

Number of Iterations

=item C<< rows >>

Number of Rows in the Output

=item C<< interval >>


=item C<< refresh_display >>

Toggle Screen Refresh Between Each Iteration, possible value(s) are true,false

=item C<< node >>

Node

=item C<< cols >>

*List of Domains to Display
(Array)
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { cols = [ value1, value2...] }

=back

=cut

package NACL::CS::QosStatisticsWorkloadResourceCpu;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'workload',
    scalar => 'id',
    scalar => 'CPU',
];

=head1 METHODS

=head2 fetch

    my $QosStatisticsWorkloadResourceCpu_state  = NACL::CS::QosStatisticsWorkloadResourceCpu->fetch(command_interface => $ci, ...);
	my @QosStatisticsWorkloadResourceCpu_states = NACL::CS::QosStatisticsWorkloadResourceCpu->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching qos statistics workload resource cpu(s) found',
        show_cmd       =>
            'qos statistics workload resource cpu show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts = validate @args, $pkg->_fetch_backend_validate_spec();
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};
    my $filter            = \%{$opts{filter}};
    my %cmd_opts;
    my $type;
    my @arr;

    while (my ($key, $value) = each %{$filter}) {
        if (ref $value eq 'ARRAY') {
            $cmd_opts{$key} = join(",", @{delete $filter->{$key}});
        }
    }
    my $response
        = $apiset->qos_statistics_workload_resource_cpu_show(%{$filter},
        %cmd_opts);
    my $output = $response->get_parsed_output();
    while (my ($key, $value) = each %{$output->[0]}) {
        $key =~ s/\s+//g;
        next
            if (lc($key) eq "cpu"
            || lc($key) eq "id"
            || lc($key) eq "workload");
        unless (NACL::CS::QosStatisticsWorkloadResourceCpu->can($key)) {
            if (ref $value eq 'ARRAY') {
                $type = 'array';
            } elsif (!ref $value) {
                $type = 'scalar';
            } else {
                $Log->exit() if $may_exit;
                NATE::BaseException->throw(
                          "Some other typedef other than a scalar "
                        . " and array that is ref($value)\n"
                        . NACL::ComponentUtils::Dumper($value));
            }
            my $method = $pkg->_translate_to_obj_field_name($key);
            push @arr, $type, $method;
        }
    }
    Class::MethodMaker->import(
        [   '-target_class' => 'NACL::CS::QosStatisticsWorkloadResourceCpu',
            @arr
        ]
    );
    my @state_objs;
    my %target_hash;
    foreach my $row (@$output) {
        my $obj = $pkg->new(command_interface => $command_interface);
        while (my ($key, $value) = each %$row) {
            $key =~ s/\s+$//g;
            $key = $pkg->_translate_to_obj_field_name($key);
            $target_hash{$key} = $value;
        }
        $obj->_set_fields(row => \%target_hash);
        push @state_objs, $obj;
    }
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _extra_filter_fields {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [
        qw( node iterations rows refresh_display cols show-time-spent interval)
    ];
}

1;
