# $Id: //depot/prod/test/nacldev/lib/NACL/CS/QosStatisticsWorkloadResourceDisk.pm#4 $
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary QosStatisticsWorkloadResourceDisk ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::QosStatisticsWorkloadResourceDisk

=head1 DESCRIPTION

C<NACL::CS::QosStatisticsWorkloadResourceDisk> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP QosStatisticsWorkloadResourceDisk.  A related class is
L<NACL::C::QosStatisticsWorkloadResourceDisk|lib-NACL-C-QosStatisticsWorkloadResourceDisk-pm>, which represents access
to an ONTAP QosStatisticsWorkloadResourceDisk.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the QosStatisticsWorkloadResourceDisk
element are the attributes of the QosStatisticsWorkloadResourceDisk ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< workload >>

Filled in for CMode CLI

=item C<< wid >>

Filled in for CMode CLI

=item C<< disk_percent >>

Filled in for CMode CLI

=item C<< num_disks >>

Filled in for CMode CLI

=back

=head1 ADDITIONAL FILTER FIELDS

The following options can only be passed in 'filter'. These are not valid for 'requested_fields' as these are not the attributes.

=over

=item C<< show_time_spent >>

*Toggle Display of Time Spent in Execution, possible value(s) are true,false

=item C<< iterations >>

Number of Iterations

=item C<< rows >>

Number of Rows in the Output

=item C<< interval >>

=item C<< refresh_display >>

Toggle Screen Refresh Between Each Iteration, possible value(s) are true,false

=item C<< node >>

Node

=back

=cut

package NACL::CS::QosStatisticsWorkloadResourceDisk;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'workload',
    scalar => 'wid',
    scalar => 'disk_percent',
    scalar => 'num_disks',
];

=head1 METHODS

=head2 fetch

    my $QosStatisticsWorkloadResourceDisk_state  = NACL::CS::QosStatisticsWorkloadResourceDisk->fetch(command_interface => $ci, ...);
	my @QosStatisticsWorkloadResourceDisk_states = NACL::CS::QosStatisticsWorkloadResourceDisk->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'qos statistics workload resource disk show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching $not_matching_element found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'qos_statistics_workload_resource_disk_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _extra_filter_fields {
    $Log->enter() if $may_enter;
    $Log->exit() if $may_exit;
    return [
        qw( show-time-spent iterations rows interval node refresh-display )];
}

1;
