#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary RepositoryPlacementFileCreate ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::RepositoryPlacementFileCreate

=head1 DESCRIPTION

C<NACL::CS::RepositoryPlacementFileCreate> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP RepositoryPlacementFileCreate.  A related class is
L<NACL::C::RepositoryPlacementFileCreate|lib-NACL-C-RepositoryPlacementFileCreate-pm>, which represents access
to an ONTAP RepositoryPlacementFileCreate.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the RepositoryPlacementFileCreate
element are the attributes of the RepositoryPlacementFileCreate ComponentState.

=over

=item C<< create_regular_ratio >>

Filled in for CMode CLI.

=item C<< create_empty_ratio >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< create_force_volume >>

Filled in for CMode CLI.

=item C<< constituent_group_id >>

*Constituent Group ID

Filled in for CMode CLI.

=item C<< volume >>

*Volume Name

Filled in for CMode CLI.

=back

=cut

package NACL::CS::RepositoryPlacementFileCreate;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'create_regular_ratio',
    scalar => 'create_empty_ratio',
    scalar => 'vserver',
    scalar => 'create_force_volume',
    scalar => 'object_volume_group',
    scalar => 'data_constituent_group',
    scalar => 'constituent_group_id',
    scalar => 'volume',
];

=head1 METHODS

=head2 fetch

    my $RepositoryPlacementFileCreate_state   = NACL::CS::RepositoryPlacementFileCreate->fetch(command_interface => $ci, ...);
	my @RepositoryPlacementFileCreate_states = NACL::CS::RepositoryPlacementFileCreate->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'repository placement file-create show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text =>
            'No matching repository placement file create(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'repository_placement_file_create_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
