#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary RepositoryVolume ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::RepositoryVolume

=head1 DESCRIPTION

C<NACL::CS::RepositoryVolume> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP RepositoryVolume.  A related class is
L<NACL::C::RepositoryVolume|lib-NACL-C-RepositoryVolume-pm>, which represents access
to an ONTAP RepositoryVolume.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the RepositoryVolume
element are the attributes of the RepositoryVolume ComponentState.

=over

=item C<< percent_used >>

Filled in for CMode CLI.

=item C<< status >>

Filled in for CMode CLI.

=item C<< perform_objcons_check >>

Filled in for CMode CLI.

=item C<< available_size >>

Filled in for CMode CLI.

=item C<< junction_path >>

Filled in for CMode CLI.

=item C<< state >>

Filled in for CMode CLI.

=item C<< size >>

Filled in for CMode CLI.

=item C<< junction_active >>

Filled in for CMode CLI.

=item C<< sis_space_saved_percent >>

Filled in for CMode CLI.

=item C<< namespace_aggregate >>

Filled in for CMode CLI.

=item C<< group >>

Filled in for CMode CLI.

=item C<< user >>

Filled in for CMode CLI.

=item C<< policy >>

Filled in for CMode CLI.

=item C<< default_object_volume_group >>

Filled in for CMode CLI.

=item C<< dedup_space_saved >>

Filled in for CMode CLI.

=item C<< directory_bitwidth >>

Filled in for CMode CLI.

=item C<< sys_aggr_list >>

(Array)

Filled in for CMode CLI.

=item C<< compression_space_saved_percent >>

Filled in for CMode CLI.

=item C<< volume >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< total >>

Filled in for CMode CLI.

=item C<< compression_space_saved >>

Filled in for CMode CLI.

=item C<< sis_space_saved >>

Filled in for CMode CLI.

=item C<< snapshot_policy >>

Filled in for CMode CLI.

=item C<< space_guarantee >>

Filled in for CMode CLI.

=item C<< unix_permissions >>

Filled in for CMode CLI.

=item C<< used >>

Filled in for CMode CLI.

=item C<< type >>

Filled in for CMode CLI.

=item C<< foreground >>

Filled in for CMode CLI.

=item C<< nvfail >>

Filled in for CMode CLI.

=item C<< dedup_space_saved_percent >>

Filled in for CMode CLI.

=item C<< read_realloc >>

Filled in for CMode CLI.

=item C<< nfs_character_set >>

Filled in for CMode CLI.

=item C<< files >>

Filled in for CMode CLI.

=item C<< is_data_protection_mirror >>

Filled in for CMode CLI.

=item C<< is_cluster_volume >>

Filled in for CMode CLI.

=item C<< is_move_mirror >>

Filled in for CMode CLI.

=item C<< convert_ucode >>

Filled in for CMode CLI.

=item C<< percent_snapshot_space >>

Filled in for CMode CLI.

=item C<< perform_datacons_check >>

Filled in for CMode CLI.

=item C<< default_data_constituent_group >>

Filled in for CMode CLI.

=item C<< files_used >>

Filled in for CMode CLI.

=item C<< volume_style >>

Filled in for CMode CLI.

=item C<< extent_enabled >>

Filled in for CMode CLI.

=item C<< is_sis_volume >>

Filled in for CMode CLI.

=item C<< snapdir_access >>

Filled in for CMode CLI.

=item C<< size_available_for_snapshots >>

Filled in for CMode CLI.

=item C<< filesys_size_fixed >>

Filled in for CMode CLI.

=item C<< snapshot_reserve_size >>

Filled in for CMode CLI.

=item C<< snap_autodelete_enabled >>

Filled in for CMode CLI.

=item C<< is_load_sharing_mirror >>

Filled in for CMode CLI.

=item C<< create_time >>

Filled in for CMode CLI.

=item C<< auto_snapshots_enabled >>

Filled in for CMode CLI.

=item C<< ideal_state >>

Filled in for CMode CLI.

=item C<< language >>

Filled in for CMode CLI.

=item C<< create_ucode >>

Filled in for CMode CLI.

=item C<< security_style >>

Filled in for CMode CLI.

=item C<< is_replica_volume >>

Filled in for CMode CLI.

=item C<< is_readonly >>

Filled in for CMode CLI.

=item C<< is_sis_logging_enabled >>

Filled in for CMode CLI.

=item C<< min_readahead >>

Filled in for CMode CLI.

=item C<< mirror_transfer_in_progress >>

Filled in for CMode CLI.

=item C<< snapshot_space_used >>

Filled in for CMode CLI.

=item C<< language_str >>

Filled in for CMode CLI.

=item C<< oem_character_set >>

Filled in for CMode CLI.

=item C<< vserver_uuid >>

Filled in for CMode CLI.

=item C<< available >>

Filled in for CMode CLI.

=item C<< space_guarantee_enabled >>

Filled in for CMode CLI.

=item C<< is_inconsistent >>

Filled in for CMode CLI.

=item C<< atime_update >>

Filled in for CMode CLI.

=item C<< comment >>

Filled in for CMode CLI.

=item C<< is_compressed_volume >>

Filled in for CMode CLI.

=item C<< size_used_by_snapshots >>

Filled in for CMode CLI.

=item C<< actual_size >>

Filled in for CMode CLI.

=item C<< ols_aggr_list >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $ols_aggr_list = $obj->ols_aggr_list();
# $ols_aggr_list contains a reference to the array of values
my @ols_aggr_list = $obj->ols_aggr_list();
# @ols_aggr_list contains the array of values

Filled in for CMode CLI.

=item C<< object_write_sync_period >>

Filled in for CMode CLI.

=item C<< enable_object_store >>

Filled in for CMode CLI.

=item C<< ols_constituent_count >>

Filled in for CMode CLI.

=item C<< ols_constituent_size >>

Filled in for CMode CLI.

=item C<< use_new_algorithm >>

Filled in for CMode CLI.

=item C<< uuid >>

Filled in for CMode CLI.

=item C<< dedupe_space_saved_percent >>

Filled in for CMode CLI.

=item C<< is_managed_by_service >>

Filled in for CMode CLI.

=item C<< dedupe_space_shared >>

Filled in for CMode CLI.

=item C<< dedupe_space_saved >>

Filled in for CMode CLI.

=item C<< storage_service >>

Filled in for CMode CLI.

=item C<< max_data_constituent_size >>

Filled in for CMode CLI.

=item C<< max_namespace_constituent_size >>

*Maximum Size of Namespace Constituent, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< data_aggr_list >>

*List of Aggregates for Data Constituents

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $data_aggr_list = $obj->data_aggr_list();
# $data_aggr_list contains a reference to the array of values
my @data_aggr_list = $obj->data_aggr_list();
# @data_aggr_list contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { data_aggr_list = [ value1, value2...] }

Filled in for CMode CLI.

=item C<< enable_snapdiff >>

*Create Namespace Mirrors For Snapdiff Use, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< ns_mirror_aggr_list >>

*List of Aggregates for Namespace Mirrors

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $ns_mirror_aggr_list = $obj->ns_mirror_aggr_list();
# $ns_mirror_aggr_list contains a reference to the array of values
my @ns_mirror_aggr_list = $obj->ns_mirror_aggr_list();
# @ns_mirror_aggr_list contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { ns_mirror_aggr_list = [ value1, value2...] }

Filled in for CMode CLI.

=item C<< percent_reserve_constituent >>

*Percent Space For Reserve Data Constituent

Filled in for CMode CLI.

=item C<< snap_mirror_enabled >>

Filled in for CMode CLI.

=item C<< in_nvfailed_state >>

*Volume's Nvfailed State, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< filesystem_size >>

Filesystem Size

Filled in for CMode CLI.

=item C<< unreachable_attr_action >>


Action When Attributes Are Not Reachable possible value(s) are, return-generated,wait

Filled in for CMode CLI.


=item C<< excluded_from_balancer >>

Is Capacity Balancer Disabled possible value(s) are, true,false

Filled in for CMode CLI.


=back

=cut

package NACL::CS::RepositoryVolume;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'percent_used',
    scalar => 'status',
    scalar => 'perform_objcons_check',
    scalar => 'available_size',
    scalar => 'junction_path',
    scalar => 'state',
    scalar => 'size',
    scalar => 'junction_active',
    scalar => 'sis_space_saved_percent',
    scalar => 'namespace_aggregate',
    scalar => 'group',
    scalar => 'user',
    scalar => 'policy',
    scalar => 'default_object_volume_group',
    scalar => 'dedup_space_saved',
    scalar => 'directory_bitwidth',
    array  => 'sys_aggr_list',
    scalar => 'compression_space_saved_percent',
    scalar => 'volume',
    scalar => 'vserver',
    scalar => 'total',
    scalar => 'compression_space_saved',
    scalar => 'sis_space_saved',
    scalar => 'snapshot_policy',
    scalar => 'space_guarantee',
    scalar => 'unix_permissions',
    scalar => 'used',
    scalar => 'type',
    scalar => 'foreground',
    scalar => 'nvfail',
    scalar => 'dedup_space_saved_percent',
    scalar => 'read_realloc',
    scalar => 'nfs_character_set',
    scalar => 'files',
    scalar => 'is_data_protection_mirror',
    scalar => 'is_cluster_volume',
    scalar => 'is_move_mirror',
    scalar => 'convert_ucode',
    scalar => 'percent_snapshot_space',
    scalar => 'perform_datacons_check',
    scalar => 'default_data_constituent_group',
    scalar => 'files_used',
    scalar => 'volume_style',
    scalar => 'extent_enabled',
    scalar => 'is_sis_volume',
    scalar => 'snapdir_access',
    scalar => 'size_available_for_snapshots',
    scalar => 'filesys_size_fixed',
    scalar => 'snapshot_reserve_size',
    scalar => 'snap_autodelete_enabled',
    scalar => 'is_load_sharing_mirror',
    scalar => 'create_time',
    scalar => 'auto_snapshots_enabled',
    scalar => 'ideal_state',
    scalar => 'language',
    scalar => 'create_ucode',
    scalar => 'security_style',
    scalar => 'is_replica_volume',
    scalar => 'is_readonly',
    scalar => 'is_sis_logging_enabled',
    scalar => 'min_readahead',
    scalar => 'mirror_transfer_in_progress',
    scalar => 'snapshot_space_used',
    scalar => 'language_str',
    scalar => 'oem_character_set',
    scalar => 'vserver_uuid',
    scalar => 'available',
    scalar => 'space_guarantee_enabled',
    scalar => 'is_inconsistent',
    scalar => 'atime_update',
    scalar => 'comment',
    scalar => 'is_compressed_volume',
    scalar => 'size_used_by_snapshots',
    scalar => 'actual_size',
    array  => 'ols_aggr_list',
    scalar => 'object_write_sync_period',
    scalar => 'enable_object_store',
    scalar => 'ols_constituent_count',
    scalar => 'ols_constituent_size',
    scalar => 'use_new_algorithm',
    scalar => 'uuid',
    scalar => 'dedupe_space_saved_percent',
    scalar => 'is_managed_by_service',
    scalar => 'dedupe_space_shared',
    scalar => 'dedupe_space_saved',
    scalar => 'storage_service',
    scalar => 'max_data_constituent_size',
    scalar => 'max_namespace_constituent_size',
    array  => 'data_aggr_list',
    scalar => 'enable_snapdiff',
    array  => 'ns_mirror_aggr_list',
    scalar => 'percent_reserve_constituent',
    scalar => 'snap_mirror_enabled',
    scalar => 'in_nvfailed_state',
    scalar => 'filesystem_size',
    scalar => 'unreachable_attr_action',
    scalar => 'excluded_from_balancer',
];

=head1 METHODS

=head2 fetch

    my $RepositoryVolume_state   = NACL::CS::RepositoryVolume->fetch(command_interface => $ci, ...);
	my @RepositoryVolume_states = NACL::CS::RepositoryVolume->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'repository volume show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching repository volume(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'repository_volume_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
