#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::RepositoryVolumeSnapshot->get_snapshot_UUID()
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::RepositoryVolumeSnapshotGetSnapshotUUID

=head1 DESCRIPTION

C<NACL::CS::RepositoryVolumeSnapshotGetSnapshotUUID> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::RepositoryVolumeSnapshot->get_snapshot_UUID() is invoked.

(This module does not represent the state of any element, but is an object
repesentation of the output obtained when
NACL::C::RepositoryVolumeSnapshot->get_snapshot_UUID() is invoked.)

=head1 ATTRIBUTES

=head2 snapshot_uuid

The UUID of the snapshot.

Filled in for CMode-CLI.

=cut

package NACL::CS::RepositoryVolumeSnapshotGetSnapshotUUID;

use strict;
use warnings;
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [ scalar => 'snapshot_uuid', ];

1;
