# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SecurityCertificateCaIssued ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SecurityCertificateCaIssued

=head1 DESCRIPTION

C<NACL::CS::SecurityCertificateCaIssued> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SecurityCertificateCaIssued.  A related class is
L<NACL::C::SecurityCertificateCaIssued|lib-NACL-C-SecurityCertificateCaIssued-pm>, which represents access
to an ONTAP SecurityCertificateCaIssued.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SecurityCertificateCaIssued
element are the attributes of the SecurityCertificateCaIssued ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< country >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
<country>$value</country>
 </certificate-ca-issued-info>

=item C<< ca_serial >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <ca-serial-number>$value</ca-serial-number>
 </certificate-ca-issued-info>

=item C<< email_addr >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <email_addr>$value</email_addr>
 </certificate-ca-issued-info>

=item C<< serial >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <serial-number>$value</serial-number>
 </certificate-ca-issued-info>

=item C<< vserver >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <vserver>$value</vserver>
 </certificate-ca-issued-info>

=item C<< status >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <status>$value</status>
 </certificate-ca-issued-info>

=item C<< ca >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <certificate-authority>$value</certificate-authority>
 </certificate-ca-issued-info>

=item C<< state >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <state>$value</state>
 </certificate-ca-issued-info>

=item C<< locality >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <locality>$value</locality>
 </certificate-ca-issued-info>

=item C<< revocation >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <revocation-date>$value</revocation-date>
 </certificate-ca-issued-info>

=item C<< common_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <common_name>$value</common_name>
 </certificate-ca-issued-info>

=item C<< unit >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <organization-unit>$value</organization-unit>
 </certificate-ca-issued-info>

=item C<< expiration >>

Filled in for CMode CLI/ZAPI.
Maps to 'expiration-date' for ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <expiration-date>$value</expiration-date>
 </certificate-ca-issued-info>

=item C<< organization >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <certificate-ca-issued-info>
    <organization>$value</organization>
 </certificate-ca-issued-info>

=back

=cut

package NACL::CS::SecurityCertificateCaIssued;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'country',
    scalar => 'ca_serial',
    scalar => 'email_addr',
    scalar => 'serial',
    scalar => 'vserver',
    scalar => 'status',
    scalar => 'ca',
    scalar => 'state',
    scalar => 'locality',
    scalar => 'revocation',
    scalar => 'common_name',
    scalar => 'unit',
    scalar => 'expiration',
    scalar => 'organization',
];

=head1 METHODS

=head2 fetch

    my $SecurityCertificateCaIssued_state  = NACL::CS::SecurityCertificateCaIssued->fetch(command_interface => $ci, ...);
	my @SecurityCertificateCaIssued_states = NACL::CS::SecurityCertificateCaIssued->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI APIset.

Invokes "security-certificate-ca-issued-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'security certificate ca-issued show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        exception_text =>
            'No matching security certificate ca-issued(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'security_certificate_ca_issued_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'security_certificate_ca_issued_get_iter',
        copy => [
            qw (vserver common-name country email-addr
                locality organization state status
                )
        ],
        map => {
            'ca'         => 'certificate-authority',
            'ca_serial'  => 'ca-serial-number',
            'revocation' => 'revocation-date',
            'expiration' => 'expiration-date',
            'unit'       => 'organization-unit',
            'serial'     => 'serial-number',
        },
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
