# $Id: //depot/prod/test/main/lib/NACL/CS/SmtapeRestoreGetImageHeader.pm#1 $

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method
##   NACL::C::Smtape->restore_get_image_header()
## @author dl-dpg-nb-automation; dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SmtapeRestoreGetImageHeader

=head1 DESCRIPTION

C<NACL::CS::SmtapeRestoreGetImageHeader> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::Smtape->restore_get_image_header() is invoked.

(This module does not represent the state of any element, but is an object
repesentation of the output obtained when the Smtape Restore is queried
for backup image header.)

=head1 ATTRIBUTES

The individual pieces of data that are part of the parsed output of
'smtape restore -h' are the attributes of the SmtapeRestoreGetImageHeader
ComponentState object.

=over

=item C<< image_header >>

Tape device for which image header will be retrieved.

=back

=cut

package NACL::CS::SmtapeRestoreGetImageHeader;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'is_sis_volume',
    scalar => 'volume_type',
    scalar => 'backup_sequence_no',
    scalar => 'time_of_previous_backup',
    scalar => 'volume_attrbutes',
    scalar => 'tape_number',
    scalar => 'source_filer',
    scalar => 'volume_used_inodes',
    scalar => 'backup_version',
    scalar => 'source_volume',
    scalar => 'time_of_backup',
    scalar => 'source_snapshot',
    scalar => 'backup_set_id',
    scalar => 'backup_mode',
    scalar => 'wafl_version',
    scalar => 'source_volume_used_size',
    scalar => 'source_volume_capacity',
    scalar => 'volume_total_inodes',
    scalar => 'is_aggregate',
    scalar => 'baremetal_version',
    scalar => 'snapshots',
    scalar => 'number_of_snapshots',
];

1;
