# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Statistics2CatalogCounter ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::Statistics2CatalogCounter

=head1 DESCRIPTION

C<NACL::CS::Statistics2CatalogCounter> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP Statistics2CatalogCounter.  A related class is
L<NACL::C::Statistics2CatalogCounter|lib-NACL-C-Statistics2CatalogCounter-pm>, which represents access
to an ONTAP Statistics2CatalogCounter.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Statistics2CatalogCounter
element are the attributes of the Statistics2CatalogCounter ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< object >>

Filled in for CMode CLI.

=item C<< size >>

Filled in for CMode CLI.

=item C<< desc >>

Filled in for CMode CLI.

=item C<< aggregation_style >>

Filled in for CMode CLI.

=item C<< base_counter >>

Filled in for CMode CLI.

=item C<< filter_data >>

Filled in for CMode CLI.

=item C<< is_key >>

Filled in for CMode CLI.

=item C<< objectName >>

Filled in for CMode CLI.

=item C<< name >>

Filled in for CMode CLI.

=item C<< instance >>

Filled in for CMode CLI.

=item C<< description >>

Filled in for CMode CLI.

=item C<< properties >>

Filled in for CMode CLI.

=item C<< translation_input_counter >>

Filled in for CMode CLI.

=item C<< unit >>

Filled in for CMode CLI.

=item C<< privilege_level >>

Filled in for CMode CLI.

=item C<< privilegeLevel >>

Filled in for CMode CLI.

=item C<< label >>

Filled in for CMode CLI.
(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $label = $obj->label();
# $label contains a reference to the array of values
my @label = $obj->label();
# @label contains the array of values

Filled in for CMode CLI.

=item C<< type >>

Filled in for CMode CLI.

=item C<< counter >>

Filled in for CMode CLI.

=item C<< filter >>

Filled in for CMode CLI.


=item C<< objectname >>

Filled in for CMode CLI.

=item C<< privilege >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::Statistics2CatalogCounter;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'object',
    scalar => 'size',
    scalar => 'desc',
    scalar => 'aggregation_style',
    scalar => 'base_counter',
    scalar => 'filter_data',
    scalar => 'is_key',
    scalar => 'objectName',
    scalar => 'name',
    scalar => 'instance',
    scalar => 'description',
    scalar => 'properties',
    scalar => 'translation_input_counter',
    scalar => 'unit',
    scalar => 'privilege_level',
    scalar => 'privilegeLevel',
    array  => 'label',
    scalar => 'type',
    scalar => 'counter',
    scalar => 'filter',
    scalar => 'objectname',
    scalar => 'privilege',
];

=head1 METHODS

=head2 fetch

    my $Statistics2CatalogCounter_state  = NACL::CS::Statistics2CatalogCounter->fetch(command_interface => $ci, ...);
	my @Statistics2CatalogCounter_states = NACL::CS::Statistics2CatalogCounter->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'statistics2 catalog counter show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching statistics2 catalog counter(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli( @_,
        api => 'statistics2_catalog_counter_show', );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
