# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Statistics2Samples ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::Statistics2Samples

=head1 DESCRIPTION

C<NACL::CS::Statistics2Samples> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP Statistics2Samples.  A related class is
L<NACL::C::Statistics2Samples|lib-NACL-C-Statistics2Samples-pm>, which represents access
to an ONTAP Statistics2Samples.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the Statistics2Samples
element are the attributes of the Statistics2Samples ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< stop_time >>

Filled in for CMode CLI.

=item C<< start_time >>

Filled in for CMode CLI.

=item C<< object >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $object = $obj->object();
# $object contains a reference to the array of values
my @object = $obj->object();
# @object contains the array of values

Filled in for CMode CLI.

=item C<< name >>

Filled in for CMode CLI.

=item C<< counter >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $counter = $obj->counter();
# $counter contains a reference to the array of values
my @counter = $obj->counter();
# @counter contains the array of values

Filled in for CMode CLI.

=item C<< instance >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $instance = $obj->instance();
# $instance contains a reference to the array of values
my @instance = $obj->instance();
# @instance contains the array of values

Filled in for CMode CLI.

=item C<< sample_id >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::Statistics2Samples;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'stop_time',
    scalar => 'start_time',
    array  => 'object',
    scalar => 'name',
    array  => 'counter',
    array  => 'instance',
    scalar => 'sample_id',
];

=head1 METHODS

=head2 fetch

    my $Statistics2Samples_state  = NACL::CS::Statistics2Samples->fetch(command_interface => $ci, ...);
	my @Statistics2Samples_states = NACL::CS::Statistics2Samples->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'statistics2 samples show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching statistics2 samples(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli( @_,
        api => 'statistics2_samples_show', );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
