#
# Copyright (c) 2011-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsAggregate ComponentState Module
## @author lmurthy@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsAggregate

=head1 DESCRIPTION

C<NACL::CS::StatisticsAggregate> is a derived class of
L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>. It represents the
state of an ONTAP StatisticsAggregate.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StatisticsAggregate
element are the attributes of the StatisticsAggregate ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

Being a sub-class of L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>,
all of the attributes listed under _StatisticsBase are applicable to this CS
package as well. The extra attributes applicable to this CS package are listed below.

=over

=item C<< "aggregate" >>

Display statistics for specific aggregate instance.

Filled in for CMode CLI.

=item C<< "node" >>

Display statistics for aggregate on specified node.

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsAggregate;

use base qw(NACL::CS::_StatisticsBase);

use Class::MethodMaker [
    scalar  => 'aggregate',
    scalar  => 'node',
];

__PACKAGE__->_build_fetch_methods('statistics aggregate show');

1;
