# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsArchive ComponentState Module (auto-generated by CGT)
## @author Akshay Mohit(makshay@netapp.com), dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsArchive

=head1 DESCRIPTION

C<NACL::CS::StatisticsArchive> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StatisticsArchive.  A related class is
L<NACL::C::StatisticsArchive|lib-NACL-C-StatisticsArchive-pm>, which represents access
to an ONTAP StatisticsArchive.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StatisticsArchive
element are the attributes of the StatisticsArchive ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< source_nodes >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $source_nodes = $obj->source_nodes();
# $source_nodes contains a reference to the array of values
my @source_nodes = $obj->source_nodes();
# @source_nodes contains the array of values

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <source-nodes>
        <node-name>@value</node-name>
    </source-nodes>
 </perf-archive-info>

=item C<< version >>

Filled in for CMode CLI.

=item C<< end_time >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <end-time>$value</end-time>
 </perf-archive-info>


=item C<< case_number >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <case-number>$value</case-number>
 </perf-archive-info>

=item C<< name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <name>$value</name>
 </perf-archive-info>

=item C<< path >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $path = $obj->path();
# $path contains a reference to the array of values
my @path = $obj->path();
# @path contains the array of values

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <path>
        <string>@value</string>
    </path>
 </perf-archive-info>

=item C<< uuid >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <uuid>$value</uuid>
 </perf-archive-info>

=item C<< state >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <state>$value</state>
 </perf-archive-info>

=item C<< size >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <size>$value</size>
 </perf-archive-info>

=item C<< upload_uri >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <upload-uri>$value</upload-uri>
 </perf-archive-info>

=item C<< start_time >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <start-time>$value</start-time>
 </perf-archive-info>

=item C<< comment >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <comment>$value</comment>
 </perf-archive-info>

=item C<< new_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <new-name>$value</new-name>
 </perf-archive-info>

=item C<< host_node >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <host-node>$value</host-node>
 </perf-archive-info>

=item C<< archive >>

*Performance Archive Name

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

For "requested_fields", "filter" and Output mapping:

 <perf-archive-info>
    <archive>$value</archive>
 </perf-archive-info>

=item C<< failed_nodes >>

*Source Nodes which Failed to Provide Data

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $failed_nodes = $obj->failed_nodes();
# $failed_nodes contains a reference to the array of values
my @failed_nodes = $obj->failed_nodes();
# @failed_nodes contains the array of values
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref
# filter => { failed_nodes = [ value1, value2...] }

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsArchive;

use strict;
use warnings;
use Params::Validate qw(validate SCALAR validate_with);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'source_nodes',
    scalar => 'version',
    scalar => 'end_time',
    scalar => 'case_number',
    scalar => 'name',
    array  => 'path',
    scalar => 'uuid',
    scalar => 'state',
    scalar => 'size',
    scalar => 'upload_uri',
    scalar => 'start_time',
    scalar => 'comment',
    scalar => 'new_name',
    scalar => 'host_node',
    scalar => 'archive',
    scalar => 'node_name',
    array  => 'failed_nodes',
];

=head1 METHODS

=head2 fetch

    my $StatisticsArchive_state  = NACL::CS::StatisticsArchive->fetch(command_interface => $ci, ...);
	my @StatisticsArchive_states = NACL::CS::StatisticsArchive->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI APISet.

Invokes "perf_archive_get_iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        exception_text => 'No matching statistics archive(s) found',
        show_cmd       => 'statistics archive show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@_, api => 'statistics_archive_show',
        );
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'perf_archive_get_iter',
        copy => [
            qw( end-time case-number name upload-uri start-time comment
                node-name host-node archive state uuid size)
        ],
        map => {
            'source-nodes' => [
                make_zapi_array('source-nodes'), make_zapi_skip('node-name')
            ],
            'path' => [make_zapi_array('path'), make_zapi_skip('string')],
        }
    );

    # For end-time and start-time, CLI understands the unix time
    # returned by ZAPI. Also ZAPI understands the CLI format. So no additional
    # processing of values is not needed in both input and output side.

    foreach my $obj (@state_objs) {
        if ($obj->state_isset) {
            my $val = $obj->state;

            # Normalize the values to look like CM CLI
            $val =~ s/_/-/g;
            $obj->state($val);
        }

    }
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
