#
# Copyright (c) 2011-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsCacheFlashPool ComponentState Module
## @author lmurthy@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsCacheFlashPool

=head1 DESCRIPTION

C<NACL::CS::StatisticsCacheFlashPool> is a derived class of
L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>. It represents the
state of an ONTAP StatisticsCacheFlashPool.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StatisticsCacheFlashPool
element are the attributes of the StatisticsCacheFlashPool ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

Being a sub-class of L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>,
all of the attributes listed under _StatisticsBase are applicable to this CS
package as well. The extra attributes applicable to this CS package are listed below.

=over

=item C<< "aggregate" >>

Display statistics for cache flash-pool on specified aggregate.

=item C<< "volume" >>

Display statistics for cache flash-pool on specified volume.

Filled in for CMode CLI.

=item C<< "vserver" >>

Display statistics for cache flash-pool in specified vserver.

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsCacheFlashPool;

use base qw(NACL::CS::_StatisticsBase);

use Class::MethodMaker [
    scalar  => 'aggregate',
    scalar  => 'volume',
    scalar  => 'vserver',
];

__PACKAGE__->_build_fetch_methods('statistics cache flash-pool show');

1;
