#
# Copyright (c) 2011-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsLun ComponentState Module
## @author lmurthy@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsLun

=head1 DESCRIPTION

C<NACL::CS::StatisticsLun> is a derived class of
L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>. It represents the
state of an ONTAP StatisticsLun.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StatisticsLun
element are the attributes of the StatisticsLun ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

Being a sub-class of L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>,
all of the attributes listed under _StatisticsBase are applicable to this CS
package as well. The extra attributes applicable to this CS package are listed below.

=over

=item C<< "lun" >>

Display statistics for specific lun.

=item C<< "vserver" >>

Display statistics for lun on specificied vserver.

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsLun;

use base qw(NACL::CS::_StatisticsBase);

use Class::MethodMaker [
    scalar  => 'lun',
    scalar  => 'vserver',
];

__PACKAGE__->_build_fetch_methods('statistics lun show');

1;
