# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::StatisticsRdbTransactions->show_details() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsRdbTransactionsShowDetails

=head1 DESCRIPTION

C<NACL::CS::StatisticsRdbTransactionsShowDetails> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::StatisticsRdbTransactions->show_details() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::StatisticsRdbTransactions->show_details() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< held >>

Filled in for CMode CLI.

=item C<< originator >>

Filled in for CMode CLI.

=item C<< seqnum >>

Filled in for CMode CLI.

=item C<< ring >>

Filled in for CMode CLI.

=item C<< lifetime >>

Filled in for CMode CLI.

=item C<< reporter >>

Filled in for CMode CLI.

=item C<< tid >>

Filled in for CMode CLI.

=item C<< created >>

Filled in for CMode CLI.

=item C<< acquire >>

Filled in for CMode CLI.

=item C<< global_commit >>

Filled in for CMode CLI.

=item C<< commits >>

Filled in for CMode CLI.
(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $commits = $obj->commits();
# $commits contains a reference to the array of values
my @commits = $obj->commits();
# @commits contains the array of values

Filled in for CMode CLI.

=item C<< timestamp >>

Filled in for CMode CLI.

=item C<< nodes >>

Filled in for CMode CLI.
(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $nodes = $obj->nodes();
# $nodes contains a reference to the array of values
my @nodes = $obj->nodes();
# @nodes contains the array of values

Filled in for CMode CLI.

=item C<< label >>

Filled in for CMode CLI.

=item C<< result >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsRdbTransactionsShowDetails;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'held',
    scalar => 'originator',
    scalar => 'seqnum',
    scalar => 'ring',
    scalar => 'lifetime',
    scalar => 'reporter',
    scalar => 'tid',
    scalar => 'created',
    scalar => 'acquire',
    scalar => 'global_commit',
    array  => 'commits',
    scalar => 'timestamp',
    array  => 'nodes',
    scalar => 'label',
    scalar => 'result',
];

=head1 METHODS

=head2 fetch

    my $StatisticsRdbTransactionsShowDetails_state  = NACL::CS::StatisticsRdbTransactionsShowDetails->fetch(command_interface => $ci, ...);
	my @StatisticsRdbTransactionsShowDetails_states = NACL::CS::StatisticsRdbTransactionsShowDetails->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'statistics rdb transactions show-details',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching statistics rdb transactions(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'statistics_rdb_transactions_show_details',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
