#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsSettings ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsSettings

=head1 DESCRIPTION

C<NACL::CS::StatisticsSettings> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StatisticsSettings.  A related class is
L<NACL::C::StatisticsSettings|lib-NACL-C-StatisticsSettings-pm>, which represents access
to an ONTAP StatisticsSettings.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the StatisticsSettings
element are the attributes of the StatisticsSettings ComponentState.

=over

=item C<< "max_clients_to_view" >>

Filled in for CMode CLI.

=item C<< "display_rates" >>

Filled in for CMode CLI.

=item C<< "max_clients_to_collect" >>

Filled in for CMode CLI.

=item C<< "client_stats" >>

Filled in for CMode CLI.

=item C<< "update_delta_base" >>

Filled in for CMode CLI.

=item C<< counter_display >>

Filled in for CMode CLI.

=item C<< display_count_exponent >>

Display Count Exponent ranges from 1 to 10

Filled in for CMode CLI.

=item C<< counter_display_units >>

Counter Display Units possible value(s) are, Counter Units B,KB,MB,GB

Filled in for CMode CLI.


=back

=cut

package NACL::CS::StatisticsSettings;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'max_clients_to_view',
    scalar => 'display_rates',
    scalar => 'max_clients_to_collect',
    scalar => 'client_stats',
    scalar => 'update_delta_base',
    scalar => 'counter_display',
    scalar => 'display_count_exponent',
    scalar => 'counter_display_units',
];

=head1 METHODS

=head2 fetch

    my $StatisticsSettings_state   = NACL::CS::StatisticsSettings->fetch(command_interface => $ci, ...);
	my @StatisticsSettings_states = NACL::CS::StatisticsSettings->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'statistics settings show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching statistics settings(s) found',
        is_singleton   => 1
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api          => 'statistics_settings_show',
        is_singleton => 1
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
