#
# Copyright (c) 2011-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StatisticsWorkload ComponentState Module
## @author lmurthy@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StatisticsWorkload

=head1 DESCRIPTION

C<NACL::CS::StatisticsWorkload> is a derived class of
L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>. It represents the
state of an ONTAP StatisticsWorkload.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StatisticsWorkload
element are the attributes of the StatisticsWorkload ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

Being a sub-class of L<NACL::CS::_StatisticsBase|lib-NACL-CS-_StatisticsBase-pm>,
all of the attributes listed under _StatisticsBase are applicable to this CS
package as well. The extra attributes applicable to this CS package are listed below.

=over

=item C<< "workload" >>

Display statistics for specific workload.

Filled in for CMode CLI.

=back

=cut

package NACL::CS::StatisticsWorkload;

use base qw(NACL::CS::_StatisticsBase);

use Class::MethodMaker [
    scalar  => 'workload',
];

__PACKAGE__->_build_fetch_methods('statistics workload show');

1;
