# $Id: //depot/prod/test/nacldev/lib/NACL/CS/StorageFailoverInternalOptions.pm# $

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageFailoverInternalOptions ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageFailoverInternalOptions

=head1 DESCRIPTION

C<NACL::CS::StorageFailoverInternalOptions> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageFailoverInternalOptions.  A related class is
L<NACL::C::StorageFailoverInternalOptions|lib-NACL-C-StorageFailoverInternalOptions-pm>, which represents access
to an ONTAP StorageFailoverInternalOptions.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StorageFailoverInternalOptions
element are the attributes of the StorageFailoverInternalOptions ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< check_partner >>

Filled in for CMode CLI.

=item C<< auto_giveback >>

Filled in for CMode CLI.

=item C<< hwassist >>

Filled in for CMode CLI.

=item C<< short_uptime >>

Filled in for CMode CLI.

=item C<< failover_when_cluster_ports_down >>

Filled in for CMode CLI.

=item C<< hwassist_partner_port >>

Filled in for CMode CLI.

=item C<< onreboot >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< hwassist_health_check_interval >>

Filled in for CMode CLI.

=item C<< delay_seconds >>

Filled in for CMode CLI.

=item C<< propagate >>

Filled in for CMode CLI.

=item C<< cluster_ports_down_interval >>

Filled in for CMode CLI.

=item C<< hwassist_partner_ip >>

Filled in for CMode CLI.

=item C<< auto_sendhome >>

Filled in for CMode CLI.

=item C<< detection_time >>

Filled in for CMode CLI.

=item C<< attempts_time >>

Filled in for CMode CLI.

=item C<< onfailure >>

Filled in for CMode CLI.

=item C<< attempts >>

Filled in for CMode CLI.

=item C<< onshort_uptime >>

Filled in for CMode CLI.

=item C<< onpanic >>

Filled in for CMode CLI.

=item C<< read_interval >>

Filled in for CMode CLI.

=item C<< write_interval >>

Filled in for CMode CLI.

=item C<< hwassist_retry_count >>

Filled in for CMode CLI.

=item C<< mode >>

Filled in for CMode CLI.


=item C<< bypass_takeover_optimization >>

*Bypass Takeover Optimization Enabled, possible value(s) are true,false
Filled in for CMode CLI.


=back

=cut

package NACL::CS::StorageFailoverInternalOptions;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::ComponentUtils qw (Dumper);
use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'check_partner',
    scalar => 'auto_giveback',
    scalar => 'hwassist',
    scalar => 'short_uptime',
    scalar => 'failover_when_cluster_ports_down',
    scalar => 'hwassist_partner_port',
    scalar => 'onreboot',
    scalar => 'node',
    scalar => 'hwassist_health_check_interval',
    scalar => 'delay_seconds',
    scalar => 'propagate',
    scalar => 'cluster_ports_down_interval',
    scalar => 'hwassist_partner_ip',
    scalar => 'auto_sendhome',
    scalar => 'detection_time',
    scalar => 'attempts_time',
    scalar => 'onfailure',
    scalar => 'attempts',
    scalar => 'onshort_uptime',
    scalar => 'onpanic',
    scalar => 'read_interval',
    scalar => 'write_interval',
    scalar => 'hwassist_retry_count',
    scalar => 'mode',
    scalar => 'bypass_takeover_optimization',
];

=head1 METHODS

=head2 fetch

    my $StorageFailoverInternalOptions_state  = NACL::CS::StorageFailoverInternalOptions->fetch(command_interface => $ci, ...);
    my @StorageFailoverInternalOptions_states = NACL::CS::StorageFailoverInternalOptions->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet or 7Mode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'storage failover internal-options show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_7mode_cli',
                interface => 'CLI',
                set       => '7Mode'
            }
        ],
        exception_text =>
            'No matching storage failover internal options(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'storage_failover_internal_options_show');
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_7mode_cli {
    my $pkg    = shift;
    my %opts   = validate @_, $pkg->_fetch_backend_validate_spec();
    my $apiset = delete $opts{apiset};
    my $filter = delete $opts{filter};

    my @state_objs;
    my $response = $apiset->options("show-options" => 'cf');
    my $output   = $response->get_parsed_output();
    my $Node     = $opts{command_interface}->node();
    foreach my $row (@$output) {
        my $obj = $pkg->new(node => $Node);
        my $row_modified;
        $row_modified = $pkg->_hash_copy(
            source => $row,
            map    => {
                'cf.giveback.auto.enable'       => 'auto-giveback',
                'cf.giveback.check.partner'     => 'check-partner',
                'cf.takeover.detection.seconds' => 'detection-time',
                'cf.takeover.on_failure'        => 'onfailure',
                'cf.takeover.on_panic'          => 'onpanic',
                'cf.takeover.on_reboot'         => 'onreboot',
                'cf.hw_assist.enable'           => 'hwassist',
                'cf.hw_assist.partner.address'  => 'hwassist-partner-ip',
                'cf.hw_assist.partner.port'     => 'hwassist-partner-port',
            },
        );
        $$row_modified{'command_interface'} = $opts{'command_interface'};
        $obj->_set_fields(row => $row_modified);
        push @state_objs, $obj;
    } ## end foreach my $row (@$output)
    return @state_objs;
}
1;
