# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary StorageTape ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageTape

=head1 DESCRIPTION

C<NACL::CS::StorageTape> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP StorageTape.  A related class is
L<NACL::C::StorageTape|lib::NACL-C-StorageTape-pm>, which represents access
to an ONTAP StorageTape.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the StorageTape
element are the attributes of the StorageTape ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< file_number >>

File Number

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info file-number="$value" />



=item C<< device_name_r >>

Device Name for Rewind
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $device_name_r = $obj->device_name_r();
 
# $device_name_r contains a reference to the array of values
 
my @device_name_r = $obj->device_name_r();
 
# @device_name_r contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { device_name_r = [ value1, value2...] }


Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info>
  <device-names name="device-name-density" device-name-rewind="@values" />
</tape-mc-info>



=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info node-name="$value" />



=item C<< device_id >>

Device ID

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info device-id="$value" />



=item C<< alias_mapping >>

Alias Mapping

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info alias-mapping="$value" />



=item C<< functional_status >>

Functional Status possible value(s) are, unknown,normal,error

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info functional-status="$value" />



=item C<< device_name_nr >>

Device Name for No Rewind
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $device_name_nr = $obj->device_name_nr();
 
# $device_name_nr contains a reference to the array of values
 
my @device_name_nr = $obj->device_name_nr();
 
# @device_name_nr contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { device_name_nr = [ value1, value2...] }


Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info>
  <device-names name="device-name-density" device-name-no-rewind="@values" />
</tape-mc-info>



=item C<< error >>

Tape Error

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info error="$value" />



=item C<< device_state >>


Operational State of Device possible value(s) are, unknown,available,ready-write-enabled,ready-write-protected,offline,in-use,error,reserved-by-another-host,normal

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info device-state="$value" />



=item C<< serial_number >>

Serial Number

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info serial-number="$value" />



=item C<< residual_count >>

Residual Count of Last I/O Operation

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info residual-count="$value" />



=item C<< wwpn >>

World Wide Port Name

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info wwpn="$value" />



=item C<< resv_type >>


Reservation Type for device possible value(s) are, unknown,tape-drive,media-changer,persistent,scsi,off

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info resv-type="$value" />



=item C<< device_if_type >>


Device Interface Type possible value(s) are, unknown,fibre-channel,SAS,pSCSI

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info device-if-type="$value" />



=item C<< description >>

Description

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info description="$value" />



=item C<< initiator >>

Initiator Port

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info initiator="$value" />



=item C<< device_name_ur >>

Device Name for Unload Reload
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $device_name_ur = $obj->device_name_ur();
 
# $device_name_ur contains a reference to the array of values
 
my @device_name_ur = $obj->device_name_ur();
 
# @device_name_ur contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { device_name_ur = [ value1, value2...] }


Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info>
  <device-names name="device-name-density" device-name-unload-reload="@values" />
</tape-mc-info>



=item C<< block_number >>

Block Number

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info block-number="$value" />



=item C<< format >>

Tape Cartridge Format
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $format = $obj->format();
 
# $format contains a reference to the array of values
 
my @format = $obj->format();
 
# @format contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { format = [ value1, value2...] }


Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info>
  <density-formats name="device-density-format" device-format="@values" />
</tape-mc-info>



=item C<< alias_name >>

Alias Name

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info alias-name="$value" />



=item C<< wwnn >>

World Wide Node Name

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info wwnn="$value" />



=item C<< device_type >>

Device Type

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<tape-mc-info device-type="$value" />



=back

=cut

package NACL::CS::StorageTape;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'file_number',
    array  => 'device_name_r',
    scalar => 'node',
    scalar => 'device_id',
    scalar => 'alias_mapping',
    scalar => 'functional_status',
    array  => 'device_name_nr',
    scalar => 'error',
    scalar => 'device_state',
    scalar => 'serial_number',
    scalar => 'residual_count',
    scalar => 'wwpn',
    scalar => 'resv_type',
    scalar => 'device_if_type',
    scalar => 'description',
    scalar => 'initiator',
    array  => 'device_name_ur',
    scalar => 'block_number',
    array  => 'format',
    scalar => 'alias_name',
    scalar => 'wwnn',
    scalar => 'device_type',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $StorageTape_state  = NACL::CS::StorageTape->fetch(command_interface => $ci, ...);
	my @StorageTape_states = NACL::CS::StorageTape->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes tape-mc-get-iter API for CMode ZAPI.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
	show_cmd       => 'storage tape show',
        exception_text => 'No matching storage tape(s) found',
        frontend       => 'NACL::CS::StorageTape::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@args, api => 'storage_tape_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(file-number alias-mapping device-id functional-status error device-state
                serial-number residual-count wwpn resv-type device-if-type description
                initiator block-number wwnn alias-name device-type
                )
        ],
        map => {
            'device-name-r' => [
                make_zapi_array('device-names'),
                make_zapi_skip('device-name-density'),
            ],
            'node'           => 'node-name',
            'device-name-nr' => [
                make_zapi_array('device-names'),
                make_zapi_skip('device-name-density'),
            ],
            'device-name-ur' => [
                make_zapi_array('device-names'),
                make_zapi_skip('device-name-density'),
            ],
            'format' => [
                make_zapi_array('density-formats'),
                make_zapi_skip('device-density-format'),
            ],
        },
        api => "tape-mc-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
