# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::StorageTape->show_all() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::StorageTapeShowAll

=head1 DESCRIPTION

C<NACL::CS::StorageTapeShowAll> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::StorageTape->show_all() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::StorageTape->show_all() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< device_name_r >>

Device Name for Rewind
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $device_name_r = $obj->device_name_r();
 
# $device_name_r contains a reference to the array of values
 
my @device_name_r = $obj->device_name_r();
 
# @device_name_r contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { device_name_r = [ value1, value2...] }

Filled in for CMode CLI

=item C<< file_number >>

File Number

Filled in for CMode CLI

=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI

=item C<< alias_mapping >>

Alias Mapping

Filled in for CMode CLI

=item C<< device_id >>

Device ID

Filled in for CMode CLI

=item C<< functional_status >>

Functional Status possible value(s) are, unknown,normal,error

Filled in for CMode CLI

=item C<< device_name_nr >>

Device Name for No Rewind
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $device_name_nr = $obj->device_name_nr();
 
# $device_name_nr contains a reference to the array of values
 
my @device_name_nr = $obj->device_name_nr();
 
# @device_name_nr contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { device_name_nr = [ value1, value2...] }

Filled in for CMode CLI

=item C<< error >>

Tape Error

Filled in for CMode CLI

=item C<< device_state >>


Operational State of Device possible value(s) are, unknown,available,ready-write-enabled,ready-write-protected,offline,in-use,error,reserved-by-another-host,normal

Filled in for CMode CLI

=item C<< serial_number >>

Serial Number

Filled in for CMode CLI

=item C<< residual_count >>

Residual Count of Last I/O Operation

Filled in for CMode CLI

=item C<< wwpn >>

World Wide Port Name

Filled in for CMode CLI

=item C<< resv_type >>


Reservation Type for device possible value(s) are, unknown,tape-drive,media-changer,persistent,scsi,off

Filled in for CMode CLI

=item C<< description >>

Description

Filled in for CMode CLI

=item C<< device_if_type >>


Device Interface Type possible value(s) are, unknown,fibre-channel,SAS,pSCSI

Filled in for CMode CLI

=item C<< initiator >>

Initiator Port

Filled in for CMode CLI

=item C<< device_name_ur >>

Device Name for Unload Reload
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $device_name_ur = $obj->device_name_ur();
 
# $device_name_ur contains a reference to the array of values
 
my @device_name_ur = $obj->device_name_ur();
 
# @device_name_ur contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { device_name_ur = [ value1, value2...] }

Filled in for CMode CLI

=item C<< block_number >>

Block Number

Filled in for CMode CLI

=item C<< alias_name >>

Alias Name

Filled in for CMode CLI

=item C<< format >>

Tape Cartridge Format
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $format = $obj->format();
 
# $format contains a reference to the array of values
 
my @format = $obj->format();
 
# @format contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { format = [ value1, value2...] }

Filled in for CMode CLI

=item C<< wwnn >>

World Wide Node Name

Filled in for CMode CLI

=item C<< device_type >>

Device Type

Filled in for CMode CLI

=back

=cut

package NACL::CS::StorageTapeShowAll;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'device_name_r',
    scalar => 'file_number',
    scalar => 'node',
    scalar => 'alias_mapping',
    scalar => 'device_id',
    scalar => 'functional_status',
    array  => 'device_name_nr',
    scalar => 'error',
    scalar => 'device_state',
    scalar => 'serial_number',
    scalar => 'residual_count',
    scalar => 'wwpn',
    scalar => 'resv_type',
    scalar => 'description',
    scalar => 'device_if_type',
    scalar => 'initiator',
    array  => 'device_name_ur',
    scalar => 'block_number',
    scalar => 'alias_name',
    array  => 'format',
    scalar => 'wwnn',
    scalar => 'device_type',
];

=head1 METHODS

=head2 fetch

    my $StorageTapeShowAll_state  = NACL::CS::StorageTapeShowAll->fetch(command_interface => $ci, ...);
	my @StorageTapeShowAll_states = NACL::CS::StorageTapeShowAll->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'storage tape show-all',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
	show_cmd       => 'storage tape show-all',
        exception_text => 'No matching storage tape(s) found',
        frontend       => 'NACL::CS::StorageTapeShowAll::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'storage_tape_show_all',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
