#
# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::SystemFeatureUsage->show_summary() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemFeatureUsageShowSummary

=head1 DESCRIPTION

C<NACL::CS::SystemFeatureUsageShowSummary> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::SystemFeatureUsage->show_summary() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::SystemFeatureUsage->show_summary() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< owner >>

Owner

Filled in for CMode CLI/ZAPI

=item C<< serial_number >>

Node Serial Number

Filled in for CMode CLI/ZAPI

=item C<< feature_name >>

Feature Name

Filled in for CMode CLI/ZAPI

=item C<< weeks_not_available >>

Weeks Data Not Available ranges from 0 to 2147483647

Filled in for CMode CLI/ZAPI

=item C<< weeks_in_use >>

Weeks In-Use ranges from 0 to 2147483647

Filled in for CMode CLI/ZAPI

=item C<< weeks_configured >>

Weeks Configured ranges from 0 to 2147483647

Filled in for CMode CLI/ZAPI

=item C<< weeks_not_used >>

Weeks Not Used ranges from 0 to 2147483647

Filled in for CMode CLI/ZAPI

=item C<< last_used >>

Date last used

Filled in for CMode CLI/ZAPI

Maps to:

CM ZAPI:

<feature-usage-summary-get-iter>
 <last-used-time>$value</last-used-time?
</feature-usage-summary-get-iter>

=back

=cut

package NACL::CS::SystemFeatureUsageShowSummary;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'owner',
    scalar => 'serial_number',
    scalar => 'feature_name',
    scalar => 'weeks_not_available',
    scalar => 'weeks_in_use',
    scalar => 'weeks_configured',
    scalar => 'weeks_not_used',
    scalar => 'last_used',
];

=head1 METHODS

=head2 fetch

    my $SystemFeatureUsageShowSummary_state  = NACL::CS::SystemFeatureUsageShowSummary->fetch(command_interface => $ci, ...);
    my @SystemFeatureUsageShowSummary_states = NACL::CS::SystemFeatureUsageShowSummary->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI

Invokes API "feature-usage-summary-get-iter" for ZAPI

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        show_cmd => 'system feature-usage show-summary',
	exception_text => 'No matching system feature-usage(s) found',
        frontend       => 'NACL::CS::SystemFeatureUsageShowSummary::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'system_feature_usage_show_summary',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @opts,
        api  => 'feature-usage-summary-get-iter',
        copy => [
            qw(feature-name owner serial-number weeks-configured
                weeks-in-use weeks-not-available weeks-not-used)
        ],
        map => {'last-used' => 'last-used-time',},
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
