# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthAutosupportTriggerHistory ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthAutosupportTriggerHistory

=head1 DESCRIPTION

C<NACL::CS::SystemHealthAutosupportTriggerHistory> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemHealthAutosupportTriggerHistory.  A related class is
L<NACL::C::SystemHealthAutosupportTriggerHistory|lib-NACL-C-SystemHealthAutosupportTriggerHistory-pm>, which represents access
to an ONTAP SystemHealthAutosupportTriggerHistory.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemHealthAutosupportTriggerHistory
element are the attributes of the SystemHealthAutosupportTriggerHistory ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< alert_id >>

Filled in for CMode CLI.

=item C<< perceived_severity >>

Filled in for CMode CLI.

=item C<< monitor >>

Filled in for CMode CLI.

=item C<< subsystem >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< indication_time >>

Filled in for CMode CLI.

=item C<< autosupport_triggered >>

Filled in for CMode CLI.

=item C<< corrective_actions >>

Filled in for CMode CLI.

=item C<< probable_cause >>

Filled in for CMode CLI.

=item C<< alerting_resource >>

Filled in for CMode CLI.

=item C<< recommended_actions >>

Filled in for CMode CLI.


=item C<< asup_enable >>

Enable asup for this alert, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< alert_clear_time >>

Alert Clear Time

Filled in for CMode CLI.


=back

=cut

package NACL::CS::SystemHealthAutosupportTriggerHistory;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'alert_id',
    scalar => 'perceived_severity',
    scalar => 'monitor',
    scalar => 'subsystem',
    scalar => 'node',
    scalar => 'indication_time',
    scalar => 'autosupport_triggered',
    scalar => 'corrective_actions',
    scalar => 'probable_cause',
    scalar => 'alerting_resource',
    scalar => 'recommended_actions',
    scalar => 'asup_enable',
    scalar => 'alert_clear_time',
];

=head1 METHODS

=head2 fetch

    my $SystemHealthAutosupportTriggerHistory_state  = NACL::CS::SystemHealthAutosupportTriggerHistory->fetch(command_interface => $ci, ...);
	my @SystemHealthAutosupportTriggerHistory_states = NACL::CS::SystemHealthAutosupportTriggerHistory->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI .

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system health autosupport trigger history show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching system health autosupport trigger history(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_health_autosupport_trigger_history_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
