# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthClusterSwitchInterface ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthClusterSwitchInterface

=head1 DESCRIPTION

C<NACL::CS::SystemHealthClusterSwitchInterface> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemHealthClusterSwitchInterface.  A related class is
L<NACL::C::SystemHealthClusterSwitchInterface|lib-NACL-C-SystemHealthClusterSwitchInterface-pm>, which represents access
to an ONTAP SystemHealthClusterSwitchInterface.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemHealthClusterSwitchInterface
element are the attributes of the SystemHealthClusterSwitchInterface ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< status >>

Port Config Status, possible value(s) are
Ok,Ok_with_suppressed,degraded,unreachable

Filled in for CMode CLI

=item C<< monitor >>

Health Monitor, possible value(s) are
node-connect,system-connect,system,controller,chassis,cluster-switch,example

Filled in for CMode CLI

=item C<< ifnum >>

Interface Number

Filled in for CMode CLI

=item C<< display_name >>

Interface Display Name

Filled in for CMode CLI

=item C<< is_isl >>

Isl Port, possible value(s) are yes,no

Filled in for CMode CLI

=item C<< speed >>

1,000,000 bits/sec

Filled in for CMode CLI

=item C<< inoctets >>

Input Octets

Filled in for CMode CLI

=item C<< adminstatus >>

Admin Status

Filled in for CMode CLI

=item C<< mtu >>

Mtu

Filled in for CMode CLI

=item C<< indiscards >>

Input Discards

Filled in for CMode CLI

=item C<< outerrors >>

Output Errors

Filled in for CMode CLI

=item C<< outdiscards >>

Output Discards

Filled in for CMode CLI

=item C<< operstatus >>

Operational Status

Filled in for CMode CLI

=item C<< device >>

Switch Name

Filled in for CMode CLI

=item C<< descr >>

Interface Name

Filled in for CMode CLI

=item C<< index >>

Interface Index

Filled in for CMode CLI

=item C<< inerrors >>

Input Errors

Filled in for CMode CLI

=item C<< unique_name >>

Interface Unique Name

Filled in for CMode CLI

=item C<< type >>

Interface Type

Filled in for CMode CLI

=item C<< outoctets >>

Output Octets

Filled in for CMode CLI

=item C<< duplexstatus >>

Duplex Settings

Filled in for CMode CLI

=item C<< node >>

Node

Filled in for CMode CLI.


=item C<< if_number >>

Interface Number

Filled in for CMode CLI.

=item C<< oper_state >>


Operational Status possible value(s) are, up,down,testing,unknown,dormant,not-present,lower-layer-down

Filled in for CMode CLI.

=item C<< duplex_type >>

Duplex Settings possible value(s) are, unknown,half-duplex,full-duplex

Filled in for CMode CLI.

=item C<< in_discards >>

Input Discards

Filled in for CMode CLI.

=item C<< out_discards >>

Output Discards

Filled in for CMode CLI.

=item C<< admin_state >>

Adminstrative Status possible value(s) are, up,down,testing

Filled in for CMode CLI.

=item C<< in_octets >>

Input Octets

Filled in for CMode CLI.

=item C<< out_octets >>

Output Octets

Filled in for CMode CLI.

=item C<< interface_name >>

Interface Name

Filled in for CMode CLI.

=item C<< out_errors >>

Output Errors

Filled in for CMode CLI.

=item C<< in_errors >>

Input Errors

Filled in for CMode CLI.


=item C<< interface_number >>

Interface Number

Filled in for CMode CLI.


=back

=cut

package NACL::CS::SystemHealthClusterSwitchInterface;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'status',
    scalar => 'monitor',
    scalar => 'ifnum',
    scalar => 'display_name',
    scalar => 'is_isl',
    scalar => 'speed',
    scalar => 'inoctets',
    scalar => 'adminstatus',
    scalar => 'mtu',
    scalar => 'indiscards',
    scalar => 'outerrors',
    scalar => 'outdiscards',
    scalar => 'operstatus',
    scalar => 'device',
    scalar => 'descr',
    scalar => 'index',
    scalar => 'inerrors',
    scalar => 'unique_name',
    scalar => 'type',
    scalar => 'outoctets',
    scalar => 'duplexstatus',
    scalar => 'node',
    scalar => 'if_number',
    scalar => 'oper_state',
    scalar => 'duplex_type',
    scalar => 'in_discards',
    scalar => 'out_discards',
    scalar => 'admin_state',
    scalar => 'in_octets',
    scalar => 'out_octets',
    scalar => 'interface_name',
    scalar => 'out_errors',
    scalar => 'in_errors',
    scalar => 'interface_number',
];

=head1 METHODS

=head2 fetch

    my $SystemHealthClusterSwitchInterface_state  = NACL::CS::SystemHealthClusterSwitchInterface->fetch(command_interface => $ci, ...);
	my @SystemHealthClusterSwitchInterface_states = NACL::CS::SystemHealthClusterSwitchInterface->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system health cluster-switch interface show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching system health cluster-switch interface(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_health_cluster_switch_interface_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
