# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::SystemHealthClusterSwitch->show_all() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthClusterSwitchShowAll

=head1 DESCRIPTION

C<NACL::CS::SystemHealthClusterSwitchShowAll> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::SystemHealthClusterSwitch->show_all() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::SystemHealthClusterSwitch->show_all() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< sw_version >>

Software Version

Filled in for CMode CLI

=item C<< model >>


Model Number possible value(s) are, NX5010,NX5020,CAT2960,OTHER,NX5596,CN1610,CN1601

Filled in for CMode CLI

=item C<< reason >>

Reason For Not Monitoring

Filled in for CMode CLI

=item C<< device >>

Device Name

Filled in for CMode CLI

=item C<< discovered >>

Is Discovered possible value(s) are, true,false

Filled in for CMode CLI

=item C<< community >>

Community String

Filled in for CMode CLI

=item C<< snmp_version >>

SNMP Version possible value(s) are, SNMPv1,SNMPv2c

Filled in for CMode CLI

=item C<< address >>

IP Address

Filled in for CMode CLI

=item C<< type >>


Switch Network possible value(s) are, cluster-network,management-network

Filled in for CMode CLI

=item C<< monitoring_status >>

Switch Monitoring Status possible value(s) are, yes,no

Filled in for CMode CLI

=item C<< version_source >>

Source Of Switch Version

Filled in for CMode CLI.


=item C<< is_monitoring_enabled_operational >>

Switch Monitoring Status possible value(s) are, true,false

Filled in for CMode CLI.


=back

=cut

package NACL::CS::SystemHealthClusterSwitchShowAll;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'sw_version',
    scalar => 'model',
    scalar => 'reason',
    scalar => 'device',
    scalar => 'discovered',
    scalar => 'community',
    scalar => 'snmp_version',
    scalar => 'address',
    scalar => 'type',
    scalar => 'monitoring_status',
    scalar => 'version_source',
    scalar => 'is_monitoring_enabled_operational',
];

=head1 METHODS

=head2 fetch

    my $SystemHealthClusterSwitchShowAll_state  = NACL::CS::SystemHealthClusterSwitchShowAll->fetch(command_interface => $ci, ...);
	my @SystemHealthClusterSwitchShowAll_states = NACL::CS::SystemHealthClusterSwitchShowAll->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'system health cluster-switch show-all',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching system health cluster-switch(s) found',
        frontend       => 'NACL::CS::SystemHealthClusterSwitchShowAll::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'system_health_cluster_switch_show_all',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
