#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemHealthNodeConnectivityAdapter ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemHealthNodeConnectivityAdapter

=head1 DESCRIPTION

C<NACL::CS::SystemHealthNodeConnectivityAdapter> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemHealthNodeConnectivityAdapter.  A related class is
L<NACL::C::SystemHealthNodeConnectivityAdapter|lib-NACL-C-SystemHealthNodeConnectivityAdapter-pm>, which represents access
to an ONTAP SystemHealthNodeConnectivityAdapter.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the SystemHealthNodeConnectivityAdapter
element are the attributes of the SystemHealthNodeConnectivityAdapter ComponentState.

=over

=item C<< "iom_port" >>

Filled in for CMode CLI.

=item C<< "port_name" >>

Filled in for CMode CLI.

=item C<< "status" >>

Filled in for CMode CLI.

=item C<< "ioma_list" >>
(Array)

Filled in for CMode CLI.

=item C<< "monitor" >>

Filled in for CMode CLI.

=item C<< "is_enabled" >>

Filled in for CMode CLI.

=item C<< "node" >>

Filled in for CMode CLI.

=item C<< "iomb_list" >>
(Array)

Filled in for CMode CLI.

=item C<< "circle_port_list" >>
(Array)

Filled in for CMode CLI.

=item C<< "in_use" >>

Filled in for CMode CLI.

=item C<< "square_port_list" >>
(Array)

Filled in for CMode CLI.

=item C<< "shelf_list" >>
(Array)

Filled in for CMode CLI.

=item C<< "num_ioma" >>

Filled in for CMode CLI.

=item C<< "name" >>

Filled in for CMode CLI.

=item C<< "is_dual_attached" >>

Filled in for CMode CLI.

=item C<< "wwn" >>

Filled in for CMode CLI.

=item C<< "num_square_port" >>

Filled in for CMode CLI.

=item C<< "num_shelf" >>

Filled in for CMode CLI.

=item C<< "num_circle_port" >>

Filled in for CMode CLI.

=item C<< "num_iomb" >>

Filled in for CMode CLI.

=item C<< "adapter_name" >>

Filled in for CMode CLI.

=item C<< "slot_num" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::SystemHealthNodeConnectivityAdapter;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'iom_port',
    scalar => 'port_name',
    scalar => 'status',
    array  => 'ioma_list',
    scalar => 'monitor',
    scalar => 'is_enabled',
    scalar => 'node',
    array  => 'iomb_list',
    array  => 'circle_port_list',
    scalar => 'in_use',
    array  => 'square_port_list',
    array  => 'shelf_list',
    scalar => 'num_ioma',
    scalar => 'name',
    scalar => 'is_dual_attached',
    scalar => 'wwn',
    scalar => 'num_square_port',
    scalar => 'num_shelf',
    scalar => 'num_circle_port',
    scalar => 'num_iomb',
    scalar => 'adapter_name',
    scalar => 'slot_num',
];

=head1 METHODS

=head2 fetch

    my $SystemHealthNodeConnectivityAdapter_state   = NACL::CS::SystemHealthNodeConnectivityAdapter->fetch(command_interface => $ci, ...);
	my @SystemHealthNodeConnectivityAdapter_states = NACL::CS::SystemHealthNodeConnectivityAdapter->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system health node-connectivity adapter show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text =>
            'No matching system health node connectivity adapter(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_health_node_connectivity_adapter_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
