# $Id$ //depot/prod/test/nacldev/lib/NACL/CS/SystemLicenseStatus.pm#5

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemLicenseStatus ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemLicenseStatus

=head1 DESCRIPTION

C<NACL::CS::SystemLicenseStatus> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemLicenseStatus.  A related class is
L<NACL::C::SystemLicenseStatus|lib-NACL-C-SystemLicenseStatus-pm>, which represents access
to an ONTAP SystemLicenseStatus.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemLicenseStatus
element are the attributes of the SystemLicenseStatus ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< expiration >>

Filled in for CMode CLI.

=item C<< method >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <license-v2-status>
    <license-v2-status-info>
        <method>$value</method>
    </license-v2-status-info>
 </license-v2-status>

=item C<< package >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <license-v2-status>
    <license-v2-status-info>
        <package>$value</package>
    </license-v2-status-info>
 </license-v2-status>

=item C<< description >>

Description

Filled in for CMode CLI.


=back

=cut

package NACL::CS::SystemLicenseStatus;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';
use Params::Validate qw(validate validate_with SCALAR ARRAYREF);

use Class::MethodMaker [
    scalar => 'expiration',
    scalar => 'method',
    scalar => 'package',
    scalar => 'description',
];

=head1 METHODS

=head2 fetch

    my $SystemLicenseStatus_state  = NACL::CS::SystemLicenseStatus->fetch(command_interface => $ci, ...);
	my @SystemLicenseStatus_states = NACL::CS::SystemLicenseStatus->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI APISet.

Invokes 'license-v2-status-list-info' API for CMode ZAPI

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching system license status(s) found',
        show_cmd       => 'system license status show',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_license_status_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;

    my %opts = validate @args,
        $pkg->_fetch_backend_validate_spec(allow_extra => 1);
    my @state_objs;
    my $command_interface = $opts{command_interface};
    my $apiset            = $opts{apiset};

    my $response = $apiset->license_v2_status_list_info();
    my $output   = $response->get_parsed_output();

    foreach my $list_output (@$output) {
        my $target = $pkg->_hash_copy(
            source => $list_output->{'license-v2-status'}->[0]
                ->{'license-v2-status-info'}->[0],
            copy => [qw( package method )],
        );
        my $obj = $pkg->new(command_interface => $command_interface,);
        $obj->_set_fields(row => $target);
        push @state_objs, $obj;
    } ## end foreach my $list_output (@$output)

    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
