# $Id$ //depot/prod/test/nacldev/lib/NACL/CS/SystemNodeCoredump.pm#6 $
#
# Copyright (c) 2012-2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemNodeCoredump ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemNodeCoredump

=head1 DESCRIPTION

C<NACL::CS::SystemNodeCoredump> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemNodeCoredump.  A related class is
L<NACL::C::SystemNodeCoredump|lib-NACL-C-SystemNodeCoredump-pm>, which represents access
to an ONTAP SystemNodeCoredump.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the SystemNodeCoredump
element are the attributes of the SystemNodeCoredump ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< is_saved >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<is-saved>$value</is-saved>
 </coredump-info>

=item C<< panic_node >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<panic-node>$value</panic-node>
 </coredump-info>

=item C<< version >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<version>$value</version>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< panic_systemid >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<panic-system-id>$value</panic-system-id>
 </coredump-info>

=item C<< coreid >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<core-id>$value</core-id>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< node >>

Maps to node-name for Cmode Zapi

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<node-name>$value</node-name>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< panic_string >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<panic-string>$value</panic-string>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< save_attempts >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<save-attempts>$value</save-attempts>
 </coredump-info>

=item C<< 'corename' => $corename >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<core-name>$value</core-name>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< is_partial >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<is-partial>$value</is-partial>
 </coredump-info>

=item C<< panic_time >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<panic-time>$value</panic-time>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< type >>

Filled in for CMode CLI and CMode ZAPI.

=item C<< coreid >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<core-id>$value</core-id>
 </coredump-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< space_needed >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <coredump-info>
	<space-needed>$value</space-needed>
 </coredump-info>

=back

=cut

package NACL::CS::SystemNodeCoredump;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'is_saved',
    scalar => 'panic_node',
    scalar => 'version',
    scalar => 'panic_systemid',
    scalar => 'node',
    scalar => 'panic_string',
    scalar => 'save_attempts',
    scalar => 'corename',
    scalar => 'is_partial',
    scalar => 'panic_time',
    scalar => 'type',
    scalar => 'coreid',
    scalar => 'space_needed',
    scalar => 'md5_data_chksum',
    scalar => 'ancillary_segment_directory',
    scalar => 'size',
];

=head1 METHODS

=head2 fetch

    my $SystemNodeCoredump_state  = NACL::CS::SystemNodeCoredump->fetch(command_interface => $ci, ...);
    my @SystemNodeCoredump_states = NACL::CS::SystemNodeCoredump->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI, 7Mode CLI.

Invokes "coredump-get-iter" API for CMode ZAPI.

Invokes "savecore" command for 7Mode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
            {   method    => '_fetch_7mode_cli',
                interface => 'CLI',
                set       => '7Mode'
            }
        ],
        exception_text => 'No matching system node coredump(s) found',
	show_cmd => 'system node coredump show',
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_node_coredump_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'coredump_get_iter',
        copy => [
            qw ( is-saved is-partial panic-node panic-time panic-string
                save-attempts space-needed version ancillary-segment-directory md5-data-chksum size )
        ],
        map => {
            'node'           => 'node-name',
            'coreid'         => 'core-id',
            'corename'       => 'core-name',
            'panic-systemid' => 'panic-system-id',
        }
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

sub _fetch_7mode_cli {
    my $pkg = shift;
    my %opts = validate @_, $pkg->_fetch_backend_validate_spec();
    my %api_opts;
    my $node;
    my @state_objs;
    my $apiset                = delete $opts{apiset};
    my $command_interface     = delete $opts{command_interface};
    my %copy_filter           = %{$opts{filter}};
    my @copy_requested_fields = @{$opts{requested_fields}};
    my $deleted_filter        = $pkg->_remove_relational_regex_filters(
        filter           => \%copy_filter,
        requested_fields => \@copy_requested_fields
    );
    my $filter           = \%copy_filter;
    my $requested_fields = \@copy_requested_fields;
    my $response         = $apiset->savecore('list' => "1");
    my $output           = $response->get_parsed_output();

    foreach my $list_output (@{$output}) {
        my $target = $pkg->_hash_copy(
            source => $list_output,
            copy   => [qw(corename coreid  node panic_string panic_time )],
            map    => {
                'os_version' => "version",
                'core_name'  => "corename",
            },
        );
        my $obj = $pkg->new(command_interface => $command_interface,);
        $obj->_set_fields(row => $target);
        push @state_objs, $obj;
    } ## end foreach my $list_output (@$output)
    return @state_objs;
} ## end sub _fetch_7mode_cli

1;
