#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemServicesFirewallPolicyService ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemServicesFirewallPolicyService

=head1 DESCRIPTION

C<NACL::CS::SystemServicesFirewallPolicyService> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemServicesFirewallPolicyService.  A related class is
L<NACL::C::SystemServicesFirewallPolicyService|lib-NACL-C-SystemServicesFirewallPolicyService-pm>, which represents access
to an ONTAP SystemServicesFirewallPolicyService.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the SystemServicesFirewallPolicyService
element are the attributes of the SystemServicesFirewallPolicyService ComponentState.

=over

=item C<< "protocol" >>

Filled in for CMode CLI.

=item C<< "port" >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $port = $obj->port();
# $port contains a reference to the array of values
my @port = $obj->port();
# @port contains the array of values

Filled in for CMode CLI.

=item C<< "service" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::SystemServicesFirewallPolicyService;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'protocol',
    array  => 'port',
    scalar => 'service',
];

=head1 METHODS

=head2 fetch

    my $SystemServicesFirewallPolicyService_state   = NACL::CS::SystemServicesFirewallPolicyService->fetch(command_interface => $ci, ...);
	my @SystemServicesFirewallPolicyService_states = NACL::CS::SystemServicesFirewallPolicyService->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system services firewall policy service show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text =>
            'No matching system services firewall policy service(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_services_firewall_policy_service_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
