#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method NACL::C::SystemServicesNdmp->get_version()
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemServicesNdmpGetVersion

=head1 DESCRIPTION

C<NACL::CS::SystemServicesNdmpGetVersion> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::SystemServicesNdmp->get_version() is invoked.

(This module does not represent the state of any element, but is an object
repesentation of the output obtained when the NDMP version is queried.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< node >>

The node in the cluster for which the NDMP version is being displayed. This 
field will be present in the object only if the test was run on a CMode host.

=item C<< version >>

The current NDMP version.

=back

=cut

package NACL::CS::SystemServicesNdmpGetVersion;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'node',
    scalar => 'version',
];

1;
