#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary SystemServicesWebPackages ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::SystemServicesWebPackages

=head1 DESCRIPTION

C<NACL::CS::SystemServicesWebPackages> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP SystemServicesWebPackages.  A related class is
L<NACL::C::SystemServicesWebPackages|lib-NACL-C-SystemServicesWebPackages-pm>, which represents access
to an ONTAP SystemServicesWebPackages.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the SystemServicesWebPackages
element are the attributes of the SystemServicesWebPackages ComponentState.

=over

=item C<< "default_roles" >>

(Array)

Filled in for CMode CLI.

=item C<< "is_root_locked" >>

Filled in for CMode CLI.

=item C<< "node" >>

Filled in for CMode CLI.

=item C<< "restrict_vserver" >>

(Array)

Filled in for CMode CLI.

=item C<< "reqs_ok" >>

Filled in for CMode CLI.

=item C<< "availability" >>

Filled in for CMode CLI.

=item C<< "default_root" >>

Filled in for CMode CLI.

=item C<< "is_local_only" >>

Filled in for CMode CLI.

=item C<< "capabilities" >>

Filled in for CMode CLI.

=item C<< "default_enabled" >>

Filled in for CMode CLI.

=item C<< "requires" >>

(Array)

Filled in for CMode CLI.

=item C<< "long_description" >>

Filled in for CMode CLI.

=item C<< "version" >>

Filled in for CMode CLI.

=item C<< "name" >>

Filled in for CMode CLI.

=item C<< "description" >>

Filled in for CMode CLI.

=item C<< "modified" >>

Filled in for CMode CLI.

=item C<< "is_valid" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::SystemServicesWebPackages;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'default_roles',
    scalar => 'is_root_locked',
    scalar => 'node',
    array  => 'restrict_vserver',
    scalar => 'reqs_ok',
    scalar => 'availability',
    scalar => 'default_root',
    scalar => 'is_local_only',
    scalar => 'capabilities',
    scalar => 'default_enabled',
    array  => 'requires',
    scalar => 'long_description',
    scalar => 'version',
    scalar => 'name',
    scalar => 'description',
    scalar => 'modified',
    scalar => 'is_valid',
];

=head1 METHODS

=head2 fetch

    my $SystemServicesWebPackages_state   = NACL::CS::SystemServicesWebPackages->fetch(command_interface => $ci, ...);
	my @SystemServicesWebPackages_states = NACL::CS::SystemServicesWebPackages->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'system services web packages show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching system services web packages(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'system_services_web_packages_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
