#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary UnitTestRdbAggr ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::UnitTestRdbAggr

=head1 DESCRIPTION

C<NACL::CS::UnitTestRdbAggr> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP UnitTestRdbAggr.  A related class is
L<NACL::C::UnitTestRdbAggr|lib-NACL-C-UnitTestRdbAggr-pm>, which represents access
to an ONTAP UnitTestRdbAggr.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the UnitTestRdbAggr
element are the attributes of the UnitTestRdbAggr ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< comment >>

Filled in for CMode CLI.

=item C<< member_id >>

Filled in for CMode CLI.

=item C<< name >>

Filled in for CMode CLI.

=item C<< blade_id >>

Filled in for CMode CLI.

=item C<< snmp_id >>

Filled in for CMode CLI.

=item C<< id >>

Filled in for CMode CLI.

=item C<< voltype >>

Filled in for CMode CLI.

=item C<< nickname >>

Filled in for CMode CLI.

=item C<< uuid >>

Filled in for CMode CLI.

=item C<< member_name >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::UnitTestRdbAggr;

use strict;
use warnings;
use Params::Validate qw(validate);
use Tharn qw($Log);

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'comment',
    scalar => 'member_id',
    scalar => 'name',
    scalar => 'blade_id',
    scalar => 'snmp_id',
    scalar => 'id',
    scalar => 'voltype',
    scalar => 'nickname',
    scalar => 'uuid',
    scalar => 'member_name',
];

=head1 METHODS

=head2 fetch

    my $UnitTestRdbAggr_state  = NACL::CS::UnitTestRdbAggr->fetch(command_interface => $ci, ...);
	my @UnitTestRdbAggr_states = NACL::CS::UnitTestRdbAggr->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter();
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'unit-test rdb aggr show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching unit-test rdb aggr(s) found'
    );
    $Log->exit();
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter();
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api => 'unit_test_rdb_aggr_show',

    );
    $Log->exit();
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
