# $Id: $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeFileCloneStatus ComponentState Module
## @author dl-nacl-dev@netapp.com , raghaveb@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeFileCloneStatus

=head1 DESCRIPTION

This module does not represent the state of any element, but is an object
representation of the output of volume file clone status 

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VolumeFileCloneStatus 
element are the attributes of the VolumeFileCloneStatus ComponentState.

=over

=item C<< status >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeFileCloneStatus;

use strict;
use warnings;
use base qw(NACL::CS::ComponentState::ONTAP);
use Class::MethodMaker [
    scalar => 'status',
];

1;
