# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeFileRepositoryFhmap ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeFileRepositoryFhmap

=head1 DESCRIPTION

C<NACL::CS::VolumeFileRepositoryFhmap> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VolumeFileRepositoryFhmap.  A related class is
L<NACL::C::VolumeFileRepositoryFhmap|lib-NACL-C-VolumeFileRepositoryFhmap-pm>, which represents access
to an ONTAP VolumeFileRepositoryFhmap.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VolumeFileRepositoryFhmap
element are the attributes of the VolumeFileRepositoryFhmap ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< nc_junction_active >>

*Namespace Constituent Junction Active, possible value(s) are true,false
Filled in for CMode CLI

=item C<< filehandle >>

*Filehandle
Filled in for CMode CLI

=item C<< data_path >>

*Data File Path
Filled in for CMode CLI

=item C<< vserver >>

*Vserver
Filled in for CMode CLI

=item C<< namespace_filehandle >>

*Namespace Filehandle
Filled in for CMode CLI

=item C<< path >>

*File Path
Filled in for CMode CLI

=item C<< namespace_constituent >>

*Namespace Constituent
Filled in for CMode CLI

=item C<< data_constituent >>

*Data Constituent
Filled in for CMode CLI

=item C<< namespace_path >>

*Namespace File Path
Filled in for CMode CLI

=item C<< dc_junction_path >>

*Data Constituent Junction Path
Filled in for CMode CLI

=item C<< show_filehandle_with_dsid >>

*Show Filehandle with DSID
Filled in for CMode CLI

=item C<< dc_junction_active >>

*Data Constituent Junction Active, possible value(s) are true,false
Filled in for CMode CLI

=item C<< data_filehandle >>

*Data Filehandle
Filled in for CMode CLI

=item C<< nc_junction_path >>

*Namespace Constituent Junction Path
Filled in for CMode CLI

=back

=cut

package NACL::CS::VolumeFileRepositoryFhmap;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'nc_junction_active',
    scalar => 'filehandle',
    scalar => 'data_path',
    scalar => 'vserver',
    scalar => 'namespace_filehandle',
    scalar => 'path',
    scalar => 'namespace_constituent',
    scalar => 'data_constituent',
    scalar => 'namespace_path',
    scalar => 'dc_junction_path',
    scalar => 'show_filehandle_with_dsid',
    scalar => 'dc_junction_active',
    scalar => 'data_filehandle',
    scalar => 'nc_junction_path',
];

=head1 METHODS

=head2 fetch

    my $VolumeFileRepositoryFhmap_state  = NACL::CS::VolumeFileRepositoryFhmap->fetch(command_interface => $ci, ...);
    my @VolumeFileRepositoryFhmap_states = NACL::CS::VolumeFileRepositoryFhmap->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'volume file repository fhmap show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching VolumeFileRepositoryFhmap objects found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'volume_file_repository_fhmap_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _compute_cmode_cli_options {
    my ($pkg, @args) = @_;
    $Log->enter() if $may_enter;
    my $opts_ref = $pkg->SUPER::_compute_cmode_cli_options(@args);

    # This additional code is kept for backward compatibility reasons. The
    # earlier code had filehandle as mandatory primary key and so for anyone
    # doing find(), $obj->filehandle would have returned the value.
    # It's added here and not in the frontend because, base class
    # _compute_cmode_cli is dropping filehandle, eventhough frontend passes
    # it, as it's a optional primary key. Further, it cannot be removed from
    # pri key spec, then the users wouldn't get the attribute populated in the
    # component object.
    if (exists $opts_ref->{fields} && defined $opts_ref->{fields}) {
        if ($opts_ref->{fields} !~ /,\s*filehandle\s*,/) {
            $opts_ref->{fields} .= ',filehandle';
        }
    }
    $Log->exit() if $may_exit;
    return $opts_ref;
}

1;
