# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VolumeFile->repository_fhmap_show() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeFileRepositoryFhmapShow

=head1 DESCRIPTION

C<NACL::CS::VolumeFileRepositoryFhmapShow> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VolumeFile->repository_fhmap_show() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VolumeFile->repository_fhmap_show() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< nc_junction_active >>

Namespace Constituent Junction Active possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< filehandle >>

Filehandle

Filled in for CMode CLI.

=item C<< data_path >>

Data File Path

Filled in for CMode CLI.

=item C<< vserver >>

Vserver

Filled in for CMode CLI.

=item C<< path >>

File Path

Filled in for CMode CLI.

=item C<< namespace_filehandle >>

Namespace Filehandle

Filled in for CMode CLI.

=item C<< namespace_constituent >>

Namespace Constituent

Filled in for CMode CLI.

=item C<< data_constituent >>

Data Constituent

Filled in for CMode CLI.

=item C<< namespace_path >>

Namespace File Path

Filled in for CMode CLI.

=item C<< dc_junction_path >>

Data Constituent Junction Path

Filled in for CMode CLI.

=item C<< data_filehandle >>

Data Filehandle

Filled in for CMode CLI.

=item C<< dc_junction_active >>

Data Constituent Junction Active possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< nc_junction_path >>

Namespace Constituent Junction Path

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeFileRepositoryFhmapShow;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'nc_junction_active',
    scalar => 'filehandle',
    scalar => 'data_path',
    scalar => 'vserver',
    scalar => 'path',
    scalar => 'namespace_filehandle',
    scalar => 'namespace_constituent',
    scalar => 'data_constituent',
    scalar => 'namespace_path',
    scalar => 'dc_junction_path',
    scalar => 'data_filehandle',
    scalar => 'dc_junction_active',
    scalar => 'nc_junction_path',
];

=head1 METHODS

=head2 fetch

    my $VolumeFileRepositoryFhmapShow_state  = NACL::CS::VolumeFileRepositoryFhmapShow->fetch(command_interface => $ci, ...);
	my @VolumeFileRepositoryFhmapShow_states = NACL::CS::VolumeFileRepositoryFhmapShow->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'volume file repository fhmap show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching volume file(s) found',
        frontend       => 'NACL::CS::VolumeFileRepositoryFhmapShow::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'volume_file_repository_fhmap_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
