
#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState module for the method NACL::C::VolumeFile->showfh()
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeFileShowfh

=head1 DESCRIPTION

C<NACL::CS::VolumeFileShowfh> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::C::VolumeFile->showfh() is invoked.

This module does not represent the state of any element, but is an object
repesentation of the output of showfh DBlade command.

=head1 ATTRIBUTES

The attribute names are selected to be the same as what ONTAP returns
in the output of 'showfh' DBlade command. 

Example:
toaster*> showfh /vol/vol0/lun1
flags=0x00 snapid=0 fileid=0x000067 gen=0x1994d4c6 fsid=0xb6638c9f
toaster*>

=over

=item C<< flags >>

=item C<< fileid >>

=item C<< gen >>

=item C<< fsid >>

=item C<< snapid >>

=item C<< dsid >>

=item C<< msid >>

=back

=cut

package NACL::CS::VolumeFileShowfh;

use strict;
use warnings;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'flags',
    scalar => 'fileid',
	scalar => 'gen',
	scalar => 'fsid',
	scalar => 'snapid',
	scalar => 'dsid',
	scalar => 'msid',
];

1;
