# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VolumeFlexcacheDelegations ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeFlexcacheDelegations

=head1 DESCRIPTION

C<NACL::CS::VolumeFlexcacheDelegations> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VolumeFlexcacheDelegations.  A related class is
L<NACL::C::VolumeFlexcacheDelegations|lib-NACL-C-VolumeFlexcacheDelegations-pm>, which represents access
to an ONTAP VolumeFlexcacheDelegations.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VolumeFlexcacheDelegations
element are the attributes of the VolumeFlexcacheDelegations ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

Filled in for CMode CLI.

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< peer_dsid >>

*Peer DSID

Filled in for CMode CLI.

=item C<< protocol >>

*Lock Protocol, possible value(s) are cifs,nfsv4,nlm,fcache,nfsv4.1

Filled in for CMode CLI.

=item C<< volume >>

*Volume

Filled in for CMode CLI.

=item C<< mode >>

*Read or Write

Filled in for CMode CLI.

=item C<< vserver >>

*Vserver

Filled in for CMode CLI.

=item C<< fileid >>

*Object FileId

Filled in for CMode CLI.

=item C<< dsid >>

*Volume DSID

Filled in for CMode CLI.

=item C<< path >>

*Object Path

Filled in for CMode CLI.

=item C<< lock_state >>

*Lock State

Filled in for CMode CLI.

=item C<< node >>

*Node Holding Lock State

Filled in for CMode CLI.

=item C<< lockid >>

*Lock UUID

Filled in for CMode CLI.

=item C<< index >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeFlexcacheDelegations;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'peer_dsid',
    scalar => 'protocol',
    scalar => 'volume',
    scalar => 'mode',
    scalar => 'vserver',
    scalar => 'fileid',
    scalar => 'dsid',
    scalar => 'path',
    scalar => 'lock_state',
    scalar => 'node',
    scalar => 'lockid',
    scalar => 'index',
];

=head1 METHODS

=head2 fetch

    my $VolumeFlexcacheDelegations_state  = NACL::CS::VolumeFlexcacheDelegations->fetch(command_interface => $ci, ...);
	my @VolumeFlexcacheDelegations_states = NACL::CS::VolumeFlexcacheDelegations->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'volume flexcache delegations show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching volume flexcache delegations(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'volume_flexcache_delegations_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
