# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::Volume->show_footprint_old() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VolumeShowFootprintOld

=head1 DESCRIPTION

C<NACL::CS::VolumeShowFootprintOld> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::Volume->show_footprint_old() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::Volume->show_footprint_old() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< delayed_free_fp_percent >>

Delayed Free Footprint Percent

Filled in for CMode CLI.

=item C<< percent_used >>

Used Percentage

Filled in for CMode CLI.

=item C<< flexvol_metadata_fp >>

Flexible Volume's Metadata Footprint, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< delayed_free_fp >>

Delayed Free Footprint, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< volume_guarantee_fp_percent >>

Guarantee Footprint Percent

Filled in for CMode CLI.

=item C<< dedupe_metafiles_fp_percent >>

Deduplication Metadata Footprint Percent

Filled in for CMode CLI.

=item C<< total_fp >>

Total Footprint, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< tape_backup_metafiles_fp_percent >>

Tape Backup Metadata Percent

Filled in for CMode CLI.

=item C<< dedupe_metafiles_fp >>

Deduplication Metadata Footprint, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< total_fp_percent >>

Total Footprint Percent

Filled in for CMode CLI.

=item C<< snapmirror_destination_fp >>

SnapMirror Destination Transfer Footprint, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< dedupe_metafiles_tmp_fp >>

Temporary Deduplication Metadata Footprint, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< volume >>

Volume Name

Filled in for CMode CLI.

=item C<< dedupe_metafiles_tmp_fp_percent >>

Temporary Deduplication Metadata Footprint Percent

Filled in for CMode CLI.

=item C<< vserver >>

Vserver Name

Filled in for CMode CLI.

=item C<< flexvol_metadata_fp_percent >>

Flexible Volume's Metadata Footprint Percent

Filled in for CMode CLI.

=item C<< snapmirror_destination_fp_percent >>

SnapMirror Destination Transfer Footprint Percent

Filled in for CMode CLI.

=item C<< volume_blocks_fp_percent >>

Volume Blocks Written Footprint Percent

Filled in for CMode CLI.

=item C<< total >>

Total User-Visible Size, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< volume_guarantee_fp >>

Guarantee Footprint, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< used >>

Used Size, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< tape_backup_metafiles_fp >>

Tape Backup Metadata, possible value(s) are <integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=item C<< volume_blocks_fp >>

Volume Blocks Written Footprint, possible value(s) are
<integer>[KB,MB,GB,TB,PB]

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VolumeShowFootprintOld;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'delayed_free_fp_percent',
    scalar => 'percent_used',
    scalar => 'flexvol_metadata_fp',
    scalar => 'delayed_free_fp',
    scalar => 'volume_guarantee_fp_percent',
    scalar => 'dedupe_metafiles_fp_percent',
    scalar => 'total_fp',
    scalar => 'tape_backup_metafiles_fp_percent',
    scalar => 'dedupe_metafiles_fp',
    scalar => 'total_fp_percent',
    scalar => 'snapmirror_destination_fp',
    scalar => 'dedupe_metafiles_tmp_fp',
    scalar => 'volume',
    scalar => 'dedupe_metafiles_tmp_fp_percent',
    scalar => 'vserver',
    scalar => 'flexvol_metadata_fp_percent',
    scalar => 'snapmirror_destination_fp_percent',
    scalar => 'volume_blocks_fp_percent',
    scalar => 'total',
    scalar => 'volume_guarantee_fp',
    scalar => 'used',
    scalar => 'tape_backup_metafiles_fp',
    scalar => 'volume_blocks_fp',
];

=head1 METHODS

=head2 fetch

    my $VolumeShowFootprintOld_state  = NACL::CS::VolumeShowFootprintOld->fetch(command_interface => $ci, ...);
	my @VolumeShowFootprintOld_states = NACL::CS::VolumeShowFootprintOld->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'volume show-footprint-old',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching volume(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli( @_,
        api => 'volume_show_footprint_old', );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
