# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsDomainPasswordSchedule ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsDomainPasswordSchedule

=head1 DESCRIPTION

C<NACL::CS::VserverCifsDomainPasswordSchedule> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsDomainPasswordSchedule.  A related class is
L<NACL::C::VserverCifsDomainPasswordSchedule|lib-NACL-C-VserverCifsDomainPasswordSchedule-pm>, which represents access
to an ONTAP VserverCifsDomainPasswordSchedule.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverCifsDomainPasswordSchedule
element are the attributes of the VserverCifsDomainPasswordSchedule ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< schedule_randomized_minute >>


Minutes Within Which Schedule Start Can be Randomized ranges from 1 to 180
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <cifs-domain-password-schedule schedule-randomized-minute="$value" />


=item C<< schedule_warn_msg >>

Warning Message in Case Job Is Deleted
Filled in for CMode CLI/ZAPI iter

=item C<< vserver >>

Vserver
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <cifs-domain-password-schedule vserver="$value" />


=item C<< is_schedule_enabled >>

Is Password Change Schedule Enabled possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <cifs-domain-password-schedule is-schedule-enabled="$value" />


=item C<< pwdchange_called_from_ui >>


Called From CIFS Password Schedule Change UI possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

=item C<< pwdchange_job_is_queued >>

Password Change Job Queued/Dequeued possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

=item C<< pwdchange_randomJob_id >>

Random Job Id for Password Change Schedule
Filled in for CMode CLI/ZAPI iter

=item C<< schedule_weekly_interval >>

Interval in Weeks for Password Change Schedule ranges from 1 to 52
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <cifs-domain-password-schedule schedule-weekly-interval="$value" />


=item C<< pwdchange_randomJob_name >>

Random Job Name for Password Change Schedule
Filled in for CMode CLI/ZAPI iter

=item C<< pwdchange_job_name >>

Job Name for Password Change Schedule
Filled in for CMode CLI/ZAPI iter

=item C<< pwdchange_schedule_counter >>

Counter for Password Change Schedule
Filled in for CMode CLI/ZAPI iter

=item C<< schedule_description >>

Schedule Description
Filled in for CMode CLI/ZAPI iter

=item C<< pwdchange_job_id >>

Job Id for Password Change Schedule
Filled in for CMode CLI/ZAPI iter

=item C<< pwdchange_schedule_last_changed >>

Time at Which Last Successful Password Change Occured
Filled in for CMode CLI/ZAPI iter

=item C<< schedule_last_changed >>

Last Successful Password Change/Reset Time
Filled in for CMode CLI/ZAPI iter
=back

=cut

package NACL::CS::VserverCifsDomainPasswordSchedule;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'schedule_randomized_minute',
    scalar => 'schedule_warn_msg',
    scalar => 'vserver',
    scalar => 'is_schedule_enabled',
    scalar => 'pwdchange_called_from_ui',
    scalar => 'pwdchange_job_is_queued',
    scalar => 'pwdchange_randomJob_id',
    scalar => 'schedule_weekly_interval',
    scalar => 'pwdchange_randomJob_name',
    scalar => 'pwdchange_job_name',
    scalar => 'pwdchange_schedule_counter',
    scalar => 'schedule_description',
    scalar => 'pwdchange_job_id',
    scalar => 'pwdchange_schedule_last_changed',
    scalar => 'schedule_last_changed',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverCifsDomainPasswordSchedule_state  = NACL::CS::VserverCifsDomainPasswordSchedule->fetch(command_interface => $ci, ...);
	my @VserverCifsDomainPasswordSchedule_states = NACL::CS::VserverCifsDomainPasswordSchedule->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes cifs-domain-password-schedule-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver cifs domain password schedule show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text =>
            'No matching VserverCifsDomainPasswordSchedule(s) found',
        frontend => 'NACL::CS::VserverCifsDomainPasswordSchedule::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_cifs_domain_password_schedule_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(schedule-randomized-minute is-schedule-enabled vserver
                schedule-weekly-interval
                )
        ],
        api => "cifs-domain-password-schedule-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
