# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VserverCifsGroupPolicy->show_applied() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsGroupPolicyShowApplied

=head1 DESCRIPTION

C<NACL::CS::VserverCifsGroupPolicyShowApplied> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VserverCifsGroupPolicy->show_applied() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VserverCifsGroupPolicy->show_applied() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< gpo_uuid >>

Filled in for CMode CLI.

=item C<< security_kerberos_ticketage >>

Filled in for CMode CLI.

=item C<< filesyspath >>

Filled in for CMode CLI.

=item C<< security_kerberos_renewage >>

Filled in for CMode CLI.

=item C<< security_privilege_takeownership >>

Filled in for CMode CLI.

=item C<< gpo_status >>

Filled in for CMode CLI.

=item C<< gpo_name >>

Filled in for CMode CLI.

=item C<< registry_refreshrandomoffset >>

Filled in for CMode CLI.

=item C<< link >>

Filled in for CMode CLI.

=item C<< dspath >>

Filled in for CMode CLI.

=item C<< extension >>

(Array) Filled in for CMode CLI.

=item C<< gpo_index >>

Filled in for CMode CLI.

=item C<< version >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< registry_refreshinterval >>

Filled in for CMode CLI.

=item C<< security_kerberos_clockskew >>

Filled in for CMode CLI.

=item C<< registry_hashpublication >>

Filled in for CMode CLI.

=item C<< registry_hashversion >>

Filled in for CMode CLI.


=item C<< cap_list >>

List of central access policies
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $cap_list = $obj->cap_list();
 
# $cap_list contains a reference to the array of values
 
my @cap_list = $obj->cap_list();
 
# @cap_list contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { cap_list = [ value1, value2...] }

Filled in for CMode CLI.


=item C<< security_privilege_securitypriv >>

Privilege Rights SecurityPriv
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $security_privilege_securitypriv = $obj->security_privilege_securitypriv();
 
# $security_privilege_securitypriv contains a reference to the array of values
 
my @security_privilege_securitypriv = $obj->security_privilege_securitypriv();
 
# @security_privilege_securitypriv contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { security_privilege_securitypriv = [ value1, value2...] }

Filled in for CMode CLI.


=item C<< security_registry_requiresign >>

SMB Signing Required possible value(s) are, true,false

Filled in for CMode CLI.


=item C<< security_restricted_groups >>

Restricted Groups
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $security_restricted_groups = $obj->security_restricted_groups();
 
# $security_restricted_groups contains a reference to the array of values
 
my @security_restricted_groups = $obj->security_restricted_groups();
 
# @security_restricted_groups contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { security_restricted_groups = [ value1, value2...] }

Filled in for CMode CLI.


=item C<< security_privilege_bypasstraverse >>

Privilege Rights BypassTraverse
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $security_privilege_bypasstraverse = $obj->security_privilege_bypasstraverse();
 
# $security_privilege_bypasstraverse contains a reference to the array of values
 
my @security_privilege_bypasstraverse = $obj->security_privilege_bypasstraverse();
 
# @security_privilege_bypasstraverse contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { security_privilege_bypasstraverse = [ value1, value2...] }

Filled in for CMode CLI.

=item C<< security_restano_noenum_for_sam >>

No enumeration of SAM accounts possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< security_audit_object_access >>

Audit Object Access

Filled in for CMode CLI/ZAPI.

=item C<< scripts_shutdown_names >>

Shutdown Scripts: Names
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $scripts_shutdown_names = $obj->scripts_shutdown_names();
 
# $scripts_shutdown_names contains a reference to the array of values
 
my @scripts_shutdown_names = $obj->scripts_shutdown_names();
 
# @scripts_shutdown_names contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { scripts_shutdown_names = [ value1, value2...] }

Filled in for CMode CLI.

=item C<< security_restano_no_access >>


Restrict Anonymous access to shares and named pipes possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< security_restano_noenum_for_samshare >>


No enumeration of SAM accounts and shares possible value(s) are, true,false

Filled in for CMode CLI.

=item C<< security_audit_logon_events >>

Audit Logon Events

Filled in for CMode CLI/ZAPI.

=item C<< adv_audit_cap_staging >>

Audit Cap Staging 

Filled in for CMode CLI/ZAPI.


=item C<< scripts_startup_names >>

Startup Scripts: Names
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $scripts_startup_names = $obj->scripts_startup_names();
 
# $scripts_startup_names contains a reference to the array of values
 
my @scripts_startup_names = $obj->scripts_startup_names();
 
# @scripts_startup_names contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { scripts_startup_names = [ value1, value2...] }

Filled in for CMode CLI.

=item C<< security_audit_log_ret_method >>

Audit Log Retention Method

Filled in for CMode CLI.

=item C<< resultant_restrict_anonymous >>


Combined restriction for anonymous user possible value(s) are, no-restriction,no-enumeration,no-access

Filled in for CMode CLI.

=item C<< security_audit_max_log_size >>

Maximum Size Of Security Log

Filled in for CMode CLI.


=item C<< security_file_security >>

Files/Directories for File Security
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $security_file_security = $obj->security_file_security();
 
# $security_file_security contains a reference to the array of values
 
my @security_file_security = $obj->security_file_security();
 
# @security_file_security contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { security_file_security = [ value1, value2...] }

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsGroupPolicyShowApplied;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);
use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'gpo_uuid',
    scalar => 'security_kerberos_ticketage',
    scalar => 'filesyspath',
    scalar => 'security_kerberos_renewage',
    scalar => 'security_privilege_takeownership',
    scalar => 'gpo_status',
    scalar => 'gpo_name',
    scalar => 'registry_refreshrandomoffset',
    scalar => 'link',
    scalar => 'dspath',
    array  => 'extension',
    scalar => 'gpo_index',
    scalar => 'version',
    scalar => 'vserver',
    scalar => 'registry_refreshinterval',
    scalar => 'security_kerberos_clockskew',
    scalar => 'registry_hashpublication',
    scalar => 'registry_hashversion',
    array  => 'cap_list',
    array  => 'security_privilege_securitypriv',
    scalar => 'security_registry_requiresign',
    array  => 'security_restricted_groups',
    array  => 'security_privilege_bypasstraverse',
    scalar => 'security_restano_noenum_for_sam',
    scalar => 'security_audit_object_access',
    array  => 'scripts_shutdown_names',
    scalar => 'security_restano_no_access',
    scalar => 'security_restano_noenum_for_samshare',
    scalar => 'security_audit_logon_events',
    scalar => 'adv_audit_cap_staging',
    array  => 'scripts_startup_names',
    scalar => 'security_audit_log_ret_method',
    scalar => 'resultant_restrict_anonymous',
    scalar => 'security_audit_max_log_size',
    array  => 'security_file_security',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsGroupPolicyShowApplied_state  = NACL::CS::VserverCifsGroupPolicyShowApplied->fetch(command_interface => $ci, ...);
	my @VserverCifsGroupPolicyShowApplied_states = NACL::CS::VserverCifsGroupPolicyShowApplied->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
	show_cmd       => 'vserver cifs group-policy show-applied',
        exception_text => 'No matching vserver cifs group-policy(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_cifs_group_policy_show_applied',);
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'gpo_applied_info_get_iter',
        copy => [
            qw( gpo-uuid filesyspath gpo-index gpo-name gpo-status vserver version dspath link adv-audit-cap-staging security-audit-logon-events security-audit-object-access )
        ],
        map => {
            'security-kerberos-clockskew' => 'security-kerberos-clock-skew',
            'security-kerberos-ticketage' => 'security-kerberos-ticket-age',
            'registry-refreshinterval'    => 'registry-refresh-interval',
            'extension' =>
                [make_zapi_array('extension'), make_zapi_skip('string'),],
            'registry-refreshrandomoffset' =>
                'registry-refresh-random-offset',
            'security-privilege-takeownership' =>
                'security-privilege-take-ownership',
            'security-kerberos-renewage' => 'security-kerberos-renewal-age',
        },
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi
1;
