#$Id$
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsSessionFile ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsSessionFile

=head1 DESCRIPTION

C<NACL::CS::VserverCifsSessionFile> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsSessionFile.  A related class is
L<NACL::C::VserverCifsSessionFile|lib-NACL-C-VserverCifsSessionFile-pm>, which represents access
to an ONTAP VserverCifsSessionFile.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverCifsSessionFile
element are the attributes of the VserverCifsSessionFile ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< open_mode >>

Open Mode
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <open-mode>$value</open-mode>
 </cifs-session-file>

=item C<< file_type >>

File Type
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <file-type>$value</file-type>
 </cifs-session-file>

=item C<< file_id >>

File ID
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <file-id>$value</file-id>
 </cifs-session-file>

=item C<< vserver >>

Vserver
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <vserver>$value</vserver>
 </cifs-session-file>

=item C<< reconnected >>

Reconnected
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <reconnected>$value</reconnected>
 </cifs-session-file>

=item C<< path >>

Path from CIFS Share
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <path>$value</path>
 </cifs-session-file>

=item C<< range_locks >>

Range Locks
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <range-locks>$value</range-locks>
 </cifs-session-file>

=item C<< session_id >>

Session ID
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <session-id>$value</session-id>
 </cifs-session-file>

=item C<< node >>

Node
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <node>$value</node>
 </cifs-session-file>

=item C<< ca_protection >>

CA Protection
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <ca-protection>$value</ca-protection>
 </cifs-session-file>

=item C<< connection_id >>

Connection ID
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <connection-id>$value</connection-id>
 </cifs-session-file>

=item C<< share >>

CIFS Share
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <share>$value</share>
 </cifs-session-file>

=item C<< open_type >>

Open Type
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <open-type>$value</open-type>
 </cifs-session-file>

=item C<< hosting_node >>

Node Hosting File
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <hosting-node>$value</hosting-node>
 </cifs-session-file>

=item C<< share_mode >>

Share Mode
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <share-mode>$value</share-mode>
 </cifs-session-file>

=item C<< hosting_aggregate >>

Aggregate Hosting File
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <hosting-aggregate>$value</hosting-aggregate>
 </cifs-session-file>

=item C<< continuously_available >>

Continuously Available
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <continuously-available>$value</continuously-available>
 </cifs-session-file>

=item C<< hosting_volume >>

Volume Hosting File
Filled in for CMode CLI, CMode ZAPI.

Maps to:

CM ZAPI:

 <cifs-session-file>
    <hosting-volume>$value</hosting-volume>
 </cifs-session-file>

=item C<< file_index >>

File Index

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsSessionFile;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'open_mode',
    scalar => 'file_type',
    scalar => 'file_id',
    scalar => 'vserver',
    scalar => 'reconnected',
    scalar => 'path',
    scalar => 'range_locks',
    scalar => 'session_id',
    scalar => 'node',
    scalar => 'ca_protection',
    scalar => 'connection_id',
    scalar => 'share',
    scalar => 'open_type',
    scalar => 'hosting_node',
    scalar => 'share_mode',
    scalar => 'hosting_aggregate',
    scalar => 'continuously_available',
    scalar => 'hosting_volume',
    scalar => 'file_index',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsSessionFile_state  = NACL::CS::VserverCifsSessionFile->fetch(command_interface => $ci, ...);
	my @VserverCifsSessionFile_states = NACL::CS::VserverCifsSessionFile->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "cifs-session-file-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver cifs session file show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching VserverCifsSessionFile(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_cifs_session_file_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my $copy = [
        qw( ca-protection connection-id continuously-available file-id
            file-type hosting-aggregate hosting-node hosting-volume node
            open-mode open-type path range-locks reconnected session-id
            share share-mode vserver )
    ];

    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        api  => "cifs-session-file-get-iter",
        copy => $copy,
    );

    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
