# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUsersAndGroupsLocalGroup ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsUsersAndGroupsLocalGroup

=head1 DESCRIPTION

C<NACL::CS::VserverCifsUsersAndGroupsLocalGroup> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsUsersAndGroupsLocalGroup.  A related class is
L<NACL::C::VserverCifsUsersAndGroupsLocalGroup|lib-NACL-C-VserverCifsUsersAndGroupsLocalGroup-pm>, which represents access
to an ONTAP VserverCifsUsersAndGroupsLocalGroup.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverCifsUsersAndGroupsLocalGroup
element are the attributes of the VserverCifsUsersAndGroupsLocalGroup ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< vserver >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <cifs-local-group>
    <vserver>$values</vserver>
 </cifs-local-group>

=item C<< domain_name >>

Filled in for CMode CLI.

=item C<< group_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <cifs-local-group>
    <group-name>$values</group-name>
 </cifs-local-group>

=item C<< description >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <cifs-local-group>
    <description>$values</description>
 </cifs-local-group>

=item C<< domain_id >>

Domain ID

Filled in for CMode CLI.

=item C<< group_rid >>

Group RID

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsUsersAndGroupsLocalGroup;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'domain_name',
    scalar => 'group_name',
    scalar => 'description',
    scalar => 'domain_id',
    scalar => 'group_rid',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsUsersAndGroupsLocalGroup_state  = NACL::CS::VserverCifsUsersAndGroupsLocalGroup->fetch(command_interface => $ci, ...);
	my @VserverCifsUsersAndGroupsLocalGroup_states = NACL::CS::VserverCifsUsersAndGroupsLocalGroup->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.


Supports CMode CLI/ZAPI.

Invokes "cifs-local-group-get-iter" API for CMode ZAPI

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver cifs users-and-groups local-group show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching vserver cifs users-and-groups local-group(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_cifs_users_and_groups_local_group_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'cifs_local_group_get_iter',
        copy => [qw ( vserver group-name description)],
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
