# $Id: //depot/prod/test/nacldev/lib/NACL/CS/VserverCifsUsersAndGroupsLocalUserShowMembership.pm#2 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VserverCifsUsersAndGroupsLocalUser->show_membership() (auto-generated by CGT)
## @author pbala@netapp, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership

=head1 DESCRIPTION

C<NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VserverCifsUsersAndGroupsLocalUser->show_membership() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VserverCifsUsersAndGroupsLocalUser->show_membership() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< memberof_sid >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <cifs-local-user-membership>
    <vserver>$values</vserver>
 </cifs-local-user-membership>

=item C<< membership >>
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $membership = $obj->membership();

# $membership contains a reference to the array of values

my @membership = $obj->membership();

# @membership contains the array of values

If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { membership  = [ value1, value2...] }

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <cifs-local-user-membership>
    <membership>$values</membership>
 </cifs-local-user-membership>
 
=item C<< user_name >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <cifs-local-user-membership>
    <user-name>$values</user-name>
 </cifs-local-user-membership>

=item C<< domain_name >>

Domain Name

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'memberof_sid',
    scalar => 'vserver',
    array  => 'membership',
    scalar => 'user_name',
    scalar => 'domain_name',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsUsersAndGroupsLocalUserShowMembership_state  = NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership->fetch(command_interface => $ci, ...);
	my @VserverCifsUsersAndGroupsLocalUserShowMembership_states = NACL::CS::VserverCifsUsersAndGroupsLocalUserShowMembership->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "cifs-local-user-membership-get-iter" API for CMode ZAPI

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver cifs users-and-groups local-user show-membership',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        exception_text =>
            'No matching vserver cifs users-and-groups local-user(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_cifs_users_and_groups_local_user_show_membership',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg = shift;
    my %opts = validate @_, $pkg->_fetch_backend_validate_spec();

    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        %opts,
        api    => 'cifs_local_user_membership_get_iter',
        copy   => [qw ( vserver membership user-name )],
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
