#$Id: //depot/prod/test/nacldev/lib/NACL/CS/VserverCifsUtilitiesFile.pm#3 $
#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsUtilitiesFile ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverCifsUtilitiesFile

=head1 DESCRIPTION

C<NACL::CS::VserverCifsUtilitiesFile> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverCifsUtilitiesFile.  A related class is
L<NACL::C::VserverCifsUtilitiesFile|lib-NACL-C-VserverCifsUtilitiesFile-pm>, which represents access
to an ONTAP VserverCifsUtilitiesFile.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverCifsUtilitiesFile
element are the attributes of the VserverCifsUtilitiesFile ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< open_mode >>

Filled in for CMode CLI.
(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $open_mode = $obj->open_mode();
# $open_mode contains a reference to the array of values
my @open_mode = $obj->open_mode();
# @open_mode contains the array of values

Filled in for CMode CLI.

=item C<< file_type >>

Filled in for CMode CLI.

=item C<< file_id >>

Filled in for CMode CLI.

=item C<< vserver >>

Filled in for CMode CLI.

=item C<< reconnected >>

Filled in for CMode CLI.

=item C<< path >>

Filled in for CMode CLI.

=item C<< range_locks >>

Filled in for CMode CLI.

=item C<< session_id >>

Filled in for CMode CLI.

=item C<< node >>

Filled in for CMode CLI.

=item C<< ca_protection >>

Filled in for CMode CLI.

=item C<< connection_id >>

Filled in for CMode CLI.

=item C<< share >>

Filled in for CMode CLI.

=item C<< open_type >>

Filled in for CMode CLI.

=item C<< hosting_node >>

Filled in for CMode CLI.

=item C<< share_mode >>

Filled in for CMode CLI.
(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $share_mode = $obj->share_mode();
# $share_mode contains a reference to the array of values
my @share_mode = $obj->share_mode();
# @share_mode contains the array of values

Filled in for CMode CLI.

=item C<< file_index >>

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverCifsUtilitiesFile;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'open_mode',
    scalar => 'file_type',
    scalar => 'file_id',
    scalar => 'vserver',
    scalar => 'reconnected',
    scalar => 'path',
    scalar => 'range_locks',
    scalar => 'session_id',
    scalar => 'node',
    scalar => 'ca_protection',
    scalar => 'connection_id',
    scalar => 'share',
    scalar => 'open_type',
    scalar => 'hosting_node',
    array  => 'share_mode',
    scalar => 'file_index',
];

=head1 METHODS

=head2 fetch

    my $VserverCifsUtilitiesFile_state  = NACL::CS::VserverCifsUtilitiesFile->fetch(command_interface => $ci, ...);
	my @VserverCifsUtilitiesFile_states = NACL::CS::VserverCifsUtilitiesFile->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver cifs utilities file show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching vserver cifs utilities file(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli( @_,
        api => 'vserver_cifs_utilities_file_show', );
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
