# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VserverFpolicy->show_passthrough_read_connection() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverFpolicyShowPassthroughReadConnection

=head1 DESCRIPTION

C<NACL::CS::VserverFpolicyShowPassthroughReadConnection> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VserverFpolicy->show_passthrough_read_connection() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VserverFpolicy->show_passthrough_read_connection() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info vserver="$value" />



=item C<< disconnect_reason >>

Reason for Disconnection

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info disconnect-reason="$value" />



=item C<< control_session_id >>

Session ID of the Control Channel

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info control-session-id="$value" />



=item C<< policy_name >>

Policy

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info policy-name="$value" />



=item C<< node >>

Node possible value(s) are, <nodename>,local

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info node="$value" />



=item C<< server_status >>

Server Status

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info server-status="$value" />



=item C<< server >>

Server

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info fpolicy-server="$value" />



=item C<< disconnected_since >>

Time Channel Was Disconnected

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info disconnected-since="$value" />



=item C<< connected_since >>

Time Channel Was Connected

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<fpolicy-passthrough-read-connection-info connected-since="$value" />



=back

=cut

package NACL::CS::VserverFpolicyShowPassthroughReadConnection;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'disconnect_reason',
    scalar => 'control_session_id',
    scalar => 'policy_name',
    scalar => 'node',
    scalar => 'server_status',
    scalar => 'server',
    scalar => 'disconnected_since',
    scalar => 'connected_since',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverFpolicyShowPassthroughReadConnection_state  = NACL::CS::VserverFpolicyShowPassthroughReadConnection->fetch(command_interface => $ci, ...);
	my @VserverFpolicyShowPassthroughReadConnection_states = NACL::CS::VserverFpolicyShowPassthroughReadConnection->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes fpolicy-passthrough-read-connection-get-iter API for CMode ZAPI.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        show_cmd => 'vserver fpolicy show-passthrough-read-connection',
	exception_text => 'No matching vserver fpolicy(s) found',
        frontend =>
            'NACL::CS::VserverFpolicyShowPassthroughReadConnection::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_fpolicy_show_passthrough_read_connection',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(disconnect-reason vserver control-session-id policy-name node server-status
                disconnected-since connected-since
                )
        ],
        map => {'server' => 'fpolicy-server',},
        api => "fpolicy-passthrough-read-connection-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
