# $Id //depot/prod/test/nacldev/lib/NACL/CS/VserverGroupMapping.pm#3 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverGroupMapping ComponentState Module (auto-generated by CGT)
## @author Akshay Mohit(makshay@netapp.com), dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverGroupMapping

=head1 DESCRIPTION

C<NACL::CS::VserverGroupMapping> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverGroupMapping.  A related class is
L<NACL::C::VserverGroupMapping|lib-NACL-C-VserverGroupMapping-pm>, which represents access
to an ONTAP VserverGroupMapping.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverGroupMapping
element are the attributes of the VserverGroupMapping ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< direction >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <group-mapping-info>
    <direction>$value</direction>
 </group-mapping-info>

=item C<< pattern >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <group-mapping-info>
    <pattern>$value</pattern>
 </group-mapping-info>

=item C<< vserver >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <group-mapping-info>
    <vserver>$value</vserver>
 </group-mapping-info>

=item C<< position >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <group-mapping-info>
    <position>$value</position>
 </group-mapping-info>

=item C<< replacement >>

Filled in for CMode CLI/ZAPI.

Maps to:

CM ZAPI:

 <group-mapping-info>
    <replacement>$value</replacement>
 </group-mapping-info>

=back

=cut

package NACL::CS::VserverGroupMapping;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'direction',
    scalar => 'pattern',
    scalar => 'vserver',
    scalar => 'position',
    scalar => 'replacement',
];

=head1 METHODS

=head2 fetch

    my $VserverGroupMapping_state  = NACL::CS::VserverGroupMapping->fetch(command_interface => $ci, ...);
    my @VserverGroupMapping_states = NACL::CS::VserverGroupMapping->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI APISet.

Invokes "group-mapping-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver group-mapping show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching vserver group-mapping(s) found'
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_group_mapping_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg                   = shift;
    my $allowed_cmode_options = [
        qw( direction pattern position replacement vserver
            )
    ];
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'group-mapping-get-iter',
        copy => $allowed_cmode_options,
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
