# $Id: //depot/prod/test/nacldev/lib/NACL/CS/VserverIscsiInterface.pm#18 $

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverIscsiInterface ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com, benjaram@netapp.com
## @changes anupamap@netapp.com 2011-07-23 : Added 7Mode support for iscsi show
## @status shared
## @pod here
## Supports 7MODE and CMODE

=head1 NAME

NACL::CS::VserverIscsiInterface

=head1 DESCRIPTION

C<NACL::CS::VserverIscsiInterface> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverIscsiInterface.  A related class is
L<NACL::C::VserverIscsiInterface|lib-NACL-C-VserverIscsiInterface-pm>, which represents access
to an ONTAP VserverIscsiInterface.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverIscsiInterface
element are the attributes of the VserverIscsiInterface ComponentState.

=over

=item C<< "curr_node" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <current-node>$value</current-node>
 </iscsi-interface-list-entry-info>

=item C<< "home_port" >>

Filled in for CMode CLI.

=item C<< "all" >>

Filled in for CMode/7Mode CLI.

Maps to:

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< "netmask" >>

Filled in for CMode CLI.

=item C<< "address" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <ip-address>$value</ip-address>
 </iscsi-interface-list-entry-info>

=item C<< "home_node" >>

Filled in for CMode CLI.

=item C<< "enabled" >>

Filled in for CMode CLI/ZAPI, 7Mode CLI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <is-interface-enabled>$value</is-interface-enabled>
 </iscsi-interface-list-entry-info>

7Mode CLI:

For "filter":
Applicable, Filtering will be done by Components.

For "requested_fields",
Not applicable, but the field will be populated in the CS object.

=item C<< "tpgname" >>

Filled in for CMode CLI.

=item C<< "vserver" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <vserver>$value</vserver>
 </iscsi-interface-list-entry-info>

=item C<< "status_admin" >>

Filled in for CMode CLI.

=item C<< "ip_port" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <ip-port>$value</ip-port>
 </iscsi-interface-list-entry-info>

=item C<< "status_oper" >>

Filled in for CMode CLI.

=item C<< "curr_port" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <current-port>$value</current-port>
 </iscsi-interface-list-entry-info>

=item C<< "is_home" >>

Filled in for CMode CLI.

=item C<< "tpgtag" >>

Filled in for CMode CLI.

=item C<< "lif" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <interface-name>$value</interface-name>
 </iscsi-interface-list-entry-info>

=item C<< "lifs" >>

Filled in for CMode CLI.

=item C<< relative_port_id >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <relative-port-id>$value</relative-port-id>
 </iscsi-interface-list-entry-info>

=item C<< tpgroup >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <tpgroup-name>$value</tpgroup-name>
 </iscsi-interface-list-entry-info>

=item C<< tpgroup_tag >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <iscsi-interface-list-entry-info>
     <vsertpgroup-tagver>$value</tpgroup-tag>
 </iscsi-interface-list-entry-info>

=item C<< vserver_uuid >>

Filled in for CMode CLI.

=item C<< sendtargets_fqdn >>

iSCSI Discovery SendTargets FQDN

Filled in for CMode CLI/ZAPI.

=back

=cut

package NACL::CS::VserverIscsiInterface;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one Dumper);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'curr_node',
    scalar => 'all',
    scalar => 'home_port',
    scalar => 'netmask',
    scalar => 'address',
    scalar => 'home_node',
    scalar => 'enabled',
    scalar => 'tpgname',
    scalar => 'vserver',
    scalar => 'status_admin',
    scalar => 'ip_port',
    scalar => 'status_oper',
    scalar => 'curr_port',
    scalar => 'is_home',
    scalar => 'tpgtag',
    scalar => 'lif',
    scalar => 'lifs',
    scalar => 'relative_port_id',
    scalar => 'tpgroup',
    scalar => 'tpgroup_tag',
    scalar => 'vserver_uuid',
    scalar => 'sendtargets_fqdn',
];

=head1 METHODS

=head2 fetch

    my $VserverIscsiInterface_state   = NACL::CS::VserverIscsiInterface->fetch(command_interface => $ci, ...);
    my @VserverIscsiInterface_states = NACL::CS::VserverIscsiInterface->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI, 7Mode CLI.

Invokes "iscsi-interface-get-iter" API for CMode ZAPI.

Invokes "iscsi interface show" command for 7Mode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver iscsi interface show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
            {   method    => '_fetch_7mode_cli',
                interface => 'CLI',
                set       => '7Mode',
            },
        ],
        exception_text => 'No matching vserver iscsi interface(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_iscsi_interface_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => "iscsi_interface_get_iter",
        copy => [qw (vserver relative-port-id ip-port tpgroup-tag)],
        map  => {
            'curr_node' => 'current-node',
            'curr_port' => 'current-port',
            'enabled'   => 'is-interface-enabled',
            'tpgroup'   => 'tpgroup-name',
            'address'   => 'ip-address',
            'lif'       => 'interface-name',
        },
    );

    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

sub _fetch_7mode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my %opts        = validate @args, $pkg->_fetch_backend_validate_spec();
    my $apiset      = delete $opts{apiset};
    my %copy_filter = %{$opts{filter}};
    my @copy_requested_fields = @{$opts{requested_fields}};
    my $deleted_filter        = $pkg->_remove_relational_regex_filters(
        filter           => \%copy_filter,
        requested_fields => \@copy_requested_fields
    );
    my $filter           = \%copy_filter;
    my $requested_fields = \@copy_requested_fields;
    my $req_field_filter;
    $req_field_filter->{'requested_fields'} = $requested_fields;
    $req_field_filter->{'filter'}           = \%copy_filter;
    my @state_objs;
    my $Node     = $opts{command_interface}->node();
    my $response = $apiset->iscsi_interface_show();
    my $output   = $response->get_parsed_output();
    my $row;

    foreach $row (@$output) {
        my $obj = $pkg->new(command_interface => $opts{command_interface});
        $obj->curr_port((%$row)[0]);
        my $val;
        if (((%$row)[1]) =~ /enabled/) {
            $val = "true";
        } else {
            $val = "false";
        }
        $obj->enabled($val);
        push @state_objs, $obj;
    } ## end foreach $row (@$output)
    return @state_objs;
} ## end sub _fetch_7mode_cli
1;
