# $Id$

#
# Copyright (c) 2001-2010 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary ComponentState Module for the method NACL::C::VserverIscsiPortal->vserver_iscsi_interface_show() (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow

=head1 DESCRIPTION

C<NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this type
are returned when NACL::C::VserverIscsiPortal->vserver_iscsi_interface_show() is invoked.

((This module does not represent the state of any element, but is an object
repesentation of the output obtained when NACL::C::VserverIscsiPortal->vserver_iscsi_interface_show() is invoked.)

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< curr_node >>

Current Node
Filled in for CMode CLI

=item C<< vserver >>

Vserver
Filled in for CMode CLI

=item C<< status_admin >>

Administrative Status possible value(s) are, up,down
Filled in for CMode CLI

=item C<< ip_port >>

IP Port Number
Filled in for CMode CLI

=item C<< status_oper >>

Operational Status possible value(s) are, up,down
Filled in for CMode CLI

=item C<< curr_port >>

Current Port possible value(s) are, <netport>,<ifgrp>
Filled in for CMode CLI

=item C<< relative_port_id >>

Relative Port ID
Filled in for CMode CLI

=item C<< tpgroup >>

TPGroup Name
Filled in for CMode CLI

=item C<< is_home >>

Is Home possible value(s) are, true,false
Filled in for CMode CLI

=item C<< tpgroup_tag >>

TPGroup Tag
Filled in for CMode CLI

=item C<< vserver_uuid >>

Vserver UUID
Filled in for CMode CLI

=item C<< address >>

IP Address
Filled in for CMode CLI

=item C<< lif >>

Logical Interface
Filled in for CMode CLI

=item C<< enabled >>

Enabled possible value(s) are, true,false
Filled in for CMode CLI

=back

=cut

package NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'curr_node',
    scalar => 'vserver',
    scalar => 'status_admin',
    scalar => 'ip_port',
    scalar => 'status_oper',
    scalar => 'curr_port',
    scalar => 'relative_port_id',
    scalar => 'tpgroup',
    scalar => 'is_home',
    scalar => 'tpgroup_tag',
    scalar => 'vserver_uuid',
    scalar => 'address',
    scalar => 'lif',
    scalar => 'enabled',
];

=head1 METHODS

=head2 fetch

    my $VserverIscsiPortalVserverIscsiInterfaceShow_state  = NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow->fetch(command_interface => $ci, ...);
	my @VserverIscsiPortalVserverIscsiInterfaceShow_states = NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses a CMode CLI APISet.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
	show_cmd => 'vserver iscsi interface show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text => 'No matching vserver iscsi portal(s) found',
        frontend =>
            'NACL::CS::VserverIscsiPortalVserverIscsiInterfaceShow::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_iscsi_interface_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
