# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverLocks ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverLocks

=head1 DESCRIPTION

C<NACL::CS::VserverLocks> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverLocks.  A related class is
L<NACL::C::VserverLocks|lib-NACL-C-VserverLocks-pm>, which represents access
to an ONTAP VserverLocks.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverLocks
element are the attributes of the VserverLocks ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< protocol >>

Lock Protocol

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info protocol="$value" />



=item C<< smb_connect_state >>

SMB Connect State

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info smb-connect-state="$value" />



=item C<< node >>

Node Holding Lock State

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info node="$value" />



=item C<< sharelock_mode >>

Shared Lock Access Mode

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info sharelock-mode="$value" />



=item C<< smb_open_type >>

SMB Open Type possible value(s) are, none,durable,persistent

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info smb-open-type="$value" />



=item C<< bytelock_length >>

Number of Bytes Locked

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info bytelock-length="$value" />



=item C<< bytelock_offset >>

Bytelock Starting Offset

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info bytelock-offset="$value" />



=item C<< oplock_level >>


Oplock Level possible value(s) are, exclusive,level2,batch,null,read-batch

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info oplock-cache-level="$value" />



=item C<< sharelock_soft >>

Shared Lock is Soft possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info is-sharelock-soft="$value" />



=item C<< smb_open_group_id >>

SMB Open Group ID

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info smb-open-group-id="$value" />



=item C<< bytelock_exclusive >>

Bytelock is Exclusive possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info is-bytelock-exclusive="$value" />



=item C<< delegation_type >>

Delegation Type possible value(s) are, read,write

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info delegation-type="$value" />



=item C<< bytelock_soft >>

Bytelock is Soft possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info is-bytelock-soft="$value" />



=item C<< volume >>

Volume

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info volume="$value" />



=item C<< client_id >>

Client ID

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info client-id="$value" />



=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info vserver="$value" />



=item C<< constituent_path >>

Constituent Path

Filled in for CMode CLI.

=item C<< path >>

Object Path

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info path="$value" />



=item C<< lock_state >>

Lock State

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info lock-state="$value" />



=item C<< bytelock_super >>

Bytelock is Superlock possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info is-bytelock-super="$value" />



=item C<< lockid >>

Lock UUID

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info lockid="$value" />



=item C<< smb_expiration_time >>

SMB Expiration Time (Secs)

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info smb-expiration-time="$value" />



=item C<< owner_id >>

Owner ID

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info owner-id="$value" />



=item C<< type >>


Lock Type possible value(s) are, byte-range,share-level,op-lock,delegation

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info lock-type="$value" />



=item C<< bytelock_mandatory >>

Bytelock is Mandatory possible value(s) are, true,false

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info is-bytelock-mandatory="$value" />



=item C<< lif >>

Logical Interface

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info lif="$value" />



=item C<< client_address >>

Client Address

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<lock-info client-address="$value" />

=item C<< lock_cursor >>

Lock Cursor

Filled in for CMode CLI.

=item C<< member_name >>

Volume Member Name

Filled in for CMode CLI.

=item C<< lock_index >>

Lock Index Number

Filled in for CMode CLI.

=item C<< volume_junction >>

Volume Junction Path

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverLocks;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'protocol',
    scalar => 'smb_connect_state',
    scalar => 'node',
    scalar => 'sharelock_mode',
    scalar => 'smb_open_type',
    scalar => 'bytelock_length',
    scalar => 'bytelock_offset',
    scalar => 'oplock_level',
    scalar => 'sharelock_soft',
    scalar => 'smb_open_group_id',
    scalar => 'bytelock_exclusive',
    scalar => 'delegation_type',
    scalar => 'bytelock_soft',
    scalar => 'volume',
    scalar => 'client_id',
    scalar => 'vserver',
    scalar => 'constituent_path',
    scalar => 'path',
    scalar => 'lock_state',
    scalar => 'bytelock_super',
    scalar => 'lockid',
    scalar => 'smb_expiration_time',
    scalar => 'owner_id',
    scalar => 'type',
    scalar => 'bytelock_mandatory',
    scalar => 'lif',
    scalar => 'client_address',
    scalar => 'smb2',
    scalar => 'smb2_open_type',
    scalar => 'smb2_connect_state',
    scalar => 'smb2_expiration_time',
    scalar => 'smb2_open_group_id',
    scalar => 'lock_cursor',
    scalar => 'member_name',
    scalar => 'lock_index',
    scalar => 'volume_junction',
];

my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverLocks_state  = NACL::CS::VserverLocks->fetch(command_interface => $ci, ...);
	my @VserverLocks_states = NACL::CS::VserverLocks->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes lock-get-iter API for CMode ZAPI.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver locks show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        exception_text => 'No matching vserver locks(s) found',
        frontend       => 'NACL::CS::VserverLocks::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs
        = $pkg->SUPER::_fetch_cmode_cli(@args, api => 'vserver_locks_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(protocol smb-connect-state node sharelock-mode smb-open-type
                bytelock-length bytelock-offset smb-open-group-id delegation-type volume
                client-id vserver path lock-state lockid smb-expiration-time owner-id lif
                client-address
                )
        ],
        map => {
            'sharelock-soft'     => 'is-sharelock-soft',
            'oplock-level'       => 'oplock-cache-level',
            'bytelock-exclusive' => 'is-bytelock-exclusive',
            'bytelock-soft'      => 'is-bytelock-soft',
            'bytelock-super'     => 'is-bytelock-super',
            'type'               => 'lock-type',
            'bytelock-mandatory' => 'is-bytelock-mandatory',
        },
        api => "lock-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _update_state_objs_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    $pkg->SUPER::_update_state_objs_cmode_zapi(
        %opts,
        zapi_field_translations => {
            hyphenate_value => [qw(type oplock-level)],
        },
    );
    
    # ZAPI returns values with underscores, but in CLI values are a mix of
    # underscores and hyphens.
    # The "delete-on-close" CLI value maps to "delete_on_close".
    # For all other CLI values, the values are of the form *-deny_*, but the
    # ZAPI is *_deny_*. For example,
    # CLI               -> ZAPI:
    # read-deny_read       read_deny_read
    # read-deny_write      read_deny_write
    # For for all values other than "delete_on_close", we replace
    # "_deny" with "-deny".
    foreach my $state_obj (@{$opts{state_objs}}) {
        my $sharelock_mode = $state_obj->sharelock_mode();
        if ($sharelock_mode eq 'delete_on_close') {
            $state_obj->sharelock_mode('delete-on-close');
        } else {
            $sharelock_mode =~ s/_deny/-deny/;
            $state_obj->sharelock_mode($sharelock_mode);
        }
    }
    $Log->exit() if $may_exit;
}

1;
