# $Id$

#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverSecurityFileDirectoryJob ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverSecurityFileDirectoryJob

=head1 DESCRIPTION

C<NACL::CS::VserverSecurityFileDirectoryJob> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverSecurityFileDirectoryJob.  A related class is
L<NACL::C::VserverSecurityFileDirectoryJob|lib-NACL-C-VserverSecurityFileDirectoryJob-pm>, which represents access
to an ONTAP VserverSecurityFileDirectoryJob.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverSecurityFileDirectoryJob
element are the attributes of the VserverSecurityFileDirectoryJob ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< priority >>

Priority, possible value(s) are Low,Medium,High,Exclusive

Filled in for CMode CLI.

=item C<< restarted >>

Restarted?, possible value(s) are true,false

Filled in for CMode CLI.

=item C<< affinity >>

Affinity, possible value(s) are Cluster,Node

Filled in for CMode CLI.

=item C<< uuid >>

UUID

Filled in for CMode CLI.

=item C<< node >>

Node

Filled in for CMode CLI.

=item C<< state >>

State, possible value(s) are
Initial,Queued,Running,Waiting,Pausing,Paused,Quitting,Success,Failure,Reschedule,Error,Quit,Dead,Unknown,Restart,Dormant

Filled in for CMode CLI.

=item C<< starttime >>

Start Time

Filled in for CMode CLI.

=item C<< endtime >>

End Time

Filled in for CMode CLI.

=item C<< category >>

Job Category

Filled in for CMode CLI.

=item C<< id >>

Job ID

Filled in for CMode CLI.

=item C<< queuetime >>

Queue Time

Filled in for CMode CLI.

=item C<< code >>

Status Code

Filled in for CMode CLI.

=item C<< dropdeadtime >>

Drop-dead Time

Filled in for CMode CLI.

=item C<< progress >>

Execution Progress

Filled in for CMode CLI.

=item C<< vserver >>

Owning Vserver

Filled in for CMode CLI.

=item C<< name >>

Name

Filled in for CMode CLI.

=item C<< completion >>

Completion String

Filled in for CMode CLI.

=item C<< description >>

Description

Filled in for CMode CLI.

=item C<< process >>

Process

Filled in for CMode CLI.

=item C<< schedule >>

Schedule

Filled in for CMode CLI.

=item C<< username >>

User Name

Filled in for CMode CLI.

=item C<< jobtype >>

Job Type

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VserverSecurityFileDirectoryJob;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'priority',
    scalar => 'restarted',
    scalar => 'affinity',
    scalar => 'uuid',
    scalar => 'node',
    scalar => 'state',
    scalar => 'starttime',
    scalar => 'endtime',
    scalar => 'category',
    scalar => 'id',
    scalar => 'queuetime',
    scalar => 'code',
    scalar => 'dropdeadtime',
    scalar => 'progress',
    scalar => 'vserver',
    scalar => 'name',
    scalar => 'completion',
    scalar => 'description',
    scalar => 'process',
    scalar => 'schedule',
    scalar => 'username',
    scalar => 'jobtype',
];

=head1 METHODS

=head2 fetch

    my $VserverSecurityFileDirectoryJob_state  = NACL::CS::VserverSecurityFileDirectoryJob->fetch(command_interface => $ci, ...);
	my @VserverSecurityFileDirectoryJob_states = NACL::CS::VserverSecurityFileDirectoryJob->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver security file-directory job show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            }
        ],
        exception_text =>
            'No matching vserver security file-directory job(s) found',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_security_file_directory_job_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

1;
