#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesKerberosKeyblocks ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesKerberosKeyblocks

=head1 DESCRIPTION

C<NACL::CS::VserverServicesKerberosKeyblocks> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverServicesKerberosKeyblocks.  A related class is
L<NACL::C::VserverServicesKerberosKeyblocks|lib-NACL-C-VserverServicesKerberosKeyblocks-pm>, which represents access
to an ONTAP VserverServicesKerberosKeyblocks.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverServicesKerberosKeyblocks
element are the attributes of the VserverServicesKerberosKeyblocks ComponentState.

=over

=item C<< "vserver" >>

Filled in for CMode CLI.

=item C<< "keyblock" >>

Filled in for CMode CLI.

=item C<< "spn" >>

Filled in for CMode CLI.

=item C<< "timestamp" >>

Filled in for CMode CLI.

=item C<< "key_version" >>

Filled in for CMode CLI.

=item C<< "vif" >>

Filled in for CMode CLI.

=item C<< "lif" >>

Filled in for CMode CLI.

=item C<< "service_type" >>

Filled in for CMode CLI.

=item C<< "encryption_type" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VserverServicesKerberosKeyblocks;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'keyblock',
    scalar => 'spn',
    scalar => 'timestamp',
    scalar => 'key_version',
    scalar => 'vif',
    scalar => 'lif',
    scalar => 'service_type',
    scalar => 'encryption_type',
];

=head1 METHODS

=head2 fetch

    my $VserverServicesKerberosKeyblocks_state   = NACL::CS::VserverServicesKerberosKeyblocks->fetch(command_interface => $ci, ...);
	my @VserverServicesKerberosKeyblocks_states = NACL::CS::VserverServicesKerberosKeyblocks->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver services kerberos-keyblocks show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text =>
            'No matching vserver services kerberos keyblocks(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(
        @_,
        api => 'vserver_services_kerberos_keyblocks_show',

    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
