# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesKerberosRealm ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesKerberosRealm

=head1 DESCRIPTION

"vserver services kerberos-realm show" command has got aliased to
"vserver nfs kerberos realm show" command. So usage of this component is deprecated.Use
L<NACL::CS::VserverNfsKerberosRealm|lib-NACL-CS-VserverNfsKerberosRealm-pm> instead.

>>>> ORIGINAL //depot/prod/DOT/dev/test/lib/NACL/CS/VserverServicesKerberosRealm.pm#7
=item C<< "kdc_vendor" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <kdc-vendor>$value</kdc-vendor>
</kerberos-realm>

=item C<< "clock_skew" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <clock-skew>$value</clock-skew>
</kerberos-realm>

=item C<< "configname" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-realm>
     <config-name>$value</config-name>
 </kerberos-realm>

=item C<< "adminserver_ip" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <admin-server-ip>$value</admin-server-ip>
</kerberos-realm>

=back

==== THEIRS //depot/prod/DOT/dev/test/lib/NACL/CS/VserverServicesKerberosRealm.pm#8
=item C<< "kdc_vendor" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <kdc-vendor>$value</kdc-vendor>
</kerberos-realm>

=item C<< "clock_skew" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <clock-skew>$value</clock-skew>
</kerberos-realm>

=item C<< "configname" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

 <kerberos-realm>
     <config-name>$value</config-name>
 </kerberos-realm>

=item C<< "adminserver_ip" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <admin-server-ip>$value</admin-server-ip>
</kerberos-realm>

=item C<< "vserver" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<kerberos-realm>
    <vserver-name>$value</vserver-name>
    </kerberos-realm>

=back

==== YOURS //aanusha:volumefile_754270/test/lib/NACL/CS/VserverServicesKerberosRealm.pm
<<<<
=cut

package NACL::CS::VserverServicesKerberosRealm;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'adminserver_port',
    scalar => 'passwordserver_port',
    scalar => 'kdc_ip',
    scalar => 'kdc_port',
    scalar => 'adserver_name',
    scalar => 'adserver_ip',
    scalar => 'comment',
    scalar => 'realm',
    scalar => 'passwordserver_ip',
    scalar => 'kdc_vendor',
    scalar => 'clock_skew',
    scalar => 'configname',
    scalar => 'adminserver_ip',
    scalar => 'vserver',
];

=head1 METHODS

=head2 fetch

Usage of this method is deprecated. It is recommended to use
   NACL::C::VserverNfsKerberosRealm->find(...); instead.

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, %opts) = @_;
    my @state_objs = $pkg->_redirect_call(%opts);
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _redirect_call {
    $Log->enter() if $may_enter;
    my ($pkg_or_obj, %opts) = @_;
    $Log->warn("The command 'vserver services kerberos-realm show' was renamed to "
                    . "'vserver nfs kerberos realm show'. Please change the call to use the new name");
    require NACL::CS::VserverNfsKerberosRealm;
    $Log->exit() if $may_exit;
    return NACL::CS::VserverNfsKerberosRealm->fetch(%opts);
}

1;
