#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesLdapClientSchema ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesLdapClientSchema

=head1 DESCRIPTION

C<NACL::CS::VserverServicesLdapClientSchema> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverServicesLdapClientSchema.  A related class is
L<NACL::C::VserverServicesLdapClientSchema|lib-NACL-C-VserverServicesLdapClientSchema-pm>, which represents access
to an ONTAP VserverServicesLdapClientSchema.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverServicesLdapClientSchema
element are the attributes of the VserverServicesLdapClientSchema ComponentState.

=over

=item C<< "member_uid_attribute" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <member-uid-attribute>$value</member-uid-attribute>
</ldap-client-schema>

=item C<< "posix_account_object_class" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <posix-account-object-class>$value</posix-account-object-class>
</ldap-client-schema>

=item C<< "posix_group_object_class" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <posix-group-object-class>$value</posix-group-object-class>
</ldap-client-schema>

=item C<< "unix_account_attribute" >>

Filled in for CMode CLI.

=item C<< "uid_number_attribute" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <uid-number-attribute>$value</uid-number-attribute>
</ldap-client-schema>

=item C<< "schema" >>

Filled in for CMode CLI/ZAPI.

Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
    <schema> $value </schema>
</ldap-client-schema>

=item C<< "cn_netgroup_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <cn-netgroup-attribute>$value</cn-netgroup-attribute>
</ldap-client-schema>

=item C<< "windows_to_unix_attribute" >>

Filled in for CMode CLI.

=item C<< "unique_member_attribute" >>

Filled in for CMode CLI.

=item C<< "nis_netgroup_triple_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <nis-netgroup-triple-attribute>$value</nis-netgroup-triple-attribute>
</ldap-client-schema>

=item C<< "user_password_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <user-password-attribute>$value</user-password-attribute>
</ldap-client-schema>

=item C<< "home_directory_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <home-directory-attribute>$value</home-directory-attribute>
</ldap-client-schema>

=item C<< "windows_to_unix_object_class" >>

Filled in for CMode CLI.

=item C<< "cn_group_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <cn-group-attribute>$value</cn-group-attribute>
</ldap-client-schema>

=item C<< "login_shell_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <login-shell-attribute>$value</login-shell-attribute>
</ldap-client-schema>

=item C<< "gecos_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <gecos-attribute>$value</gecos-attribute>
</ldap-client-schema>

=item C<< "member_nis_netgroup_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <member-nis-netgroup-attribute>$value</member-nis-netgroup-attribute>
</ldap-client-schema>

=item C<< "gid_number_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <gid-number-attribute>$value</gid-number-attribute>
</ldap-client-schema>

=item C<< "nis_netgroup_object_class" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <nis-netgroup-object-class>$value</nis-netgroup-object-class>
</ldap-client-schema>

=item C<< "group_of_unique_names_object_class" >>

Filled in for CMode CLI.

=item C<< "uid_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <uid-attribute>$value</uid-attribute>
</ldap-client-schema>

=item C<< "comment" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <comment>$value</comment>
</ldap-client-schema>

=item C<< "windows_account_attribute" >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <windows-account-attribute>$value</windows-account-attribute>
</ldap-client-schema>

=item C<< "enable_rfc2307bis" >>

Filled in for CMode CLI.

=item C<< is_owner >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <is-owner>$value</is-owner>
</ldap-client-schema>

=item C<< vserver >>

Filled in for CMode/ZAPI.

Maps to:

CMode ZAPI:
	
For "requested_fields", "filter" and Output mapping:

<ldap-client-schema>
   <vserver>$value</vserver>
</ldap-client-schema>

=back

=cut

package NACL::CS::VserverServicesLdapClientSchema;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NACL::C::_Mixins::VserverServicesLdapClientSchema qw(:all);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'member_uid_attribute',
    scalar => 'posix_account_object_class',
    scalar => 'posix_group_object_class',
    scalar => 'unix_account_attribute',
    scalar => 'uid_number_attribute',
    scalar => 'schema',
    scalar => 'cn_netgroup_attribute',
    scalar => 'windows_to_unix_attribute',
    scalar => 'unique_member_attribute',
    scalar => 'nis_netgroup_triple_attribute',
    scalar => 'user_password_attribute',
    scalar => 'home_directory_attribute',
    scalar => 'windows_to_unix_object_class',
    scalar => 'cn_group_attribute',
    scalar => 'login_shell_attribute',
    scalar => 'gecos_attribute',
    scalar => 'member_nis_netgroup_attribute',
    scalar => 'gid_number_attribute',
    scalar => 'nis_netgroup_object_class',
    scalar => 'group_of_unique_names_object_class',
    scalar => 'uid_attribute',
    scalar => 'comment',
    scalar => 'windows_account_attribute',
    scalar => 'enable_rfc2307bis',
    scalar => 'is_owner',
    scalar => 'vserver',
];

=head1 METHODS

=head2 fetch

    my $VserverServicesLdapClientSchema_state   = NACL::CS::VserverServicesLdapClientSchema->fetch(command_interface => $ci, ...);
	my @VserverServicesLdapClientSchema_states = NACL::CS::VserverServicesLdapClientSchema->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI/ZAPI.

Invokes "ldap-client-schema-get-iter" API for CMode ZAPI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
        show_cmd => 'vserver services ldap client schema show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
            },
        ],
        exception_text =>
            'No matching vserver services ldap client schema(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_services_ldap_client_schema_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my $pkg         = shift;
    my $common_copy = $pkg->_common_zapi_copy();
    push(@$common_copy, qw(is_owner vserver));
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @_,
        api  => 'ldap_client_schema_get_iter',
        copy => $common_copy
    );
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_zapi

1;
