# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceGetxxbyyyGethostbyaddr ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr

=head1 DESCRIPTION

C<NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr->gethostbyaddr() is invoked.

(This module does not represent the state of any element, but is an object
representation of the output obtained when the getxxbyyy gethostbyaddr is queried for
Get the host information from the IP address.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< ip_address >>

=item C<< host_name >>

=item C<< canonical_name >>

=back

=cut

package NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyaddr;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'ip_address',
    scalar => 'host_name',
    scalar => 'canonical_name',
];

1;
