# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceGetxxbyyyGethostbyname ComponentState Module
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname

=head1 DESCRIPTION

C<NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. Object(s) of this
type are returned when NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname->gethostbyaddr() is invoked.

(This module does not represent the state of any element, but is an object
representation of the output obtained when the getxxbyyy gethostbyname is queried for
Get the IP address information from host name.

=head1 ATTRIBUTES

The fields of the output are fields of the ComponentState object.

=over

=item C<< ip_address >>

=item C<< canonical_name >>

=item C<< host_name >>

=back

=cut

package NACL::CS::VserverServicesNameServiceGetxxbyyyGethostbyname;

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'ip_address',
    scalar => 'canonical_name',
    scalar => 'host_name',
];

1;
