# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesNameServiceNetgroupFile ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesNameServiceNetgroupFile

=head1 DESCRIPTION

C<NACL::CS::VserverServicesNameServiceNetgroupFile> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverServicesNameServiceNetgroupFile.  A related class is
L<NACL::C::VserverServicesNameServiceNetgroupFile|lib-NACL-C-VserverServicesNameServiceNetgroupFile-pm>, which represents access
to an ONTAP VserverServicesNameServiceNetgroupFile.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverServicesNameServiceNetgroupFile
element are the attributes of the VserverServicesNameServiceNetgroupFile ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< index >>

Index
Filled in for CMode CLI/ZAPI iter, non-iter.

=item C<< netgroup >>

Netgroup Name
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <netgroups-file-config-info netgroup-name="$value" />

Mapping for CMode ZAPI non-iter: netgroup-name


=item C<< domain >>

Member Domain
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <netgroups-file-config-info domain="$value" />


=item C<< vserver >>

Vserver
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <netgroups-file-config-info vserver="$value" />


=item C<< user >>

Member User
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <netgroups-file-config-info user="$value" />


=item C<< netgrpmemb >>

Member Netgroup
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <netgroups-file-config-info member-netgroup="$value" />

Mapping for CMode ZAPI non-iter: member-netgroup


=item C<< host >>

Member Host
Filled in for CMode CLI/ZAPI iter, non-iter.

Mapping for CMode ZAPI iter: <netgroups-file-config-info host="$value" />

=back

=cut

package NACL::CS::VserverServicesNameServiceNetgroupFile;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'index',
    scalar => 'netgroup',
    scalar => 'domain',
    scalar => 'vserver',
    scalar => 'user',
    scalar => 'netgrpmemb',
    scalar => 'host',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

sub _check_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @opts) = @_;
    $pkg->_base_check_non_iter(
        @opts,
        _primary_keys => [qw(vserver)],
        _vs_context   => 1
    );
    $Log->exit() if $may_exit;
}

=head1 METHODS

=head2 fetch

    my $VserverServicesNameServiceNetgroupFile_state  = NACL::CS::VserverServicesNameServiceNetgroupFile->fetch(command_interface => $ci, ...);
	my @VserverServicesNameServiceNetgroupFile_states = NACL::CS::VserverServicesNameServiceNetgroupFile->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes netgroups-file-get-iter API for CMode ZAPI iter.

Invokes netgroups-file-get API for CMode ZAPI non-iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver services name-service netgroup file show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },
            {   method    => '_fetch_cmode_zapi_non_iter',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'non-iter',
                check     => '_check_non_iter'
            },
        ],
        exception_text =>
            'No matching VserverServicesNameServiceNetgroupFile(s) found',
        frontend => 'NACL::CS::VserverServicesNameServiceNetgroupFile::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_services_name_service_netgroup_file_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(domain vserver user host
                )
        ],
        map => {
            'netgroup'   => 'netgroup-name',
            'netgrpmemb' => 'member-netgroup',
        },
        api => "netgroups-file-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi_non_iter {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi_non_iter(
        @args,
        copy => [
            qw(domain vserver user host
                )
        ],
        map => {
            'netgroup'   => 'netgroup-name',
            'netgrpmemb' => 'member-netgroup',
        },
        api                 => "netgroups-file-get",
        vserver_operated_on => \my $vserver,
        primary_keys        => [qw(  )],
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
