#
# Copyright (c) 2001-2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverServicesWeb ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverServicesWeb

=head1 DESCRIPTION

C<NACL::CS::VserverServicesWeb> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverServicesWeb.  A related class is
L<NACL::C::VserverServicesWeb|lib-NACL-C-VserverServicesWeb-pm>, which represents access
to an ONTAP VserverServicesWeb.

=head1 ATTRIBUTES

The individual pieces of data that are part of the  state of the VserverServicesWeb
element are the attributes of the VserverServicesWeb ComponentState.

=over

=item C<< "vserver" >>

Filled in for CMode CLI.

=item C<< "version" >>

Filled in for CMode CLI.

=item C<< "long_description" >>

Filled in for CMode CLI.

=item C<< "name" >>

Filled in for CMode CLI.

=item C<< "default_roles" >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $default_roles = $obj->default_roles();
# $default_roles contains a reference to the array of values
my @default_roles = $obj->default_roles();
# @default_roles contains the array of values

Filled in for CMode CLI.

=item C<< "description" >>

Filled in for CMode CLI.

=item C<< "ssl_only" >>

Filled in for CMode CLI.

=item C<< "requires" >>

(Array)

Note that for array fields, the accessor method can be invoked in either
scalar or list context.
my $requires = $obj->requires();
# $requires contains a reference to the array of values
my @requires = $obj->requires();
# @requires contains the array of values

Filled in for CMode CLI.

=item C<< "type" >>

Filled in for CMode CLI.

=item C<< "enabled" >>

Filled in for CMode CLI.

=back

=cut

package NACL::CS::VserverServicesWeb;

use strict;
use warnings;
use Params::Validate qw(validate);
use NACL::ComponentUtils qw(_dump_one);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Data::Dumper;

use NACL::Exceptions::NoElementsFound qw(:try);

use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'vserver',
    scalar => 'version',
    scalar => 'long_description',
    scalar => 'name',
    array  => 'default_roles',
    scalar => 'description',
    scalar => 'ssl_only',
    array  => 'requires',
    scalar => 'type',
    scalar => 'enabled',
];

=head1 METHODS

=head2 fetch

    my $VserverServicesWeb_state   = NACL::CS::VserverServicesWeb->fetch(command_interface => $ci, ...);
	my @VserverServicesWeb_states = NACL::CS::VserverServicesWeb->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Supports CMode CLI.

=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::fetch(
        @_,
	show_cmd => 'vserver services web show',
	choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
            },
        ],
        exception_text => 'No matching vserver services web(s) found'
    );

    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
} ## end sub fetch

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my $pkg        = shift;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@_,
        api => 'vserver_services_web_show');
    $Log->exit() if $may_exit;
    return @state_objs;
} ## end sub _fetch_cmode_cli

1;
