# $Id$

#
# Copyright (c) 2001-2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanOnDemandTask ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverVscanOnDemandTask

=head1 DESCRIPTION

C<NACL::CS::VserverVscanOnDemandTask> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverVscanOnDemandTask.  A related class is
L<NACL::C::VserverVscanOnDemandTask|lib-NACL-C-VserverVscanOnDemandTask-pm>, which represents access
to an ONTAP VserverVscanOnDemandTask.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverVscanOnDemandTask
element are the attributes of the VserverVscanOnDemandTask ComponentState. 

Additionally, the command_interface used to obtain the ComponentState object is 
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using 
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)


=item C<< scan_paths >>

List of Scan Paths
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $scan_paths = $obj->scan_path();
 
# $scan_paths contains a reference to the array of values
 
my @scan_paths = $obj->scan_path();
 
# @scan_paths contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { scan_paths = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info>
  <scan-paths string="@values" />
</vscan-on-demand-task-info>


=item C<< paths_to_exclude >>

File Paths Not to Scan
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $paths_to_exclude = $obj->paths_to_exclude();
 
# $paths_to_exclude contains a reference to the array of values
 
my @paths_to_exclude = $obj->paths_to_exclude();
 
# @paths_to_exclude contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { paths_to_exclude = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info>
  <paths-to-exclude string="@values" />
</vscan-on-demand-task-info>


=item C<< cross_junction >>

Cross Junction possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info cross-junction="$value" />


=item C<< vserver >>

Vserver
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info vserver="$value" />


=item C<< scan_files_with_no_ext >>

Scan Files with No Extension possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info scan-files-with-no-ext="$value" />


=item C<< report_directory >>

Report Path
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info report-directory="$value" />


=item C<< schedule >>

Job Schedule
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info schedule="$value" />


=item C<< request_timeout >>

Request Service Timeout
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info request-timeout="$value" />


=item C<< directory_recursion >>

Directory Recursion possible value(s) are, true,false
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info directory-recursion="$value" />


=item C<< file_ext_to_include >>

File Extensions to Scan
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $file_ext_to_include = $obj->file_ext_to_include();
 
# $file_ext_to_include contains a reference to the array of values
 
my @file_ext_to_include = $obj->file_ext_to_include();
 
# @file_ext_to_include contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { file_ext_to_include = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info>
  <file-ext-to-include file-extension="@values" />
</vscan-on-demand-task-info>


=item C<< scan_priority >>

Scan Priority possible value(s) are, low,normal
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info scan-priority="$value" />


=item C<< file_ext_to_exclude >>

File Extensions Not to Scan
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $file_ext_to_exclude = $obj->file_ext_to_exclude();
 
# $file_ext_to_exclude contains a reference to the array of values
 
my @file_ext_to_exclude = $obj->file_ext_to_exclude();
 
# @file_ext_to_exclude contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { file_ext_to_exclude = [ value1, value2...] }

Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info>
  <file-ext-to-exclude file-extension="@values" />
</vscan-on-demand-task-info>


=item C<< task_name >>

Task Name
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info task-name="$value" />


=item C<< max_file_size >>

Max File Size Allowed for Scanning
Filled in for CMode CLI/ZAPI iter

Mapping for CMode ZAPI iter: <vscan-on-demand-task-info max-file-size="$value" />

=back

=cut

package NACL::CS::VserverVscanOnDemandTask;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    array  => 'scan_paths',
    array  => 'paths_to_exclude',
    scalar => 'cross_junction',
    scalar => 'vserver',
    scalar => 'scan_files_with_no_ext',
    scalar => 'report_directory',
    scalar => 'schedule',
    scalar => 'request_timeout',
    scalar => 'directory_recursion',
    array  => 'file_ext_to_include',
    scalar => 'scan_priority',
    array  => 'file_ext_to_exclude',
    scalar => 'task_name',
    scalar => 'max_file_size',
];
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 fetch

    my $VserverVscanOnDemandTask_state  = NACL::CS::VserverVscanOnDemandTask->fetch(command_interface => $ci, ...);
	my @VserverVscanOnDemandTask_states = NACL::CS::VserverVscanOnDemandTask->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes vscan-on-demand-task-get-iter API for CMode ZAPI iter.

            
=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        show_cmd => 'vserver vscan on-demand-task show',
        choices  => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode',
                zapi_type => 'none',
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode',
                zapi_type => 'iter'
            },

        ],
        exception_text => 'No matching VserverVscanOnDemandTask(s) found',
        frontend       => 'NACL::CS::VserverVscanOnDemandTask::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _update_state_objs_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    $pkg->SUPER::_update_state_objs_cmode_zapi(
        @args,
        zapi_field_translations => {
            sec_to_hrminsec => [qw(request-timeout)],
            hyphenate_value => [qw(scan-priority)],
        },
    );
    $Log->exit() if $may_exit;
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_vscan_on_demand_task_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(cross-junction directory-recursion task-name max-file-size vserver
                scan-files-with-no-ext request-timeout schedule report-directory scan-priority
                )
        ],
        map => {
            'scan-paths' =>
                [make_zapi_array('scan-paths'), make_zapi_skip('string'),],
            'file-ext-to-exclude' => [
                make_zapi_array('file-ext-to-exclude'),
                make_zapi_skip('file-extension'),
            ],
            'paths-to-exclude' => [
                make_zapi_array('paths-to-exclude'),
                make_zapi_skip('string'),
            ],
            'file-ext-to-include' => [
                make_zapi_array('file-ext-to-include'),
                make_zapi_skip('file-extension'),
            ],
        },
        api => "vscan-on-demand-task-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
