# Copyright (c) 2001-2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverVscanScannerPool ComponentState Module (auto-generated by CGT)
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::CS::VserverVscanScannerPool

=head1 DESCRIPTION

C<NACL::CS::VserverVscanScannerPool> is a derived class of
L<NACL::CS::ComponentState::ONTAP|lib-NACL-CS-ComponentState-ONTAP-pm>. It represents the
state of an ONTAP VserverVscanScannerPool.  A related class is
L<NACL::C::VserverVscanScannerPool|lib-NACL-C-VserverVscanScannerPool-pm>, which represents access
to an ONTAP VserverVscanScannerPool.

=head1 ATTRIBUTES

The individual pieces of data that are part of the state of the VserverVscanScannerPool
element are the attributes of the VserverVscanScannerPool ComponentState.

Additionally, the command_interface used to obtain the ComponentState object is
also an attribute of the object. This makes it easier to obtain the component
object corresponding to the CS object, using
L<get_component_instance|lib-NACL-CS-ComponentState-pm/get_component_instance>.

=over

=item command_interface

The command_interface with which the CS object was obtained. (Available in
all CS objects regardless of requested_fields and the mode/interface)

=item C<< owner >>

Scanner Pool Config Owner

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info admin-owner="$value" />



=item C<< session_setup_timeout >>

Session Setup Timeout

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info session-setup-timeout="$value" />



=item C<< vserver >>

Vserver

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info vserver="$value" />



=item C<< current_status >>

Current Status possible value(s) are, on,off

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info is-currently-active="$value" />



=item C<< request_timeout >>

Request Service Timeout

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info request-timeout="$value" />



=item C<< privileged_users >>

List of Privileged Users
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $privileged_users = $obj->privileged_users();

# $privileged_users contains a reference to the array of values

my @privileged_users = $obj->privileged_users();

# @privileged_users contains the array of values

If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { privileged_users = [ value1, value2...] }


Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info></vscan-scanner-pool-info>



=item C<< scanner_pool >>

Scanner Pool

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info scanner-pool="$value" />



=item C<< scanner_policy >>

Applied Policy

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info scanner-policy="$value" />



=item C<< max_session_setup_retries >>

Max Number of Consecutive Session Setup Attempts

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info max-session-setup-retries="$value" />



=item C<< servers >>

List of IPs of Allowed Vscan Servers
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $servers = $obj->servers();

# $servers contains a reference to the array of values

my @servers = $obj->servers();

# @servers contains the array of values

If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { servers = [ value1, value2...] }


Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info></vscan-scanner-pool-info>



=item C<< scan_queue_timeout >>

Scan Queue Timeout

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info scan-queue-timeout="$value" />



=item C<< session_teardown_timeout >>

Session Teardown Timeout

Filled in for CMode CLI/ZAPI.
Maps to:

CMode ZAPI:

For "requested_fields", "filter" and Output mapping:

<vscan-scanner-pool-info session-teardown-timeout="$value" />



=item C<< cluster >>

Cluster on Which Policy Is Applied

Filled in for CMode CLI.


=item C<< hostnames >>

List of Host Names of Allowed Vscan Servers
(Array)
Note that for array fields, the accessor method can be invoked in either
scalar or list context.

my $hostnames = $obj->hostnames();
 
# $hostnames contains a reference to the array of values
 
my @hostnames = $obj->hostnames();
 
# @hostnames contains the array of values
 
If this field needs to be passed to the filter hash,
the value for this field should be passed in as an arrayref

# filter => { hostnames = [ value1, value2...] }

Filled in for CMode CLI.


=back

=cut

package NACL::CS::VserverVscanScannerPool;

use strict;
use warnings;
use Params::Validate qw(validate);
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

use NACL::Exceptions::NoElementsFound qw(:try);

use NACL::CS::ComponentState::ZapiSkip qw(make_zapi_skip);
use NACL::CS::ComponentState::ZapiArray qw(make_zapi_array);
use base 'NACL::CS::ComponentState::ONTAP';

use Class::MethodMaker [
    scalar => 'owner',
    scalar => 'session_setup_timeout',
    scalar => 'vserver',
    scalar => 'current_status',
    scalar => 'request_timeout',
    array  => 'privileged_users',
    scalar => 'scanner_pool',
    scalar => 'scanner_policy',
    scalar => 'max_session_setup_retries',
    array  => 'servers',
    scalar => 'scan_queue_timeout',
    scalar => 'session_teardown_timeout',
    scalar => 'cluster',
    array  => 'hostnames',
];

=head1 METHODS

=head2 fetch

    my $VserverVscanScannerPool_state  = NACL::CS::VserverVscanScannerPool->fetch(command_interface => $ci, ...);
    my @VserverVscanScannerPool_states = NACL::CS::VserverVscanScannerPool->fetch(command_interface => $ci, ...);

(Class method)
Discovers which elements are present and returns their state in ComponentState
objects. Called in scalar context it returns only one state object, in list
context it returns all state objects.
See L<NACL::CS::ComponentState|lib-NACL-CS-ComponentState-pm/fetch> for a
more detailed description along with a complete explanation of the options
it accepts.

Uses CMode CLI/ZAPI.

Invokes vscan-scanner-pool-get-iter API for CMode ZAPI.


=over

=item Exceptions

=over

=item C<NACL::Exceptions::NoElementsFound>

When there are no elements matching the query specified or elements of that type
doesn't exist, then this exception will be thrown.

=back

=back

=cut

sub fetch {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::fetch(
        @args,
        choices => [
            {   method    => '_fetch_cmode_cli',
                interface => 'CLI',
                set       => 'CMode'
            },
            {   method    => '_fetch_cmode_zapi',
                interface => 'ZAPI',
                set       => 'CMode'
            },
        ],
        show_cmd       => 'vserver vscan scanner-pool show',
        exception_text => 'No matching vserver vscan scanner-pool(s) found',
        frontend       => 'NACL::CS::VserverVscanScannerPool::fetch',
    );
    $Log->exit() if $may_exit;
    return wantarray ? @state_objs : $state_objs[0];
}

sub _fetch_cmode_cli {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_cli(@args,
        api => 'vserver_vscan_scanner_pool_show',);
    $Log->exit() if $may_exit;
    return @state_objs;
}

sub _fetch_cmode_zapi {
    $Log->enter() if $may_enter;
    my ($pkg, @args) = @_;
    my @state_objs = $pkg->SUPER::_fetch_cmode_zapi(
        @args,
        copy => [
            qw(session-setup-timeout vserver request-timeout scanner-pool scanner-policy
                max-session-setup-retries scan-queue-timeout session-teardown-timeout
                )
        ],
        map => {
            'owner'            => 'admin-owner',
            'current-status'   => 'is-currently-active',
            'privileged-users' => [
                make_zapi_array('privileged-users'),
                make_zapi_skip('privileged-user'),
            ],
            'servers' =>
                [make_zapi_array('servers'), make_zapi_skip('ip-address'),],
        },
        api => "vscan-scanner-pool-get-iter",
    );
    $Log->exit() if $may_exit;
    return @state_objs;
}
1;
