#
#   Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Common methods for the QosStatisticsWorkloadLatencyRollup component
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::CS::_Mixins::QosStatisticsWorkloadLatencyRollup;

use strict;
use warnings;

BEGIN {
    use Exporter qw(import);
    our @EXPORT_OK = qw(_common_zapi_copy );
    our %EXPORT_TAGS = ('all' => \@EXPORT_OK);
}

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();
use Params::Validate qw(:all);


sub _common_zapi_copy {
    $Log->enter() if $may_enter;
    my @copy = ( qw (dirty-buffers freed-blocks read-done readahead-x-stripe
                cpu-nblade-visits cpu-nblade-service-time cpu-nblade-wait-time cpu-dblade-visits cpu-dblade-service-time
                cpu-dblade-wait-time cpu-dblade-bg-visits cpu-dblade-bg-service-time cpu-dblade-bg-wait-time disk-hdd-bg-visits
                disk-hdd-bg-service-time disk-hdd-bg-wait-time disk-ssd-bg-visits disk-ssd-bg-service-time disk-ssd-bg-wait-time
                delay-wafl-susp-cp-visits delay-wafl-susp-cp-wait-time delay-cluster-interconnect-visits delay-cluster-interconnect-wait-time
                 delay-disk-io-visits delay-disk-io-wait-time delay-qos-limit-visits delay-qos-limit-wait-time delay-network-visits
                delay-network-wait-time node)
               );

    $Log->exit() if $may_exit;
    return wantarray ? @copy : [@copy];
}

1;

