# Copyright (c) 2009-2014 NetApp Inc.
# All rights reserved.
#
## @summary Exception with gather_diagnostics method defined on it.
## Any exception thrown by NACL::UnitTest::GatherDiagnostics library will be
## caught and NACL::Exceptions::GatherDiagnostics::UnitTest exception will
## be thrown by it so that gather_diagnostics method can be called by TCD.
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::GatherDiagnostics::UnitTest

=head1 Author/Maintainer

dl-nacl-dev

=head1 Description

Exception with gather_diagnostics method defined on it.
Any exception thrown by NACL::UnitTest::GatherDiagnostics library will be
caught and NACL::Exceptions::GatherDiagnostics::UnitTest exception will
be thrown by it so that gather_diagnostics method can be called by TCD.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::GatherDiagnostics::UnitTest

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::GatherDiagnostics::UnitTest;

use NACL::APISet::_Mixins::Exceptions::Common qw(convert);

use Tharn qw($Log);

sub make_base_of {
    my ($self, $ex) = @_;
    our @ISA = (ref($ex));
}

sub gather_diagnostics {
    $Log->comment("gather_diagnostics method is called");
}

1;
