#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when a choice
##          specified in the choices hash of call_on_apiset cannot be
##          used
##
## @author dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::Exceptions::InvalidChoice

=head1 Author/Maintainer

dl-nacl-dev

=head1 Description

An exception for when a choice specified in the choices hash of call_on_apiset
cannot be used

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::InvalidChoice

=head2 Expected use

Use when a choice specified in the choices hash of call_on_apiset cannot be
used

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::InvalidChoice;
use base qw(NATE::BaseException);
1;
