#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when an unknown filter field
##          is passed in a call to 'find'.
##
## @author madhavs@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NATE::Exceptions::InvalidFilterField

=head1 Author/Maintainer

Madhav Shekar, dl-nacl-dev

=head1 Description

An exception for when an unknown filter field is passed in a call to 'find'.

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::InvalidFilterField

=head2 Expected use

Use when an unknown filter field is passed in a call to 'find'.

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::InvalidFilterField;
use base qw(NATE::BaseException);

use Class::MethodMaker [
    array => 'unknown_filters',
    array => 'unknown_requested_fields'
];
1;
