# $Id: //depot/prod/test/nacldev/lib/NACL/Exceptions/LunSetFailure.pm#1 $
#
# Copyright (c) 2012 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::Exceptions::SetFailure that will be thrown whenever
##          Comparision of luns in the snapmirror relation got failed.
##
## @author sshaik@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::Exceptions::LunSetFailure

=head1 DESCRIPTION

This exception is thrown when comparison of luns under source and destination volumes
of the snapmirror got failed, and this exception will be the subclass of NACL::Exceptions::SetFailure
This exception will define a hashref which includes source_lun_path, destination_lun_path and
exception_object as keys of the hash.

=head1 ATTRIBUTES

=head2 text

=over

This attribute is a scalar, which will hold the error text.

=back

=head2 exception_objects

=over

This is an array attribute and each element of the array is a hash
reference which contains the following as hash keys

=item C<source_lun_path>

The source lun path.

=item C<destination_lun_path>

The destination lun path.

=item C<exception_object>

The exception object which is of type NACL::Exceptions::CompareLunFailure.
See L<NACL::Exceptions::CompareLunFailure|lib-NACL-Exceptions-CompareLunFailure-pm>

=back

=cut

package NACL::Exceptions::LunSetFailure;
use base qw(NACL::Exceptions::SetFailure);
1;
