#
#
# Copyright (c) 2009-2011 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the 
##          data population / modification operation fails
##          
##
## @author anerudh@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::MTask::DataUtils::Exceptions::OperationFailed

=head1 Author/Maintainer

dl-nacl-dev

=head1 Description

An exception thrown from NACL::MTask::Data if any of the data population 
operations has failed

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::OperationFailed

=head2 Expected use

This exception should only be thrown from NACL::MTask::Data

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::OperationFailed;
use base qw(NATE::BaseException);
1;
