#
# Copyright (c) 2013 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the
##          retry limit is reached by a library
##
## @author jreid@netapp.com, dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NATE::Exceptions::RetriesExceeded

=head1 Author/Maintainer

Jason Reid, dl-nacl-dev

=head1 Description

An exception for when a library reaches the retry limit

=head1 See Also

Package inherits from the BaseException module in NATE.

=head1 NACL::Exceptions::RetriesExceeded

=head2 Expected use

Use when the task retry count is exceeded

=head2 Base Class

NATE::BaseException

=cut

package NACL::Exceptions::RetriesExceeded;

use strict;
use warnings;

use base qw(NATE::BaseException);

1;
