#   Copyright (c) 2017 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.

package NACL::Init::Tasks::ONTAPSelect::ESX::InstallOvfTool;

use strict;
use warnings;
use Carp         qw(croak);

use Moo;
extends qw(NATE::Init::Task);
# need to do this to prevent Moo from clashing with NATE::BaseException
BEGIN {undef *with;}

use NATE::Log qw(log_global);

sub execute
{
    my ($self, %args) = @_;
    my %task_args = %{$self->task_args};
    my $log = log_global;

    $log->info('Installing ovftool...');
    my $proc = NATE::Process->new(
        'username' => 'root',
        'codespec' => $task_args{'OVFTOOL_INSTALLER'},
        'onexit'   => \&NATE::Process::on_exit_die_on_non_zero_exit_status,
        'args'     => [
            '--eulas-agreed',
            '--required',
        ],
    );
    $proc->start;
    $proc->wait;
    $proc->destroy;
}

1;
