#
#
# Copyright (c) 2015 NetApp Inc.
# All rights reserved.
#
## @summary Provide a generic exception class (a subclass of
##          NATE::BaseException) that will be thrown for
##          generic file operation failures.
##          Callers should catch this specific exception
##          for handling file operation failures.
##          See NACL::MTask::BSDFileOps for examples.
##
## @author nimishp@netapp.com
## @status Shared
## @pod here

=pod

=head1 Package Name

NACL::MTask::Exceptions::FileOperationFailed

=head1 Author/Maintainer

dl-kernel-qa

=head1 Description

A generic NACL exception for file operation failures on clients
or filers.

=head1 See Also

Package inherits from NATE::BaseException

=head1 NACL::MTask::Exceptions::FileOperationFailed

=head2 Expected use

Throw this exception for file operation failures.

=head2 Base Class

NATE::BaseException

=cut

package NACL::MTask::Exceptions::FileOperationFailed;
use base qw(NATE::BaseException);

1;
