# $Id:$
#
# Copyright (c) 2001-2013 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::Exceptions::Timeout that will be thrown when
##          wafliron start fails after specified number of
##          retries and start timeout.
##
## @author dl-nacl-dev@netapp.com
## @status public
## @pod here

=pod

=head1 Package Name

NACL::MTask::Exceptions::IronStartFailure

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown when wafliron start fails after specified number of retries and start timeout.

=head1 NACL::MTask::Exceptions::IronStartFailure

=head2 Base Class

NACL::Exceptions::Timeout

=head1 See Also

Package inherits from the following modules. See these modules for further
interface details.

B<NACL/Exceptions/Timeout>

=cut

package NACL::MTask::Exceptions::IronStartFailure;

## Note that the package inherits NACL::Exceptions::Timeout
## to provide backward compatibility with the old behaviour of NACL::MTask::Wafliron

use base qw(NACL::Exceptions::Timeout);

1;
