# $Id: //depot/prod/test/nacldev/lib/NACL/MTask/LunMount.pm# $
#
# Copyright (c) 2012 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Performing LunMount setup in client.
## @author kathar.hidayath@netapp.com, dl-nacl-dev@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::MTask::LunMount

=head1 DESCRIPTION

C<NACL::MTask::LunMount> provides a number of well-defined but
potentially complex or multi-step methods related to Lun Mount in Client.

This is an alias of C<NACL::MTask::Client::LunMount>. The functionality offered
is documented at L<NACL::MTask::Client::LunMount|lib-NACL-MTask-Client-LunMount-pm>

=cut

package NACL::MTask::LunMount;
use base 'NACL::MTask::Client::LunMount';

# Storable blesses the object (during thaw) with the appropriate class
# name and load the library if we place storable hooks. Hence the foll
# hooks are added, otherwise there is no customization needed in freeze
# and thaw operations.

use Storable qw(freeze thaw);

sub STORABLE_freeze {
    my ( $self, $cloning ) = @_;
    return if $cloning;    # Regular default serialization
    my $data  = {%$self};
    my $dummy = "";
    return ( $dummy, $data );
} ## end sub STORABLE_freeze

sub STORABLE_thaw {
    my ( $self, $cloning, $dummy, $data ) = @_;
    %$self = %$data;
}
1;
