#
#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::MTask::MCC::Exceptions::DiskState
##          that will be thrown when an MCC disk state is invalid
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package NACL::MTask::MCC::Exceptions::DiskState::FailedDisk;

use strict;
use warnings;
use Carp;

use base qw(NACL::MTask::MCC::Exceptions::DiskState);

=pod

=head1 Package Name

NACL::MTask::MCC::Exceptions::DiskState::FailedDisk

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

NACL::MTask::MCC::Exceptions::DiskState::FailedDisk is a subclass of
NATE::Mtask::MCC:Exceptions::DiskState that will be thrown when an MCC
disk state is invalid.

    NACL::MTask::MCC::Exceptions::DiskState::FailedDisk->
                                                     throw('my error message');


=head1 See Also

Package inherits from the DiskState module in NACL::MTask::MCC::Exceptions.

=head2 Base Class

NACL::MTask::MCC::Exceptions::DiskState

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

