#
#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NACL::MTask::MCC::Exceptions::State
##          that will be thrown when MCC is in state
##          complete-with-warnings
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package NACL::MTask::MCC::Exceptions::State::OperationTimeOverrun;

use strict;
use warnings;
use Carp;

use parent qw(NACL::MTask::MCC::Exceptions::State);

=pod

=head1 Package Name

NACL::MTask::MCC::Exceptions::State::OperationTimeOverrun

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

NACL::MTask::MCC::Exceptions::State::OperationTimeOverrun is a subclass of
NACL::MTask::MCC::Exceptions::State that will be thrown when an MCC
dr operation (metrocluster operation show) time takes longer than
the specification.

metrocluster switchover and metrocluster switchback are specified to
take a maximum of 300 seconds (5 minutes)


    NACL::MTask::MCC::Exceptions::State::OperationTimeOverrun->
                                                     throw('my error message');


=head1 See Also

Package inherits from the State module in NACL::MTask::MCC::Exceptions.

=head2 Base Class

NACL::MTask::MCC::Exceptions::State

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

