#
#
# Copyright (c) 2010-2013 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when validation
##          of mcc states fail.
##
## @author dl-mcc-dpg-qa@netapp.com
## @status Shared
## @pod here

package NACL::MTask::MCC::Exceptions::Validation;

use strict;
use warnings;
use Carp;

use base qw(NACL::MTask::MCC::Exceptions::BaseException);

=pod

=head1 Package Name

NACL::MTask::MCC::Exceptions::Validation

=head1 Author/Maintainer

dl-mcc-dpg-qa@netapp.com

=head1 Description

NACL::MTask::MCC::Exceptions::Validation is a subclass of
NATE::BaseException that will be thrown when validation
of mcc states fail.

    NACL::MTask::MCC::Exceptions::Validation->throw('my error message');

See NACL::MTask::MCC::Metrocluster::Validation() for an example
usage.

=head1 See Also

Package inherits from the BaseException module in NACL::MTask::MCC::Exceptions.

=head2 Base Class

NACL::MTask::MCC::Exceptions::BaseException

=cut

# No functionality changes compared to NATE::BaseException, just more specific
# object identity wrt MCC systems.

1;

