# $Id: //depot/prod/test/nacldev/lib/NACL/MTask/Set/SnapshotListCompare.pm# $

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Set of VolumeSnapshot ComponentState objects
## @author msmeena@netapp.com
## @status shared
## @pod here

package NACL::MTask::Set::SnapshotListCompare;

use strict;
use warnings;

use base 'NACL::MTask::Set';
use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 NAME

NACL::MTask::Set::SnapshotListCompare

=head1 DESCRIPTION

This module implements a set containing VolumeSnapshot component state objects.
Each set contains only unique volume snapshot componentstates, where the
uniqueness criteria is determined by the snapshot name string.

See L<NACL::MTask::Set|lib-NACL-MTask-Set-pm> for a description of a set and
the operations that can be performed on a set.

=cut

sub _calculate_key_of_member {
    $Log->enter() if $may_enter;
    my ( $self, $member ) = @_;
    my $str = $member->snapshot();
    $Log->exit() if $may_exit;
    return $str;
}

sub _base_type { return 'NACL::CS::VolumeSnapshot'; }

1;
