use utf8;
package NACL::ResourceList::Schema::Result::Command;

=head1 NAME

NACL::ResourceList::Schema::Result::Command

=cut

use strict;
use warnings;

use base 'DBIx::Class::Core';

=head1 TABLE: C<Commands>

=cut

__PACKAGE__->table("Command");

=head1 ACCESSORS

=head2 id

  data_type: 'integer'
  is_auto_increment: 1
  is_nullable: 0

=head2 command

  data_type: 'varchar'
  is_nullable: 1
  size: 45

=cut

__PACKAGE__->add_columns(
  "id",
  { data_type => "integer", is_auto_increment => 1, is_nullable => 0 },
  "command",
  { data_type => "varchar", is_nullable => 1, size => 245 },
);

=head1 PRIMARY KEY

=over 4

=item * L</id>

=back

=cut

__PACKAGE__->set_primary_key("id");

=head1 UNIQUE CONSTRAINTS

=head2 C<command_unique>

=over 4

=item * L</command>

=back

=cut

__PACKAGE__->add_unique_constraint("command_unique", ["command"]);

=head1 RELATIONS

=head2 command_histories

Type: has_many

Related object: L<NACL::ResourceList::Schema::Result::CommandHistory>

=cut

__PACKAGE__->has_many(
  "command_histories",
  "NACL::ResourceList::Schema::Result::CommandHistory",
  { "foreign.command_id" => "self.id" },
  { cascade_copy => 0, cascade_delete => 0 },
);


1;
