use utf8;
package NACL::ResourceList::Schema::Result::CommandHistory;

=head1 NAME

NACL::ResourceList::Schema::Result::CommandHistory

=cut

use strict;
use warnings;

use base 'DBIx::Class::Core';

=head1 TABLE: C<Command_History>

=cut

__PACKAGE__->table("Command_History");

=head1 ACCESSORS

=head2 id

  data_type: 'integer'
  is_auto_increment: 1
  is_nullable: 0

=head2 element_id

  data_type: 'integer'
  is_foreign_key: 1
  is_nullable: 1

=head2 command_id

  data_type: 'integer'
  is_foreign_key: 1
  is_nullable: 1

=cut

__PACKAGE__->add_columns(
  "id",
  { data_type => "integer", is_auto_increment => 1, is_nullable => 0 },
  "element_id",
  { data_type => "integer", is_foreign_key => 1, is_nullable => 1 },
  "command_id",
  { data_type => "integer", is_foreign_key => 1, is_nullable => 1 },
);

=head1 PRIMARY KEY

=over 4

=item * L</id>

=back

=cut

__PACKAGE__->set_primary_key("id");

=head1 RELATIONS

=head2 arguments

Type: has_many

Related object: L<NACL::ResourceList::Schema::Result::Argument>

=cut

__PACKAGE__->has_many(
  "arguments",
  "NACL::ResourceList::Schema::Result::Argument",
  { "foreign.command_seq_id" => "self.id" },
  { cascade_copy => 0, cascade_delete => 0 },
);

=head2 command

Type: belongs_to

Related object: L<NACL::ResourceList::Schema::Result::Command>

=cut

__PACKAGE__->belongs_to(
  "command",
  "NACL::ResourceList::Schema::Result::Command",
  { id => "command_id" },
  {
    is_deferrable => 0,
    join_type     => "LEFT",
    on_delete     => "CASCADE",
    on_update     => "CASCADE",
  },
);

=head2 element

Type: belongs_to

Related object: L<NACL::ResourceList::Schema::Result::Element>

=cut

__PACKAGE__->belongs_to(
  "element",
  "NACL::ResourceList::Schema::Result::Element",
  { id => "element_id" },
  {
    is_deferrable => 0,
    join_type     => "LEFT",
    on_delete     => "CASCADE",
    on_update     => "CASCADE",
  },
);


1;
