# Copyright (c) 2016 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary AVA Node Task Module
## @author rjray@netapp.com,ng-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::STask::AVANode;

use strict;
use warnings;
use base qw(NACL::C::AVANode NACL::STask::STask);

use NATE::Exceptions::Argument qw(:try);
use NATE::Log qw(log_global);

# Set up the global logging object and the conditionals for logging enter/exit
my $Log       = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 NAME

NACL::STask::AVANode

=head1 DESCRIPTION

C<NACL::STask::AVANode> provides a collection of methods that are more complex
and/or multi-step, when compared to the methods of B<NACL::C::AVANode>.

This class builds on, and derives from, the B<NACL::C::AVANode> class. As such,
objects of this class can be used to dispatch all the basic AltaVault commands
that a B<NACL::C::Node> object can. See the documentation for B<NACL::C::Node>
for details.

=head1 ATTRIBUTES

This class does not add any attributes to those already defined by
B<NACL::C::Node>.

=head1 METHODS

At present, there are no methods here.

The candidates for inclusion here will be methods that only operate on an
AVA connection (i.e., are not MTask candidates), but require composite logic.

For example, where B<NACL::C::AVANode> allows adding of an IP address to the
AVA's whitelist, at the STask level one may want to allow adding multiple
addresses at once, with the option of rebooting the AVA node afterwards (you
wouldn't want the B<NACL::C::AVANode> method to reboot the node after every
single IP addressed added).

=head1 AUTHORS

Randy J. Ray C<< <rjray@netapp.com> >>
ng-nacl-dev C<< <ng-nacl-dev@netapp.com> >>

=cut

1;
