# $Id: //depot/prod/test/nacldev/lib/NACL/STask/DFM.pm#1 $

#
# Copyright (c) 2001-2011 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Base class for DFM STasks
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::STask::DFM;

=head1 NAME

NACL::STask::DFM

=head1 DESCRIPTION

This is the base class for DFM STasks. It provides DFM-specific
customizations of methods provided by NACL::STask::STask.

=cut

use base qw(NACL::STask::STask);

use strict;
use warnings;

use NATE::Log qw(log_global);
my $Log = log_global();
my $may_enter = $Log->may_enter();
my $may_exit  = $Log->may_exit();

=head1 METHODS

=head2 _if_exists_validate_spec

Like
L<NACL::STask::STask::_if_exists_validate_spec|lib-NACL-STask-STask-pm/_if_exists_validate_spec>
but with the default being "reuse" rather than "die".

=cut

sub _if_exists_validate_spec {
    $Log->enter();
    my $pkg = shift;
    $Log->exit();
    return { %{$pkg->SUPER::_if_exists_validate_spec()}, default => 'reuse' };
}

=head2 _element_exists_handler

Like
L<NACL::STask::STask::_element_exists_handler|lib-NACL-STask-STask-pm/_element_exists_handler>
but with the C<create_to_new_purge_mapping> defaulted to the mapping as
defined by C<_create_to_pk_mapping()> in the Component.

=cut

sub _element_exists_handler {
    $Log->enter();
    my $pkg = shift;
    my %mapping;
    if ($pkg->can('_create_to_pk_mapping') ) {
        $mapping{create_to_new_purge_mapping} = $pkg->_create_to_pk_mapping();
    }
    $Log->exit();
    return $pkg->SUPER::_element_exists_handler(
        %mapping,
        @_
    );
}

1;
