#
# Copyright (c) 2014 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown when the
##          call to NACL::STask::Client::Mount->fetch fails because
##          no mount point with given atrribute was found.
##
## @author  dl-nacl-dev@netapp.com
## @status Shared
## @pod here

=head1 NAME

NACL::STask::Exceptions::Client::Mount::NotMounted

=head1 EXAMPLES

=head2 Throwing exception

 my $found = NACL::STask::Client::Mount->find(
        command_interface => $opts{command_interface},
        filter            => {'mount_point' => $self->mount_point()},
        allow_empty       => 1
    );
    if (!$found) {
        $Log->exit();
        NACL::STask::Exceptions::Client::Mount::NotMounted->throw();
    }
=cut

package NACL::STask::Exceptions::Client::Mount::NotMounted;

use base 'NATE::BaseException';

1;
