#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Lun Copy Stask
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here

package NACL::STask::LunCopy;
use strict;
use warnings;
use base qw(NACL::C::LunCopy NACL::STask::STask );

use Params::Validate qw(SCALAR);

use NACL::STask::_Mixins::LunMoveCopy qw(:all);

=head1 NAME

NACL::STask::LunCopy

=head1 DESCRIPTION

C<NACL::STask::LunCopy> This class provides methods to copy luns from
source volume to destination volume. This class makes heavy use of
the mixin class C<NACL::STask::_Mixins::LunMoveCopy>. This class
inherits from C<NACL::C::LunCopy>.

=head1 METHODS

Please see  C<NACL::STask::_Mixins::LunMoveCopy> and
C<NACL::C::LunCopy> for available methods.

=over

=item Exceptions

=over

=item C<NATE::Exceptions::Argument>

This type of exception is thrown when there are insufficient arguments
to start lun copy.

=item C<NACL::Exceptions::UnexpectedState>

This type of exception is thrown when scanner status for a lun copy job
is in unexpected state.

=item C<NACL::APISet::Exceptions::TimeoutException>

This type of exception is thrown when timeout occured while waiting
for lun copy job to finish.

=item C<NACL::C::Exceptions::Lun::AlreadyExists>

This type of exception is thrown when we try to start Lun Copy job
without completion of earlier job.

=item C<NACL::C::Exceptions::Lun::DoesNotExist>

This type of exception is thrown when we try to copy a lun which
does not exist.

=item C<NACL::STask::Exceptions::LunMoveCopyFailed>

This type of exception is thrown when lun move/copy operation is failed.

=item Other exceptions

See L<< NACL::C::LunCopy >> for all other exceptions that
this method could throw.

=back

=back

=cut

1;
