=head1 NAME

NACL::STask::SystemNodeAutosupport

=head1 DESCRIPTION

C<NACL::STask::SystemNodeAutosupport> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Cifs Options
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::SystemNodeAutosupport>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::SystemNodeAutosupport> for
details.  This also means that a C<NACL::STask::SystemNodeAutosupport> object may
generally be used in place of a component object.


=head1 METHODS

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::SystemNodeAutosupport::modify|lib-NACL-C-SystemNodeAutosupport-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut

package NACL::STask::SystemNodeAutosupport;

use base qw(NACL::C::SystemNodeAutosupport NACL::STask::STask);

__PACKAGE__->modify_method_builder();

1;

