#
# Copyright (c) 2013 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary Volume File Move Stask
## @author dl-nacl-dev@netapp.com
## @status shared
## @pod here


package NACL::STask::VolumeFileMove;
use strict;
use warnings;
use base qw(NACL::C::VolumeFileMove NACL::STask::STask );

use Params::Validate qw(SCALAR);

use NACL::STask::_VolumeFile qw(:all);

=head1 NAME

NACL::STask::VolumeFileMove

=head1 DESCRIPTION

C<NACL::STask::VolumeFileMove> This class makes heavy use of the mixin 
class C<NACL::STask::_VolumeFile>. This class inherits from 
C<NACL::C::VolumeFileMove>.

=head1 METHODS

Please see  C<NACL::STask::_VolumeFile> and C<NACL::C::VolumeFileMove>
for available methods.

=over

=item Exceptions

=over

=item C<NATE::Exceptions::Argument>

This type of exception is thrown when there are insufficient arguments to start volume file move.

=item C<NACL::Exceptions::UnexpectedState>

This type of exception is thrown when scanner status for an ondemand job is in unexpected state.

=item C<NACL::APISet::Exceptions::TimeoutException>

This type of exception is thrown when timeout occured while waiting for ondemand job to finish.

=back

=cut

1;
