# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifs Task Module
## @author ng-ptefit-automation-core@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::STask::VserverCifs

=head1 DESCRIPTION

C<NACL::STask::VserverCifs> provides a number of well-defined but potentially
 complex or multi-step methods related to Volume Quota Policy in ONTAP.

 It is created on top of C<NACL::C::VserverCifs> component
 Since it is derived class of C<NACL::C::VserverCifs>,
 we can use all the methods of C<NACL::C::VserverCifs>
 from the object of this task.


=cut

package NACL::STask::VserverCifs;

use base qw(NACL::C::VserverCifs NACL::STask::STask);

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();
__PACKAGE__->create_method_builder(stask_method_name => 'add_netbios_aliases', c_method_name => 'add_netbios_aliases');
__PACKAGE__->purge_method_builder(stask_method_name => 'remove_netbios_aliases', c_method_name => 'remove_netbios_aliases');


1;
