# Copyright (c) 2015 NetApp, Inc., All Rights Reserved
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @summary VserverCifsHomeDirectorySearchPath Task Module
## @author ng-ptefit-automation-core@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::STask::VserverCifsHomeDirectorySearchPath

=head1 DESCRIPTION

C<NACL::STask::VserverCifsHomeDirectorySearchPath> provides a number of well-defined but potentially
 complex or multi-step methods related to Volume Quota Policy in ONTAP.

 It is created on top of C<NACL::C::VserverCifsHomeDirectorySearchPath> component
 Since it is derived class of C<NACL::C::VserverCifsHomeDirectorySearchPath>,
 we can use all the methods of C<NACL::C::VserverCifsHomeDirectorySearchPath>
 from the object of this task.


=head1 METHODS

=head2 add

L<< NACL::STask::STask->create_method_builder(c_method_name => 'add')|lib-NACL-STask-STask-pm/create_method_builder >>

=head2 remove

L<< NACL::STask::STask->purge_method_builder(c_method_name => 'remove')|lib-NACL-STask-STask-pm/purge_method_builder >>

=cut

package NACL::STask::VserverCifsHomeDirectorySearchPath;

use base qw(NACL::C::VserverCifsHomeDirectorySearchPath NACL::STask::STask);

__PACKAGE__->create_method_builder(stask_method_name => 'add', c_method_name => 'add');
__PACKAGE__->purge_method_builder(stask_method_name => 'remove', c_method_name => 'remove');

1;
