=head1 NAME

NACL::STask::VserverCifsOptions

=head1 DESCRIPTION

C<NACL::STask::VserverCifsOptions> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Cifs Options
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverCifsOptions>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverCifsOptions> for
details.  This also means that a C<NACL::STask::VserverCifsOptions> object may
generally be used in place of a component object.


=head1 METHODS

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::VserverCifsOptions::modify|lib-NACL-C-VserverCifsOptions-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut

package NACL::STask::VserverCifsOptions;

use base qw(NACL::C::VserverCifsOptions NACL::STask::STask);

__PACKAGE__->modify_method_builder();

1;

