=head1 NAME

NACL::STask::VserverCifsUsersAndGroupsLocalUser

=head1 DESCRIPTION

C<NACL::STask::VserverCifsUsersAndGroupsLocalUser> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver CIFS Users and
Group in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverCifsUsersAndGroupsLocalUser>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverCifsUsersAndGroupsLocalUser> for
details.  This also means that a C<NACL::STask::VserverCifsUsersAndGroupsLocalUser> object may
generally be used in place of a component object.


=head1 METHODS

=head2 create

This accepts the same options and provides the same facilities as
L<NACL::C::VserverCifsUsersAndGroupsLocalUser::create|lib-NACL-C-VserverCifsUsersAndGroupsLocalUser-pm/create>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>, C<MCC checks>. The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 purge

This accepts the same options and provides the same facilities as
L<NACL::C::VserverCifsUsersAndGroupsLocalUser::delete|lib-NACL-C-VserverCifsUsersAndGroupsLocalUser-pm/delete>.
Additionally, the STask provides the following facilities: C<nacltask_verify>,
C<MCC checks>. The description of these features are
present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::VserverCifsUsersAndGroupsLocalUser::modify|lib-NACL-C-VserverCifsUsersAndGroupsLocalUser-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut

package NACL::STask::VserverCifsUsersAndGroupsLocalUser;

use base qw(NACL::C::VserverCifsUsersAndGroupsLocalUser NACL::STask::STask);


__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();
__PACKAGE__->modify_method_builder();

1;
