=head1 NAME

NACL::STask::VserverIscsiSecurity

=head1 DESCRIPTION

C<NACL::STask::VserverIscsiSecurity> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Export Policy Rule
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverIscsiSecurity>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverIscsiSecurity> for
details.  This also means that a C<NACL::STask::VserverIscsiSecurity> object may
generally be used in place of a component object.


=head1 METHODS

=head2 create

This accepts the same options and provides the same facilities as
L<NACL::C::VserverIscsiSecurity::create|lib-NACL-C-VserverIscsiSecurity-pm/create>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>.  The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 purge

This accepts the same options and provides the same facilities as
L<NACL::C::VserverIscsiSecurity::delete|lib-NACL-C-VserverIscsiSecurity-pm/delete>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::VserverIscsiSecurity::modify|lib-NACL-C-VserverIscsiSecurity-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut

package NACL::STask::VserverIscsiSecurity;

use base qw(NACL::C::VserverIscsiSecurity NACL::STask::STask);

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();
__PACKAGE__->modify_method_builder();

1;
