# Copyright (c) 2014-2015 NetApp, Inc.
# All rights reserved.
#
## @summary VserverSecurityTraceFilter Task Module
## @author namitha.k@netapp.com
## @status shared
## @pod here

=head1 NAME

NACL::STask::VserverSecurityTraceFilter

=head1 DESCRIPTION

C<NACL::STask::VserverSecurityTraceFilter> provides a number of well-defined but
potentially complex or multi-step methods related to VserverSecurityTraceFilter in
ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverSecurityTraceFilter>,
and so it also provides methods that are more in the scope of
individual VserverSecurityTraceFilter-related commands.  See C<NACL::C::VserverSecurityTraceFilter>
for details.  This also means that a C<NACL::STask::VserverSecurityTraceFilter> object may
generally be used in place of a component object.

=head1 ATTRIBUTES

=head2 command_interface

(Required) A component object that represents the host to which to send commands.
See L<NACL::C::Component::command_interface|lib-NACL-C-Component-pm/command_interface>.

=head1 METHODS

=head2 create

This accepts the same options and provides the same facilities as
L<NACL::C::VserverSecurityTraceFilter::create|lib-NACL-C-VserverSecurityTraceFilter-pm/create>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>.  The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 purge

This accepts the same options and provides the same facilities as
L<NACL::C::VserverSecurityTraceFilter::delete|lib-NACL-C-VserverSecurityTraceFilter-pm/delete>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::VserverSecurityTraceFilter::modify|lib-NACL-C-VserverSecurityTraceFilter-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut 

package NACL::STask::VserverSecurityTraceFilter;

use base qw(NACL::C::VserverSecurityTraceFilter NACL::STask::STask);

__PACKAGE__->create_method_builder();
__PACKAGE__->purge_method_builder();
__PACKAGE__->modify_method_builder();

1;




