=head1 NAME

NACL::STask::VserverServicesNameServiceDnsDynamicUpdate

=head1 DESCRIPTION

C<NACL::STask::VserverServicesNameServiceDnsDynamicUpdate> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Services NameService Dns Dynamic Update
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverServicesNameServiceDnsDynamicUpdate>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverServicesNameServiceDnsDynamicUpdate> for
details.  This also means that a C<NACL::STask::VserverServicesNameServiceDnsDynamicUpdate> object may
generally be used in place of a component object.


=head1 METHODS

=head2 modify

This accepts the same options and provides the same facilities as
L<NACL::C::VserverServicesNameServiceDnsDynamicUpdate::modify|lib-NACL-C-VserverServicesNameServiceDnsDynamicUpdate-pm/modify>.
Additionally, the STask provides the following facilities: C<nacltask_verify>.
The description of these features are present at:
L<Common modify options|lib-NACL-STask-STask-pm/Common_Modify_Options>.

=cut

package NACL::STask::VserverServicesNameServiceDnsDynamicUpdate;

use base qw(NACL::C::VserverServicesNameServiceDnsDynamicUpdate NACL::STask::STask);

__PACKAGE__->modify_method_builder();

1;
