=head1 NAME

NACL::STask::VserverServicesWebAccess

=head1 DESCRIPTION

C<NACL::STask::VserverServicesWebAccess> provides a number of well-defined but
potentially complex or multi-step methods related to Vserver Services Web Access
in ONTAP.

It builds on top of, and is a derived class of C<NACL::C::VserverServicesWebAccess>,
and so it also provides methods that are more in the scope of
individual vserver-related commands.  See C<NACL::C::VserverServicesWebAccess> for
details.  This also means that a C<NACL::STask::VserverServicesWebAccess> object may
generally be used in place of a component object.


=head1 METHODS

=head2 create

This accepts the same options and provides the same facilities as
L<NACL::C::VserverServicesWebAccess::create|lib-NACL-C-VserverServicesWebAccess-pm/create>.
Additionally, the STask provides the following facilities: C<Cleanup>,
C<nacltask_verify>, C<MCC checks>. The description of these features are
present at:
L<Common Create options|lib-NACL-STask-STask-pm/Common_Create_Options>.

=head2 purge

This accepts the same options and provides the same facilities as
L<NACL::C::VserverServicesWebAccess::delete|lib-NACL-C-VserverServicesWebAccess-pm/delete>.
Additionally, the STask provides the following facilities: C<nacltask_verify>,
C<MCC checks>. The description of these features are
present at:
L<Common Purge options|lib-NACL-STask-STask-pm/Common_Purge_Options>.

=cut

package NACL::STask::VserverServicesWebAccess;

use base qw(NACL::C::VserverServicesWebAccess NACL::STask::STask);

use strict;
use warnings;

__PACKAGE__->create_method_builder(if_exists => 0, mcc_check => 1);
__PACKAGE__->purge_method_builder(if_purged => 0, mcc_check => 1);

1;
