#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

from NATE.Service.Base import Base as NATEService;

class Base (NATEService):
    def __init__ (self, admin_mail = 'dl-nacl-dev@netapp.com',**args):
        super().__init__(admin_mail=admin_mail,**args);

    def public_api (self):
        return({});

    def setup (self, **args):
        super().setup(**args);
        module = str(self.__module__);
        namespace = module.replace('.','::');
        api = self.public_api();
        if (len(api)>0):
            for k in (api):
                if('worker_type' in api[k]):
                    worker = api[k]['worker_type'];
                    if (worker):
                        if (worker == 1):
                            # generic worker class
                            api[k]['worker_type'] = module+'.Worker';
                    else:
                        # no worker defined, this is a passive API
                        del(api[k]['worker_type']);
            self.api_register_bulk(namespace=namespace, structure=api);
