#
# Copyright (c) 2014 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::Service::Configurator;

use strict;
use warnings;

use parent qw(NACL::Service);

use Params::Validate
    qw(validate_with BOOLEAN HASHREF OBJECT ARRAYREF SCALAR UNDEF);

use constant public_api => (
                            store    => {worker_type => 0},
                            retrieve    => {worker_type => 0},
                            configure_using_preset => {worker_type => 0},
                            );

sub configure_using_preset {
    my $self = shift;
    #my %opts = @_;
    # ...
    my %opts = validate_with(
        params => \@_,
        spec   => {
            'preset' => { 'type' => SCALAR },
            'target' => { 'type' => HASHREF },
        },
        allow_extra => 1,
    );
    #when subtests work call the appbuilder lib here...
}

1;
__END__
