#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::Service::Events;

use strict;
use warnings;

use parent qw(NACL::Service);

use constant worker_pool_maximums => {'NACL::Service::Events::Worker'=>10};
use constant public_api => (



    sfmod                 => { worker_type => 1 },
    sfcod                 => { worker_type => 1 },

    portToggle            => { worker_type => 1 },

    # covered by icfailure
    interclusterFailure   => { worker_type => 1 },

    # covered by reboot
    reboot                => { worker_type => 1 },

    # covered by ARL
    ARL                   => { worker_type => 1 },

    # covered by TOGB
    TOGB                  => { worker_type => 1 },
    takeover              => { worker_type => 1 },
    giveback              => { worker_type => 1 },

    # covered by luns_and_files
    #lunOnline             => { worker_type => 1 },
    #lunOffline            => { worker_type => 1 },
    lunOfflineOnline      => { worker_type => 1 },
    volumeFileClone       => { worker_type => 1 },

    # covered by volumeOps
    volMove               => { worker_type => 1 },
    volumeClone           => { worker_type => 1 },
    volumeCreate          => { worker_type => 1 },
    volumeDelete          => { worker_type => 1 },
    volOnline             => { worker_type => 1 },
    volOffline            => { worker_type => 1 },
    volOfflineOnline      => { worker_type => 1 },
    volumeCreateDelete    => { worker_type => 1 },

    #covered by dummyOpTestcases
    dummyOp               => { worker_type => 1 },

    # covered by snapmirrorShowTestcases
    snapmirrorShow        => { worker_type => 1 },

    # covered by snapmirrorShowHistoryTestcases
    snapmirrorShowHistory => { worker_type => 1 },

    #
    snapshotCreateDelete  => { worker_type => 1 },
);

sub new
{
    my ($proto, %opts) = @_;
    my $class = ref($proto) || $proto;
    return $class->SUPER::new(%opts);
}

1;
