#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

## @pod here
## @author dl-nacl-dev@netapp.com
## @summary An example resource module for Xgen

package NACL::Service::Xgen::Examples::ExampleResource;

# This is a derived class of the Base Resource module
use parent qw(NACL::Service::Xgen::Resource);

1;

__END__

=head1 NAME

NACL::Service::Xgen::Examples::ExampleResource

=head1 DESCRIPTION

This is a simple example implementation of an Xgen Resource module. See the base class for all APIs
L<C<NACL::Service::Xgen::Resource>|lib-NACL-Service-Xgen-Resource-pm> that are available.

=head1 IMPLEMENTATION

To create a resource module, the very minimum that is needed is to make it a derived class of
L<C<NACL::Service::Xgen::Resource>|lib-NACL-Service-Xgen-Resource-pm>.

=head2 Code

=over

 package NACL::Service::Xgen::Examples::ExampleResource;

 # This is a derived class of the Base Resource module
 use parent qw(NACL::Service::Xgen::Resource);

=back

=head1 SEE ALSO

For a more detailed example, see
L<C<NACL::Service::Xgen::Examples::ExampleResourceComplex>|lib-NACL-Service-Xgen-Examples-ExampleResourceComplex-pm>

To see this resource being used in a configuration module, see
L<C<NACL::Service::Xgen::Examples::ExampleConfig>|lib-NACL-Service-Xgen-Examples-ExampleConfig-pm>

=head1 AUTHOR/MAINTAINER

=over

=item NACL Development (dl-nacl-dev@netapp.com)

=back

=cut
