#
# Copyright (c) 2009-2010 NetApp Inc.
# All rights reserved.
#
## @summary Provide an exception class that is a subclass of
##          NATE::BaseException that will be thrown the number of retries have
##          been exceeded while trying to reach the specified state
##
## @author dl-nacl-dev@netapp.com
## @status private
## @pod here

=pod

=head1 Package Name

NACL::Transit::Exceptions::RetriesExceeded

=head1 Author

dl-nacl-dev@netapp.com

=head1 Description

An exception to be thrown if the number of retries are exceeded while trying to 
get to the specified state

=head1 See Also

Package inherits from the following modules. See these modules for further 
interface detail.

=head1 NACL::Transit::Exceptions::RetriesExceeded

=head2 Expected use

When the number of retries are exceeded while trying to get to the specified 
state

=head2 Usage

Same as for exceptions defined by BaseException

=head2 Base Class

NATE::BaseException

=cut

package NACL::Transit::Exceptions::RetriesExceeded;
use base qw(NACL::Transit::Exceptions::TransitException);
1;
