#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Cluster;

use strict;
use warnings;

use parent qw( NACL::AppBuilder::Xgen::Config::ONTAP );

use NACL::AppBuilder::Xgen::Resource::Cluster;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->update_cluster_resources(%args);

}

sub update_cluster_resources {
    my ($self, %args) = @_;

    my $cluster_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Cluster");
    my @clusters = @{$cluster_resources};
    
    foreach my $cluster (@clusters) {
        $cluster->set_private_attributes(autosupport                => 'enable',
                                         ipv6_enabled               => 'true',
                                         'is-ra-processing-enabled' => 'true',);
    }
}

1;

