#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::ClusterPeer;

use strict;
use warnings;

use parent qw( NACL::AppBuilder::Xgen::Config::ONTAP );

use NACL::AppBuilder::Xgen::Resource::ClusterPeer;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_clusterpeer_resources(%args);

}

sub generate_clusterpeer_resources {
    my ($self, %args) = @_;

    my $cluster_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Cluster");
    my @clusters = @{$cluster_resources};
    my @clusterpeer;

    my $clus_res = NACL::AppBuilder::Xgen::Resource::ClusterPeer->new(cluster => $clusters[0]->get_attribute("cluster_name"),
                                                                      rcluster => $clusters[1]->get_attribute("cluster_name"),
                                                                     );

    # connect the vs resource to the aggr's cluster parent resource
    $clus_res->add_parent_resources(resources => [$clusters[1],$clusters[0]]);

    push(@clusterpeer, $clus_res);
    $self->add_resources(resources => \@clusterpeer);
}

1;

