#
# Copyright (c) 2017 NetApp, Inc., All Rights Reserved.
#   Any use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::FlexGroupVol;

use strict;
use warnings;

use parent qw(NACL::AppBuilder::Xgen::Config::ONTAP);

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    my $aggregates = $self->get_resources(
        type => "NACL::AppBuilder::Xgen::Resource::Aggregate"
    );

    use NACL::AppBuilder::Xgen::Resource::Vserver;

    my $vs = NACL::AppBuilder::Xgen::Resource::Vserver->new(
        vserver => "flexgroup_vs",
        aggregate => $aggregates->[0]->get_attribute('aggregate'),
        'rootvolume-security-style' => 'mixed'
    );

    $vs->add_parent_resources(resources => [
        $aggregates->[0]->get_ancestors(type => "NACL::AppBuilder::Xgen::Resource::Cluster")
    ]);

    use NACL::AppBuilder::Xgen::Resource::Volume;
    my $vol = NACL::AppBuilder::Xgen::Resource::Volume->new(
        vserver => $vs->get_attribute('vserver'),
        volume => "flexgroup_vol",
        size => "10g",
        'aggr-list' => [map {$_->get_attribute('aggregate')} @{$aggregates}],
        'aggr-list-multiplier' => 2,
        'autosize-mode' => 'grow-shrink'
    );

    $vol->add_parent_resources(resources => [$vs]);

    $self->add_resources(resources => [$vs, $vol]);

    return;
}

1;
