#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Fpolicy::FpolicyEvent;

use strict;
use warnings;

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Vserver );

use NACL::AppBuilder::Xgen::Resource::Vserver;
use NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy::Event;

# These are the constant values that determine what happens in the config.
use constant TOTAL_VSERVER_COUNT => 1;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_fpolicy_event_resources(%args);

}

sub generate_fpolicy_event_resources{
    my ($self, %args) = @_;

    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers =  @{$vserver_resources};

    my $event_res = NACL::AppBuilder::Xgen::Resource::Fpolicy::Policy::Event->new(vserver => $vservers[0]->get_attribute("vserver"),
                                                                                  'event-name' => "netapp",
                                                                                  );

    # connect the vs resource to the aggr's cluster parent resource
    $event_res->add_parent_resources(resources => [$vservers[0]]);
    $self->add_resources(resources => [$event_res]);
}

1;

