#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Ifgrp;

use strict;
use warnings;

use parent qw( NACL::AppBuilder::Xgen::Config::ONTAP );

use NACL::AppBuilder::Xgen::Resource::Ifgrp;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    $self->generate_ifgrp_resources(%args);

}

sub generate_ifgrp_resources {
    my ($self, %args) = @_;

    my $cluster_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Cluster");
    my @clusters = @{$cluster_resources};
    my @port_list = ('e0g');

    my $ifgrp_res = NACL::AppBuilder::Xgen::Resource::Ifgrp->new(node => "sti13-vsim-ucs401m",
                                                                 ifgrp => "a1b",
                                                                 'distr-func' => "port",
                                                                 mode => "multimode",
                                                                 'port-list' => \@port_list,
                                                                );

    # connect the vs resource to the aggr's cluster parent resource
    $ifgrp_res->add_parent_resources(resources => [$clusters[0]]);

    $self->add_resources(resources => [$ifgrp_res]);
}

1;

