#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::Igroup;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Vserver);

use NACL::AppBuilder::Xgen::Resource::Igroup;

use constant IGROUP_NAME => 'test_igroup';
use constant IGROUP_OS_TYPE => 'linux';


sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    #Call to create igroup
    $self->generate_igroup_resources(%args);
}

sub generate_igroup_resources {
    my ($self, %args) = @_;
    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers = @{$vserver_resources};
    my $vserver = shift @vservers;
    my $vserver_name = $vserver->get_attribute("vserver");

    my $igroup_resource = NACL::AppBuilder::Xgen::Resource::Igroup->new(
           'vserver'  => $vserver_name,
           'igroup'   => $self->IGROUP_NAME,
           'ostype'   => $self->IGROUP_OS_TYPE
       );
   $igroup_resource->add_parent_resources(resources => [$vserver]);
   $self->add_resources(resources => [ $igroup_resource ]);
}
1;
