#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::IscsiSecurity;

use strict;
use warnings;

use parent qw( NACL::UnitTest::AppBuilder::Xgen::Config::Iscsi );

use NACL::AppBuilder::Xgen::Resource::IscsiSecurity;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);

    # Call to set iscsi security
    $self->generate_iscsi_security(%args);
}


sub generate_iscsi_security {
    my ($self, %args) = @_;

    my $iscsi_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Iscsi");
    my @iscsi_resources = @{$iscsi_resources};
    my @iscsi;

    foreach my $iscsi (@iscsi_resources) {
        my $iscsi_res = NACL::AppBuilder::Xgen::Resource::IscsiSecurity->new(vserver           => $iscsi->get_attribute("vserver"),
                                                                             'initiator-name'  => "iqn.1970-01.com.company:abcdef",
                                                                              'auth-type'      => "CHAP",
                                                                              'chap_mode'      => "unidirectional",

                                                                              'user-name'      => "admin",
                                                                               password        => "netapp1!",);

        $iscsi_res->add_parent_resources(resources => [$iscsi]);

        push(@iscsi,$iscsi_res);
    }
    $self->add_resources(resources => \@iscsi);
}

1;
