#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::VserverVscan;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Vserver);

use NACL::AppBuilder::Xgen::Resource::Vscan;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    $self->generate_vscan_resources(%args);
}

sub generate_vscan_resources {
    my ($self, %args) = @_;
    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers = @{$vserver_resources};
    my $vserver = shift @vservers;
    my $vserver_name = $vserver->get_attribute("vserver");

    my $vscan_resource = NACL::AppBuilder::Xgen::Resource::Vscan->new(
           'vserver'  => 'vs_32501_2',
       );
   $vscan_resource->add_parent_resources(resources => [$vserver]);
   $self->add_resources(resources => [ $vscan_resource ]);
}

1;
