#
# Copyright (c) 2015 NetApp, Inc., All Rights Reserved.
#   Any other use, modification, or distribution is prohibited
#   without prior written consent from NetApp, Inc.
#

package NACL::UnitTest::AppBuilder::Xgen::Config::VserverVscanOnDemandTask;

use strict;
use warnings;

use parent qw(NACL::UnitTest::AppBuilder::Xgen::Config::Vserver);

use NACL::AppBuilder::Xgen::Resource::Vscan::OnDemandTask;

sub build {
    my ($self, %args) = @_;

    $self->SUPER::build(%args);
    $self->generate_on_demand_task_resources(%args);
}

sub generate_on_demand_task_resources {
    my ($self, %args) = @_;
    my $vserver_resources = $self->get_resources(type => "NACL::AppBuilder::Xgen::Resource::Vserver");
    my @vservers = @{$vserver_resources};
    my $vserver = shift @vservers;
    my $vserver_name = $vserver->get_attribute("vserver");

    my $on_demand_resource = NACL::AppBuilder::Xgen::Resource::Vscan::OnDemandTask->new(
           'vserver'  => 'vs0',
           'task-name' => 'netapp',
           'scan-paths' => '/ramya',
           'report-directory' => '/ramya',
       );
   $on_demand_resource->add_parent_resources(resources => [$vserver]);
   $self->add_resources(resources => [ $on_demand_resource ]);
}
1;
