#!/usr/software/bin/perl

use strict;
use warnings;

use Carp;

use Test::More import => ['!subtest'];
use FindBin '$Bin';
use Cwd qw/abs_path/;

use Test::MockObject;
use Test::MockObject::Extends;
use Test::MockModule;

use NACL::UnitTest::MTask::MCC::TestUtils qw( :all );

MAIN: {
    test_use_mcc();
    test_wafliron();
    done_testing();
}

############# Tests ###################

sub test_wafliron {
    my $mcc = make_mock_mcc();

    my ($wafliron_mod_mock, $wafliron) = mock_wafliron();

    my $aggr = make_mock_aggregate();

    $mcc->perform_wafliron(nacltask_timeout => 123, aggr_obj => $aggr);

    $wafliron->called_ok('start');
    my (undef, %args) = $wafliron->call_args(1);
    is($args{'nacltask_timeout'}, 123, 'nacltask_timeout');

}
